# spml -- a fortran library for spectral model

<!-- English bellow -->

@ja
## SPML ライブラリとは?

**spml — SPmodel (SPectral MODEL) Library** はスペクトル法による
数値計算ライブラリです.

フーリエ変換, 球面調和函数変換, チェビシェフ変換などの計算エンジンには
石岡圭一氏による[ISPACK][ISPACK]を用いています.
spml は ISPACK の変換ルーチンを wrap し,
微分・積分・境界値問題などを取り扱いやすくしています.
また, データI/Oや後処理などは[地球流体電脳倶楽部 gtool プロジェクト][gtool project]
において開発されている [gtool5 Fortran Library][gtool5(ja)] を使うことを前提としています.

このライブラリに含まれる関数は, Fortran90 以降で強化された配列機能である

* 「要素別演算:配列の要素を指定せずに各要素に対する計算を行えること」
* 「配列を返す関数を作成できること」

を利用し, さらに関数の名前の命名法を
``(関数の出力するデータ種類)_(機能)_(引数のデータ種類)``
といった形に統一してあります.

Fortran90以降で導入された配列機能を生かしたこのライブラリを用いることで,
時間発展方程式の時間変化項以外の部分を「数式の形そのままに」プログラミン
グすることができるようになってます. 支配方程式の形をそのままソースコード
に反映させられるので, プログラムの可読性を向上させることができます. また,
spml の配列関数は入出力配列の性質が名前からわかるようにするべく統一的に
命名法にしたがっているので, 関数の使い方が機械的になり, プログラムを修正・
改変も容易に行えるようになっています. 引数と出力関数の種類を名前からわか
るようにすることで, 引数や出力の間違いを減らすことも狙っています.

本ライブラリの使用にあたっては, 地球流体スペクトルモデルプロジェクトの
Webサイトである [階層的地球流体スペクトルモデル集(SPMODEL)][SPMODEL] を
一度ご覧下さい.

## 最新安定版

- tar.gz ファイル
- ソースツリー

## ドキュメント

- \subpage INSTALL "インストールガイド"
- \subpage TUTORIAL "チュートリアル"
- \subpage CREDITS "開発者, 貢献者一覧"
- \subpage COPYRIGHT "COPYRIGHT and License"

## 主なモジュールとその解説

### 一次元問題

* ae_module: 一次元周期境界条件での問題をフーリエ変換により解く(多層対応).
* at_module: 一次元有限領域での問題をチェビシェフ変換法により解く(多層対応).

### 二次元問題

* ee_mpi_module: 二次元周期境界条件での問題をフーリエ変換によって解く
* et_module: 二次元水路領域での問題をフーリエ変換とチェビシェフ変換法により解く.
* w_module: 二次元球面上の問題を球面調和関数変換法により解く.
* w_mpi_module: 二次元球面上の問題を球面調和関数変換法により解く(MPI並列版).

### 三次元問題

* tee_mpi_module:
* ua_mpi_module:
* wa_module:
* wb_mpi_module:

[TOC]

## 使用上の注意とライセンス

MIT/X11 ライセンスです.
正式なライセンスについては [COPYRIGHT](@ref COPYRIGHT) を参照下さい.

### 科学者・研究者の方へのお願い

本ソフトウェアはフリーソフトウェアとしてリリースされていますが,
適切な引用を行なう科学的な作法までを免責していないことにご注意下さい.
本ソフトウェアを使用した研究を記述した論文を書く際には、
再現性の担保のためにも、適切な形式での引用をお願いします.

引用例は以下の通りです:

引用例 (和文)
> 竹広 真一, 佐々木 洋平, 石岡 圭一, 小高 正嗣, 高橋 芳幸, 中島 健介, 石渡 正樹, 林 祥介, spmodel 開発グループ, 2013: 階層的地球流体力学スペクトルモデル集 (SPMODEL), https://www.gfd-dennou.org/library/spmodel/, 地球流体電脳倶楽部. 

引用例 (英文)
> Takehiro, S., SASAKI, Y., Ishioka, K., Odaka, M., Takahashi, Y. O., Nakajima, K., Ishiwatari, M., Hayashi, Y.-Y., SPMODEL Development Group, 2013: Hierarchical Spectral Models for GFD (SPMODEL), https://www.gfd-dennou.org/library/spmodel/, GFD Dennou Club.

査読付き論文しか引用できない場合には, 流体力学会オンラインジャーナル「ながれマルチメディア」の解説論文をレファレンスとしてあげてください.
> Takehiro, S., Odaka, M., Ishioka, K., Ishiwatari, M., Hayashi, Y.-Y., 2006: SPMODEL: A Series of Hierarchical Spectral Models for Geophyiscal Fluid Dynamics, Nagare Multimedia 2006, http://www.nagare.or.jp/mm/2006/spmodel/

@endja

<!-- English page -->

@en

see [http://www.gfd-dennou.org/library/spmodel/]

Installation Guide is [INSTALL](@ref INSTALL).

@enden

[ISPACK]: https://www.gfd-dennou.org/arch/ispack/
[gtool project]:https://www.gfd-dennou.org/library/gtool/
[gtool5(ja)]: https://www.gfd-dennou.org/library/gtool/gtool5.htm.ja
[gtool5(en)]: https://www.gfd-dennou.org/library/gtool/gtool5.htm.en
[SPMODEL]: https://www.gfd-dennou.org/library/spmodel/
<!-- Local Variables: -->
<!-- mode: markdown -->
<!-- End: -->

! -*- mode: f90; coding: utf-8 -*-
!-----------------------------------------------------------------------
!> 固有値解法ルーチン(後方互換性のため存在)
!>
!> 本モジュールは後方互換性のために存在している．
!> 実体は @ref spml_utils を参照されたい.
module eigmatrix
  use spml_utils, only: eigen, ceigen
  implicit none
  private
  public eigen
  public ceigen
end module eigmatrix

!--
!----------------------------------------------------------------------
!     Copyright (c) 2020 SPMDOEL Development Group
!----------------------------------------------------------------------
!表題  ua_base_mpi_module_sypack
!
!  spml/ua_base_mpi_module_sypack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための
!  モジュール ua_mpi_module_sypack の下部モジュールであり,
!  スペクトル計算の基本的な Fortran90 関数を提供する.
!
!  球面上の 1 層モデル用 u_base_module_sypack モジュールを多層モデル用に
!  並列化拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3 の SYPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって u_mpi_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある.
!
!
!履歴  2020/07/31  竹広真一  ua_mpi_module よリ改造
!
!++
module wb_mpi_module_base
  !
  != wb_mpi_module_base
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/wb_mpi_module_base モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための
  !  モジュール wb_mpi_module の下部モジュールであり,
  !  スペクトル計算の基本的な Fortran90 関数を提供する.
  !
  !  球面上の 1 層モデル用 w_base_module モジュールを多層モデル用に
  !  並列化拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3 の SYPACK のマニュアルを参照されたい.
  !
  !  このモジュールを使うためには前もって w_mpi_base_initial を呼んで
  !  切断波数, 格子点数の設定をしておく必要がある.
  !
  use mpi
  use dc_message, only: MessageNotify
  use w_mpi_module_base,  only : im, jm, jcc=>jl, nn, mm, &
    xv_Lon, xv_Lat, x_Lon, v_Lat, x_Lon_Weight, v_Lat_Weight, &
       xv_w, w_xv, &
       w_StreamPotential2VectorMPI, w_Vector2VorDivMPI, &
       w_VectorCosLat2VorDivMPI, &
       w_base_mpi_initial, w_base_mpi_finalize, ncc=>nc, l_nm, nm_l


  implicit none

  integer              :: km=16         ! 同時に処理する最大データ数(層の数).

  integer              :: nproc, nproc_h, nproc_v
  integer              :: iproc, iproc_h, iproc_v

  integer              :: jc
  integer              :: nc
  
  integer              :: is, ie, ic
  integer, allocatable :: isp(:), iep(:), icp(:)

  integer              :: ks, ke, kc
  integer, allocatable :: ksp(:), kep(:), kcp(:)

  real(8), allocatable :: pv_Lon(:,:), pv_Lat(:,:)
  real(8), allocatable :: p_Lon(:)
  real(8), allocatable :: p_Lon_Weight(:)
  
  integer              :: MPI_COMM_W
  integer              :: MPI_COMM_H
  integer              :: MPI_COMM_V

  logical              :: first_xvb_pva=.true.
  logical              :: first_pva_xvb=.true.
  logical              :: first_aa_ab=.true.
  logical              :: first_xa_pa=.true.

  private

  public wb_base_mpi_Initial                   ! 初期化サブルーチン
  public wb_base_mpi_Finalize                  ! 終了処理

  public MPI_COMM_W, MPI_COMM_H, MPI_COMM_V
  public nproc, nproc_h, nproc_v
  public iproc, iproc_h, iproc_v

  public jc, nc
  public is, ie, ic
  public km
  public ks, ke, kc

  public l_nm, nm_l
  public kp_kl

  public xv_Lon, xv_Lat
  public x_Lon, v_Lat
  public x_Lon_Weight, v_Lat_Weight
  public pv_Lon, pv_Lat
  public p_Lon
  public p_Lon_Weight

  public wb_pva, pva_wb                        ! 変換関数
  public wb_xvb, xvb_wb                        ! 変換関数
  public xvb_pva, pva_xvb                      ! 変換関数
  public pv_w, w_pv                            ! 変換関数
  public xv_w, w_xv                            ! 変換関数

  public xa_pa, pa_xa                          ! 変換関数
  public aa_ab, ab_aa                          ! 変換関数
  public wb_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public wb_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public wb_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  save jc  
  save nc
  save km                                      ! 最大データ数(層数)を記憶
  save nproc, iproc, nproc_h, iproc_h, nproc_v, iproc_v
  save icp, isp, iep
  save ic, is, ie
  save kcp, ksp, kep
  save kc, ks, ke
  save pv_Lon, pv_Lat
  save p_Lon
  save p_Lon_Weight
  save MPI_COMM_W, MPI_COMM_H, MPI_COMM_V
  save first_xvb_pva, first_pva_xvb
  save first_aa_ab, first_xa_pa

  contains
  !--------------- 初期化 -----------------
    subroutine wb_base_mpi_initial(n_in,i_in,j_in,k_in,npv,mpi_comm)
      !
      ! ua_mpi_module_base 初期化
      !
      integer,intent(in) :: n_in                !(in) 切断波数
      integer,intent(in) :: i_in                !(in) 格子点数(東西)
      integer,intent(in) :: j_in                !(in) 格子点数(南北)
      integer,intent(in) :: k_in                !(in) 最大データ数(層数)
      integer,intent(in),optional :: npv        !(in) 層方向分割数
      integer,intent(in),optional :: mpi_comm   !(in) 全体コミュニケーター

      integer :: ierr, iv

      km = k_in

      if ( present(npv) ) then
         nproc_v = npv
      else
         nproc_v = 1
      endif

      if ( present(mpi_comm) ) then
         MPI_COMM_W = mpi_comm
      else
         MPI_COMM_W = MPI_COMM_WORLD
      endif

      CALL MPI_COMM_SIZE(MPI_COMM_W,NPROC,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_W,IPROC,IERR)

      NPROC_H = NPROC/NPROC_V
      IPROC_V = IPROC/NPROC_H
      IPROC_H = MOD(IPROC,NPROC_H)

      CALL MPI_COMM_SPLIT(MPI_COMM_W, iproc_v, iproc_h, MPI_COMM_H, IERR )
      CALL MPI_COMM_SPLIT(MPI_COMM_W, iproc_h, iproc_v, MPI_COMM_V, IERR )

      call w_base_mpi_initial(n_in,i_in,j_in,mpi_comm_h)
      jc = jcc
      nc = ncc      

      allocate(isp(0:NPROC_V-1))
      allocate(iep(0:NPROC_V-1))
      allocate(icp(0:NPROC_V-1))
      call mpidivide(int(im),nproc_v,isp,iep,icp)
      isp = isp-1 ; iep = iep-1
      is = isp(iproc_v) ; ie = iep(iproc_v) ; ic = icp(iproc_v)

      IF(iproc.EQ.0)THEN
         WRITE(6,*)'   RANK  KSTART  KEND    IC '
         WRITE(6,*)'------------------------------'
         DO IV=0,NPROC_V-1
            WRITE(6,'(4i7)') IV, ISP(IV), IEP(IV), ICP(IV)
         ENDDO
         WRITE(6,*)''
      END IF
      
      allocate(ksp(0:NPROC_V-1))
      allocate(kep(0:NPROC_V-1))
      allocate(kcp(0:NPROC_V-1))
      call mpidivide(km,nproc_v,ksp,kep,kcp)
      ks = ksp(iproc_v) ; ke = kep(iproc_v) ; kc = kcp(iproc_v)

      IF(iproc.EQ.0)THEN
         WRITE(6,*)'   RANK  KSTART  KEND    KC '
         WRITE(6,*)'------------------------------'
         DO IV=0,NPROC_V-1
            WRITE(6,'(4i7)') IV, KSP(IV), KEP(IV), KCP(IV)
         ENDDO
         WRITE(6,*)''
      END IF

      allocate(pv_Lon(ic,jc),pv_Lat(ic,jc))
      allocate(p_Lon(ic),p_Lon_Weight(ic))

      pv_Lon = xv_Lon(is:ie,:)
      pv_Lat = xv_Lat(is:ie,:)      
      p_Lon  = x_Lon(is:ie)
      p_Lon_Weight  = x_Lon_Weight(is:ie)
      
      call MessageNotify('M','wb_base_mpi_initial', &
          'wb_mpi_module_base (2020/07/31) is initialized')

    end subroutine wb_base_mpi_initial

    subroutine mpidivide(mm,np,msp,mep,mcp)
      !
      ! 鉛直分割情報
      !
      integer, intent(IN)  :: mm              ! 全格子点数
      integer, intent(IN)  :: np              ! 分割プロセス数
      integer, intent(OUT) :: msp(0:np-1)     ! 分割開始インデックス
      integer, intent(OUT) :: mep(0:np-1)     ! 分割終了インデックス
      integer, intent(OUT) :: mcp(0:np-1)     ! 分割インデックス数

      integer :: i, mint, mmod

      mint = mm/np
      mmod = mod(mm,np)
      mcp  = mint
      do i = 0,mmod-1
         mcp(i) = mcp(i)+1
      enddo

      msp(0)=1 ; mep(0) = msp(0) + mcp(0) -1
      do i = 1,np-1
         msp(i) = msp(i-1) + mcp(i-1)
         mep(i) = msp(i) + mcp(i) - 1
      end do

    end subroutine mpidivide

    !--------------- 基本関数 -----------------
    function kp_kl(kl)
      integer, intent(IN) :: kl             ! 層番号(全体)
      integer             :: kp_kl          ! 層番号(分割プロセス中)

      if ( ks .le. kl .AND. kl .le. ke ) then
         kp_kl = kl - ks + 1
      else
         kp_kl = 0
      endif

    end function kp_kl


    !--------------- データ入れ換え -----------------
    function xvb_pva(pva)
      !
      ! 格子点データ(経度・緯度分割)から格子点データ(緯度・層分割)へ変換する.
      !
      real(8), dimension(ic,jc,km), intent(in)       :: pva
      !(in) 2 次元球面調和函数(水平再分割) (nc,:)
      real(8), dimension(0:im-1,jc,kc)               :: xvb_pva
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), allocatable :: pvb_recv(:,:,:)

      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, iv
      integer, parameter   :: itag=110
      integer, allocatable :: snd_rank_v(:)
      integer, allocatable :: rcv_rank_v(:)

      save snd_rank_v, rcv_rank_v !, rcv_idx

      if ( first_xvb_pva ) then
         first_xvb_pva = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))

         do iv=1,nproc_v-1
            rcv_rank_v(iv) = mod(iproc_v+iv,nproc_v)
            snd_rank_v(iv) = mod(iproc_v-iv+nproc_v,nproc_v)
         enddo

      endif

      call MPI_Barrier(MPI_COMM_V,IERR)
      
      if ( jc > 0 ) then
         do iv=1,nproc_v-1
            call MPI_ISEND(pva(1,1,ksp(rcv_rank_v(iv))),ic*jc*kcp(rcv_rank_v(iv)), &
                 MPI_REAL8, rcv_rank_v(iv),&
                 itag,MPI_COMM_V,IRQSTS,IERR)
            allocate(pvb_recv(icp(snd_rank_v(iv)),jc,kc))
            call MPI_RECV(pvb_recv,kc*jc*icp(snd_rank_v(iv)), MPI_REAL8, &
                 snd_rank_v(iv), itag, MPI_COMM_V, IST, IERR)
            xvb_pva(isp(snd_rank_v(iv)):iep(snd_rank_v(iv)),:,:) = pvb_recv
            deallocate(pvb_recv)
            CALL MPI_WAIT(IRQSTS,IST,IERR)
         enddo
      end if

      xvb_pva(is:ie,:,:) = pva(:,:,ks:ke)

    end function xvb_pva

    function pva_xvb(xvb)
      !
      ! 格子点データ(経度・緯度分割)から格子点データ(緯度・層分割)へ変換する.
      !
      real(8), dimension(0:im-1,jc,kc), intent(in)   :: xvb
      !(in) 2 次元球面調和函数(水平再分割) (nc,:)
      real(8), dimension(ic,jc,km)                   :: pva_xvb
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), allocatable :: pvb_send(:,:,:)

      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, iv
      integer, parameter :: itag=111
      integer, allocatable ::snd_rank_v(:)
      integer, allocatable ::rcv_rank_v(:)
      integer, allocatable ::rcv_idx(:)

      save snd_rank_v, rcv_rank_v, rcv_idx

      if ( first_pva_xvb ) then
         first_pva_xvb = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         if ( allocated(rcv_idx) ) deallocate(rcv_idx)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))
         allocate(rcv_idx(0:nproc_v-1))

         do iv=1,nproc_v-1
            rcv_rank_v(iv) = mod(iproc_v+iv,nproc_v)
            snd_rank_v(iv) = mod(iproc_v-iv+nproc_v,nproc_v)
         enddo

         rcv_idx(0) = 1
         do iv=1,nproc_v-1
            rcv_idx(iv) = rcv_idx(iv-1)+kcp(iv-1)
         enddo
      endif

      call MPI_Barrier(MPI_COMM_V,IERR)

      if ( jc > 0 ) then
         do iv=1,nproc_v-1
            allocate(pvb_send(icp(rcv_rank_v(iv)),jc,kc))
            pvb_send = xvb(isp(rcv_rank_v(iv)):iep(rcv_rank_v(iv)),:,:)
            call MPI_ISEND(pvb_send, icp(rcv_rank_v(iv))*jc*kc,&
                 MPI_REAL8, rcv_rank_v(iv),&
                 itag,MPI_COMM_V,IRQSTS,IERR)
            deallocate(pvb_send)
            call MPI_RECV(pva_xvb(1,1,rcv_idx(snd_rank_v(iv))),&
                 ic*jc*kcp(snd_rank_v(iv)), MPI_REAL8,    &
                 snd_rank_v(iv), itag, MPI_COMM_V, IST, IERR)
            CALL MPI_WAIT(IRQSTS,IST,IERR)
         enddo
      endif
      
      pva_xvb(:,:,ks:ke) = xvb(is:ie,:,:)

    end function pva_xvb

    function xa_pa(pa)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(:,:), intent(in)       :: pa
      !(in) 2 次元格子点データ(経度分割) (ic,:)
      real(8), dimension(0:im-1,size(pa,2))     :: xa_pa
      !(out) 2 次元格子点データ

      real(8), dimension(size(pa,2),ic)      :: ap
      real(8), dimension(size(pa,2),0:im-1)  :: ax

      integer :: a_size
      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, ip_v
      integer, parameter :: itag=120
      ! integer, allocatable ::snd_rank(:)
      integer, allocatable ::snd_rank_v(:)
      ! integer, allocatable ::rcv_rank(:)
      integer, allocatable ::rcv_rank_v(:)
      integer, allocatable ::rcv_idx(:)

      save snd_rank_v, rcv_rank_v, rcv_idx !, snd_rank, rcv_rank

      if ( first_xa_pa ) then
         first_xa_pa = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         if ( allocated(rcv_idx)    ) deallocate(rcv_idx)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))
         allocate(rcv_idx(0:nproc_v-1))

         do ip_v=1,nproc_v-1
            rcv_rank_v(ip_v) = mod(iproc_v+ip_v,nproc_v)
            snd_rank_v(ip_v) = mod(iproc_v-ip_v+nproc_v,nproc_v)
         enddo

         rcv_idx(0) = 0
         do ip_v=1,nproc_v-1
            rcv_idx(ip_v) = rcv_idx(ip_v-1)+icp(ip_v-1)
         enddo
      endif

      ap = transpose(pa)
      a_size = size(pa,2)

      call MPI_Barrier(MPI_COMM_V,IERR)

      if ( a_size > 0 ) then
         do ip_v=1,nproc_v-1
            call MPI_ISEND(ap, a_size*ic, MPI_REAL8, rcv_rank_v(ip_v),&
                 itag,MPI_COMM_V,IRQSTS,IERR)
            call MPI_RECV(ax(1,rcv_idx(snd_rank_v(ip_v))),  &
                 a_size*icp(snd_rank_v(ip_v)), MPI_REAL8,   &
                 snd_rank_v(ip_v), itag, MPI_COMM_V, IST, IERR)
            CALL MPI_WAIT(IRQSTS,IST,IERR)
         enddo
      endif
      
      ax(:,is:ie) = ap

      xa_pa = transpose(ax)

    end function xa_pa

    function pa_xa(xa)
      !
      ! 水平格子データを再分割する
      !
      real(8), dimension(0:,:), intent(in) :: xa
      !(in) 2 次元格子点数データ (0:im-1,:)
      real(8), dimension(ic,size(xa,2))  :: pa_xa
      !(out) 2 次元格子点データ(経度分割)

      pa_xa = xa(is:ie,:)

    end function pa_xa

    function aa_ab(ab)
      !
      ! 水平スペクトル・動径格子点データを集める.
      !
      real(8), dimension(:,:), intent(in) :: ab
      !(in)  動径格子点データ(分割)
      real(8), dimension(size(ab,1),km)   :: aa_ab
      !(out) 動径格子点データ

      integer :: a_size
      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, ip_v
      integer, parameter :: itag=111
      integer, allocatable ::snd_rank_v(:)
      integer, allocatable ::rcv_rank_v(:)
      integer, allocatable ::rcv_idx(:)

      save snd_rank_v, rcv_rank_v, rcv_idx

      if ( first_aa_ab ) then
         first_aa_ab = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         if ( allocated(rcv_idx) )    deallocate(rcv_idx)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))
         allocate(rcv_idx(0:nproc_v-1))

         do ip_v=1,nproc_v-1
            rcv_rank_v(ip_v) = mod(iproc_v+ip_v,nproc_v)
            snd_rank_v(ip_v) = mod(iproc_v-ip_v+nproc_v,nproc_v)
         enddo

         rcv_idx(0) = 1
         do ip_v=1,nproc_v-1
            rcv_idx(ip_v) = rcv_idx(ip_v-1)+kcp(ip_v-1)
         enddo
      endif

      a_size = size(ab,1)

      call MPI_Barrier(MPI_COMM_V,IERR)
      do ip_v=1,nproc_v-1
         call MPI_ISEND(ab, a_size*kc, MPI_REAL8, rcv_rank_v(ip_v),&
              itag,MPI_COMM_V,IRQSTS,IERR)
         call MPI_RECV(aa_ab(1,rcv_idx(snd_rank_v(ip_v))),&
              a_size*kcp(snd_rank_v(ip_v)), MPI_REAL8,    &
              snd_rank_v(ip_v), itag, MPI_COMM_V, IST, IERR)
         CALL MPI_WAIT(IRQSTS,IST,IERR)
      enddo

      aa_ab(:,rcv_idx(iproc_v):rcv_idx(iproc_v)+kcp(iproc_v)-1) = ab

    end function aa_ab

    function ab_aa(aa)
      !
      ! 水平スペクトル・動径格子点データを分割する.
      !
      real(8), dimension(:,:), intent(in) :: aa
      !(in)  動径格子点データ(:,0:km)
      real(8), dimension(size(aa,1),kc)    :: ab_aa
      !(out) 動径格子点データ(分割)

      ab_aa = aa(:,ks:ke)

    end function ab_aa

    !--------------- 基本変換 -----------------

    function pva_wb(wb_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: wb_data(nc,kc)
      !(in) スペクトルデータ
      !
      real(8)               :: pva_wb(1:ic,1:jc,km)
      !(out) 格子点データ
      !
      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0.
      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0
      integer ipval, ifval

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      pva_wb = pva_xvb(xvb_wb(wb_data,ipow=ipval,iflag=ifval))

    end function pva_wb

    function wb_pva(pva_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: pva_data(1:ic,1:jc,km)
      !(in) スペクトルデータ
      !
      real(8)               :: wb_pva(nc,kc)
      !(out) 格子点データ
      !
      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0.
      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0
      integer ipval, ifval

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      wb_pva = wb_xvb(xvb_pva(pva_data),ipow=ipval,iflag=ifval)

    end function wb_pva

    function w_pv(pv_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
      !
      ! 格子データからスペクトルデータへ(正)変換する(多層用).
      !
      real(8), intent(in)   :: pv_data(ic,jc)
      !(in) 格子点データ

      real(8)               :: w_pv(nc)
      !(out) スペクトルデータ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

      integer ipval, ifval

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      w_pv = w_xv(xa_pa(pv_data),ipow=ipval,iflag=ifval)

    end function w_pv

    function pv_w(w_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: w_data(nc)
      !(in) スペクトルデータ
      !
      real(8)               :: pv_w(1:ic,1:jc)
      !(out) 格子点データ
      !
      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0.
      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0
      integer ipval, ifval

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      pv_w = pa_xa(xv_w(w_data,ipow=ipval,iflag=ifval))

    end function pv_w

    function xvb_wb(wb_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
      !
      ! スペクトルデータから格子データへ変換する(多層用).
      !
      real(8), intent(in)   :: wb_data(nc,kc)
      !(in) スペクトルデータ
      !
      real(8)               :: xvb_wb(0:im-1,1:jc,kc)
      !(out) 格子点データ
      !
      integer, intent(in), optional  :: ipow
      !(in) 作用させる 1/cosφ の次数. 省略時は 0.
      integer, intent(in), optional  :: iflag
      !(in) 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた逆変換
      !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
      !    2 : sinφを作用させた逆変換
      !    省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0
      integer, parameter  :: iflag_default = 0
      integer ipval, ifval

      integer :: k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      do k=1,kc
         xvb_wb(:,:,k) = xv_w(wb_data(:,k),iflag=ifval,ipow=ipval)
      enddo

    end function xvb_wb

    function wb_xvb(xvb_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
      !
      ! 格子データからスペクトルデータへ(正)変換する(多層用).
      !
      real(8), intent(in)   :: xvb_data(0:im-1,jc,kc)
      !(in) 格子点データ

      real(8)               :: wb_xvb(nc,kc)
      !(out) スペクトルデータ

      integer, intent(in), optional  :: ipow
      !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

      integer, intent(in), optional  :: iflag
      ! 変換の種類
      !    0 : 通常の正変換
      !   -1 : 経度微分を作用させた正変換
      !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
      !    2 : sinφを作用させた正変換
      !  省略時は 0.
      !
      integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
      integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

      integer ipval, ifval

      integer k

      if (present(ipow)) then
         ipval = ipow
      else
         ipval = ipow_default
      endif

      if (present(iflag)) then
         ifval = iflag
      else
         ifval = iflag_default
      endif

      do k=1,kc
         wb_xvb(:,k) = w_xv(xvb_data(:,:,k),iflag=ifval,ipow=ipval)
      enddo

    end function wb_xvb

    !----------- 速度, 渦度・発散, 流線・ポテンシャル計算 -------------

    subroutine wb_StreamPotential2VectorMPI(wb_Psi, wb_Chi, pva_U, pva_V)
      !
      ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
      ! (逆)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
      !
      !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ,
      !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ
      !
      real(8), intent(in)    :: wb_Psi(nc,kc)
      !(in) 流線関数

      real(8), intent(in)    :: wb_Chi(nc,kc)
      !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

      real(8), intent(out)   :: pva_U(ic,jc,km)
      !(out) 速度経度成分

      real(8), intent(out)   :: pva_V(ic,jc,km)
      !(out) 速度緯度成分

      real(8) :: xvb_U(0:im-1,jc,kc)
      !(out) 速度経度成分

      real(8) :: xvb_V(0:im-1,jc,kc)
      !(out) 速度緯度成分
      integer :: k

      do k=1,kc
         call w_StreamPotential2VectorMPI &
              ( wb_Psi(:,k), wb_Chi(:,k), xvb_U(:,:,k), xvb_V(:,:,k) )
      enddo

      pva_U = pva_xvb(xvb_U)
      pva_V = pva_xvb(xvb_V)      
      
    end subroutine wb_StreamPotential2VectorMPI

    subroutine wb_Vector2VorDivMPI(pva_U, pva_V, wb_Vor, wb_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: pva_U(ic,jc,km)
      !(in) 速度経度成分

      real(8), intent(in)   :: pva_V(ic,jc,km)
      !(in) 速度緯度成分

      real(8), intent(out)   :: wb_Vor(nc,kc)
      !(out) 渦度
      real(8), intent(out)   :: wb_Div(nc,kc)
      !(out) 発散

      real(8) :: xvb_U(0:im-1,jc,kc)
      !速度経度成分

      real(8) :: xvb_V(0:im-1,jc,kc)
      !速度緯度成分

      integer :: k

      xvb_U = xvb_pva(pva_U)
      xvb_V = xvb_pva(pva_V)

      do k=1,kc
         call w_Vector2VorDivMPI &
               (xvb_U(:,:,k), xvb_V(:,:,k), wb_Vor(:,k), wb_Div(:,k))
      enddo

    end subroutine wb_Vector2VorDivMPI

    subroutine wb_VectorCosLat2VorDivMPI(pva_UCosLat, pva_VCosLat, wb_Vor, wb_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)  :: pva_UCosLat(ic,jc,km)
      !(in) 速度経度成分 * cos(lat)

      real(8), intent(in)  :: pva_VCosLat(ic,jc,km)
      !(in) 速度緯度成分 * cos(lat)

      real(8), intent(out) :: wb_Vor(nc,kc)
      !(out) 流線関数
      real(8), intent(out) :: wb_Div(nc,kc)
      !(out) 速度ポテンシャル

      real(8) :: xvb_UCosLat(0:im-1,jc,kc)
      !速度経度成分 * cos(lat)

      real(8) :: xvb_VCosLat(0:im-1,jc,kc)
      !速度緯度成分 * cos(lat)

      integer :: k

      xvb_UCosLat = xvb_pva(pva_UCosLat)
      xvb_VCosLat = xvb_pva(pva_VCosLat)      
      
      do k=1,kc
         call w_VectorCosLat2VorDivMPI &
               (xvb_UCosLat(:,:,k), xvb_VCosLat(:,:,k), wb_Vor(:,k), wb_Div(:,k))
      enddo

    end subroutine wb_VectorCosLat2VorDivMPI

    !--------------- 終了処理 -----------------
    subroutine wb_base_mpi_Finalize
      !
      !
      ! このサブルーチンを単独で用いるのでなく,
      ! 上位サブルーチン wa_Finalize を使用すること.
      !
      deallocate(isp)
      deallocate(iep)
      deallocate(icp)
      deallocate(ksp)
      deallocate(kep)
      deallocate(kcp)

      deallocate(pv_Lon,pv_Lat)
      deallocate(p_Lon,p_Lon_Weight)

      call w_base_mpi_Finalize

      first_xvb_pva=.true.
      first_pva_xvb=.true.
      first_aa_ab=.true.
      first_xa_pa=.true.

      call MessageNotify('M',     &
           & 'wb_base_mpi_finalize', &
           & 'wb_mpi_module_base is finalized (2020/07/31) ')

    end subroutine wb_base_mpi_Finalize

end module wb_mpi_module_base

!--
!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wb_mpi_module
!
!   spml/wb_mpi_module モジュールは球面上での 2 次元流体運動を
!   球面調和函数を用いたスペクトル法によって数値計算するための
!   Fortran90 関数を提供する.
!
!   球面上の 1 層モデル用 w_module モジュールを多層モデル用に
!   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!   対する変換が行える.
!
!   wb_mpi_module は実際には基本変換, 微分計算, 積分・平均計算,
!   スペクトル解析をそれぞれ担っている下部モジュール wb_base_module_sjpack,
!   wh_deriv_module, wa_integral_module,
!   wb_spectrum_module および 1 層用のモジュール w_module からなっている.
!
!   内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!
!履歴  2020/08/02  竹広真一  ua_mpi_module よリ改造
!
!++
module wb_mpi_module
  !
  != wb_mpi_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !   spml/wb_mpi_module モジュールは球面上での 2 次元流体運動を
  !   球面調和函数を用いたスペクトル法によって数値計算するための
  !   Fortran90 関数を提供する.
  !
  !   球面上の 1 層モデル用 w_module モジュールを多層モデル用に
  !   拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !   対する変換が行える.
  !
  !   wb_mpi_module は実際には基本変換, 微分計算, 積分・平均計算,
  !   スペクトル解析をそれぞれ担っている下部モジュール wb_base_module_sjpack,
  !   wh_deriv_module, wa_integral_module,
  !   wb_spectrum_module および 1 層用のモジュール w_module からなっている.
  !
  !   内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
  !   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !   ついては ISPACK3/SYPACK のマニュアルを参照されたい.
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (wb_, nma_, na_, pva_, xb_, yb_, w_, xy_, x_, y_, a_) は,
  !   返す値の形を示している.
  !   wb_  :: 水平スペクトルデータの並んだ 2 次元配列(水平波数, 層分割)
  !           (スペクトルデータの並びは SYPACK/ISPACK に従ったもの)
  !   nmb_ :: スペクトルデータの並んだ 3 次元配列(層分割)
  !           (スペクトルデータの並びは全波数 n, 帯状波数 m で指定される
  !             2 次元配列)
  !   nb_  :: スペクトルデータの並んだ 2 次元配列(層分割)
  !           (スペクトルデータの並びは全波数 n で指定される 1 次元配列)
  !   pva_ :: 3 次元格子点データ(経度, 層分割)
  !   pa_  :: 経度方向 1 次元格子点データ(分割)が層方向に並んだ 2 次元配列
  !   va_  :: 緯度方向 1 次元格子点データ(分割)に層方向に並んだ 2 次元配列
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,
  !   LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_wb_wb, _wb, _pva, _pa, _va, _w_w, _w, _pv, _p, _v) は,
  !   入力変数の形スペクトルデータおよび格子点データであることを示している.
  !   _wb    :: スペクトルデータの並んだ 2 次元配列(水平波数, 層分割)
  !   _wb_wb :: 2 つのスペクトルデータの並んだ 2 次元配列(水平波数, 層分割)
  !   _pva   :: 2 次元格子点データの並んだ 3 次元配列(経度, 層分割)
  !   _pa    :: 経度方向 1 次元格子点データ(分割)が層方向に並んだ 2 次元配列
  !   _va    :: 緯度方向 1 次元格子点データ(分割)が層方向に並んだ 2 次元配列
  !
  !=== 各データの種類の説明
  !
  ! * pva : 2 次元格子点データの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(ic,jc,km).
  !   * ic, jc はそれぞれ経度, 緯度座標の分割格子点数であり, サブルーチン
  !     wb_mpi_Initial を call した後に設定される. 
  !   * 第 3 次元(層方向)の大きさ km を wb_mpi_Initial で設定しておく.
  !
  ! * wb : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(nc,kc)
  !   * nc は球面調和函数成分の分割された数であり, 
  !     サブルーチン wb_mpi_Initial にてあらかじめ設定しておく.
  !   * スペクトルデータの格納のされ方は関数
  !     l_nm, nm_l によって調べることができる.
  !   * 扱う第 3 次元の分割大きさ kc は
  !     wb_mpi_Initial を call した後に設定される. 
  !
  ! * pa, va : 経度, 緯度方向 1 次元格子点データ(分割).
  !   * 変数の種類と次元はそれぞれ real(8), dimension(ic,km)
  !     および real(8), dimension(jc,km).
  !
  ! * nmb : スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,kc).
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数を表す.
  !   * nm は球面調和函数の最大全波数であり,
  !     サブルーチン wa_mpi_Initial にてあらかじめ設定しておく.
  !
  ! * nb : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,kc).
  !   *  第 1 次元が水平全波数を表す.nm は球面調和函数の最大全波数であり,
  !      サブルーチン wb_mpi_Initial にてあらかじめ設定しておく.
  !
  ! * wb_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  ! * nmb_ で始まる関数が返す値はスペクトルデータの並んだ 3 次元配列に同じ.
  !
  ! * nb_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
  !
  ! * pva_ で始まる関数が返す値は 2 次元格子点データの並んだ 3 次元配列に
  !   同じ.
  !
  ! * pa_, va_ で始まる関数が返す値は 1 次元格子点データの並んだ 2 次元
  !   配列に同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! wb_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさ,
  !                :: および同時に計算するデータの個数の最大値設定
  !
  !==== 終了処理
  !
  ! wb_mpi_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう.
  !
  !==== 座標変数
  !
  ! p_Lon, v_Lat     ::  格子点座標(緯度, 経度座標)を格納した 1 次元配列
  ! p_Lon_Weight, v_Lat_Weight ::  重み座標を格納した 1 次元配列
  ! pv_Lon, pv_Lat   :: 格子点データの経度・緯度座標(X,Y)
  !                     (格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! pva_wb, pv_w :: スペクトルデータから格子データへの変換(多層, 1 層用)
  ! wb_pva, w_py :: 格子データからスペクトルデータへの変換(多層, 1 層用)
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換
  ! w_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
  ! w_Vector2VorDiv          :: 速度場から渦度発散を計算
  ! w_VectorCosLat2VorDiv    :: 速度場から渦度発散を計算
  ! wb_StreamPotential2VectorMPI :: 流線ポテンシャルから速度場計算
  ! wb_Vector2VorDivMPI          :: 速度場から渦度発散を計算
  ! wb_VectorCosLat2VorDivMPI    :: 速度場から渦度発散を計算
  !
  !==== 微分
  !
  ! wb_Lapla_wb, w_Lapla_w        :: スペクトルデータにラプラシアンを
  !                                  作用させる(多層, 1 層用)
  ! rn                            :: スペクトルデータのラプラシアンを
  !                                  計算するための係数
  ! irm                           :: 経度微分演算用配列(未定義)
  ! wb_LaplaInv_wb, w_LaplaInv_w  :: スペクトルデータにラプラシアンの逆変換を
  !                                  作用させる(多層, 1 層用)
  ! wb_DLon_wb, w_DLon_w          :: スペクトルデータに
  !                                  経度微分∂/∂λを作用させる(多層, 1 層用)
  ! pva_GradLon_wb, pv_GradLon_w  :: スペクトルデータに
  !                                  勾配型経度微分 1/cosφ・∂/∂λ を
  !                                  作用させる(多層, 1 層用)
  ! pva_GradLat_wb, pv_GradLat_w  :: スペクトルデータに
  !                                  勾配型緯度微分 ∂/∂φ を
  !                                  作用させる(多層, 1 層用)
  ! wb_DivLon_pva, w_DivLon_pv    :: 格子データに
  !                                  発散型経度微分 1/cosφ・∂/∂λを
  !                                  作用させる(多層, 1 層用)
  ! wb_DivLat_pva, w_DivLat_pv    :: 格子データに
  !                                  発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを
  !                                  作用させる (多層, 1 層用)
  ! wb_Div_pva_pva, w_Div_pv_pv   :: ベクトル成分である 2 つの格子データに
  !                                  発散を作用させる(多層, 1 層用)
  ! wb_Jacobian_wb_wb,w_Jacobian_w_w :: 2つのスペクトルデータからヤコビアンを
  !                                     計算する(多層, 1 層用)
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! pva_GradLambda_wb, pv_GradLambda_w  :: スペクトルデータに
  !                                        勾配型経度微分∂/∂λを作用させる
  !                                        (多層, 1 層用)
  ! pva_GradMu_wb, pv_GradMu_w          :: スペクトルデータに
  !                                        勾配型緯度微分(1-μ^2)∂/∂μ
  !                                        を作用させる
  !                                        (多層, 1 層用)
  ! wb_DivLambda_pva,w_DivLambda_pv     :: 格子データに発散型経度微分
  !                                        1 /(1-μ^2)・∂/∂λを作用させる
  !                                        (多層, 1 層用)
  !
  ! wb_DivMu_pva,w_DivMu_pv             :: 格子データに発散型緯度微分
  !                                        ∂/∂μを作用させる(多層, 1 層用)
  !
  !==== 補間計算
  !
  ! a_Interpolate_wb, Interpolate_w :: スペクトルデータから
  !                                    任意の点の関数値を計算する.
  !
  !==== 積分・平均
  !
  ! a_IntLonLat_pva, a_AvrLonLat_pva :: 2 次元格子点データの
  !                                     全領域積分および平均(多層用)
  ! IntLonLat_pv, AvrLonLat_pv       :: 2 次元格子点データの
  !                                     全領域積分および平均(1 層用)
  ! va_IntLon_pva, va_AvrLon_pva     :: 2 次元格子点データの
  !                                     経度方向積分および平均(多層用)
  ! v_IntLon_pv, v_AvrLon_pv         :: 2 次元格子点データの
  !                                     経度方向積分および平均(1 層用)
  ! a_IntLon_pa, a_AvrLon_pa         :: 1 次元(X)格子点データの
  !                                     経度方向積分および平均(多層用)
  ! IntLon_p, AvrLon_p               :: 1 次元(X)格子点データの
  !                                     経度方向積分および平均(1 層用)
  ! pa_IntLat_pva, p_AvrLat_pv       :: 2 次元格子点データの
  !                                     緯度方向積分および平均(多層用)
  ! p_IntLat_pv, p_AvrLat_pv         :: 2 次元格子点データの
  !                                     緯度方向積分および平均(1 層用)
  ! a_IntLat_va, a_AvrLat_va         :: 1 次元(Y)格子点データの
  !                                     緯度方向積分および平均(多層用)
  ! IntLat_v, AvrLat_v               :: 1 次元(Y)格子点データの
  !                                     緯度方向積分および平均(1 層用)
  !
  !==== スペクトル解析
  !
  ! nmb_EnergyFromStreamfunc_wb,nm_EnergyFromStreamfunc_w   ::
  ! 流線関数からエネルギースペクトルを計算する
  ! (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
  !
  ! nb_EnergyFromStreamfunc_wb,n_EnergyFromStreamfunc_w     ::
  ! 流線関数からエネルギースペクトルを計算する
  ! (水平全波数 n 空間) (多層, 1 層用)
  !
  ! nmb_EnstrophyFromStreamfunc_wb,nm_EnstrophyFromStreamfunc_w   ::
  ! 流線関数からエンストロフィースペクトルを計算する
  ! (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
  !
  ! nb_EnstrophyFromStreamfunc_wb,n_EnstrophyFromStreamfunc_w ::
  ! 流線関数からエンストロフィースペクトルを計算する(水平全波数 n 空間)
  ! (多層, 1 層用)
  !
  ! wb_spectrum_VMiss, w_spectrum_VMiss          ::  欠損値
  !
  !
  use dc_message, only : MessageNotify
  use w_mpi_module_integral, only : IntLat_v, AvrLat_v
  use w_mpi_module_interpolate
  use w_mpi_module_spectrum
  use wb_mpi_module_base
  use wb_mpi_module_deriv
  use wb_mpi_module_integral
  use wb_mpi_module_interpolate
  use wb_mpi_module_spectrum

  implicit none

  private
  public wb_mpi_Initial                       ! 初期化
  public wb_mpi_Finalize                      ! 終了処理

  public nproc_h, nproc_v
  public iproc_h, iproc_v

  public jc, nc
  public is, ie, ic
  public ks, ke, kc

  public l_nm, nm_l
  public kp_kl

  public xv_Lon, xv_Lat
  public x_Lon, v_Lat                          ! 格子座標
  public x_Lon_Weight, v_Lat_Weight            ! 格子座標重み
  public pv_Lon, pv_Lat
  public p_Lon                                 ! 格子座標
  public p_Lon_Weight                          ! 格子座標重み

  public wb_pva, pva_wb                        ! 変換関数
  public wb_xvb, xvb_wb                        ! 変換関数
  public xvb_pva, pva_xvb                      ! 変換関数
  public pv_w, w_pv                            ! 変換関数
  public xv_w, w_xv                            ! 変換関数

  public xa_pa, pa_xa                          ! 変換関数
  public aa_ab, ab_aa                          ! 変換関数
  public wb_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public wb_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public wb_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算

  public rn                                   ! ラプラシアンの係数配列

  public wb_Lapla_wb, wb_LaplaInv_wb          ! ラプラシアンと逆演算
  public wb_DLon_wb                           ! 経度微分
  public pva_GradLon_wb, pva_GradLat_wb       ! 勾配型微分
  public wb_DivLon_pva, wb_DivLat_pva         ! 発散型微分
  public wb_Div_pva_pva                       ! 発散型微分
  public wb_JacobianMPI_wb_wb                 ! ヤコビアン
  public pva_GradLambda_wb, pva_GradMu_wb     ! 勾配型微分(λ,μ座標)
  public wb_DivLambda_pva, wb_DivMu_pva       ! 発散型微分(λ,μ座標)

  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public pv_GradLon_w, pv_GradLat_w           ! 勾配型微分
  public w_DivLon_pv, w_DivLat_pv             ! 発散型微分
  public w_Div_pv_pv                          ! 発散型微分
  public w_JacobianMPI_w_w                    ! ヤコビアン
  public pv_GradLambda_w, pv_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_pv, w_DivMu_pv           ! 発散型微分(λ,μ座標)

  public b_Interpolate_wb                     ! 補間関数
  public Interpolate_w                        ! 補間関数

  public a_IntLonLat_pva, IntLonLat_pv        ! 緯度経度積分
  public va_IntLon_pva, a_IntLon_pa, IntLon_p ! 経度積分
  public pa_IntLat_pva, a_IntLat_va, IntLat_v ! 緯度積分
  public a_AvrLonLat_pva, AvrLonLat_pv        ! 緯度経度平均
  public va_AvrLon_pva, a_AvrLon_pa, AvrLon_p ! 経度平均
  public pa_AvrLat_pva, a_AvrLat_va, AvrLat_v ! 緯度平均

  public nmb_EnergyFromStreamfunc_wb        ! エネルギースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public nb_EnergyFromStreamfunc_wb         ! エネルギースペクトル
                                            ! (水平全波数 n 空間)
  public nmb_EnstrophyFromStreamfunc_wb     ! エンストロフィースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public nb_EnstrophyFromStreamfunc_wb      ! エンストロフィースペクトル
                                            !  (水平全波数 n 空間)
  public wb_spectrum_VMiss                  ! 欠損値

  public nm_EnergyFromStreamfunc_w          ! エネルギースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_w           ! エネルギースペクトル
                                            ! (水平全波数 n 空間)
  public nm_EnstrophyFromStreamfunc_w       ! エンストロフィースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_w        ! エンストロフィースペクトル
                                            !  (水平全波数 n 空間)
  public w_spectrum_VMiss                   ! 欠損値

contains
  subroutine wb_mpi_Initial(n_in,i_in,j_in,k_in,np,npv)
    !
    ! スペクトル変換の格子点数, 波数, 最大データ数(層数)および
    ! OPENMP 使用時の最大スレッド数を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない.
    !
    integer,intent(in) :: i_in                ! 格子点数(東西)
    integer,intent(in) :: j_in                ! 格子点数(南北)
    integer,intent(in) :: n_in                ! 切断波数
    integer,intent(in) :: k_in                ! 最大データ数(層数)
    integer,intent(in), optional :: np        ! OPENMP での最大スレッド数(dummy)
    integer,intent(in), optional :: npv       ! OPENMP での最大スレッド数

    if ( present(np) ) &
      call MessageNotify('M','wb_mpi_Initial','Optional argument np is dummy')
    if ( present(npv) ) then
      call wb_base_mpi_Initial(n_in,i_in,j_in,k_in,npv=npv)
    else
      call wb_base_mpi_Initial(n_in,i_in,j_in,k_in)
    endif
    call wb_deriv_mpi_Initial

    call MessageNotify('M',&
      & 'wb_mpi_initial', &
      & 'wb_mpi_module (2020/08/02) is initialized')

  end subroutine wb_mpi_Initial

  !--------------- 終了処理 -----------------
  subroutine wb_mpi_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう.
    !
    ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
    ! おこなったのちに再度 ua_mpi_Initial で初期設定しなければ
    ! ならない.
    !
    call wb_base_mpi_Finalize
    call wb_deriv_mpi_Finalize

    call MessageNotify('M','wb_mpi_Finalize', &
      'wb_mpi_module (2020/08/02) is finalized')

  end subroutine wb_mpi_Finalize

end module wb_mpi_module

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_spectrum_module テストプログラム :: スペクトル関数のテスト
!
!履歴  2019/05/03  竹広真一
!      2020/11/10  竹広真一  セクター計算オプション導入
!
program ua_mpi_module_spectrum_mint
  use mpi
  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_mint
  implicit none

!!$  integer, parameter :: im=64, jm=32, nm=21, km=2, npv=2, mint=1
  integer, parameter :: im=64, jm=32, nm=21, km=2, npv=2, mint=2

  real(8), allocatable ::  ua_data(:,:)
  real(8), allocatable ::  xvb_data(:,:,:)
  real(8), allocatable               ::  b_data(:)

  real(8), dimension(0:nm,-nm:nm,km) ::  nma_data
  real(8), dimension(0:nm,km)        ::  na_data
  real(8), dimension(km)             ::  a_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: n,m
  integer :: ip, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call ua_mpi_Initial( nm, im, jm, km, npv=npv, mint=mint )

  allocate(ua_data(nmc,km))
  allocate(xvb_data(0:im-1,1:jc,kc))
  allocate(b_data(kc))

  call MessageNotify('M','ua_mpi_module_spectrum_mint_test',&
                         'ua_mpi_module_mint spectrum functions tests.')

  ua_data = 0.0D0
  !ua_data = ua_xvb(xvb_ua(ua_data))

  ! 2Y_1^0
  if ( kp_kl(1) /= 0 ) &
       xvb_data(:,:,kp_kl(1)) = 2*sqrt(3.0D0)*sin(xv_Lat) 
  ! 3*Y_1^0 + 2Y_2^0 +Y_2^-2
  if ( kp_kl(2) /= 0 ) &
  xvb_data(:,:,kp_kl(2)) = 3*sqrt(3.0D0)*sin(xv_Lat) &
                + 2*sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0) &
                - sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)

  ua_data = ua_xvb(xvb_data)

  !--------- Energy spectrum ---------
  nma_data=ua_spectrum_VMiss

  do n=0,nm
     do m=-n,n
        nma_data(n,m,:) = 0.0D0
     enddo
  enddo

  nma_data(1,0,1) = 4.0D0
  nma_data(1,0,2) = 9.0D0
  nma_data(2,0,2) = 12.0D0
  nma_data(2,-2,2)= 2*3*(1.0D0/2)**2/2
  nma_data(2,2,2) = nma_data(2,-2,2)

  call AssertEqual(&
    message='nma_EnergyFromStreamfunc_ua',                        &
    answer = nma_EnergyFromStreamfunc_ua(ua_data),                &
    check =  nma_data,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  na_data = 0.0D0
  na_data(1,1) = 4.0D0
  na_data(1,2) = 9.0D0
  na_data(2,2) = 12.0D0 + 2*3*(1.0D0/2)**2

  call AssertEqual(&
    message='na_EnergyFromStreamfunc_ua',                         &
    answer = na_EnergyFromStreamfunc_ua(ua_data),                 &
    check =  na_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nma_Data = nma_EnergyFromStreamfunc_ua(ua_data)
  b_data = 0.0D0
  do n=0,nm
     do m=-n,n
        b_data = b_data + nma_Data(n,m,ks:ke)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum',                        &
    answer = b_AvrLonLat_xvb(                                     &
    0.5*(xvb_GradLon_ua(ua_data)**2+xvb_GradLat_ua(ua_data)**2) ),&
    check = b_data,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  a_data = sum(na_EnergyFromStreamfunc_ua(ua_data),1)
  b_data = a_data(ks:ke)
  call AssertEqual(&
    message='total energy with n-spectrum',                       &
    answer = b_AvrLonLat_xvb(                                     &
    0.5*(xvb_GradLon_ua(ua_data)**2+xvb_GradLat_ua(ua_data)**2) ),&
    check =  b_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nma_data=ua_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nma_data(n,m,:) = 0.0D0
     enddo
  enddo

  nma_data(1,0,1) = 8.0D0

  nma_data(1,0,2)  = 18.0D0
  nma_data(2,0,2)  = 72.0D0
  nma_data(2,-2,2) = 2**2 * 3**2 * (1.0D0/2)**2 /2
  nma_data(2,2,2)  = nma_data(2,-2,2)

  call AssertEqual(&
    message='nma_EnstrophyFromStreamfunc_ua',                     &
    answer = nma_EnstrophyFromStreamfunc_ua(ua_data),             &
    check =  nma_data,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  na_data = 0.0
  na_data(1,1) = 8.0D0
  na_data(1,2) = 18.0D0
  na_data(2,2) = 72.0D0 + 2**2 * 3**2 * (1.0D0/2)**2

  call AssertEqual(&
    message='na_EnstrophyFromStreamfunc_ua',                      &
    answer = na_EnstrophyFromStreamfunc_ua(ua_data),              &
    check =  na_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nma_Data = nma_EnstrophyFromStreamfunc_ua(ua_data)
  b_data = 0.0D0
  do n=0,nm
     do m=-n,n
        b_data = b_data + nma_Data(n,m,ks:ke)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum',                     &
    answer = b_AvrLonLat_xvb( 0.5*(xvb_ua(ua_Lapla_ua(ua_data))**2)),&
    check = b_data,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  a_data = sum(na_EnstrophyFromStreamfunc_ua(ua_data),1)
  b_data = a_data(ks:ke)
  call AssertEqual(&
    message='total energy with n-spectrum',                       &
    answer = b_AvrLonLat_xvb( 0.5*(xvb_ua(ua_Lapla_ua(ua_data))**2)), &
    check =  b_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ua_mpi_module_spectrum_mint_test', &
                     'ua_mpi_module_mint spectrum tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_mpi_module_spectrum_mint

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
!***********************************************************************
!     そのプロセスが扱う Mの範囲を返す(MPI用).
!     MCM: そのプロセスが扱う M の個数(扱わない場合は 0)
!     MC: そのプロセスで扱う Mが格納される 配列 MC(1:MCM)
!-----------------------------------------------------------------------
SUBROUTINE SYQMNM(MM,MCM,MC,ICOM,MI)

  IMPLICIT NONE    
  INCLUDE 'mpif.h'
  INTEGER(8) :: MM,MCM,N1,M1,K,ICOM,MI
  INTEGER(8) :: MC(*) ! MC(MM/NP+1) 
  INTEGER :: NP,IP,IERR,ICOM4

  ICOM4=ICOM
!  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
!  CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)
  CALL MPI_COMM_RANK(ICOM4,IP,IERR)

  N1=(MM/MI+1)/NP
  M1=N1*NP*MI
  MCM=N1
  IF(MOD(N1,2).EQ.0) THEN
     IF(IP.LE.MM/MI-M1/MI) THEN
        MCM=MCM+1
     END IF
  ELSE
     IF(IP.GE.NP-MM/MI+M1/MI-1) THEN
        MCM=MCM+1
     END IF
  END IF

  DO K=0,MCM-1
     MC(K+1)=( K*NP+IP+MOD(K,2)*(NP-2*IP-1) )*MI
  END DO

END SUBROUTINE SYQMNM

!----------------------------------------------------------------------
!     Copyright (c) 2022 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム (境界値問題, ▽^2φ から φを求める)
!
!履歴  2022/03/29  竹広真一
!
program tee_mpi_module_test_LaplaInvTau

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

  !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=16       ! 切断波数の設定(X,Y)

  !---- 変数 ----
  real(8), allocatable :: zvx_Data(:,:,:)           ! 格子データ
  real(8), allocatable :: zvx_Data_orig(:,:,:)      ! 格子データ
  real(8), allocatable :: zvx_Lapla(:,:,:)          ! 格子データ
  real(8), allocatable :: zvx_Lapla_orig(:,:,:)     ! 格子データ
  real(8), allocatable :: zvx_DData(:,:,:)           ! 格子データ
  real(8), allocatable :: tef_Data(:,:,:)           ! スペクトルデータ
  real(8), allocatable :: tef_Lapla(:,:,:)          ! スペクトルデータ

  real(8), allocatable :: zvx_Null(:,:,:)           ! 格子データ

  integer            :: l=2, m=5
  integer            :: np, ip, ierr
  
  !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','tee_mpi_module_test_LaplaInvTau', &
       'tee_mpi_module Inverse Laplacian function tests')

  !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
   
  !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Data(0:km,jc(ip),0:im-1))           ! 格子データ
  allocate(zvx_Data_orig(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(zvx_Lapla(0:km,jc(ip),0:im-1))          ! 格子データ
  allocate(zvx_Lapla_orig(0:km,jc(ip),0:im-1))     ! 格子データ
  allocate(zvx_DData(0:km,jc(ip),0:im-1))          ! 格子データ
  allocate(tef_Data(0:nm,-mm:mm,2*lc(ip)))         ! スペクトルデータ
  allocate(tef_Lapla(0:nm,-mm:mm,2*lc(ip)))        ! スペクトルデータ

  allocate(zvx_Null(0:km,jc(ip),0:im-1)) ! 格子データ
  zvx_Null = 0.0D0

  !-------------------BC-DD(Tau) ----------------------
  zvx_Data_orig = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * cos(pi/2.0D0*zvx_Z)
  zvx_Lapla_orig = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Data_orig)))

  tef_Data = tef_zvx(zvx_Data_orig)
  tef_Lapla = tef_Lapla_tef(tef_Data)
  zvx_Data  = zvx_tef(tef_LaplaInvDD_tef(tef_Lapla))

  call AssertEqual(&
       message='tef_LaplaInvTauDD_tef',                           &
       answer = zvx_Data_orig,                                    &
       check = zvx_Data,                                          &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  !-------------------BC-NN(Tau) ----------------------
  zvx_Data_orig = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * sin(pi/2.0D0*zvx_Z)
  zvx_Lapla_orig = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Data_orig)))

  tef_Data = tef_zvx(zvx_Data_orig)
  tef_Lapla = tef_Lapla_tef(tef_Data)
  zvx_Data  = zvx_tef(tef_LaplaInvNN_tef(tef_Lapla))

  call AssertEqual(&
       message='tef_LaplaInvTauNN_tef',                           &
       answer = zvx_Data_orig,                                    &
       check = zvx_Data,                                          &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

!!$  !-------------------BC-RR(Tau) ----------------------
!!$  zvx_Polvel_orig = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (zvx_Z-zmin)**2 * (zvx_Z-zmax)**2
!!$  zvx_LaplaPolvel_orig = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Polvel_orig)))
!!$
!!$  tef_Polvel = tef_LaplaPol2PolTau_tef(tef_zvx(zvx_LaplaPolvel_orig),&
!!$       cond='RR',new=.true.)
!!$
!!$  zvx_Polvel = zvx_tef(tef_Polvel)
!!$  zvx_LaplaPolvel = zvx_tef(tef_Lapla_tef(tef_Polvel))
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RR,poloidal]',              &
!!$    answer = zvx_Polvel_orig,                                     &
!!$    check = zvx_Polvel,                                           &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RR,laplapol]',              &
!!$    answer = zvx_LaplaPolvel_orig,                                &
!!$    check = zvx_LaplaPolvel,                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RR,Top]',                   &
!!$    answer = zvx_Polvel(0,:,:),                                   &
!!$    check = zvx_Null(0,:,:),                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RR,Bottom]',                &
!!$    answer = zvx_Polvel(km,:,:),                                  &
!!$    check = zvx_Null(km,:,:),                                     &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Polvel))
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RR,Top,deriv]',             &
!!$    answer = zvx_DPolvel(0,:,:),                                  &
!!$    check = zvx_Null(0,:,:),                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RR,Bottom,deriv]',          &
!!$    answer = zvx_DPolvel(km,:,:),                                 &
!!$    check = zvx_Null(km,:,:),                                     &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$ !-------------------BC-RF(Tau) ----------------------
!!$  zvx_Polvel_orig = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (zvx_Z-zmin)**3 * (zvx_Z-zmax)**2
!!$  zvx_LaplaPolvel_orig = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Polvel_orig)))
!!$
!!$  tef_Polvel = tef_LaplaPol2PolTau_tef(tef_zvx(zvx_LaplaPolvel_orig),&
!!$       cond='RF',new=.true.)
!!$
!!$  zvx_Polvel = zvx_tef(tef_Polvel)
!!$  zvx_LaplaPolvel = zvx_tef(tef_Lapla_tef(tef_Polvel))
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RF,poloidal]',              &
!!$    answer = zvx_Polvel_orig,                                     &
!!$    check = zvx_Polvel,                                           &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RF,laplapol]',              &
!!$    answer = zvx_LaplaPolvel_orig,                                &
!!$    check = zvx_LaplaPolvel,                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RF,Top]',                   &
!!$    answer = zvx_Polvel(0,:,:),                                   &
!!$    check = zvx_Null(0,:,:),                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RF,Bottom]',                &
!!$    answer = zvx_Polvel(km,:,:),                                  &
!!$    check = zvx_Null(km,:,:),                                     &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Polvel))
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RF,Top,deriv]',             &
!!$    answer = zvx_DPolvel(0,:,:),                                  &
!!$    check = zvx_Null(0,:,:),                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Dz_tef(tef_Polvel)))
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RF,Bottom,deriv]',          &
!!$    answer = zvx_DPolvel(km,:,:),                                 &
!!$    check = zvx_Null(km,:,:),                                     &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$ !-------------------BC-FR(Tau) ----------------------
!!$  zvx_Polvel_orig = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (zvx_Z-zmin)**2 * (zvx_Z-zmax)**3
!!$  zvx_LaplaPolvel_orig = zvx_tef(tef_Lapla_tef(tef_zvx(zvx_Polvel_orig)))
!!$
!!$  tef_Polvel = tef_LaplaPol2PolTau_tef(tef_zvx(zvx_LaplaPolvel_orig),&
!!$       cond='FR',new=.true.)
!!$
!!$  zvx_Polvel = zvx_tef(tef_Polvel)
!!$  zvx_LaplaPolvel = zvx_tef(tef_Lapla_tef(tef_Polvel))
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [FR,poloidal]',              &
!!$    answer = zvx_Polvel_orig,                                     &
!!$    check = zvx_Polvel,                                           &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [FR,laplapol]',              &
!!$    answer = zvx_LaplaPolvel_orig,                                &
!!$    check = zvx_LaplaPolvel,                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [FR,Top]',                   &
!!$    answer = zvx_Polvel(0,:,:),                                   &
!!$    check = zvx_Null(0,:,:),                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [FR,Bottom]',                &
!!$    answer = zvx_Polvel(km,:,:),                                  &
!!$    check = zvx_Null(km,:,:),                                     &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Dz_tef(tef_Polvel)))
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [FR,Top,deriv]',             &
!!$    answer = zvx_DPolvel(0,:,:),                                  &
!!$    check = zvx_Null(0,:,:),                                      &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  zvx_DPolvel = zvx_tef(tef_Dz_tef(tef_Polvel))
!!$
!!$  call AssertEqual(&
!!$    message='tef_LaplaPol2PolTau_tef [RF,Bottom,deriv]',          &
!!$    answer = zvx_DPolvel(km,:,:),                                 &
!!$    check = zvx_Null(km,:,:),                                     &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
  call MPI_FINALIZE(IERR)

  call MessageNotify('M','tee_mpi_module_test_LaplaInvTau_test', &
       'tee_mpi_module Inverse Laplacian function tests succeeded.')

end program tee_mpi_module_test_LaplaInvTau

!----------------------------------------------------------------------
!     Copyright (c) 2019--2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム
!
!      ポロイダルポテンシャルの境界値問題
!
!履歴  2019/06/29  竹広真一
!      2020/11/11  竹広真一  セクター計算オプション導入
!
program ut_mpi_module_polvelbc_grid_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_mint
  use mpi

  implicit none

!!$  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
!!$  integer,parameter  :: mint=1               ! 経度方向対称性
  integer,parameter  :: im=16, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: mint=2               ! 経度方向対称性
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv = 2
  integer :: iproc, np, ierr

  real(8), allocatable :: xvh_Polvel(:,:,:)

  real(8), allocatable :: ut_Polvel(:,:)
  real(8), allocatable :: ut_LaplaPol(:,:)
  real(8), allocatable :: ut_LaplaPol0(:,:)
  real(8), allocatable :: uz_Polvel(:,:)
  real(8), allocatable :: uz_True(:,:)
  real(8), allocatable :: uz_Zero(:,:)

  character(len=2), dimension(4), parameter :: BCond=(/'FF','FR','RF','RR'/)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: l

  !---------------- MPI スタート ---------------------
  ! call get_ENV_INT('NPV',npv)
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_polvelbc_mint_grid', &
       'ut_mpi_module_mint Polvelbc(Grid) function tests')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro,npv=npv,mint=mint)

  allocate(xvh_Polvel(0:im-1,jc,kc))

  allocate(ut_Polvel(nmc,0:lm))
  allocate(ut_LaplaPol(nmc,0:lm))
  allocate(ut_LaplaPol0(nmc,0:lm))
  allocate(uz_Polvel(nmc,0:km))
  allocate(uz_True(nmc,0:km))
  allocate(uz_Zero(nmc,0:km))

  do l=1,4

     ! P_10
     !xvh_Polvel = sin(xvh_Lat) * sin( pi*(xvh_Rad-ri)/(ro-ri) )
     !xvh_LaplaPol = xvh_ut(ut_Lapla_ut(ut_xvh(xvh_Polvel)))
     !xvh_LaplaPol = sin(xvh_Lat) * sin( pi*(xvh_Rad-ri)/(ro-ri) )
     ! P_2_2
     !xvh_LaplaPol = cos(xvh_Lat)**2*cos(2*xvh_Lon)* sin( pi*(xvh_Rad-ri)/(ro-ri) )
     !xvh_LaplaPol = 2*sin(xvh_Lat)**2 * sin( pi*(xvh_Rad-ri)/(ro-ri) )

     !xvh_Polvel = xvh_wz(wz_LaplaPol2pol_wz(wz_xvh(xvh_LaplaPol),BCond(l)))
     !xvh_Polvel = xvh_ut(ut_LaplaPol2PolGrid_ut(ut_xvh(xvh_LaplaPol),BCond(l)))
     select case (BCOND(l))
     case ('FF')
        xvh_Polvel = sin(xvh_Lat) * (xvh_Rad-ri)**3*(xvh_Rad-ro)**3
     case('FR')
        xvh_Polvel = cos(xvh_lat)**2*cos(2*xvh_lon) * (xvh_Rad-ri)**2*(xvh_Rad-ro)**3
     case('RF')
        xvh_Polvel = 2*sin(xvh_lat)**2 * (xvh_Rad-ri)**3*(xvh_Rad-ro)**2
     case('RR')
        xvh_Polvel = sin(xvh_Lat) * (xvh_Rad-ri)**2*(xvh_Rad-ro)**2
     end select

     ut_LaplaPol  = ut_Lapla_ut(ut_xvh(xvh_Polvel))
     ut_Polvel    = ut_LaplaPol2PolGrid_ut(ut_LaplaPol,BCond(l),new=.true.)
     ut_LaplaPol0 = ut_Lapla_ut(ut_Polvel)
     uz_Polvel    = uz_ut(ut_Polvel)

     uz_Zero = 0.0D0

     !---------------- 内部チェック -----------------------
     call AssertEqual(&
          message='ut_LaplaPol2polGrid_ut (intenal value)',           &
          answer = ut_Laplapol0(:,0:lm-4),                           &
          check = ut_LaplaPol(:,0:lm-4),                             &
          significant_digits = check_digits, ignore_digits = ignore  &
          )

     !--------- 上端境界チェック ----------
     !----- Φ=0 at the top ---------
     call AssertEqual(&
          message='ut_LaplaPol2polGrid_ut (Top B.C. Phi=0)',          &
          answer = uz_Zero(:,0),                                     &
          check = uz_Polvel(:,0),                                  &
          significant_digits = check_digits, ignore_digits = ignore  &
          )

     !----- dΦ/dr=0, d^2Φ/dr^2 at the top ---------
     if( BCond(l)(1:1) == 'F' ) then
        uz_True = uz_ut(ut_DRad_ut(ut_DRad_ut(ut_Polvel)))
     else
        uz_True = uz_ut(ut_DRad_ut(ut_Polvel))
     endif

     call AssertEqual(&
          message='ut_LaplaPol2polGrid_ut ('//BCond(l)//'-Top B.C)',  &
          answer = uz_Polvel(:,0),                                 &
          check = uz_True(:,0),                                      &
          significant_digits = check_digits, ignore_digits = ignore  &
          )

     !--------- 下端境界チェック ----------
     !----- Φ=0 at the bottom ---------
     call AssertEqual(&
          message='ut_LaplaPol2polGrid_ut (Bottom B.C. Phi=0)',       &
          answer = uz_Zero(:,km),                                    &
          check = uz_Polvel(:,km),                                 &
          significant_digits = check_digits, ignore_digits = ignore  &
          )

     !----- dΦ/dr=0, d^2Φ/dr^2 at the bottom ---------
     if( BCond(l)(2:2) == 'F' ) then
        uz_True = uz_ut(ut_DRad_ut(ut_DRad_ut(ut_Polvel)))
     else
        uz_True = uz_ut(ut_DRad_ut(ut_Polvel))
     endif

     call AssertEqual(&
          message='ut_LaplaPol2polGrid_ut ('//BCond(l)//'-Bottom B.C)',&
          answer = uz_Zero(:,km),                                     &
          check = uz_True(:,km),                                      &
          significant_digits = check_digits, ignore_digits = ignore   &
          )
  end do

  call MessageNotify('M','ut_mpi_module_polvelbc_grid_mint_test', &
       'ut_mpi_module_mint Polvelbc(Grid) function tests suceeded!')

  !------ MPIの終了 ------
  call MPI_FINALIZE(IERR)

end program ut_mpi_module_polvelbc_grid_mint_test

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム (境界値問題, ポロイダル磁場, Tau 法)
!
!履歴  2016/09/20  竹広真一
!
program tee_mpi_module_polmagbctau_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=64, jm=64, km=32       ! 格子点の設定(X,Y)
  integer, parameter :: lm=21, mm=21, nm=21       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: zvx_Polmag(:,:,:)       ! 格子データ

  real(8), allocatable :: tef_Polmag(:,:,:)       ! スペクトルデータ
  real(8), allocatable :: tef_Polmag_orig(:,:,:)  ! スペクトルデータ

  real(8), allocatable :: tef_Kh(:,:,:)           ! 水平全波数

  real(8), allocatable :: zef_Boundary(:,:,:)     ! 境界条件
  real(8), allocatable :: ef_Null(:,:)            ! 0 

  real(8)            :: rl, rm
  integer            :: l=2, m=5
  integer            :: l1, m1
  integer            :: np, ip, ierr
  
 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_mpi_module_PolmagbcTau_test', &
       'tee_mpi_module poloidal mag. field B.C. subruoutine tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
   
 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Polmag(0:km,jc(ip),0:im-1))        ! 格子データ

  allocate(tef_Polmag(0:nm,-mm:mm,2*lc(ip)))      ! スペクトルデータ
  allocate(tef_Polmag_orig(0:nm,-mm:mm,2*lc(ip))) ! スペクトルデータ

  allocate(tef_Kh(0:nm,-mm:mm,2*lc(ip)))          ! 水平全波数

  allocate(zef_Boundary(0:km,-mm:mm,2*lc(ip)))    ! 境界条件
  allocate(ef_Null(-mm:mm,2*lc(ip)))              ! 0
  ef_Null = 0.0D0

  do m1=-mm,mm
     do l1=-lm,lm
        if ( lf_l(l1) > 0 ) then
           rl = 2*PI/(xmax-xmin)*l1 ; rm = 2*PI/(ymax-ymin)*m1
           tef_Kh(:,m1,lf_l(l1)) = sqrt(rl**2+rm**2)
        end if
     enddo
     if ( lf_l(0) > 0 ) then
        tef_Kh(:,m1,2*lc(ip)) = tef_Kh(:,m1,1)
     end if
  enddo

 !-------------------BC-DD(Tau) ----------------------
  zvx_Polmag = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z

  tef_Polmag = tef_zvx(zvx_Polmag)
  tef_Polmag_orig = tef_Polmag

  call tef_PolmagBoundariesTau(tef_Polmag)
  zvx_Polmag = zvx_tef(tef_Polmag)

  call AssertEqual(&
    message='tef_PolmagBoundariesTau [internal]',&
    answer = tef_Polmag_orig(0:nm-2,:,:),                         &
    check = tef_Polmag(0:nm-2,:,:),                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zef_Boundary = zef_tef(tef_Dz_tef(tef_Polmag) + tef_Kh * tef_Polmag)
     
  call AssertEqual(&
    message='tef_PolmagBoundariesTau [Top]',&
    answer = ef_Null,                                             &
    check = zef_Boundary(0,:,:),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zef_Boundary = zef_tef(tef_Dz_tef(tef_Polmag) - tef_Kh * tef_Polmag)
  call AssertEqual(&
    message='tef_PolmagBoundariesTau [Bottom]',&
    answer = ef_Null,                                             &
    check = zef_Boundary(km,:,:),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','tee_mpi_module_PolmagbcTau_test', &
       'tee_mpi_module poloidal mag. field B.C. subruoutine tests succeeded!')

end program tee_mpi_module_polmagbctau_test

! -*- mode: f90; coding: utf-8 -*-
!----------------------------------------------------------------------
! Copyright(c) 2002-2019 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief 2 次元水路領域: Fourier 展開 + Chebyshev 展開法
!>
!> @details
!>
!> spml/et_module モジュールは 2 次元水路領域での流体運動を
!> スペクトル法により数値計算を実行するための Fortran90 関数を提供する.
!> 周期的な境界条件を扱うための X 方向へのフーリエ変換と境界壁を扱うための
!> Y 方向のチェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!> 関数を提供する.
!>
!> 内部で ae_module, at_module を用いている.
!> 最下部ではフーリエ変換およびチェビシェフ変換のエンジンとして
!> ISPACK3/FXPACKを用いている.
!>
!> ## 関数・変数の名前と型について
!>
!> ### 命名法
!>
!> * 関数名の先頭 (et_, yx_, x_, y_) は, 返す値の形を示している.
!>   et_ :: 2次元スペクトルデータ
!>   yx_ :: 2 次元格子点データ
!>   x_  :: X 方向 1 次元格子点データ
!>   y_  :: Y 方向 1 次元格子点データ
!>
!> * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv, Jacobian)は,
!>   その関数の作用を表している.
!>
!> * 関数名の最後 (_et_et, _et, _yx, _x, _y) は, 入力変数のスペクトルデータ
!>   および格子点データであることを示している.
!>   _et    :: 2次元スペクトルデータ
!>   _et_et :: 2 つの2次元スペクトルデータ
!>   _yx    :: 2 次元格子点データ
!>   _x     :: X 方向 1 次元格子点データ
!>   _y     :: Y 方向 1 次元格子点データ
!>
!> ### 各データの種類の説明
!>
!> * yx : 2 次元格子点データ.
!>   * 変数の種類と次元は real(DP), dimension(0:jm,0:im-1).
!>   * im, jm はそれぞれ X, Y 座標の格子点数であり, サブルーチン
!>     et_initial にてあらかじめ設定しておく.
!>   * 第 1 次元が Y 座標の格子点位置番号, 第 2 次元が X 座標の
!>     格子点位置番号である (X, Y の順ではない)ことに注意.
!>
!> * et : 2 次元スペクトルデータ.
!>   * 変数の種類と次元は real(DP), dimension(-km:km,0:lm).
!>   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン
!>     et_initial にてあらかじめ設定しておく.
!>   * スペクトルデータの格納のされ方については...
!>
!> * x, y : X, Y 方向 1 次元格子点データ.
!>   * 変数の種類と次元はそれぞれ real(DP), dimension(0:im-1)
!>     および real(DP), dimension(0:jm).
!>
!> * e, t : 1 次元スペクトルデータ.
!>   * 変数の種類と次元は real(DP), dimension(-km:km)
!>     および real(DP), dimension(-lm:lm).
!>
!> * ax, ay : 1 次元格子点データの並んだ 2 次元配列.
!>   * 変数の種類と次元は real(DP), dimension(:,0:im-1)
!>     および real(DP), dimension(:,0:jm).
!>
!> * ae, at : 1 次元スペクトルデータの並んだ 2 次元配列.
!>   * 変数の種類と次元は real(DP), dimension(:,-km:km)
!>     および real(DP), dimension(:,0:lm).
!>
!> * et_ で始まる関数が返す値はスペクトルデータに同じ.
!>
!> * yx_ で始まる関数が返す値は 2 次元格子点データに同じ.
!>
!> * x_, y_ で始まる関数が返す値は 1 次元格子点データに同じ.
!>
!> * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
!>   微分などを作用させたデータをスペクトル変換したものことである.
!----------------------------------------------------------------------
!履歴  2002/01/27  竹広真一
!      2002/03/30  竹広真一  モジュール名変更
!      2002/08/19  竹広真一  格子データ添字を gg -> xy, eg -> ey に変更
!                            積分・平均関数追加
!      2005/01/09  竹広真一  msgdmp -> MessageNotify に変更
!      2005/03/15  竹広真一  xy -> yx に接頭子を変更
!      2006/03/04  竹広真一  余計な変数を削除(et_Jacobian_et_et)
!      2006/03/06  竹広真一  コメントを RDoc 用に修正
!      2007/11/20  竹広真一  渦度-流線関数計算に行列設定スイッチ導入
!      2007/11/21  竹広真一  初期化サブルーチンメッセージ出力
!      2009/01/09  竹広真一  et_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に修正
!      2009/07/31  竹広真一  境界条件計算用配列を threadprivate 指定(OpenMP)
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2011/03/06  佐々木洋平 境界条件スイッチを修正, RR をデフォルトに.
!      2011/12/03  竹広真一  補間関数を追加
!      2012/07/08  竹広真一  et_Vor2Strm_et を追加
!      2013/08/20  竹広真一  gnu fortran 対応
!      2015/12/11  竹広真一  et_Vort2Strm_et の境界値オプションを追加
!      2016/09/26  竹広真一  et_BoundariesGrid 追加
!----------------------------------------------------------------------
module et_module
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! et_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! x_X, y_Y     ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, y_Y_Weight ::  重み座標を格納した 1 次元配列
  ! yx_X, yx_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! yx_et :: スペクトルデータから格子データへの変換
  ! et_yx :: 格子データからスペクトルデータへの変換
  ! ax_ae, x_e :: X 方向のスペクトルデータから格子データへの変換
  ! ay_at, y_t :: Y 方向のスペクトルデータから格子データへの変換
  ! ae_ax, e_x :: X 方向の格子点データからスペクトルデータへの変換
  ! at_ay, t_y :: Y 方向の格子点データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! et_Lapla_et  :: スペクトルデータにラプラシアンを作用させる
  ! et_Dx_et, ae_Dx_ae, e_Dx_e :: スペクトルデータに X 微分を作用させる
  ! et_Dy_et, at_Dy_at, t_Dy_t :: スペクトルデータに Y 微分を作用させる
  ! et_Jacobian_et_et :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  !==== 境界値問題
  !
  ! et_Boundaries  :: ディリクレ, ノイマン境界条件の適用
  ! et_LaplaInv_et :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! et_Vor2Strm_et :: 渦度から流線を計算する
  ! ey_Vor2Strm_ey :: 渦度から流線を計算する
  !
  !==== 積分・平均
  !
  ! IntYX_yx, AvrYX_yx   :: 2 次元格子点データの全領域積分および平均
  ! y_IntX_yx, y_AvrX_yx :: 2 次元格子点データの X 方向積分および平均
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! x_IntY_yx, x_AvrY_yx :: 2 次元格子点データの Y 方向積分および平均
  ! IntY_y, AvrY_y       :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  !==== 補間
  !
  ! Interpolate_et       :: スペクトルデータからの特定の座標の値の補間
  !
  use dc_types, only: DP
  use dc_message, only: MessageNotify
  use lumatrix
  use spml_utils, only: pi
  use ae_module, x_X => g_X, x_X_weight => g_X_Weight, &
    e_x => e_g, ae_ax => ae_ag, &
    x_e => g_e, ax_ae => ag_ae
  use at_module, y_Y => g_X, y_Y_Weight => g_X_Weight, &
    at_ay => at_ag, t_y => t_g, &
    ay_at => ag_at, y_t => g_t, &
    t_Dy_t => t_Dx_t, at_Dy_at => at_Dx_at, &
    et_BoundariesGrid => at_BoundariesGrid
  implicit none
  private

  public et_Initial                                       ! 初期化
  public x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y     ! 座標変数

  public yx_et, et_yx                                     ! 基本変換
  public yx_ey, ey_yx                                     ! 基本変換
  public ey_et, et_ey                                     ! 基本変換
  public e_x, x_e, ae_ax, ax_ae                           ! 基本変換
  public t_y, y_t, at_ay, ay_at                           ! 基本変換

  public et_Dx_et, e_Dx_e, ae_Dx_ae                       ! 微分
  public et_Dy_et, t_Dy_t, at_Dy_at                       ! 微分
  public et_Lapla_et                                      ! 微分

  public et_Jacobian_et_et                                ! 非線形計算

  public et_Boundaries                                    ! 境界値問題
  public at_Boundaries_DD, at_Boundaries_DN               ! 境界値問題
  public at_Boundaries_ND, at_Boundaries_NN               ! 境界値問題
  public et_BoundariesGrid                                ! 境界値問題
  public et_LaplaInv_et, ey_Vor2Strm_ey                   ! 境界値問題
  public et_Vor2Strm_et                                   ! 境界値問題
  public et_Vor2Strm2_et                                  ! 境界値問題
  public et_Vor2Strm3_et                                  ! 境界値問題

  public IntYX_yx, y_IntX_yx, x_IntY_yx, IntX_x, IntY_y   ! 積分
  public AvrYX_yx, y_AvrX_yx, x_AvrY_yx, AvrX_x, AvrY_y   ! 平均

  public Interpolate_et                                   ! 補間

  !> 格子点データの X 座標: 格子点データ型 2 次元配列(X,Y)
  real(DP), dimension(:,:), allocatable :: yx_X
  !> 格子点データの Y 座標: 格子点データ型 2 次元配列(X,Y)
  real(DP), dimension(:,:), allocatable :: yx_Y

  !> X方向格子点
  integer            :: im=32
  !> Y方向格子点
  integer            :: jm=8
  !> X方向切断波数
  integer            :: km=10
  !> Y方向切断波数
  integer            :: lm=5
  !> X 方向計算領域
  real(DP)           :: xl=2.0D0
  !> Y 方向計算領域
  real(DP)           :: yl=1.0D0

  save im, jm, km, lm, xl, yl

contains
  !----------------------------------------------------------
  !> スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
  !>
  !> 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
  !> 初期設定をしなければならない.
  !----------------------------------------------------------
  subroutine et_Initial(i,j,k,l,xmin,xmax,ymin,ymax)
    !> 格子点数(X)
    integer,intent(in) :: i
    !> 格子点数(Y)
    integer,intent(in) :: j
    !> 切断波数(X)
    integer,intent(in) :: k
    !> 切断波数(Y)
    integer,intent(in) :: l
    !> X 座標範囲
    real(DP),intent(in) :: xmin, xmax
    !> Y 座標範囲
    real(DP),intent(in) :: ymin, ymax

    im = i
    jm = j
    km = k
    lm = l
    xl = xmax-xmin
    yl = ymax-ymin

    call ae_initial(im,km,xmin,xmax)
    call at_initial(jm,lm,ymin,ymax)

    allocate(yx_X(0:jm,0:im-1),yx_Y(0:jm,0:im-1))
    yx_X = spread(x_X,1,jm+1)
    yx_Y = spread(y_Y,2,im)

    call MessageNotify('M','et_initial', &
      & 'et_module (2019/09/30) is initialized')
  end subroutine et_initial


  !----------------------------------------------------------
  !> スペクトルデータから格子データへ変換する.
  !----------------------------------------------------------
  function yx_et(et)
    !> スペクトルデータ
    real(DP), dimension(-km:km,0:lm), intent(in)  :: et
    !> 格子点データ
    real(DP), dimension(0:jm,0:im-1)              :: yx_et

    real(DP), dimension(-km:km,0:jm)              :: ey
    real(DP), dimension(0:jm,-km:km)              :: ye

    integer :: j, k

    ! yx_et = ax_ae(transpose(ay_at(et)))
    !
    ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように
    ! 書き直す
    !
    ey = ay_at(et)
    do j=0,jm
      do k=-km,km
        ye(j,k) = ey(k,j)
      enddo
    enddo
    yx_et = ax_ae(ye)

  end function yx_et

  !----------------------------------------------------------
  ! 格子データからスペクトルデータへ変換する.
  !----------------------------------------------------------
  function et_yx(yx)
    !> 格子点データ
    real(DP), dimension(0:jm,0:im-1), intent(in)  :: yx
    !> スペクトルデータ
    real(DP), dimension(-km:km,0:lm)              :: et_yx


    real(DP), dimension(-km:km,0:jm)              :: ey
    real(DP), dimension(0:jm,-km:km)              :: ye

    integer :: j, k

    ! et_yx = at_ay(transpose(ae_ax(yx)))
    !
    ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書き直す
    !
    ye = ae_ax(yx)
    do j=0,jm
      do k=-km,km
        ey(k,j) = ye(j,k)
      enddo
    enddo
    et_yx = at_ay(ey)

  end function et_yx

  !----------------------------------------------------------
  !> X 座標スペクトルデータから格子データへ変換する.
  !----------------------------------------------------------
  function yx_ey(ey)
    !> スペクトルデータ
    real(DP), dimension(-km:km,0:jm), intent(in)  :: ey

    !> 格子点データ
    real(DP), dimension(0:jm,0:im-1)              :: yx_ey

    real(DP), dimension(0:jm,-km:km)              :: ye
    integer :: j, k

    ! yx_ey = ax_ae(transpose(ey))
    !
    ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書
    ! き直す
    !
    do j=0,jm
      do k=-km,km
        ye(j,k) = ey(k,j)
      enddo
    enddo
    yx_ey = ax_ae(ye)

  end function yx_ey

  !----------------------------------------------------------
  ! X 座標格子データからスペクトルデータへ変換する.
  !----------------------------------------------------------
  function ey_yx(yx)
    !> 格子点データ
    real(DP), dimension(0:jm,0:im-1), intent(in)  :: yx
    !> スペクトルデータ
    real(DP), dimension(-km:km,0:jm)              :: ey_yx

    real(DP), dimension(0:jm,-km:km)              :: ye
    integer :: j, k

    ! ey_yx = transpose(ae_ax(yx))
    !
    ! 本来上の書き方でいいはずだが, gfortran で通らないので下のように書
    ! き直す
    !
    ye = ae_ax(yx)
    do j=0,jm
      do k=-km,km
        ey_yx(k,j) = ye(j,k)
      enddo
    enddo

  end function ey_yx

  !----------------------------------------------------------
  !> Y 座標の格子データからスペクトルデータへ変換する.
  !----------------------------------------------------------
  function et_ey(ey)
    !> 格子点データ
    real(DP), dimension(-km:km,0:jm), intent(in)  :: ey
    !> スペクトルデータ
    real(DP), dimension(-km:km,0:lm)              :: et_ey
    et_ey = at_ay(ey)

  end function et_ey

  !----------------------------------------------------------
  !> Y 座標スペクトルデータから格子データへ変換する.
  !----------------------------------------------------------
  function ey_et(et)
    !> スペクトルデータ
    real(DP), dimension(-km:km,0:lm), intent(in)  :: et
    !> 格子点データ
    real(DP), dimension(-km:km,0:jm)              :: ey_et

    ey_et = ay_at(et)

  end function ey_et


  !----------------------------------------------------------
  !>  入力スペクトルデータに X 微分 \f$\partial_x\f$ を作用する.
  !----------------------------------------------------------
  function et_Dx_et(et)
    !> 入力スペクトルデータ
    real(DP), dimension(-km:km,0:lm), intent(in)    :: et
    real(DP), dimension(-km:km,0:lm)                :: et_Dx_et

    integer k
    do k=-km,km
      et_Dx_et(k,:)  =  (-2*pi*k/xl)*et(-k,:)
    enddo
  end function et_Dx_et

  !----------------------------------------------------------
  !>  入力スペクトルデータに Y 微分 \f$\partial_y\f$ を作用する.
  !----------------------------------------------------------
  function et_Dy_et(et)
    !> 入力スペクトルデータ
    real(DP), dimension(-km:km,0:lm), intent(in)   :: et
    real(DP), dimension(-km:km,0:lm)               :: et_Dy_et

    et_Dy_et = at_Dy_at(et)

  end function et_Dy_et

  !----------------------------------------------------------
  !> 入力スペクトルデータにラプラシアン
  !> \f$(\partial_{xx}+\partial_{yy})\f$ を作用する.
  !----------------------------------------------------------
  function et_Lapla_et(et)
    !> 入力スペクトルデータ
    real(DP), dimension(-km:km,0:lm), intent(in)    :: et
    real(DP), dimension(-km:km,0:lm)                :: et_Lapla_et

    integer k
    do k=-km,km
      et_Lapla_et(k,:) = -(2*pi*k/xl)**2*et(k,:)
    enddo

    et_Lapla_et = et_Lapla_et + et_Dy_et(et_Dy_et(et))

  end function et_Lapla_et

  !----------------------------------------------------------
  !> 2 つのスペクトルデータからヤコビアン
  !> \f$ J(A,B) = (\partial_{x}A)(\partial_{y}B)
  !>            -(\partial_{y}A)(\partial_{x}B)\f$ を計算する.
  !----------------------------------------------------------
  function et_Jacobian_et_et(et_a,et_b)
    !> 1つ目の入力スペクトルデータ
    real(DP), dimension(-km:km,0:lm), intent(in)    :: et_a
    !> 2つ目の入力スペクトルデータ
    real(DP), dimension(-km:km,0:lm), intent(in)    :: et_b
    !> 2 つのスペクトルデータのヤコビアン
    real(DP), dimension(-km:km,0:lm)                :: et_Jacobian_et_et
    et_Jacobian_et_et = et_yx(                           &
      &  yx_et(et_Dx_et(et_a)) * yx_et(et_Dy_et(et_b))   &
      & - yx_et(et_Dy_et(et_a)) * yx_et(et_Dx_et(et_b)) )

  end function et_Jacobian_et_et


  !----------------------------------------------------------
  !> ディリクレ, ノイマン条件の適用. チェビシェフ空間での計算
  !>
  !> 実際には中で呼ばれている at_module のサブルーチン at_Boundaries_DD,
  !> at_Boundaries_DN, at_Boundaries_ND, at_Boundaries_NN を用いている.
  !> これらを直接呼ぶことも出来る.
  !----------------------------------------------------------
  subroutine et_Boundaries(et,values,cond)
    !> 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
    !> 省略時は値/勾配 0 となる.
    real(DP), dimension(-km:km,2), intent(in), optional :: values

    !> 境界条件を適用するデータ. 修正された値を返す.
    real(DP), dimension(-km:km,0:lm),intent(inout)      :: et

    !> 境界条件. 省略時は 'RR'
    !> * DD : 両端ディリクレ
    !> * DN,ND : ディリクレ/ノイマン条件
    !> * NN : 両端ノイマン
    character(len=2), intent(in), optional             :: cond

    if (.not. present(cond)) then
      if (present(values)) then
        call at_Boundaries_DD(et,values)
      else
        call at_Boundaries_DD(et)
      endif
      return
    endif

    select case(cond)
    case ('NN')
      if (present(values)) then
        call at_Boundaries_NN(et,values)
      else
        call at_Boundaries_NN(et)
      endif
    case ('DN')
      if (present(values)) then
        call at_Boundaries_DN(et,values)
      else
        call at_Boundaries_DN(et)
      endif
    case ('ND')
      if (present(values)) then
        call at_Boundaries_ND(et,values)
      else
        call at_Boundaries_ND(et)
      endif
    case ('DD')
      if (present(values)) then
        call at_Boundaries_DD(et,values)
      else
        call at_Boundaries_DD(et)
      endif
    case default
      call MessageNotify('E','et_Boundaries','B.C. not supported')
    end select

  end subroutine et_Boundaries

  !----------------------------------------------------------
  !> 境界で一様な値を与える条件(ディリクレ条件)下で
  !> 入力スペクトルデータに逆ラプラシアン
  !> \f$(\partial_{xx}+\partial_{yy})^{-1}\f$ を作用する
  !> (Chebyshev-tau法)
  !----------------------------------------------------------
  function et_LaplaInv_et(et,values)
    !> スペクトルデータ
    real(DP), dimension(-km:km,0:lm),intent(in)  :: et
    !> 境界値. 省略時は 0 が設定される.
    real(DP), dimension(-km:km,2), intent(in), optional :: values
    !> スペクトルデータの逆ラプラシアン
    real(DP), dimension(-km:km,0:lm)             :: et_LaplaInv_et

    real(DP), dimension(:,:,:), allocatable  :: alu
    integer,  dimension(:,:), allocatable    :: kp
    real(DP), dimension(-km:km,0:lm)         :: et_work
    real(DP), dimension(-km:km,0:jm)         :: ey_work
    real(DP), dimension(-km:km)              :: value1, value2   ! 境界値

    logical :: first = .true.
    integer :: l
    save    :: alu, kp, first

    if (.not. present(values)) then
      value1=0.0D0
      value2=0.0D0
    else
      value1 = values(:,1)
      value2 = values(:,2)
    endif

    if ( first ) then
      first = .false.

      allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

      do l=0,lm
        et_work=0.0D0
        et_work(:,l) = 1.0D0
        alu(:,:,l) = et_Lapla_et(et_work)
        ey_work = ay_at(et_work)
        alu(:,lm-1,l) = ey_work(:,0)
        alu(:,lm,l)   = ey_work(:,jm)
      enddo

      call ludecomp(alu,kp)
    endif

    et_work = et
    et_work(:,lm-1) = value1
    et_work(:,lm)   = value2
    et_LaplaInv_et = lusolve(alu,kp,et_work)

  end function et_LaplaInv_et

  !----------------------------------------------------------
  !> @brief
  !> Y 方向格子点空間での Chebyshev-Collocation 法により，
  !> 渦度から流線を求める.
  !>
  !> @details
  !> 渦度 \f$\zeta\f$ を与えて流線 \f$\psi\f$ を求める.
  !> \f{align*}{
  !>    \nabla^2 \psi & = \zeta, \\
  !>    \psi & = \mbox{const. at boundaries.}
  !> \f}
  !> 粘着条件
  !> \f[ \partial_{y} \psi  = 0 \, \mbox{at boundaries} \f]
  !> 応力なし条件
  !> \f[ (\partial_{y})^{2} \psi = 0\, \mbox{at boundaries} \f]
  !----------------------------------------------------------
  function ey_Vor2Strm_ey(ey,values,cond,new)
    !> 入力渦度分布
    real(DP), dimension(-km:km,0:jm),intent(in)  :: ey
    !> 流線境界値. 境界で一定なので波数 0 成分のみ. 省略時は 0.
    real(DP), dimension(2), intent(in), optional :: values
    !> 境界条件スイッチ. 省略時は 'RR'
    !> * RR : 両端粘着条件
    !> * RF : 上端粘着下端応力なし条件
    !> * FR : 上端応力なし下端粘着条件
    !> * FF : 両端応力なし条件
    character(len=2), intent(in), optional  :: cond
    !> true だと境界条件計算用行列を強制的に新たに作る. default は false.
    logical, intent(IN), optional :: new
    !> 出力流線分布
    real(DP), dimension(-km:km,0:jm)             :: ey_Vor2Strm_ey

    real(DP), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable     :: kp

    real(DP), dimension(-km:km,0:jm)         :: ey_work
    real(DP), dimension(-km:km,0:jm)         :: ey_I
    real(DP)                                 :: value1, value2   ! 境界値
    logical                                  :: rigid1 = .true.
    logical                                  :: rigid2 = .true.
    logical :: first = .true.
    logical :: new_matrix = .false.
    integer :: j
    save    :: alu, kp, first

    if (.not. present(values)) then
      value1=0.0D0
      value2=0.0D0
    else
      value1 = values(1)
      value2 = values(2)
    endif

    if ( present(cond) ) then
      select case (cond)
      case ('RR')
        rigid1 = .TRUE.
        rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.
        rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE.
        rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE.
        rigid2 = .FALSE.
      case default
        call MessageNotify('E','ey_Vor2Strm_ey','B.C. not supported')
      end select
    else
      rigid1 = .TRUE.
      rigid2 = .TRUE.
    endif

    if (.not. present(new)) then
      new_matrix=.false.
    else
      new_matrix=new
    endif

    if ( first .OR. new_matrix ) then
      first = .false.

      if ( allocated(alu) ) deallocate(alu)
      if ( allocated(kp) ) deallocate(kp)
      allocate(alu(-km:km,0:jm,0:jm),kp(-km:km,0:jm))

      do j=0,jm
        ey_I = 0.0D0
        ey_I(:,j) = 1.0D0
        alu(:,:,j) = ey_et(et_Lapla_et(et_ey(ey_I)))
      enddo

      do j=0,jm
        ey_I = 0.0D0
        ey_I(:,j) = 1.0D0

        ! 運動学的条件. 流線は境界で一定
        alu(:,0,j)   = ey_I(:,0)
        alu(:,jm,j)  = ey_I(:,jm)

        if ( rigid1 ) then                               ! 粘着条件(top)
          ey_work=ey_et(et_Dy_et(et_ey(ey_I)))
        else
          ey_work=ey_et(et_Dy_et(et_Dy_et(et_ey(ey_I)))) ! すべり条件(top)
        endif

        alu(:,1,j) = ey_work(:,0)

        if ( rigid2 ) then                               ! 粘着条件(bottom)
          ey_work=ey_et(et_Dy_et(et_ey(ey_I)))
        else
          ey_work=ey_et(et_Dy_et(et_Dy_et(et_ey(ey_I)))) ! すべり条件(bottom)
        endif
        alu(:,jm-1,j) = ey_work(:,jm)
      enddo

      call ludecomp(alu,kp)

      call MessageNotify('M','ey_Vor2Strm_ey',&
        'Matrix for stream func. calc. produced')
    endif

    ey_work = ey
    ey_work(:,1)    = 0.0D0               ! 力学的条件
    ey_work(:,jm-1) = 0.0D0               ! 力学的条件

    ey_work(:,0) = 0.0D0                  ! 運動学的条件. 波数 0 以外は 0
    ey_work(0,0) = value1*2.0D0           ! 運動学的条件. 波数 0 は重み 1/2

    ey_work(:,jm)   = 0.0D0               ! 運動学的条件. 波数 0 以外は 0
    ey_work(0,jm)   = value2*2.0D0        ! 運動学的条件. 波数 0 は重み 1/2

    ey_Vor2Strm_ey = lusolve(alu,kp,ey_work)

  end function ey_Vor2Strm_ey

  !----------------------------------------------------------
  !> @brief Chebyshev-tau 法により，渦度から流線を求める(境界値は定数)
  !> @details
  !> 渦度 \f$\zeta\f$ を与えて流線 \f$\psi\f$ を求める.
  !> \f{align*}{
  !>    \nabla^2\psi & = \zeta, \\
  !>    \psi & = \mbox{const. at boundaries.}
  !> \f}
  !> 粘着条件
  !> \f[   \partial_{y} \psi = 0 \, \mbox{at boundaries} \f]
  !> 応力なし条件
  !> \f[  (\partial_{y})^{2} \psi = 0 \, \mbox{at boundaries} \f]
  !----------------------------------------------------------
  function et_Vor2Strm_et(et,values,cond,new)
    !> 入力渦度分布
    real(DP), dimension(-km:km,0:lm),intent(in)  :: et
    !> 流線境界値. 境界で一定なので波数 0 成分のみ. 省略時は 0.
    real(DP), dimension(2), intent(in), optional :: values
    !> 境界条件スイッチ. 省略時は 'RR'
    !> * RR : 両端粘着条件
    !> * RF : 上端粘着下端応力なし条件
    !> * FR : 上端応力なし下端粘着条件
    !> * FF : 両端応力なし条件
    character(len=2), intent(in), optional  :: cond
    !> true だと境界条件計算用行列を強制的に新たに作る.
    !> default は false.
    logical, intent(IN), optional :: new
    !> 出力流線分布
    real(DP), dimension(-km:km,0:lm)             :: et_Vor2Strm_et

    real(DP), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable     :: kp

    real(DP), dimension(-km:km,0:lm)         :: et_work
    real(DP), dimension(-km:km,0:jm)         :: ey_work
    real(DP)                                 :: value1
    real(DP)                                 :: value2
    logical                                  :: rigid1 = .true.
    logical                                  :: rigid2 = .true.


    logical :: first = .true.
    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp, first

    if (.not. present(values)) then
      value1=0.0D0
      value2=0.0D0
    else
      value1 = values(1)
      value2 = values(2)
    endif

    if ( present(cond) ) then
      select case (cond)
      case ('RR')
        rigid1 = .TRUE.
        rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.
        rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE.
        rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE.
        rigid2 = .FALSE.
      case default
        call MessageNotify('E','et_Vor2Strm_et','B.C. not supported')
      end select
    endif

    if (.not. present(new)) then
      new_matrix=.false.
    else
      new_matrix=new
    endif

    if ( first .OR. new_matrix ) then
      first = .false.

      if ( allocated(alu) ) deallocate(alu)
      if ( allocated(kp) ) deallocate(kp)
      allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

      alu = 0.0D0
      do l=0,lm-2
        et_work(:,:)= 0.0D0
        et_work(:,l)= 1.0D0

        alu(:,:,l) = et_Lapla_et(et_work)
      enddo

      do l=0,lm
        et_work(:,:)= 0.0D0
        et_work(:,l)= 1.0D0

        ! 運動学的条件. 流線は境界で一定
        ey_work = ay_at(et_work)
        alu(:,lm,l) = ey_work(:,0)
        alu(:,lm-1,l) = ey_work(:,jm)

        if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
          ey_work=ay_at(et_Dy_et(et_work))
          alu(:,lm-2,l) = ey_work(:,0)
        else                                 ! 力学的条件すべり条件(Top)
          ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
          alu(:,lm-2,l) = ey_work(:,0)
        endif
        if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
          ey_work=ay_at(et_Dy_et(et_work))
          alu(:,lm-3,l) = ey_work(:,jm)
        else                                 ! 力学的条件すべり条件(bottom)
          ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
          alu(:,lm-3,l) = ey_work(:,jm)
        endif
      enddo

      call ludecomp(alu,kp)

      call MessageNotify('M','et_Vor2Strm_et',&
        'Matrix for stream func. calc. produced')
    endif

    ! 内部領域計算
    et_work = et

    et_work(:,lm-2) = 0.0D0           ! 力学的条件
    et_work(:,lm-3) = 0.0D0           ! 力学的条件

    et_work(:,lm-1) = 0.0D0        ! 運動学的条件. 波数 0 以外は 0
    !!$      et_work(0,lm-1) = value2*2     ! 運動学的条件. 波数 0 は重み 1/2
    et_work(0,lm-1) = value2       ! 運動学的条件. 波数 0 は重み 1/2

    et_work(:,lm)   = 0.0D0        ! 運動学的条件. 波数 0 以外は 0
    !!$      et_work(0,lm)   = value1*2     ! 運動学的条件. 波数 0 は重み 1/2
    et_work(0,lm)   = value1     ! 運動学的条件. 波数 0 は重み 1/2

    et_Vor2Strm_et = lusolve(alu,kp,et_work)

  end function et_Vor2Strm_et

  !----------------------------------------------------------
  !> @brief Chebyshev-tau 法により，渦度から流線を求める．
  !>        境界値として X方向の スペクトルを与えることが可能
  !> @details
  !> 渦度 \f$\zeta\f$ を与えて流線 \f$\psi\f$ を求める.
  !> \f{align*}{
  !>    \nabla^2\psi & = \zeta, \\
  !>    \psi & = \mbox{const. at boundaries.}
  !> \f}
  !> 粘着条件
  !> \f[   \partial_{y} \psi = 0 \, \mbox{at boundaries} \f]
  !> 応力なし条件
  !> \f[  (\partial_{y})^{2} \psi = 0 \, \mbox{at boundaries} \f]
  !----------------------------------------------------------
  function et_Vor2Strm2_et(et,ea,cond,new)
    !> 入力渦度分布
    real(DP), dimension(-km:km,0:lm),intent(in)  :: et
    !> 流線境界値. 省略時は 0. 1:Top,2:Btm
    real(DP), dimension(-km:km,2), intent(in), optional :: ea
    !> 境界条件スイッチ. 省略時は 'RR'
    !> * RR : 両端粘着条件
    !> * RF : 上端粘着下端応力なし条件
    !> * FR : 上端応力なし下端粘着条件
    !> * FF : 両端応力なし条件
    character(len=2), intent(in), optional  :: cond
    !> true だと境界条件計算用行列を強制的に新たに作る.
    !> default は false.
    logical, intent(IN), optional :: new
    !> 出力流線分布
    real(DP), dimension(-km:km,0:lm)         :: et_Vor2Strm2_et

    real(DP), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable     :: kp

    real(DP), dimension(-km:km,0:lm)         :: et_work
    real(DP), dimension(-km:km,0:jm)         :: ey_work
    real(DP), dimension(-km:km)              :: e_Top
    real(DP), dimension(-km:km)              :: e_Btm
    logical                                  :: rigid1 = .true.
    logical                                  :: rigid2 = .true.

    logical :: first = .true.
    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp, first

    if (.not. present(ea)) then
      e_Top = 0.0D0
      e_Btm = 0.0D0
    else
      e_Top = ea(:,1)
      e_Btm = ea(:,2)
    endif

    if ( present(cond) ) then
      select case (cond)
      case ('RR')
        rigid1 = .TRUE.
        rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.
        rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE.
        rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE.
        rigid2 = .FALSE.
      case default
        call MessageNotify('E','et_Vor2Strm_et','B.C. not supported')
      end select
    endif

    if (.not. present(new)) then
      new_matrix=.false.
    else
      new_matrix=new
    endif

    if ( first .OR. new_matrix ) then
      first = .false.

      if ( allocated(alu) ) deallocate(alu)
      if ( allocated(kp) ) deallocate(kp)
      allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

      alu = 0.0D0
      do l=0,lm-2
        et_work(:,:)= 0.0D0
        et_work(:,l)= 1.0D0

        alu(:,:,l) = et_Lapla_et(et_work)
      enddo

      do l=0,lm
        et_work(:,:)= 0.0D0
        et_work(:,l)= 1.0D0

        ! 運動学的条件. 流線は境界で一定
        ey_work = ay_at(et_work)
        alu(:,lm,l) = ey_work(:,0)
        alu(:,lm-1,l) = ey_work(:,jm)

        if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
          ey_work=ay_at(et_Dy_et(et_work))
          alu(:,lm-2,l) = ey_work(:,0)
        else                                 ! 力学的条件すべり条件(Top)
          ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
          alu(:,lm-2,l) = ey_work(:,0)
        endif
        if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
          ey_work=ay_at(et_Dy_et(et_work))
          alu(:,lm-3,l) = ey_work(:,jm)
        else                                 ! 力学的条件すべり条件(bottom)
          ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
          alu(:,lm-3,l) = ey_work(:,jm)
        endif
      enddo

      call ludecomp(alu,kp)

      call MessageNotify('M','et_Vor2Strm_et',&
        'Matrix for stream func. calc. produced')
    endif

    ! 内部領域計算
    et_work = et

    et_work(:,lm-2) = 0.0D0           ! 力学的条件
    et_work(:,lm-3) = 0.0D0           ! 力学的条件

    et_work(:,lm-1) = e_Btm           ! 運動学的条件. 波数 0 以外は 0
    et_work(:,lm)   = e_Top           ! 運動学的条件. 波数 0 以外は 0

    et_Vor2Strm2_et = lusolve(alu,kp,et_work)

  end function et_Vor2Strm2_et

  !----------------------------------------------------------
  !> @brief Chebyshev-tau 法により，渦度から流線を求める．
  !>        境界での値と勾配のスペクトルを与えることが可能.
  !> @details
  !> 渦度 \f$\zeta\f$ を与えて流線 \f$\psi\f$ を求める.
  !> \f{align*}{
  !>    \nabla^2\psi & = \zeta, \\
  !>    \psi & = \mbox{const. at boundaries.}
  !> \f}
  !> 粘着条件
  !> \f[   \partial_{y} \psi = 0 \, \mbox{at boundaries} \f]
  !> 応力なし条件
  !> \f[  (\partial_{y})^{2} \psi = 0 \, \mbox{at boundaries} \f]
  !----------------------------------------------------------
  function et_Vor2Strm3_et(et,ea,cond,new)
    !> 入力渦度分布
    real(DP), dimension(-km:km,0:lm),intent(in)  :: et
    !> 流線/微分境界値. 省略時は 0.
    !> 1. Top 値,
    !> 2. Bottom 値
    !> 3. Top 微分(勾配)
    !> 4. Bottom 微分(勾配)
    real(DP), dimension(-km:km,4), intent(in), optional :: ea
    !> 境界条件スイッチ. 省略時は 'RR'
    !> * RR : 両端粘着条件
    !> * RF : 上端粘着下端応力なし条件
    !> * FR : 上端応力なし下端粘着条件
    !> * FF : 両端応力なし条件
    character(len=2), intent(in), optional  :: cond
    !> true だと境界条件計算用行列を強制的に新たに作る.
    !> default は false.
    logical, intent(IN), optional :: new
    !> 出力流線分布
    real(DP), dimension(-km:km,0:lm)             :: et_Vor2Strm3_et

    real(DP), dimension(:,:,:), allocatable :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(DP), dimension(-km:km,0:lm)        :: et_work
    real(DP), dimension(-km:km,0:jm)        :: ey_work
    real(DP), dimension(-km:km)             :: e_TopValue
    real(DP), dimension(-km:km)             :: e_BtmValue
    real(DP), dimension(-km:km)             :: e_TopDiff
    real(DP), dimension(-km:km)             :: e_BtmDiff
    logical                                 :: rigid1 = .true.
    logical                                 :: rigid2 = .true.
    logical :: first = .true.
    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp, first

    if (.not. present(ea)) then
      e_TopValue = 0.0D0
      e_BtmValue = 0.0D0
      e_TopDiff  = 0.0D0
      e_BtmDiff  = 0.0D0
    else
      e_TopValue = ea(:,1)
      e_BtmValue = ea(:,2)
      e_TopDiff  = ea(:,3)
      e_BtmDiff  = ea(:,4)
    endif

    if ( present(cond) ) then
      select case (cond)
      case ('RR')
        rigid1 = .TRUE.
        rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.
        rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE.
        rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE.
        rigid2 = .FALSE.
      case default
        call MessageNotify('E','et_Vor2Strm_et','B.C. not supported')
      end select
    endif

    if (.not. present(new)) then
      new_matrix=.false.
    else
      new_matrix=new
    endif

    if ( first .OR. new_matrix ) then
      first = .false.

      if ( allocated(alu) ) deallocate(alu)
      if ( allocated(kp) ) deallocate(kp)
      allocate(alu(-km:km,0:lm,0:lm),kp(-km:km,0:lm))

      alu = 0.0D0
      do l=0,lm-2
        et_work(:,:)= 0.0D0
        et_work(:,l)= 1.0D0

        alu(:,:,l) = et_Lapla_et(et_work)
      enddo

      do l=0,lm
        et_work(:,:)= 0.0D0
        et_work(:,l)= 1.0D0

        ! 運動学的条件. 流線は境界で一定
        ey_work = ay_at(et_work)
        alu(:,lm,l) = ey_work(:,0)
        alu(:,lm-1,l) = ey_work(:,jm)

        if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
          ey_work=ay_at(et_Dy_et(et_work))
          alu(:,lm-2,l) = ey_work(:,0)
        else                                 ! 力学的条件すべり条件(Top)
          ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
          alu(:,lm-2,l) = ey_work(:,0)
        endif
        if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
          ey_work=ay_at(et_Dy_et(et_work))
          alu(:,lm-3,l) = ey_work(:,jm)
        else                                 ! 力学的条件すべり条件(bottom)
          ey_work=ay_at(et_Dy_et(et_Dy_et(et_work)))
          alu(:,lm-3,l) = ey_work(:,jm)
        endif
      enddo

      call ludecomp(alu,kp)

      call MessageNotify('M','et_Vor2Strm_et',&
        'Matrix for stream func. calc. produced')
    endif

    ! 内部領域計算
    et_work = et

    et_work(:,lm-2) = e_TopDIff         ! 力学的条件
    et_work(:,lm-3) = e_BtmDiff         ! 力学的条件

    et_work(:,lm-1) = e_BtmValue        ! 運動学的条件. 波数 0 以外は 0
    et_work(:,lm)   = e_TopValue        ! 運動学的条件. 波数 0 以外は 0

    et_Vor2Strm3_et = lusolve(alu,kp,et_work)

  end function et_Vor2Strm3_et

  !----------------------------------------------------------
  !> 2 次元格子点データの全領域積分および平均.
  !----------------------------------------------------------
  function IntYX_yx(yx)
    !> 2 次元格子点データ
    real(DP), dimension(0:jm,0:im-1)   :: yx
    !> 積分値
    real(DP)                           :: IntYX_yx

    integer :: i, j

    IntYX_yx = 0.0d0
    do i=0,im-1
      do j=0,jm
        IntYX_yx = IntYX_yx + yx(j,i) * y_Y_Weight(j) * x_X_Weight(i)
      enddo
    enddo
  end function IntYX_yx

  !----------------------------------------------------------
  !> 2 次元格子点データの X 方向積分
  !----------------------------------------------------------
  function y_IntX_yx(yx)  ! X 方向積分
    !> 2 次元格子点データ
    real(DP), dimension(0:jm,0:im-1)   :: yx
    !> 積分された 1 次元(Y)格子点データ
    real(DP), dimension(0:jm)          :: y_IntX_yx

    integer :: i

    y_IntX_yx = 0.0d0
    do i=0,im-1
      y_IntX_yx(:) = y_IntX_yx(:) + yx(:,i) * x_X_Weight(i)
    enddo
  end function y_IntX_yx

  !----------------------------------------------------------
  !> 2 次元格子点データの Y 方向積分
  !----------------------------------------------------------
  function x_IntY_yx(yx)  ! Y 方向積分
    !> 2 次元格子点データ
    real(DP), dimension(0:jm,0:im-1)   :: yx
    !> 積分された 1 次元(X)格子点データ
    real(DP), dimension(0:im-1)        :: x_IntY_yx

    integer :: j
    ! 作業変数

    x_IntY_yx = 0.0d0
    do j=0,jm
      x_IntY_yx(:) = x_IntY_yx(:) + yx(j,:) * y_Y_Weight(j)
    enddo
  end function x_IntY_yx

  !----------------------------------------------------------
  !> 1 次元(X)格子点データの X 方向積分
  !----------------------------------------------------------
  function IntX_x(x)      ! X 方向積分
    !> 1 次元格子点データ
    real(DP), dimension(0:im-1)   :: x
    !> 積分値
    real(DP)                      :: IntX_x

    IntX_x = sum(x*x_X_Weight)
  end function IntX_x

  !----------------------------------------------------------
  !> 1 次元(Y)格子点データの Y 方向積分
  !----------------------------------------------------------
  function IntY_y(y)      ! Y 方向積分
    !> 1 次元格子点データ
    real(DP), dimension(0:jm)   :: y
    !> 積分値
    real(DP)                    :: IntY_y

    IntY_y = sum(y*y_Y_Weight)
  end function IntY_y

  !----------------------------------------------------------
  !> 2 次元格子点データの全領域平均
  !----------------------------------------------------------
  function AvrYX_yx(yx)
    !> 2 次元格子点データ
    real(DP), dimension(0:jm,0:im-1)   :: yx
    !> 平均値
    real(DP)                           :: AvrYX_yx

    AvrYX_yx = IntYX_yx(yx)/(sum(x_X_weight)*sum(y_Y_weight))
  end function AvrYX_yx

  !----------------------------------------------------------
  !>  2 次元格子点データの X 方向平均
  !----------------------------------------------------------
  function y_AvrX_yx(yx)
    !> 2 次元格子点データ
    real(DP), dimension(0:jm,0:im-1)   :: yx
    !> 平均された 1 次元(Y)格子点
    real(DP), dimension(0:jm)          :: y_AvrX_yx

    y_AvrX_yx = y_IntX_yx(yx)/sum(x_X_weight)
  end function y_AvrX_yx

  !----------------------------------------------------------
  ! 2 次元格子点データの Y 方向平均
  !----------------------------------------------------------
  function x_AvrY_yx(yx)
    !> 2 次元格子点データ
    real(DP), dimension(0:jm,0:im-1)   :: yx
    !> 平均された 1 次元(X)格子点
    real(DP), dimension(0:im-1)        :: x_AvrY_yx

    x_AvrY_yx = x_IntY_yx(yx)/sum(y_Y_weight)
  end function x_AvrY_yx

  !----------------------------------------------------------
  !> 1 次元(X)格子点データの X 方向平均
  !----------------------------------------------------------
  function AvrX_x(x)
    !> 1 次元格子点データ
    real(DP), dimension(0:im-1)   :: x
    !> 平均値
    real(DP)                      :: AvrX_x

    AvrX_x = IntX_x(x)/sum(x_X_weight)
  end function AvrX_x

  !----------------------------------------------------------
  !> 1 次元(Y)格子点データの Y 方向平均
  !----------------------------------------------------------
  function AvrY_y(y)
    !> 1 次元格子点データ
    real(DP), dimension(0:jm)   :: y
    !> 平均値
    real(DP)                    :: AvrY_y

    AvrY_y = IntY_y(y)/sum(y_Y_weight)
  end function AvrY_y

  !----------------------------------------------------------
  !> 補間関数
  !----------------------------------------------------------
  function Interpolate_et(et_data,xval,yval)
    !> 入力スペクトルデータ
    real(DP), dimension(-km:km,0:lm), intent(IN) :: et_data
    !> 補間する点の X 座標
    real(DP), intent(in)                         :: xval
    !> 補間する点の Y 座標
    real(DP), intent(in)                         :: yval
    !> 補間結果
    real(DP)                                     :: Interpolate_et

    Interpolate_et = Interpolate_e(a_Interpolate_at(et_data,yval),xval)
  end function Interpolate_et

end module et_module

!--
!----------------------------------------------------------------------
! Copyright (c) 2024-2025 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  w_zonal_module
!
!   spml/w_zonal_module モジュールは球面上での 2 次元流体運動を
!   球面調和函数を用いたスペクトル法によって 1 東西波数数値計算するための
!   Fortran90 関数を提供する. 
!
!   w_zonal_module は実際には基本変換, 微分計算をそれぞれ担っている
!   下部モジュール w_zonal_module_base, w_zonal_module_deriv, 
!   w_zonal_module_interpolate からなっている.
!
!   内部で ISPACK3 の LXPACK(SXPACK) の Fortran サブルーチンを呼んでいる.
!   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!   ついては ISPACK3/LXPACK のマニュアルを参照されたい.
!
!   w_zonal_modulde で提供される関数・サブルーチンは 2 次元的
!   流体運動を扱う w_module モジュールで用いられているものと
!   名前およびインターフェースが共通になるように設計してある. 
!   したがって, w_module を用いて構成された 2 次元モデルを
!   経度方向に 1 波数成分のモデルへと改造するには次の手順が必要となる.
!
!      * use 文での w_module の引用を w_zonal_module に変更する.
!      * 配列の大きさを経度方向格子点数 im -> 1 に,
!        水平波数を (nm+1)**2 -> nm-m+1 に変更する.
!      * DO 文で水平波数に関してループを回しているところを
!        (nm+1)**2 -> nm-m+1 に変更する.
!      * gtool 出力の次元変数を変更する.
!
!履歴  2024/02/15  竹広真一  w_wave_module より改造
!      2025/11/27  竹広真一  w_initial interface を変更
!      2025/12/10  竹広真一  経度座標変数を追加
!      2025/12/15  竹広真一  領域積分・平均関数を追加
!
!++
module w_zonal_module
  !
  != w_zonal_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: w_zonal_module.f90 586 2013-05-23 17:42:12Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !   spml/w_zonal_module モジュールは球面上での帯状的な 2 次元流体運動を
  !   球面調和函数を用いたスペクトル法によって数数値計算するための
  !   Fortran90 関数を提供する. 
  !
  !   w_zonal_module は実際には基本変換, 微分計算をそれぞれ担っている
  !   下部モジュール w_zonal_module_base, w_zonal_module_deriv, 
  !   w_zonal_module_interpolate からなっている.
  !
  !   内部で ISPACK3 の LXPACK(SXPACK) の Fortran サブルーチンを呼んでいる.
  !   スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !   ついては ISPACK3/LXPACK のマニュアルを参照されたい.
  !
  !   w_zonal_modulde で提供される関数・サブルーチンは 2 次元的
  !   流体運動を扱う w_module モジュールで用いられているものと
  !   名前およびインターフェースが共通になるように設計してある. 
  !   したがって, w_module を用いて構成された 2 次元モデルを
  !   経度方向に 1 波数成分のモデルへと改造するには次の手順が必要となる.
  !
  !      * use 文での w_module の引用を w_zonal_module に変更する.
  !      * 配列の大きさを経度方向格子点数 im -> 1 に,
  !        水平波数を nc -> nm+1 に変更する.
  !      * DO 文で水平波数に関してループを回しているところを
  !        nc -> nm+1 に変更する.
  !      * gtool 出力の次元変数を変更する.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (w_, nm_, n_, xy_, x_, y_) は, 返す値の形を示している.
  !   w_  :: スペクトルデータ
  !   xy_ :: 2 次元格子点データ(y 方向緯度座標, x 方向スペクトルデータ実数虚数)
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla, 
  !   LaplaInv, Jacobian)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_w_w, _w, _xy, _x, _y) は, 入力変数の形スペクトルデータ
  !   および格子点データであることを示している.
  !   _w   :: スペクトルデータ
  !   _w_w :: 2 つのスペクトルデータ
  !   _xy  :: 2 次元格子点データ(y 方向緯度座標, x 方向スペクトルデータ実数虚数)
  !
  !=== 各データの種類の説明
  !
  ! * xy : 2 次元格子点データ(y 方向緯度座標, x 方向スペクトルデータ実数虚数).
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm). 
  !   * im(=2), jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
  !     w_Initial にてあらかじめ設定しておく.
  !
  ! * w : スペクトルデータ.
  !   * 変数の種類と次元は real(8), dimension(nm+1)
  !   * nm は球面調和函数の最大全波数. 
  !     サブルーチン w_Initial にてあらかじめ設定しておく. 
  !   * スペクトルデータの格納のされ方は関数 l_nm, nm_l によって
  !     調べることができる.
  !
  ! * y : 緯度方向 1 次元格子点データ.
  !   * 変数の種類と次元は real(8), dimension(1:jm).
  !
  ! * w_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xy_ で始まる関数が返す値は 2 次元格子点データに同じ.
  !
  ! * y_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! w_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 終了処理 
  !
  ! w_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう. 
  !
  !==== 座標変数
  !
  ! y_Lat        :: 格子点座標(経度座標)を格納した 1 次元配列
  ! y_Lat_Weight :: 重み座標を格納した 1 次元配列
  ! xy_Lat       :: 格子点データの緯度座標(格子点データ型 2 次元配列)
  !
  !==== 基本変換
  !
  ! xy_w :: スペクトルデータから格子データへの変換
  ! w_xy :: 格子データからスペクトルデータへの変換
  ! l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! w_Lapla_w       :: スペクトルデータにラプラシアンを作用させる
  ! rn              :: スペクトルデータのラプラシアンを計算するための係数. 
  ! irm             :: 経度微分演算用配列(未定義)
  ! w_LaplaInv_w    :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! w_DLon_w        :: スペクトルデータに経度微分∂/∂λを作用させる
  ! xy_GradLon_w    :: スペクトルデータに
  !                    勾配型経度微分 1/cosφ・∂/∂λを作用させる
  ! xy_GradLat_w    :: スペクトルデータに勾配型緯度微分∂/∂φを作用させる
  ! w_DivLon_xy     :: 格子データに発散型経度微分 1/cosφ・∂/∂λを作用させる
  ! w_DivLat_xy     :: 格子データに
  !                    発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを作用させる
  ! w_Div_xy_xy     :: ベクトル成分である 2 つの格子データに発散を作用させる
  !
  !
  !==== 微分(λ,μ=sinφ 座標)
  !
  ! xy_GradLambda_w :: スペクトルデータに勾配型経度微分∂/∂λを作用させる
  ! xy_GradMu_w     :: スペクトルデータに
  !                    勾配型緯度微分 (1-μ^2)∂/∂μを作用させる
  ! w_DivLambda_xy  :: 格子データに
  !                    発散型経度微分 1/(1-μ^2)・∂/∂λを作用させる
  ! w_DivMu_xy      :: 格子データに発散型緯度微分∂/∂μを作用させる
  !
  !
  !==== 補間
  !
  ! Interpolate_w :: スペクトルデータから任意の点での値を求める.
  !
  use dc_message, only : MessageNotify
  use w_zonal_module_base
  use w_zonal_module_deriv
  use w_zonal_module_integral
  use w_zonal_module_interpolate

  private

  public w_Initial                            ! 初期化
  public w_Finalize                           ! 終了処理

  public x_Lon, y_Lat                         ! 格子座標
  public x_Lon_weight, y_Lat_Weight           ! 格子座標重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public xy_w, w_xy, l_nm, nm_l               ! 変換関数

  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public rn                                   ! ラプラシアン演算用配列
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public IntLonLat_xy                         ! 緯度経度積分
  public y_IntLon_xy, IntLon_x                ! 経度積分
  public x_IntLat_xy, IntLat_y                ! 緯度積分
  public AvrLonLat_xy                         ! 緯度経度積分
  public y_AvrLon_xy, AvrLon_x                ! 経度積分
  public x_AvrLat_xy, AvrLat_y                ! 緯度積分

  public Interpolate_w                        ! 補間関数
 
contains

  !--------------- 初期化 -----------------
  subroutine w_initial(n_in,i_in,j_in)
    !
    ! スペクトル変換の格子点数, 波数を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない. 
    !
    integer,intent(in) :: i_in              !(in) 格子点数(東西)
    integer,intent(in) :: j_in              !(in) 格子点数(南北)
    integer,intent(in) :: n_in              !(in) 切断波数の設定

    call w_base_initial(n_in,i_in,j_in)

    call w_deriv_initial

    call MessageNotify('M','w_initial',&
         'w_zonal_module (2025/12/15) is initialized')

  end subroutine w_initial


  !--------------- 終了処理 -----------------
  subroutine w_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
    !
    ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
    ! おこなったのちに再度 w_Initial で初期設定しなければ
    ! ならない. 
    !
    call w_base_Finalize
    call w_deriv_Finalize

    call MessageNotify('M','w_Finalize',&
         'w_zonal_module (2025/12/15) is finalized')

  end subroutine w_Finalize

end module w_zonal_module

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_interpolate_module テストプログラム :: 補間関数のテスト
!
!履歴  2019/03/19  竹広真一
!
program w_interpolate_mpi_module_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_mpi_module
  use mpi
  implicit none

  integer, parameter :: im=32, jm=16, nm=10

  real(8), allocatable     ::  w_data(:)
  real(8), allocatable     ::  xv_data(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: data_sol
  real(8) :: Alon_array(2)
  real(8) :: data_sol_array(2)
  real(8) :: pi

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3
  Alon_array =(/pi/4,-pi/6/)

  call w_mpi_Initial( nm, im, jm )
  allocate(w_data(nc))
  allocate(xv_data(0:im-1,jc))


  call MessageNotify('M','w_Interpolate00_mpi_module_test', &
       'w_interpolate_module interpolate(00) tests')

  !---- Y_1^0 のテスト ----
  xv_data = sqrt(3.0D0)*sin(xv_Lat)                      ! Y_1^0
  data_sol = sqrt(3.0D0)*sin(ALat)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^0',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^1 のテスト ----
  xv_data = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)          ! Y_1^1
  data_sol = sqrt(3.0D0/2)*cos(ALat)*cos(ALon)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^1',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^-1 のテスト ----
  xv_data = -sqrt(3.0D0)*cos(xv_Lat)*sin(xv_Lon)         ! Y_1^{-1}
  data_sol = -sqrt(3.0D0)*cos(ALat)*sin(ALon)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^-1',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^0 のテスト ----
  xv_data = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)                 ! Y_2^0
  data_sol = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^0',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^1 のテスト ----
  xv_data = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)! Y_2^1
  data_sol = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * cos(ALon)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^1',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-1 のテスト ----
  xv_data = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * sin(xv_Lon)! Y_2^{-1}
  data_sol = -sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * sin(ALon)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-1',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^2 のテスト ----
  xv_data = sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*cos(2*xv_Lon)             ! Y_2^2
  data_sol = sqrt(5.0D0/24)*3.0*cos(ALat)**2*cos(2*ALon)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^2',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-2 のテスト ----
  xv_data = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)          ! Y_2^-2
  data_sol = -sqrt(5.0D0/24)*3.0*cos(ALat)**2*sin(2*ALon)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-2',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的な関数のテスト ----
  xv_data = cos(2*xv_Lon-pi/3) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)-0.5)*(sin(xv_Lat)+1)
  data_sol = cos(2*ALon-pi/3) &
       *(sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with generaul function',               &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_interpolate00_mpi_module_test', &
       'w_interpolate_module interpolate(00) tests succeeded')


  !---- Y_1^0 のテスト ----
  xv_data = sqrt(3.0D0)*sin(xv_Lat)                      ! Y_1^0
  data_sol_array = sqrt(3.0D0)*sin(ALat)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^0',                           &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^1 のテスト ----
  xv_data = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)          ! Y_1^1
  data_sol_array = sqrt(3.0D0/2)*cos(ALat)*cos(Alon_Array)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^1',                           &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^-1 のテスト ----
  xv_data = -sqrt(3.0D0)*cos(xv_Lat)*sin(xv_Lon)         ! Y_1^{-1}
  data_sol_array = -sqrt(3.0D0)*cos(ALat)*sin(Alon_Array)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^-1',                          &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^0 のテスト ----
  xv_data = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)                 ! Y_2^0
  data_sol_array = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^0',                           &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^1 のテスト ----
  xv_data = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)! Y_2^1
  data_sol_array = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * cos(Alon_Array)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^1',                           &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-1 のテスト ----
  xv_data = -sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat) * sin(xv_Lon)! Y_2^{-1}
  data_sol_array = -sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * sin(Alon_Array)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-1',                          &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^2 のテスト ----
  xv_data = sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*cos(2*xv_Lon)             ! Y_2^2
  data_sol_array = sqrt(5.0D0/24)*3.0*cos(ALat)**2*cos(2*Alon_Array)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^2',                           &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-2 のテスト ----
  xv_data = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)          ! Y_2^-2
  data_sol_array = -sqrt(5.0D0/24)*3.0*cos(ALat)**2*sin(2*Alon_Array)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-2',                          &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的な関数のテスト ----
  xv_data = cos(2*xv_Lon-pi/3) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)-0.5)*(sin(xv_Lat)+1)
  data_sol_array = cos(2*Alon_Array-pi/3) &
       *(sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  w_data = w_xv(xv_data)
  call AssertEqual(&
    message='Interpolate_w with generaul function',               &
    answer = data_sol_array,                                      &
    check = Interpolate_w(w_data,alon_array,alat),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_interpolate10_mpi_module_test', &
       'w_interpolate_module interpolate(10) tests succeeded')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program w_interpolate_mpi_module_test

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SYNMML(NN,N,M,IP,L,ICOM,MI)

  IMPLICIT NONE    
  INCLUDE 'mpif.h'
  INTEGER(8) :: NN,N,M,L,K,MA,IP,ICOM,MI
  INTEGER :: NP,IERR,ICOM4

  ICOM4=ICOM
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)

  MA=ABS(M)
  K=MA/NP/MI
  IF(MOD(K,2).EQ.0) THEN
     IP=MA/MI-K*NP
  ELSE
!!$     IP=(K+1)*NP*MA-MA/MI-1
     IP=(K+1)*NP-MA/MI-1
  END IF

  IF(M.EQ.0) THEN
     L=N+1
  ELSE IF(M.GT.0) THEN
     L=K*(2*(NN+1)-(K-1)*NP*MI)+1+2*(N-M)
  ELSE
     L=K*(2*(NN+1)-(K-1)*NP*MI)+1+2*(N+M)+1
  END IF

END SUBROUTINE SYNMML

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_base_mpi_module_sypack テストプログラム :: ベクトル用サブルーチンのテスト
!
!履歴  2019/04/30  竹広真一
!
program ua_base_mpi_module_sypack_vector_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module

  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=6, npv=2

  real(8), allocatable ::  xvb_U(:,:,:)              ! 速度経度成分
  real(8), allocatable ::  xvb_V(:,:,:)              ! 速度緯度成分

  real(8), allocatable ::  xvb_UCosLat(:,:,:)        ! 速度経度成分
  real(8), allocatable ::  xvb_VCosLat(:,:,:)        ! 速度緯度成分

  real(8), allocatable ::  xvb_Uans(:,:,:)           ! 速度経度成分
  real(8), allocatable ::  xvb_Vans(:,:,:)           ! 速度緯度成分

  real(8), allocatable ::  xvb_Psi(:,:,:)            ! 流線関数
  real(8), allocatable ::  xvb_Chi(:,:,:)            ! 速度ポテンシャル

  real(8), allocatable ::  ua_Vor(:,:)               ! 渦度
  real(8), allocatable ::  ua_Div(:,:)               ! 発散

  real(8), allocatable ::  xvb_Vorans(:,:,:)         ! 渦度
  real(8), allocatable ::  xvb_Divans(:,:,:)         ! 発散


  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  integer :: ip, np, ierr
  integer :: k

  call MessageNotify('M','ua_base_mpi_module_vector_sypack_test', &
                         'ua_base_mpi_module_sypack subroutine tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call ua_mpi_Initial( nm, im, jm, km, npv=npv )

  allocate(xvb_U(0:im-1,jc,kc))
  allocate(xvb_V(0:im-1,jc,kc))
  allocate(xvb_UCosLat(0:im-1,jc,kc))
  allocate(xvb_VCosLat(0:im-1,jc,kc))
  allocate(xvb_Uans(0:im-1,jc,kc))
  allocate(xvb_Vans(0:im-1,jc,kc))
  allocate(xvb_Psi(0:im-1,jc,kc))
  allocate(xvb_Chi(0:im-1,jc,kc))
  allocate(xvb_Vorans(0:im-1,jc,kc))
  allocate(xvb_Divans(0:im-1,jc,kc))

  allocate(ua_Vor(nmc,km))
  allocate(ua_Div(nmc,km))

  xvb_Psi    = 0.0D0
  xvb_Chi    = 0.0D0
  xvb_Uans   = 0.0D0
  xvb_Vans   = 0.0D0
  xvb_Vorans = 0.0D0
  xvb_Divans = 0.0D0

  if ( kp_kl(1) /= 0 ) then
     xvb_Psi(:,:,kp_kl(1)) = cos(xv_Lat)*sin(xv_Lon)       ! Y_1^{-1}
     xvb_Chi(:,:,kp_kl(1)) = 0.0D0

     xvb_Uans(:,:,kp_kl(1)) = sin(xv_Lat)*sin(xv_Lon)
     xvb_Vans(:,:,kp_kl(1)) = cos(xv_Lon)

     xvb_Vorans(:,:,kp_kl(1)) = -2*cos(xv_Lat)*sin(xv_Lon)
     xvb_Divans(:,:,kp_kl(1)) = 0.0D0
  endif

  if ( kp_kl(2) /= 0 ) then
     xvb_Psi(:,:,kp_kl(2)) = 0.0D0
     xvb_Chi(:,:,kp_kl(2)) = cos(xv_Lat)*sin(xv_Lon)       ! Y_1^{-1}

     xvb_Uans(:,:,kp_kl(2)) = cos(xv_Lon)
     xvb_Vans(:,:,kp_kl(2)) = - sin(xv_Lat)*sin(xv_Lon)

     xvb_Vorans(:,:,kp_kl(2)) = 0.0D0
     xvb_Divans(:,:,kp_kl(2)) = -2*cos(xv_Lat)*sin(xv_Lon)
  endif

  if ( kp_kl(3) /= 0 ) then
     xvb_Psi(:,:,kp_kl(3)) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
     xvb_Chi(:,:,kp_kl(3)) = 0.0D0

     xvb_Uans(:,:,kp_kl(3)) = - cos(2*xv_Lat)*cos(xv_Lon)
     xvb_Vans(:,:,kp_kl(3)) = - sin(xv_Lat)*sin(xv_Lon)

     xvb_Vorans(:,:,kp_kl(3)) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! Y_2^1
     xvb_Divans(:,:,kp_kl(3)) = 0.0D0
  endif

  if ( kp_kl(4) /= 0 ) then
     xvb_Psi(:,:,kp_kl(4)) = 0.0D0
     xvb_Chi(:,:,kp_kl(4)) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1

     xvb_Uans(:,:,kp_kl(4)) = - sin(xv_Lat)*sin(xv_Lon)
     xvb_Vans(:,:,kp_kl(4)) =   cos(2*xv_Lat)*cos(xv_Lon)

     xvb_Vorans(:,:,kp_kl(4)) = 0.0D0
     xvb_Divans(:,:,kp_kl(4)) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! Y_2^1
  endif

  if ( kp_kl(5) /= 0 ) then
     xvb_Psi(:,:,kp_kl(5)) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)       ! Y_2^1
     xvb_Chi(:,:,kp_kl(5)) = cos(xv_Lat)*sin(xv_Lon)                     ! Y_1^{-1}

     xvb_Uans(:,:,kp_kl(5)) = - cos(2*xv_Lat)*cos(xv_Lon) + cos(xv_Lon)
     xvb_Vans(:,:,kp_kl(5)) = - sin(xv_Lat)*sin(xv_Lon) - sin(xv_Lat)*sin(xv_Lon)

     xvb_Vorans(:,:,kp_kl(5)) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! Y_2^1
     xvb_Divans(:,:,kp_kl(5)) = -2*cos(xv_Lat)*sin(xv_Lon)            ! Y_1^{-1}
  endif

  if ( kp_kl(6) /= 0 ) then
     xvb_Psi(:,:,kp_kl(6)) = cos(xv_Lat)*sin(xv_Lon)                ! Y_1^{-1}
     xvb_Chi(:,:,kp_kl(6)) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)  ! Y_2^1

     xvb_Uans(:,:,kp_kl(6)) = 0.0D0
     xvb_Vans(:,:,kp_kl(6)) = cos(2*xv_Lat)*cos(xv_Lon) + cos(xv_Lon)

     xvb_Vorans(:,:,kp_kl(6)) = -2*cos(xv_Lat)*sin(xv_Lon)            ! Y_1^{-1}
     xvb_Divans(:,:,kp_kl(6)) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! Y_2^1
  endif

  call ua_StreamPotential2VectorMPI &
       ( ua_xvb(xvb_Psi), ua_xvb(xvb_Chi), xvb_U, xvb_V )

  call AssertEqual(&
    message='Test of ua_StreamPotential2VectorMPI(U)',            &
    answer = xvb_Uans,                                            &
    check  = xvb_U,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of ua_StreamPotential2VectorMPI(V)',            &
    answer = xvb_Vans,                                            &
    check  = xvb_V,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call ua_Vector2VorDivMPI( xvb_U, xvb_V, ua_Vor, ua_Div )

  call AssertEqual(&
    message='Test of ua_Vector2VorDivMPI(Vor)',                   &
    answer = xvb_Vorans,                                          &
    check  = xvb_ua(ua_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of ua_Vector2VorDivMPI(Div)',                   &
    answer = xvb_Divans,                                          &
    check  = xvb_ua(ua_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  do k=1,kc
     xvb_UCosLat(:,:,k) = xvb_U(:,:,k) * cos(xv_Lat)
     xvb_VCosLat(:,:,k) = xvb_V(:,:,k) * cos(xv_Lat)
  enddo

  call ua_VectorCosLat2VorDivMPI( xvb_UCosLat, xvb_VCosLat, ua_Vor, ua_Div )

  call AssertEqual(&
    message='Test of ua_VectorCosLat2VorDivMPI(Vor)',             &
    answer = xvb_Vorans,                                          &
    check  = xvb_ua(ua_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of ua_VectorCosLat2VorDivMPI(Div)',             &
    answer = xvb_Divans,                                          &
    check  = xvb_ua(ua_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ua_base_mpi_module_vector sypack_test', &
                         'ua_base_mpi_module_sypack subroutine tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_base_mpi_module_sypack_vector_test

!--
!----------------------------------------------------------------------
! Copyright(c) 2024 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wt_zonal_module
!
!    spml/wt_zonal_module モジュールは球面上および球殻内での
!    流体運動をスペクトル法によって帯状数値計算するための 
!    Fortran90 関数を提供するものである. 
!
!    水平方向に球面調和函数変換および上下の境界壁を扱うための
!    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!    関数を提供する. 
!
!    内部で wa_zonal_module, at_module を用いている. 最下部では
!    球面調和変換およびチェビシェフ変換のエンジンとして ISPACK3 の 
!    Fortran サブルーチンを用いている.
!
!   wt_zonal_modulde で提供される関数・サブルーチンは 3 次元
!   球殻内の流体運動を扱う wt_module モジュールで用いられているものと
!   名前およびインターフェースが共通になるように設計してある. 
!   したがって, wt_module を用いて構成された 2 次元モデルを
!   帯状成分のモデルへと改造するには次の手順が必要となる.
!
!      * use 文での wt_module の引用を wt_zonal_module に変更する.
!      * 配列の大きさを経度方向格子点数 im -> 1 に,
!        水平波数を (nm+1)**2 -> nm-m+1 に変更する.
!      * DO 文で水平波数に関してループを回しているところを
!        (nm+1)**2 -> nm-m+1 に変更する.
!      * gtool 出力の次元変数変更する.
!
!   ただし, 帯状成分モデルへの改変については以下の点に留意する必要がある. 
!
!      * 帯状成分ではない場をスペクトル変換しているところは
!        水平スペクトル変換してはいけない.
!      * 非線形項を実空間で計算しているところで他の波数成分が生じないよう
!        留意すること. 
!
!履歴  2024/02/19  竹広真一  wt_wave_module より改造
!
!凡例
!      データ種類と index
!        x : 経度波数(実部, 虚部)   y : 緯度        z : 動径
!        w : 球面調和関数スペクトル
!        t : チェビシェフ関数スペクトル
!        a : 任意の次元
!
!        xyz : 3 次元格子点データ
!        xy  : 水平 2 次元格子点データ
!        yz  : 子午面 2 次元格子点データ
!
!        wz  : 水平スペクトル動径格子点データ
!        wt  : スペクトルデータ
!
!++
module wt_zonal_module
  !
  != wt_zonal_module
  !
  !== 概要
  !
  !    spml/wt_zonal_module モジュールは球面上および球殻内での
  !    流体運動をスペクトル法によって帯状成分数値計算するための 
  !    Fortran90 関数を提供するものである. 
  !
  !    水平方向に球面調和函数変換および上下の境界壁を扱うための
  !    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
  !    関数を提供する. 
  !
  !    内部で wa_zonal_module, at_module を用いている. 最下部では
  !    球面調和変換およびチェビシェフ変換のエンジンとして ISPACK3 の 
  !    Fortran サブルーチンを用いている.
  !
  !   wt_zonal_modulde で提供される関数・サブルーチンは 3 次元
  !   球殻内の流体運動を扱う wt_module モジュールで用いられているものと
  !   名前およびインターフェースが共通になるように設計してある. 
  !   したがって, wt_module を用いて構成された 2 次元モデルを
  !   帯状成分のモデルへと改造するには次の手順が必要となる.
  !
  !      * use 文での wt_module の引用を wt_zonal_module に変更する.
  !      * 配列の大きさを経度方向格子点数 im -> 1 に,
  !        水平波数を (nm+1)**2 -> nm-m+1 に変更する.
  !      * DO 文で水平波数に関してループを回しているところを
  !        (nm+1)**2 -> nm-m+1 に変更する.
  !      * gtool 出力の次元変数変更する.
  !
  !   ただし, 帯状成分モデルへの改変については以下の点に留意する必要がある. 
  !
  !      * 帯状成分ではない場をスペクトル変換しているところは
  !        水平スペクトル変換してはいけない.
  !      * 非線形項を実空間で計算しているところで他の波数成分が生じないよう
  !        留意すること. 
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (wt_, xyz_, wz_, w_, xy_, x_, y_, z_, a_) は, 
  !   返す値の形を示している.
  !   wt_  :: スペクトルデータ(球面調和函数・チェビシェフ変換)
  !   xyz_ :: 3 次元格子点データ(経度スペクトル(実部虚部・緯度・動径)
  !   wz_  :: 水平スペクトル, 動径格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (wt_, xyz_, wz_, w_, xy_,  y_, z_, a_) は, 入力変数の
  !   形がスペクトルデータおよび格子点データであることを示している.
  !   _wt      :: スペクトルデータ
  !   _xyz     :: 3 次元格子点データ
  !   _xyz_xyz :: 2 つの3 次元格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xyz : 3 次元格子点データ(経度スペクトル(実虚部)・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,0:km). 
  !   * im, jm, km はそれぞれ経度, 緯度, 動径座標の格子点数であり, 
  !     サブルーチン wt_Initial にてあらかじめ設定しておく.
  !
  ! * wt : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(2*(nm-m+1),0:lm). 
  !   * nm は球面調和函数の最大全波数, m は東西波数, lm はチェビシェフ
  !     多項式の最大次数であり, サブルーチン wt_Initial にてあらかじめ
  !     設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  !
  ! * wz : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),0:km).
  !
  ! * wt_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xyz_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * wz_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  ! 
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wt_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! y_Lat, z_Rad               :: 格子点座標(緯度, 経度, 動径座標)を
  !                                 格納した1 次元配列
  ! y_Lat_Weight, z_Rad_Weight :: 重み座標を格納した 1 次元配列
  ! xyz_Lat, xyz_Rad           :: 格子点データの経度・緯度・動径座標(X,Y,Z)
  !                                 (格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyz_wt, wt_xyz :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, チェビシェフ変換)
  ! xyz_wz, wz_xyz :: 3 次元格子データと水平スペクトル・動径格子データとの間
  !                   の変換 (球面調和函数)
  ! wz_wt, wt_wz   :: スペクトルデータと水平スペクトル・動径格子データとの間
  !                   の変換 (チェビシェフ変換)
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの間の変換
  !                   (球面調和函数変換) 
  ! az_at, at_az   :: 同時に複数個行う (チェビシェフ変換)格子データと
  !                   チェビシェフデータの間の変換を
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wt_DRad_wt          :: スペクトルデータに動径微分∂/∂r を作用させる
  ! wt_DivRad_wt        :: スペクトルデータに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wt_RotRad_wt        :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wt_Lapla_wt         :: スペクトルデータにラプラシアンを作用させる
  ! xyz_GradLon_wt      :: スペクトルデータに勾配型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! xyz_GradLat_wt      :: スペクトルデータに勾配型緯度微分
  !                        1/r・∂/∂φを作用させる
  ! wt_DivLon_xyz       :: 格子データに発散型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! wt_DivLat_xyz       :: 格子データに発散型緯度微分
  !                        1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wt_Div_xyz_xyz_xyz  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyz_Div_xyz_xyz_xyz :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyz_RotLon_wt_wt    :: ベクトル場の回転の経度成分を計算する
  ! xyz_RotLat_wt_wt    :: ベクトル場の回転の緯度成分を計算する
  ! wt_RotRad_xyz_xyz   :: ベクトル場の回転の動径成分を計算する
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! wt_KxRGrad_wt            :: スペクトルデータに
  !                             経度微分 k×r・▽ = ∂/∂λを作用させる
  ! xyz_KGrad_wt             :: スペクトルデータに軸方向微分
  !                             k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を
  !                             作用させる
  ! wt_L2_wt                 :: スペクトルデータに 
  !                             L2 演算子 = -水平ラプラシアンを作用させる
  ! wt_L2Inv_wt              :: スペクトルデータに 
  !                             L2 演算子の逆 = -逆水平ラプラシアンを作用させる
  ! wt_QOperator_wt          :: スペクトルデータに
  !                             演算子 Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を
  !                             作用させる
  ! wt_RadRot_xyz_xyz        :: ベクトル v の渦度と動径ベクトル r の内積
  !                             r・(▽×v) を計算する
  ! wt_RadRotRot_xyz_xyz_xyz :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wt_Potential2Vector      :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! wt_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  !
  !
  !==== 境界値問題
  !
  ! wt_BoundariesTau, wt_BoundariesGrid, wt_Boundaries                   ::
  !     ディリクレ, ノイマン境界条件を適用する(タウ法, 選点法)
  ! wt_TorBoundariesTau, wt_TorBoundariesGrid, wt_TorBoundaries          ::
  !     速度トロイダルポテンシャルの境界条件を適用する(タウ法,選点法) 
  !
  ! wz_LaplaPol2Pol_wz, wt_LaplaPol2PolTau_wt, wt_LaplaPol2PolGrid_wt    ::
  !     速度ポロイダルポテンシャルΦを▽^2Φから求める
  !     (入出力がそれぞれチェビシェフ格子点,チェビシェフ係数)
  ! wt_TorMagBoundariesTau, wt_TorMagBoundariesGrid, wt_TorMagBoundaries ::
  !     磁場トロイダルポテンシャルの境界条件を適用する(タウ法, 選点法)
  !
  ! wt_PolMagBoundariesTau, wt_PolMagBoundariesGrid, wt_PolMagBoundaries ::
  !     磁場トロイダルポテンシャル境界の境界条件を適用する(タウ法, 選点法)
  !
  !
  !==== 補間計算
  !
  ! Interpolate_wt :: スペクトルデータから任意の点の値を補間する. 
  ! 
  use dc_message
  use lumatrix
  use wa_zonal_module
  use at_module, z_RAD => g_X, z_RAD_WEIGHT => g_X_WEIGHT, &
                 at_az => at_ag, az_at => ag_at, &
                 t_z => t_g, z_t => g_t, &
                 t_Dr_t => t_Dx_t, at_Dr_at => at_Dx_at
  implicit none
  private

  public wt_Initial
  public wt_Finalize

  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public z_Rad, z_Rad_Weight
  public l_nm, nm_l
  public xy_Lon, xy_Lat
  public xyz_Lon, xyz_Lat, xyz_Rad
  public wz_Rad
  public wt_VMiss

  public w_xy, xy_w
  public at_Dr_at, t_Dr_t, az_at, at_az
  public xyz_wt, wt_xyz, xyz_wz, wz_xyz, wz_wt, wt_wz
  public wt_DRad_wt, wt_DivRad_wt, wt_RotRad_wt, wt_Lapla_wt
  public xyz_GradLon_wt, xyz_gradlat_wt
  public wt_DivLon_xyz, wt_DivLat_xyz
  public wt_Div_xyz_xyz_xyz, xyz_Div_xyz_xyz_xyz
  public xyz_RotLon_wt_wt, xyz_RotLat_wt_wt, wt_RotRad_xyz_xyz

  public wt_KxRGrad_wt, xyz_KGrad_wt, wt_L2_wt, wt_L2Inv_wt, wt_QOperator_wt
  public wt_RadRot_xyz_xyz, wt_RadRotRot_xyz_xyz_xyz
  public wt_Potential2vector, wt_Potential2Rotation

  public wt_Boundaries, wt_TorBoundaries
  public wt_LaplaPol2Pol_wt, wz_LaplaPol2Pol_wz
  public wt_TormagBoundaries, wt_PolmagBoundaries

  public wt_BoundariesTau, wt_TorBoundariesTau, wt_LaplaPol2PolTau_wt
  public wt_TormagBoundariesTau, wt_PolmagBoundariesTau

  public wt_BoundariesGrid, wt_TorBoundariesGrid, wt_LaplaPol2PolGrid_wt
  public wt_TormagBoundariesGrid, wt_PolmagBoundariesGrid

  public Interpolate_wt

  interface wt_Boundaries
     module procedure wt_BoundariesTau
  end interface

  interface wt_TorBoundaries
     module procedure wt_TorBoundariesTau
  end interface

  interface wt_LaplaPol2Pol_wt
     module procedure wt_LaplaPol2PolTau_wt
  end interface

  interface wt_TorMagBoundaries
     module procedure wt_TorMagBoundariesTau
  end interface

  interface wt_PolMagBoundaries
     module procedure wt_PolMagBoundariesTau
  end interface

  integer            :: im=2,  jm=32, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=16         ! 切断波数の設定(水平, 動径)
  real(8)            :: ri=0.0, ro=1.0       ! 球殻内外半径
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), dimension(:,:,:), allocatable :: xyz_LON, xyz_LAT, xyz_RAD ! 座標
  real(8), dimension(:,:), allocatable   :: wz_RAD                    ! 座標

  real(8) :: wt_VMiss = -999.0        ! 欠損値

  logical :: wt_Initialize = .false.
  ! 初期化スイッチ

  logical :: wt_TorBoundariesTau_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: wt_TorBoundariesGrid_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: wz_LaplaPol2Pol_wz_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: wt_LaplaPol2PolTau_wt_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: wt_LaplaPol2PolGrid_wt_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: wt_TormagBoundariesTau_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: wt_TormagBoundariesGrid_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: wt_PolmagBoundariesTau_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  logical :: wt_PolmagBoundariesGrid_first = .true.
  ! 境界条件ルーチン初期化スイッチ

  save im, jm, km, nm, lm, ri, ro
  save xyz_Lat, xyz_Rad, wz_Rad
  save wt_Initialize
  save wt_TorBoundariesTau_first
  save wt_TorBoundariesGrid_first
  save wz_LaplaPol2Pol_wz_first
  save wt_LaplaPol2PolTau_wt_first
  save wt_LaplaPol2PolGrid_wt_first
  save wt_TormagBoundariesTau_first
  save wt_TormagBoundariesGrid_first
  save wt_PolmagBoundariesTau_first
  save wt_PolmagBoundariesGrid_first

contains
  !--------------- 初期化 -----------------
  subroutine wt_Initial(i,j,k,n,l,r_in,r_out,np,wa_init)
    !
    ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない. 
    !
    ! np に 1 より大きな値を指定すれば ISPACK の球面調和函数変換 
    ! OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには, 
    ! 実行時に環境変数 OMP_NUM_THREADS を np 以下の数字に設定する等の
    ! システムに応じた準備が必要となる. 
    !
    ! np に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
    !
    !
    integer,intent(in) :: i              ! 格子点数(経度λ)
    integer,intent(in) :: j              ! 格子点数(緯度φ)
    integer,intent(in) :: k              ! 格子点数(動径 r)
    integer,intent(in) :: n              ! 切断波数(水平全波数)
    integer,intent(in) :: l              ! 切断波数(動径波数)

    real(8),intent(in) :: r_in           ! 球殻内半径
    real(8),intent(in) :: r_out          ! 球殻外半径

    integer,intent(in), optional :: np   ! OPENMP での最大スレッド数
    logical,intent(in), optional :: wa_init   ! wa_initial スイッチ

    logical    :: wa_initialize=.true.   ! wa_initial スイッチ

    im = i  ; jm = j ; km = k
    nm = n  ; lm = l
    ri = r_in ; ro = r_out

    if ( present(wa_init) ) then
       wa_initialize = wa_init
    else
       wa_initialize = .true.
    endif

    if ( wa_initialize ) then
       if ( present(np) ) then
          call MessageNotify &
               ('M','wt_Initial','np is dummy . No need to set np in wt_zonal_module')
       else
          call wa_Initial(nm,im,jm,km+1)
       endif
    endif

    call at_Initial(km,lm,r_in,r_out)

    allocate(xyz_Lon(0:im-1,1:jm,0:km))
    allocate(xyz_Lat(0:im-1,1:jm,0:km))
    allocate(xyz_Rad(0:im-1,1:jm,0:km))

    allocate(wz_Rad(nm+1,0:km))

    xyz_Lon = spread(xy_Lon,3,km+1)
    xyz_Lat = spread(xy_Lat,3,km+1)
    xyz_Rad = spread(spread(z_Rad,1,jm),1,im)

    wz_Rad = spread(z_Rad,1,nm+1)

    z_Rad_Weight = z_Rad_Weight * z_Rad**2       ! r^2 dr の積分重み

    wt_Initialize = .true.

    call MessageNotify('M','wt_initial', &
         'wt_zonal_module (2025/12/10) is initialized')

  end subroutine wt_initial

  !--------------- 基本変換 -----------------

  function xyz_wt(wt)
    !
    ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
    real(8), dimension(0:im-1,1:jm,0:km)               :: xyz_wt
    !(out) 3 次元経度緯度動径格子点データ

    xyz_wt = xya_wa(wz_wt(wt))

  end function xyz_wt

  function wt_xyz(xyz)
    !
    ! 3 次元格子点データからスペクトルデータへ(正)変換する.
    !
    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz
    !(in) 3 次元経度緯度動径格子点データ
    real(8), dimension(nm+1,0:lm)           :: wt_xyz
    !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

    wt_xyz = wt_wz(wa_xya(xyz))

  end function wt_xyz

  function xyz_wz(wz)
    !
    ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
    !
    real(8), dimension(nm+1,0:km), intent(in) :: wz
    !(in) 2 次元球面調和函数スペクトル・動径格子点データ
    real(8), dimension(0:im-1,1:jm,0:km)               :: xyz_wz
    !(out) 3 次元経度緯度動径格子点データ

    xyz_wz = xya_wa(wz)

  end function xyz_wz

  function wz_xyz(xyz)
    !
    ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
    !
    real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
    !(in) 3 次元経度緯度動径格子点データ
    real(8), dimension(nm+1,0:km)             :: wz_xyz
    !(out) 2 次元球面調和函数スペクトル・動径格子点データ

    wz_xyz = wa_xya(xyz)

  end function wz_xyz

  function wz_wt(wt)
    !
    ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
    real(8), dimension(nm+1,0:km)             :: wz_wt
    !(out) 2 次元球面調和函数スペクトル・動径格子点データ

    wz_wt = az_at(wt)

  end function wz_wt

  function wt_wz(wz)
    !
    ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
    !
    real(8), dimension(nm+1,0:km), intent(in) :: wz
    !(in) 2 次元球面調和函数スペクトル・動径格子点データ
    real(8), dimension(nm+1,0:lm)             :: wt_wz
    !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

    wt_wz = at_az(wz)

  end function wt_wz

  !--------------- 微分計算 -----------------
  function wt_DRad_wt(wt)
    !
    ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
    !
    ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(nm+1,0:lm)             :: wt_DRad_wt
    !(in) 動径微分された2 次元球面調和函数チェビシェフスペクトルデータ

    wt_DRad_wt = at_Dr_at(wt)

  end function wt_DRad_wt

  function wt_DivRad_wt(wt)
    ! 
    ! 入力スペクトルデータに発散型動径微分
    !
    !       1/r^2 ∂/∂r (r^2 .)= ∂/∂r + 2/r
    !
    ! を作用する.
    !
    ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
    ! 発散型動径微分を作用させたデータのスペクトル変換のことである. 
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(nm+1,0:lm)             :: wt_DivRad_wt
    !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

    wt_DivRad_wt = wt_Drad_wt(wt) + wt_wz(2/wz_rad*wz_wt(wt))


  end function wt_DivRad_wt

  function wt_RotRad_wt(wt)
    !
    ! 入力スペクトルデータに回転型動径微分
    !
    !      1/r ∂(r.)/∂r = ∂(.)/∂r + (.)/r
    !
    ! を作用する.
    !
    ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
    ! 回転型動径微分を作用させたデータのスペクトル変換のことである. 
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(nm+1,0:lm)             :: wt_RotRad_wt
    !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

    wt_RotRad_wt = wt_Drad_wt(wt) + wt_wz(1/wz_Rad*wz_wt(wt))

  end function wt_RotRad_wt

  function wt_Lapla_wt(wt)
    ! 入力スペクトルデータにラプラシアン
    !
    !     ▽^2 =   1/r^2 cos^2φ・∂^2/∂λ^2 
    !            + 1/r^2 cosφ・∂/∂φ(cosφ∂/∂φ) 
    !            + 1/r^2 ∂/∂r (r^2 ∂/∂r) 
    !
    ! を作用する.
    !
    ! スペクトルデータのラプラシアンとは, 対応する格子点データに
    ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(nm+1,0:lm)             :: wt_Lapla_wt
    !(out) ラプラシアンを作用された 2 次元スペクトルデータ

    wt_Lapla_wt = wt_DivRad_wt(wt_Drad_wt(wt)) &
         + wt_wz(wz_wt(wa_Lapla_wa(wt))/wz_Rad**2)

  end function wt_Lapla_wt

  function xyz_GradLon_wt(wt)
    !
    ! スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λ
    ! を作用させる.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(0:im-1,1:jm,0:km)   :: xyz_GradLon_wt
    !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

    xyz_GradLon_wt = xya_GradLon_wa(wz_wt(wt))/xyz_Rad

  end function xyz_GradLon_wt

  function xyz_GradLat_wt(wt) 
    !
    ! スペクトルデータに勾配型経度微分 1/r ∂/∂φ を作用させる.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(0:im-1,1:jm,0:km)    :: xyz_GradLat_wt
    !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

    xyz_GradLat_wt = xya_GradLat_wa(wz_wt(wt))/xyz_Rad

  end function xyz_GradLat_wt

  function wt_DivLon_xyz(xyz)
    ! 
    ! 格子点データに発散型経度微分 1/rcosφ・∂/∂λ を作用させた
    ! スペクトルデータを返す.
    !
    real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
    !(in) 3 次元経度緯度動径格子点データ
    real(8), dimension(nm+1,0:lm)       :: wt_DivLon_xyz
    !(out) 発散型経度微分を作用された 2 次元スペクトルデータ

    wt_DivLon_xyz = wt_wz(wa_DivLon_xya(xyz/xyz_Rad))

  end function wt_DivLon_xyz

  function wt_DivLat_xyz(xyz)
    !
    ! 格子データに発散型緯度微分 1/rcosφ・∂(f cosφ)/∂φ を
    ! 作用させたスペクトルデータを返す.
    !
    real(8), dimension(0:im-1,1:jm,0:km), intent(in)   :: xyz
    !(in) 3 次元経度緯度動径格子点データ
    real(8), dimension(nm+1,0:lm)       :: wt_DivLat_xyz
    !(out) 発散型緯度微分を作用された 2 次元スペクトルデータ

    wt_DivLat_xyz = wt_wz(wa_divlat_xya(xyz/xyz_Rad))

  end function wt_DivLat_xyz

  function wt_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)
    !
    ! べクトル成分である 3 つの格子データに発散を作用させた
    ! スペクトルデータを返す.
    !
    ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
    ! 動径成分を表し, 発散は 
    !
    !      1/rcosφ・∂u/∂λ + 1/rcosφ・∂(v cosφ)/∂φ 
    !    + 1/r^2 ∂/∂r (r^2 w)
    !
    ! と計算される.
    !
    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
    !(in) ベクトル場の経度成分
    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
    !(in) ベクトル場の緯度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vrad
    !(in) ベクトル場の動径成分

    real(8), dimension(nm+1,0:lm)     :: wt_Div_xyz_xyz_xyz
    !(out) ベクトル場の発散

    wt_Div_xyz_xyz_xyz =   wt_DivLon_xyz(xyz_Vlon) &
         + wt_DivLat_xyz(xyz_Vlat) &
         + wt_DivRad_wt(wt_xyz(xyz_Vrad))

  end function wt_Div_xyz_xyz_xyz

  function xyz_Div_xyz_xyz_xyz(xyz_Vlon,xyz_Vlat,xyz_Vrad)
    !
    ! ベクトル成分である 3 つの格子データに発散を作用させる.
    !
    ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
    ! 動径成分を表す.
    !
    ! 極の特異性を回避するためにベクトル場に cosφ/r の重みをかけて
    ! 計算している. 
    !
    !      div V = (r/cosφ)・div (Vcosφ/r) + V_φtanφ/r + V_r/r
    ! 
    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
    !(in) ベクトル場の経度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
    !(in) ベクトル場の緯度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vrad
    !(in) ベクトル場の動径成分

    real(8), dimension(0:im-1,1:jm,0:km)             :: xyz_Div_xyz_xyz_xyz
    !(out) ベクトル場の発散

    xyz_Div_xyz_xyz_xyz &
         = xyz_Rad/cos(xyz_Lat) &
         * xyz_wt(wt_Div_xyz_xyz_xyz(xyz_VLon*cos(xyz_Lat)/xyz_Rad,  &
         xyz_VLat*cos(xyz_Lat)/xyz_Rad,  &
         xyz_VRad*cos(xyz_Lat)/xyz_Rad ))&
         + xyz_VLat*tan(xyz_Lat)/xyz_Rad &
         + xyz_VRad/xyz_Rad

  end function xyz_Div_xyz_xyz_xyz

  function xyz_RotLon_wt_wt(wt_Vrad,wt_Vlat) 
    !
    ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
    ! 回転の経度成分 
    !
    !    1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r を計算する.
    !
    ! を計算する
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt_Vrad
    !(in) ベクトル場の動径成分

    real(8), dimension(nm+1,0:lm), intent(in) :: wt_Vlat
    !(in) ベクトル場の緯度成分

    real(8), dimension(0:im-1,1:jm,0:km)                     :: xyz_RotLon_wt_wt
    !(out) ベクトル場の回転の経度成分

    xyz_RotLon_wt_wt =   xyz_GradLat_wt(wt_Vrad) &
         - xyz_wt(wt_RotRad_wt(wt_Vlat))

  end function xyz_RotLon_wt_wt

  function xyz_RotLat_wt_wt(wt_Vlon,wt_Vrad) 
    !
    ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
    ! 回転の緯度成分 
    !
    !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
    !
    ! を計算する.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt_Vlon
    !(in) ベクトル場の経度成分

    real(8), dimension(nm+1,0:lm), intent(in) :: wt_Vrad
    !(in) ベクトル場の動径成分

    real(8), dimension(0:im-1,1:jm,0:km)                     :: xyz_RotLat_wt_wt
    !(out) ベクトル場の回転の緯度成分

    xyz_RotLat_wt_wt =   xyz_wt(wt_RotRad_wt(wt_Vlon)) &
         - xyz_GradLon_wt(wt_Vrad) 

  end function xyz_RotLat_wt_wt

  function wt_RotRad_xyz_xyz(xyz_Vlat,xyz_Vlon) 
    !
    ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
    ! ベクトル場の回転の動径成分 
    !
    !    1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ
    !
    ! を計算する.
    !
    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlat
    !(in) ベクトル場の緯度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_Vlon
    !(in) ベクトル場の経度成分

    real(8), dimension(nm+1,0:lm)     :: wt_RotRad_xyz_xyz
    !(out) ベクトル場の回転の動径成分

    wt_RotRad_xyz_xyz =   wt_DivLon_xyz(xyz_Vlat) &
         - wt_DivLat_xyz(xyz_Vlon)

  end function wt_RotRad_xyz_xyz

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------

  function wt_KxRGrad_wt(wt)
    !
    ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(nm+1,0:lm)             :: wt_KxRGrad_wt
    !(out) 経度微分を作用された 2 次元スペクトルデータ

    wt_KxRGrad_wt =  wa_Dlon_wa(wt)

  end function wt_KxRGrad_wt

  function xyz_KGrad_wt(wt)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
    !
    ! 入力スペクトルデータに対応する格子データに軸方向微分 
    !
    !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r 
    !
    ! を作用させた格子データが返される. 
    ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(0:im-1,1:jm,0:km)                     :: xyz_KGrad_wt
    !(out) 軸方向微分を作用された 2 次元スペクトルデータ

    xyz_KGrad_wt =  cos(xyz_Lat)*xyz_GradLat_wt(wt) &
         + sin(xyz_Lat)*xyz_wt(wt_Drad_wt(wt))

  end function xyz_KGrad_wt

  function wt_L2_wt(wt)
    !
    ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
    !
    ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる. 
    !  入力スペクトルデ ータに対応する格子点データに演算子 
    !
    !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
    !
    ! を作用させたデータのスペクトル変換が返される.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(nm+1,0:lm)             :: wt_L2_wt
    !(out) L^2 演算子を作用された 2 次元スペクトルデータ

    wt_L2_wt = -wa_Lapla_wa(wt)

  end function wt_L2_wt

  function wt_L2Inv_wt(wt)
    !
    ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
    ! 作用する.
    !
    ! スペクトルデータに L^2 演算子を作用させる関数 wt_L2_wt の逆計算を
    ! 行う関数である.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(nm+1,0:lm)             :: wt_L2Inv_wt
    !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

    wt_L2Inv_wt = -wa_LaplaInv_wa(wt)

  end function wt_L2Inv_wt

  function wt_QOperator_wt(wt)
    !
    ! 入力スペクトルデータに対応する格子点データに演算子 
    !
    !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) 
    !
    ! を作用させたデータのスペクトル変換が返される.
    !
    real(8), dimension(nm+1,0:lm), intent(in) :: wt
    !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

    real(8), dimension(nm+1,0:lm)             :: wt_QOperator_wt
    !(out) Q 演算子を作用された 2 次元スペクトルデータ

    wt_QOperator_wt = &
         wt_xyz(xyz_KGrad_wt(wt) - xyz_KGrad_wt(wt_L2_wt(wt))/2) &
         - wt_L2_wt(wt_xyz(xyz_KGrad_wt(wt)))/2

  end function wt_QOperator_wt

  function wt_RadRot_xyz_xyz(xyz_VLON,xyz_VLAT)  ! r・(▽×v)
    !
    ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
    !
    ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
    !
    !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
    !
    ! のスペクトル データが返される.
    !
    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLON
    !(in) ベクトルの経度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLAT
    !(in) ベクトルの緯度成分

    real(8), dimension(nm+1,0:lm)     :: wt_RadRot_xyz_xyz
    !(out) ベクトルの渦度と動径ベクトルの内積

    wt_RadRot_xyz_xyz = wt_wz(wa_DivLon_xya(xyz_VLAT) &
         - wa_DivLat_xya(xyz_VLON))

  end function wt_RadRot_xyz_xyz

  function wt_RadRotRot_xyz_xyz_xyz(xyz_VLON,xyz_VLAT,xyz_VRAD) 
    ! 
    ! ベクトル v に対して r・(▽×▽×v) を計算する.
    !
    ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
    ! 緯度成分, 動径成分を表す. 
    !
    !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ 
    !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
    !                     + L^2 v[r]/r 
    !
    ! のスペクトルデータが返される.
    !
    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLON
    !(in) ベクトルの経度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VLAT
    !(in) ベクトルの緯度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(in) :: xyz_VRAD
    !(in) ベクトルの動径成分

    real(8), dimension(nm+1,0:lm)     :: wt_RadRotRot_xyz_xyz_xyz
    !(out) ベクトル v の r・(▽×▽×v) 

    wt_RadRotRot_xyz_xyz_xyz = &
         wt_RotRad_wt(wt_wz( &
         (wa_DivLon_xya(xyz_VLON)+ wa_DivLat_xya(xyz_VLAT)))) &
         + wt_L2_wt(wt_xyz(xyz_VRAD/xyz_RAD))

  end function wt_RadRotRot_xyz_xyz_xyz

  subroutine wt_Potential2Vector(&
       xyz_VLON,xyz_VLAT,xyz_VRAD,wt_TORPOT,wt_POLPOT)
    !
    ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
    !
    !     v = ▽x(Ψr) + ▽x▽x(Φr) 
    !
    ! の各成分を計算する
    !
    real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLON
    !(out) ベクトル場の経度成分

    real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VLAT
    !(out) ベクトル場の緯度成分

    real(8), dimension(0:im-1,1:jm,0:km)     :: xyz_VRAD
    !(out) ベクトル場の動径成分

    real(8), dimension(nm+1,0:lm), intent(in) :: wt_TORPOT
    !(in) トロイダルポテンシャル

    real(8), dimension(nm+1,0:lm), intent(in) :: wt_POLPOT
    !(in) ポロイダルポテンシャル

    xyz_VLON =   xyz_RAD * xyz_GradLat_wt(wt_TORPOT) &
         + xya_GradLon_wa(wz_wt(wt_RotRad_wt(wt_POLPOT)))
    xyz_VLAT = - xyz_RAD * xyz_GradLon_wt(wt_TORPOT) &
         + xya_GradLat_wa(wz_wt(wt_RotRad_wt(wt_POLPOT)))
    xyz_VRAD = xyz_wt(wt_L2_wt(wt_POLPOT))/xyz_RAD

  end subroutine wt_Potential2Vector

  subroutine wt_Potential2Rotation(&
       xyz_RotVLON,xyz_RotVLAT,xyz_RotVRAD,wt_TORPOT,wt_POLPOT)
    !
    ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
    !
    !     v = ▽x(Ψr) + ▽x▽x(Φr) 
    !
    ! に対して, その回転
    !
    !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
    !
    ! を計算する. 

    ! ベクトル場の回転
    real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVLON
    !(out) 回転の経度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVLAT
    !(out) 回転の緯度成分

    real(8), dimension(0:im-1,1:jm,0:km), intent(OUT) :: xyz_RotVRAD
    !(out) 回転の動径成分

    ! 入力ベクトル場を表すポテンシャル
    real(8), dimension(nm+1,0:lm), intent(in) :: wt_TORPOT
    !(in) トロイダルポテンシャル

    real(8), dimension(nm+1,0:lm), intent(in) :: wt_POLPOT
    !(in) ポロイダルポテンシャル

    call wt_Potential2Vector( &
         xyz_RotVLON,xyz_RotVLAT,xyz_RotVRAD, &
         -wt_Lapla_wt(wt_POLPOT), wt_TORPOT)

  end subroutine wt_Potential2Rotation

  !--------------- 境界値問題 -----------------

  subroutine wt_BoundariesTau(wt,values,cond)
    !
    ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
    ! Chebyshev 空間での境界条件適用(タウ法)
    !
    ! チェビシェフ空間において境界条件を満たすべく高次の係数を
    ! 定める方法をとっている(タウ法).
    !
    real(8), dimension(nm+1,0:lm),intent(inout)      :: wt
    !(inout) 境界条件を適用するデータ. 修正された値を返す. 

    real(8), dimension(nm+1,2), intent(in), optional :: values
    !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
    !     省略時は値/勾配 0 となる. 

    character(len=2), intent(in), optional             :: cond
    !(in) 境界条件. 省略時は 'DD'
    !        DD : 両端ディリクレ条件
    !        DN : 上端ディリクレ, 下端ノイマン条件
    !        ND : 上端ノイマン, 下端ディリクレ条件
    !        NN : 両端ノイマン条件

    if (.not. present(cond)) then
       if (present(values)) then
          call at_BoundariesTau_DD(wt,values)
       else
          call at_BoundariesTau_DD(wt)
       endif
       return
    endif

    select case(cond)
    case ('NN')
       if (present(values)) then
          call at_BoundariesTau_NN(wt,values)
       else
          call at_BoundariesTau_NN(wt)
       endif
    case ('DN')
       if (present(values)) then
          call at_BoundariesTau_DN(wt,values)
       else
          call at_BoundariesTau_DN(wt)
       endif
    case ('ND')
       if (present(values)) then
          call at_BoundariesTau_ND(wt,values)
       else
          call at_BoundariesTau_ND(wt)
       endif
    case ('DD')
       if (present(values)) then
          call at_BoundariesTau_DD(wt,values)
       else
          call at_BoundariesTau_DD(wt)
       endif
    case default
       call MessageNotify('E','wt_BoundariesTau','B.C. not supported')
    end select

  end subroutine wt_BoundariesTau

  subroutine wt_BoundariesGrid(wt,values,cond)
    !
    ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
    ! 実空間での境界条件適用
    !
    ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
    ! 条件を課している(選点法). このルーチンを用いるためには 
    ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
    ! 等しくしておく必要がある.
    !
    real(8), dimension(nm+1,0:lm),intent(inout)      :: wt
    !(inout) 境界条件を適用するデータ. 修正された値を返す. 

    real(8), dimension(nm+1,2), intent(in), optional :: values
    !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
    !    省略時は値/勾配 0 となる. 

    character(len=2), intent(in), optional             :: cond
    !(in) 境界条件. 省略時は 'DD'
    !        DD : 両端ディリクレ条件
    !        DN : 上端ディリクレ, 下端ノイマン条件
    !        ND : 上端ノイマン, 下端ディリクレ条件
    !        NN : 両端ノイマン条件

    if (.not. present(cond)) then
       if (present(values)) then
          call at_boundariesGrid_DD(wt,values)
       else
          call at_boundariesGrid_DD(wt)
       endif
       return
    endif

    select case(cond)
    case ('NN')
       if (present(values)) then
          call at_BoundariesGrid_NN(wt,values)
       else
          call at_BoundariesGrid_NN(wt)
       endif
    case ('DN')
       if (present(values)) then
          call at_BoundariesGrid_DN(wt,values)
       else
          call at_BoundariesGrid_DN(wt)
       endif
    case ('ND')
       if (present(values)) then
          call at_BoundariesGrid_ND(wt,values)
       else
          call at_BoundariesGrid_ND(wt)
       endif
    case ('DD')
       if (present(values)) then
          call at_BoundariesGrid_DD(wt,values)
       else
          call at_BoundariesGrid_DD(wt)
       endif
    case default
       call MessageNotify('E','wt_BoundariesGrid','B.C. not supported')
    end select

  end subroutine wt_BoundariesGrid

  subroutine wt_TorBoundariesTau(wt_TORPOT,values,cond,new) 
    !
    ! 速度トロイダルポテンシャルに対して境界条件を適用する. 
    ! Chebyshev 空間での境界条件適用. 
    !
    ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
    !
    !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
    !                                   default は 0(静止状態).
    !
    !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    real(8), dimension(nm+1,0:lm),intent(inout)      :: wt_TORPOT
    !(inout) 境界条件を適用するデータ. 修正された値を返す. 

    real(8), dimension(nm+1,2), intent(in), optional :: values
    !(in) 両端境界でのトロイダルポテンシャル
    !     粘着条件の時のみ有効

    character(len=2), intent(in), optional  :: cond
    !(in) 境界条件スイッチ. 省略時は 'RR'
    !     RR    : 両端粘着条件
    !     RF    : 上端粘着, 下端応力なし条件
    !     FR    : 上端応力なし, 下端粘着条件
    !     FF    : 両端応力なし条件

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable    :: kp
    real(8), dimension(0:lm)              :: t_data
    real(8), dimension(0:km)              :: z_data
    logical                               :: rigid1, rigid2   ! 境界条件

    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp

    if (.not. present(cond)) then
       rigid1=.TRUE. ; rigid2=.TRUE.
    else
       select case (cond)
       case ('RR')
          rigid1 = .TRUE.  ; rigid2 = .TRUE.
       case ('RF')
          rigid1 = .TRUE.  ; rigid2 = .FALSE.
       case ('FR')
          rigid1 = .FALSE. ; rigid2 = .TRUE.
       case ('FF')
          rigid1 = .FALSE. ; rigid2 = .FALSE.
       case default
          call MessageNotify('E','wt_TorBoundariesTau','B.C. not supported')
       end select
    endif

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wt_TorBoundariesTau_first .OR. new_matrix ) then
       wt_TorBoundariesTau_first = .false.

       if ( allocated(alu) ) deallocate(alu)
       if ( allocated(kp) ) deallocate(kp)
       allocate(alu(0:lm,0:lm),kp(0:lm))

       do l=0,lm
          t_data = 0.0D0 ; t_data(l) = 1.0D0
          alu(:,l) = t_data

          ! 力学的条件粘着条件 
          if ( rigid1 ) then
             z_data = z_t(t_data)
          else
             z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
          endif
          alu(lm-1,l) = z_data(0)       ! 境界 k=0 での条件式代入

          if ( rigid2 ) then
             z_data = z_t(t_data)
          else
             z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
          endif
          alu(lm,l)   = z_data(km)      ! 境界 k=km での条件式代入
       enddo

       call ludecomp(alu,kp)

       if ( rigid1 .AND. present(values) ) then 
          call MessageNotify('M','wt_TorBoundariesTau',&
               'Toroidal potential at k=0 was given by the optional variable.')
       else if ( rigid1 .AND. (.NOT.present(values)) ) then
          call MessageNotify('M','wt_TorBoundariesTau',&
               'Toroidal potential at k=0 was set to zero.')
       else if ( (.NOT. rigid1) .AND. present(values) ) then
          call MessageNotify('W','wt_TorBoundariesTau',&
               'Boundary value k=0 cannot be set under stress-free condition.')
       endif

       if ( rigid2 .AND. present(values) ) then 
          call MessageNotify('M','wt_TorBoundariesTau',&
               'Toroidal potential at k=0 was given by the optional variable.')
       else if ( rigid2 .AND. (.NOT.present(values)) ) then
          call MessageNotify('M','wt_TorBoundariesTau',&
               'Toroidal potential at k=0 was set to zero.')
       else if ( (.NOT. rigid2) .AND. present(values) ) then
          call MessageNotify('W','wt_TorBoundariesTau',&
               'Boundary value k=0 cannot be set under stress-free condition.')
       endif

       call MessageNotify('M','wt_TorBoundariesTau',&
            'Matrix to apply  b.c. newly produced.')
    endif

    if ( rigid1 .AND. present(values) ) then
       wt_torpot(:,lm-1) = values(:,1)
    else
       wt_torpot(:,lm-1) = 0.0D0
    endif
    if ( rigid2 .AND. present(values) ) then
       wt_torpot(:,lm)   = values(:,2)
    else
       wt_torpot(:,lm) = 0.0D0
    endif

    wt_torpot = lusolve(alu,kp,wt_TORPOT)

  end subroutine wt_TorBoundariesTau

  subroutine wt_TorBoundariesGrid(wt_TORPOT,values,cond,new) 
    !
    ! 速度トロイダルポテンシャルに対して境界条件を適用する.
    ! 実空間での境界条件適用
    !
    ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
    ! 条件を課している(選点法). このルーチンを用いるためには 
    ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
    ! 等しくしておく必要がある. 
    !
    ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
    !
    !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
    !                                   default は 0 (静止状態).
    !
    !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    real(8), dimension(nm+1,0:lm),intent(inout)      :: wt_TORPOT
    !(inout) 境界条件を適用するデータ. 修正された値を返す. 

    real(8), dimension(nm+1,2), intent(in), optional :: values
    !(in) 両端境界でのトロイダルポテンシャル
    !     粘着条件の時のみ有効

    character(len=2), intent(in), optional  :: cond
    !(in) 境界条件スイッチ. 省略時は 'RR'
    !     RR    : 両端粘着条件
    !     RF    : 上端粘着, 下端応力なし条件
    !     FR    : 上端応力なし, 下端粘着条件
    !     FF    : 両端応力なし条件

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(nm+1,0:km)  :: wz_TORPOT
    real(8), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable    :: kp
    real(8), dimension(0:lm)              :: t_data
    real(8), dimension(0:km)              :: z_data
    logical                               :: rigid1, rigid2   ! 境界条件

    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp

    if (.not. present(cond)) then
       rigid1=.TRUE. ; rigid2=.TRUE.
    else
       select case (cond)
       case ('RR')
          rigid1 = .TRUE.  ; rigid2 = .TRUE.
       case ('RF')
          rigid1 = .TRUE.  ; rigid2 = .FALSE.
       case ('FR')
          rigid1 = .FALSE. ; rigid2 = .TRUE.
       case ('FF')
          rigid1 = .FALSE. ; rigid2 = .FALSE.
       case default
          call MessageNotify('E','wt_TorBoundariesGrid','B.C. not supported')
       end select
    endif

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wt_TorBoundariesGrid_first .OR. new_matrix ) then
       wt_TorBoundariesGrid_first = .false.

       if ( lm /= km ) then
          call MessageNotify('E','TorBoundariesGrid', &
               'Chebyshev truncation and number of grid points should be same.')
       endif

       if ( allocated(alu) ) deallocate(alu)
       if ( allocated(kp) ) deallocate(kp)
       allocate(alu(0:km,0:lm),kp(0:lm))

       do l=0,lm
          t_data = 0.0D0 ; t_data(l)=1.0D0
          alu(:,l) = z_t(t_data)

          if ( rigid1 ) then
             z_data = z_t(t_data)
          else
             z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
          endif
          alu(0,l) = z_data(0)        ! 境界 k=0 での条件式代入

          if ( rigid2 ) then
             z_data = z_t(t_data)
          else
             z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
          endif
          alu(km,l)   = z_data(km)    ! 境界 k=km での条件式代入
       end do

       call ludecomp(alu,kp)

       if ( rigid1 .AND. present(values) ) then 
          call MessageNotify('M','wt_TorBoundariesGrid',&
               'Toroidal potential at k=0 was given by the optional variable.')
       else if ( rigid1 .AND. (.NOT.present(values)) ) then
          call MessageNotify('M','wt_TorBoundariesGrid',&
               'Toroidal potential at k=0 was set to zero.')
       else if ( (.NOT. rigid1) .AND. present(values) ) then
          call MessageNotify('W','wt_TorBoundariesGrid',&
               'Boundary value at k=0 cannot be set under stress-free condition.')
       endif

       if ( rigid2 .AND. present(values) ) then 
          call MessageNotify('M','wt_TorBoundariesGrid',&
               'Toroidal potential at k=km was given by the optional variable.')
       else if ( rigid2 .AND. (.NOT.present(values)) ) then
          call MessageNotify('M','wt_TorBoundariesGrid',&
               'Toroidal potential at k=km was set to zero.')
       else if ( (.NOT. rigid2) .AND. present(values) ) then
          call MessageNotify('W','wt_TorBoundariesGrid',&
               'Boundary value at k=km cannot be set under stress-free condition.')
       endif

       call MessageNotify('M','wt_TorBoundariesGrid',&
            'Matrix to apply  b.c. newly produced.')
    endif

    wz_TorPot       = wz_wt(wt_TorPot)

    if ( rigid1 .AND. present(values) ) then
       wz_TorPot(:,0)  = values(:,1)
    else
       wz_TorPot(:,0)  = 0.0D0
    endif

    if ( rigid2 .AND. present(values) ) then
       wz_TorPot(:,km) = values(:,2)
    else
       wz_TorPot(:,km) = 0.0D0
    endif

    wt_torpot = lusolve(alu,kp,wz_TorPot)

  end subroutine wt_TorBoundariesGrid

  function wz_LaplaPol2Pol_wz(wz,cond,new)
    !
    ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
    !
    ! チェビシェフ格子点空間で境界条件を適用している. 
    ! この関数を用いるためには wt_Initial にて設定する
    ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
    ! しておく必要がある. 
    !
    ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
    !
    !   ▽^2Φ = f
    !     Φ = const. at boundaries.
    !     ∂Φ/∂r = 0 at boundaries           (粘着条件) 
    !     or ∂^2Φ/∂r^2 = 0 at boundaries    (応力なし条件)
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    real(8), dimension(nm+1,0:km),intent(in)  :: wz
    !(in) 入力▽^2φ分布

    real(8), dimension(nm+1,0:km)             :: wz_LaplaPol2Pol_wz
    !(out) 出力ポロイダルポテンシャル分布

    character(len=2), intent(in), optional  :: cond
    !(in) 境界条件スイッチ. 省略時は 'RR'
    !     RR    : 両端粘着条件
    !     RF    : 上端粘着, 下端応力なし条件
    !     FR    : 上端応力なし, 下端粘着条件
    !     FF    : 両端応力なし条件

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(8), dimension(nm+1,0:km)  :: wz_work
    real(8), dimension(0:km,0:km)           :: gg
    real(8), dimension(0:km,0:km)           :: gg_work
    logical                                 :: rigid1, rigid2   ! 境界条件

    logical :: new_matrix = .false.
    integer :: k,n
    save    :: alu, kp

    if (.not. present(cond)) then
       rigid1=.TRUE. ; rigid2=.TRUE.
    else
       select case (cond)
       case ('RR')
          rigid1 = .TRUE.  ; rigid2 = .TRUE.
       case ('RF')
          rigid1 = .TRUE.  ; rigid2 = .FALSE.
       case ('FR')
          rigid1 = .FALSE. ; rigid2 = .TRUE.
       case ('FF')
          rigid1 = .FALSE. ; rigid2 = .FALSE.
       case default
          call MessageNotify('E','wz_LaplaPol2Pol_wz','B.C. not supported')
       end select
    endif

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wz_LaplaPol2Pol_wz_first .OR. new_matrix ) then
       wz_LaplaPol2Pol_wz_first = .false.

       if ( lm /= km ) then
          call MessageNotify('E','wz_LaplaPol2Pol_wz', &
               'Chebyshev truncation and number of grid points should be same.')
       endif

       if ( allocated(alu) ) deallocate(alu)
       if ( allocated(kp) ) deallocate(kp)
       allocate(alu(nm+1,0:km,0:km),kp(nm+1,0:km))

       do k=0,km
          wz_work = 0.0D0 ; wz_work(:,k) = 1.0D0

          ! 各水平波数に関して独立の式
          alu(:,:,k) = wz_wt(wt_lapla_wt(wt_wz(wz_work)))
       enddo

       ! 運動学的条件. 流線は境界で一定
       gg = 0.0D0
       do k=0,km
          gg(k,k)=1.0D0
       enddo
       do n=1,nm+1
          alu(n,0,:)   = gg(:,0)
          alu(n,km,:)  = gg(:,km)
       enddo

       ! 力学的条件粘着条件 
       if ( rigid1 ) then
          gg_work=az_at(at_dr_at(at_az(gg)))
       else
          gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
       endif
       do n=1,nm+1
          alu(n,1,:) = gg_work(:,0)
       enddo

       ! 力学的条件粘着条件 
       if ( rigid2 ) then
          gg_work=az_at(at_dr_at(at_az(gg)))
       else
          gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
       endif
       do n=1,nm+1
          alu(n,km-1,:) = gg_work(:,km)
       enddo

       call ludecomp(alu,kp)

       call MessageNotify('M','wz_LaplaPol2Pol_wz',&
            'Matrix to apply  b.c. newly produced.')
    endif

    wz_work         = wz
    wz_work(:,1)    = 0.0D0               ! 力学的条件
    wz_work(:,km-1) = 0.0D0               ! 力学的条件
    wz_work(:,0)    = 0.0D0               ! 運動学的条件
    wz_work(:,km)   = 0.0D0               ! 運動学的条件 

    wz_laplapol2pol_wz = lusolve(alu,kp,wz_work)

  end function wz_LaplaPol2Pol_wz

  function wt_LaplaPol2PolTau_wt(wt,cond,new)
    !
    ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
    ! チェビシェフタウ法で境界条件を適用している. 
    !
    ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
    !
    !    ▽^2Φ = f
    !      Φ = const. at boundaries.
    !      ∂Φ/∂r = 0 at boundaries          (粘着条件) 
    !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    real(8), dimension(nm+1,0:lm),intent(in)  :: wt
    !(in) 入力▽^2φ分布

    real(8), dimension(nm+1,0:lm)             :: wt_LaplaPol2PolTau_wt
    !(out) 出力ポロイダルポテンシャル分布

    character(len=2), intent(in), optional  :: cond
    !(in) 境界条件スイッチ. 省略時は 'RR'
    !     RR    : 両端粘着条件
    !     RF    : 上端粘着, 下端応力なし条件
    !     FR    : 上端応力なし, 下端粘着条件
    !     FF    : 両端応力なし条件

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(8), dimension(nm+1,0:km)  :: wz_work
    real(8), dimension(nm+1,0:lm)  :: wt_work
    logical                                 :: rigid1, rigid2   ! 境界条件

    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp

    if (.not. present(cond)) then
       rigid1=.TRUE. ; rigid2=.TRUE.
    else
       select case (cond)
       case ('RR')
          rigid1 = .TRUE.  ; rigid2 = .TRUE.
       case ('RF')
          rigid1 = .TRUE.  ; rigid2 = .FALSE.
       case ('FR')
          rigid1 = .FALSE. ; rigid2 = .TRUE.
       case ('FF')
          rigid1 = .FALSE. ; rigid2 = .FALSE.
       case default
          call MessageNotify('E','wt_LaplaPol2PolTau_wt','B.C. not supported')
       end select
    endif

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wt_LaplaPol2PolTau_wt_first .OR. new_matrix ) then
       wt_LaplaPol2PolTau_wt_first = .false.

       if ( allocated(alu) ) deallocate(alu)
       if ( allocated(kp) ) deallocate(kp)
       allocate(alu(nm+1,0:lm,0:lm),kp(nm+1,0:lm))

       alu = 0.0D0
       do l=0,lm-2
          wt_work = 0.0D0 ; wt_work(:,l) = 1.0D0

          ! 各水平波数に関して独立の式
          alu(:,:,l) = wt_Lapla_wt(wt_work)
       enddo

       ! 運動学的条件. 流線は境界で一定
       do l=0,lm
          wt_work=0.0D0
          wt_work(:,l) = 1.0D0
          wz_work = wz_wt(wt_work)

          alu(:,lm-1,l)  = wz_work(:,0)
          alu(:,lm,l)    = wz_work(:,km)

          ! 力学的条件粘着条件 
          if ( rigid1 ) then
             wz_work=wz_wt(wt_DRad_wt(wt_work))
          else
             wz_work=wz_wt(wt_DRad_wt(wt_DRad_wt(wt_work)))
          endif
          alu(:,lm-2,l) = wz_work(:,0)

          ! 力学的条件粘着条件 
          if ( rigid2 ) then
             wz_work=wz_wt(wt_DRad_wt(wt_work))
          else
             wz_work=wz_wt(wt_DRad_wt(wt_DRad_wt(wt_work)))
          endif
          alu(:,lm-3,l) = wz_work(:,km)
       end do

       call ludecomp(alu,kp)

       call MessageNotify('M','wt_LaplaPol2PolTau_wt',&
            'Matrix to apply  b.c. newly produced.')
    endif

    wt_work         = wt
    wt_work(:,lm)   = 0.0D0               ! 運動学的条件 
    wt_work(:,lm-1) = 0.0D0               ! 運動学的条件
    wt_work(:,lm-2) = 0.0D0               ! 力学的条件
    wt_work(:,lm-3) = 0.0D0               ! 力学的条件

    wt_LaplaPol2PolTau_wt = lusolve(alu,kp,wt_work)

  end function wt_LaplaPol2PolTau_wt

  function wt_LaplaPol2PolGrid_wt(wt,cond,new)
    !
    ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
    ! チェビシェフ格子点空間で境界条件を適用している. 
    !
    ! この関数を用いるためには wt_Initial にて設定する
    ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
    ! しておく必要がある. 
    !
    ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
    !
    !    ▽^2Φ = f
    !      Φ = const. at boundaries.
    !      ∂Φ/∂r = 0 at boundaries          (粘着条件) 
    !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    ! 最終的にチェビシェフ係数の解が欲しい場合には, wz_LaplaPol2Pol_wz に
    ! 比べてチェビシェフ -- 格子点変換が 1 回分少なくて済む.
    !
    real(8), dimension(nm+1,0:lm),intent(in)  :: wt
    !(in) 入力▽^2φ分布

    real(8), dimension(nm+1,0:lm)             :: wt_LaplaPol2PolGrid_wt
    !(out) 出力ポロイダルポテンシャル分布

    character(len=2), intent(in), optional  :: cond
    !(in) 境界条件スイッチ. 省略時は 'RR'
    !     RR    : 両端粘着条件
    !     RF    : 上端粘着, 下端応力なし条件
    !     FR    : 上端応力なし, 下端粘着条件
    !     FF    : 両端応力なし条件

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(8), dimension(nm+1,0:km)  :: wz_work
    real(8), dimension(nm+1,0:lm)  :: wt_work
    real(8), dimension(0:lm,0:lm)           :: tt_I
    real(8), dimension(0:lm,0:km)           :: tz_work
    logical                                 :: rigid1, rigid2   ! 境界条件

    logical :: new_matrix = .false.
    integer :: l,n
    save    :: alu, kp

    if (.not. present(cond)) then
       rigid1=.TRUE. ; rigid2=.TRUE.
    else
       select case (cond)
       case ('RR')
          rigid1 = .TRUE.  ; rigid2 = .TRUE.
       case ('RF')
          rigid1 = .TRUE.  ; rigid2 = .FALSE.
       case ('FR')
          rigid1 = .FALSE. ; rigid2 = .TRUE.
       case ('FF')
          rigid1 = .FALSE. ; rigid2 = .FALSE.
       case default
          call MessageNotify('E','wt_LaplaPol2PolGrid_wt','B.C. not supported')
       end select
    endif

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wt_LaplaPol2PolGrid_wt_first .OR. new_matrix ) then
       wt_LaplaPol2PolGrid_wt_first = .false.

       if ( lm /= km ) then
          call MessageNotify('E','wt_LaplaPol2PolGrid_wt', &
               'Chebyshev truncation and number of grid points should be same.')
       endif

       if ( allocated(alu) ) deallocate(alu)
       if ( allocated(kp) ) deallocate(kp)
       allocate(alu(nm+1,0:km,0:lm),kp(nm+1,0:lm))

       do l=0,lm
          wt_work = 0.0D0 ; wt_work(:,l) = 1.0D0

          ! 各水平波数に関して独立の式
          alu(:,:,l) = wz_wt(wt_Lapla_wt(wt_work))
       enddo

       ! 運動学的条件. 流線は境界で一定
       tt_I = 0.0D0
       do l=0,lm
          tt_I(l,l)=1.0D0
       enddo

       ! 非電気伝導体
       tz_work = az_at(tt_I)

       do n=1,nm+1
          alu(n,0,:)  = tz_work(:,0)
          alu(n,km,:) = tz_work(:,km)
       enddo

       ! 力学的条件粘着条件 
       if ( rigid1 ) then
          tz_work=az_at(at_Dr_at(tt_I))
       else
          tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
       endif
       do n=1,nm+1
          alu(n,1,:) = tz_work(:,0)
       enddo

       ! 力学的条件粘着条件 
       if ( rigid2 ) then
          tz_work=az_at(at_Dr_at(tt_I))
       else
          tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
       endif
       do n=1,nm+1
          alu(n,km-1,:) = tz_work(:,km)
       enddo

       call ludecomp(alu,kp)

       call MessageNotify('M','wt_LaplaPol2PolGrid_wt',&
            'Matrix to apply  b.c. newly produced.')
    endif

    wz_work         = wz_wt(wt)
    wz_work(:,1)    = 0.0D0               ! 力学的条件
    wz_work(:,km-1) = 0.0D0               ! 力学的条件
    wz_work(:,0)    = 0.0D0               ! 運動学的条件
    wz_work(:,km)   = 0.0D0               ! 運動学的条件 

    wt_LaplaPol2PolGrid_wt = lusolve(alu,kp,wz_work)

  end function wt_LaplaPol2PolGrid_wt

  subroutine wt_TormagBoundariesTau(wt_TOR,new)

    ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
    ! Chebyshev 空間での境界条件適用
    !
    ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
    ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
    ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
    !
    ! 外側
    !    wt_psi = 0   at the outer boundary
    ! 内側
    !    wt_psi = 0       at the inner boundary
    ! 
    ! であるから wt_Boundaries で対応可能だが, 将来のため別途作成しておく.
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    real(8), dimension(nm+1,0:lm),intent(inout)   :: wt_TOR
    !(inout) 境界条件を適用するデータ. 修正された値を返す. 

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(8), dimension(:,:), allocatable    :: wt_I
    real(8), dimension(:,:), allocatable    :: wz_PSI

    logical :: new_matrix = .false.
    integer  :: l, n
    save     :: alu, kp

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wt_TormagBoundariesTau_first .OR. new_matrix ) then
       wt_TormagBoundariesTau_first = .false.

       if ( allocated(alu) ) deallocate(alu)
       if ( allocated(kp) ) deallocate(kp)
       if ( allocated(wt_I) ) deallocate(wt_I)
       if ( allocated(wz_PSI) ) deallocate(wz_PSI)
       allocate(alu(nm+1,0:lm,0:lm),kp(nm+1,0:lm))
       allocate(wt_I(nm+1,0:lm),wz_PSI(nm+1,0:km))

       do l=0,lm
          wt_I = 0.0D0 ; wt_I(:,l)=1.0D0
          alu(:,:,l) = wt_I

          ! 非電気伝導体
          wz_PSI = wz_wt(wt_I)

          alu(:,lm-1,l) = wz_PSI(:,0)
          alu(:,lm,l)   = wz_PSI(:,km)
       enddo

       call ludecomp(alu,kp)

       deallocate(wt_I,wz_PSI)

       call MessageNotify('M','TormagBoundariesTau',&
            'Matrix to apply  b.c. newly produced.')
    endif

    wt_TOR(:,lm-1) = 0.0D0
    wt_TOR(:,lm)   = 0.0D0
    wt_TOR = lusolve(alu,kp,wt_TOR)

  end subroutine wt_TormagBoundariesTau

  subroutine wt_TormagBoundariesGrid(wt_TOR,new)
    !
    ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
    ! 鉛直実空間での境界条件適用.
    !
    ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
    ! 条件を課している(選点法). このルーチンを用いるためには 
    ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
    ! 等しくしておく必要がある. 
    !
    ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
    ! その場合, 磁場トロイダルポテンシャルの境界条件は
    !
    ! 外側
    !    wt_psi = 0   at the outer boundary
    ! 内側
    !    wt_psi = 0       at the inner boundary
    ! 
    ! であるので wt_Boundaries で対応可能だが, 将来のため別途作成しておく
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    real(8), dimension(nm+1,0:lm),intent(inout)   :: wt_TOR
    !(inout) 境界条件を適用するデータ. 修正された値を返す. 

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(8), dimension(:,:), allocatable    :: wt_I
    real(8), dimension(:,:), allocatable    :: wz_PSI
    real(8), dimension(nm+1,0:km)  :: wz_TOR

    logical :: new_matrix = .false.
    integer  :: l, n
    save     :: alu, kp

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wt_TormagBoundariesGrid_first .OR. new_matrix ) then
       wt_TormagBoundariesGrid_first = .false.

       if ( lm /= km ) then
          call MessageNotify('E','TorMagBoundariesGrid', &
               'Chebyshev truncation and number of grid points should be same.')
       endif

       if ( allocated(alu) ) deallocate(alu)
       if ( allocated(kp) ) deallocate(kp)
       if ( allocated(wt_I) ) deallocate(wt_I)
       if ( allocated(wz_PSI) ) deallocate(wz_PSI)
       allocate(alu(nm+1,0:km,0:lm),kp(nm+1,0:lm))
       allocate(wt_I(nm+1,0:lm),wz_PSI(nm+1,0:km))

       do l=0,lm
          wt_I = 0.0D0 ; wt_I(:,l)=1.0D0
          wz_PSI = wz_wt(wt_I)
          alu(:,:,l) = wz_PSI

          ! 非電気伝導体
          alu(:,0,l)  = wz_PSI(:,0)
          alu(:,km,l) = wz_PSI(:,km)
       enddo

       call ludecomp(alu,kp)

       deallocate(wt_I,wz_PSI)

       call MessageNotify('M','TormagBoundariesGrid',&
            'Matrix to apply  b.c. newly produced.')
    endif

    wz_TOR       = wz_wt(wt_TOR)
    wz_TOR(:,0)  = 0.0D0
    wz_TOR(:,km) = 0.0D0
    wt_TOR = lusolve(alu,kp,wz_TOR)

  end subroutine wt_TormagBoundariesGrid

  subroutine wt_PolmagBoundariesTau(wt_POL,new)
    !
    ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
    ! Chebyshev 空間での境界条件適用
    !
    ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
    ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
    ! 対応している. その場合, 磁場ポロイダルポテンシャルの各水平スペクトル
    ! 成分 h にたいして境界条件が与えられ,
    !
    !  * 外側境界 : dh/dr + (n+1)h/r = 0
    !  * 内側境界 : dh/dr - nh/r = 0
    !
    ! である. ここで n は h の水平全波数である. 
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    real(8), dimension(nm+1,0:lm),intent(inout)   :: wt_POL
    !(inout) 境界条件を適用するデータ. 修正された値を返す. 

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(8), dimension(:,:), allocatable    :: wt_I
    real(8), dimension(:,:), allocatable    :: wz_PSI
    real(8), dimension(:,:), allocatable    :: wz_DPSIDR
    real(8), dimension(:), allocatable      :: w_n

    logical :: new_matrix = .false.
    integer  :: l, n, nn(2)
    save     :: alu, kp

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wt_PolmagBoundariesTau_first .OR. new_matrix ) then
       wt_PolmagBoundariesTau_first = .false.

       if ( allocated(alu) ) deallocate(alu)
       if ( allocated(kp) ) deallocate(kp)
       if ( allocated(wt_I) ) deallocate(wt_I)
       if ( allocated(wz_PSI) ) deallocate(wz_PSI)
       if ( allocated(wz_DPSIDR) ) deallocate(wz_DPSIDR)
       if ( allocated(w_n) ) deallocate(w_n)

       allocate(alu(nm+1,0:lm,0:lm),kp(nm+1,0:lm))
       allocate(wt_I(nm+1,0:lm),w_n(nm+1))
       allocate(wz_PSI(nm+1,0:km),wz_DPSIDR(nm+1,0:km))

       do n=1,nm+1
          nn=nm_l(n)
          w_n(n) = nn(1)
       enddo

       do l=0,lm
          wt_I = 0.0D0 ; wt_I(:,l) = 1.0D0
          alu(:,:,l) = wt_I

          wz_PSI = wz_wt(wt_I)
          wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))
          alu(:,lm-1,l) = wz_DPSIDR(:,0) + (w_n+1) * wz_PSI(:,0)/z_RAD(0)
          alu(:,lm,l)   = wz_DPSIDR(:,km) - w_n * wz_PSI(:,km)/z_RAD(km)
       enddo

       call ludecomp(alu,kp)

       deallocate(wt_I,wz_PSI,wz_DPSIDR,w_n)

       call MessageNotify('M','PolmagBoundariesTau',&
            'Matrix to apply  b.c. newly produced.')
    endif

    wt_POL(:,lm-1) = 0.0D0
    wt_POL(:,lm)   = 0.0D0
    wt_POL = lusolve(alu,kp,wt_POL)

  end subroutine wt_PolmagBoundariesTau

  subroutine wt_PolmagBoundariesGrid(wt_POL,new)
    !
    ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
    ! 鉛直実空間での境界条件適用. 
    !
    ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
    ! 条件を課している(選点法). このルーチンを用いるためには 
    ! wt_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
    ! 等しくしておく必要がある. 
    !
    ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
    ! その場合, 磁場ポロイダルポテンシャルの各水平スペクトル成分 h に
    ! たいして境界条件が与えられ,
    !
    !  * 外側境界 : dh/dr + (n+1)h/r = 0
    !  * 内側境界 : dh/dr - nh/r = 0
    !
    ! である. ここで n は h の水平全波数である. 
    !
    ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
    !
    real(8), dimension(nm+1,0:lm),intent(inout)   :: wt_POL
    !(inout) 境界条件を適用するデータ. 修正された値を返す. 

    logical, intent(IN), optional :: new
    !(in) true だと境界条件計算用行列を強制的に新たに作る.
    !     default は false.

    real(8), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(8), dimension(:,:), allocatable    :: wt_I
    real(8), dimension(:,:), allocatable    :: wz_PSI
    real(8), dimension(:,:), allocatable    :: wz_DPSIDR
    real(8), dimension(:), allocatable      :: w_n

    real(8), dimension(nm+1,0:km)  :: wz_POL

    logical :: new_matrix = .false.
    integer  :: l, n, nn(2)
    save     :: alu, kp

    if (.not. present(new)) then
       new_matrix=.false.
    else 
       new_matrix=new
    endif

    if ( wt_PolmagBoundariesGrid_first .OR. new_matrix ) then
       wt_PolmagBoundariesGrid_first = .false.

       if ( lm /= km ) then
          call MessageNotify('E','PolMagBoundariesGrid', &
               'Chebyshev truncation and number of grid points should be same.')
       endif

       if ( allocated(alu) )  deallocate(alu)
       if ( allocated(kp) )   deallocate(kp)
       if ( allocated(wt_I) ) deallocate(wt_I)
       if ( allocated(wz_PSI) ) deallocate(wz_PSI)
       if ( allocated(wz_DPSIDR) ) deallocate(wz_DPSIDR)
       if ( allocated(w_n) ) deallocate(w_n)

       allocate(alu(nm+1,0:lm,0:lm),kp(nm+1,0:lm))
       allocate(wt_I(nm+1,0:lm),w_n(nm+1))
       allocate(wz_PSI(nm+1,0:km),wz_DPSIDR(nm+1,0:km))

       do n=1,nm+1
          nn=nm_l(n)
          w_n(n) = nn(1)
       enddo

       do l=0,lm
          wt_I = 0.0D0 ; wt_I(:,l) = 1.0D0
          wz_PSI = wz_wt(wt_I)
          alu(:,:,l) = wz_PSI

          wz_DPSIDR = wz_wt(wt_DRad_wt(wt_I))
          alu(:,0,l)  = wz_DPSIDR(:,0) + (w_n+1) * wz_PSI(:,0)/z_RAD(0)
          alu(:,km,l) = wz_DPSIDR(:,km) - w_n * wz_PSI(:,km)/z_RAD(km)
       enddo

       call ludecomp(alu,kp)

       deallocate(wt_I,wz_PSI,wz_DPSIDR,w_n)

       call MessageNotify('M','PolmagBoundariesGrid',&
            'Matrix to apply  b.c. newly produced.')
    endif

    wz_POL       = wz_wt(wt_POL)
    wz_POL(:,0)  = 0.0D0
    wz_POL(:,km) = 0.0D0
    wt_POL = lusolve(alu,kp,wz_POL)

  end subroutine wt_PolmagBoundariesGrid

  !--------------- 補間計算 -----------------
  function Interpolate_wt(wt_data,alon,alat,arad)
    !
    ! 緯度 alon, 経度 alat 動径 arad における関数値を
    ! その球面調和変換係数 wa_data から補間計算する
    !
    real(8), intent(IN) :: wt_data(nm+1,0:lm)! スペクトルデータ
    real(8), intent(IN) :: alon                     ! 補間する位置(経度)
    real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
    real(8), intent(IN) :: arad                     ! 補間する位置(動径)
    real(8) :: Interpolate_wt                       ! 補間した値

    Interpolate_wt = &
         Interpolate_w(a_Interpolate_at(wt_data,arad),alon,alat)

  end function Interpolate_wt

  !--------------- 終了処理 -----------------
  subroutine wt_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
    !
    if ( .not. wt_initialize ) then
       call MessageNotify('W','wt_Finalize',&
            'wt_zonal_module not initialized yet')
       return
    endif

    call wa_Finalize
    call at_Finalize

    deallocate(xyz_Lon)            ! 格子点座標格納配列
    deallocate(xyz_Lat)            ! 格子点座標格納配列
    deallocate(xyz_Rad)
    deallocate(wz_Rad)

    wt_initialize = .false.

    wt_TorBoundariesTau_first = .true.
    wt_TorBoundariesGrid_first = .true.
    wz_LaplaPol2Pol_wz_first = .true.
    wt_LaplaPol2PolTau_wt_first = .true.
    wt_LaplaPol2PolGrid_wt_first = .true.
    wt_TormagBoundariesTau_first = .true.
    wt_TormagBoundariesGrid_first = .true.
    wt_PolmagBoundariesTau_first = .true.
    wt_PolmagBoundariesGrid_first = .true.

    call MessageNotify('M','wt_Finalize','wt_zonal_module (2025/12/10) is finalized')

  end subroutine wt_Finalize
 
end module wt_zonal_module
  

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_base_module テストプログラム :: ベクトル用サブルーチンのテスト
!
!履歴  2019/03/13  竹広真一
!
program w_base_module_vector

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module
  implicit none

  integer, parameter :: im=128, jm=64, nm=42

  real(8), dimension(0:im-1,1:jm)  ::  xy_U              ! 速度経度成分
  real(8), dimension(0:im-1,1:jm)  ::  xy_V              ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm)  ::  xy_UCosLat        ! 速度経度成分
  real(8), dimension(0:im-1,1:jm)  ::  xy_VCosLat        ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm)  ::  xy_Uans           ! 速度経度成分
  real(8), dimension(0:im-1,1:jm)  ::  xy_Vans           ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm)  ::  xy_Psi            ! 流線関数
  real(8), dimension(0:im-1,1:jm)  ::  xy_Chi            ! 速度ポテンシャル

  real(8), dimension((nm+1)**2)    ::  w_Vor             ! 渦度
  real(8), dimension((nm+1)**2)    ::  w_Div             ! 発散

  real(8), dimension(0:im-1,1:jm)  ::  xy_Vorans         ! 渦度
  real(8), dimension(0:im-1,1:jm)  ::  xy_Divans         ! 発散


  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  call MessageNotify('M','w_base_module_vector_test', &
                         'w_base_module subroutine tests')

  call w_Initial( nm, im, jm )

  !---- Y_1^{-1} のテスト ----
  xy_Psi = cos(xy_Lat)*sin(xy_Lon)       ! Y_1^{-1}
  xy_Chi = 0.0D0

  xy_Uans = sin(xy_Lat)*sin(xy_Lon)
  xy_Vans = cos(xy_Lon)

  xy_Vorans = -2*cos(xy_Lat)*sin(xy_Lon)
  xy_Divans = 0.0D0

  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )

  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_StreamPotential2Vector(U)',   &
    answer = xy_Uans,                                             &
    check  = xy_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_StreamPotential2Vector(V)',   &
    answer = xy_Vans,                                             &
    check  = xy_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_Vector2VorDiv(Vor)',          &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_Vector2VorDiv(Div)',          &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)

  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_VectorCosLat2VorDiv(Vor)',    &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^-1 test of w_VectorCosLat2VorDiv(Div)',    &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!!$  xy_Psi = 0.0D0
!!$  xy_Chi = cos(xy_Lat)*sin(xy_Lon)       ! Y_1^{-1}
!!$
!!$  xy_Uans = cos(xy_Lon)
!!$  xy_Vans = - sin(xy_Lat)*sin(xy_Lon)
!!$
!!$  xy_Vorans = 0.0D0
!!$  xy_Divans = -2*cos(xy_Lat)*sin(xy_Lon)
!!$
!!$  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )
!!$
!!$  call AssertEqual(&
!!$    message='Chi = Y_1^-1 test of w_StreamPotential2Vector(U)',   &
!!$    answer = xy_Uans,                                             &
!!$    check  = xy_U,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Chi = Y_1^-1 test of w_StreamPotential2Vector(V)',   &
!!$    answer = xy_Vans,                                             &
!!$    check  = xy_V,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Chi = Y_1^-1 test of w_Vector2VorDiv(Vor)',          &
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Chi = Y_1^-1 test of w_Vector2VorDiv(Div)',          &
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)
!!$
!!$  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Chi = Y_1^-1 test of w_VectorCosLat2VorDiv(Vor)',    &
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Chi = Y_1^-1 test of w_VectorCosLat2VorDiv(Div)',    &
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  !---- Y_2^1 のテスト ----
!!$  xy_Psi = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
!!$  xy_Chi = 0.0D0
!!$
!!$  xy_Uans = - cos(2*xy_Lat)*cos(xy_Lon)
!!$  xy_Vans = - sin(xy_Lat)*sin(xy_Lon)
!!$
!!$  xy_Vorans = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
!!$  xy_Divans = 0.0D0
!!$
!!$  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1 test of w_StreamPotential2Vector(U)',    &
!!$    answer = xy_Uans,                                             &
!!$    check  = xy_U,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1 test of w_StreamPotential2Vector(V)',    &
!!$    answer = xy_Vans,                                             &
!!$    check  = xy_V,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1 test of w_Vector2VorDiv(Vor)',           &
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1 test of w_Vector2VorDiv(Div)',           &
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)
!!$
!!$  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1 test of w_VectorCosLat2VorDiv(Vor)',     &
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1 test of w_VectorCosLat2VorDiv(Div)',     &
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  xy_Psi = 0.0D0
!!$  xy_Chi = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
!!$
!!$  xy_Uans = - sin(xy_Lat)*sin(xy_Lon)
!!$  xy_Vans =   cos(2*xy_Lat)*cos(xy_Lon)
!!$
!!$  xy_Vorans = 0.0D0
!!$  xy_Divans = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
!!$
!!$  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )
!!$
!!$  call AssertEqual(&
!!$    message='Chi = Y_2^1 test of w_StreamPotential2Vector(U)',    &
!!$    answer = xy_Uans,                                             &
!!$    check  = xy_U,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Chi = Y_2^1 test of w_StreamPotential2Vector(V)',    &
!!$    answer = xy_Vans,                                             &
!!$    check  = xy_V,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Chi = Y_2^1 test of w_Vector2VorDiv(Vor)',           &
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Chi = Y_2^1 test of w_Vector2VorDiv(Div)',           &
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)
!!$
!!$  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Chi = Y_2^1 test of w_VectorCosLat2VorDiv(Vor)',     &
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Chi = Y_2^1 test of w_VectorCosLat2VorDiv(Div)',     &
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  !---- Y_1^-1, Y_2^1 のテスト ----
!!$  xy_Psi = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
!!$  xy_Chi = cos(xy_Lat)*sin(xy_Lon)                     ! Y_1^{-1}
!!$
!!$  xy_Uans = - cos(2*xy_Lat)*cos(xy_Lon) + cos(xy_Lon)
!!$  xy_Vans = - sin(xy_Lat)*sin(xy_Lon) - sin(xy_Lat)*sin(xy_Lon)
!!$
!!$  xy_Vorans = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
!!$  xy_Divans = -2*cos(xy_Lat)*sin(xy_Lon)                     ! Y_1^{-1}
!!$
!!$  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1, Chi = Y_1^-1 test of w_StreamPotential2Vector(U)',     &
!!$    answer = xy_Uans,                                             &
!!$    check  = xy_U,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1, Chi = Y_1^-1 test of w_StreamPotential2Vector(V)',     &
!!$    answer = xy_Vans,                                             &
!!$    check  = xy_V,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1, Chi=Y_1^-1 test of w_Vector2VorDiv(Vor)',&
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1, Chi=Y_1^-1 test of w_Vector2VorDiv(Div)',&
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)
!!$
!!$  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1, Chi=Y_1^-1 test of w_VectorCosLat2VorDiv(Vor)',&
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_2^1, Chi=Y_1^-1 test of w_VectorCosLat2VorDiv(Div)',&
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  xy_Psi = cos(xy_Lat)*sin(xy_Lon)                     ! Y_1^{-1}
!!$  xy_Chi = sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
!!$
!!$  xy_Uans = 0.0D0
!!$  xy_Vans = cos(2*xy_Lat)*cos(xy_Lon) + cos(xy_Lon)
!!$
!!$  xy_Vorans = -2*cos(xy_Lat)*sin(xy_Lon)                     ! Y_1^{-1}
!!$  xy_Divans = -6*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)       ! Y_2^1
!!$
!!$  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_1^-1, Chi = Y_2^1 test of w_StreamPotential2Vector(U)',     &
!!$    answer = xy_Uans,                                             &
!!$    check  = xy_U,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_1^-1, Chi = Y_2^1 test of w_StreamPotential2Vector(V)',     &
!!$    answer = xy_Vans,                                             &
!!$    check  = xy_V,                                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_1^-1, Chi=Y_2^1 test of w_Vector2VorDiv(Vor)',&
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_1^-1, Chi=Y_2^1 test of w_Vector2VorDiv(Div)',&
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)
!!$
!!$  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )
!!$
!!$  call AssertEqual(&
!!$    message='Psi = Y_1^-1, Chi=Y_2^1 test of w_VectorCosLat2VorDiv(Vor)',&
!!$    answer = xy_Vorans,                                           &
!!$    check  = xy_w(w_Vor),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$  call AssertEqual(&
!!$    message='Psi = Y_1^-1, Chi=Y_2^1 test of w_VectorCosLat2VorDiv(Div)',&
!!$    answer = xy_Divans,                                           &
!!$    check  = xy_w(w_Div),                                         &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call MessageNotify('M','w_base_module_sjpack_vector_test', &
!!$                         'w_base_module_sjpack subroutine tests succeeded!')

end program w_base_module_vector

!----------------------------------------------------------------------
! Copyright (c) 2008-2025 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  aq_module テストプログラム
!      1 次元境界値問題
!
!履歴  2008/04/02  竹広真一
!      2009/07/22  佐々木洋平 dc_test を使用するように修正
!      2025/12/22  竹広真一 spml2 版対応
!
program aq_test_boundary_grid_1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use aq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, km=10       ! 格子点数, 切断波数
  real(8), parameter :: ra=2               ! 領域の大きさ

 !---- 座標変数など ----
  real(8), parameter :: alpha=0.5D0        ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: beta= 1.0D0        ! 展開多項式パラメター  0 < β
!  real(8), parameter :: gamma=2*alpha+beta ! 展開多項式パラメター 
  real(8), parameter :: amin=2.0D0

  real(8), dimension(im)   :: g_a, g_a_orig
  real(8), dimension(im)   :: g_dadx
!  real(8), dimension(0:km) :: q_a
  real(8)                  :: value=amin

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call aq_Initial(im,km,ra,alpha,beta,(/2/))
  call MessageNotify('M', 'aq_test_boundary_grid_1d', &
       'aq_module boundary test(1d)')
  
  g_a = (g_R-ra)**2.0D0 + 1.0D0
!  q_a = q_g(g_a)
  g_a_orig = g_a

!----- ag_BoundaryGrid_D ------

  call ag_BoundaryGrid_D(g_a, value)
  call AssertEqual(&
    message='ag_BoundaryGrid_D, 1st. ',                         &
    answer = amin,                                              &
    check  = g_a(im),                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  call AssertEqual(&
    message='ag_BoundaryGrid_D, 2nd.',                          &
    answer = g_a_orig(1:im-1),                                  &
    check  = g_a(1:im-1),                                       &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

!----- ag_BoundaryGrid_N ------
  call ag_BoundaryGrid_N(g_a,value)
!   call AssertEqual(&
!     message='ag_BoundaryGrid_N, 1st.',                          &
!     answer = g_a_orig,                                          &
!     check  = g_a,                                               &
!     significant_digits = check_digits, ignore_digits = ignore   &
!     )
  g_dadx = g_q(q_rDr_q(q_g(g_a)))/g_R
  call AssertEqual(&
    message='ag_BoundaryGrid_N, 2nd.',                          &
    answer = amin,                                              &
    check  = g_dadx(im),                                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  call MessageNotify('M', 'aq_test_boundary_grid_1d', &
       'aq_module boundary test(1d) succeded.')

end program aq_test_boundary_grid_1d

!----------------------------------------------------------------------
! Copyright (c) 2007-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム :: 補間関数のテスト
!
!履歴  2007/10/24  竹広真一
!      2009/01/04  竹広真一  spml 書法に反するため複数補間点対応版削除
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_test_interpolate

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_module
  implicit none

  integer, parameter    :: im=32, km=32
  real(8), parameter    :: xmin=-5.0D0, xmax=1.0D0
  ! 補間する点の座標
  real(8), parameter    :: xval=5.0d-1
  !--- Interpolate_t 用
  real(8)                    :: zsol, zint             ! 補間値(正解, 計算値)
  real(8), dimension(0:im)   :: g_z
  !--- a_Interpolate_at 用
  real(8), dimension(2)      :: ysol, yint          ! 補間値(正解, 計算値)
  real(8), dimension(2,0:im) :: ag_y
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11
  !--- 作業変数
  integer :: i

  call MessageNotify('M','at_test_interpolate', &
    & 'Test of Interpolate function')

  do i=1,2
    call at_initial(im,km/i,xmin,xmax)

    !--------- Test of "Interpolate_t" ----------
    g_z = sin(g_X-(xmax+xmin)/3.0d0)
    zsol = sin(xval-(xmax+xmin)/3.0d0)
    zint = Interpolate_t(t_g(g_z),xval)
    call check0d(zint, zsol, 'Test of Interpolate_t')

    !--------- Test of "a_Interpolate_at" ----------
    ag_y(1,:) = cos(g_X-(xmax+xmin)/4.0d0)
    ag_y(2,:) = sin(g_X+(xmax+xmin)/4.0d0)
    ysol(1) =  cos(xval-(xmax+xmin)/4.0d0)
    ysol(2) = sin(xval+(xmax+xmin)/4.0d0)
    yint = a_Interpolate_at(at_ag(ag_y),xval)
    call check1d(yint, ysol, 'Test of a_Interpolate_at')

    call at_Finalize

  enddo

call MessageNotify('M','Test of Interpolate_t', &
  & 'Test of Interpolate function succeeded')

contains
  subroutine check1d(var, true, funcname)
    real(8) :: var(:)
    real(8) :: true(:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,     &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check1d

  subroutine check0d(var0d,true0d, funcname)
    real(8) :: var0d
    real(8) :: true0d
    real(8) :: var_tmp(1)
    real(8) :: true_tmp(1)
    character(len=*), optional :: funcname

    var_tmp(1) = var0d
    true_tmp(1) = true0d
    call check1d(var_tmp, true_tmp, funcname)
  end subroutine check0d


end program at_test_interpolate

!----------------------------------------------------------------------
! Copyright (c) 2019-2020 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  ua_integral_mpi_module_mint
!
!  spml/ua_integral_mpi_module_mint モジュールは球面上での流体運動を
!  球面調和函数と MPI 並列ライブラリを用いたスペクトル法によって
!  数値計算するための モジュール ua_mpi_module_sypack の下部モジュールであり,
!  積分・平均計算のための Fortran90 関数を提供する.
!
!  球面上の 1 層モデル用 u_integral_module_sypack モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!
!
!履歴  2019/05/01  竹広真一
!      2020/08/04  竹広真一  pva 変数の積分を追加
!
module ua_mpi_module_integral_mint
  !
  ! ua_mpi_module_integral_mint
  !
  !  spml/ua_mpi_module_integral_mint モジュールは球面上での流体運動を
  !  球面調和函数と MPI 並列ライブラリを用いたスペクトル法によって
  !  数値計算するための モジュール ua_mpi_module の下部モジュールであり,
  !  積分・平均計算のための Fortran90 関数を提供する.
  !
  !  球面上の 1 層モデル用 u_integral_module モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
  !
  !
  use mpi
  use w_mpi_module_base_mint, only : im
  use w_mpi_module_mint, only : IntLat_v, AvrLat_v
  use ua_mpi_module_base_mint, only : MPI_COMM_H, MPI_COMM_V, &
       ic, p_Lon_Weight, x_Lon_Weight, jc, v_Lat_Weight

  implicit none
  integer :: ierr

  private

  public a_IntLonLat_pva, IntLonLat_pv        ! 緯度経度積分
  public va_IntLon_pva, a_IntLon_pa, IntLon_p ! 経度積分
  public pa_IntLat_pva, a_IntLat_va           ! 緯度積分
  public a_AvrLonLat_pva, AvrLonLat_pv        ! 緯度経度平均
  public va_AvrLon_pva, a_AvrLon_pa, AvrLon_p ! 経度平均
  public pa_AvrLat_pva, a_AvrLat_va           ! 緯度平均

  public b_IntLonLat_xvb                      ! 緯度経度積分
  public vb_IntLon_xvb, b_IntLon_xb           ! 経度積分
  public xb_IntLat_xvb, b_IntLat_vb           ! 緯度積分
  public b_AvrLonLat_xvb                      ! 緯度経度平均
  public vb_AvrLon_xvb, b_AvrLon_xb           ! 経度平均
  public xb_AvrLat_xvb, b_AvrLat_vb           ! 緯度平均

contains

  !--------------- 積分計算 (pva) -----------------
  function a_IntLonLat_pva(pva_data)
    !
    ! 2 次元緯度経度格子点データの全領域積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算している.
    !
    real(8), intent(in)   :: pva_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:ic-1,jc,*)

    real(8) :: a_IntLonLat_pva(size(pva_data,3))
    !(out) 積分されたデータの並び(*)

    a_IntLonLat_pva = a_IntLon_pa(pa_IntLat_pva(pva_data))
  end function a_IntLonLat_pva

  function IntLonLat_pv(pv_data)
    !
    ! 2 次元緯度経度格子点データの全領域積分(一層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算している.
    !
    real(8), intent(in)   :: pv_data(:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:ic-1,jc)

    real(8) :: IntLonLat_pv
    !(out) 積分されたデータの並び(*)

    IntLonLat_pv = IntLat_v(a_IntLon_pa(pv_Data))
  end function IntLonLat_pv

  function pa_IntLat_pva(pva_data)
    !
    ! 2 次元緯度経度格子点データの緯度(Y)方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: pva_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8)             :: pa_IntLat_pva(0:ic-1,size(pva_data,3))
    !(out) 積分された 1 次元経度(X)格子点データの並び

    real(8)             :: pa_IntLatTmp(0:ic-1,size(pva_data,3))
    Integer :: j

    pa_IntLat_pva = 0
    do j=1,jc
       pa_IntLat_pva = pa_IntLat_pva + pva_data(:,j,:) * v_Lat_Weight(j)
    enddo

    pa_IntLatTmp=pa_IntLat_pva
    CALL MPI_ALLREDUCE(pa_IntLatTMP,pa_IntLat_pva,ic*size(pva_data,3),&
         MPI_REAL8, MPI_SUM,MPI_COMM_H,IERR)

  end function pa_IntLat_pva

  function va_IntLon_pva(pva_data)
    !
    ! 2 次元緯度経度格子点データの経度(X)方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: pva_data(0:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:ic-1,jc,*)

    real(8)             :: va_IntLon_pva(jc,size(pva_data,3))
    !(out) 積分された 1 次元緯度(Y)格子点データの並び

    real(8)             :: va_IntLonTmp(jc,size(pva_data,3))
    integer :: i

    va_IntLon_pva = 0
    do i=0,ic-1
       va_IntLon_pva = va_IntLon_pva + pva_data(i,:,:) * p_Lon_Weight(i)
    enddo

    va_IntLonTmp=va_IntLon_pva
    CALL MPI_ALLREDUCE(va_IntLonTMP,va_IntLon_pva,jc*size(pva_data,3),&
         MPI_REAL8, MPI_SUM, MPI_COMM_V, IERR)

  end function va_IntLon_pva

  function a_IntLon_pa(pa_data)          ! 経度積分
    !
    ! 1 次元経度(X)格子点データの X 方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: pa_data(0:,:)
    !(in)  1 次元経度(X)格子点データの並び(0:ic-1,*)
    real(8)             :: a_IntLon_pa(size(pa_data,2))
    !(out) 積分値の並び(*)
    integer :: i

    real(8)             :: a_IntLonTmp(size(pa_data,2))

    a_IntLon_pa = 0.0D0
    do i=0,ic-1
       a_IntLon_pa = a_IntLon_pa + pa_data(i,:) * p_Lon_Weight(i)
    enddo

    a_IntLonTmp = a_IntLon_pa
    CALL MPI_ALLREDUCE(a_IntLonTMP,a_IntLon_pa,size(pa_data,2),&
         MPI_REAL8, MPI_SUM, MPI_COMM_V, IERR)

  end function a_IntLon_pa

  function IntLon_p(p_data)          ! 経度積分
    !
    ! 1 次元経度(X)格子点データの X 方向積分(一層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: p_data(:)
    !(in)  1 次元経度(X)格子点データの並び(0:ic-1,*)
    real(8)             :: IntLon_p
    !(out) 積分値の並び(*)

    real(8)             :: IntLonTmp

    IntLonTmp= sum(p_data*p_Lon_Weight)

    CALL MPI_ALLREDUCE(IntLonTMP,IntLon_p,1,&
         MPI_REAL8, MPI_SUM, MPI_COMM_V, IERR)

  end function IntLon_p

  function a_IntLat_va(va_data)
    !
    ! 1 次元緯度(Y)格子点データの Y 方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: va_data(:,:)
    !(in)  1 次元緯度(Y)格子点データの並び(jc,*)

    real(8)             :: a_IntLat_va(size(va_data,2))
    !(out) 積分値の並び(*)

    real(8)             :: a_IntLatTmp(size(va_data,2))
    integer :: j

    a_IntLat_va = 0
    do j=1,jc
       a_IntLat_va = a_IntLat_va + va_data(j,:) * v_Lat_Weight(j)
    enddo

    a_IntLatTmp=a_IntLat_va
    CALL MPI_ALLREDUCE(a_IntLatTMP,a_IntLat_va,size(va_data,2),MPI_REAL8, &
         MPI_SUM,MPI_COMM_H,IERR)

  end function a_IntLat_va

  !--------------- 平均計算 (pva) -----------------
  function a_AvrLonLat_pva(pva_data)
    !
    ! 2 次元緯度経度格子点データの全領域平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している.
    !
    real(8), intent(in)   :: pva_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8) :: a_AvrLonLat_pva(size(pva_data,3))
    !(out) 平均値の並び(*)

    a_AvrLonLat_pva = a_AvrLon_pa(pa_AvrLat_pva(pva_data))
  end function a_AvrLonLat_pva

  function AvrLonLat_pv(pv_data)
    !
    ! 2 次元緯度経度格子点データの全領域平均(一層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している.
    !
    real(8), intent(in)   :: pv_data(:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:ic-1,jc,*)

    real(8) :: AvrLonLat_pv
    !(out) 平均値の並び(*)

    AvrLonLat_pv = AvrLat_v(a_AvrLon_pa(pv_data))
  end function AvrLonLat_pv

  function pa_AvrLat_pva(pva_data)
    !
    ! 2 次元緯度経度格子点データの緯度(Y)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
    ! y_Y_Weight の総和で割ることで平均している.
    !
    real(8), intent(in) :: pva_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8)             :: pa_AvrLat_pva(0:ic-1,size(pva_data,3))
    !(out) 平均された 1 次元経度(X)格子点データの並び(0:im-1,*)

    real(8)             :: Tmp
    real(8)             :: Lat_Weight_Sum

    Tmp = sum(v_Lat_weight)
    CALL MPI_ALLREDUCE(TMP,Lat_Weight_Sum,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_H,IERR)

    pa_AvrLat_pva = pa_IntLat_pva(pva_data)/Lat_Weight_Sum

  end function pa_AvrLat_pva

  function va_AvrLon_pva(pva_data)
    !
    ! 2 次元緯度経度格子点データの経度(X)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
    ! x_X_Weight の総和で割ることで平均している.
    !
    real(8), intent(in) :: pva_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8)             :: va_AvrLon_pva(jc,size(pva_data,3))
    !(out) 平均された 1 次元緯度(Y)格子点の並び(jc,*)

    real(8)             :: Tmp
    real(8)             :: Lon_Weight_Sum

    Tmp = sum(p_Lon_weight)
    CALL MPI_ALLREDUCE(TMP,Lon_Weight_Sum,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_V,IERR)

    va_AvrLon_pva = va_IntLon_pva(pva_data)/Lon_Weight_Sum

  end function va_AvrLon_pva

  function a_AvrLon_pa(pa_data)          ! 経度平均
    !
    ! 1 次元(X)格子点データの経度(X)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
    ! x_X_Weight の総和で割ることで平均している.
    !
    real(8), intent(in) :: pa_data(0:,:)
    !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)

    real(8)             :: a_AvrLon_pa(size(pa_data,2))
    !(out) 平均値の並び(*)

    real(8)             :: Tmp
    real(8)             :: Lon_Weight_Sum

    Tmp = sum(p_Lon_weight)
    CALL MPI_ALLREDUCE(TMP,Lon_Weight_Sum,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_V,IERR)

    a_AvrLon_pa = a_IntLon_pa(pa_data)/Lon_Weight_Sum

  end function a_AvrLon_pa

  function AvrLon_p(p_data)          ! 経度積分
    !
    ! 1 次元経度(X)格子点データの X 方向積分(一層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: p_data(:)
    !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)
    real(8)             :: AvrLon_p
    !(out) 積分値の並び(*)

    real(8)             :: Tmp
    real(8)             :: Lon_Weight_Sum

    Tmp = sum(p_Lon_weight)
    CALL MPI_ALLREDUCE(TMP,Lon_Weight_Sum,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_V,IERR)

    AvrLon_p = IntLon_p(p_data)/Lon_Weight_Sum

  end function AvrLon_p

  function a_AvrLat_va(va_data)
    !
    ! 1 次元(Y)格子点データの緯度(Y)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
    ! y_Y_Weight の総和で割ることで平均している.
    !
    real(8), intent(in) :: va_data(:,:)
    !(in)  1 次元緯度格子点データの並び(jc,*)

    real(8)             :: a_AvrLat_va(size(va_data,2))
    !(out) 平均値の並び(*)

    real(8)             :: Tmp
    real(8)             :: Lat_Weight_Sum

    Tmp = sum(v_Lat_weight)
    CALL MPI_ALLREDUCE(TMP,Lat_Weight_Sum,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_H,IERR)

    a_AvrLat_va = a_IntLat_va(va_data)/Lat_Weight_Sum

  end function a_AvrLat_va

  !--------------- 積分計算 (xvb) -----------------
  function b_IntLonLat_xvb(xvb_data)
    !
    ! 2 次元緯度経度格子点データの全領域積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算している.
    !
    real(8), intent(in)   :: xvb_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8) :: b_IntLonLat_xvb(size(xvb_data,3))
    !(out) 積分されたデータの並び(*)

    b_IntLonLat_xvb = b_IntLon_xb(xb_IntLat_xvb(xvb_data))
  end function b_IntLonLat_xvb

  function xb_IntLat_xvb(xvb_data)
    !
    ! 2 次元緯度経度格子点データの緯度(Y)方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: xvb_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8)             :: xb_IntLat_xvb(0:im-1,size(xvb_data,3))
    !(out) 積分された 1 次元経度(X)格子点データの並び

    real(8)             :: xb_IntLatTmp(0:im-1,size(xvb_data,3))
    Integer :: j

    xb_IntLat_xvb = 0
    do j=1,jc
       xb_IntLat_xvb = xb_IntLat_xvb + xvb_data(:,j,:) * v_Lat_Weight(j)
    enddo

    xb_IntLatTmp=xb_IntLat_xvb
    CALL MPI_ALLREDUCE(xb_IntLatTMP,xb_IntLat_xvb,int(im)*size(xvb_data,3),&
         MPI_REAL8, MPI_SUM,MPI_COMM_H,IERR)

  end function xb_IntLat_xvb

  function vb_IntLon_xvb(xvb_data)
    !
    ! 2 次元緯度経度格子点データの経度(X)方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: xvb_data(0:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8)             :: vb_IntLon_xvb(jc,size(xvb_data,3))
    !(out) 積分された 1 次元緯度(Y)格子点データの並び

    integer :: i

    vb_IntLon_xvb = 0
    do i=0,int(im)-1
       vb_IntLon_xvb = vb_IntLon_xvb + xvb_data(i,:,:) * x_Lon_Weight(i)
    enddo

  end function vb_IntLon_xvb

  function b_IntLon_xb(xb_data)          ! 経度積分
    !
    ! 1 次元経度(X)格子点データの X 方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: xb_data(0:,:)
    !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)
    real(8)             :: b_IntLon_xb(size(xb_data,2))
    !(out) 積分値の並び(*)
    integer :: i

    b_IntLon_xb = 0.0D0
    do i=0,int(im)-1
       b_IntLon_xb = b_IntLon_xb + xb_data(i,:) * x_Lon_Weight(i)
    enddo

  end function b_IntLon_xb

  function b_IntLat_vb(vb_data)
    !
    ! 1 次元緯度(Y)格子点データの Y 方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
    !
    real(8), intent(in) :: vb_data(:,:)
    !(in)  1 次元緯度(Y)格子点データの並び(jc,*)

    real(8)             :: b_IntLat_vb(size(vb_data,2))
    !(out) 積分値の並び(*)

    real(8)             :: b_IntLatTmp(size(vb_data,2))
    integer :: j

    b_IntLat_vb = 0
    do j=1,jc
       b_IntLat_vb = b_IntLat_vb + vb_data(j,:) * v_Lat_Weight(j)
    enddo

    b_IntLatTmp=b_IntLat_vb
    CALL MPI_ALLREDUCE(b_IntLatTMP,b_IntLat_vb,size(vb_data,2),MPI_REAL8, &
         MPI_SUM,MPI_COMM_H,IERR)

  end function b_IntLat_vb

  !--------------- 平均計算 (xvb) -----------------
  function b_AvrLonLat_xvb(xvb_data)
    !
    ! 2 次元緯度経度格子点データの全領域平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している.
    !
    real(8), intent(in)   :: xvb_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8) :: b_AvrLonLat_xvb(size(xvb_data,3))
    !(out) 平均値の並び(*)

    b_AvrLonLat_xvb = b_AvrLon_xb(xb_AvrLat_xvb(xvb_data))
  end function b_AvrLonLat_xvb

  function xb_AvrLat_xvb(xvb_data)
    !
    ! 2 次元緯度経度格子点データの緯度(Y)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
    ! y_Y_Weight の総和で割ることで平均している.
    !
    real(8), intent(in) :: xvb_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8)             :: xb_AvrLat_xvb(0:im-1,size(xvb_data,3))
    !(out) 平均された 1 次元経度(X)格子点データの並び(0:im-1,*)

    real(8)             :: Tmp
    real(8)             :: Lat_Weight_Sum

    Tmp = sum(v_Lat_weight)
    CALL MPI_ALLREDUCE(TMP,Lat_Weight_Sum,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_H,IERR)

    xb_AvrLat_xvb = xb_IntLat_xvb(xvb_data)/Lat_Weight_Sum

  end function xb_AvrLat_xvb

  function vb_AvrLon_xvb(xvb_data)
    !
    ! 2 次元緯度経度格子点データの経度(X)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
    ! x_X_Weight の総和で割ることで平均している.
    !
    real(8), intent(in) :: xvb_data(:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

    real(8)             :: vb_AvrLon_xvb(jc,size(xvb_data,3))
    !(out) 平均された 1 次元緯度(Y)格子点の並び(jc,*)

    vb_AvrLon_xvb = vb_IntLon_xvb(xvb_data)/sum(x_Lon_Weight)

  end function vb_AvrLon_xvb

  function b_AvrLon_xb(xb_data)          ! 経度平均
    !
    ! 1 次元(X)格子点データの経度(X)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
    ! x_X_Weight の総和で割ることで平均している.
    !
    real(8), intent(in) :: xb_data(0:,:)
    !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)

    real(8)             :: b_AvrLon_xb(size(xb_data,2))
    !(out) 平均値の並び(*)

    b_AvrLon_xb = b_IntLon_xb(xb_data)/sum(x_Lon_Weight)

  end function b_AvrLon_xb

  function b_AvrLat_vb(vb_data)
    !
    ! 1 次元(Y)格子点データの緯度(Y)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
    ! y_Y_Weight の総和で割ることで平均している.
    !
    real(8), intent(in) :: vb_data(:,:)
    !(in)  1 次元緯度格子点データの並び(jc,*)

    real(8)             :: b_AvrLat_vb(size(vb_data,2))
    !(out) 平均値の並び(*)

    real(8)             :: Tmp
    real(8)             :: Lat_Weight_Sum

    Tmp = sum(v_Lat_weight)
    CALL MPI_ALLREDUCE(TMP,Lat_Weight_Sum,1,MPI_REAL8, &
         MPI_SUM,MPI_COMM_H,IERR)

    b_AvrLat_vb = b_IntLat_vb(vb_data)/Lat_Weight_Sum

  end function b_AvrLat_vb

end module ua_mpi_module_integral_mint

!--
!----------------------------------------------------------------------
!     Copyright (c) 2020 SPMDOEL Development Group
!----------------------------------------------------------------------
!表題  wa_wave_base_module
!
!  spml/wa_wave_module_base モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって東西 1 波数数値計算するための 
!  モジュール wa_wave_module の下部モジュールであり, スペクトル計算の
!  基本的な Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_wave_module_base モジュールを
!  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
!  格子点データに対する変換が行える.
!
!  内部で ISPACK3 の LXPACK の Fortran サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある. 
!
!
!履歴
!      2020/11/24  竹広真一  wa_wave_base_module_svpack より改造
!
!++
module wa_wave_module_base
  !
  != wa_wave_module_base
  !

  !== 概要
  !
  !  spml/wa_wave_module_base モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって東西 1 波数数値計算するための 
  !  モジュール wa_wave_module の下部モジュールであり, スペクトル計算の
  !  基本的な Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_wave_module_base モジュールを
  !  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
  !  格子点データに対する変換が行える.
  !
  !  内部で ISPACK3 の LXPACK の Fortran サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
  !
  !  このモジュールを使うためには前もって w_base_initial を呼んで
  !  切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message
  use w_wave_module_base, only : im, jm, m, nm=>nn, xy_w, w_xy

  implicit none

  integer               :: km=16         ! 同時に処理する最大データ数(層の数).
                                         ! SNPACK 用ルーチンとの互換性のため.
                                         ! wa_base_module では
                                         ! このパラメタによる制限がない.

  private

  public km                                    ! 層数
  public wa_base_Initial                       ! 初期化サブルーチン
  public wa_base_Finalize                      ! 終了処理

  public xya_wa, wa_xya                        ! 変換関数

  save km                                      ! 最大データ数(層数)を記憶

contains
  !--------------- 初期化 -----------------
  subroutine wa_base_initial(k_in)
    ! 
    ! SNPACK 用 wa_base_initial の互換のためのダミーサブルーチン
    !
    integer,intent(in) :: k_in               !(in) 最大データ数(層数)

    km = k_in

    call MessageNotify('M','wa_base_initial',&
         'No need to set maximum level number and in wa_wave_module_base (2020/11/24) ')

  end subroutine wa_base_Initial

  !--------------- 基本変換 -----------------

  function xya_wa(wa_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
    !
    ! スペクトルデータから格子データへ変換する(多層用).
    !
    real(8), intent(in)   :: wa_data(:,:)
    !(in) スペクトルデータ(2*(nm-m+1))
    !
    real(8)               :: xya_wa(0:im-1,1:jm,size(wa_data,2))
    !(out) 格子点データ(0:im-1,1:jm,:)
    !
    integer, intent(in), optional  :: ipow
    !(in) 作用させる 1/cosφ の次数. 省略時は 0. 
    integer, intent(in), optional  :: iflag
    !(in) 変換の種類
    !    0 : 通常の正変換
    !   -1 : 経度微分を作用させた逆変換
    !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
    !    2 : sinφを作用させた逆変換
    !    省略時は 0.
    !
    integer, parameter  :: ipow_default  = 0
    integer, parameter  :: iflag_default = 0
    integer ipval, ifval
    integer k

    if (present(ipow)) then
       ipval = ipow
    else
       ipval = ipow_default
    endif

    if (present(iflag)) then
       ifval = iflag
    else
       ifval = iflag_default
    endif

    do k=1,size(wa_data,2)
       xya_wa(:,:,k) = xy_w(wa_data(:,k),iflag=ifval,ipow=ipval)
    enddo

  end function xya_wa

  function wa_xya(xya_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
    !
    ! 格子データからスペクトルデータへ(正)変換する(多層用).
    !
    real(8), intent(in)   :: xya_data(0:,:,:)
    !(in) 格子点データ(0:im-1,1:jm,:)

    real(8)               :: wa_xya(2*(nm-m+1),size(xya_data,3))
    !(out) スペクトルデータ(2*(nm-m+1),:)

    integer, intent(in), optional  :: ipow
    !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

    integer, intent(in), optional  :: iflag
    ! 変換の種類
    !    0 : 通常の正変換
    !   -1 : 経度微分を作用させた正変換 
    !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
    !    2 : sinφを作用させた正変換
    !  省略時は 0.
    !
    integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
    integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

    integer ipval, ifval
    integer k

    if (present(ipow)) then
       ipval = ipow
    else
       ipval = ipow_default
    endif

    if (present(iflag)) then
       ifval = iflag
    else
       ifval = iflag_default
    endif

    do k=1,size(xya_data,3)
       wa_xya(:,k) = w_xy(xya_data(:,:,k),iflag=ifval,ipow=ipval)
    enddo

  end function wa_xya

  !--------------- 終了処理 -----------------
  subroutine wa_base_Finalize
    ! 
    !
    ! このサブルーチンを単独で用いるのでなく, 
    ! 上位サブルーチン wa_Finalize を使用すること.
    !
    call MessageNotify('M','wa_base_finalize',&
         'wa_wave_module_base is finalized (dummy, 2020/11/24) ')

  end subroutine wa_base_Finalize

end module wa_wave_module_base

!--
!----------------------------------------------------------------------
! Copyright(c) 2008-2025 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  aq_module
!
!      spml/aq_module モジュールは 1 次元有限領域の下での流体運動を
!      Matsushima and Marcus (1994) で提唱された多項式を用いた
!      スペクトル数値計算ための Fortran90 関数を提供する.
!      このルーチンは離散化にチェビシェフ--ガウス--ラダウ格子点を適用
!      しており, 主に 2 次元極座標,  円筒座標, 球座標の原点の
!      特異性を回避しながらスペクトル計算を行うために用いることを
!      念頭においている.
!
!      2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
!      関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
!
!      Matsushima and Marcus (1994) の多項式に関する説明は
!      doc/spectral_radial.tex を参照のこと.
!
!++
module aq_module
  !
  != aq_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/aq_module モジュールは 1 次元有限領域の下での流体運動を
  ! Matsushima and Marcus (1994) で提唱された多項式を用いたスペクトル法によって
  ! 数値計算するための Fortran90 関数を提供する.
  !
  ! このルーチンは離散化にチェビシェフ--ガウス--ラダウ格子点を適用して
  ! おり, 主に 2 次元極座標, 円筒座標, 球座標の原点の特異性を回避しな
  ! がらスペクトル計算を行うために用いることを念頭においている.
  !
  ! 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
  ! 関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
  !
  ! Matsushima and Marcus (1994) の多項式に関する説明は
  ! 動径座標のスペクトル法(spectral_radial.pdf[link:spectral_radial.pdf])
  ! を参照のこと.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (u_, g_, aq_, ag_) は, 返す値の形を示している.
  !   複数並んだ 2 次元データの第 1 次元の大きさは aq_Initialize で
  !   設定する重みの指数の配列 nd の大きさと同じでなければならない.
  !   q_  :: スペクトルデータ
  !   g_  :: 1 次元格子点データ
  !   aq_ :: 1 次元スペクトルデータが複数並んだ 2 次元データ
  !   ag_ :: 1 次元格子点データが複数並んだ 2 次元データ.
  !
  ! * 関数名の間の文字列(Dr)は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_e, _aq, _g, _ag) は, 入力変数の形がスペクトルデータ
  !   および格子点データであることを示している.
  !   _q  :: スペクトルデータ
  !   _g  :: 1 次元格子点データ
  !   _aq :: 1 次元スペクトルデータが複数並んだ 2 次元データ
  !   _ag :: 1 次元格子点データが複数並んだ 2 次元データ
  !
  !=== 各データの種類の説明
  !
  ! * g : 1 次元格子点データ.
  !   * 変数の種類と次元は real(DP), dimension(im).
  !   * im は R 座標の格子点数であり, サブルーチン aq_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * q : スペクトルデータ.
  !   * 変数の種類と次元は real(DP), dimension(0:km).
  !   * km は R 方向の最大波数であり, サブルーチン aq_Initial にて
  !     あらかじめ設定しておく. スペクトルデータのq(l) には
  !     nd+2l 次の多項式成分が格納されている.
  !
  ! * ag : 1 次元(R)格子点データの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(DP), dimension(size(nd),im).
  !     第 2 次元が R 方向を表す.
  !
  ! * aq : 1 次元スペクトルデータの並んだ 2 次元データ.
  !   * 変数の種類と次元は real(DP), dimension(size(nd),0:km).
  !     第 2 次元がスペクトルを表す.
  !
  ! * g_ で始まる関数が返す値は 1 次元格子点データに同じ.
  !
  ! * q_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * ag_ で始まる関数が返す値は 1 次元格子点データの並んだ
  !   2 次元データに同じ.
  !
  ! * aq_ で始まる関数が返す値は 1 次元スペクトルデータの並んだ
  !   2 次元データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したもののことである.
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! aq_Initial  :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! g_R        :: 格子点座標(R)を格納した 1 次元配列
  ! g_R_Weight :: 重み座標を格納した 1 次元配列
  !
  !==== 基本変換
  !
  ! g_q, ag_aq :: スペクトルデータから格子データへの変換
  ! q_g, aq_ag :: 格子データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! q_rDr_q, aq_rDr_aq :: スペクトルデータに r(d/dR) 微分を作用させる
  !
  !==== 積
  !
  ! q_r2_q,    aq_r2_aq    :: スペクトルデータに r^2 をかける
  ! q_r2Inv_q, aq_r2Inv_aq :: スペクトルデータに r^-2 をかける
  !
  !==== 積分・平均
  !
  ! a_Int_ag, a_Avr_ag :: 1 次元格子点データの並んだ 2 次元配列の積分および平均
  ! Int_g, Avr_g       :: 1 次元格子点データの積分および平均
  !
  !==== 境界値問題
  !
  ! aq_Boundary_D, aq_Boundary_N         :: 外側ディリクレ条件, ノイマン条件
  ! aq_BoundaryTau_D, aq_BoundaryTau_N   :: 外側ディリクレ条件,
  !                                         ノイマン条件(タウ法)
  ! ag_BoundaryGrid_D, ag_BoundaryGrid_N :: 外側ディリクレ条件,
  !                                         ノイマン条件(選点法)
  !
  use dc_types, only: DP
  use dc_message
  use lumatrix
  implicit none

  private

  public aq_Initial
  public aq_Initialize                        ! 初期化
  public aq_Finalize                          ! 終了処理
  public g_R, g_R_Weight                      ! 座標変数

  public ag_aq, aq_ag, g_q, q_g               ! 基本変換

  public aq_rDr_aq, q_rDr_q                   ! 微分
  public aq_r2_aq, q_r2_q                     ! 積
  public aq_r2Inv_aq, q_r2Inv_q               ! 積

  public a_Int_ag, a_Avr_ag                   ! 積分・平均
  public Int_g, Avr_g                         ! 積分・平均

  public aq_Boundary_D, aq_Boundary_N         ! 境界条件
  public aq_BoundaryTau_D, aq_BoundaryTau_N   ! 境界条件
  public ag_BoundaryGrid_D, ag_BoundaryGrid_N ! 境界条件

  interface aq_Initialize
    module procedure aq_Initialize_I4
    module procedure aq_Initialize_I8
  end interface aq_Initialize

  interface aq_Boundary_D
    !
    ! 外側境界ディリクレ型境界条件の適用(タウ法).
    !
    ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
    !   使い分けている. ユーザーインターフェースは共通であるので
    !   下部ルーチンを呼ぶ必要はない.
    !
    ! 引数と結果の型
    !
    ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
    !
    !   real(DP), dimension(size(md),0:km),intent(inout)   :: aq_data
    !   !(inout) 境界条件を適用するスペクトルデータ
    !
    !   real(DP), dimension(size(md)), intent(in), optional :: value
    !   !(in) 適用する境界値
    !
    ! * 1 次元チェビシェフデータの場合
    !
    !   real(DP), dimension(0:km),intent(inout)       :: q_data
    !   !(inout) 境界条件を適用するスペクトルデータ
    !
    !   real(DP), intent(in), optional                :: value
    !   !(in) 適用する境界値
    !
    module procedure aq_BoundaryTau_D_1d, aq_BoundaryTau_D_2d
  end interface aq_Boundary_D

  interface aq_Boundary_N
    !
    ! 外側境界ノイマン型境界条件の適用(タウ法).
    !
    ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
    !   使い分けている. ユーザーインターフェースは共通であるので
    !   下部ルーチンを呼ぶ必要はない.
    !
    ! 引数と結果の型
    !
    ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
    !
    !   real(DP), dimension(size(md),0:km),intent(inout)    :: aq_data
    !   !(inout) 境界条件を適用するスペクトルデータ
    !
    !   real(DP), dimension(size(md)), intent(in), optional :: value
    !   !(in) 適用する境界値
    !
    ! * 1 次元チェビシェフデータの場合
    !
    !   real(DP), dimension(0:km),intent(inout)       :: q_data
    !   !(inout) 境界条件を適用するスペクトルデータ
    !
    !   real(DP), intent(in), optional                :: value
    !   !(in) 適用する境界値
    !
    module procedure aq_BoundaryTau_N_1d, aq_BoundaryTau_N_2d
  end interface aq_Boundary_N

  interface aq_BoundaryTau_D
    !
    ! 外側境界ディリクレ型境界条件の適用(タウ法).
    !
    ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
    !   使い分けている. ユーザーインターフェースは共通であるので
    !   下部ルーチンを呼ぶ必要はない.
    !
    ! 引数と結果の型
    !
    ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
    !
    !   real(DP), dimension(size(md),0:km),intent(inout)    :: aq_data
    !   !(inout) 境界条件を適用するチェビシェフデータ
    !
    !   real(DP), dimension(size(md)), intent(in), optional :: value
    !   !(in) 適用する境界値
    !
    ! * 1 次元スペクトルデータの場合
    !
    !   real(DP), dimension(0:km),intent(inout)       :: q_data
    !   !(inout) 境界条件を適用するチェビシェフデータ
    !
    !   real(DP), intent(in), optional                :: value
    !   !(in) 適用する境界値
    !
    module procedure aq_BoundaryTau_D_1d, aq_BoundaryTau_D_2d
  end interface aq_BoundaryTau_D

  interface aq_BoundaryTau_N
    !
    ! 外側境界ノイマン型境界条件の適用(タウ法).
    !
    ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
    !   使い分けている. ユーザーインターフェースは共通であるので
    !   下部ルーチンを呼ぶ必要はない.
    !
    ! 引数と結果の型
    !
    ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
    !
    !   real(DP), dimension(size(md),0:km),intent(inout)    :: aq_data
    !   !(inout) 境界条件を適用するチェビシェフデータ
    !
    !   real(DP), dimension(size(md)), intent(in), optional :: value
    !   !(in) 適用する境界値
    !
    ! * 1 次元スペクトルデータの場合
    !
    !   real(DP), dimension(0:km),intent(inout)       :: q_data
    !   !(inout) 境界条件を適用するチェビシェフデータ
    !
    !   real(DP), intent(in), optional                :: value
    !   !(in) 適用する境界値
    !
    module procedure aq_BoundaryTau_N_1d, aq_BoundaryTau_N_2d
  end interface aq_BoundaryTau_N

  interface ag_BoundaryGrid_D
    !
    ! 外側境界ディリクレ型境界条件の適用(選点法).
    !
    ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
    !   使い分けている. ユーザーインターフェースは共通であるので
    !   下部ルーチンを呼ぶ必要はない.
    !
    ! 引数と結果の型
    !
    ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
    !
    !   real(DP), dimension(size(md),0:km),intent(inout)    :: aq_data
    !   !(inout) 境界条件を適用するチェビシェフデータ
    !
    !   real(DP), dimension(size(md)), intent(in), optional :: value
    !   !(in) 適用する境界値
    !
    ! * 1 次元スペクトルデータの場合
    !
    !   real(DP), dimension(0:km),intent(inout)       :: q_data
    !   !(inout) 境界条件を適用するチェビシェフデータ
    !
    !   real(DP), intent(in), optional                :: value
    !   !(in) 適用する境界値
    !
    module procedure ag_BoundaryGrid_D_1d, ag_BoundaryGrid_D_2d
  end interface ag_BoundaryGrid_D

  interface ag_BoundaryGrid_N
    !
    ! 外側境界ノイマン型境界条件の適用(選点法).
    !
    ! * 境界条件を適用する配列の次元によって内部でサブルーチンを
    !   使い分けている. ユーザーインターフェースは共通であるので
    !   下部ルーチンを呼ぶ必要はない.
    !
    ! 引数と結果の型
    !
    ! * 1 次元スペクトルデータの並んだ 2 次元配列の場合
    !
    !   real(DP), dimension(size(md),0:km),intent(inout)    :: aq_data
    !   !(inout) 境界条件を適用するチェビシェフデータ
    !
    !   real(DP), dimension(size(md)), intent(in), optional :: value
    !   !(in) 適用する境界値
    !
    ! * 1 次元スペクトルデータの場合
    !
    !   real(DP), dimension(0:km),intent(inout)       :: q_data
    !   !(inout) 境界条件を適用するチェビシェフデータ
    !
    !   real(DP), intent(in), optional                :: value
    !   !(in) 適用する境界値
    !
    module procedure ag_BoundaryGrid_N_1d, ag_BoundaryGrid_N_2d
  end interface ag_BoundaryGrid_N

  integer(8) :: im, km                   ! 格子点数, 切断波数
  real(DP) :: ra                         ! 領域の大きさ

  real(DP) :: alpha                      ! 展開多項式パラメター  0 < α <= 1
  real(DP) :: beta                       ! 展開多項式パラメター  0 < β
  real(DP) :: gamma                      ! 展開多項式パラメター  γ=2α+β
  integer(8), allocatable :: md(:)       ! 展開多項式上付次数のならび

  integer(8) :: jmax                     ! a 座標(データ第 1 次元)の大きさ

  real(DP), allocatable :: g_R(:)        ! ガウス--ラダウ格子点
  real(DP), allocatable :: g_R_Weight(:) ! ガウス重み

  real(DP), allocatable :: CF(:, :, :)   ! 正変換用行列
  real(DP), allocatable :: CB(:, :, :)   ! 逆変換用行列

  logical :: first_r2inv = .true.
  logical :: first_Tau_D = .true.
  logical :: first_Tau_N = .true.
  logical :: first_Grid_N = .true.

  save im, km, ra, alpha, beta, gamma, CF, CB, g_R, g_R_Weight, md, jmax
  save first_r2inv, first_Tau_D, first_Tau_N, first_Grid_N

contains

  ! --------------------------------------------------------------------------
  subroutine aq_Initial(i, k, r, a, b, m)
    integer, intent(in) :: i, k
    integer, dimension(:), intent(in) :: m
    real(DP), intent(in) :: a, b, r

    call MessageNotify('W', 'aq_Initial', &
      & 'aq_Initial is deprecated; will be removed; use aq_Initialize.')

    call aq_Initialize_I8(int(i, kind(im)), int(k, kind(km)), r, a, b, int(m, kind(md)))

  end subroutine aq_Initial

  ! --------------------------------------------------------------------------
  subroutine aq_Initialize_I4(i, k, r, a, b, m)
    integer, intent(in) :: i, k
    integer, dimension(:), intent(in) :: m
    real(DP), intent(in) :: a, b, r

    call MessageNotify('W', 'aq_Initialize', &
      & 'INTEGER(4) im/km/md deprecated; will be removed; use INTEGER(8).')

    call aq_Initialize_I8(int(i, kind(im)), int(k, kind(km)), r, a, b, int(m, kind(md)))

  end subroutine aq_Initialize_I4

  !--- 初期化 ----------------------------------------------------------------
  subroutine aq_Initialize_I8(i_in, k_in, r_in, alpha_in, beta_in, md_in)
    !
    ! スペクトル変換の格子点数, 波数, 領域の大きさ, 重みを設定する.
    !
    ! 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
    ! 初期設定をしなければならない.
    !
    integer(8), intent(in) :: i_in     !(in) 格子点数
    integer(8), intent(in) :: k_in     !(in) 切断波数
    real(DP), intent(in) :: r_in       !(in) 外側境界の座標(半径)
    real(DP), intent(in) :: alpha_in   !(in) 展開多項式パラメター
    real(DP), intent(in) :: beta_in    !(in) 展開多項式パラメター
    integer(8), intent(in) :: md_in(:) !(in) 展開多項式上付次数のならび

    integer(8) i, j, n, nn

    !--- パラメターのチェック・記憶
    im = i_in
    km = k_in
    ra = r_in
    alpha = alpha_in
    beta = beta_in

    if (km .ge. 2.0_DP * im) then
      call MessageNotify('E', 'aq_initial', 'KM shoud be less than 2*IM')
    end if

    if (alpha .le. 0.0_DP) then
      call MessageNotify('E', 'aq_initial', 'alpha must be larger than 0')
    end if
    if (alpha .gt. 1.0_DP) then
      call MessageNotify('E', 'aq_initial', 'alpha must be smaller equal to 1')
    end if
    if (beta .le. 0.0D0) then
      call MessageNotify('E', 'aq_initial', 'beta must be larger than 0')
    end if

    gamma = 2.0_DP * alpha + beta

    !--- 次数情報の計算
    jmax = size(md_in)
    if (allocated(md)) deallocate (md)
    allocate (md(jmax))

    md = md_in

    !--- 格子点, 重みの設定
    if (allocated(g_R)) deallocate (g_R)
    if (allocated(g_R_Weight)) deallocate (g_R_Weight)
    allocate (g_R(im), g_R_Weight(im))

    call gauss_radau(2 * im, g_R, g_R_Weight)
    g_R = ra * g_R
    g_R_Weight = ra**(gamma - 1) * g_R_Weight

    !--- 変換行列の設定
    if (allocated(CF)) deallocate (CF)
    if (allocated(CB)) deallocate (CB)
    allocate (CF(jmax, 0:km, im), CB(jmax, im, 0:km))

    CF = 0.0D0
    do j = 1, jmax
      do n = 0, km
        nn = n * 2 + md(j)
        do i = 1, im
          CF(j, n, i) = Phi(g_R(i) / ra, nn, md(j)) * g_R_Weight(i) / ra**(gamma - 1)
        end do
      end do
    end do

    CB = 0.0D0
    do j = 1, jmax
      do i = 1, im
        do n = 0, km
          nn = n * 2 + md(j)
          CB(j, i, n) = Phi(g_R(i) / ra, nn, md(j))
        end do
      end do
    end do

    !--- 各ルーチン変換行列の初期化スイッチ

    first_r2inv = .true.
    first_Tau_D = .true.
    first_Tau_N = .true.
    first_Grid_N = .true.

    call MessageNotify(  &
      & 'M', 'aq_Initialize', 'aq_module (2026/02/12) is initialized')

  end subroutine aq_Initialize_I8

  subroutine aq_Finalize

    first_r2inv = .false.
    first_Tau_D = .false.
    first_Tau_N = .false.
    first_Grid_N = .false.

  end subroutine aq_Finalize

  !---- 逆変換 ----
  function ag_aq(aq_data)
    !
    ! スペクトルデータから格子データへ変換する(2 次元配列用).
    !
    real(DP), dimension(:, 0:), intent(in) :: aq_data
    !(in) スペクトルデータ

    real(DP), dimension(size(aq_data, 1), im) :: ag_aq
    !(out) 格子点データ

    integer(8) :: i, j

    if (size(aq_data, 1) /= jmax) then
      call MessageNotify('E', 'ag_aq', &
                         '1st dim. of the spectral data should be same as dim. of MD.')
    end if

    if (size(aq_data, 2) - 1 < km) then
      call MessageNotify('E', 'ag_aq', &
                         'The spectral dimension of input data too small.')
    elseif (size(aq_data, 2) - 1 > km) then
      call MessageNotify('W', 'ag_aq', &
                         'The spectral dimension of input data too large.')
    end if

    ag_aq = 0.0D0
    do i = 1, im
      !$omp parallel do
      do j = 1, jmax
        ag_aq(j, i) = sum(CB(j, i, :) * aq_data(j, :))
      end do
      !$omp end parallel do
    end do

  end function ag_aq

  function g_q(q_data)
    !
    ! スペクトルデータから格子データへ変換する(1 次元配列用).
    !
    real(DP), dimension(:), intent(in) :: q_data
    !(in) スペクトルデータ

    real(DP), dimension(im) :: g_q
    !(out) 格子点データ

    real(DP), dimension(1, size(q_data)) :: q_work
    ! 作業用配列
    real(DP), dimension(1, im) :: g_work
    ! 作業用配列

    q_work(1, :) = q_data
    g_work = ag_aq(q_work)
    g_q = g_work(1, :)

  end function g_q

  !---- 正変換 ----
  function aq_ag(ag_data)
    !
    ! 格子データからスペクトルデータへ変換する(2 次元配列用).
    !
    real(DP), dimension(:, :), intent(in) :: ag_data
    !(in) 格子点データ

    real(DP), dimension(size(ag_data, 1), 0:km) :: aq_ag
    !(out) スペクトルデータ

    integer(8) :: j, n

    if (size(ag_data, 1) /= jmax) then
      call MessageNotify('E', 'aq_ag', &
                         '1st dim. of the grid data should be same as dim. of MD.')
    end if

    if (size(ag_data, 2) < im) then
      call MessageNotify('E', 'aq_ag', &
                         'The Grid points of input data too small.')
    elseif (size(ag_data, 2) > im) then
      call MessageNotify('W', 'aq_ag', &
                         'The Grid points of input data too large.')
    end if

    aq_ag = 0.0D0
    !$omp parallel do private(n)
    do j = 1, jmax
      do n = 0, km
        aq_ag(j, n) = sum(CF(j, n, :) * ag_data(j, :))
      end do
    end do
    !$omp end parallel do

  end function aq_ag

  function q_g(g_data)
    !
    ! 格子データからスペクトルデータへ変換する(1 次元配列用).
    !
    real(DP), dimension(:), intent(in) :: g_data
    !(in) 格子点データ

    real(DP), dimension(0:km) :: q_g
    !(out) スペクトルデータ

    real(DP), dimension(1, size(g_data)) :: ag_work
    real(DP), dimension(1, 0:km) :: aq_work

    ag_work(1, :) = g_data
    aq_work = aq_ag(ag_work)
    q_g = aq_work(1, :)

  end function q_g

  !---- 微分計算 ----
  function aq_rDr_aq(aq_data)
    !
    ! 入力スペクトルデータに対して微分 r(d/dr) のスペクトル係数
    ! を計算する(2 次元配列用).
    !
    !   a_n = aq_data/sqrt(Inm),  b_n = aq_rDr_aq/sqrt(Inm)
    !
    !   b_n = (2n+gamma-1)/(2n+gamma+3)b_n+2
    !       + (2n+gamma-1)(n+gamma+1)/(2n+gamma+3)a_n+2 + n a_n
    !
    real(DP), dimension(:, 0:), intent(in) :: aq_data
    !(in) 入力スペクトルデータ

    real(DP), dimension(size(aq_data, 1), 0:size(aq_data, 2) - 1) :: aq_rDr_aq
    !(out) 出力スペクトルデータ

    integer(8) :: j, n, nn
    real(DP) :: sqInm, sqInm2

    if (size(aq_data, 1) /= jmax) then
      call MessageNotify('E', 'aq_rDr_aq', &
                         '1st dim. of the spectral data should be same as dim. of MD.')
    end if

    if (size(aq_data, 2) - 1 < km) then
      call MessageNotify('E', 'aq_rDr_aq', &
                         'The spectral dimension of input data too small.')
    elseif (size(aq_data, 2) - 1 > km) then
      call MessageNotify('W', 'aq_rDr_aq', &
                         'The spectral dimension of input data too large.')
    end if

    aq_rDr_aq = 0.0D0
    !$omp parallel do private(sqInm,sqInm2,n,nn)
    do j = 1, jmax
      n = md(j) + km * 2
      sqInm = sqrt(Inm(n, md(j)))
      aq_rDr_aq(j, km) = n * aq_data(j, km)

      do nn = km - 1, 0, -1
        n = md(j) + nn * 2
        sqInm2 = sqInm
        sqInm = sqrt(Inm(n, md(j)))

        aq_rDr_aq(j, nn) = sqInm / sqInm2 * ( &
                           (2 * n + gamma - 1) / (2 * n + gamma + 3) * aq_rDr_aq(j, nn + 1) &
                           + (2 * n + gamma - 1) * (n + gamma + 1) / (2 * n + gamma + 3) * aq_data(j, nn + 1)) &
                           + n * aq_data(j, nn)
      end do
    end do
    !$omp end parallel do

  end function aq_rDr_aq

  function q_rDr_q(q_data)
    !
    ! 入力スペクトルデータに r(d/dR) 微分を作用する(1 次元配列用).
    !
    ! スペクトルデータの r(d/dR) 微分とは, 対応する格子点データに R 微分を
    ! 作用させたデータのスペクトル変換のことである.
    !
    !
    real(DP), dimension(:), intent(in) :: q_data
    !(in) 入力チェビシェフデータ

    real(DP), dimension(0:km) :: q_rDr_q
    !(out) チェビシェフデータの R 微分

    real(DP), dimension(1, size(q_data)) :: aq_work
    ! 作業用配列

    aq_work(1, :) = q_data
    aq_work = aq_rDr_aq(aq_work)
    q_rDr_q = aq_work(1, :)

  end function q_rDr_q

  !---- r^2 積計算 ----
  function aq_r2_aq(aq_data)
    !
    ! 入力スペクトルデータに対して積 r^2 のスペクトル係数
    ! を計算する(2 次元配列用).
    !
    !   a_n^m = aq_data/sqrt(Inm),  b_n^m = aq_rDr_aq/sqrt(Inm)
    !
    !   b_n^m = (n-|m|)(n+|m|+beta-1)/((2n+gamma-5)(2n+gamma-3)) a_n-2^m
    !       + (2n(n+gamma-1) + 2|m|(|m|+beta-1)+(gamma-3)(beta+1)
    !            /((2n+gamma+1)(2n+gamma-3)) a_n^m
    !       + (n-|m|+gamma-beta)(n+|m|+gamma-1)
    !            /((2n+gamma+3)(2n+gamma+1)) a_n+2^m
    !
    real(DP), dimension(:, 0:), intent(in) :: aq_data
    !(in) 入力スペクトルデータ

    real(DP), dimension(size(aq_data, 1), 0:size(aq_data, 2) - 1) :: aq_r2_aq
    !(out) 出力スペクトルデータ

    integer(8) :: j, n, m, nn
    real(DP) :: sqrInp2m, sqrInm, sqrInm2m

    if (size(aq_data, 1) /= jmax) then
      call MessageNotify('E', 'aq_r2_aq', &
                         '1st dim. of the spectral data should be same as dim. of MD.')
    end if

    if (size(aq_data, 2) - 1 < km) then
      call MessageNotify('E', 'aq_r2_aq', &
                         'The spectral dimension of input data too small.')
    elseif (size(aq_data, 2) - 1 > km) then
      call MessageNotify('W', 'aq_r2_aq', &
                         'The spectral dimension of input data too large.')
    end if

    aq_r2_aq = 0.0D0

    !$omp parallel do private(sqrInm,sqrInm2m,sqrInp2m,nn,n,m)
    do j = 1, jmax
      m = abs(md(j))

      n = md(j)
      sqrInm = sqrt(Inm(n, m))
      sqrInp2m = sqrt(Inm(n + 2, m))
      aq_r2_aq(j, 0) = &
        (2 * n * (n + gamma - 1) + 2 * m * (m + beta - 1) + (gamma - 3) * (beta + 1)) &
        / ((2 * n + gamma + 1) * (2 * n + gamma - 3)) * aq_data(j, 0) &
        + (n - m + gamma - beta) * (n + m + gamma - 1) &
        / ((2 * n + gamma + 3) * (2 * n + gamma + 1)) &
        * aq_data(j, 1) * (sqrInm / sqrInp2m)

      do nn = 1, km - 1
        n = md(j) + nn * 2
        sqrInm2m = sqrInm
        sqrInm = sqrInp2m
        sqrInp2m = sqrt(Inm(n + 2, m))

        aq_r2_aq(j, nn) = &
          (n - m) * (n + m + beta - 1) / ((2 * n + gamma - 5) * (2 * n + gamma - 3)) &
          * aq_data(j, nn - 1) * (sqrInm / sqrInm2m) &
          + (2 * n * (n + gamma - 1) + 2 * m * (m + beta - 1) + (gamma - 3) * (beta + 1)) &
          / ((2 * n + gamma + 1) * (2 * n + gamma - 3)) * aq_data(j, nn) &
          + (n - m + gamma - beta) * (n + m + gamma - 1) &
          / ((2 * n + gamma + 3) * (2 * n + gamma + 1)) &
          * aq_data(j, nn + 1) * (sqrInm / sqrInp2m)
      end do

      n = md(j) + km * 2
      sqrInm2m = sqrInm
      sqrInm = sqrInp2m
      aq_r2_aq(j, km) = &
        (n - m) * (n + m + beta - 1) / ((2 * n + gamma - 5) * (2 * n + gamma - 3)) &
        * aq_data(j, km - 1) * (sqrInm / sqrInm2m) &
        + (2 * n * (n + gamma - 1) + 2 * m * (m + beta - 1) + (gamma - 3) * (beta + 1)) &
        / ((2 * n + gamma + 1) * (2 * n + gamma - 3)) * aq_data(j, km)
    end do
    !$omp end parallel do

    aq_r2_aq = aq_r2_aq * ra**2

  end function aq_r2_aq

  function q_r2_q(q_data)
    !
    ! 入力スペクトルデータに対して積 r^2 のスペクトル係数
    ! を計算する(1 次元配列用).
    !
    real(DP), dimension(:), intent(in) :: q_data
    !(in) 入力チェビシェフデータ

    real(DP), dimension(0:km) :: q_r2_q
    !(out) チェビシェフデータの R 微分

    real(DP), dimension(1, size(q_data)) :: aq_work
    ! 作業用配列

    aq_work(1, :) = q_data
    aq_work = aq_r2_aq(aq_work)
    q_r2_q = aq_work(1, :)

  end function q_r2_q

  !---- r^-2 積計算 ----
  function aq_r2Inv_aq(aq_data)
    !
    ! 入力スペクトルデータに対して積 r^-2 のスペクトル係数
    ! を計算する(2 次元配列用).
    !
    !   a_n^m = aq_r2Inv_aq/sqrt(Inm),  b_n^m = aq_data/sqrt(Inm)
    !
    !   b_n^m = (n-|m|)(n+|m|+beta-1)/((2n+gamma-5)(2n+gamma-3)) a_n-2^m
    !       + (2n(n+gamma-1) + 2|m|(|m|+beta-1)+(gamma-3)(beta+1)
    !            /((2n+gamma+1)(2n+gamma-3)) a_n^m
    !       + (n-|m|+gamma-beta)(n+|m|+gamma-1)
    !            /((2n+gamma+3)(2n+gamma+1)) a_n+2^m
    !
    real(DP), dimension(:, 0:), intent(in) :: aq_data
    !(in) 入力スペクトルデータ

    real(DP), dimension(size(aq_data, 1), 0:size(aq_data, 2) - 1) :: aq_r2Inv_aq
    !(out) 出力スペクトルデータ

    real(DP), dimension(:, :, :), allocatable :: R2MTX
    integer, dimension(:, :), allocatable :: kp

    integer(8) :: j, n, m, nn
    real(DP) :: sqrInp2m, sqrInm, sqrInm2m

    save R2MTX, kp

    if (size(aq_data, 1) /= jmax) then
      call MessageNotify('E', 'aq_r2Inv_aq', &
                         '1st dim. of the spectral data should be same as dim. of MD.')
    end if

    if (size(aq_data, 2) - 1 < km) then
      call MessageNotify('E', 'aq_r2Inv_aq', &
                         'The spectral dimension of input data too small.')
    elseif (size(aq_data, 2) - 1 > km) then
      call MessageNotify('W', 'aq_r2Inv_aq', &
                         'The spectral dimension of input data too large.')
    end if

    if (first_r2inv) then
      first_r2inv = .false.
      if (allocated(R2MTX)) deallocate (R2MTX)
      if (allocated(kp)) deallocate (kp)
      allocate (R2MTX(jmax, 0:km, 0:km), kp(jmax, 0:km))

      R2MTX(:, :, :) = 0.0D0
      do n = 0, km
        R2MTX(:, n, n) = 1.0D0
      end do

      !$omp parallel do private(sqrInm,sqrInm2m,sqrInp2m,n,m,nn)
      do j = 1, jmax
        m = abs(md(j))
        n = md(j)

        sqrInm = sqrt(Inm(n, m))
        sqrInp2m = sqrt(Inm(n + 2, m))

        R2MTX(j, 0, 0) = &
          (2 * n * (n + gamma - 1) + 2 * m * (m + beta - 1) + (gamma - 3) * (beta + 1)) &
          / ((2 * n + gamma + 1) * (2 * n + gamma - 3))

        R2MTX(j, 0, 1) = &
          (n - m + gamma - beta) * (n + m + gamma - 1) &
          / ((2 * n + gamma + 3) * (2 * n + gamma + 1)) &
          * (sqrInm / sqrInp2m)

        do nn = 1, km - 1
          n = md(j) + nn * 2
          sqrInm2m = sqrInm
          sqrInm = sqrInp2m
          sqrInp2m = sqrt(Inm(n + 2, m))

          R2MTX(j, nn, nn - 1) = &
            (n - m) * (n + m + beta - 1) / ((2 * n + gamma - 5) * (2 * n + gamma - 3)) &
            * (sqrInm / sqrInm2m)

          R2MTX(j, nn, nn) = &
            (2 * n * (n + gamma - 1) + 2 * m * (m + beta - 1) + (gamma - 3) * (beta + 1)) &
            / ((2 * n + gamma + 1) * (2 * n + gamma - 3))

          R2MTX(j, nn, nn + 1) = &
            (n - m + gamma - beta) * (n + m + gamma - 1) &
            / ((2 * n + gamma + 3) * (2 * n + gamma + 1)) &
            * (sqrInm / sqrInp2m)
        end do

        n = md(j) + km * 2
        sqrInm2m = sqrInm
        sqrInm = sqrInp2m
        R2MTX(j, km, km - 1) = &
          (n - m) * (n + m + beta - 1) / ((2 * n + gamma - 5) * (2 * n + gamma - 3)) &
          * (sqrInm / sqrInm2m)
        R2MTX(j, km, km) = &
          (2 * n * (n + gamma - 1) + 2 * m * (m + beta - 1) + (gamma - 3) * (beta + 1)) &
          / ((2 * n + gamma + 1) * (2 * n + gamma - 3))
      end do
      !$omp end parallel do

      R2MTX = R2MTX * ra**2

      call LUDECOMP(R2MTX, kp)

    end if

    aq_r2Inv_aq = LUSOLVE(R2MTX, kp, aq_data)

  end function aq_r2Inv_aq

  function q_r2Inv_q(q_data)
    !
    ! 入力スペクトルデータに対して積 r^2 のスペクトル係数
    ! を計算する(1 次元配列用).
    !
    real(DP), dimension(:), intent(in) :: q_data
    !(in) 入力チェビシェフデータ

    real(DP), dimension(0:km) :: q_r2Inv_q
    !(out) チェビシェフデータの R 微分

    real(DP), dimension(1, size(q_data)) :: aq_work
    ! 作業用配列

    aq_work(1, :) = q_data
    aq_work = aq_r2Inv_aq(aq_work)
    q_r2Inv_q = aq_work(1, :)

  end function q_r2Inv_q

  !--------------- 積分計算 -----------------
  function a_Int_ag(ag)
    !
    ! 1 次元格子点データが並んだ 2 次元配列の積分
    !
    !      \int_0^a f(R) W(R) dR, W(R) = R^beta/(a^2-R^2)^(1-alpha)
    !
    ! を計算する.
    !
    real(DP), dimension(:, :), intent(in) :: ag
    !(in)入力格子点データ

    real(DP), dimension(size(ag, 1)) :: a_Int_ag
    !(out) 積分したデータ
    integer(8) :: i

    if (size(ag, 2) < im) then
      call MessageNotify('E', 'a_Int_ag', &
                         'The Grid points of input data too small.')
    elseif (size(ag, 2) > im) then
      call MessageNotify('W', 'a_Int_ag', &
                         'The Grid points of input data too large.')
    end if

    a_Int_ag = 0.0d0
    do i = 1, im
      a_Int_ag(:) = a_Int_ag(:) + ag(:, i) * g_R_Weight(i)
    end do
  end function a_Int_ag

  function Int_g(g)
    !
    ! 1 次元格子点データの積分
    !
    !      \int_0^a f(R) W(R) dR, W(R) = R^beta/(a^2-R^2)^(1-alpha)
    !
    ! を行う
    !
    real(DP), dimension(im), intent(in) :: g
    !(in) 格子点データ

    real(DP) :: Int_g
    !(out) 積分値

    Int_g = sum(g * g_R_Weight)

  end function Int_g

  function a_Avr_ag(ag)
    !
    ! 1 次元格子点データが並んだ 2 次元配列の平均
    !
    !      \int_0^a f(R) W(R) dR/\int_0^a W(R) dR,
    !          W(R) = R^beta/(a^2-R^2)^(1-alpha)
    !
    ! を計算する.
    !
    real(DP), dimension(:, 0:), intent(in) :: ag
    !(in)入力格子点データ

    real(DP), dimension(size(ag, 1)) :: a_Avr_ag
    !(out) 平均したデータ

    a_Avr_ag = a_Int_ag(ag) / sum(g_R_Weight)

  end function a_Avr_ag

  function Avr_g(g)
    !
    ! 1 次元格子点データの平均
    !
    !      \int_0^a f(R) W(R) dR/\int_0^a W(R) dR,
    !          W(R) = R^beta/(a^2-R^2)^(1-alpha)
    !
    ! を計算する.
    !
    real(DP), dimension(im), intent(in) :: g
    !(in) 格子点データ

    real(DP) :: Avr_g
    !(out) 積分値

    Avr_g = Int_g(g) / sum(g_R_Weight)
  end function Avr_g

  !---- Dirichlet 型境界条件(タウ法) ----

  subroutine aq_BoundaryTau_D_2d(aq_data, value)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
    ! * 外側境界(i=im)での値を与える.
    !
    real(DP), dimension(:, 0:), intent(inout) :: aq_data
    !(inout) 境界条件を適用するチェビシェフデータ(jmax,0:km)

    real(DP), dimension(:), intent(in), optional :: value
    !(in) 境界値(jmax)

    real(DP), dimension(:, :, :), allocatable :: alu
    integer, dimension(:, :), allocatable :: kp
    real(DP), dimension(size(aq_data, 1), 0:km) :: aq_work
    real(DP), dimension(size(aq_data, 1), im) :: ag_work
    real(DP), dimension(size(aq_data, 1)) :: value0           ! 境界値

    integer(8) :: k, j
    save :: alu, kp

    if (size(aq_data, 2) - 1 < km) then
      call MessageNotify('E', 'aq_BoundaryTau_D', &
                         'The spectral dimension of input data too small.')
    elseif (size(aq_data, 2) - 1 > km) then
      call MessageNotify('W', 'aq_BoundaryTau_D', &
                         'The spectral dimension of input data too large.')
    end if

    if (.not. present(value)) then
      value0 = 0.0D0
    else
      value0 = value
    end if

    if (first_Tau_D) then
      first_Tau_D = .false.

      allocate (alu(size(aq_data, 1), 0:km, 0:km), kp(size(aq_data, 1), 0:km))

      alu = 0.0D0
      do k = 0, km
        alu(:, k, k) = 1.0D0
      end do

      do k = 0, km
        aq_work = 0.0D0
        aq_work(:, k) = 1.0D0
        ag_work = ag_aq(aq_work)
        alu(:, km, k) = ag_work(:, im)
      end do

      call LUDECOMP(alu, kp)
    end if

    do j = 1, jmax
      aq_data(j, km) = value0(j)
    end do

    aq_data = LUSOLVE(alu, kp, aq_data)

  end subroutine aq_BoundaryTau_D_2d

  subroutine aq_BoundaryTau_D_1d(q_data, value)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
    ! * 両境界での値を与える.
    !
    real(DP), dimension(0:km), intent(inout) :: q_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(DP), intent(in), optional :: value
    !(in) 境界値

    real(DP), dimension(1, 0:km) :: aq_work
    real(DP), dimension(1) :: vwork  ! 境界値

    if (.not. present(value)) then
      vwork(1) = 0.0D0
    else
      vwork(1) = value
    end if

    aq_work(1, :) = q_data
    call aq_BoundaryTau_D_2d(aq_work, vwork)
    q_data = aq_work(1, :)

  end subroutine aq_BoundaryTau_D_1d

  !---- Neumann 型境界条件(タウ法) ----

  subroutine aq_BoundaryTau_N_2d(aq_data, value)
    !
    ! 外側境界 Neumann 型境界条件の適用(タウ法, 2 次元配列用)
    ! * i=im で勾配の値を与える.
    !
    real(DP), dimension(:, 0:), intent(inout) :: aq_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,0:km)

    real(DP), dimension(:), intent(in), optional :: value
    !(in) 境界値(m)

    real(DP), dimension(:, :, :), allocatable :: alu
    integer, dimension(:, :), allocatable :: kp
    real(DP), dimension(size(aq_data, 1), 0:km) :: aq_work
    real(DP), dimension(size(aq_data, 1), im) :: ag_work
    real(DP), dimension(size(aq_data, 1)) :: value0           ! 境界値

    integer(8) :: j, k

    save :: alu, kp

    if (size(aq_data, 2) - 1 < km) then
      call MessageNotify('E', 'aq_BoundaryTau_N', &
                         'The spectral dimension of input data too small.')
    elseif (size(aq_data, 2) - 1 > km) then
      call MessageNotify('W', 'aq_BoundaryTau_N', &
                         'The spectral dimension of input data too large.')
    end if

    if (.not. present(value)) then
      value0 = 0.0D0
    else
      value0 = value
    end if

    if (first_Tau_N) then
      first_Tau_N = .false.
      allocate (alu(jmax, 0:km, 0:km), kp(jmax, 0:km))

      alu = 0.0D0
      do k = 0, km
        alu(:, k, k) = 1.0D0
      end do

      do k = 0, km
        aq_work = 0.0D0
        aq_work(:, k) = 1.0D0
        ag_work = ag_aq(aq_rDr_aq(aq_work)) / spread(g_R, 1, jmax)
        alu(:, km, k) = ag_work(:, im)
      end do

      call LUDECOMP(alu, kp)
    end if

    do j = 1, jmax
      aq_data(j, km) = value0(j)
    end do

    aq_data = LUSOLVE(alu, kp, aq_data)

  end subroutine aq_BoundaryTau_N_2d

  subroutine aq_BoundaryTau_N_1d(q_data, value)
    !
    ! Dirichlet/Neumann 型境界条件の適用(タウ法, 1 次元配列用)
    ! * i=0 で勾配の値を与える.
    !
    real(DP), dimension(0:km), intent(inout) :: q_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(DP), intent(in), optional :: value
    !(in) 境界値

    real(DP), dimension(1, 0:km) :: aq_work
    real(DP), dimension(1) :: vwork           ! 境界値

    if (.not. present(value)) then
      vwork(1) = 0.0D0
    else
      vwork(1) = value
    end if

    aq_work(1, :) = q_data
    call aq_BoundaryTau_N_2d(aq_work, vwork)
    q_data = aq_work(1, :)

  end subroutine aq_BoundaryTau_N_1d

  !---- Dirichlet 型境界条件(選点法) ----

  subroutine ag_BoundaryGrid_D_2d(ag_data, value)
    !
    ! Dirichlet 型境界条件の適用(選点法, 2 次元配列用)
    ! * 外側境界(i=im)での値を与える.
    !
    real(DP), dimension(:, :), intent(inout) :: ag_data
    !(inout) 境界条件を適用するチェビシェフデータ(jmax,im)

    real(DP), dimension(:), intent(in), optional :: value
    !(in) 境界値(jmax)

    real(DP), dimension(size(ag_data, 1)) :: value0

    if (.not. present(value)) then
      value0 = 0.0d0
    else
      value0 = value
    end if
    ag_data(:, im) = value0

  end subroutine ag_BoundaryGrid_D_2d

  subroutine ag_BoundaryGrid_D_1d(g_data, value)
    !
    ! Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
    ! * 両境界での値を与える.
    !
    real(DP), dimension(im), intent(inout) :: g_data
    !(inout) 境界条件を適用するチェビシェフデータ(im)

    real(DP), intent(in), optional :: value
    !(in) 境界値

    real(DP), dimension(1, im) :: ag_work
    real(DP), dimension(1) :: vwork

    if (.not. present(value)) then
      vwork(1) = 0.0d0
    else
      vwork(1) = value
    end if

    ag_work(1, :) = g_data
    call ag_BoundaryGrid_D_2d(ag_work, vwork)
    g_data = ag_work(1, :)

  end subroutine ag_BoundaryGrid_D_1d

  !---- Neumann 型境界条件(選点法) ----

  subroutine ag_BoundaryGrid_N_2d(ag_data, value)
    !
    ! 外側境界 Neumann 型境界条件の適用(選点法, 2 次元配列用)
    ! * i=im で勾配の値を与える.
    !
    real(DP), dimension(:, :), intent(inout) :: ag_data
    !(inout) 境界条件を適用するチェビシェフデータ(m,im)

    real(DP), dimension(:), intent(in), optional :: value
    !(in) 境界値(m)

    real(DP), dimension(:, :, :), allocatable :: alu
    integer, dimension(:, :), allocatable :: kp
    real(DP), dimension(size(ag_data, 1), im) :: ag_work
    real(DP), dimension(size(ag_data, 1)) :: value0           ! 境界値

    integer(8) :: i
    save :: alu, kp

    if (size(ag_data, 2) < im) then
      call MessageNotify('E', 'aq_BoundaryGrid_N', &
                         'The dimension of input data too small.')
    elseif (size(ag_data, 2) > im) then
      call MessageNotify('W', 'aq_BoundaryGrid_N', &
                         'The dimension of input data too large.')
    end if

    if (.not. present(value)) then
      value0 = 0.0D0
    else
      value0 = value
    end if

    if (first_Grid_N) then
      first_Grid_N = .false.
      allocate (alu(jmax, im, im), kp(jmax, im))

      alu = 0.0D0
      do i = 1, im
        alu(:, i, i) = 1.0D0
      end do

      do i = 1, im
        ag_work = 0.0D0
        ag_work(:, i) = 1.0D0
        ag_work = ag_aq(aq_rDr_aq(aq_ag(ag_work))) / spread(g_R, 1, jmax)
        alu(:, im, i) = ag_work(:, im)
      end do

      call LUDECOMP(alu, kp)
    end if

    ag_data(:, im) = value0

    ag_data = LUSOLVE(alu, kp, ag_data)

  end subroutine ag_BoundaryGrid_N_2d

  subroutine ag_BoundaryGrid_N_1d(g_data, value)
    !
    ! Dirichlet/Neumann 型境界条件の適用(選点法, 1 次元配列用)
    ! * i=0 で勾配の値を与える.
    !
    real(DP), dimension(im), intent(inout) :: g_data
    !(inout) 境界条件を適用するチェビシェフデータ(0:km)

    real(DP), intent(in), optional :: value
    !(in) 境界値

    real(DP), dimension(1, im) :: ag_work
    real(DP), dimension(1) :: vwork           ! 境界値

    if (.not. present(value)) then
      vwork(1) = 0.0D0
    else
      vwork(1) = value
    end if

    ag_work(1, :) = g_data
    call ag_BoundaryGrid_N_2d(ag_work, vwork)
    g_data = ag_work(1, :)

  end subroutine ag_BoundaryGrid_N_1d

  !---- 下部ルーチン
  subroutine gauss_radau(M, g_R, g_W)
    !
    ! M 次の多項式 π(r) の零点から
    ! ガウス-ラダウ格子点とガウス重みを計算する
    !
    integer(8), intent(in) :: M
    ! (in) 多項式打切次数(0 < M, M even)
    real(DP), intent(out) :: g_R(M / 2)         ! ガウス-ラダウ格子点
    real(DP), intent(out) :: g_W(M / 2)         ! ガウス重み

    real(DP) :: r1, r2, dr
    real(DP) :: pi1, pi2
    integer(8) :: i
    integer(8) :: ir
    character(len=4) :: CNUM
    real(DP), parameter :: eps = 1.0D-15      ! 打切誤差
    integer, parameter :: nrfact = 100       ! 格子点走査間隔を定める数

    !--- 入力チェック
    if (mod(M, 2_8) .ne. 0) then
      call MessageNotify('E', 'gauss_radau', 'M must be even')
    end if

    !--- ガウス--ラダウ格子点
    dr = 1.0_DP / (real(nrfact, DP) * real(M, DP))

    i = 0
    do ir = 1, nrfact * M
      r1 = ir * dr; r2 = (ir + 1) * dr
      pi1 = pir(r1, M); pi2 = pir(r2, M)

      if (pi1 * pi2 .le. 0.0D0) then
        i = i + 1
        g_R(i) = bisec_pir(r1, r2, M, eps)

        if (i .eq. M / 2 - 1) then
          i = i + 1
          g_R(M / 2) = 1.0D0
          goto 10
        end if
      end if
    end do

    write (CNUM, '(I4)') i
    call MessageNotify('E', 'gauss_radau', &
                       'Only '//CNUM//' Gauss-Radau points are found')

    !--- ガウス重み
10  continue
    write (CNUM, '(I4)') i
    call MessageNotify('M', 'gauss_radau', CNUM//' Gauss-Radau points are set up.')

    do i = 1, M / 2 - 1
      g_W(i) = 2 * (2 * M + gamma - 5) * g_R(i)**2     &
        &        / ((M + gamma - beta - 2) * (M + gamma - 3) * Phi(g_R(i), M - 2, 0_8)**2)
    end do

    g_W(M / 2) = Inm(0_8, 0_8) - sum(g_W(1:M / 2 - 1))

  end subroutine gauss_radau

  function bisec_pir(r1, r2, n, eps)
    !
    !  2 分法で π(r,n) の零点を区間 [r1,r2] の間で誤差 eps で探す
    !
    real(DP) :: r1, r2
    integer(8), intent(in) :: n
    real(DP), intent(in) :: eps
    real(DP) :: bisec_pir

    real(DP) :: rm, pim
    real(DP) :: pi1, pi2

    pi1 = pir(r1, n)
    if (abs(pi1) .lt. eps) then
      bisec_pir = r1
      return
    end if

    pi2 = pir(r2, n)
    if (abs(pi2) .lt. eps) then
      bisec_pir = r2
      return
    end if

10  rm = (r1 + r2) / 2
    pim = pir(rm, n)

    if (abs(pim) .lt. eps) then
      bisec_pir = rm
      return
    end if

    if (abs(r1 - r2) .lt. eps) then
      bisec_pir = rm
      return
    end if

    if (pim * pi1 .gt. 0.0D0) then
      r1 = rm
      pi1 = pim
    else
      r2 = rm
      pi2 = pim
    end if
    goto 10

  end function bisec_pir

  function pir(r, n)
    !
    ! ガウス-ラダウ格子点を定義するための関数
    !
    real(DP), intent(in) :: r                ! 動径座標 ( 0 < r < ra )
    integer(8), intent(in) :: n                ! 多項式次数(0 <= n)
    real(DP) :: pir              ! 多項式の値

    pir = qnm(r, n, 0_8) - (n + gamma - beta - 2) * (n + gamma - 3) * qnm(r, n - 2, 0_8) / (n * (n + beta - 1))

  end function pir

  function Phi(r, n_ind, m_ind)
    !
    ! 正規化された多項式計算
    !
    real(DP), intent(in) :: r                ! 動径座標 ( 0 < r < ra )
    integer(8), intent(in) :: n_ind            ! 多項式次数(0 <= |m| <= n)
    integer(8), intent(in) :: m_ind            ! 多項式次数(0 <= |m| <= n)
    real(DP) :: Phi              ! 多項式の値

    Phi = qnm(r, n_ind, m_ind) / sqrt(Inm(n_ind, m_ind))
  end function Phi

  function qnm(r, n_ind, m_ind)

    real(DP), intent(in) :: r                ! 動径座標 ( 0 < r < ra )
    integer(8), intent(in) :: n_ind            ! 多項式次数(0 <= |m| <= n)
    integer(8), intent(in) :: m_ind            ! 多項式次数(0 <= |m| <= n)
    real(DP) :: qnm              ! 多項式の値

    real(DP) :: qnp2m, qnm2m
    integer(8) :: m, n

    m = abs(m_ind)

    !--- 入力チェック
    if (n_ind .lt. 0) then
      call MessageNotify('E', 'qnm', 'n must be larger equal to 0')
    end if

    if (m .gt. n_ind) then
      call MessageNotify('E', 'qnm', 'abs(m) must be smaller equal to n')
    end if

    if (mod(n_ind + m_ind, 2_8) .ne. 0) then
      call MessageNotify('E', 'qnm', 'n+m must be even')
    end if

    !--- 初期値
    if (m .eq. n_ind) then
      qnm = r**m
      return
    end if

    if (n_ind .eq. m + 2) then
      qnm = (2 * m + gamma - 1) / 2 * ((2 * m + gamma + 1) / (2 * m + beta + 1) * r**2 - 1) * r**m
      return
    end if

    qnm2m = r**m
    qnm = (2 * m + gamma - 1) / 2 * ((2 * m + gamma + 1) / (2 * m + beta + 1) * r**2 - 1) * r**m

    !--- 漸化式

    do n = m + 2, n_ind - 2, 2
      qnp2m = ((2 * n + gamma - 1)                                                                  &
        &          * ((2 * n + gamma - 3) * (2 * n + gamma + 1) * r**2                              &
        &              - 2 * n * (n + gamma - 1) - 2 * m * (m + beta - 1)                           &
        &              - (gamma - 3) * (beta + 1)) * qnm                                            &
        &         - (n - m + gamma - beta - 2) * (n + m + gamma - 3) * (2 * n + gamma + 1) * qnm2m) &
        &        / ((n - m + 2) * (n + m + beta + 1) * (2 * n + gamma - 3))
      qnm2m = qnm
      qnm = qnp2m
    end do
    return
  end function qnm

  function Inm(n_ind, m_ind)
    !
    ! 多項式の規格化定数を漸化式により求める
    !
    integer(8), intent(in) :: n_ind            ! 多項式次数(0 <= |m| <= n)
    integer(8), intent(in) :: m_ind            ! 多項式次数(0 <= |m| <= n)
    real(DP) :: Inm              ! 規格化定数

    integer(8) :: n, m
    real(DP) :: Inm2m
    real(DP) :: Inmln                         ! 規格化定数のlog
    real(DP) :: dlgamma
    external dlgamma

    m = abs(m_ind)

    !--- 入力チェック
    if (n_ind .lt. 0) then
      call MessageNotify('E', 'Inm', 'n must be larger equal to 0')
    end if

    if (m .gt. n_ind) then
      call MessageNotify('E', 'Inm', 'abs(m) must be smaller equal to n')
    end if

    if (mod(n_ind + m_ind, 2_8) .ne. 0) then
      call MessageNotify('E', 'Inm', 'n+m must be even')
    end if

    !--- 初期値
    Inmln = dlgamma((gamma - beta) / 2) + dlgamma(m + (beta + 1) / 2) &
      &     - dlgamma(m + (gamma + 1) / 2) - log(2.0D0)
    Inm = exp(Inmln)

    !--- 漸化式
    do n = m + 2, n_ind, 2
      Inm2m = Inm
      Inm = (2 * n + gamma - 5) * (n - m + gamma - beta - 2) * (n + m + gamma - 3) &
        &  / ((n - m) * (n + m + beta - 1) * (2 * n + gamma - 1)) * Inm2m
    end do

    return
  end function Inm

end module aq_module

!----------------------------------------------------------------------
!     Copyright (c) 2019-2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_interpolate_module テストプログラム :: 補間関数のテスト
!
!履歴  2019/03/16  竹広真一
!      2020/11/07  竹広真一 セクター計算テスト
!
program w_interpolate_module_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module_mint
  implicit none

!!$  integer, parameter :: im=64, jm=32, nm=21, mint=1
  integer, parameter :: im=32, jm=32, nm=21, mint=2  
  integer, parameter :: nc=(nm/mint+1)*(2*(nm+1)-nm/mint*mint)

  real(8), dimension(nc)          ::  w_data
  real(8), dimension(0:im-1,1:jm) ::  xy_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call w_Initial( nm, im, jm, mint=mint )

  call MessageNotify('M','w_interpolate_module_mint_test', &
                         'w_interpolate_module interpolate(00) tests')

  !---- Y_1^0 のテスト ----
  xy_data = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  data_sol = sqrt(3.0D0)*sin(ALat)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^0',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^0 のテスト ----
  xy_data = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)                 ! Y_2^0
  data_sol = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^0',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^2 のテスト ----
  xy_data = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*cos(2*xy_Lon)             ! Y_2^2
  data_sol = sqrt(5.0D0/24)*3.0*cos(ALat)**2*cos(2*ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^2',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^-2 のテスト ----
  xy_data = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)          ! Y_2^-2
  data_sol = -sqrt(5.0D0/24)*3.0*cos(ALat)**2*sin(2*ALon)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^-2',                          &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_interpolate_module_mint_test', &
                      'w_interpolate_module function tests succeeded')

end program w_interpolate_module_mint_test

!----------------------------------------------------------------------
!     Copyright (c) 2009-2025 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wq_module テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2009/12/11  竹広真一  wq_test_torvelbc.f90 より SJPACK 用に改造
!      2025/12/22  竹広真一  spml2 版対応
!
program wq_module_torvelbc_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wq_module

  implicit none

  integer,parameter  :: im=32, jm=16, km=8   ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=7          ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ra=2.0               ! 球半径

  real(8), dimension(0:im-1,1:jm,km)       :: xyr_TorVel0
  real(8), dimension(0:im-1,1:jm,km)       :: xyr_TorVel
  real(8), dimension((nm+1)*(nm+1),0:lm)   :: wq_TorVel
  real(8), dimension((nm+1)*(nm+1),0:lm)   :: wq_TorVel0
  real(8), dimension((nm+1)*(nm+1),km)     :: wr_TorVel
  character(len=1), dimension(2),parameter :: BCond=(/'F','R'/)

  real(8), dimension(0:im-1,1:jm,km)       :: xyr_True
  real(8), dimension(0:im-1,1:jm,km)       :: xyr_Zero=0.0D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 12
  integer, parameter :: ignore = -13

  integer :: ll

  call MessageNotify('M','wq_module_torvelbc_test', &
       'wq_module wq_TorvelBoundary subroutine test')

  call wq_initial(im,jm,km,nm,lm,ra)

  do ll=1,2

     ! P_10
     !xyr_TorVel = sin(xyr_lat) * cos( pi*(xyr_rad-ri)/(ro-ri) )
     ! P_1_1
     !xyr_TorVel = cos(xyr_lat)*cos(xyr_lon)* cos( pi*(xyr_rad-ri)/(ro-ri) )
     xyr_TorVel = 2*sin(xyr_lat)**2 * (xyr_rad-ra)**2 * xyr_Rad**2

     xyr_TorVel0 = xyr_TorVel
     wq_TorVel = wq_xyr(xyr_TorVel)
     wq_TorVel0 = wq_TorVel  
     wr_TorVel = wr_xyr(xyr_TorVel)


     !---- wq_TorBoundary test
     call wq_TorBoundary(wq_TorVel,cond=BCond(ll),new=.true.)
     xyr_TorVel = xyr_wq(wq_TorVel)

     call AssertEqual(&
          message='wq_TorvelgBoundary (internal value)',                &
          answer = wq_Torvel(:,0:lm-2),                                 &
          check = wq_Torvel0(:,0:lm-2),                                 &
          significant_digits = check_digits, ignore_digits = ignore     &
       )

     ! 上端境界チェック
     if( BCond(ll) == 'F' ) then
        xyr_True = xyr_wq(wq_RadDRad_wq(wq_Torvel)- wq_Torvel)/xyr_Rad
     else
        xyr_True = xyr_TorVel
     endif

     call AssertEqual(&
          message='wq_TorlBoundary (Top boundary)',                     &
          answer = xyr_True(:,:,km),                                    &
          check = xyr_Zero(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     call MessageNotify('M','wq_module_torvelbc_test', &
          'wq_TorBoundarry: '//BCond(ll)//'-Top B.C. test succeeded!')


     !---- wr_TorBoundaryGrid test
     call wr_TorBoundaryGrid(wr_TorVel,cond=BCond(ll),new=.true.)
     xyr_TorVel = xyr_wr(wr_TorVel)
     wq_TorVel = wq_wr(wr_TorVel)

     ! 内部チェック
     xyr_True = xyr_TorVel - xyr_TorVel0

     call AssertEqual(&
          message='wq_TorBoundary (internal value)',                    &
          answer = xyr_Torvel(:,:,1:km-1),                              &
          check = xyr_Torvel0(:,:,1:km-1),                              &
          significant_digits = check_digits, ignore_digits = ignore     &
       )

     ! 上端境界チェック
     if( BCond(ll) == 'F' ) then
        xyr_True = xyr_wq(wq_RadDRad_wq(wq_Torvel)- wq_Torvel)/xyr_Rad
     else
        xyr_True = xyr_TorVel
     endif

     call AssertEqual(&
          message='wq_TorlBoundaryGrid (Top Booundary)',                &
          answer = xyr_True(:,:,km),                                    &
          check = xyr_Zero(:,:,km),                                     &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     call MessageNotify('M','wq_module_torvelbc_test', &
          'wq_TorBoundaryGrid: '//BCond(ll)//'-Top B.C. test succeeded!')
          
  enddo

  call MessageNotify('M','wq_module_torvelbc_test', &
       'wq_module wq_TorvelBoundary subroutine test succeeded!')

end program wq_module_torvelbc_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2019-2020 SPMDOEL Development Group
!----------------------------------------------------------------------
!表題  ua_base_mpi_module_sypack
!
!  spml/ua_base_mpi_module_sypack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための
!  モジュール ua_mpi_module_sypack の下部モジュールであり,
!  スペクトル計算の基本的な Fortran90 関数を提供する.
!
!  球面上の 1 層モデル用 u_base_module_sypack モジュールを多層モデル用に
!  並列化拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3 の SYPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって u_mpi_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある.
!
!
!履歴  2016/08/15  竹広真一  wa_base_module より多層 MPI 対応改造
!      2020/01/25  竹広真一  u_xv, xv_u を ut_mpi_module から移動
!      2020/08/05  竹広真一  xvb <=> pva と wb 関数を追加
!      2020/08/11  竹広真一  bug fixed
!      2020/08/17  竹広真一  ua_wb, wb_ua fixed
!
!++
module ua_mpi_module_base
  !
  != ua_mpi_module_base
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/ua_mpi_module_base モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための
  !  モジュール ua_mpi_module の下部モジュールであり,
  !  スペクトル計算の基本的な Fortran90 関数を提供する.
  !
  !  球面上の 1 層モデル用 w_base_module モジュールを多層モデル用に
  !  並列化拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3 の SYPACK のマニュアルを参照されたい.
  !
  !  このモジュールを使うためには前もって w_mpi_base_initial を呼んで
  !  切断波数, 格子点数の設定をしておく必要がある.
  !
  use mpi
  use dc_message, only: MessageNotify
  use w_mpi_module_base,  only : im, jm, jc=>jl, nn, mm, &
    xv_Lon, xv_Lat, x_Lon, v_Lat, x_Lon_Weight, v_Lat_Weight, &
       xv_w, w_xv, &
       w_StreamPotential2VectorMPI, w_Vector2VorDivMPI, &
       w_VectorCosLat2VorDivMPI, &
       w_base_mpi_initial, w_base_mpi_finalize, ncc=>nc, l_nm, nm_l


  implicit none

  integer              :: km=16         ! 同時に処理する最大データ数(層の数).

  integer              :: nproc, nproc_h, nproc_v
  integer              :: iproc, iproc_h, iproc_v

  integer              :: nc
  
  integer              :: is, ie, ic
  integer, allocatable :: isp(:), iep(:), icp(:)

  integer              :: ks, ke, kc
  integer, allocatable :: ksp(:), kep(:), kcp(:)

  integer              :: nms, nme, nmc
  integer, allocatable :: nmsp(:), nmep(:), nmcp(:)

  real(8), allocatable :: pv_Lon(:,:), pv_Lat(:,:)
  real(8), allocatable :: p_Lon(:)
  real(8), allocatable :: p_Lon_Weight(:)
  
  integer              :: MPI_COMM_W
  integer              :: MPI_COMM_H
  integer              :: MPI_COMM_V

  logical              :: first_xvb_pva=.true.
  logical              :: first_pva_xvb=.true.
  logical              :: first_wb_ua=.true.
  logical              :: first_ua_wb=.true.
  logical              :: first_wa_ua=.true.
  logical              :: first_aa_ab=.true.
  logical              :: first_xa_pa=.true.

  private

  public ua_base_mpi_Initial                   ! 初期化サブルーチン
  public ua_base_mpi_Finalize                  ! 終了処理

  public MPI_COMM_W, MPI_COMM_H, MPI_COMM_V
  public nproc, nproc_h, nproc_v
  public iproc, iproc_h, iproc_v

  public jc, nc
  public is, ie, ic
  public km
  public ks, ke, kc
  public nms, nme, nmc

  public l_nm, nm_l
  public lu_nm, nm_lu
  public kp_kl

  public xv_Lon, xv_Lat
  public x_Lon, v_Lat
  public x_Lon_Weight, v_Lat_Weight
  public pv_Lon, pv_Lat
  public p_Lon
  public p_Lon_Weight

  public ua_pva, pva_ua                        ! 変換関数(ua)
  public xvb_ua, ua_xvb                        ! 変換関数(ua)
  public pv_u, u_pv                            ! 変換関数(ua)
  public xv_u, u_xv                            ! 変換関数(ua)

  public wb_pva, pva_wb                        ! 変換関数(wb)
  public wb_xvb, xvb_wb                        ! 変換関数(wb)
  public pv_w, w_pv                            ! 変換関数(wb)
  public xv_w, w_xv                            ! 変換関数(wb)
  
  public xvb_pva, pva_xvb                      ! 変換関数
  public wb_ua, ua_wb                          ! 変換関数  
  public wa_ua, ua_wa                          ! 変換関数
  public xa_pa, pa_xa                          ! 変換関数
  public aa_ab, ab_aa                          ! 変換関数

  public ua_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算(ua)
  public ua_Vector2VorDivMPI                   ! 速度場から渦度発散を計算(ua)
  public ua_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算(ua)
  public wb_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算(wa)
  public wb_Vector2VorDivMPI                   ! 速度場から渦度発散を計算(wa)
  public wb_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算(wa)
  
  save nc
  save km                                      ! 最大データ数(層数)を記憶
  save nproc, iproc, nproc_h, iproc_h, nproc_v, iproc_v
  save icp, isp, iep
  save ic, is, ie
  save kcp, ksp, kep
  save kc, ks, ke
  save nmsp, nmep, nmcp
  save nms, nme, nmc
  save pv_Lon, pv_Lat
  save p_Lon
  save p_Lon_Weight
  save MPI_COMM_W, MPI_COMM_H, MPI_COMM_V
  save first_xvb_pva, first_pva_xvb
  save first_wb_ua, first_ua_wb, first_wa_ua, first_aa_ab, first_xa_pa

  contains
  !--------------- 初期化 -----------------
    subroutine ua_base_mpi_initial(n_in,i_in,j_in,k_in,npv,mpi_comm)
      !
      ! ua_mpi_module_base 初期化
      !
      integer,intent(in) :: n_in                !(in) 切断波数
      integer,intent(in) :: i_in                !(in) 格子点数(東西)
      integer,intent(in) :: j_in                !(in) 格子点数(南北)
      integer,intent(in) :: k_in                !(in) 最大データ数(層数)
      integer,intent(in),optional :: npv        !(in) 層方向分割数
      integer,intent(in),optional :: mpi_comm   !(in) 全体コミュニケーター

      integer :: ierr, iv

      km = k_in

      if ( present(npv) ) then
         nproc_v = npv
      else
         nproc_v = 1
      endif

      if ( present(mpi_comm) ) then
         MPI_COMM_W = mpi_comm
      else
         MPI_COMM_W = MPI_COMM_WORLD
      endif

      CALL MPI_COMM_SIZE(MPI_COMM_W,NPROC,IERR)
      CALL MPI_COMM_RANK(MPI_COMM_W,IPROC,IERR)

      NPROC_H = NPROC/NPROC_V
      IPROC_V = IPROC/NPROC_H
      IPROC_H = MOD(IPROC,NPROC_H)

      CALL MPI_COMM_SPLIT(MPI_COMM_W, iproc_v, iproc_h, MPI_COMM_H, IERR )
      CALL MPI_COMM_SPLIT(MPI_COMM_W, iproc_h, iproc_v, MPI_COMM_V, IERR )

      call w_base_mpi_initial(n_in,i_in,j_in,mpi_comm_h)
      nc = ncc

      allocate(isp(0:NPROC_V-1))
      allocate(iep(0:NPROC_V-1))
      allocate(icp(0:NPROC_V-1))
      call mpidevide(int(im),nproc_v,isp,iep,icp)
      isp = isp-1 ; iep = iep-1
      is = isp(iproc_v) ; ie = iep(iproc_v) ; ic = icp(iproc_v)

      IF(iproc.EQ.0)THEN
         WRITE(6,*)'   RANK  KSTART  KEND    IC '
         WRITE(6,*)'------------------------------'
         DO IV=0,NPROC_V-1
            WRITE(6,'(4i7)') IV, ISP(IV), IEP(IV), ICP(IV)
         ENDDO
         WRITE(6,*)''
      END IF
      
      allocate(ksp(0:NPROC_V-1))
      allocate(kep(0:NPROC_V-1))
      allocate(kcp(0:NPROC_V-1))
      call mpidevide(km,nproc_v,ksp,kep,kcp)
      ks = ksp(iproc_v) ; ke = kep(iproc_v) ; kc = kcp(iproc_v)

      IF(iproc.EQ.0)THEN
         WRITE(6,*)'   RANK  KSTART  KEND    KC '
         WRITE(6,*)'------------------------------'
         DO IV=0,NPROC_V-1
            WRITE(6,'(4i7)') IV, KSP(IV), KEP(IV), KCP(IV)
         ENDDO
         WRITE(6,*)''
      END IF

      allocate(nmsp(0:NPROC_V-1))
      allocate(nmep(0:NPROC_V-1))
      allocate(nmcp(0:NPROC_V-1))
      call mpidevide(nc,nproc_v,nmsp,nmep,nmcp)
      nms = nmsp(iproc_v) ; nme = nmep(iproc_v) ; nmc = nmcp(iproc_v)

      IF(iproc.EQ.0)THEN
         WRITE(6,*)'   RANK  NSTART  NEND    NC '
         WRITE(6,*)'------------------------------'
         DO IV=0,NPROC_V-1
            WRITE(6,'(4i7)') IV, NMSP(IV), NMEP(IV), NMCP(IV)
         ENDDO
         WRITE(6,*)''
      ENDIF

      allocate(pv_Lon(0:ic-1,jc),pv_Lat(0:ic-1,jc))
      allocate(p_Lon(0:ic-1),p_Lon_Weight(0:ic-1))

      pv_Lon = xv_Lon(is:ie,:)
      pv_Lat = xv_Lat(is:ie,:)
      p_Lon  = x_Lon(is:ie)
      p_Lon_Weight  = x_Lon_Weight(is:ie)
      
      call MessageNotify('M','ua_base_mpi_initial', &
          'ua_mpi_module_base (2020/08/17) is initialized')

    end subroutine ua_base_mpi_initial

    subroutine mpidevide(mm,np,msp,mep,mcp)
      !
      ! 鉛直分割情報
      !
      integer, intent(IN)  :: mm              ! 全格子点数
      integer, intent(IN)  :: np              ! 分割プロセス数
      integer, intent(OUT) :: msp(0:np-1)     ! 分割開始インデックス
      integer, intent(OUT) :: mep(0:np-1)     ! 分割終了インデックス
      integer, intent(OUT) :: mcp(0:np-1)     ! 分割インデックス数

      integer :: i, mint, mmod

      mint = mm/np
      mmod = mod(mm,np)
      mcp  = mint
      do i = 0,mmod-1
         mcp(i) = mcp(i)+1
      enddo

      msp(0)=1 ; mep(0) = msp(0) + mcp(0) -1
      do i = 1,np-1
         msp(i) = msp(i-1) + mcp(i-1)
         mep(i) = msp(i) + mcp(i) - 1
      end do

    end subroutine mpidevide

    !--------------- 基本関数 -----------------
    function kp_kl(kl)
      integer, intent(IN) :: kl             ! 層番号(全体)
      integer             :: kp_kl          ! 層番号(分割プロセス中)

      if ( ks .le. kl .AND. kl .le. ke ) then
         kp_kl = kl - ks + 1
      else
         kp_kl = 0
      endif

    end function kp_kl

    function lu_nm(n,m)
      integer, intent(IN) :: n              ! 全波数
      integer, intent(IN) :: m              ! 帯状波数
      integer             :: lu_nm          ! 位置情報(分割プロセス中)

      integer :: ll                         ! 位置情報(全体)

      ll = l_nm(n,m)
      if ( nms .le. ll .AND. ll .le. nme ) then
         lu_nm = ll-nms+1
      else
         lu_nm = 0
      endif

    end function lu_nm

    function nm_lu(l)
      integer, intent(IN) :: l              ! 位置情報(分割プロセス中)
      integer             :: nm_lu(2)        ! 全波数, 帯状波数

      nm_lu = nm_l(l+nms-1)

    end function nm_lu

    !--------------- データ入れ換え -----------------
    function xvb_pva(pva)
      !
      ! 格子点データ(経度・緯度分割)から格子点データ(緯度・層分割)へ変換する.
      !
      real(8), dimension(0:ic-1,jc,km), intent(in)   :: pva
      !(in) 2 次元球面調和函数(水平再分割) (nc,:)
      real(8), dimension(0:im-1,jc,kc)               :: xvb_pva
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), allocatable :: pvb_recv(:,:,:)

      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, iv
      integer :: itag
      integer, allocatable :: snd_rank_v(:)
      integer, allocatable :: rcv_rank_v(:)

      save snd_rank_v, rcv_rank_v !, rcv_idx

      if ( first_xvb_pva ) then
         first_xvb_pva = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))

         do iv=1,nproc_v-1
            rcv_rank_v(iv) = mod(iproc_v+iv,nproc_v)
            snd_rank_v(iv) = mod(iproc_v-iv+nproc_v,nproc_v)
         enddo

      endif

      !call MPI_Barrier(MPI_COMM_V,IERR)
      
!!$      if ( jc > 0 ) then
!!$         do iv=1,nproc_v-1
!!$            itag = 10000+iproc_h*1000+iproc_v
!!$            allocate(pvb_recv(icp(snd_rank_v(iv)),jc,kc))
!!$            call MPI_IRECV(pvb_recv,kc*jc*icp(snd_rank_v(iv)), MPI_REAL8, &
!!$                 snd_rank_v(iv), itag, MPI_COMM_V, IRQSTS, IERR)
!!$            itag = 10000+iproc_h*1000+rcv_rank_v(iv)
!!$            call MPI_SEND(pva(0,1,ksp(rcv_rank_v(iv))),ic*jc*kcp(rcv_rank_v(iv)), &
!!$                 MPI_REAL8, rcv_rank_v(iv),&
!!$                 itag,MPI_COMM_V,IERR)
!!$            CALL MPI_WAIT(IRQSTS,IST,IERR)
!!$            xvb_pva(isp(snd_rank_v(iv)):iep(snd_rank_v(iv)),:,:) = pvb_recv
!!$            deallocate(pvb_recv)
!!$         enddo
         do iv=1,nproc_v-1
            itag = 10000+iproc_h*1000+rcv_rank_v(iv)
            call MPI_ISEND(pva(0,1,ksp(rcv_rank_v(iv))),ic*jc*kcp(rcv_rank_v(iv)), &
                 MPI_REAL8, rcv_rank_v(iv),&
                 itag,MPI_COMM_V,IRQSTS,IERR)
            allocate(pvb_recv(icp(snd_rank_v(iv)),jc,kc))
            itag = 10000+iproc_h*1000+iproc_v
            call MPI_RECV(pvb_recv,kc*jc*icp(snd_rank_v(iv)), MPI_REAL8, &
                 snd_rank_v(iv), itag, MPI_COMM_V, IST, IERR)
            xvb_pva(isp(snd_rank_v(iv)):iep(snd_rank_v(iv)),:,:) = pvb_recv
            deallocate(pvb_recv)
            CALL MPI_WAIT(IRQSTS,IST,IERR)
         enddo
!!$      end if

      xvb_pva(is:ie,:,:) = pva(:,:,ks:ke)

    end function xvb_pva

    function pva_xvb(xvb)
      !
      ! 格子点データ(経度・緯度分割)から格子点データ(緯度・層分割)へ変換する.
      !
      real(8), dimension(0:im-1,jc,kc), intent(in)   :: xvb
      !(in) 2 次元球面調和函数(水平再分割) (nc,:)
      real(8), dimension(0:ic-1,jc,km)               :: pva_xvb
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), allocatable :: pvb_send(:,:,:)

      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, iv
      integer :: itag
      integer, allocatable ::snd_rank_v(:)
      integer, allocatable ::rcv_rank_v(:)
      integer, allocatable ::rcv_idx(:)

      save snd_rank_v, rcv_rank_v, rcv_idx

      if ( first_pva_xvb ) then
         first_pva_xvb = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         if ( allocated(rcv_idx) ) deallocate(rcv_idx)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))
         allocate(rcv_idx(0:nproc_v-1))

         do iv=1,nproc_v-1
            rcv_rank_v(iv) = mod(iproc_v+iv,nproc_v)
            snd_rank_v(iv) = mod(iproc_v-iv+nproc_v,nproc_v)
         enddo

         rcv_idx(0) = 1
         do iv=1,nproc_v-1
            rcv_idx(iv) = rcv_idx(iv-1)+kcp(iv-1)
         enddo
      endif

      !call MPI_Barrier(MPI_COMM_V,IERR)

      if ( jc > 0 ) then
         do iv=1,nproc_v-1
            itag = 20000+iproc_h*1000+iproc_v
            call MPI_IRECV(pva_xvb(0,1,rcv_idx(snd_rank_v(iv))),&
                 ic*jc*kcp(snd_rank_v(iv)), MPI_REAL8,    &
                 snd_rank_v(iv), itag, MPI_COMM_V, IRQSTS, IERR)
            allocate(pvb_send(icp(rcv_rank_v(iv)),jc,kc))
            pvb_send = xvb(isp(rcv_rank_v(iv)):iep(rcv_rank_v(iv)),:,:)
            itag = 20000+iproc_h*1000+rcv_rank_v(iv)
            call MPI_SEND(pvb_send, icp(rcv_rank_v(iv))*jc*kc,&
                 MPI_REAL8, rcv_rank_v(iv),&
                 itag,MPI_COMM_V,IERR)
            deallocate(pvb_send)
            CALL MPI_WAIT(IRQSTS,IST,IERR)
         enddo
      endif
      
      pva_xvb(:,:,ks:ke) = xvb(is:ie,:,:)

    end function pva_xvb

    function xa_pa(pa)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(:,:), intent(in)       :: pa
      !(in) 2 次元格子点データ(経度分割) (ic,:)
      real(8), dimension(0:im-1,size(pa,2))     :: xa_pa
      !(out) 2 次元格子点データ

      real(8), dimension(size(pa,2),ic)      :: ap
      real(8), dimension(size(pa,2),0:im-1)  :: ax

      integer :: a_size
      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, ip_v
      integer :: itag
      ! integer, allocatable ::snd_rank(:)
      integer, allocatable ::snd_rank_v(:)
      ! integer, allocatable ::rcv_rank(:)
      integer, allocatable ::rcv_rank_v(:)
      integer, allocatable ::rcv_idx(:)

      save snd_rank_v, rcv_rank_v, rcv_idx !, snd_rank, rcv_rank

      if ( first_xa_pa ) then
         first_xa_pa = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         if ( allocated(rcv_idx)    ) deallocate(rcv_idx)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))
         allocate(rcv_idx(0:nproc_v-1))

         do ip_v=1,nproc_v-1
            rcv_rank_v(ip_v) = mod(iproc_v+ip_v,nproc_v)
            snd_rank_v(ip_v) = mod(iproc_v-ip_v+nproc_v,nproc_v)
         enddo

         rcv_idx(0) = 0
         do ip_v=1,nproc_v-1
            rcv_idx(ip_v) = rcv_idx(ip_v-1)+icp(ip_v-1)
         enddo
      endif

      ap = transpose(pa)
      a_size = size(pa,2)

      !call MPI_Barrier(MPI_COMM_V,IERR)

      if ( a_size > 0 ) then
         do ip_v=1,nproc_v-1
            itag = 30000+iproc_h*1000+iproc_v
            call MPI_IRECV(ax(1,rcv_idx(snd_rank_v(ip_v))),  &
                 a_size*icp(snd_rank_v(ip_v)), MPI_REAL8,   &
                 snd_rank_v(ip_v), itag, MPI_COMM_V, IRQSTS, IERR)
            itag = 30000+iproc_h*1000+rcv_rank_v(ip_v)
            call MPI_SEND(ap, a_size*ic, MPI_REAL8, rcv_rank_v(ip_v),&
                 itag,MPI_COMM_V,IERR)
            CALL MPI_WAIT(IRQSTS,IST,IERR)
         enddo
      endif
      
      ax(:,is:ie) = ap

      xa_pa = transpose(ax)

    end function xa_pa

    function pa_xa(xa)
      !
      ! 水平格子データを再分割する
      !
      real(8), dimension(0:,:), intent(in) :: xa
      !(in) 2 次元格子点数データ (0:im-1,:)
      real(8), dimension(ic,size(xa,2))  :: pa_xa
      !(out) 2 次元格子点データ(経度分割)

      pa_xa = xa(is:ie,:)

    end function pa_xa
      
    function wb_ua(ua)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension(nmc,km), intent(in)       :: ua
      !(in) 2 次元球面調和函数(水平再分割) (nc,:)
      real(8), dimension(nc,kc)                    :: wb_ua
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), allocatable :: ua_recv(:,:)

      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, iv
      integer :: itag
      integer, allocatable ::snd_rank_v(:)
      integer, allocatable ::rcv_rank_v(:)
      integer, allocatable ::rcv_idx(:)

      save snd_rank_v, rcv_rank_v, rcv_idx

      if ( first_wb_ua ) then
         first_wb_ua = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         if ( allocated(rcv_idx) ) deallocate(rcv_idx)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))
         allocate(rcv_idx(0:nproc_v-1))

         do iv=1,nproc_v-1
            rcv_rank_v(iv) = mod(iproc_v+iv,nproc_v)
            snd_rank_v(iv) = mod(iproc_v-iv+nproc_v,nproc_v)
         enddo

         rcv_idx(0) = 1
         do iv=1,nproc_v-1
            rcv_idx(iv) = rcv_idx(iv-1)+nmcp(iv-1)
         enddo
      endif

      !call MPI_Barrier(MPI_COMM_W,IERR)
!!$      do iv=1,nproc_v-1
!!$         itag = 40000+iproc_h*1000+iproc_v
!!$         allocate(ua_recv(nmcp(snd_rank_v(iv)),kc))
!!$         call MPI_IRECV(ua_recv,kc*nmcp(snd_rank_v(iv)), MPI_REAL8,&
!!$              snd_rank_v(iv), itag, MPI_COMM_V, IRQSTS, IERR)
!!$         itag = 40000+iproc_h*1000+rcv_rank_v(iv)
!!$         call MPI_SEND(ua(1,ksp(rcv_rank_v(iv))),nmc*kcp(rcv_rank_v(iv)), &
!!$              MPI_REAL8, rcv_rank_v(iv),&
!!$              itag,MPI_COMM_V,IERR)
!!$         CALL MPI_WAIT(IRQSTS,IST,IERR)
!!$         wb_ua(nmsp(snd_rank_v(iv)):nmep(snd_rank_v(iv)),:) = ua_recv
!!$         deallocate(ua_recv)
!!$      enddo
!!$      !call MPI_Barrier(MPI_COMM_W,IERR)
      do iv=1,nproc_v-1
         itag = 40000+iproc_h*1000+rcv_rank_v(iv)
         call MPI_ISEND(ua(1,ksp(rcv_rank_v(iv))),nmc*kcp(rcv_rank_v(iv)), &
              MPI_REAL8, rcv_rank_v(iv),&
              itag,MPI_COMM_V,IRQSTS,IERR)
         allocate(ua_recv(nmcp(snd_rank_v(iv)),kc))
         itag = 40000+iproc_h*1000+iproc_v
         call MPI_RECV(ua_recv,kc*nmcp(snd_rank_v(iv)), MPI_REAL8,&
              snd_rank_v(iv), itag, MPI_COMM_V, IST, IERR)
         wb_ua(nmsp(snd_rank_v(iv)):nmep(snd_rank_v(iv)),:) = ua_recv
         deallocate(ua_recv)
         CALL MPI_WAIT(IRQSTS,IST,IERR)
      enddo
!!$      call MPI_Barrier(MPI_COMM_W,IERR)

      wb_ua(nms:nme,:) = ua(:,ks:ke)

    end function wb_ua

    function ua_wb(wb)
      !
      ! 水平スペクトル・層分割データを集める.
      !
      real(8), dimension(nc,kc), intent(in) :: wb
      !(in)  動径格子点データ(分割)
      real(8), dimension(nmc,km) :: ua_wb
      !(out) 動径格子点データ

      real(8), allocatable :: wb_send(:,:)

      integer :: IRQSTS
      integer :: IST( MPI_STATUS_SIZE )

      integer :: ierr, iv
      integer :: itag
      integer, allocatable ::snd_rank_v(:)
      integer, allocatable ::rcv_rank_v(:)
      integer, allocatable ::rcv_idx(:)

      save snd_rank_v, rcv_rank_v, rcv_idx

      if ( first_ua_wb ) then
         first_ua_wb = .false.
         if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
         if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
         if ( allocated(rcv_idx) ) deallocate(rcv_idx)
         allocate(snd_rank_v(1:nproc_v-1))
         allocate(rcv_rank_v(1:nproc_v-1))
         allocate(rcv_idx(0:nproc_v-1))

         do iv=1,nproc_v-1
            rcv_rank_v(iv) = mod(iproc_v+iv,nproc_v)
            snd_rank_v(iv) = mod(iproc_v-iv+nproc_v,nproc_v)
         enddo

         rcv_idx(0) = 1
         do iv=1,nproc_v-1
            rcv_idx(iv) = rcv_idx(iv-1)+kcp(iv-1)
         enddo
      endif

      call MPI_Barrier(MPI_COMM_W,IERR)
      do iv=1,nproc_v-1
         itag = 50000+iproc_h*1000+iproc_v
         call MPI_IRECV(ua_wb(1,rcv_idx(snd_rank_v(iv))),&
              nmc*kcp(snd_rank_v(iv)), MPI_REAL8,    &
              snd_rank_v(iv), itag, MPI_COMM_V, IRQSTS, IERR)

         allocate(wb_send(nmcp(rcv_rank_v(iv)),kc))
         wb_send = wb(nmsp(rcv_rank_v(iv)):nmep(rcv_rank_v(iv)),:)
         itag = 50000+iproc_h*1000+rcv_rank_v(iv)
         call MPI_SEND(wb_send, nmcp(rcv_rank_v(iv))*kc,&
              MPI_REAL8, rcv_rank_v(iv),&
              itag,MPI_COMM_V,IERR)
         deallocate(wb_send)
         CALL MPI_WAIT(IRQSTS,IST,IERR)
      enddo
      call MPI_Barrier(MPI_COMM_W,IERR)

!!$      call MPI_Barrier(MPI_COMM_W,IERR)
!!$      do iv=1,nproc_v-1
!!$         allocate(wb_send(nmcp(rcv_rank_v(iv)),kc))
!!$         wb_send = wb(nmsp(rcv_rank_v(iv)):nmep(rcv_rank_v(iv)),:)
!!$         call MPI_ISEND(wb_send, nmcp(rcv_rank_v(iv))*kc,&
!!$              MPI_REAL8, rcv_rank_v(iv),&
!!$              itag,MPI_COMM_V,IRQSTS,IERR)
!!$         deallocate(wb_send)
!!$         call MPI_RECV(ua_wb(1,rcv_idx(snd_rank_v(iv))),&
!!$              nmc*kcp(snd_rank_v(iv)), MPI_REAL8,    &
!!$              snd_rank_v(iv), itag, MPI_COMM_V, IST, IERR)
!!$         CALL MPI_WAIT(IRQSTS,IST,IERR)
!!$      enddo
!!$      call MPI_Barrier(MPI_COMM_W,IERR)

      ua_wb(:,ks:ke) = wb(nms:nme,:)

    end function ua_wb

   function wa_ua(ua)
     !
     ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
     !
     real(8), dimension(:,:), intent(in)       :: ua
     !(in) 2 次元球面調和函数(水平再分割) (nc,:)
     real(8), dimension(nc,size(ua,2))   :: wa_ua
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

     real(8), dimension(size(ua,2),nmc)  :: au
     real(8), dimension(size(ua,2),nc)   :: aw

     integer :: a_size
     integer :: IRQSTS
     integer :: IST( MPI_STATUS_SIZE )

     integer :: ierr, ip_v
     integer :: itag
     ! integer, allocatable ::snd_rank(:)
     integer, allocatable ::snd_rank_v(:)
     ! integer, allocatable ::rcv_rank(:)
     integer, allocatable ::rcv_rank_v(:)
     integer, allocatable ::rcv_idx(:)

     save snd_rank_v, rcv_rank_v, rcv_idx !, snd_rank, rcv_rank

     if ( first_wa_ua ) then
        first_wa_ua = .false.
        if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
        if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
        if ( allocated(rcv_idx)    ) deallocate(rcv_idx)
        allocate(snd_rank_v(1:nproc_v-1))
        allocate(rcv_rank_v(1:nproc_v-1))
        allocate(rcv_idx(0:nproc_v-1))

        do ip_v=1,nproc_v-1
           rcv_rank_v(ip_v) = mod(iproc_v+ip_v,nproc_v)
           snd_rank_v(ip_v) = mod(iproc_v-ip_v+nproc_v,nproc_v)
        enddo

        rcv_idx(0) = 1
        do ip_v=1,nproc_v-1
           rcv_idx(ip_v) = rcv_idx(ip_v-1)+nmcp(ip_v-1)
        enddo
     endif

     au = transpose(ua)
     a_size = size(ua,2)

     !call MPI_Barrier(MPI_COMM_V,IERR)
     do ip_v=1,nproc_v-1
        itag = 60000+iproc_h*1000+iproc_v
        call MPI_IRECV(aw(1,rcv_idx(snd_rank_v(ip_v))),  &
             a_size*nmcp(snd_rank_v(ip_v)), MPI_REAL8,   &
             snd_rank_v(ip_v), itag, MPI_COMM_V, IRQSTS, IERR)
         itag = 60000+iproc_h*1000+rcv_rank_v(ip_v)
        call MPI_SEND(au, a_size*nmc, MPI_REAL8, rcv_rank_v(ip_v),&
             itag,MPI_COMM_V,IERR)
        CALL MPI_WAIT(IRQSTS,IST,IERR)
     enddo

     aw(:,rcv_idx(iproc_v):rcv_idx(iproc_v)+nmcp(iproc_v)-1) = au

     wa_ua = transpose(aw)

   end function wa_ua

   function ua_wa(wa)
     !
     ! 水平スペクトルデータを再分割する
     !
     real(8), dimension(:,:), intent(in) :: wa
     !(in) 2 次元球面調和函数データ (nc,:)
     real(8), dimension(nmc,size(wa,2))  :: ua_wa
     !(out) 2 次元球面調和函数データ(水平再分割)

     ua_wa = wa(nms:nme,:)

   end function ua_wa

   function aa_ab(ab)
     !
     ! 水平スペクトル・動径格子点データを集める.
     !
     real(8), dimension(:,:), intent(in) :: ab
     !(in)  動径格子点データ(分割)
     real(8), dimension(size(ab,1),km)   :: aa_ab
     !(out) 動径格子点データ

     integer :: a_size
     integer :: IRQSTS
     integer :: IST( MPI_STATUS_SIZE )

     integer :: ierr, ip_v
     integer :: itag
     integer, allocatable ::snd_rank_v(:)
     integer, allocatable ::rcv_rank_v(:)
     integer, allocatable ::rcv_idx(:)

     save snd_rank_v, rcv_rank_v, rcv_idx

     if ( first_aa_ab ) then
        first_aa_ab = .false.
        if ( allocated(snd_rank_v) ) deallocate(snd_rank_v)
        if ( allocated(rcv_rank_v) ) deallocate(rcv_rank_v)
        if ( allocated(rcv_idx) )    deallocate(rcv_idx)
        allocate(snd_rank_v(1:nproc_v-1))
        allocate(rcv_rank_v(1:nproc_v-1))
        allocate(rcv_idx(0:nproc_v-1))

        do ip_v=1,nproc_v-1
           rcv_rank_v(ip_v) = mod(iproc_v+ip_v,nproc_v)
           snd_rank_v(ip_v) = mod(iproc_v-ip_v+nproc_v,nproc_v)
        enddo

        rcv_idx(0) = 1
        do ip_v=1,nproc_v-1
           rcv_idx(ip_v) = rcv_idx(ip_v-1)+kcp(ip_v-1)
        enddo
     endif

     a_size = size(ab,1)

     call MPI_Barrier(MPI_COMM_V,IERR)
     do ip_v=1,nproc_v-1
        itag = 70000+iproc_h*1000+iproc_v
        call MPI_IRECV(aa_ab(1,rcv_idx(snd_rank_v(ip_v))),&
             a_size*kcp(snd_rank_v(ip_v)), MPI_REAL8,    &
             snd_rank_v(ip_v), itag, MPI_COMM_V, IRQSTS, IERR)
        itag = 70000+iproc_h*1000+rcv_rank_v(ip_v)
        call MPI_SEND(ab, a_size*kc, MPI_REAL8, rcv_rank_v(ip_v),&
             itag,MPI_COMM_V,IERR)
        CALL MPI_WAIT(IRQSTS,IST,IERR)
     enddo

     aa_ab(:,rcv_idx(iproc_v):rcv_idx(iproc_v)+kcp(iproc_v)-1) = ab

   end function aa_ab

   function ab_aa(aa)
     !
     ! 水平スペクトル・動径格子点データを分割する.
     !
     real(8), dimension(:,:), intent(in) :: aa
     !(in)  動径格子点データ(:,0:km)
     real(8), dimension(size(aa,1),kc)    :: ab_aa
     !(out) 動径格子点データ(分割)

     ab_aa = aa(:,ks:ke)

   end function ab_aa

   !--------------- 基本変換(ua) -----------------
   
   function pva_ua(ua_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: ua_data(nmc,km)
     !(in) スペクトルデータ
     !
     real(8)               :: pva_ua(0:ic-1,jc,km)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     pva_ua = pva_xvb(xvb_ua(ua_data,ipow=ipval,iflag=ifval))

   end function pva_ua

   function ua_pva(pva_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: pva_data(0:ic-1,jc,km)
     !(in) スペクトルデータ
     !
     real(8)               :: ua_pva(nmc,km)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     ua_pva = ua_xvb(xvb_pva(pva_data),ipow=ipval,iflag=ifval)

   end function ua_pva

   function u_pv(pv_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
     !
     ! 格子データからスペクトルデータへ(正)変換する(多層用).
     !
     real(8), intent(in)   :: pv_data(0:ic-1,jc)
     !(in) 格子点データ

     real(8)               :: u_pv(nmc)
     !(out) スペクトルデータ

     integer, intent(in), optional  :: ipow
     !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

     integer, intent(in), optional  :: iflag
     ! 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた正変換
     !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
     !    2 : sinφを作用させた正変換
     !  省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
     integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

     integer ipval, ifval

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     u_pv = u_xv(xa_pa(pv_data),ipow=ipval,iflag=ifval)

   end function u_pv

   function pv_u(u_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: u_data(nmc)
     !(in) スペクトルデータ
     !
     real(8)               :: pv_u(0:ic-1,jc)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     pv_u = pa_xa(xv_u(u_data,ipow=ipval,iflag=ifval))

   end function pv_u

   function xvb_ua(ua_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: ua_data(nmc,km)
     !(in) スペクトルデータ
     !
     real(8)               :: xvb_ua(0:im-1,jc,kc)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     real(8) :: wb_data(nc,kc)
     integer :: k

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     wb_data = wb_ua(ua_data)

     do k=1,kc
        xvb_ua(:,:,k) = xv_w(wb_data(:,k),iflag=ifval,ipow=ipval)
     enddo

   end function xvb_ua

   function ua_xvb(xvb_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
     !
     ! 格子データからスペクトルデータへ(正)変換する(多層用).
     !
     real(8), intent(in)   :: xvb_data(0:im-1,jc,kc)
     !(in) 格子点データ

     real(8)               :: ua_xvb(nmc,km)
     !(out) スペクトルデータ

     integer, intent(in), optional  :: ipow
     !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

     integer, intent(in), optional  :: iflag
     ! 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた正変換
     !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
     !    2 : sinφを作用させた正変換
     !  省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
     integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

     integer ipval, ifval

     real(8) :: wb_data(nc,kc)
     integer k

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     do k=1,kc
        wb_data(:,k) = w_xv(xvb_data(:,:,k),iflag=ifval,ipow=ipval)
     enddo

     ua_xvb = ua_wb(wb_data)

   end function ua_xvb

   function xv_u(u_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: u_data(nmc)
     !(in) スペクトルデータ
     !
     real(8)               :: xv_u(0:im-1,jc)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     real(8) :: ua_data(nmc,1)
     real(8) :: wa_data(nc,1)

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     ua_data(:,1) = u_data
     wa_data = wa_ua(ua_data)
     xv_u = xv_w(wa_data(:,1),iflag=ifval,ipow=ipval)

   end function xv_u

   function u_xv(xv_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
     !
     ! 格子データからスペクトルデータへ(正)変換する(多層用).
     !
     real(8), intent(in)   :: xv_data(0:im-1,jc)
     !(in) 格子点データ

     real(8)               :: u_xv(nmc)
     !(out) スペクトルデータ

     integer, intent(in), optional  :: ipow
     !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

     integer, intent(in), optional  :: iflag
     ! 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた正変換
     !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
     !    2 : sinφを作用させた正変換
     !  省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
     integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

     integer ipval, ifval

     real(8) :: ua_data(nmc,1)
     real(8) :: wa_data(nc,1)

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     wa_data(:,1) = w_xv(xv_data,iflag=ifval,ipow=ipval)
     ua_data = ua_wa(wa_data)
     u_xv = ua_data(:,1)

   end function u_xv

   !--------------- 基本変換(wb) -----------------
   
   function pva_wb(wb_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: wb_data(nc,kc)
     !(in) スペクトルデータ
     !
     real(8)               :: pva_wb(0:ic-1,jc,km)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     pva_wb = pva_xvb(xvb_wb(wb_data,ipow=ipval,iflag=ifval))

   end function pva_wb

   function wb_pva(pva_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: pva_data(0:ic-1,jc,km)
     !(in) スペクトルデータ
     !
     real(8)               :: wb_pva(nc,kc)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     wb_pva = wb_xvb(xvb_pva(pva_data),ipow=ipval,iflag=ifval)

   end function wb_pva

   function w_pv(pv_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
     !
     ! 格子データからスペクトルデータへ(正)変換する(多層用).
     !
     real(8), intent(in)   :: pv_data(0:ic-1,jc)
     !(in) 格子点データ

     real(8)               :: w_pv(nc)
     !(out) スペクトルデータ

     integer, intent(in), optional  :: ipow
     !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

     integer, intent(in), optional  :: iflag
     ! 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた正変換
     !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
     !    2 : sinφを作用させた正変換
     !  省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
     integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

     integer ipval, ifval

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     w_pv = w_xv(xa_pa(pv_data),ipow=ipval,iflag=ifval)

   end function w_pv

   function pv_w(w_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: w_data(nc)
     !(in) スペクトルデータ
     !
     real(8)               :: pv_w(0:ic-1,jc)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     pv_w = pa_xa(xv_w(w_data,ipow=ipval,iflag=ifval))

   end function pv_w

   function xvb_wb(wb_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
     !
     ! スペクトルデータから格子データへ変換する(多層用).
     !
     real(8), intent(in)   :: wb_data(nc,kc)
     !(in) スペクトルデータ
     !
     real(8)               :: xvb_wb(0:im-1,jc,kc)
     !(out) 格子点データ
     !
     integer, intent(in), optional  :: ipow
     !(in) 作用させる 1/cosφ の次数. 省略時は 0.
     integer, intent(in), optional  :: iflag
     !(in) 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた逆変換
     !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
     !    2 : sinφを作用させた逆変換
     !    省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0
     integer, parameter  :: iflag_default = 0
     integer ipval, ifval

     integer :: k

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     do k=1,kc
        xvb_wb(:,:,k) = xv_w(wb_data(:,k),iflag=ifval,ipow=ipval)
     enddo

   end function xvb_wb

   function wb_xvb(xvb_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
     !
     ! 格子データからスペクトルデータへ(正)変換する(多層用).
     !
     real(8), intent(in)   :: xvb_data(0:im-1,jc,kc)
     !(in) 格子点データ

     real(8)               :: wb_xvb(nc,kc)
     !(out) スペクトルデータ

     integer, intent(in), optional  :: ipow
     !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

     integer, intent(in), optional  :: iflag
     ! 変換の種類
     !    0 : 通常の正変換
     !   -1 : 経度微分を作用させた正変換
     !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
     !    2 : sinφを作用させた正変換
     !  省略時は 0.
     !
     integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
     integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

     integer ipval, ifval

     integer k

     if (present(ipow)) then
        ipval = ipow
     else
        ipval = ipow_default
     endif

     if (present(iflag)) then
        ifval = iflag
     else
        ifval = iflag_default
     endif

     do k=1,kc
        wb_xvb(:,k) = w_xv(xvb_data(:,:,k),iflag=ifval,ipow=ipval)
     enddo

   end function wb_xvb
   
   !----------- 速度, 渦度・発散, 流線・ポテンシャル計算(ua) -------------
   
   subroutine ua_StreamPotential2VectorMPI(ua_Psi, ua_Chi, xvb_U, xvb_V)
     !
     ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
     ! (逆)変換する(多層用)
     !
     ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
     !
     !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ,
     !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ
     !
     real(8), intent(in)    :: ua_Psi(nmc,km)
     !(in) 流線関数((nm+1)*(nm+1),:)

     real(8), intent(in)    :: ua_Chi(nmc,km)
     !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

     real(8), intent(out)   :: xvb_U(0:im-1,jc,kc)
     !(out) 速度経度成分(0:im-1,1:jm,:)

     real(8), intent(out)   :: xvb_V(0:im-1,jc,kc)
     !(out) 速度緯度成分(0:im-1,1:jm,:)

     real(8) :: wb_Psi(nc,kc)
     !(in) 流線関数((nm+1)*(nm+1),:)

     real(8) :: wb_Chi(nc,kc)
     !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

     integer :: k

     wb_Psi = wb_ua(ua_Psi)
     wb_Chi = wb_ua(ua_Chi)

     do k=1,kc
        call w_StreamPotential2VectorMPI &
             ( wb_Psi(:,k), wb_Chi(:,k), xvb_U(:,:,k), xvb_V(:,:,k) )
     enddo

   end subroutine ua_StreamPotential2VectorMPI

   subroutine ua_Vector2VorDivMPI(xvb_U, xvb_V, ua_Vor, ua_Div)
     !
     ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
     ! (正)変換する(多層用)
     !
     ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
     !
     !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
     !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
     !
     real(8), intent(in)   :: xvb_U(0:im-1,jc,kc)
     !(in) 速度経度成分(0:im-1,1:jm,:)

     real(8), intent(in)   :: xvb_V(0:im-1,jc,kc)
     !(in) 速度緯度成分(0:im-1,1:jm,:)

     real(8), intent(out)   :: ua_Vor(nmc,km)
     !(out) 渦度
     real(8), intent(out)   :: ua_Div(nmc,km)
     !(out) 発散

     real(8)  :: wb_Vor(nc,kc)  ! 渦度
     real(8)  :: wb_Div(nc,kc)  ! 発散

     integer :: k

     do k=1,kc
        call w_Vector2VorDivMPI &
             (xvb_U(:,:,k), xvb_V(:,:,k), wb_Vor(:,k), wb_Div(:,k))
     enddo

     ua_Vor = ua_wb(wb_Vor)
     ua_Div = ua_wb(wb_Div)

   end subroutine ua_Vector2VorDivMPI

   subroutine ua_VectorCosLat2VorDivMPI(xvb_UCosLat, xvb_VCosLat, ua_Vor, ua_Div)
     !
     ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
     ! (正)変換する(多層用)
     !
     ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
     !
     !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
     !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
     !
     real(8), intent(in)   :: xvb_UCosLat(0:im-1,jc,kc)
     !(in) 速度経度成分 * cos(lat) (0:im-1,1:jm,:)

     real(8), intent(in)   :: xvb_VCosLat(0:im-1,jc,kc)
     !(in) 速度緯度成分 * cos(lat) (0:im-1,1:jm,:)

     real(8), intent(out)   :: ua_Vor(nmc,km)
     !(out) 流線関数
     real(8), intent(out)   :: ua_Div(nmc,km)
     !(out) 速度ポテンシャル

     real(8)  :: wb_Vor(nc,kc)  ! 渦度
     real(8)  :: wb_Div(nc,kc)  ! 発散

     integer :: k

     do k=1,kc
        call w_VectorCosLat2VorDivMPI &
             (xvb_UCosLat(:,:,k), xvb_VCosLat(:,:,k), wb_Vor(:,k), wb_Div(:,k))
     enddo

     ua_Vor = ua_wb(wb_Vor)
     ua_Div = ua_wb(wb_Div)

   end subroutine ua_VectorCosLat2VorDivMPI

   !----------- 速度, 渦度・発散, 流線・ポテンシャル計算(wb) -------------
   
   subroutine wb_StreamPotential2VectorMPI(wb_Psi, wb_Chi, pva_U, pva_V)
     !
     ! 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
     ! (逆)変換する(多層用)
     !
     ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
     !
     !   u cosφ =      ∂χ/∂λ - cosφ∂ψ/∂φ,
     !   v cosφ = cosφ∂χ/∂φ +      ∂ψ/∂λ
     !
     real(8), intent(in)    :: wb_Psi(nc,kc)
     !(in) 流線関数

     real(8), intent(in)    :: wb_Chi(nc,kc)
     !(in) 速度ポテンシャル((nm+1)*(nm+1),:)

     real(8), intent(out)   :: pva_U(0:ic-1,jc,km)
     !(out) 速度経度成分

     real(8), intent(out)   :: pva_V(0:ic-1,jc,km)
     !(out) 速度緯度成分

     real(8) :: xvb_U(0:im-1,jc,kc)
     !(out) 速度経度成分

     real(8) :: xvb_V(0:im-1,jc,kc)
     !(out) 速度緯度成分
     integer :: k

     do k=1,kc
        call w_StreamPotential2VectorMPI &
             ( wb_Psi(:,k), wb_Chi(:,k), xvb_U(:,:,k), xvb_V(:,:,k) )
     enddo

     pva_U = pva_xvb(xvb_U)
     pva_V = pva_xvb(xvb_V)      

   end subroutine wb_StreamPotential2VectorMPI

   subroutine wb_Vector2VorDivMPI(pva_U, pva_V, wb_Vor, wb_Div)
     !
     ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
     ! (正)変換する(多層用)
     !
     ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
     !
     !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
     !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
     !
     real(8), intent(in)   :: pva_U(0:ic-1,jc,km)
     !(in) 速度経度成分

     real(8), intent(in)   :: pva_V(0:ic-1,jc,km)
     !(in) 速度緯度成分

     real(8), intent(out)   :: wb_Vor(nc,kc)
     !(out) 渦度
     real(8), intent(out)   :: wb_Div(nc,kc)
     !(out) 発散

     real(8) :: xvb_U(0:im-1,jc,kc)
     !速度経度成分

     real(8) :: xvb_V(0:im-1,jc,kc)
     !速度緯度成分

     integer :: k

     xvb_U = xvb_pva(pva_U)
     xvb_V = xvb_pva(pva_V)

     do k=1,kc
        call w_Vector2VorDivMPI &
             (xvb_U(:,:,k), xvb_V(:,:,k), wb_Vor(:,k), wb_Div(:,k))
     enddo

   end subroutine wb_Vector2VorDivMPI

   subroutine wb_VectorCosLat2VorDivMPI(pva_UCosLat, pva_VCosLat, wb_Vor, wb_Div)
     !
     ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
     ! (正)変換する(多層用)
     !
     ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
     !
     !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
     !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
     !
     real(8), intent(in)  :: pva_UCosLat(0:ic-1,jc,km)
     !(in) 速度経度成分 * cos(lat)

     real(8), intent(in)  :: pva_VCosLat(0:ic-1,jc,km)
     !(in) 速度緯度成分 * cos(lat)

     real(8), intent(out) :: wb_Vor(nc,kc)
     !(out) 流線関数
     real(8), intent(out) :: wb_Div(nc,kc)
     !(out) 速度ポテンシャル

     real(8) :: xvb_UCosLat(0:im-1,jc,kc)
     !速度経度成分 * cos(lat)

     real(8) :: xvb_VCosLat(0:im-1,jc,kc)
     !速度緯度成分 * cos(lat)

     integer :: k

     xvb_UCosLat = xvb_pva(pva_UCosLat)
     xvb_VCosLat = xvb_pva(pva_VCosLat)      

     do k=1,kc
        call w_VectorCosLat2VorDivMPI &
             (xvb_UCosLat(:,:,k), xvb_VCosLat(:,:,k), wb_Vor(:,k), wb_Div(:,k))
     enddo

   end subroutine wb_VectorCosLat2VorDivMPI
   
   !--------------- 終了処理 -----------------
   subroutine ua_base_mpi_Finalize
     !
     !
     ! このサブルーチンを単独で用いるのでなく,
     ! 上位サブルーチン wa_Finalize を使用すること.
     !
     deallocate(isp)
     deallocate(iep)
     deallocate(icp)
     deallocate(ksp)
     deallocate(kep)
     deallocate(kcp)
     deallocate(nmsp)
     deallocate(nmep)
     deallocate(nmcp)

     deallocate(pv_Lon,pv_Lat)
     deallocate(p_Lon,p_Lon_Weight)

     call w_base_mpi_Finalize

     first_xvb_pva=.true.
     first_pva_xvb=.true.
     first_wb_ua=.true.
     first_ua_wb=.true.
     first_wa_ua=.true.
     first_aa_ab=.true.
     first_xa_pa=.true.

     call MessageNotify('M',     &
          & 'ua_base_mpi_finalize', &
          & 'ua_mpi_module_base is finalized (2020/08/17) ')

   end subroutine ua_base_mpi_Finalize

end module ua_mpi_module_base

!--
!----------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  ut_mpi_module
!
!    spml/ut_mpi_module モジュールは球面上および球殻内での流体運動を
!    スペクトル法と MPI 並列化によって数値計算するための Fortran90
!    関数を提供するものである.
!
!    水平方向に球面調和函数変換および上下の境界壁を扱うための
!    チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!    関数を提供する.
!
!    内部で ua_mpi_module_syapck を用いている. 最下部では球面調和変換
!    として SYPACK/ISPACK3 を, チェビシェフ変換のエンジンとして ISPACK の
!    サブルーチンを用いている.
!
!
!履歴  2002/05/19  竹広真一  yt_module よりモジュール名変更.
!                            格子点次元を区別する必要があるため.
!      2002/06/10  竹広真一  ポロイダル磁場境界条件ルーチン追加
!      2002/11/10  竹広真一  実空間での境界条件ルーチン追加
!      2002/11/24  竹広真一  チェビシェフ係数入出力の
!                            ラプラシアン逆解きルーチンを追加
!      2002/11/28  竹広真一  VGradV の計算変更.
!      2005/01/09  竹広真一  msgdmp -> MessageNotify に変更
!      2005/01/09  竹広真一  ベクトル場の回転の各成分を計算する関数を追加.
!      2005/02/19  竹広真一  トロイダル粘着境界条件にて非零速度場を
!                             与えられるようにオプションを追加
!      2005/02/19  竹広真一  変数 xy_Lon, xy_Lat を追加
!      2005/03/18  竹広真一  積分・平均関数を追加
!                            z_IntLon_xz, x_IntRad_xz, IntLonRad_xz
!                            z_InRad_xz, y_IntRad_yz, IntLatRad_yz
!                            IntRad_z
!                            z_IntLon_xz, x_IntRad_xz, IntLonRad_xz
!                            z_InRad_xz, y_IntRad_yz, IntLatRad_yz
!                            IntRad_z
!      2005/04/24  竹広真一  スペクトル解析計算ルーチンを追加
!                            nmz_ToroidalEnergySpectrum_wt
!                            nz_ToroidalEnergySpectrum_wt
!                            nmz_PoloidalEnergySpectrum_wt
!                            nz_PoloidalEnergySpectrum_wt
!                            内部変数欠損値 wt_VMiss を追加
!      2005/07/09  竹広真一  OPENMP 版変換ルーチンに対応
!      2006/03/03  竹広真一  配列サイズミス修正
!                            wt_wz, nmz_ToroidalEnergySpectrum_wt,
!                            nmz_PoloidalEnergySpectrum_wt
!      2006/03/08  竹広真一  コメントを RDoc 用に修正
!      2006/03/19  竹広真一  変数・手続き群の要約をコメントに追加
!      2007/08/11  竹広真一  境界値ルーチンのコメントを増強
!      2007/09/15  竹広真一  微分ルーチンのコメントを修正
!      2007/11/02  竹広真一  補間計算ルーチン追加
!      2007/11/11  竹広真一  境界条件関数サブルーチンに行列設定スイッチ導入
!      2007/11/21  竹広真一  初期化サブルーチンメッセージ出力
!      2008/01/07  竹広真一  xyz_RotLon_wt_wt, xyz_RotLat_wt_wt バグ修正
!      2008/01/13  竹広真一  wa_initial スイッチ導入
!      2008/05/29  竹広真一  MPI 並列化
!      2008/06/11  竹広真一  OPENMP スイッチ導入
!      2008/06/11  竹広真一  配列添え字変更
!      2009/02/27  佐々木洋平 RDoc 用のコメントを修正
!      2010/01/07  佐々木洋平  RDoc 用のドキュメント修正,
!                              include 'mpif.h' -> use mpi
!      2011/09/08  竹広真一   コメント修正
!      2011/09/12  竹広真一   wt_mpi_Initial に wa_init スイッチ導入
!      2012/05/25  竹広真一   wt_QoperatorMPI_wt を追加
!      2012/08/24  竹広真一   wt_LaplaPol2Pol_wt を追加
!      2013/08/20  竹広真一  gnu fortran 対応
!      2014/03/10  竹広真一  wt_mpi_module_nm に改造
!      2014/03/17  竹広真一  mint パラメターに対応
!      2014/03/21  竹広真一  OpenMP 版
!      2015/02/15  竹広真一  Interpolate 関数追加
!      2016/03/02  竹広真一  nz_ToroidalEnergySpectrum_wt,
!                            nz_PoloidalEnergySpectrum_wt 追加
!      2016/11/04  竹広真一  nmz_ToroidalEnergySpectrum_wt,
!                            nmz_PoloidalEnergySpectrum_wt 追加
!      2017/02/07  竹広真一  wt_mpi_Finalize 追加
!      2017/10/26  竹広真一  ut_mpi_module_nmomp に改造
!      2017/11/07  竹広真一  ut_mpi_module_nmomp_lp に改造
!      2017/11/11  竹広真一  ut_wh, wh_ut を追加
!      2018/01/28  竹広真一  ut_mpi_module_nmomp に改名
!      2018/06/14  竹広真一  ut_mpi_module_extomp に改名, 変数定義変更
!      2019/05/28  竹広真一  ut_mpi_module に改造
!      2020/01/25  竹広真一  u_xv, xv_u を ua_mpi_module に移動
!      2021/11/15  竹広真一  Potentail2VectorMPI を ua_Potentail2VectorMPI で計算
!                             ut_Vector2VorDivMPI, ut_RadRot_RadRotRotRot を作成
!      2023/03/22  竹広真一  Intel Compiler で jc, lc が public 変数として
!                            認識されない問題に対応
!
!凡例
!      データ種類と index
!        x : 経度   y : 緯度    v : 緯度(分散格子) z : 動径  h : 動径(分散格子)
!        w : 球面調和関数スペクトル
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(帯状波数)
!        t : チェビシェフ関数スペクトル
!        a : 任意の次元
!
!        xvh : 3 次元分散格子点データ
!        xv  : 水平 2 次元格子点データ
!        vh  : 子午面 2 次元格子点データ
!        xh  : 緯度面 2 次元格子点データ
!
!        wz  : 水平スペクトル動径格子点データ
!        wt  : スペクトルデータ
!
!++
module ut_mpi_module
  !
  != ut_mpi_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: wt_mpi_module.f90 598 2013-08-20 03:23:44Z takepiro $
  ! Copyright&License:: See COPYRIGHT[link:../../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wt_mpi_module モジュールは球面上および球殻内での流体運動を
  ! スペクトル法と MPI 並列化によって数値計算するための Fortran90
  ! 関数を提供するものである.
  !
  ! 水平方向に球面調和函数変換および上下の境界壁を扱うための
  ! チェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
  ! 関数を提供する.
  !
  ! 内部で ua_mpi_module_syapck を用いている. 最下部では球面調和変換
  ! として SYPACK/ISPACK3 を, チェビシェフ変換のエンジンとして ISPACK の
  ! サブルーチンを用いている.
  !
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭(ut_, nmz_, nz_, xyz_, xvh_ uz_, w_, xv_, x_, y_, z_, a_)は,
  !   返す値の形を示している.
  !      ut_ :: スペクトルデータ(球面調和函数・チェビシェフ変換)
  !     xvh_ :: 3 次元分散格子点データ(経度・緯度・動径)
  !      uz_ :: 水平スペクトル, 動径格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (_ut, _xyz, _xvh, _uz_, _w, _xy, _xv, _x, _y, _z, _a) は,
  !   入力変数の形がスペクトルデータおよび格子点データであることを示している.
  !         _ut :: スペクトルデータ
  !        _xvh :: 3 次元分散格子点データ
  !    _xvh_xvh :: 2 つの3 次元分散格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xvh : 3 次元分散格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,jc,kc).
  !   * im, は経度の格子点数である.
  !   * jc, kc はこのプロセスで保有する緯度・動径格子点数である.
  !     サブルーチン ut_mpi_Initial を呼ぶと jc が設定される.
  !
  ! * wh : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(nc,kc).
  !   * nc はこのプロセスで保有する球面調和函数成分の数,
  !     lm はチェビシェフ多項式の最大次数であり,
  !     サブルーチン ut_mpi_Initial を呼ぶと nc が設定される.
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる.
  !
  ! * ut : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension(nmc,0:lm).
  !   * nmc はこのプロセスで保有する球面調和函数成分の数,
  !     lm はチェビシェフ多項式の最大次数であり,
  !     サブルーチン ut_mpi_Initial を呼ぶと nc が設定される.
  !   * 水平スペクトルデータの格納のされ方は関数 lu_nm, nm_lu によって調べる
  !     ことができる.
  !
  ! * uz : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension(nmc,0:km).
  !
  ! * ut_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xvh_ で始まる関数が返す値は 3 次元分散格子点データに同じ.
  !
  ! * uz_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  !
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! ut_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  !
  !==== 座標変数
  !
  ! x_Lon, x_Lon_Weight,  ::  格子点座標(経度)と重みを格納した 1 次元配列
  ! y_Lat, y_Lat_Weight   ::  格子点座標(緯度)と重みを格納した 1 次元配列
  ! v_Lat, v_Lat_Weight   ::  分散格子点座標(緯度)と重みを格納した 1 次元配列
  ! z_Rad, z_Rad_Weight   ::  格子点座標(同形)と重みを格納した 1 次元配列
  ! xvh_Lon, xvh_Lat, xvh_Rad :: 格子点データの経度・緯度・動径座標(X,Y,Z) (分散格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xvh_ut, ut_xvh :: スペクトルデータと 3 次元分散格子データの間の変換 (球面調和函数, チェビシェフ変換)
  !
  ! xvh_uz, uz_xvh :: 3 次元分散格子データと水平スペクトル・動径格子データとの間の変換 (球面調和函数)
  !
  ! uz_ut, ut_uz   :: スペクトルデータと水平スペクトル・動径格子データとの間の変換 (チェビシェフ変換)
  !
  ! w_xv, xv_w     :: スペクトルデータと 2 次元水平分散格子データの間の変換(球面調和函数変換)
  !
  ! az_at, at_az   :: 同時に複数個行う (チェビシェフ変換)格子データとチェビシェフデータの間の変換を
  !
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換
  !
  !==== 微分
  !
  ! ut_DRad_ut     :: スペクトルデータに動径微分∂/∂r を作用させる
  ! ut_DivRad_ut   :: スペクトルデータに発散型動径微分 1 /r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  !
  ! ut_RotRad_ut   :: スペクトルデータに回転型動径微分 1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  !
  ! ut_Lapla_ut    :: スペクトルデータにラプラシアンを作用させる
  !
  ! xvh_GradLon_ut :: スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λを作用させる
  !
  ! xvh_GradLat_ut :: スペクトルデータに勾配型緯度微分 1/r・∂/∂φを作用させる(分散格子)
  ! ut_DivLon_xvh  :: 分散格子データに発散型経度微分 1/rcosφ・∂/∂λを作用させる
  ! ut_DivLat_xvh  :: 分散格子データに発散型緯度微分 1/rcosφ・∂(g cosφ)/∂φを作用させる(分散格子)
  !
  ! ut_Div_xvh_xvh_xvh  :: ベクトル成分である 3 つの分散格子データに発散を作用させる
  ! xvh_Div_xvh_xvh_xvh :: ベクトル成分である 3 つの分散格子データに発散を作用させる
  ! xvh_RotLon_ut_ut  :: ベクトル場の回転の経度成分を計算する(分散格子)
  ! xvh_RotLat_ut_ut  :: ベクトル場の回転の緯度成分を計算する(分散格子)
  ! ut_RotRad_xyz_xyz :: ベクトル場の回転の動径成分を計算する
  ! ut_RotRad_xvh_xvh :: ベクトル場の回転の動径成分を計算する(分散格子)
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! ut_L2_ut        :: スペクトルデータに L2 演算子 = -水平ラプラシアンを作用させる
  !
  ! ut_L2Inv_ut     :: スペクトルデータに L2 演算子の逆 = -逆水平ラプラシアンを作用させる
  !
  ! ut_RadRot_xvh_xvh :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を計算する(分散格子)
  ! ut_RadRotRot_xvh_xvh_xvh :: ベクトルの v の r・(▽×▽×v) を計算する(分散格子)
  ! ut_Potential2VectorMPI   :: トロイダルポロイダルポテンシャルからベクトル場を計算する(分散格子)
  !
  ! ut_Potential2RotationMPI :: トロイダルポロイダルポテンシャルで表される非発散ベクトル場の回転の各成分を計算する(分散格子)
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmz_ToroidalEnergySpectrum_ut, :: トロイダルポテンシャルからエネルギーの
  ! nz_ToroidalEnergySpectrum_ut   :: 球面調和函数各成分を計算する
  !
  ! nmz_PoloidalEnergySpectrum_ut, :: ポロイダルポテンシャルからエネルギーの
  ! nz_PoloidalEnergySpectrum_ut   :: 球面調和函数各成分を計算する
  !
  !==== 境界値問題
  !
  ! ut_BoundariesTau,    :: ディリクレ, ノイマン境界条件を適用する
  ! ut_BoundariesGrid,   ::(タウ法, 選点法)
  ! ut_Boundaries        ::
  !
  ! ut_TorBoundariesTau,  :: 速度トロイダルポテンシャルの境界条件を
  ! ut_TorBoundariesGrid, :: 適用する(タウ法,選点法)
  ! ut_TorBoundaries      ::
  !
  ! uz_LaplaPol2Pol_uz,   :: 速度ポロイダルポテンシャルΦを▽^2Φから
  ! ut_LaplaPol2Pol_ut    :: 求める (入出力がそれぞれチェビシェフ格子点,
  !                       :: チェビシェフ係数)
  !
  ! ut_TorMagBoundariesTau,  :: 磁場トロイダルポテンシャルの境界条件を
  ! ut_TorMagBoundariesGrid, :: 適用する(タウ法, 選点法)
  ! ut_TorMagBoundaries      ::
  !
  ! ut_PolMagBoundariesTau,  :: 磁場トロイダルポテンシャル境界の境界条件を
  ! ut_PolMagBoundariesGrid, :: 適用する(タウ法, 選点法)
  ! ut_PolMagBoundaries      ::
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xvh, AvrLonLatRad_xvh :: 3 次元格子点データの全領域積分および平均
  !
  ! h_IntLonLat_xvh, h_AvrLonLat_xvh :: 3 次元格子点データの緯度経度(水平・球面)積分および平均
  !
  ! v_IntLonRad_xvh, v_AvrLonRad_xvh :: 3 次元格子点データの緯度動径積分および平均
  !
  ! h_IntLatRad_xvh, h_AvrLatRad_xvh :: 3 次元格子点データの経度動径(子午面)積分および平均
  !
  ! vh_IntLon_xvh, vz_AvrLon_xvh :: 3 次元格子点データの経度方向積分および平均
  ! xh_IntLat_xvh, xz_AvrLat_xvh :: 3 次元格子点データの緯度方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xv, AvrLonLat_xv :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xh, AvrLonRad_xh :: 2 次元(XZ)格子点データの経度動径積分
  !                            :: および平均
  ! IntLatRad_vh, AvrLatRad_vh :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                            :: 積分および平均
  ! v_IntLon_xv, v_AvrLon_xv   :: 水平 2 次元(球面)格子点データの経度方向
  !                            :: 積分および平均
  ! v_IntLat_xv, x_AvrLat_xv   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                            :: および平均
  ! h_IntLon_xh, h_AvrLon_xh   :: 2 次元(XZ)格子点データの経度方向積分および
  !                            :: 平均
  ! h_IntRad_xh, x_AvrRad_xh   :: 2 次元(XZ)格子点データの動径方向積分および
  !                            :: 平均
  ! h_IntLat_vh, z_AvrLat_vh   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                            :: 平均
  ! v_IntRad_vh, v_AvrRad_vh   :: 2 次元(YZ)格子点データの動径方向積分および
  !                            :: 平均
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_v, AvrLat_v  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_h, AvrRad_h  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  !==== 補間計算
  !
  ! Interpolate_ut :: スペクトルデータから任意の点の値を補間する.
  !
  use dc_types, only: DP
  use dc_message
  use lumatrix
  use mpi
  use ua_mpi_module, jc_ua_mpi=>jc, nc_ua_mpi=>nc, &
       ks_ua_mpi=>ks, ke_ua_mpi=>ke, kc_ua_mpi=>kc, &
       nms_ua_mpi=>nms, nme_ua_mpi=>nme, nmc_ua_mpi=>nmc
!!$       ua_mpi_initial, &
!!$       xvb_GradLon_ua, xvb_GradLat_ua, ua_DivLon_xvb, ua_DivLat_xvb, &
!!$       ua_Lapla_ua, ua_LaplaInv_ua, &
!!$       ut_uz, uz_ut
  use ua_mpi_module_base, only: &
    & MPI_COMM_H, MPI_COMM_V, iproc, iproc_h, iproc_v
  use w_mpi_module, only : y_Lat, y_Lat_Weight, &
       w_Vector2VorDivMPI, &
       Interpolate_w
  use at_module, &
    & z_RAD => g_X, z_RAD_WEIGHT => g_X_WEIGHT, &
    & at_az => at_ag, az_at => ag_at, &
    & t_z => t_g, z_t => g_t, &
    & t_Dr_t => t_Dx_t, at_Dr_at => at_Dx_at

  implicit none

  private

  public ut_mpi_Initial, ut_mpi_Finalize

  public nproc_h, nproc_v
  public iproc_h, iproc_v

  public jc                                   ! 緯度方向分散格子点数
  public ks,ke,kc
  public nc                                   ! MPI 分割水平波数(w_)
  public nms,nme,nmc                          ! MPI 分割水平波数(u_)

  public l_nm, nm_l
  public lu_nm, nm_lu
  public kp_kl

  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public v_Lat, v_Lat_Weight
  public z_Rad, z_Rad_Weight
  public h_Rad, h_Rad_Weight
  public xv_Lon, xv_Lat
  public xvh_Lon, xvh_Lat, xvh_Rad
  public wh_Rad
  public uz_Rad
  public ut_VMiss

  public u_xv, xv_u
  public at_Dr_at, t_Dr_t, az_at, at_az
  !public xvh_wt, wt_xvh, xvh_wh, wh_xvh
  public xvh_ut, ut_xvh
  public ut_wh, wh_ut, ua_wa, wa_ua
  public wz_uz, uz_wz, wz_wh, wh_wz
  !public wz_wh, wh_wz, wz_uz, uz_wz, az_ah, ah_az
  public wz_wt, wt_wz, wt_ut, ut_wt, uz_ut, ut_uz
  public ut_DRad_ut, ut_DivRad_ut, ut_RotRad_ut
  public ut_Lapla_ut, ua_LaplaH_ua, ua_LaplaHInv_ua
  public xvh_GradLon_ut, xvh_Gradlat_ut
  public ut_DivLon_xvh, ut_DivLat_xvh
  public ut_Div_xvh_xvh_xvh, xvh_Div_xvh_xvh_xvh
  public xvh_RotLon_ut_ut, xvh_RotLat_ut_ut, ut_RotRad_xvh_xvh

  public vh_IntLon_xvh, xh_IntLat_xvh, xv_IntRad_xvh
  public x_IntLatRad_xvh, v_IntLonRad_xvh, h_IntLonLat_xvh
  public IntLonLatRad_xvh

  public h_IntLon_xh, x_IntRad_xh, IntLonRad_xh
  public IntLon_x, IntRad_h, IntRad_z

  public x_IntLat_xv, v_IntLon_xv, IntLonLat_xv
  public h_IntLat_vh, v_IntRad_vh, IntLatRad_vh
  public IntLat_v

  public vh_AvrLon_xvh, xh_AvrLat_xvh, xv_AvrRad_xvh
  public x_AvrLatRad_xvh, v_AvrLonRad_xvh, h_AvrLonLat_xvh
  public AvrLonLatRad_xvh

  public h_AvrLon_xh, x_AvrRad_xh, AvrLonRad_xh
  public AvrLon_x, AvrRad_h, AvrRad_z

  public x_AvrLat_xv, v_AvrLon_xv, AvrLonLat_xv
  public h_AvrLat_vh, v_AvrRad_vh, AvrLatRad_vh
  public AvrLat_v

  public ut_L2_ut, ut_L2Inv_ut
  public ut_RadRot_xvh_xvh, ut_RadRotRot_xvh_xvh_xvh
  public ut_RadRot_RadRotRot
  public ut_Potential2vectorMPI, ut_Potential2RotationMPI
  public ut_Vector2VorDivMPI

  public Interpolate_ut

  public nmz_ToroidalEnergySpectrum_ut, nz_ToroidalEnergySpectrum_ut
  public nmz_PoloidalEnergySpectrum_ut, nz_PoloidalEnergySpectrum_ut

  public ut_Boundaries, ut_TorBoundaries
  public ut_LaplaPol2Pol_ut, uz_LaplaPol2Pol_uz
  public ut_TormagBoundaries, ut_PolmagBoundaries

  public ut_BoundariesTau, ut_TorBoundariesTau, ut_LaplaPol2PolTau_ut
  public ut_TormagBoundariesTau, ut_PolmagBoundariesTau

  public ut_BoundariesGrid, ut_TorBoundariesGrid, ut_LaplaPol2PolGrid_ut
  public ut_TormagBoundariesGrid, ut_PolmagBoundariesGrid

  interface Interpolate_ut
     !
     ! 緯度 alon, 経度 alat 動径 arad における関数値を
     ! そのスペクトルデータ wt_data から補間計算する
     !
     ! 入力する緯度経度座標は,
     !       １点, 経度複数点緯度動径1点
     ! の 2 種類
     !
     module procedure Interpolate_array000_ut
     module procedure a_Interpolate_array100_ut
  end interface

  interface ut_Boundaries
     module procedure ut_BoundariesTau
  end interface

  interface ut_TorBoundaries
     module procedure ut_TorBoundariesTau
  end interface

  interface ut_LaplaPol2Pol_ut
     module procedure ut_LaplaPol2PolTau_ut
  end interface

  interface ut_TorMagBoundaries
     module procedure ut_TorMagBoundariesTau
  end interface

  interface ut_PolMagBoundaries
     module procedure ut_PolMagBoundariesTau
  end interface

  integer            :: im=64, jm=32, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=16         ! 切断波数の設定(水平, 動径)
  real(DP)            :: ri=0.0, ro=1.0       ! 球殻内外半径
  real(DP), parameter :: pi=3.1415926535897932385D0

  integer              :: jc, nc
  integer              :: ks, ke, kc
  integer              :: nms, nme, nmc

  real(DP), dimension(:,:,:), allocatable :: xvh_LON, xvh_LAT, xvh_RAD ! 座標
  real(DP), dimension(:,:), allocatable   :: wh_RAD                    ! 座標
  real(DP), dimension(:,:), allocatable   :: uz_RAD                    ! 座標
  real(DP), dimension(:), allocatable     :: h_rad                     ! 座標
  real(DP), dimension(:), allocatable     :: h_rad_weight              ! 座標

  real(DP) :: ut_VMiss = -999.0        ! 欠損値

!!$  integer              :: ks, ke, kc
!!$  integer, allocatable :: ksp(:), kep(:), kcp(:)
!!$
!!$  integer              :: nc
!!$  integer              :: nms, nme, nmc
!!$  integer, allocatable :: nmsp(:), nmep(:), nmcp(:)

  save im, jm, km, nm, lm, ri, ro, ut_VMiss
  save nc, jc, ks, ke, kc, nms, nme, nmc

contains
  !--------------- 初期化 -----------------
  subroutine ut_mpi_Initial(i,j,k,n,l,r_in,r_out,np,npv)
     !
     ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない.
     !
     integer,intent(in) :: i              ! 格子点数(経度λ)
     integer,intent(in) :: j              ! 格子点数(緯度φ)
     integer,intent(in) :: k              ! 格子点数(動径 r)
     integer,intent(in) :: n              ! 切断波数(水平全波数)
     integer,intent(in) :: l              ! 切断波数(動径波数)

     real(DP),intent(in) :: r_in           ! 球殻内半径
     real(DP),intent(in) :: r_out          ! 球殻外半径

     integer,intent(in), optional :: np   ! OPENMP での最大スレッド数(dummy)
     integer,intent(in), optional :: npv  ! 鉛直並列プロセス数

     logical :: wa_initialize=.true.   ! wa_initial スイッチ
     integer :: npv_in                 ! 鉛直並列プロセス数

     im = i  ; jm = j ; km = k
     nm = n  ; lm = l
     ri = r_in ; ro = r_out

     if (present(npv)) then
        npv_in = npv
     else
        npv_in = 1
     endif

     if ( wa_initialize ) then
        if ( present(np) ) then
           call ua_mpi_Initial(nm,im,jm,km+1,np=np,npv=npv_in)
        else
           call ua_mpi_Initial(nm,im,jm,km+1,npv=npv_in)
        endif
     endif

     call at_Initial(km,lm,r_in,r_out)

     nc = nc_ua_mpi ; jc = jc_ua_mpi
     ks = ks_ua_mpi; ke = ke_ua_mpi; kc = kc_ua_mpi
     nms = nms_ua_mpi; nme = nme_ua_mpi; nmc = nmc_ua_mpi
     
     allocate(h_Rad(kc))
     allocate(h_Rad_Weight(kc))

     allocate(xvh_Lon(0:im-1,jc,kc))
     allocate(xvh_Lat(0:im-1,jc,kc))
     allocate(xvh_Rad(0:im-1,jc,kc))

     allocate(wh_Rad(nc,kc))
     allocate(uz_Rad(nmc,0:km))

     z_Rad_Weight = z_Rad_Weight * z_Rad**2     ! r^2 dr の積分重み
     h_Rad = z_Rad(ks-1:ke-1)
     h_Rad_Weight = z_Rad_Weight(ks-1:ke-1)

     xvh_Lon = spread(xv_Lon,3,kc)
     xvh_Lat = spread(xv_Lat,3,kc)
     xvh_Rad = spread(spread(h_Rad,1,jc),1,im)

     wh_Rad = spread(h_Rad,1,nc)
     uz_Rad = spread(z_Rad,1,nmc)

     call MessageNotify('M','ut_mpi_initial', &
          'ut_mpi_module (2021/11/15) is initialized')

   end subroutine ut_mpi_Initial

   !--------------- 基本変換 -----------------

   function ut_xvh(xvh)
     !
     ! 3 次元格子点データからスペクトルデータへ(正)変換する.
     !
     real(DP), dimension(nmc,0:lm)                   :: ut_xvh
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

     real(DP), dimension(0:im-1,jc,kc), intent(in)  :: xvh
     !(in) 3 次元経度緯度動径格子点データ

     !ut_xvh = ut_uz(uz_wz(wz_wh(wh_xvh(xvh))))
     ut_xvh = ut_uz(ua_xvb(xvh))

   end function ut_xvh

   function xvh_ut(ut)
     !
     ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
     !
     real(DP), dimension(0:im-1,jc,kc)        :: xvh_ut
     !(out) 3 次元経度緯度動径格子点データ

     real(DP), dimension(nmc,0:lm), intent(in) :: ut
     !(in) 2 次元球面調和函数スペクトル・動径格子点データ

     xvh_ut = xvb_ua(uz_ut(ut))

   end function xvh_ut

!!$   function wt_xvh(xvh)
!!$     !
!!$     ! 3 次元格子点データからスペクトルデータへ(正)変換する.
!!$     !
!!$     real(DP), dimension(nc,0:lm)             :: wt_xvh
!!$     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$     real(DP), dimension(0:im-1,jc,kc), intent(in)  :: xvh
!!$     !(in) 3 次元経度緯度動径格子点データ
!!$
!!$     wt_xvh = wt_uz(ua_xvb(xvh))
!!$
!!$   end function wt_xvh
!!$
!!$   function xvh_wt(wt)
!!$     !
!!$     ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
!!$     !
!!$     real(DP), dimension(0:im-1,jc,kc)              :: xvh_wt
!!$     !(out) 3 次元経度緯度動径格子点データ
!!$
!!$     real(DP), dimension(nc,0:lm), intent(in) :: wt
!!$     !(in) 2 次元球面調和函数スペクトル・動径格子点データ
!!$
!!$     xvh_wt = xvb_ua(uz_wt(wt))
!!$
!!$   end function xvh_wt
!!$
!!$   function wh_xvh(xvh)
!!$     !
!!$     ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
!!$     !
!!$     real(DP), dimension(nc,kc)              :: wh_xvh
!!$     !(out) 2 次元球面調和函数スペクトル・動径格子点データ
!!$
!!$     real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
!!$     !(in) 3 次元経度緯度動径格子点データ
!!$
!!$     wh_xvh = wb_xvb(xvh)
!!$
!!$   end function wh_xvh
!!$
!!$   function xvh_wh(wh)
!!$     !
!!$     ! 水平スペクトル・動径格子点データから 3 次元格子データへ(逆)変換する.
!!$     !
!!$     real(DP), dimension(0:im-1,jc,kc)            :: xvh_wh
!!$     !(out) 2 次元球面調和函数スペクトル・動径格子点データ
!!$
!!$     real(DP), dimension(nc,kc), intent(in) :: wh
!!$     !(in) 3 次元経度緯度動径格子点データ
!!$
!!$     xvh_wh = xvb_wb(wh)
!!$
!!$   end function xvh_wh
!!$
!!$   function u_xv(xv)
!!$     !
!!$     ! 2 次元格子データから水平スペクトル(正)変換する.
!!$     !
!!$     real(DP), dimension(nmc)                    :: u_xv
!!$     !(out) 2 次元球面調和函数スペクトル・動径格子点データ
!!$
!!$     real(DP), dimension(0:im-1,jc), intent(in) :: xv
!!$     !(in) 3 次元経度緯度動径格子点データ
!!$
!!$     u_xv = reshape(ua_wa(reshape(w_xv(xv),(/nc,1/))),(/nmc/))
!!$
!!$   end function u_xv
!!$
!!$   function xv_u(u)
!!$     !
!!$     ! 水平スペクトルデータから 2 次元格子データへ(逆)変換する.
!!$     !
!!$     real(DP), dimension(0:im-1,jc)      :: xv_u
!!$     !(out) 2 次元球面調和函数スペクトル・動径格子点データ
!!$
!!$     real(DP), dimension(nmc), intent(in) :: u
!!$     !(in) 3 次元経度緯度動径格子点データ
!!$
!!$     xv_u = xv_w(reshape(wa_ua(reshape(u,(/nmc,1/))),(/nc/)))
!!$
!!$   end function xv_u

   function ut_wh(wh)
     !
     ! 水平スペクトル・動径格子点データを集める.
     !
     real(DP), dimension(nc,kc), intent(in) :: wh
     !(in)  2 次元球面調和函数スペクトル・動径格子点データ(分割)
     real(DP), dimension(nmc,0:lm)                 :: ut_wh
     !(out) 2 次元球面調和函数スペクトル・動径格子点データ

     !ut_wh = ut_uz(uz_wz(wz_wh(wh)))
     ut_wh = ut_uz(uz_wh(wh))

   end function ut_wh

   function wh_ut(ut)
     !
     ! 水平スペクトル・動径格子点データを分割する.
     !
     real(DP), dimension(nmc,0:lm), intent(in)       :: ut
     !(in) 2 次元球面調和函数スペクトル・動径格子点データ
     real(DP), dimension(nc,kc)               :: wh_ut
     !(out) 2 次元球面調和函数スペクトル・動径格子点データ(分割)

     wh_ut = wh_uz(uz_ut(ut))

   end function wh_ut

   function wz_wh(wh)
     !
     ! 水平スペクトル・動径格子点データを集める.
     !
     real(DP), dimension(nc,kc), intent(in) :: wh
     !(in)  2 次元球面調和函数スペクトル・動径格子点データ(分割)
     real(DP), dimension(nc,0:km)           :: wz_wh
     !(out) 2 次元球面調和函数スペクトル・動径格子点データ

     wz_wh = aa_ab(wh)

   end function wz_wh

   function wh_wz(wz)
     !
     ! 水平スペクトル・動径格子点データを分割する.
     !
     real(DP), dimension(nc,0:km), intent(in) :: wz
     !(in) 2 次元球面調和函数スペクトル・動径格子点データ
     real(DP), dimension(nc,kc)               :: wh_wz
     !(out) 2 次元球面調和函数スペクトル・動径格子点データ(分割)

     wh_wz = ab_aa(wz)

   end function wh_wz

   function wz_wt(wt)
     !
     ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
     !
     real(DP), dimension(nc,0:lm), intent(in) :: wt
     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
     real(DP), dimension(nc,0:km)             :: wz_wt
     !(out) 2 次元球面調和函数スペクトル・動径格子点データ

     wz_wt = az_at(wt)

   end function wz_wt

   function wt_wz(wz)
     !
     ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
     !
     real(DP), dimension(nc,0:km), intent(in) :: wz
     !(in) 2 次元球面調和函数スペクトル・動径格子点データ
     real(DP), dimension(nc,0:lm)             :: wt_wz
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

     wt_wz = at_az(wz)

   end function wt_wz

   function ut_wt(wt)
     !
     ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
     !
     real(DP), dimension(nc,0:lm), intent(in) :: wt
     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
     real(DP), dimension(nmc,0:lm)                   :: ut_wt
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ(水平再分割)

     ut_wt = ua_wa(wt)

   end function ut_wt

   function wt_ut(ut)
     !
     ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
     !
     real(DP), dimension(nmc,0:lm), intent(in)       :: ut
     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ(水平再分割)
     real(DP), dimension(nc,0:lm)             :: wt_ut
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

     wt_ut = wa_ua(ut)

   end function wt_ut

   function uz_wz(wz)
     !
     ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
     !
     real(DP), dimension(nc,0:km), intent(in) :: wz
     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
     real(DP), dimension(nmc,0:km)                   :: uz_wz
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ(水平再分割)

     uz_wz = ua_wa(wz)

   end function uz_wz

   function wz_uz(uz)
     !
     ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
     !
     real(DP), dimension(nmc,0:km), intent(in)       :: uz
     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ(水平再分割)
     real(DP), dimension(nc,0:km)             :: wz_uz
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

     wz_uz = wa_ua(uz)

   end function wz_uz

   function uz_ut(ut)
     !
     ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
     !
     real(DP), dimension(nmc,0:lm), intent(in) :: ut
     !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
     real(DP), dimension(nmc,0:km)             :: uz_ut
     !(out) 2 次元球面調和函数スペクトル・動径格子点データ

     uz_ut = az_at(ut)

   end function uz_ut

   function ut_uz(uz)
     !
     ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
     !
     real(DP), dimension(nmc,0:km), intent(in) :: uz
     !(in) 2 次元球面調和函数スペクトル・動径格子点データ
     real(DP), dimension(nmc,0:lm)             :: ut_uz
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

     ut_uz = at_az(uz)

   end function ut_uz

!!$   function wa_ua(ua)
!!$     !
!!$     ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
!!$     !
!!$     real(DP), dimension(:,:), intent(in)       :: ua
!!$     !(in) 2 次元球面調和函数(水平再分割) (nc,:)
!!$     real(DP), dimension(nc,size(ua,2))   :: wa_ua
!!$     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$     real(DP), dimension(size(ua,2),nmc)  :: au
!!$     real(DP), dimension(size(ua,2),nc)   :: aw
!!$
!!$     integer :: a_size
!!$     integer :: IRQSTS
!!$     integer :: IST( MPI_STATUS_SIZE )
!!$
!!$     integer :: ierr, ip_v
!!$     integer, parameter :: itag=110
!!$     ! integer, allocatable ::snd_rank(:)
!!$     integer, allocatable ::snd_rank_v(:)
!!$     ! integer, allocatable ::rcv_rank(:)
!!$     integer, allocatable ::rcv_rank_v(:)
!!$     integer, allocatable ::rcv_idx(:)
!!$     logical :: first=.true.
!!$
!!$     save first, snd_rank_v, rcv_rank_v, rcv_idx !, snd_rank, rcv_rank
!!$
!!$     if ( first ) then
!!$        first = .false.
!!$        ! allocate(snd_rank(1:nproc_v-1))
!!$        allocate(snd_rank_v(1:nproc_v-1))
!!$        ! allocate(rcv_rank(1:nproc_v-1))
!!$        allocate(rcv_rank_v(1:nproc_v-1))
!!$        allocate(rcv_idx(0:nproc_v-1))
!!$
!!$        do ip_v=1,nproc_v-1
!!$           rcv_rank_v(ip_v) = mod(iproc_v+ip_v,nproc_v)
!!$           ! rcv_rank(ip_v) = myid_h + nproc_h*rcv_rank_v(ip_v)
!!$           snd_rank_v(ip_v) = mod(iproc_v-ip_v+nproc_v,nproc_v)
!!$           ! snd_rank(ip_v) = myid_h + nproc_h*snd_rank_v(ip_v)
!!$        enddo
!!$
!!$        rcv_idx(0) = 1
!!$        do ip_v=1,nproc_v-1
!!$           rcv_idx(ip_v) = rcv_idx(ip_v-1)+nmcp(ip_v-1)
!!$        enddo
!!$     endif
!!$
!!$     au = transpose(ua)
!!$     a_size = size(ua,2)
!!$
!!$     call MPI_Barrier(MPI_COMM_V,IERR)
!!$     do ip_v=1,nproc_v-1
!!$        call MPI_ISEND(au, a_size*nmc, MPI_REAL8, rcv_rank_v(ip_v),&
!!$             itag,MPI_COMM_V,IRQSTS,IERR)
!!$        call MPI_RECV(aw(1,rcv_idx(snd_rank_v(ip_v))),  &
!!$             a_size*nmcp(snd_rank_v(ip_v)), MPI_REAL8,   &
!!$             snd_rank_v(ip_v), itag, MPI_COMM_V, IST, IERR)
!!$        CALL MPI_WAIT(IRQSTS,IST,IERR)
!!$     enddo
!!$
!!$     aw(:,rcv_idx(iproc_v):rcv_idx(iproc_v)+nmcp(iproc_v)-1) = au
!!$
!!$     wa_ua = transpose(aw)
!!$
!!$   end function wa_ua
!!$
!!$   function ua_wa(wa)
!!$     !
!!$     ! 水平スペクトルデータを再分割する
!!$     !
!!$     real(DP), dimension(:,:), intent(in) :: wa
!!$     !(in) 2 次元球面調和函数データ (nc,:)
!!$     real(DP), dimension(nmc,size(wa,2))  :: ua_wa
!!$     !(out) 2 次元球面調和函数データ(水平再分割)
!!$
!!$     ua_wa = wa(nms:nme,:)
!!$
!!$   end function ua_wa
!!$

   function uz_wh(wh)
     !
     ! 水平スペクトル・動径格子点データを集める.
     !
     real(DP), dimension(nc,kc), intent(in) :: wh
     !(in)  動径格子点データ(分割)
     real(DP), dimension(nmc,0:km) :: uz_wh
     !(out) 動径格子点データ

     uz_wh = ua_wb(wh)

   end function uz_wh

   function wh_uz(uz)
     !
     ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
     !
     real(DP), dimension(nmc,0:km), intent(in)       :: uz
     !(in) 2 次元球面調和函数(水平再分割) (nc,:)
     real(DP), dimension(nc,kc)               :: wh_uz
     !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

     wh_uz = wb_ua(uz)

   end function wh_uz

   !--------------- 微分計算 -----------------
   function xvh_GradLon_ut(ut)
      !
      ! スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λ
      ! を作用させる.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(DP), dimension(0:im-1,jc,kc)      :: xvh_GradLon_ut
      !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

      xvh_GradLon_ut = xvb_GradLon_ua(uz_ut(ut))/xvh_Rad

    end function xvh_GradLon_ut

    function xvh_GradLat_ut(ut)
      !
      ! スペクトルデータに勾配型経度微分 1/r ∂/∂φ を作用させる.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(DP), dimension(0:im-1,jc,kc)      :: xvh_GradLat_ut
      !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

      xvh_GradLat_ut = xvb_GradLat_ua(uz_ut(ut))/xvh_Rad
    end function xvh_GradLat_ut

    function ut_DivLon_xvh(xvh)
      !
      ! 格子点データに発散型経度微分 1/rcosφ・∂/∂λ を作用させた
      ! スペクトルデータを返す.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(nmc,0:lm)                    :: ut_DivLon_xvh
      !(out) 発散型経度微分を作用された 2 次元スペクトルデータ

      ut_DivLon_xvh = ut_uz(ua_DivLon_xvb(xvh/xvh_Rad))

    end function ut_DivLon_xvh

    function ut_DivLat_xvh(xvh)
      !
      ! 格子データに発散型緯度微分 1/rcosφ・∂(f cosφ)/∂φ を
      ! 作用させたスペクトルデータを返す.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in)   :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(nmc,0:lm)       :: ut_DivLat_xvh
      !(out) 発散型緯度微分を作用された 2 次元スペクトルデータ

      ut_DivLat_xvh = ut_uz(ua_divlat_xvb(xvh/xvh_Rad))
    end function ut_DivLat_xvh

    function ut_Div_xvh_xvh_xvh(xvh_Vlon,xvh_Vlat,xvh_Vrad)
      !
      ! べクトル成分である 3 つの格子データに発散を作用させた
      ! スペクトルデータを返す.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分,
      ! 動径成分を表し, 発散は
      !
      !      1/rcosφ・∂u/∂λ + 1/rcosφ・∂(v cosφ)/∂φ
      !    + 1/r^2 ∂/∂r (r^2 w)
      !
      ! と計算される.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_Vlon
      !(in) ベクトル場の経度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_Vlat
      !(in) ベクトル場の緯度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_Vrad
      !(in) ベクトル場の動径成分

      real(DP), dimension(nmc,0:lm)                    :: ut_Div_xvh_xvh_xvh
      !(out) ベクトル場の発散

      ut_Div_xvh_xvh_xvh =   ut_DivLon_xvh(xvh_Vlon) &
                           + ut_DivLat_xvh(xvh_Vlat) &
                           + ut_DivRad_ut(ut_xvh(xvh_Vrad))

    end function ut_Div_xvh_xvh_xvh

    function xvh_Div_xvh_xvh_xvh(xvh_Vlon,xvh_Vlat,xvh_Vrad)
      !
      ! ベクトル成分である 3 つの格子データに発散を作用させる.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分,
      ! 動径成分を表す.
      !
      ! 極の特異性を回避するためにベクトル場に cosφ/r の重みをかけて
      ! 計算している.
      !
      !      div V = (r/cosφ)・div (Vcosφ/r) + V_φtanφ/r + V_r/r
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_Vlon
      !(in) ベクトル場の経度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_Vlat
      !(in) ベクトル場の緯度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_Vrad
      !(in) ベクトル場の動径成分

      real(DP), dimension(0:im-1,jc,kc)             :: xvh_Div_xvh_xvh_xvh
      !(out) ベクトル場の発散

      xvh_Div_xvh_xvh_xvh &
           = xvh_Rad/cos(xvh_Lat) &
                * xvh_ut(ut_Div_xvh_xvh_xvh(xvh_VLon*cos(xvh_Lat)/xvh_Rad,  &
                                            xvh_VLat*cos(xvh_Lat)/xvh_Rad,  &
                                            xvh_VRad*cos(xvh_Lat)/xvh_Rad ))&
             + xvh_VLat*tan(xvh_Lat)/xvh_Rad &
             + xvh_VRad/xvh_Rad

    end function xvh_Div_xvh_xvh_xvh

    function xvh_RotLon_ut_ut(ut_Vrad,ut_Vlat)
      !
      ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
      ! 回転の経度成分
      !
      !    1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r を計算する.
      !
      ! を計算する
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut_Vrad
      !(in) ベクトル場の動径成分

      real(DP), dimension(nmc,0:lm), intent(in) :: ut_Vlat
      !(in) ベクトル場の緯度成分

      real(DP), dimension(0:im-1,jc,kc)      :: xvh_RotLon_ut_ut
      !(out) ベクトル場の回転の経度成分

        xvh_RotLon_ut_ut =   xvh_GradLat_ut(ut_Vrad) &
                           - xvh_ut(ut_RotRad_ut(ut_Vlat))

    end function xvh_RotLon_ut_ut

    function xvh_RotLat_ut_ut(ut_Vlon,ut_Vrad)
      !
      ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
      ! 回転の緯度成分
      !
      !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
      !
      ! を計算する.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut_Vlon
      !(in) ベクトル場の経度成分

      real(DP), dimension(nmc,0:lm), intent(in) :: ut_Vrad
      !(in) ベクトル場の動径成分

      real(DP), dimension(0:im-1,jc,kc)      :: xvh_RotLat_ut_ut
      !(out) ベクトル場の回転の緯度成分

        xvh_RotLat_ut_ut =   xvh_ut(ut_RotRad_ut(ut_Vlon)) &
                           - xvh_GradLon_ut(ut_Vrad)

    end function xvh_RotLat_ut_ut

    function ut_RotRad_xvh_xvh(xvh_Vlat,xvh_Vlon)
      !
      ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
      ! ベクトル場の回転の動径成分
      !
      !    1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_Vlat
      !(in) ベクトル場の緯度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_Vlon
      !(in) ベクトル場の経度成分

      real(DP), dimension(nmc,0:lm)                    :: ut_RotRad_xvh_xvh
      !(out) ベクトル場の回転の動径成分

        ut_RotRad_xvh_xvh =   ut_DivLon_xvh(xvh_Vlat) &
                            - ut_DivLat_xvh(xvh_Vlon)

    end function ut_RotRad_xvh_xvh

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------
    function ut_DRad_ut(ut)
      !
      ! 入力スペクトルデータに動径微分 ∂/∂r を作用する.
      !
      ! スペクトルデータの動径微分とは, 対応する格子点データに動径微分を
      ! 作用させたデータのスペクトル変換のことである.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(DP), dimension(nmc,0:lm)             :: ut_DRad_ut
      !(in) 動径微分された2 次元球面調和函数チェビシェフスペクトルデータ

      ut_DRad_ut = at_Dr_at(ut)

    end function ut_DRad_ut

    function ut_DivRad_ut(ut)
      !
      ! 入力スペクトルデータに発散型動径微分
      !
      !       1/r^2 ∂/∂r (r^2 .)= ∂/∂r + 2/r
      !
      ! を作用する.
      !
      ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
      ! 発散型動径微分を作用させたデータのスペクトル変換のことである.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(DP), dimension(nmc,0:lm)             :: ut_DivRad_ut
      !(out) 発散型動径微分を作用された 2 次元スペクトルデータ

!      ut_DivRad_ut = ut_uz(uz_ut(ut_Drad_ut(ut_uz(uz_Rad**2*uz_ut(ut))))/uz_Rad**2)

      ut_DivRad_ut = ut_Drad_ut(ut) + ut_uz(2/uz_rad*uz_ut(ut))

    end function ut_DivRad_ut

    function ut_RotRad_ut(ut)
      !
      ! 入力スペクトルデータに回転型動径微分
      !
      !      1/r ∂(r.)/∂r = ∂(.)/∂r + (.)/r
      !
      ! を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(DP), dimension(nmc,0:lm)             :: ut_RotRad_ut
      !(out) 回転型動径微分を作用された 2 次元スペクトルデータ

!      ut_RotRad_ut = ut_uz(uz_ut(ut_Drad_ut(ut_uz(uz_Rad*uz_ut(ut))))/uz_Rad)
      ut_RotRad_ut = ut_Drad_ut(ut) + ut_uz(1/uz_Rad*uz_ut(ut))

    end function ut_RotRad_ut

    function ua_LaplaH_ua(ua_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: ua_data(:,:)
      !(in) 入力スペクトルデータ
      real(DP)              :: ua_LaplaH_ua(nmc,size(ua_data,2))
      !(out) 入力スペクトルデータのラプラシアン

      ua_LaplaH_ua  = ua_Lapla_ua(ua_data)
    end function ua_LaplaH_ua

    function ua_LaplaHInv_ua(ua_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: ua_data(:,:)
      !(in) 入力スペクトルデータ
      real(DP)              :: ua_LaplaHInv_ua(nmc,size(ua_data,2))
      !(out) 入力スペクトルデータのラプラシアン

      ua_LaplaHInv_ua  = ua_LaplaInv_ua(ua_data)

    end function ua_LaplaHInv_ua

    function ut_Lapla_ut(ut)
      ! 入力スペクトルデータにラプラシアン
      !
      !     ▽^2 =   1/r^2 cos^2φ・∂^2/∂λ^2
      !            + 1/r^2 cosφ・∂/∂φ(cosφ∂/∂φ)
      !            + 1/r^2 ∂/∂r (r^2 ∂/∂r)
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(DP), dimension(nmc,0:lm)             :: ut_Lapla_ut
      !(out) ラプラシアンを作用された 2 次元スペクトルデータ

      ut_Lapla_ut = ut_DivRad_ut(ut_Drad_ut(ut)) &
                   + ut_uz(uz_ut(ua_LaplaH_ua(ut))/uz_Rad**2)

    end function ut_Lapla_ut

!!$  !--------------- ポロイダル/トロイダルモデル用微分 -----------------
!!$
!!$    function wt_KxRGrad_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
!!$      !
!!$      real(DP), dimension(nc,0:lm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(DP), dimension(nc,0:lm)             :: wt_KxRGrad_wt
!!$      !(out) 経度微分を作用された 2 次元スペクトルデータ
!!$
!!$      wt_KxRGrad_wt =  wa_Dlon_wa(wt)
!!$
!!$    end function wt_KxRGrad_wt
!!$
!!$    function xvz_KGrad_wt(wt)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
!!$      !
!!$      ! 入力スペクトルデータに対応する格子データに軸方向微分
!!$      !
!!$      !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
!!$      !
!!$      ! を作用させた格子データが返される.
!!$      ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
!!$      !
!!$      real(DP), dimension(nc,0:lm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(DP), dimension(0:im-1,jc,0:km)                     :: xvz_KGrad_wt
!!$      !(out) 軸方向微分を作用された 2 次元スペクトルデータ
!!$
!!$      xvz_KGrad_wt =  cos(xvz_Lat)*xvz_GradLat_wt(wt) &
!!$                    + sin(xvz_Lat)*xvz_wt(wt_Drad_wt(wt))
!!$    end function xvz_KGrad_wt

    function ut_L2_ut(ut)
      !
      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
      !
      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる.
      !  入力スペクトルデ ータに対応する格子点データに演算子
      !
      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(DP), dimension(nmc,0:lm)             :: ut_L2_ut
      !(out) L^2 演算子を作用された 2 次元スペクトルデータ

      ut_L2_ut = -ua_LaplaH_ua(ut)

    end function ut_L2_ut

    function ut_L2Inv_ut(ut)
      !
      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
      ! 作用する.
      !
      ! スペクトルデータに L^2 演算子を作用させる関数 ut_L2_ut の逆計算を
      ! 行う関数である.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(DP), dimension(nmc,0:lm)             :: ut_L2Inv_ut
      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

      ut_L2Inv_ut = -ua_LaplaHInv_ua(ut)

    end function ut_L2Inv_ut

!!$    function wt_QOperatorMPI_wt(wt)
!!$      !
!!$      ! 入力スペクトルデータに対応する格子点データに演算子
!!$      !
!!$      !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2))
!!$      !
!!$      ! を作用させたデータのスペクトル変換が返される.
!!$      !
!!$      real(DP), dimension(nc,0:lm), intent(in) :: wt
!!$      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ
!!$
!!$      real(DP), dimension(nc,0:lm)             :: wt_QOperatorMPI_wt
!!$      !(out) Q 演算子を作用された 2 次元スペクトルデータ
!!$
!!$      wt_QOperatorMPI_wt = &
!!$             wt_xvz(xvz_KGrad_wt(wt) - xvz_KGrad_wt(wt_L2_wt(wt))/2) &
!!$           - wt_L2_wt(wt_xvz(xvz_KGrad_wt(wt)))/2
!!$
!!$    end function wt_QOperatorMPI_wt

    function ut_RadRot_xvh_xvh(xvh_VLON,xvh_VLAT)  ! r・(▽×v)
      !
      ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
      !
      !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
      !
      ! のスペクトル データが返される.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_VLON
      !(in) ベクトルの経度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_VLAT
      !(in) ベクトルの緯度成分

      real(DP), dimension(nmc,0:lm)     :: ut_RadRot_xvh_xvh
      !(out) ベクトルの渦度と動径ベクトルの内積

      ut_RadRot_xvh_xvh = ut_uz(   ua_DivLon_xvb(xvh_VLAT) &
                                 - ua_DivLat_xvb(xvh_VLON) )
!!$      ut_RadRot_xvh_xvh = ut_uz(uz_wz(wz_wh(wb_DivLon_xvb(xvh_VLAT) &
!!$                                - wb_DivLat_xvb(xvh_VLON))))

    end function ut_RadRot_xvh_xvh

    function ut_RadRotRot_xvh_xvh_xvh(xvh_VLON,xvh_VLAT,xvh_VRAD)
      !
      ! ベクトル v に対して r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分,
      ! 緯度成分, 動径成分を表す.
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) )
      !                     + L^2 v[r]/r
      !
      ! のスペクトルデータが返される.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_VLON
      !(in) ベクトルの経度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_VLAT
      !(in) ベクトルの緯度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_VRAD
      !(in) ベクトルの動径成分

      real(DP), dimension(nmc,0:lm)     :: ut_RadRotRot_xvh_xvh_xvh
      !(out) ベクトル v の r・(▽×▽×v)

      ut_RadRotRot_xvh_xvh_xvh = &
               ut_RotRad_ut(ut_uz( &
                   (ua_DivLon_xvb(xvh_VLON)+ ua_DivLat_xvb(xvh_VLAT)) )) &
             + ut_L2_ut(ut_xvh(xvh_VRAD/xvh_RAD))

    end function ut_RadRotRot_xvh_xvh_xvh


    subroutine ut_RadRot_RadRotRot( &
         xvh_VLON,xvh_VLAT,xvh_VRAD, ut_Tor, ut_LaplaPol )
      
      !
      ! ベクトル v に対して r・(▽×v) と r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分,
      ! 緯度成分, 動径成分を表す.
      !
      !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) )
      !                     + L^2 v[r]/r
      !
      ! のスペクトルデータが返される.
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回少なくてすむ.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_VLON
      !(in) ベクトルの経度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_VLAT
      !(in) ベクトルの緯度成分

      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh_VRAD
      !(in) ベクトルの動径成分

      real(DP), dimension(nmc,0:lm)     :: ut_Tor
      !(out) ベクトル v の r・(▽×v)
      
      real(DP), dimension(nmc,0:lm)     :: ut_LaplaPol
      !(out) ベクトル v の r・(▽×▽×v)

      call ut_Vector2VorDivMPI(xvh_VLon, xvh_VLat, ut_Tor, ut_LaplaPol)

      ut_LaplaPol = ut_RotRad_ut(ut_LaplaPol) &
                  + ut_L2_ut(ut_xvh(xvh_VRAD/xvh_RAD))

    end subroutine ut_RadRot_RadRotRot

    subroutine ut_Potential2VectorMPI(&
         xvh_VLON,xvh_VLAT,xvh_VRAD,ut_TORPOT,ut_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr)
      !
      ! の各成分を計算する
      !
      real(DP), dimension(0:im-1,jc,kc)     :: xvh_VLON
      !(out) ベクトル場の経度成分

      real(DP), dimension(0:im-1,jc,kc)     :: xvh_VLAT
      !(out) ベクトル場の緯度成分

      real(DP), dimension(0:im-1,jc,kc)     :: xvh_VRAD
      !(out) ベクトル場の動径成分

      real(DP), dimension(nmc,0:lm), intent(in) :: ut_TORPOT
      !(in) トロイダルポテンシャル

      real(DP), dimension(nmc,0:lm), intent(in) :: ut_POLPOT
      !(in) ポロイダルポテンシャル


      real(DP), dimension(nmc,0:km) :: uz_Tor
      !(in) トロイダルポテンシャル

      real(DP), dimension(nmc,0:km) :: uz_DPolDrad
      !(in) ポロイダルポテンシャル

      uz_Tor = uz_ut(ut_TORPOT)
      uz_DPolDRad = uz_ut(ut_RotRad_ut(ut_POLPOT))

      call ua_StreamPotential2VectorMPI(-uz_Tor, uz_DPolDRad, xvh_VLON, xvh_VLAT)
      xvh_VRAD = xvh_ut(ut_L2_ut(ut_POLPOT))/xvh_RAD


!!$      xvh_VLON =   xvh_RAD * xvh_GradLat_ut(ut_TORPOT) &
!!$                 + xvb_GradLon_ua(uz_ut(ut_RotRad_ut(ut_POLPOT)))
!!$      xvh_VLAT = - xvh_RAD * xvh_GradLon_ut(ut_TORPOT) &
!!$                 + xvb_GradLat_ua(uz_ut(ut_RotRad_ut(ut_POLPOT)))
!!$      xvh_VRAD = xvh_ut(ut_L2_ut(ut_POLPOT))/xvh_RAD
!!$      xvh_VLON =   xvh_RAD * xvh_GradLat_ut(ut_TORPOT) &
!!$                 + xvb_GradLon_wb(wh_wz(wz_uz(uz_ut(ut_RotRad_ut(ut_POLPOT)))))
!!$      xvh_VLAT = - xvh_RAD * xvh_GradLon_ut(ut_TORPOT) &
!!$                 + xvb_GradLat_wb(wh_wz(wz_uz(uz_ut(ut_RotRad_ut(ut_POLPOT)))))
!!$      xvh_VRAD = xvh_ut(ut_L2_ut(ut_POLPOT))/xvh_RAD

    end subroutine ut_Potential2VectorMPI

    subroutine ut_Potential2RotationMPI(&
       xvh_RotVLON,xvh_RotVLAT,xvh_RotVRAD,ut_TORPOT,ut_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr)
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
      !
      ! を計算する.

      ! ベクトル場の回転
      real(DP), dimension(0:im-1,jc,kc), intent(OUT) :: xvh_RotVLON
      !(out) 回転の経度成分

      real(DP), dimension(0:im-1,jc,kc), intent(OUT) :: xvh_RotVLAT
      !(out) 回転の緯度成分

      real(DP), dimension(0:im-1,jc,kc), intent(OUT) :: xvh_RotVRAD
      !(out) 回転の動径成分

      ! 入力ベクトル場を表すポテンシャル
      real(DP), dimension(nmc,0:lm), intent(in) :: ut_TORPOT
      !(in) トロイダルポテンシャル

      real(DP), dimension(nmc,0:lm), intent(in) :: ut_POLPOT
      !(in) ポロイダルポテンシャル

      call ut_Potential2VectorMPI( &
           xvh_RotVLON,xvh_RotVLAT,xvh_RotVRAD, &
           -ut_Lapla_ut(ut_POLPOT), ut_TORPOT)

    end subroutine ut_Potential2RotationMPI

    subroutine ut_Vector2VorDivMPI(xvh_VLon, xvh_VLat, ut_Vor, ut_Div)
      !
      ! 速度場(格子データ)から渦度・発散(スペクトルデータ)に
      ! (正)変換する(多層用)
      !
      ! スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
      !
      !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
      !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
      !
      real(8), intent(in)   :: xvh_VLon(0:im-1,jc,kc)
      !(in) 速度経度成分

      real(8), intent(in)   :: xvh_VLat(0:im-1,jc,kc)
      !(in) 速度緯度成分

      real(8), intent(out)   :: ut_Vor(nmc,0:lm)
      !(out) 渦度
      real(8), intent(out)   :: ut_Div(nmc,0:lm)
      !(out) 発散

      real(8) :: wh_Vor(nc,kc)
      !速度経度成分

      real(8) :: wh_Div(nc,kc)
      !速度緯度成分

      integer :: k

      do k=1,kc
         call w_Vector2VorDivMPI &
              (xvh_VLon(:,:,k), xvh_VLat(:,:,k), wh_Vor(:,k), wh_Div(:,k))
      enddo

      ut_Vor = ut_wh(wh_Vor)
      ut_Div = ut_wh(wh_Div)

    end subroutine ut_Vector2VorDivMPI

    !--------------- 積分計算 -----------------
    !----(入力データ xvz)---
    function vh_IntLon_xvh(xvh)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(jc,kc)  :: vh_IntLon_xvh
      !(out) 経度方向(帯状)積分された 2 次元子午面格子点データ

      integer :: i

      vh_IntLon_xvh = 0.0d0
      do i=0,im-1
         vh_IntLon_xvh(:,:) = vh_IntLon_xvh(:,:) &
              + xvh(i,:,:) * x_Lon_Weight(i)
      enddo
    end function vh_IntLon_xvh

    function xh_IntLat_xvh(xvh)
      !
      ! 3 次元格子点データの緯度方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) cosφ dφ を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(0:im-1,kc) :: xh_IntLat_xvh        ! 緯度円格子点データ
      !(out) 緯度積分された 2 次元緯度動径格子点データ

      xh_IntLat_xvh = xb_IntLat_xvb(xvh)

    end function xh_IntLat_xvh

    function xv_IntRad_xvh(xvh)  ! 動径積分
      !
      ! 3 次元格子点データの動径方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dr を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(0:im-1,jc)  :: xv_IntRad_xvh
      !(out) 動径積分された 2 次元経度緯度(水平, 球面)格子点データ

      real(DP), dimension(0:im-1,jc)  :: xv_IntRadTmp

      integer :: i,j,k,ierr

      xv_IntRadTmp = 0.0d0
      do k=1,kc
         do j=1,jc
            do i=0,im-1
               xv_IntRadTmp(i,j) = xv_IntRadTmp(i,j) &
                    + xvh(i,j,k) * h_Rad_Weight(k)
            enddo
         enddo
      end do

      CALL MPI_ALLREDUCE(xv_IntRadTmp,xv_IntRad_xvh,im*jc,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_V,IERR)

    end function xv_IntRad_xvh

    function x_IntLatRad_xvh(xvh)
      !
      ! 3 次元格子点データの緯度動径(子午面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dφdr
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(0:im-1)     :: x_IntLatRad_xvh
      !(out) 緯度動径(子午面)積分された 1 次元経度格子点データ

      x_IntLatRad_xvh = x_IntRad_xh(xb_IntLat_xvb(xvh))

    end function x_IntLatRad_xvh

    function v_IntLonRad_xvh(xvh)
      !
      ! 3 次元格子点データの経度動径(緯度円)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dλdr を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(jc)       :: v_IntLonRad_xvh
      !(out) 経度動径(緯度円)積分された 1 次元緯度格子点データ

      v_IntLonRad_xvh = v_IntLon_xv(xv_IntRad_xvh(xvh))

    end function v_IntLonRad_xvh

    function h_IntLonLat_xvh(xvh)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(kc)     :: h_IntLonLat_xvh
      !(out) 緯度経度(水平, 球面)積分された 1 次元動径格子点データ

      h_IntLonLat_xvh = b_IntLonLat_xvb(xvh)

    end function h_IntLonLat_xvh

    function IntLonLatRad_xvh(xvh) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2cosφ dλdφdr
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP)                     :: IntLonLatRad_xvh
      !(out) 全球積分値

      IntLonLatRad_xvh = IntLonLat_xv(xv_IntRad_xvh(xvh))

    end function IntLonLatRad_xvh

    !----(入力データ vz)---
    function h_IntLat_vh(vh)  ! 緯度積分
      !
      ! 2 次元(VZ)格子点データの緯度方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) cosφ dφ を計算する.
      !
      real(DP), dimension(jc,kc), intent(in) :: vh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(DP), dimension(kc)  :: h_IntLat_vh
      !(out) 緯度積分された 1 次元動径格子点データ

      h_IntLat_vh = b_IntLat_vb(vh)

    end function h_IntLat_vh

    function v_IntRad_vh(vh)  ! 動径積分
      !
      ! 2 次元(VH)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) r^2dr を計算する.
      !
      real(DP), dimension(jc,kc), intent(in) :: vh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(DP), dimension(jc)  :: v_IntRad_vh
      !(out) 動径積分された 1 次元緯度格子点データ

      integer :: j

      do j=1,jc
         v_IntRad_vh(j) = IntRad_h(vh(j,:))
      enddo

    end function v_IntRad_vh

    function IntLatRad_vh(vh)
      !
      ! 2 次元(VH)格子点データの緯度動径積分(子午面)および平均
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2cosφ dφdr を計算する.
      !
      real(DP), dimension(jc,0:km), intent(in) :: vh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(DP)                   :: IntLatRad_vh
      !(out) 積分値

      !IntLatRad_vh = IntRad_h(b_IntLat_vb(vh))
      IntLatRad_vh = IntLat_v(v_IntRad_vh(vh))

    end function IntLatRad_vh

    !----(入力データ xz)---
    function h_IntLon_xh(xh)
      !
      ! 2 次元(XH)格子点データの経度方向積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ を計算する.
      !
      real(DP), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(DP), dimension(kc)  :: h_IntLon_xh
      !(out) 経度積分された 1 次元動径格子点データ

      integer :: i

      h_IntLon_xh = 0.0d0
      do i=0,im-1
         h_IntLon_xh = h_IntLon_xh + xh(i,:) * x_Lon_Weight(i)
      enddo

    end function h_IntLon_xh

    function x_IntRad_xh(xh)
      !
      ! 2 次元(XH)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r) r^2dr を計算する.
      !
      real(DP), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(DP), dimension(0:im-1)  :: x_IntRad_xh
      !(out) 動径積分された 1 次元経度格子点データ

      integer :: i

      do i=0,im-1
         x_IntRad_xh(i) = IntRad_h(xh(i,:))
      enddo

    end function x_IntRad_xh

    function IntLonRad_xh(xh)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XH)格子点データの経度動径積分
      !
      ! 2 次元データ f(λ,r) に対して∫f(λ,r) r^2dλdr を計算する.
      !
      real(DP), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(DP)                                 :: IntLonRad_xh
      !(out) 積分値

      IntLonRad_xh = IntLon_x(x_IntRad_xh(xh))

    end function IntLonRad_xh

    !----(入力データ z)---
    function IntRad_h(h)  ! 動径積分
      !
      ! 1 次元(Z)格子点データの動径方向域積分.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr を計算する.
      !
      real(DP), dimension(kc), intent(in) :: h
      !(in) 1 次元動径格子点データ

      real(DP)                            :: IntRad_h
      !(out) 積分値

      real(DP) :: IntRadTmp
      integer :: k, ierr

      IntRadTmp = 0.0d0
      do k=1,kc
         IntRadTmp = IntRadTmp + h(k) * h_Rad_Weight(k)
      enddo

      CALL MPI_ALLREDUCE(IntRadTmp,IntRad_h,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_V,IERR)


    end function IntRad_h

    function IntRad_z(z)  ! 動径積分
      !
      ! 1 次元(Z)格子点データの動径方向域積分.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr を計算する.
      !
      real(DP), dimension(0:km), intent(in) :: z
      !(in) 1 次元動径格子点データ

      real(DP)                            :: IntRad_z
      !(out) 積分値

      integer :: k

      IntRad_z = 0.0d0
      do k=0,km
         IntRad_z = IntRad_z + z(k) * z_Rad_Weight(k)
      enddo

    end function IntRad_z

  !--------------- 平均計算 -----------------
    !----(入力データ xvh)---
    function vh_AvrLon_xvh(xvh)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ/2π を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(jc,kc)  :: vh_AvrLon_xvh
      !(out) 経度方向(帯状)平均された 2 次元子午面格子点データ

      vh_AvrLon_xvh = vh_IntLon_xvh(xvh)/sum(x_Lon_Weight)

    end function vh_AvrLon_xvh

    function xh_AvrLat_xvh(xvh)  ! 緯度積分
      !
      ! 3 次元格子点データの緯度方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)cosφ dφ/2 を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(im,kc)  :: xh_AvrLat_xvh
      !(out) 緯度平均された 2 次元緯度動径格子点データ

      xh_AvrLat_xvh = xh_IntLat_xvh(xvh)/sum(y_Lat_Weight)

    end function xh_AvrLat_xvh

    function xv_AvrRad_xvh(xvh)
      !
      ! 3 次元格子点データの動径方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2dr/((r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(0:im-1,jc)  :: xv_AvrRad_xvh          ! 水平格子点データ
      !(out) 動径平均された 2 次元経度緯度(水平, 球面)格子点データ

      xv_AvrRad_xvh = xv_IntRad_xvh(xvh)/sum(z_Rad_Weight)

    end function xv_AvrRad_xvh

    function x_AvrLatRad_xvh(xvh)  ! 緯度動径(子午面)積分
      !
      ! 3 次元格子点データの緯度動径(子午面)平均
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(0:im-1)     :: x_AvrLatRad_xvh
      !(out) 緯度動径(子午面)平均された 1 次元経度格子点データ

      x_AvrLatRad_xvh = x_IntLatRad_xvh(xvh) &
                   /( sum(y_Lat_Weight)*sum(z_Rad_Weight) )

    end function x_AvrLatRad_xvh

    function v_AvrLonRad_xvh(xvh)  ! 経度動径(緯度円)積分
      !
      ! 3 次元格子点データの経度動径(緯度円)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(jc)       :: v_AvrLonRad_xvh
      !(out) 経度動径(緯度円)平均された 1 次元緯度格子点データ

      v_AvrLonRad_xvh = v_IntLonRad_xvh(xvh) &
                 /(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function v_AvrLonRad_xvh

    function h_AvrLonLat_xvh(xvh)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ /4π
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP), dimension(kc)     :: h_AvrLonLat_xvh
      !(out) 緯度経度(水平, 球面)平均された 1 次元動径格子点データ

      h_AvrLonLat_xvh = h_IntLonLat_xvh(xvh) &
                 /(sum(x_Lon_Weight)*sum(y_Lat_Weight))

    end function h_AvrLonLat_xvh

    function AvrLonLatRad_xvh(xvh) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dλdφdr /(4π(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,jc,kc), intent(in) :: xvh
      !(in) 3 次元経度緯度動径格子点データ

      real(DP)                     :: AvrLonLatRad_xvh
      !(out) 全球平均値

      AvrLonLatRad_xvh = IntLonLatRad_xvh(xvh) &
            /(sum(x_Lon_Weight)*sum(y_Lat_Weight) * sum(z_Rad_Weight))

    end function AvrLonLatRad_xvh

    !----(入力データ vh)---
    function h_AvrLat_vh(vh)
      !
      ! 2 次元(VH)格子点データの緯度方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) cosφ dφ/2 を計算する.
      !
      real(DP), dimension(jc,kc), intent(in) :: vh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(DP), dimension(kc)  :: h_AvrLat_vh
      !(out) 緯度平均された 1 次元動径格子点データ

      h_AvrLat_vh = h_IntLat_vh(vh)/sum(y_Lat_Weight)
    end function h_AvrLat_vh

    function v_AvrRad_vh(vh)
      !
      ! 2 次元(VH)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2dr /((r[o]^3-r[i]^3)/3)
      ! を計算する.
      !
      real(DP), dimension(jc,kc), intent(in) :: vh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(DP), dimension(jc)  :: v_AvrRad_vh
      !(out) 動径平均された 1 次元緯度格子点データ

      v_AvrRad_vh = v_IntRad_vh(vh)/sum(z_Rad_Weight)

    end function v_AvrRad_vh

    function AvrLatRad_vh(vh)  ! 緯度動径(子午面)積分
      !
      ! 2 次元(VH)格子点データの緯度動径(子午面)平均
      !
      ! 2 次元データ f(φ,r) に対して
      !
      !    ∫f(φ,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(DP), dimension(jc,kc), intent(in) :: vh
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(DP)                   :: AvrLatRad_vh
      !(out) 平均値

      AvrLatRad_vh = IntLatRad_vh(vh)/(sum(y_Lat_Weight)*sum(z_Rad_Weight))

    end function AvrLatRad_vh

    !----(入力データ xh)---
    function h_AvrLon_xh(xh)  ! 経度(帯状)積分
      !
      ! 2 次元(XH)格子点データの経度方向平均.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ/2π を計算する.
      !
      real(DP), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(DP), dimension(kc)  :: h_AvrLon_xh
      !(out) 経度平均された 1 次元動径格子点データ

      h_AvrLon_xh = h_IntLon_xh(xh)/sum(x_Lon_Weight)

    end function h_AvrLon_xh

    function x_AvrRad_xh(xh)  ! 動径積分
      !
      ! 2 次元(XH)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(λ,r) に対して
      !
      !   ∫f(λ,r) r^2dr /((r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,kc), intent(in) :: xh
      !(in) 2 次元緯度動径格子点データ

      real(DP), dimension(0:im-1)  :: x_AvrRad_xh
      !(out) 動径平均された 1 次元経度格子点データ

      x_AvrRad_xh = x_IntRad_xh(xh)/sum(z_Rad_Weight)

    end function x_AvrRad_xh

    function AvrLonRad_xh(xh)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XH)格子点データの経度動径平均
      !
      ! 2 次元データ f(λ,r) に対して
      !
      !    ∫f(λ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(DP), dimension(0:im-1,kc), intent(in) :: xh
      ! (in) 2 次元格子点データ
      real(DP)                                 :: AvrLonRad_xh
      ! 積分値

      AvrLonRad_xh = IntLonRad_xh(xh)/(sum(x_Lon_Weight)*sum(z_Rad_Weight))

    end function AvrLonRad_xh

    !----(入力データ z)---
    function AvrRad_h(h)
      !
      ! 1 次元(Z)格子点データの動径方向域平均.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr /((r[o]^3-r[i]^3)/3) を
      ! 計算する.
      !
      real(DP), dimension(kc), intent(in) :: h
      !(in) 1 次元動径格子点データ
      real(DP)                            :: AvrRad_h
      !(out) 平均値

      AvrRad_h = IntRad_h(h)/sum(z_Rad_Weight)

    end function AvrRad_h

    function AvrRad_z(z)
      !
      ! 1 次元(Z)格子点データの動径方向域平均.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr /((r[o]^3-r[i]^3)/3) を
      ! 計算する.
      !
      real(DP), dimension(0:km), intent(in) :: z
      !(in) 1 次元動径格子点データ
      real(DP)                            :: AvrRad_z
      !(out) 平均値

      AvrRad_z = IntRad_z(z)/sum(z_Rad_Weight)

    end function AvrRad_z

    !--------------- 補間計算 -----------------
    function Interpolate_array000_ut(ut_data,alon,alat,arad)
      !
      ! 緯度 alon, 経度 alat 動径 arad における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(DP), intent(IN) :: ut_data(nmc,0:lm)         ! スペクトルデータ
      real(DP), intent(IN) :: alon                     ! 補間する位置(経度)
      real(DP), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(DP), intent(IN) :: arad                     ! 補間する位置(動径)
      real(DP) :: Interpolate_array000_ut              ! 補間した値

      real(DP) :: wa_data(nc,1)                  ! 補間した値

      wa_data = wa_ua(reshape(a_Interpolate_at(ut_data,arad),(/nmc,1/)))
      Interpolate_array000_ut = Interpolate_w(wa_data(:,1),alon,alat)

    end function Interpolate_array000_ut

    function a_Interpolate_array100_ut(ut_data,alon,alat,arad)
      !
      ! 緯度 alon, 経度 alat 動径 arad における関数値を
      ! その球面調和変換係数 wa_data から補間計算する
      !
      real(DP), intent(IN) :: ut_data(:,:)             ! スペクトルデータ
      real(DP), intent(IN) :: alon(:)                  ! 補間する位置(経度)
      real(DP), intent(IN) :: alat                     ! 補間する位置(緯度)
      real(DP), intent(IN) :: arad                     ! 補間する位置(動径)
      real(DP) :: a_Interpolate_array100_ut(size(alon))! 補間した値

      real(DP) :: wa_data(nc,1)                  ! 補間した値

      wa_data = wa_ua(reshape(a_Interpolate_at(ut_data,arad),(/nmc,1/)))
      a_Interpolate_array100_ut = Interpolate_w(wa_data(:,1),alon,alat)

    end function a_Interpolate_array100_ut

    !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------

    function nmz_ToroidalEnergySpectrum_ut(ut_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n, 帯状波数 m 成分のトロイダルエネルギー
      !    スペクトルは  (1/2)n(n+1)4πr^2|ψ(n,m,r)|^2  と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    ut_VMiss によって設定できる (初期値は -999.0)
      !
      real(DP), intent(in)   :: ut_TORPOT(nmc,0:lm)
      !(in) 流線関数(スペクトルデータ)

      real(DP), dimension(0:nm,-nm:nm,0:km) :: nmz_ToroidalEnergySpectrum_ut
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      real(DP), dimension(0:nm,-nm:nm,0:km) :: nmz_Work ! 作業領域

      real(DP), dimension(nc,0:km) ::wz_DATA      ! 作業領域

      integer :: l, n, m, nm_ary(2)
      integer :: ierr

      wz_DATA = wz_wt(wt_ut(ut_TORPOT))

      nmz_work = 0.0D0
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               nmz_Work(n,0,:) = nmz_Work(n,0,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
                  !  + 0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
            else
               nmz_Work(n,m,:) = nmz_Work(n,m,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
                  !  +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
               nmz_Work(n,-m,:) = nmz_Work(n,-m,:) &
                    +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
                  !  +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
            endif
         endif
      enddo

      CALL MPI_ALLREDUCE(nmz_Work,nmz_ToroidalEnergySpectrum_ut, &
                         (nm+1)*(2*nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_H,IERR)

      do m=1,nm
         do n=0,m-1
            nmz_ToroidalEnergySpectrum_ut(n,m,:)  = ut_Vmiss
            nmz_ToroidalEnergySpectrum_ut(n,-m,:) = ut_Vmiss
         enddo
      enddo

    end function nmz_ToroidalEnergySpectrum_ut

    function nz_ToroidalEnergySpectrum_ut(ut_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
      !    Σ[m=-n]^n(1/2)n(n+1)4πr^2ψ(n,m,r)^2 と計算される.
      !
      ! * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut_TORPOT
      !(in) トロイダルポテンシャル

      real(DP), dimension(0:nm,0:km) :: nz_ToroidalEnergySpectrum_ut
      !(out) エネルギースペクトルトロイダル成分

      real(DP), dimension(nc,0:km)   :: wz_DATA   ! 作業領域
      real(DP), dimension(0:nm,0:km) :: nz_Work
      integer :: l, n, m, nm_ary(2)
      integer :: ierr
      real(DP) :: factor

      nz_Work = 0.0D0
      wz_DATA = wz_wt(wt_ut(ut_TORPOT))
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( m == 0 ) then
            factor = 1.0D0
         else
            factor = 2.0D0
         endif
         if ( n .ge. 0 ) then
            nz_Work(n,:) = nz_Work(n,:) &
              + factor * 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * wz_Data(l,:)**2
            !  + 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * wz_Data(l,:)**2
         endif
      enddo

      CALL MPI_ALLREDUCE(nz_Work,nz_ToroidalEnergySpectrum_ut,(nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_H,IERR)

    end function nz_ToroidalEnergySpectrum_ut

    function nmz_PoloidalEnergySpectrum_ut(ut_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n, 帯状波数 m 成分のポロイダルエネルギー
      !    スペクトルは
      !
      !      (1/2)n(n+1)4π{|d(rφ(n,m,r))/dr|^2 + n(n+1)|φ(n,m,r)|^2}
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 ut_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(DP), intent(in)   :: ut_POLPOT(nmc,0:lm)
      !(in) 流線関数(スペクトルデータ)

      real(DP), dimension(0:nm,-nm:nm,0:km) :: nmz_PoloidalEnergySpectrum_ut
      !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

      real(DP), dimension(0:nm,-nm:nm,0:km) :: nmz_Work ! 作業領域

      real(DP), dimension(nc,0:km) ::wz_DATA1   ! 作業領域
      real(DP), dimension(nc,0:km) ::wz_DATA2   ! 作業領域

      integer :: l, n, m, nm_ary(2)

      integer :: ierr

      wz_Data1 = wz_wt(wt_ut(ut_POLPOT))
      wz_Data2 = wz_uz(uz_Rad*uz_ut(ut_DRad_ut(ut_POLPOT))) &    ! d(rφ)/dr
               + wz_wt(wt_ut(ut_POLPOT))                         ! = rdφ/dr+φ

      nmz_work = 0.0D0
      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               nmz_Work(n,0,:) = nmz_Work(n,0,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
                  !  +  0.5 * n*(n+1) * (4*pi) &
                  !  * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
            else
               nmz_Work(n,m,:) = nmz_Work(n,m,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
                  !  +  0.5 * n*(n+1) * (4*pi) &
                  !  * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
               nmz_Work(n,-m,:) = nmz_Work(n,-m,:) &
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
                  ! +  0.5 * n*(n+1) * (4*pi) &
                  ! * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
            endif
         endif
      enddo

      CALL MPI_ALLREDUCE(nmz_Work,nmz_PoloidalEnergySpectrum_ut, &
                         (nm+1)*(2*nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_H,IERR)

      do m=1,nm
         do n=0,m-1
            nmz_PoloidalEnergySpectrum_ut(n,m,:)  = ut_Vmiss
            nmz_PoloidalEnergySpectrum_ut(n,-m,:) = ut_Vmiss
         enddo
      enddo

    end function nmz_PoloidalEnergySpectrum_ut

    function nz_PoloidalEnergySpectrum_ut(ut_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
      !
      !      Σ[m=-n]^n ((1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2
      !                 + n(n+1)φ(n,m,r)^2}
      !
      !    と計算される.
      !
      !  * 全ての全波数に対してのエネルギースペクトル成分の和を動径積分したもの
      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
      !
      real(DP), dimension(nmc,0:lm), intent(in) :: ut_POLPOT
      !(in) ポロイダルポテンシャル

      real(DP), dimension(0:nm,0:km) :: nz_PoloidalEnergySpectrum_ut
      !(out) エネルギースペクトルポロイダル成分

      real(DP), dimension(nc,0:km) ::wz_DATA1   ! 作業領域
      real(DP), dimension(nc,0:km) ::wz_DATA2   ! 作業領域
      real(DP), dimension(0:nm,0:km)     ::nz_Work
      integer :: l, n, m, nm_ary(2)
      integer :: ierr
      real(DP) :: factor

      nz_Work = 0.0D0
      wz_Data1 = wz_wt(wt_ut(ut_POLPOT))
      wz_Data2 = wz_uz(uz_Rad*uz_ut(ut_DRad_ut(ut_POLPOT))) &    ! d(rφ)/dr
               + wz_wt(wt_ut(ut_POLPOT))                         ! = rdφ/dr+φ

      do l=1,nc
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( m == 0 ) then
            factor = 1.0D0
         else
            factor = 2.0D0
         endif
         if ( n .ge. 0 ) then
            nz_Work(n,:) = nz_Work(n,:) &
              + factor * 0.5* n*(n+1)* (4*pi) &
              *( wz_Data2(l,:)**2 + n*(n+1)*wz_Data1(l,:)**2 )
         endif
      enddo

      CALL MPI_ALLREDUCE(nz_Work,nz_PoloidalEnergySpectrum_ut,(nm+1)*(km+1), &
                         MPI_REAL8,MPI_SUM,MPI_COMM_H,IERR)

    end function nz_PoloidalEnergySpectrum_ut

    !--------------- 境界値問題 -----------------

    subroutine ut_BoundariesTau(ut,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! Chebyshev 空間での境界条件適用(タウ法)
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を
      ! 定める方法をとっている(タウ法).
      !
      real(DP), dimension(nmc,0:lm),intent(inout)      :: ut
      !(inout) 境界条件を適用するデータ. 修正された値を返す.

      real(DP), dimension(nmc,2), intent(in), optional :: values
      !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
      !     省略時は値/勾配 0 となる.

      character(len=2), intent(in), optional         :: cond
      !(in) 境界条件. 省略時は 'DD'
      !        DD : 両端ディリクレ条件
      !        DN : 上端ディリクレ, 下端ノイマン条件
      !        ND : 上端ノイマン, 下端ディリクレ条件
      !        NN : 両端ノイマン条件

      if (.not. present(cond)) then
         if (present(values)) then
            call at_BoundariesTau_DD(ut,values)
         else
            call at_BoundariesTau_DD(ut)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesTau_NN(ut,values)
         else
            call at_BoundariesTau_NN(ut)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesTau_DN(ut,values)
         else
            call at_BoundariesTau_DN(ut)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesTau_ND(ut,values)
         else
            call at_BoundariesTau_ND(ut)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesTau_DD(ut,values)
         else
            call at_BoundariesTau_DD(ut)
         endif
      case default
         call MessageNotify('E','ut_BoundariesTau','B.C. not supported')
      end select

    end subroutine ut_BoundariesTau

    subroutine ut_BoundariesGrid(ut,values,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! ut_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      real(DP), dimension(nmc,0:lm),intent(inout)      :: ut
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      real(DP), dimension(nmc,2), intent(in), optional :: values
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
              !    省略時は値/勾配 0 となる.

      character(len=2), intent(in), optional         :: cond
              !(in) 境界条件. 省略時は 'DD'
              !        DD : 両端ディリクレ条件
              !        DN : 上端ディリクレ, 下端ノイマン条件
              !        ND : 上端ノイマン, 下端ディリクレ条件
              !        NN : 両端ノイマン条件

      if (.not. present(cond)) then
         if (present(values)) then
            call at_boundariesGrid_DD(ut,values)
         else
            call at_boundariesGrid_DD(ut)
         endif
         return
      endif

      select case(cond)
      case ('NN')
         if (present(values)) then
            call at_BoundariesGrid_NN(ut,values)
         else
            call at_BoundariesGrid_NN(ut)
         endif
      case ('DN')
         if (present(values)) then
            call at_BoundariesGrid_DN(ut,values)
         else
            call at_BoundariesGrid_DN(ut)
         endif
      case ('ND')
         if (present(values)) then
            call at_BoundariesGrid_ND(ut,values)
         else
            call at_BoundariesGrid_ND(ut)
         endif
      case ('DD')
         if (present(values)) then
            call at_BoundariesGrid_DD(ut,values)
         else
            call at_BoundariesGrid_DD(ut)
         endif
      case default
         call MessageNotify('E','ut_BoundariesGrid','B.C. not supported')
      end select

    end subroutine ut_BoundariesGrid

    subroutine ut_TorBoundariesTau(ut_TORPOT,values,cond,new)
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用.
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布.
      !                                   default は 0(静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(DP), dimension(nmc,0:lm),intent(inout)      :: ut_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      real(DP), dimension(nmc,2), intent(in), optional :: values
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(DP), dimension(:,:), allocatable  :: alu
      integer, dimension(:), allocatable    :: kp
      real(DP), dimension(0:lm)              :: t_data
      real(DP), dimension(0:km)              :: z_data
      logical                               :: rigid1=.true.   ! 境界条件
      logical                               :: rigid2=.true.   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ut_TorBoundariesTau','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(0:lm,0:lm),kp(0:lm))

         do l=0,lm
            t_data = 0.0D0 ; t_data(l) = 1.0D0
            alu(:,l) = t_data

            ! 力学的条件粘着条件
            if ( rigid1 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(lm-1,l) = z_data(0)       ! 境界 k=0 での条件式代入

            if ( rigid2 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(lm,l)   = z_data(km)      ! 境界 k=km での条件式代入
         enddo

         call ludecomp(alu,kp)

         if ( rigid1 .AND. present(values) ) then
            call MessageNotify('M','ut_TorBoundariesTau',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid1 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','ut_TorBoundariesTau',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid1) .AND. present(values) ) then
            call MessageNotify('W','ut_TorBoundariesTau',&
                 'Boundary value k=0 cannot be set under stress-free condition.')
         endif

         if ( rigid2 .AND. present(values) ) then
            call MessageNotify('M','ut_TorBoundariesTau',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid2 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','ut_TorBoundariesTau',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid2) .AND. present(values) ) then
            call MessageNotify('W','ut_TorBoundariesTau',&
                 'Boundary value k=0 cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','ut_TorBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      if ( rigid1 .AND. present(values) ) then
         ut_torpot(:,lm-1) = values(:,1)
      else
         ut_torpot(:,lm-1) = 0.0D0
      endif
      if ( rigid2 .AND. present(values) ) then
         ut_torpot(:,lm)   = values(:,2)
      else
         ut_torpot(:,lm) = 0.0D0
      endif

      ut_torpot = lusolve(alu,kp,ut_TORPOT)

    end subroutine ut_TorBoundariesTau

    subroutine ut_TorBoundariesGrid(ut_TORPOT,values,cond,new)
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する.
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! ut_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布.
      !                                   default は 0 (静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(DP), dimension(nmc,0:lm),intent(inout)      :: ut_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      real(DP), dimension(nmc,2), intent(in), optional :: values
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(DP), dimension(nmc,0:km)           :: uz_TORPOT
      real(DP), dimension(:,:), allocatable  :: alu
      integer, dimension(:), allocatable    :: kp
      real(DP), dimension(0:lm)              :: t_data
      real(DP), dimension(0:km)              :: z_data
      logical                               :: rigid1=.true.   ! 境界条件
      logical                               :: rigid2=.true.   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ut_TorBoundariesGrid','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','TorBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(0:km,0:lm),kp(0:lm))

         do l=0,lm
            t_data = 0.0D0 ; t_data(l)=1.0D0
            alu(:,l) = z_t(t_data)

            if ( rigid1 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(0,l) = z_data(0)        ! 境界 k=0 での条件式代入

            if ( rigid2 ) then
               z_data = z_t(t_data)
            else
               z_data = z_t(t_dr_t(t_z(z_t(t_data)/z_rad)))
            endif
            alu(km,l)   = z_data(km)    ! 境界 k=km での条件式代入
         end do

         call ludecomp(alu,kp)

         if ( rigid1 .AND. present(values) ) then
            call MessageNotify('M','ut_TorBoundariesGrid',&
                 'Toroidal potential at k=0 was given by the optional variable.')
         else if ( rigid1 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','ut_TorBoundariesGrid',&
                 'Toroidal potential at k=0 was set to zero.')
         else if ( (.NOT. rigid1) .AND. present(values) ) then
            call MessageNotify('W','ut_TorBoundariesGrid',&
                 'Boundary value at k=0 cannot be set under stress-free condition.')
         endif

         if ( rigid2 .AND. present(values) ) then
            call MessageNotify('M','ut_TorBoundariesGrid',&
                 'Toroidal potential at k=km was given by the optional variable.')
         else if ( rigid2 .AND. (.NOT.present(values)) ) then
            call MessageNotify('M','ut_TorBoundariesGrid',&
                 'Toroidal potential at k=km was set to zero.')
         else if ( (.NOT. rigid2) .AND. present(values) ) then
            call MessageNotify('W','ut_TorBoundariesGrid',&
                 'Boundary value at k=km cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','ut_TorBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      uz_TorPot       = uz_ut(ut_TorPot)

      if ( rigid1 .AND. present(values) ) then
         uz_TorPot(:,0)  = values(:,1)
      else
         uz_TorPot(:,0)  = 0.0D0
      endif

      if ( rigid2 .AND. present(values) ) then
         uz_TorPot(:,km) = values(:,2)
      else
         uz_TorPot(:,km) = 0.0D0
      endif

      ut_torpot = lusolve(alu,kp,uz_TorPot)

    end subroutine ut_TorBoundariesGrid

    function uz_LaplaPol2Pol_uz(uz,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      !
      ! チェビシェフ格子点空間で境界条件を適用している.
      ! この関数を用いるためには wt_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !   ▽^2Φ = f
      !     Φ = const. at boundaries.
      !     ∂Φ/∂r = 0 at boundaries           (粘着条件)
      !     or ∂^2Φ/∂r^2 = 0 at boundaries    (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(DP), dimension(nmc,0:km),intent(in)  :: uz
      !(in) 入力▽^2φ分布

      real(DP), dimension(nmc,0:km)             :: uz_LaplaPol2Pol_uz
      !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
      !(in) 境界条件スイッチ. 省略時は 'RR'
      !     RR    : 両端粘着条件
      !     RF    : 上端粘着, 下端応力なし条件
      !     FR    : 上端応力なし, 下端粘着条件
      !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
      !(in) true だと境界条件計算用行列を強制的に新たに作る.
      !     default は false.

      real(DP), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(DP), dimension(nmc,0:km)            :: uz_work
      real(DP), dimension(0:km,0:km)           :: gg
      real(DP), dimension(0:km,0:km)           :: gg_work
      logical                                 :: rigid1=.true.   ! 境界条件
      logical                                 :: rigid2=.true.   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k,n
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','uz_LaplaPol2Pol_uz','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','uz_LaplaPol2Pol_uz', &
                 'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nmc,0:km,0:km),kp(nmc,0:km))

         do k=0,km
            uz_work = 0.0D0 ; uz_work(:,k) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,k) = uz_ut(ut_lapla_ut(ut_uz(uz_work)))
         enddo

         ! 運動学的条件. 流線は境界で一定
         gg = 0.0D0
         do k=0,km
            gg(k,k)=1.0D0
         enddo
         do n=1,nmc
            alu(n,0,:)   = gg(:,0)
            alu(n,km,:)  = gg(:,km)
         enddo

         ! 力学的条件粘着条件
         if ( rigid1 ) then
            gg_work=az_at(at_dr_at(at_az(gg)))
         else
            gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
         endif
         do n=1,nmc
            alu(n,1,:) = gg_work(:,0)
         enddo

         ! 力学的条件粘着条件
         if ( rigid2 ) then
            gg_work=az_at(at_dr_at(at_az(gg)))
         else
            gg_work=az_at(at_dr_at(at_dr_at(at_az(gg))))
         endif
         do n=1,nmc
            alu(n,km-1,:) = gg_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','uz_LaplaPol2Pol_uz',&
              'Matrix to apply  b.c. newly produced.')
      endif

      uz_work         = uz
      uz_work(:,1)    = 0.0D0               ! 力学的条件
      uz_work(:,km-1) = 0.0D0               ! 力学的条件
      uz_work(:,0)    = 0.0D0               ! 運動学的条件
      uz_work(:,km)   = 0.0D0               ! 運動学的条件

      uz_laplapol2pol_uz = lusolve(alu,kp,uz_work)

    end function uz_LaplaPol2Pol_uz

    function ut_LaplaPol2PolTau_ut(ut,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフタウ法で境界条件を適用している.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂r = 0 at boundaries          (粘着条件)
      !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(DP), dimension(nmc,0:lm),intent(in)  :: ut
              !(in) 入力▽^2φ分布

      real(DP), dimension(nmc,0:lm)             :: ut_LaplaPol2PolTau_ut
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(DP), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(DP), dimension(nmc,0:km)  :: uz_work
      real(DP), dimension(nmc,0:lm)  :: ut_work
      logical                       :: rigid1=.true.   ! 境界条件
      logical                       :: rigid2=.true.   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ut_LaplaPol2PolTau_ut','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nmc,0:lm,0:lm),kp(nmc,0:lm))

         alu = 0.0D0
         do l=0,lm-2
            ut_work = 0.0D0 ; ut_work(:,l) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,l) = ut_Lapla_ut(ut_work)
         enddo

         ! 運動学的条件. 流線は境界で一定
         do l=0,lm
            ut_work=0.0D0
            ut_work(:,l) = 1.0D0
            uz_work = uz_ut(ut_work)

            alu(:,lm-1,l)  = uz_work(:,0)
            alu(:,lm,l)    = uz_work(:,km)

            ! 力学的条件粘着条件
            if ( rigid1 ) then
               uz_work=uz_ut(ut_DRad_ut(ut_work))
            else
               uz_work=uz_ut(ut_DRad_ut(ut_DRad_ut(ut_work)))
            endif
            alu(:,lm-2,l) = uz_work(:,0)

            ! 力学的条件粘着条件
            if ( rigid2 ) then
               uz_work=uz_ut(ut_DRad_ut(ut_work))
            else
               uz_work=uz_ut(ut_DRad_ut(ut_DRad_ut(ut_work)))
            endif
            alu(:,lm-3,l) = uz_work(:,km)
         end do

         call ludecomp(alu,kp)

         call MessageNotify('M','ut_LaplaPol2PolTau_ut',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      ut_work         = ut
      ut_work(:,lm)   = 0.0D0               ! 運動学的条件
      ut_work(:,lm-1) = 0.0D0               ! 運動学的条件
      ut_work(:,lm-2) = 0.0D0               ! 力学的条件
      ut_work(:,lm-3) = 0.0D0               ! 力学的条件

      ut_LaplaPol2PolTau_ut = lusolve(alu,kp,ut_work)

    end function ut_LaplaPol2PolTau_ut

    function ut_LaplaPol2PolGrid_ut(ut,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      ! チェビシェフ格子点空間で境界条件を適用している.
      !
      ! この関数を用いるためには ut_Initial にて設定する
      ! チェビシェフ切断波数(lm)と鉛直格子点数(km)を等しく
      ! しておく必要がある.
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !    ▽^2Φ = f
      !      Φ = const. at boundaries.
      !      ∂Φ/∂r = 0 at boundaries          (粘着条件)
      !      or ∂^2Φ/∂r^2 = 0 at boundaries   (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      ! 最終的にチェビシェフ係数の解が欲しい場合には, uz_LaplaPol2Pol_uz に
      ! 比べてチェビシェフ -- 格子点変換が 1 回分少なくて済む.
      !
      real(DP), dimension(nmc,0:lm),intent(in)  :: ut
              !(in) 入力▽^2φ分布

      real(DP), dimension(nmc,0:lm)             :: ut_LaplaPol2PolGrid_ut
              !(out) 出力ポロイダルポテンシャル分布

      character(len=2), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'RR'
              !     RR    : 両端粘着条件
              !     RF    : 上端粘着, 下端応力なし条件
              !     FR    : 上端応力なし, 下端粘着条件
              !     FF    : 両端応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(DP), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(DP), dimension(nmc,0:km)  :: uz_work
      real(DP), dimension(nmc,0:lm)  :: ut_work
      real(DP), dimension(0:lm,0:lm)           :: tt_I
      real(DP), dimension(0:lm,0:km)           :: tz_work
      logical                                 :: rigid1=.true.   ! 境界条件
      logical                                 :: rigid2=.true.   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l,n
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid1=.TRUE. ; rigid2=.TRUE.
      else
         select case (cond)
         case ('RR')
            rigid1 = .TRUE.  ; rigid2 = .TRUE.
         case ('RF')
            rigid1 = .TRUE.  ; rigid2 = .FALSE.
         case ('FR')
            rigid1 = .FALSE. ; rigid2 = .TRUE.
         case ('FF')
            rigid1 = .FALSE. ; rigid2 = .FALSE.
         case default
            call MessageNotify('E','ut_LaplaPol2PolGrid_ut','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','ut_LaplaPol2PolGrid_ut', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu(nmc,0:km,0:lm),kp(nmc,0:lm))

         do l=0,lm
            ut_work = 0.0D0 ; ut_work(:,l) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,l) = uz_ut(ut_Lapla_ut(ut_work))
         enddo

         ! 運動学的条件. 流線は境界で一定
         tt_I = 0.0D0
         do l=0,lm
            tt_I(l,l)=1.0D0
         enddo

         ! 非電気伝導体
         tz_work = az_at(tt_I)

         do n=1,nmc
            alu(n,0,:)  = tz_work(:,0)
            alu(n,km,:) = tz_work(:,km)
         enddo

         ! 力学的条件粘着条件
         if ( rigid1 ) then
            tz_work=az_at(at_Dr_at(tt_I))
         else
            tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
         endif
         do n=1,nmc
            alu(n,1,:) = tz_work(:,0)
         enddo

         ! 力学的条件粘着条件
         if ( rigid2 ) then
            tz_work=az_at(at_Dr_at(tt_I))
         else
            tz_work=az_at(at_Dr_at(at_Dr_at(tt_I)))
         endif
         do n=1,nmc
            alu(n,km-1,:) = tz_work(:,km)
         enddo

         call ludecomp(alu,kp)

         call MessageNotify('M','ut_LaplaPol2PolGrid_ut',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      uz_work         = uz_ut(ut)
      uz_work(:,1)    = 0.0D0               ! 力学的条件
      uz_work(:,km-1) = 0.0D0               ! 力学的条件
      uz_work(:,0)    = 0.0D0               ! 運動学的条件
      uz_work(:,km)   = 0.0D0               ! 運動学的条件

      ut_LaplaPol2PolGrid_ut = lusolve(alu,kp,uz_work)

    end function ut_LaplaPol2PolGrid_ut

    subroutine ut_TormagBoundariesTau(ut_TOR,new)

      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    ut_psi = 0   at the outer boundary
      ! 内側
      !    ut_psi = 0       at the inner boundary
      !
      ! であるから ut_Boundaries で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(DP), dimension(nmc,0:lm),intent(inout)   :: ut_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(DP), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(DP), dimension(:,:), allocatable    :: ut_I
      real(DP), dimension(:,:), allocatable    :: uz_PSI

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(ut_I) ) deallocate(ut_I)
         if ( allocated(uz_PSI) ) deallocate(uz_PSI)

         allocate(alu(nmc,0:lm,0:lm),kp(nmc,0:lm))
         allocate(ut_I(nmc,0:lm),uz_PSI(nmc,0:km))

         do l=0,lm
            ut_I = 0.0D0 ; ut_I(:,l)=1.0D0
            alu(:,:,l) = ut_I

            ! 非電気伝導体
            uz_PSI = uz_ut(ut_I)

            alu(:,lm-1,l) = uz_PSI(:,0)
            alu(:,lm,l)   = uz_PSI(:,km)
         enddo

         call ludecomp(alu,kp)

         deallocate(ut_I,uz_PSI)

         call MessageNotify('M','TormagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      ut_TOR(:,lm-1) = 0.0D0
      ut_TOR(:,lm)   = 0.0D0
      ut_TOR = lusolve(alu,kp,ut_TOR)

    end subroutine ut_TormagBoundariesTau

    subroutine ut_TormagBoundariesGrid(ut_TOR,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! ut_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している.
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    ut_psi = 0   at the outer boundary
      ! 内側
      !    ut_psi = 0       at the inner boundary
      !
      ! であるので ut_Boundaries で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(DP), dimension(nmc,0:lm),intent(inout)   :: ut_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(DP), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(DP), dimension(:,:), allocatable    :: ut_I
      real(DP), dimension(:,:), allocatable    :: uz_PSI
      real(DP), dimension(nmc,0:km)  :: uz_TOR

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','TorMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(ut_I) ) deallocate(ut_I)
         if ( allocated(uz_PSI) ) deallocate(uz_PSI)

         allocate(alu(nmc,0:km,0:lm),kp(nmc,0:lm))
         allocate(ut_I(nmc,0:lm),uz_PSI(nmc,0:km))

         do l=0,lm
            ut_I = 0.0D0 ; ut_I(:,l)=1.0D0
            uz_PSI = uz_ut(ut_I)
            alu(:,:,l) = uz_PSI

            ! 非電気伝導体
            alu(:,0,l)  = uz_PSI(:,0)
            alu(:,km,l) = uz_PSI(:,km)
         enddo

         call ludecomp(alu,kp)

         deallocate(ut_I,uz_PSI)

         call MessageNotify('M','TormagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      uz_TOR       = uz_ut(ut_TOR)
      uz_TOR(:,0)  = 0.0D0
      uz_TOR(:,km) = 0.0D0
      ut_TOR = lusolve(alu,kp,uz_TOR)

    end subroutine ut_TormagBoundariesGrid

    subroutine ut_PolmagBoundariesTau(ut_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場ポロイダルポテンシャルの各水平スペクトル
      ! 成分 h にたいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !  * 内側境界 : dh/dr - nh/r = 0
      !
      ! である. ここで n は h の水平全波数である.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(DP), dimension(nmc,0:lm),intent(inout)   :: ut_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(DP), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(DP), dimension(:,:), allocatable    :: ut_I
      real(DP), dimension(:,:), allocatable    :: uz_PSI
      real(DP), dimension(:,:), allocatable    :: uz_DPSIDR
      real(DP), dimension(:), allocatable      :: u_n

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(ut_I) ) deallocate(ut_I)
         if ( allocated(uz_PSI) ) deallocate(uz_PSI)
         if ( allocated(uz_DPSIDR) ) deallocate(uz_DPSIDR)
         if ( allocated(u_n) ) deallocate(u_n)

         allocate(alu(nmc,0:lm,0:lm),kp(nmc,0:lm))
         allocate(ut_I(nmc,0:lm),u_n(nmc))
         allocate(uz_PSI(nmc,0:km),uz_DPSIDR(nmc,0:km))

         do n=1,nmc
            nn=nm_l(n)
            u_n(n) = nn(1)
         enddo

         do l=0,lm
            ut_I = 0.0D0 ; ut_I(:,l) = 1.0D0
            alu(:,:,l) = ut_I

            uz_PSI = uz_ut(ut_I)
            uz_DPSIDR = uz_ut(ut_DRad_ut(ut_I))
            alu(:,lm-1,l) = uz_DPSIDR(:,0) + (u_n+1) * uz_PSI(:,0)/z_RAD(0)
            alu(:,lm,l)   = uz_DPSIDR(:,km) - u_n * uz_PSI(:,km)/z_RAD(km)
         enddo

         call ludecomp(alu,kp)

         deallocate(ut_I,uz_PSI,uz_DPSIDR,u_n)

         call MessageNotify('M','PolmagBoundariesTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      ut_POL(:,lm-1) = 0.0D0
      ut_POL(:,lm)   = 0.0D0
      ut_POL = lusolve(alu,kp,ut_POL)

    end subroutine ut_PolmagBoundariesTau

    subroutine ut_PolmagBoundariesGrid(ut_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). このルーチンを用いるためには
      ! ut_Initial にて設定するチェビシェフ切断波数(lm)と鉛直格子点数(km)を
      ! 等しくしておく必要がある.
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している.
      ! その場合, 磁場ポロイダルポテンシャルの各水平スペクトル成分 h に
      ! たいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !  * 内側境界 : dh/dr - nh/r = 0
      !
      ! である. ここで n は h の水平全波数である.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(DP), dimension(nmc,0:lm),intent(inout)   :: ut_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す.

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(DP), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(DP), dimension(:,:), allocatable    :: ut_I
      real(DP), dimension(:,:), allocatable    :: uz_PSI
      real(DP), dimension(:,:), allocatable    :: uz_DPSIDR
      real(DP), dimension(:), allocatable      :: u_n

      real(DP), dimension(nmc,0:km)  :: uz_POL

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( lm /= km ) then
            call MessageNotify('E','PolMagBoundariesGrid', &
             'Chebyshev truncation and number of grid points should be same.')
         endif

         if ( allocated(alu) )  deallocate(alu)
         if ( allocated(kp) )   deallocate(kp)
         if ( allocated(ut_I) ) deallocate(ut_I)
         if ( allocated(uz_PSI) ) deallocate(uz_PSI)
         if ( allocated(uz_DPSIDR) ) deallocate(uz_DPSIDR)
         if ( allocated(u_n) ) deallocate(u_n)

         allocate(alu(nmc,0:lm,0:lm),kp(nmc,0:lm))
         allocate(ut_I(nmc,0:lm),u_n(nmc))
         allocate(uz_PSI(nmc,0:km),uz_DPSIDR(nmc,0:km))

         do n=1,nmc
            nn=nm_l(n)
            u_n(n) = nn(1)
         enddo

         do l=0,lm
            ut_I = 0.0D0 ; ut_I(:,l) = 1.0D0
            uz_PSI = uz_ut(ut_I)
            alu(:,:,l) = uz_PSI

            uz_DPSIDR = uz_ut(ut_DRad_ut(ut_I))
            alu(:,0,l)  = uz_DPSIDR(:,0) + (u_n+1) * uz_PSI(:,0)/z_RAD(0)
            alu(:,km,l) = uz_DPSIDR(:,km) - u_n * uz_PSI(:,km)/z_RAD(km)
         enddo

         call ludecomp(alu,kp)

         deallocate(ut_I,uz_PSI,uz_DPSIDR,u_n)

         call MessageNotify('M','PolmagBoundariesGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      uz_POL       = uz_ut(ut_POL)
      uz_POL(:,0)  = 0.0D0
      uz_POL(:,km) = 0.0D0
      ut_POL = lusolve(alu,kp,uz_POL)

    end subroutine ut_PolmagBoundariesGrid


  !--------------- 終了処理 -----------------
    subroutine ut_mpi_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう.
      !
      ! このサブルーチンを単独で用いるのでなく,
      ! 上位サブルーチン wa_mpi_Finalize を使用すること.
      !
      deallocate(h_Rad)
      deallocate(h_Rad_Weight)

      deallocate(xvh_Lon)
      deallocate(xvh_Lat)
      deallocate(xvh_Rad)

      deallocate(wh_Rad)
      deallocate(uz_Rad)

      call ua_mpi_finalize
      call at_Finalize

      call MessageNotify('M','ut_mpi_finalize',&
           'ut_mpi_module (2021/11/15) is finalized')

    end subroutine ut_mpi_Finalize

end module ut_mpi_module

!--
!----------------------------------------------------------------------
! Copyright(c) 2008-2025 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wq_module
!
!    spml/wq_module モジュールは球内での流体運動をスペクトル法によって
!    数値計算するための Fortran90 関数を提供するものである. 
!
!    水平方向に球面調和函数変換および動径方向に
!    Matsushima and Marcus (1994) で提唱された多項式を用いた
!    スペクトル計算のためのさまざまな関数を提供する. 
!
!    内部で wa_module, aq_module を用いている. 
!    最下部では球面調和変換変換のエンジンとして 
!    ISPACK の Fortran77 サブルーチンを用いている.
!
!    Matsushima and Marcus (1994) の多項式に関する説明は 
!    doc/spectral_radial.tex を参照のこと. 
!
!
!履歴  2008/04/03  竹広真一  wu_module より改変
!      2008/05/02  竹広真一  コメント追加
!      2008/07/01  佐々木洋平 水平方向の格子点を 0:im-1,1:jm に修正
!      2008/07/04  佐々木洋平 コメントを RDoc 用に微修正
!      2008/07/20  竹広真一  wq_Rad2_wq, wq_Rad2Inv_wq, wq_Lapla_wq 追加
!      2008/07/21  竹広真一  行列設定計算変更
!      2009/01/09  竹広真一  wu_Initial メッセージに日付を追加
!      2009/01/29  佐々木洋平 コメントを RDoc 用に微修正
!      2009/07/31  竹広真一  境界条件計算用配列を threadprivate 指定(OpenMP)
!      2009/12/06  竹広真一  先頭コメントを修正
!      2010/03/10  佐々木洋平  threadprivate 削除(コンパイラ依存)
!      2010/04/17  竹広真一  wr_DivRad_xyr 追加, wr_Div_xyr_xyr_xyr を変更
!                            wq_LaplaPol2Pol_wq の計算法変更
!      2010/05/08  竹広真一  wq_LaplaPol2Pol_wq の計算法元にもどす.
!      2011/09/08  竹広真一  コメント修正
!      2013/10/02  竹広真一  AvrRad_r bug fix
!      2025/12/22  竹広真一  spml2 へ移植. スペクトル計算を改訂.
!
!凡例
!      データ種類と index
!        x : 経度         y : 緯度        r : 動径
!        w : 球面調和関数スペクトル
!        n : 球面調和関数スペクトル(水平全波数)
!        m : 球面調和関数スペクトル(帯状波数)
!        q : スペクトル関数スペクトル
!        a : 任意の次元
!
!        xyr : 3 次元格子点データ
!        xy  : 水平 2 次元格子点データ
!        yr  : 子午面 2 次元格子点データ
!        xr  : 緯度面 2 次元格子点データ
!
!        wr  : 水平スペクトル動径格子点データ
!        wq  : スペクトルデータ
!
!++
module wq_module
  !
  != wq_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wq_module モジュールは球内での流体運動をスペクトル法によって
  ! 数値計算するための Fortran90 関数を提供するものである. 
  !
  ! 水平方向に球面調和函数変換および動径方向に
  ! Matsushima and Marcus (1994) で提唱された多項式を用いた
  ! スペクトル計算のためのさまざまな関数を提供する. 
  !
  ! 内部で wa_module, aq_module を用いている. 
  ! 最下部では球面調和変換のエンジンとして 
  ! ISPACK の Fortran77 サブルーチンを用いている.
  !
  !== 関数・変数の名前と型について
  !
  !=== 命名法
  !
  ! * 関数名の先頭 (wq_, nmr_, nr_, xyr_, wr_, w_, xy_, x_, y_, r_, a_) は, 
  !   返す値の形を示している.
  !   wq_  :: スペクトルデータ(球面調和函数・チェビシェフ変換)
  !   nmr_ :: 水平スペクトルデータ(全波数 n, 帯状波数各成分, 動径)
  !   nr_  :: 水平スペクトルデータ(全波数 n, 動径)
  !   xyr_ :: 3 次元格子点データ(経度・緯度・動径)
  !   wr_  :: 水平スペクトル, 動径格子点データ
  !
  ! * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,..)
  !   は, その関数の作用を表している.
  !
  ! * 関数名の最後 (wq_, xyz_, wr_, w_, xy_, x_, y_, r_, a_) は, 入力変数の
  !   形がスペクトルデータおよび格子点データであることを示している.
  !   _wq      :: スペクトルデータ
  !   _xyr     :: 3 次元格子点データ
  !   _xyr_xyr :: 2 つの3 次元格子点データ, ...
  !
  !=== 各データの種類の説明
  !
  ! * xyr : 3 次元格子点データ(経度・緯度・動径)
  !   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,km). 
  !   * im, jm, km はそれぞれ経度, 緯度, 動径座標の格子点数であり, 
  !     サブルーチン wq_Initial にてあらかじめ設定しておく.
  !
  ! * wq : スペクトルデータ
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),0:lm). 
  !   * nm は球面調和函数の最大全波数, lm はチェビシェフ多項式の最大次数
  !     であり, サブルーチン wq_Initial にてあらかじめ設定しておく. 
  !   * 水平スペクトルデータの格納のされ方は関数 l_nm, nm_l によって調べる
  !     ことができる. 
  !   * 動径スペクトルデータの格納方法については aq_module.f90 を
  !     参照のこと. km < 2*im でなければならない. 
  !
  ! * nmr : 水平スペクトルデータの並んだ 3 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,km). 
  !   * 第 1 次元が水平全波数, 第 2 次元が帯状波数, 第 3 次元が動径座標を表す. 
  !   * nm は球面調和函数の最大全波数であり, サブルーチン wq_Initial にて
  !     あらかじめ設定しておく.
  !
  ! * nr : スペクトルデータの並んだ 2 次元配列.
  !   * 変数の種類と次元は real(8), dimension(0:nm,km). 
  !   * 第 1 次元が水平全波数を表す. nm は球面調和函数の最大全波数であり, 
  !     サブルーチン wq_Initial にてあらかじめ設定しておく.
  !
  ! * wr : 水平スペクトル, 動径格子点データ.
  !   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),km).
  !
  ! * wq_ で始まる関数が返す値はスペクトルデータに同じ.
  !
  ! * xyr_ で始まる関数が返す値は 3 次元格子点データに同じ.
  !
  ! * wr_ で始まる関数が返す値は水平スペクトル, 動径格子点データに同じ.
  !
  ! * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
  !   微分などを作用させたデータをスペクトル変換したものことである.
  ! 
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化 
  !
  ! wq_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! 
  !==== 座標変数
  !
  ! x_Lon, y_Lat, r_Rad          :: 格子点座標(緯度, 経度, 動径座標)を
  !                                 格納した1 次元配列
  ! x_Lon_Weight, y_Lat_Weight, r_Rad_Weight :: 重み座標を格納した 1 次元配列
  ! xyr_Lon, xyr_Lat, xyr_Rad    :: 格子点データの経度・緯度・動径座標(X,Y,Z)
  !                                 (格子点データ型 3 次元配列)
  !
  !==== 基本変換
  !
  ! xyr_wq, wq_xyr :: スペクトルデータと 3 次元格子データの間の変換
  !                   (球面調和函数, チェビシェフ変換)
  !
  ! xyr_wr, wr_xyr :: 3 次元格子データと水平スペクトル・動径格子データとの
  !                   間の変換 (球面調和函数)
  !
  ! wr_wq, wq_wr   :: スペクトルデータと水平スペクトル・動径格子データとの
  !                   間の変換 (チェビシェフ変換)
  !
  ! w_xy, xy_w     :: スペクトルデータと 2 次元水平格子データの
  !                   間の変換(球面調和函数変換) 
  !
  ! l_nm, nm_l     :: スペクトルデータの格納位置と全波数・帯状波数の変換 
  !
  !==== 微分
  !
  ! wq_RadDRad_wq       :: スペクトルデータに動径微分 r∂/∂r を作用させる
  ! wr_DivRad_wq        :: スペクトルデータに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wr_DivRad_xyr       :: 格子点データに発散型動径微分
  !                        1/r^2 ∂/∂r r^2 = ∂/∂r + 2/r を作用させる
  ! wr_RotDRad_wq       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wr_RotDRad_wr       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wq_RotDRad_wr       :: スペクトルデータに回転型動径微分
  !                        1/r ∂/∂rr = ∂/∂r + 1/r を作用させる
  ! wq_Lapla_wq         :: スペクトルデータにラプラシアンを作用させる
  ! xyr_GradLon_wq      :: スペクトルデータに勾配型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! xyr_GradLat_wq      :: スペクトルデータに勾配型緯度微分
  !                        1/r・∂/∂φを作用させる
  ! wr_DivLon_xyr       :: 格子データに発散型経度微分
  !                        1/rcosφ・∂/∂λを作用させる
  ! wr_DivLat_xyr       :: 格子データに発散型緯度微分
  !                        1/rcosφ・∂(g cosφ)/∂φを作用させる
  ! wr_Div_xyr_xyr_xyr  :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyr_Div_xyr_xyr_xyr :: ベクトル成分である 3 つの格子データに
  !                        発散を作用させる
  ! xyr_RotLon_wq_wq    :: ベクトル場の回転の経度成分を計算する
  ! xyr_RotLat_wq_wq    :: ベクトル場の回転の緯度成分を計算する
  ! wr_RotRad_xyr_xyr   :: ベクトル場の回転の動径成分を計算する
  !
  !==== トロイダルポロイダル計算用微分
  !
  ! wq_KxRGrad_wq     :: スペクトルデータに経度微分
  !                      k×r・▽ = ∂/∂λを作用させる
  ! xyr_KGrad_wq      :: スペクトルデータに軸方向微分
  !                      k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r を作用させる
  ! wq_L2_wq          :: スペクトルデータに L2 演算子 = -水平ラプラシアンを
  !                      作用させる
  ! wq_L2Inv_wq       :: スペクトルデータに L2 演算子の逆 = -逆水平ラプラシアン
  !                      を作用させる
  ! wq_QOperator_wq   :: スペクトルデータに演算子
  !                      Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) を作用させる
  ! wr_RadRot_xyr_xyr :: ベクトル v の渦度と動径ベクトル r の内積 r・(▽×v) を
  !                      計算する
  ! wr_RadRotRot_xyr_xyr_xyr :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wq_RadRotRot_xyr_xyr_xyr :: ベクトルの v の r・(▽×▽×v) を計算する
  ! wq_Potential2Vector      :: トロイダルポロイダルポテンシャルから
  !                             ベクトル場を計算する
  ! wq_Potential2Rotation    :: トロイダルポロイダルポテンシャルで表される
  !                             非発散ベクトル場の回転の各成分を計算する
  !
  !==== ポロイダル/トロイダルモデル用スペクトル解析
  !
  ! nmr_ToroidalEnergySpectrum_wq, nr_ToroidalEnergySpectrum_wq  ::
  !     トロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  ! nmr_PoloidalEnergySpectrum_wq, nr_PoloidalEnergySpectrum_wq  ::
  !     ポロイダルポテンシャルからエネルギーの球面調和函数各成分を計算する
  !
  !==== 境界値問題
  !
  ! wq_BoundaryTau, wr_BoundaryGrid, wq_Boundary                         ::
  !     ディリクレ, ノイマン境界条件を適用する(タウ法, 選点法)
  ! wq_TorBoundaryTau, wr_TorBoundaryGrid, wq_TorBoundary                ::
  !     速度トロイダルポテンシャルの境界条件を適用する(タウ法,選点法)       
  ! wq_LaplaPol2Pol_wq, wq_LaplaPol2PolTau_wq                            ::
  !     速度ポロイダルポテンシャルΦを▽^2Φから求める
  !     (入出力がそれぞれ格子点およびスペクトル係数)
  ! wq_TorMagBoundaryTau, wr_TorMagBoundaryGrid, wq_TorMagBoundary       ::
  !     磁場トロイダルポテンシャルの境界条件を適用する(タウ法, 選点法)
  ! wq_PolMagBoundaryTau, wr_PolMagBoundaryGrid, wq_PolMagBoundary       ::
  !     磁場トロイダルポテンシャル境界の境界条件を適用する(タウ法, 選点法)
  !
  !==== 積分・平均(3 次元データ)
  !
  ! IntLonLatRad_xyr, AvrLonLatRad_xyr :: 3 次元格子点データの
  !                                       全領域積分および平均
  ! r_IntLonLat_xyr, r_AvrLonLat_xyr   :: 3 次元格子点データの
  !                                       緯度経度(水平・球面)積分および平均
  ! y_IntLonRad_xyr, y_AvrLonRad_xyr   :: 3 次元格子点データの
  !                                       緯度動径積分および平均
  ! x_IntLatRad_xyr, x_AvrLatRad_xyr   :: 3 次元格子点データの
  !                                       経度動径(子午面)積分および平均
  ! yr_IntLon_xyr, yr_AvrLon_xyr       :: 3 次元格子点データの
  !                                       経度方向積分および平均
  ! xr_IntLat_xyr, xr_AvrLat_xyr       :: 3 次元格子点データの
  !                                       緯度方向積分および平均
  ! xr_IntRad_xyr, xr_AvrRad_xyr       :: 3 次元格子点データの
  !                                       動径方向積分および平均
  !
  !==== 積分・平均(2 次元データ)
  !
  ! IntLonLat_xy, AvrLonLat_xy :: 2 次元格子点データの水平(球面)積分および平均
  ! IntLonRad_xr, AvrLonRad_xr :: 2 次元(XZ)格子点データの経度動径積分
  !                               および平均
  ! IntLatRad_yr, AvrLatRad_yr :: 2 次元(YZ)格子点データの緯度動径(子午面)
  !                               積分および平均 
  ! y_IntLon_xy, y_AvrLon_xy   :: 水平 2 次元(球面)格子点データの経度方向
  !                               積分および平均
  ! x_IntLat_xy, x_AvrLat_xy   :: 水平2 次元(球面)格子点データの緯度方向積分
  !                               および平均
  ! r_IntLon_xr, r_AvrLon_xr   :: 2 次元(XZ)格子点データの経度方向積分および
  !                               平均
  ! x_IntRad_xr, x_AvrRad_xr   :: 2 次元(XZ)格子点データの動径方向積分および
  !                               平均
  ! r_IntLat_yr, r_AvrLat_yr   :: 2 次元(YZ)格子点データの緯度方向積分および
  !                               平均
  ! y_IntRad_yr, y_AvrRad_yr   :: 2 次元(YZ)格子点データの動径方向積分および
  !                               平均                  
  !
  !==== 積分・平均(1 次元データ)
  !
  ! IntLon_x, AvrLon_x  :: 1 次元(X)格子点データの経度方向積分および平均
  ! IntLat_y, AvrLat_y  :: 1 次元(Y)格子点データの緯度方向積分および平均
  ! IntRad_r, AvrRad_r  :: 1 次元(Z)格子点データの動径方向積分および平均
  !
  ! 
  use dc_message
  use lumatrix
  use wa_module
  use aq_module, r_Rad => g_R, r_RAD_WEIGHT => g_R_WEIGHT, &
                 aq_ar => aq_ag, ar_aq => ag_aq, &
                 q_RadDRad_q => q_rDr_q, wq_RadDRad_wq => aq_rDr_aq, &
                 wq_Rad2_wq => aq_r2_aq, q_Rad2_q => q_r2_q, &
                 wq_Rad2Inv_wq => aq_r2Inv_aq, q_Rad2Inv_q => q_r2Inv_q
  implicit none
  private

  public wq_Initial

  public x_Lon, x_Lon_Weight
  public y_Lat, y_Lat_Weight
  public r_Rad, r_Rad_Weight
  public l_nm, nm_l
  public xy_Lon, xy_Lat
  public xyr_Lon, xyr_Lat, xyr_Rad
  public wr_Rad
  public wq_VMiss

  public w_xy, xy_w
  public wq_RadDRad_wq, q_RadDRad_q, wr_wq, wq_wr
  public wq_Rad2_wq, q_Rad2_q, wq_Rad2Inv_wq, q_Rad2Inv_q
  public xyr_wq, wq_xyr, xyr_wr, wr_xyr
  public wr_DivRad_wq, wr_RotDRad_wq, wr_RotDRad_wr, wq_Lapla_wq
  public wq_RotDRad_wr
  public xyr_GradLon_wq, xyr_GradLat_wq
  public wr_DivLon_xyr, wr_DivLat_xyr, wr_DivRad_xyr
  public wr_Div_xyr_xyr_xyr, xyr_Div_xyr_xyr_xyr
  public xyr_RotLon_wq_wq, xyr_RotLat_wq_wq, wr_RotRad_xyr_xyr

  public yr_IntLon_xyr, xr_IntLat_xyr, xy_IntRad_xyr
  public x_IntLatRad_xyr, y_IntLonRad_xyr, r_IntLonLat_xyr
  public IntLonLatRad_xyr

  public x_IntLat_xy, y_IntLon_xy, IntLonLat_xy
  public r_IntLat_yr, y_IntRad_yr, IntLatRad_yr
  public r_IntLon_xr, x_IntRad_xr, IntLonRad_xr
  public IntLon_x, IntLat_y, IntRad_r

  public yr_AvrLon_xyr, xr_AvrLat_xyr, xy_AvrRad_xyr
  public x_AvrLatRad_xyr, y_AvrLonRad_xyr, r_AvrLonLat_xyr
  public AvrLonLatRad_xyr

  public x_AvrLat_xy, y_AvrLon_xy, AvrLonLat_xy
  public r_AvrLat_yr, y_AvrRad_yr, AvrLatRad_yr
  public r_AvrLon_xr, x_AvrRad_xr, AvrLonRad_xr
  public AvrLon_x, AvrLat_y, AvrRad_r

  public wq_KxRGrad_wq, xyr_KGrad_wq, wq_L2_wq, wq_L2Inv_wq, wq_QOperator_wq
  public wr_RadRot_xyr_xyr, wr_RadRotRot_xyr_xyr_xyr
  public wq_RadRotRot_xyr_xyr_xyr
  public wq_Potential2vector, wq_Potential2Rotation

  public nmr_ToroidalEnergySpectrum_wq, nr_ToroidalEnergySpectrum_wq
  public nmr_PoloidalEnergySpectrum_wq, nr_PoloidalEnergySpectrum_wq

  public wq_Boundary, wq_TorBoundary, wq_LaplaPol2Pol_wq ! wr_LaplaPol2Pol_wr
  public wq_TormagBoundary, wq_PolmagBoundary

  public wq_BoundaryTau, wq_TorBoundaryTau, wq_LaplaPol2PolTau_wq
  public wq_TormagBoundaryTau, wq_PolmagBoundaryTau

  public wr_BoundaryGrid, wr_TorBoundaryGrid
  public wr_TormagBoundaryGrid, wr_PolmagBoundaryGrid

  interface wq_Boundary
     module procedure wq_BoundaryTau
  end interface

  interface wq_TorBoundary
     module procedure wq_TorBoundaryTau
  end interface

  interface wq_LaplaPol2Pol_wq
     module procedure wq_LaplaPol2PolTau_wq
  end interface

  interface wq_TorMagBoundary
     module procedure wq_TorMagBoundaryTau
  end interface

  interface wq_PolMagBoundary
     module procedure wq_PolMagBoundaryTau
  end interface

  integer            :: im=64, jm=32, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer            :: nm=21, lm=10         ! 切断波数の設定(水平, 動径)
  real(8)            :: ra=1.0               ! 球半径
  real(8), parameter :: pi=3.1415926535897932385D0

  real(8), parameter :: alpha = 1.0D0      ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: beta  = 2.0D0      ! 展開多項式パラメター  0 < β

  real(8), dimension(:,:,:), allocatable :: xyr_LON, xyr_LAT, xyr_RAD ! 座標
  real(8), dimension(:,:), allocatable   :: wr_RAD                    ! 座標
  integer, dimension(:), allocatable     :: nd             ! 重み r^n の指数

  real(8) :: wq_VMiss = -999.0        ! 欠損値

  save im, jm, km, nm, lm, ra, nd, xyr_Lon, xyr_Lat, xyr_Rad, wr_Rad

  contains
  !--------------- 初期化 -----------------
   subroutine wq_Initial(i,j,k,n,l,r,np,wa_init)
     !
     ! スペクトル変換の格子点数, 波数, 動径座標の範囲を設定する.
     !
     ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
     ! しなければならない. 
     !
     ! np に 1 より大きな値を指定すれば ISPACK の球面調和函数変換 
     ! OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには, 
     ! 実行時に環境変数 OMP_NUM_THREADS を np 以下の数字に設定する等の
     ! システムに応じた準備が必要となる. 
     !
     ! np に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
     !
     !
     integer,intent(in) :: i              ! 格子点数(経度λ)
     integer,intent(in) :: j              ! 格子点数(緯度φ)
     integer,intent(in) :: k              ! 格子点数(動径 r)
     integer,intent(in) :: n              ! 切断波数(水平全波数)
     integer,intent(in) :: l              ! 切断波数(動径波数)

     real(8),intent(in) :: r              ! 球半径

     integer,intent(in), optional :: np   ! OPENMP での最大スレッド数
     logical,intent(in), optional :: wa_init   ! wa_initial スイッチ

     logical    :: wa_initialize=.true.   ! wa_initial スイッチ

     integer :: nn, mm

     im = i  ; jm = j ; km = k
     nm = n  ; lm = l
     ra = r

     if ( present(wa_init) ) then
        wa_initialize = wa_init
     else
        wa_initialize = .true.
     endif

     if ( wa_initialize ) then
        if ( present(np) ) then
           call wa_Initial(nm,im,jm,km,np)
        else
           call wa_Initial(nm,im,jm,km)
        endif
     endif

     allocate(nd((nm+1)*(nm+1)))

     do nn=0,nm
        do mm=-nn,nn
           nd(l_nm(nn,mm)) = nn                 ! 水平 n 次は r^n から
        enddo
     enddo

     call aq_Initial(km,lm,ra,alpha,beta,nd)

     allocate(xyr_Lon(0:im-1,1:jm,km))
     allocate(xyr_Lat(0:im-1,1:jm,km))
     allocate(xyr_Rad(0:im-1,1:jm,km))

     allocate(wr_Rad((nm+1)*(nm+1),km))

     xyr_Lon = spread(xy_Lon,3,km)
     xyr_Lat = spread(xy_Lat,3,km)
     xyr_Rad = spread(spread(r_Rad,1,jm),1,im)

     wr_Rad = spread(r_Rad,1,(nm+1)*(nm+1))

    call MessageNotify('M','wq_initial','wq_module (2025/12/20) is initialized')

   end subroutine wq_initial

  !--------------- 基本変換 -----------------

    function xyr_wq(wq)
      !
      ! スペクトルデータから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:im-1,1:jm,km)                       :: xyr_wq
      !(out) 3 次元経度緯度動径格子点データ

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      xyr_wq = xya_wa(wr_wq(wq))

    end function xyr_wq

    function wq_xyr(xyr)
      !
      ! 3 次元格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wq_xyr
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jm,km), intent(in)           :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      wq_xyr = wq_wr(wa_xya(xyr))

    end function wq_xyr

    function xyr_wr(wr)
      !
      ! 水平スペクトル・動径格子点データから 3 次元格子点データへ(逆)変換する.
      !
      real(8), dimension(0:im-1,1:jm,km)                     :: xyr_wr
      !(out) 3 次元経度緯度動径格子点データ

      real(8), dimension((nm+1)*(nm+1),km), intent(in) :: wr
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ

      xyr_wr = xya_wa(wr)

    end function xyr_wr

    function wr_xyr(xyr)
      !
      ! 3 次元格子データから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),km)               :: wr_xyr
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ

      real(8), dimension(0:im-1,1:jm,km), intent(in)         :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      wr_xyr = wa_xya(xyr)

    end function wr_xyr

    function wr_wq(wq)
      !
      ! スペクトルデータから水平スペクトル・動径格子点データへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),km) :: wr_wq
      !(out) 2 次元球面調和函数スペクトル・動径格子点データ
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      wr_wq = ar_aq(wq)

    end function wr_wq

    function wq_wr(wr)
      !
      ! 水平スペクトル・動径格子点データからスペクトルデータへ(正)変換する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm) :: wq_wr
      !(out) 2 次元球面調和函数チェビシェフスペクトルデータ
      real(8), dimension((nm+1)*(nm+1),km), intent(in) :: wr
      !(in) 2 次元球面調和函数スペクトル・動径格子点データ

      wq_wr = aq_ar(wr)
      
    end function wq_wr


  !--------------- 微分計算 -----------------
    function wr_DivRad_wq(wq)
      ! 
      ! 入力スペクトルデータに発散型動径微分
      !
      !       1/r^2 ∂/∂r (r^2 .)= ∂/∂r + 2/r
      !
      ! を作用する.
      !
      ! スペクトルデータの発散型動径微分とは, 対応する格子点データに
      ! 発散型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),km)             :: wr_DivRad_wq
      !(out) 発散型動径微分を作用された水平スペクトル動径格子点データ

      wr_DivRad_wq = wr_wq(wq_RadDRad_wq(wq))/wr_Rad + 2/wr_Rad * wr_wq(wq)

    end function wr_DivRad_wq

    function wr_DivRad_xyr(xyr)
      ! 
      ! 格子点データに発散型動径微分
      !
      !       1/r^2 ∂/∂r (r^2  = ∂/∂r + 2/= 1/r∂/∂(r.) + 1/r
      !
      ! を作用する.
      !
      ! この関数の入力は動径次数と水平全波数の偶奇性が異なっていることを
      ! 仮定している. 偶奇性が一致している場合には wr_DigRad_wq を使用すること.
      !
      real(8), dimension(0:im-1,jm,km), intent(in) :: xyr
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),km)             :: wr_DivRad_xyr
      !(out) 発散型動径微分を作用された水平スペクトル動径格子点データ

      wr_DivRad_xyr = wr_wq(wq_RadDRad_wq(wq_xyr(xyr_Rad*xyr)))/wr_Rad**2 &
                    + 1/wr_Rad * wr_xyr(xyr)

    end function wr_DivRad_xyr

    function wr_RotDRad_wq(wq)
      !
      ! 入力スペクトルデータに回転型動径微分
      !
      !      1/r ∂(r.)/∂r = ∂(.)/∂r + (.)/r
      !
      ! を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),km)               :: wr_RotDRad_wq
      !(out) 回転型動径微分を作用された水平スペクトル動径格子点データ

      wr_RotDRad_wq = wr_wq(wq_RadDrad_wq(wq))/wr_Rad + wr_wq(wq)/wr_Rad

    end function wr_RotDRad_wq

    function wr_RotDRad_wr(wr)
      !
      ! 入力スペクトルデータに回転型動径微分
      !
      !      1/r ∂(r.)/∂r = ∂(.)/∂r + (.)/r
      !
      ! を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),km), intent(in) :: wr
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),km)               :: wr_RotDRad_wr
      !(out) 回転型動径微分を作用された水平スペクトル動径格子点データ

      wr_RotDRad_wr = wr_wq(wq_RadDRad_wq(wq_wr(wr*wr_Rad)))/wr_Rad**2

    end function wr_RotDRad_wr

    function wq_RotDRad_wr(wr)
      !
      ! 入力スペクトルデータに回転型動径微分
      !
      !      1/r ∂(r.)/∂r = ∂(.)/∂r + (.)/r
      !
      ! を作用する.
      !
      ! スペクトルデータの回転型動径微分とは, 対応する格子点データに
      ! 回転型動径微分を作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),km), intent(in) :: wr
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)               :: wq_RotDRad_wr
      !(out) 回転型動径微分を作用された水平スペクトル動径格子点データ

      wq_RotDRad_wr = wq_Rad2Inv_wq(wq_RadDRad_wq(wq_wr(wr*wr_Rad)))

    end function wq_RotDRad_wr

    function wq_Lapla_wq(wq)
      ! 入力スペクトルデータにラプラシアン
      !
      !     ▽^2 =   1/r^2 cos^2φ・∂^2/∂λ^2 
      !            + 1/r^2 cosφ・∂/∂φ(cosφ∂/∂φ) 
      !            + 1/r^2 ∂/∂r (r^2 ∂/∂r) 
      !              [1/r^2 (r∂/∂r)(r∂/∂r) + 1/r^2(r∂/∂r)]
      !
      ! を作用する.
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wq_Lapla_wq
      !(out) ラプラシアンを作用された水平スペクトルデータ

      wq_Lapla_wq = wq_Rad2Inv_wq(  wq_RadDRad_wq(wq_RadDRad_wq(wq)) &
                                  + wq_RadDRad_wq(wq)+ wa_Lapla_wa(wq) )

    end function wq_Lapla_wq

    function xyr_GradLon_wq(wq)
      !
      ! スペクトルデータに勾配型経度微分 1/rcosφ・∂/∂λ
      ! を作用させる.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jm,km)    :: xyr_GradLon_wq
      !(out) 勾配型経度微分を作用された 2 次元スペクトルデータ

      xyr_GradLon_wq = xya_GradLon_wa(wr_wq(wq))/xyr_Rad

    end function xyr_GradLon_wq

    function xyr_GradLat_wq(wq) 
      !
      ! スペクトルデータに勾配型経度微分 1/r ∂/∂φ を作用させる.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jm,km)    :: xyr_GradLat_wq
      !(out) 勾配型緯度微分を作用された 2 次元スペクトルデータ

      xyr_GradLat_wq = xya_GradLat_wa(wr_wq(wq))/xyr_Rad

    end function xyr_GradLat_wq

    function wr_DivLon_xyr(xyr)
      ! 
      ! 格子点データに発散型経度微分 1/rcosφ・∂/∂λ を作用させた
      ! スペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in)     :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension((nm+1)*(nm+1),km)         :: wr_DivLon_xyr
      !(out) 発散型経度微分を作用された水平スペクトル動径格子点データ

      wr_DivLon_xyr = wa_DivLon_xya(xyr/xyr_Rad)

    end function wr_DivLon_xyr

    function wr_DivLat_xyr(xyr)
      !
      ! 格子データに発散型緯度微分 1/rcosφ・∂(f cosφ)/∂φ を
      ! 作用させたスペクトルデータを返す.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in)     :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension((nm+1)*(nm+1),km)         :: wr_DivLat_xyr
      !(out) 発散型緯度微分を作用された水平スペクトル動径格子点データ

      wr_DivLat_xyr = wa_DivLat_xya(xyr/xyr_Rad)

    end function wr_DivLat_xyr

    function wr_Div_xyr_xyr_xyr(xyr_Vlon,xyr_Vlat,xyr_Vrad)
      !
      ! べクトル成分である 3 つの格子データに発散を作用させた
      ! スペクトルデータを返す.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表し, 発散は 
      !
      !      1/rcosφ・∂u/∂λ + 1/rcosφ・∂(v cosφ)/∂φ 
      !    + 1/r^2 ∂/∂r (r^2 w)
      !
      ! と計算される.
      !
      ! 第3成分の動径次数と水平全波数の偶奇性がずれていることを仮定している.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),km)     :: wr_Div_xyr_xyr_xyr
      !(out) ベクトル場の発散

      wr_Div_xyr_xyr_xyr =   wr_DivLon_xyr(xyr_Vlon) &
                           + wr_DivLat_xyr(xyr_Vlat) &
                           + wr_DivRad_xyr(xyr_Vrad)

    end function wr_Div_xyr_xyr_xyr

    function xyr_Div_xyr_xyr_xyr(xyr_Vlon,xyr_Vlat,xyr_Vrad)
      !
      ! ベクトル成分である 3 つの格子データに発散を作用させる.
      !
      ! 第 1, 2 ,3 引数(u,v,w)がそれぞれベクトルの経度成分, 緯度成分, 
      ! 動径成分を表す.
      !
      ! 極の特異性を回避するためにベクトル場に cosφ/r の重みをかけて
      ! 計算している. 
      !
      !      div V = (r/cosφ)・div (Vcosφ/r) + V_φtanφ/r + V_r/r
      ! 
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,1:jm,km)             :: xyr_Div_xyr_xyr_xyr
      !(out) ベクトル場の発散

      xyr_Div_xyr_xyr_xyr &
           = xyr_Rad/cos(xyr_Lat) &
                * xyr_wr(wr_Div_xyr_xyr_xyr(xyr_VLon*cos(xyr_Lat)/xyr_Rad,  &
                                            xyr_VLat*cos(xyr_Lat)/xyr_Rad,  &
                                            xyr_VRad*cos(xyr_Lat)/xyr_Rad ))&
             + xyr_VLat*tan(xyr_Lat)/xyr_Rad &
             + xyr_VRad/xyr_Rad

    end function xyr_Div_xyr_xyr_xyr

    function xyr_RotLon_wq_wq(wq_Vrad,wq_Vlat) 
      !
      ! ベクトル場の動径成分, 緯度成分である第 1, 2 引数 Vrad, Vlat から
      ! 回転の経度成分 
      !
      !    1/r ∂Vrad/∂φ-1/r ∂(r Vlat)/∂r を計算する.
      !
      ! を計算する
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,km)                 :: xyr_RotLon_wq_wq
      !(out) ベクトル場の回転の経度成分

        xyr_RotLon_wq_wq =   xyr_GradLat_wq(wq_Vrad) &
                           - xyr_wr(wr_RotDRad_wq(wq_Vlat))

    end function xyr_RotLon_wq_wq

    function xyr_RotLat_wq_wq(wq_Vlon,wq_Vrad) 
      !
      ! ベクトル場の経度成分, 動径成分である第 1, 2 引数 Vlon, Vrad から
      ! 回転の緯度成分 
      !
      !    1/r ∂(r Vlon)/∂r - 1/rcosφ・∂Vrad/∂λ
      !
      ! を計算する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_Vrad
      !(in) ベクトル場の動径成分

      real(8), dimension(0:im-1,1:jm,km)                 :: xyr_RotLat_wq_wq
      !(out) ベクトル場の回転の緯度成分

        xyr_RotLat_wq_wq =   xyr_wr(wr_RotDRad_wq(wq_Vlon)) &
                           - xyr_GradLon_wq(wq_Vrad) 

    end function xyr_RotLat_wq_wq

    function wr_RotRad_xyr_xyr(xyr_Vlat,xyr_Vlon) 
      !
      ! ベクトルの緯度成分, 経度成分である第 1, 2 引数 Vlat, Vlon に対して
      ! ベクトル場の回転の動径成分 
      !
      !    1/rcosφ・∂Vlat/∂λ - 1/rcosφ・∂(Vlon cosφ)/∂φ
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_Vlat
      !(in) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_Vlon
      !(in) ベクトル場の経度成分

      real(8), dimension((nm+1)*(nm+1),km)       :: wr_RotRad_xyr_xyr
      !(out) ベクトル場の回転の動径成分

        wr_RotRad_xyr_xyr =   wr_DivLon_xyr(xyr_Vlat) &
                            - wr_DivLat_xyr(xyr_Vlon)

    end function wr_RotRad_xyr_xyr

  !--------------- 積分計算 -----------------
    !----(入力データ xyr)---
    function yr_IntLon_xyr(xyr)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm,km)  :: yr_IntLon_xyr
      !(out) 経度方向(帯状)積分された 2 次元子午面格子点データ

      integer :: i

      yr_IntLon_xyr = 0.0d0
      do i=0,im-1
         yr_IntLon_xyr(:,:) = yr_IntLon_xyr(:,:) &
                       + xyr(i,:,:) * x_Lon_Weight(i)
      enddo
    end function yr_IntLon_xyr

    function xr_IntLat_xyr(xyr)
      !
      ! 3 次元格子点データの緯度方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,km)  :: xr_IntLat_xyr        
      !(out) 緯度積分された 2 次元緯度動径格子点データ
      ! 緯度円格子点データ

      integer :: j

      xr_IntLat_xyr = 0.0d0
      do j=1,jm
         xr_IntLat_xyr(:,:) = xr_IntLat_xyr(:,:) &
                       + xyr(:,j,:) * y_Lat_Weight(j)
      enddo

    end function xr_IntLat_xyr

    function xy_IntRad_xyr(xyr)  ! 動径積分
      !
      ! 3 次元格子点データの動径方向域積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_IntRad_xyr
      !(out) 動径積分された 2 次元経度緯度(水平, 球面)格子点データ

      integer :: k

      xy_IntRad_xyr = 0.0d0
      do k=1,km
         xy_IntRad_xyr(:,:) = xy_IntRad_xyr(:,:) &
                       + xyr(:,:,k) * r_Rad_Weight(k) 
      enddo

    end function xy_IntRad_xyr

    function x_IntLatRad_xyr(xyr)
      !
      ! 3 次元格子点データの緯度動径(子午面)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_IntLatRad_xyr
      !(out) 緯度動径(子午面)積分された 1 次元経度格子点データ

      integer :: j, k

      x_IntLatRad_xyr = 0.0D0
      do k=1,km
         do j=1,jm
            x_IntLatRad_xyr = x_IntLatRad_xyr &
                 + xyr(:,j,k) * y_Lat_Weight(j) * r_Rad_Weight(k)
         enddo
      enddo

    end function x_IntLatRad_xyr

    function y_IntLonRad_xyr(xyr)
      !
      ! 3 次元格子点データの経度動径(緯度円)積分.
      !
      ! 3 次元データ f(λ,φ,r) に対して∫f(λ,φ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm)       :: y_IntLonRad_xyr
      !(out) 経度動径(緯度円)積分された 1 次元緯度格子点データ

      integer :: i, k

      y_IntLonRad_xyr = 0.0D0
      do k=1,km
         do i=0,im-1
            y_IntLonRad_xyr = y_IntLonRad_xyr &
                 + xyr(i,:,k) * x_Lon_Weight(i) * r_Rad_Weight(k)
         enddo
      enddo

    end function y_IntLonRad_xyr

    function r_IntLonLat_xyr(xyr)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(km)     :: r_IntLonLat_xyr
      !(out) 緯度経度(水平, 球面)積分された 1 次元動径格子点データ

      integer :: i, j

      r_IntLonLat_xyr = 0.0D0
      do j=1,jm
         do i=0,im-1
            r_IntLonLat_xyr = r_IntLonLat_xyr &
                 + xyr(i,j,:) * x_Lon_Weight(i) * y_Lat_Weight(j)
         enddo
      enddo
    end function r_IntLonLat_xyr

    function IntLonLatRad_xyr(xyr) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2cosφ dλdφdr 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr 
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: IntLonLatRad_xyr 
      !(out) 全球積分値

      integer :: i, j, k

      IntLonLatRad_xyr = 0.0D0
      do k=1,km
         do j=1,jm
            do i=0,im-1
               IntLonLatRad_xyr = IntLonLatRad_xyr &
                    + xyr(i,j,k) * x_Lon_Weight(i) &
                         * y_Lat_Weight(j) * r_Rad_Weight(k)
            enddo
         enddo
      enddo

    end function IntLonLatRad_xyr

    !----(入力データ yr)---
    function r_IntLat_yr(yr)  ! 緯度積分
      !
      ! 2 次元(YR)格子点データの緯度方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) cosφ dφ を計算する.
      !
      real(8), dimension(1:jm,km), intent(in) :: yr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(km)  :: r_IntLat_yr
      !(out) 緯度積分された 1 次元動径格子点データ

      integer :: j

      r_IntLat_yr = 0.0d0
      do j=1,jm
         r_IntLat_yr(:) = r_IntLat_yr(:) + yr(j,:) * y_Lat_Weight(j)
      enddo

    end function r_IntLat_yr

    function y_IntRad_yr(yr)  ! 動径積分
      !
      ! 2 次元(YR)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(φ,r) に対して∫f(φ,r) r^2dr を計算する.
      !
      real(8), dimension(1:jm,km), intent(in) :: yr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jm)  :: y_IntRad_yr
      !(out) 動径積分された 1 次元緯度格子点データ

      integer :: k

      y_IntRad_yr = 0.0d0
      do k=1,km
         y_IntRad_yr(:) = y_IntRad_yr(:) &
                       + yr(:,k) * r_Rad_Weight(k) 
      enddo

    end function y_IntRad_yr

    function IntLatRad_yr(yr)
      !
      ! 2 次元(YR)格子点データの緯度動径積分(子午面)および平均
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2cosφ dφdr を計算する.
      !
      real(8), dimension(1:jm,km), intent(in) :: yr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: IntLatRad_yr
      !(out) 積分値
      integer :: j, k

      IntLatRad_yr = 0.0D0
      do k=1,km
         do j=1,jm
            IntLatRad_yr = IntLatRad_yr &
                 + yr(j,k) * y_Lat_Weight(j) * r_Rad_Weight(k)
         enddo
      enddo

    end function IntLatRad_yr

    !----(入力データ xr)---
    function r_IntLon_xr(xr)
      !
      ! 2 次元(XR)格子点データの経度方向積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ を計算する.
      !
      real(8), dimension(0:im-1,km), intent(in) :: xr
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(km)  :: r_IntLon_xr
      !(out) 経度積分された 1 次元動径格子点データ

      integer :: i

      r_IntLon_xr = 0.0d0
      do i=0,im-1
         r_IntLon_xr(:) = r_IntLon_xr(:) + xr(i,:) * x_Lon_Weight(i)
      enddo

    end function r_IntLon_xr

    function x_IntRad_xr(xr)
      !
      ! 2 次元(XR)格子点データの動径方向域積分.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r) r^2dr を計算する.
      !
      real(8), dimension(0:im-1,km), intent(in) :: xr
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_IntRad_xr
      !(out) 動径積分された 1 次元経度格子点データ

      integer :: k

      x_IntRad_xr = 0.0d0
      do k=1,km
         x_IntRad_xr(:) = x_IntRad_xr(:) &
                       + xr(:,k) * r_Rad_Weight(k) 
      enddo

    end function x_IntRad_xr

    function IntLonRad_xr(xr)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XR)格子点データの経度動径積分
      !
      ! 2 次元データ f(λ,r) に対して∫f(λ,r) r^2dλdr を計算する.
      !
      real(8), dimension(0:im-1,km), intent(in) :: xr
      !(in) 2 次元緯度動径格子点データ

      real(8)                                 :: IntLonRad_xr
      !(out) 積分値

      integer :: i, k

      IntLonRad_xr = 0.0D0
      do k=1,km
         do i=0,im-1
            IntLonRad_xr = IntLonRad_xr &
                 + xr(i,k) * x_Lon_Weight(i) * r_Rad_Weight(k)
         enddo
      enddo

    end function IntLonRad_xr

    !----(入力データ z)---
    function IntRad_r(z)  ! 動径積分
      !
      ! 1 次元(Z)格子点データの動径方向域積分.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr を計算する.
      !
      real(8), dimension(km), intent(in) :: z
      !(in) 1 次元動径格子点データ

      real(8)                              :: IntRad_r
      !(out) 積分値

      integer :: k

      IntRad_r = 0.0d0
      do k=1,km
         IntRad_r = IntRad_r + z(k) * r_Rad_Weight(k) 
      enddo

    end function IntRad_r

  !--------------- 平均計算 -----------------
    !----(入力データ xyr)---
    function yr_AvrLon_xyr(xyr)  ! 経度(帯状)積分
      !
      ! 3 次元格子点データの経度方向(帯状)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm,km)  :: yr_AvrLon_xyr
      !(out) 経度方向(帯状)平均された 2 次元子午面格子点データ

      yr_AvrLon_xyr = yr_IntLon_xyr(xyr)/sum(x_Lon_Weight)

    end function yr_AvrLon_xyr

    function xr_AvrLat_xyr(xyr)  ! 緯度積分
      !
      ! 3 次元格子点データの緯度方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して ∫f(λ,φ,r)cosφ dφ/2 を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,km)  :: xr_AvrLat_xyr
      !(out) 緯度平均された 2 次元緯度動径格子点データ

      xr_AvrLat_xyr = xr_IntLat_xyr(xyr)/sum(y_Lat_Weight)

    end function xr_AvrLat_xyr

    function xy_AvrRad_xyr(xyr)
      !
      ! 3 次元格子点データの動径方向域平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して 
      !
      !    ∫f(λ,φ,r) r^2dr/((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1,1:jm)  :: xy_AvrRad_xyr          
      !(out) 動径平均された 2 次元経度緯度(水平, 球面)格子点データ
      ! 水平格子点データ

      xy_AvrRad_xyr = xy_IntRad_xyr(xyr)/sum(r_Rad_Weight)

    end function xy_AvrRad_xyr

    function x_AvrLatRad_xyr(xyr)  ! 緯度動径(子午面)積分
      !
      ! 3 次元格子点データの緯度動径(子午面)平均
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(0:im-1)     :: x_AvrLatRad_xyr
      !(out) 緯度動径(子午面)平均された 1 次元経度格子点データ

      x_AvrLatRad_xyr = x_IntLatRad_xyr(xyr) &
                   /( sum(y_Lat_Weight)*sum(r_Rad_Weight) )

    end function x_AvrLatRad_xyr

    function y_AvrLonRad_xyr(xyr)  ! 経度動径(緯度円)積分
      !
      ! 3 次元格子点データの経度動径(緯度円)平均.
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !     ∫f(λ,φ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(1:jm)       :: y_AvrLonRad_xyr
      !(out) 経度動径(緯度円)平均された 1 次元緯度格子点データ

      y_AvrLonRad_xyr = y_IntLonRad_xyr(xyr) &
                 /(sum(x_Lon_Weight)*sum(r_Rad_Weight))

    end function y_AvrLonRad_xyr

    function r_AvrLonLat_xyr(xyr)  ! 緯度経度(水平)積分
      !
      ! 3 次元格子点データの緯度経度(水平, 球面)積分
      ! 
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) cosφ dλdφ /4π 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8), dimension(km)     :: r_AvrLonLat_xyr
      !(out) 緯度経度(水平, 球面)平均された 1 次元動径格子点データ

      r_AvrLonLat_xyr = r_IntLonLat_xyr(xyr) &
                 /(sum(x_Lon_Weight)*sum(y_Lat_Weight))

    end function r_AvrLonLat_xyr

    function AvrLonLatRad_xyr(xyr) ! 緯度経度動径(全球)積分
      !
      ! 3 次元格子点データの緯度経度動径(全球)積分
      !
      ! 3 次元データ f(λ,φ,r) に対して
      !
      !    ∫f(λ,φ,r) r^2cosφ dλdφdr /(4π(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr
      !(in) 3 次元経度緯度動径格子点データ

      real(8)                     :: AvrLonLatRad_xyr
      !(out) 全球平均値

      AvrLonLatRad_xyr = IntLonLatRad_xyr(xyr) &
            /(sum(x_Lon_Weight)*sum(y_Lat_Weight) * sum(r_Rad_Weight))

    end function AvrLonLatRad_xyr

    !----(入力データ yr)---
    function r_AvrLat_yr(yr)
      !
      ! 2 次元(YR)格子点データの緯度方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) cosφ dφ/2 を計算する.
      !
      real(8), dimension(1:jm,km), intent(in) :: yr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(km)  :: r_AvrLat_yr
      !(out) 緯度平均された 1 次元動径格子点データ

      r_AvrLat_yr = r_IntLat_yr(yr)/sum(y_Lat_Weight)

    end function r_AvrLat_yr

    function y_AvrRad_yr(yr)
      !
      ! 2 次元(YR)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(φ,r) に対して ∫f(φ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      ! を計算する.
      !
      real(8), dimension(1:jm,km), intent(in) :: yr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8), dimension(1:jm)  :: y_AvrRad_yr
      !(out) 動径平均された 1 次元緯度格子点データ

      y_AvrRad_yr = y_IntRad_yr(yr)/sum(r_Rad_Weight)

    end function y_AvrRad_yr

    function AvrLatRad_yr(yr)  ! 緯度動径(子午面)積分
      !
      ! 2 次元(YR)格子点データの緯度動径(子午面)平均
      !
      ! 2 次元データ f(φ,r) に対して
      !
      !    ∫f(φ,r) r^2cosφ dφdr /(2(r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(1:jm,km), intent(in) :: yr
      !(in) 2 次元緯度動径(子午面)格子点データ

      real(8)                   :: AvrLatRad_yr
      !(out) 平均値

      AvrLatRad_yr = IntLatRad_yr(yr)/(sum(y_Lat_Weight)*sum(r_Rad_Weight))

    end function AvrLatRad_yr

    !----(入力データ xr)---
    function r_AvrLon_xr(xr)  ! 経度(帯状)積分
      !
      ! 2 次元(XR)格子点データの経度方向平均.
      !
      ! 2 次元データ f(λ,r) に対して ∫f(λ,r)dλ/2π を計算する.
      !
      real(8), dimension(0:im-1,km), intent(in) :: xr
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(km)  :: r_AvrLon_xr 
      !(out) 経度平均された 1 次元動径格子点データ

      r_AvrLon_xr = r_IntLon_xr(xr)/sum(x_Lon_Weight)

    end function r_AvrLon_xr

    function x_AvrRad_xr(xr)  ! 動径積分
      !
      ! 2 次元(XR)格子点データの動径方向域平均.
      !
      ! 2 次元データ f(λ,r) に対して
      !
      !   ∫f(λ,r) r^2dr /((r[o]^3-r[i]^3)/3) 
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,km), intent(in) :: xr
      !(in) 2 次元緯度動径格子点データ

      real(8), dimension(0:im-1)  :: x_AvrRad_xr
      !(out) 動径平均された 1 次元経度格子点データ

      x_AvrRad_xr = x_IntRad_xr(xr)/sum(r_Rad_Weight)

    end function x_AvrRad_xr

    function AvrLonRad_xr(xr)  ! 経度動径(緯度円)積分
      !
      ! 2 次元(XR)格子点データの経度動径平均
      !
      ! 2 次元データ f(λ,r) に対して 
      ! 
      !    ∫f(λ,r) r^2dλdr /(2π(r[o]^3-r[i]^3)/3)
      !
      ! を計算する.
      !
      real(8), dimension(0:im-1,km), intent(in) :: xr
      ! (in) 2 次元格子点データ
      real(8)                                 :: AvrLonRad_xr      
      ! 積分値

      AvrLonRad_xr = IntLonRad_xr(xr)/(sum(x_Lon_Weight)*sum(r_Rad_Weight))

    end function AvrLonRad_xr

    !----(入力データ z)---
    function AvrRad_r(z)
      !
      ! 1 次元(Z)格子点データの動径方向域平均.
      !
      ! 1 次元データ f(r) に対して ∫f(r) r^2dr /((r[o]^3-r[i]^3)/3) を
      ! 計算する.
      !
      real(8), dimension(km), intent(in) :: z
      !(in) 1 次元動径格子点データ
      real(8)                            :: AvrRad_r
      !(out) 平均値

      AvrRad_r = IntRad_r(z)/sum(r_Rad_Weight)

    end function AvrRad_r

  !--------------- ポロイダル/トロイダルモデル用微分 -----------------

    function wq_KxRGrad_wq(wq)
      !
      ! 入力スペクトルデータに経度微分 k×r・▽ = ∂/∂λを作用する.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wq_KxRGrad_wq
      !(out) 経度微分を作用された 2 次元スペクトルデータ

      wq_KxRGrad_wq =  wa_Dlon_wa(wq)

    end function wq_KxRGrad_wq

    function xyr_KGrad_wq(wq)    ! k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r
      !
      ! 入力スペクトルデータに対応する格子データに軸方向微分 
      !
      !    k・▽ = cosφ/r ∂/∂φ + sinφ∂/∂r 
      !
      ! を作用させた格子データが返される. 
      ! ここでベクトル k は球の中心から北極向きの単位ベクトルである.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension(0:im-1,1:jm,km)                 :: xyr_KGrad_wq
      !(out) 軸方向微分を作用された 2 次元スペクトルデータ

      xyr_KGrad_wq =  cos(xyr_Lat)*xyr_GradLat_wq(wq) &
                    + sin(xyr_Lat)*xyr_wq(wq_RadDRad_wq(wq))/xyr_Rad

    end function xyr_KGrad_wq

    function wq_L2_wq(wq)
      !
      ! 入力スペクトルデータに L^2 演算子(=-水平ラプラシアン)を作用する.
      !
      ! L^2 演算子は単位球面上の水平ラプラシアンの逆符号にあたる. 
      !  入力スペクトルデ ータに対応する格子点データに演算子 
      !
      !     L^2 = -1/cos^2φ・∂^2/∂λ^2 - 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wq_L2_wq
      !(out) L^2 演算子を作用された 2 次元スペクトルデータ

      wq_L2_wq = -wa_Lapla_wa(wq)

    end function wq_L2_wq

    function wq_L2Inv_wq(wq)
      !
      ! 入力スペクトルデータに L^2 演算子の逆演算(-逆水平ラプラシアン)を
      ! 作用する.
      !
      ! スペクトルデータに L^2 演算子を作用させる関数 wq_L2_wq の逆計算を
      ! 行う関数である.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wq_L2Inv_wq
      !(out) L^2 演算子の逆演算を作用された 2 次元スペクトルデータ

      wq_L2Inv_wq = -wa_LaplaInv_wa(wq)

    end function wq_L2Inv_wq

    function wq_QOperator_wq(wq)
      !
      ! 入力スペクトルデータに対応する格子点データに演算子 
      !
      !    Q=(k・▽-1/2(L2 k・▽+ k・▽L2)) 
      !
      ! を作用させたデータのスペクトル変換が返される.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq
      !(in) 2 次元球面調和函数チェビシェフスペクトルデータ

      real(8), dimension((nm+1)*(nm+1),0:lm)             :: wq_QOperator_wq
      !(out) Q 演算子を作用された 2 次元スペクトルデータ

      wq_QOperator_wq = &
             wq_xyr(xyr_KGrad_wq(wq) - xyr_KGrad_wq(wq_L2_wq(wq))/2) &
           - wq_L2_wq(wq_xyr(xyr_KGrad_wq(wq)))/2

    end function wq_QOperator_wq

    function wr_RadRot_xyr_xyr(xyr_VLON,xyr_VLAT)  ! r・(▽×v)
      !
      ! ベクトルの渦度と動径ベクトルの内積 r・(▽×v) を計算する.
      !
      ! 第 1, 2 引数(v[λ], v[φ])がそれぞれベクトルの経度成分, 緯度成分を表す.
      !
      !    r・(▽×v) = 1/cosφ・∂v[φ]/∂λ - 1/cosφ・∂(v[λ] cosφ)/∂φ
      !
      ! のスペクトル データが返される.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension((nm+1)*(nm+1),km)     :: wr_RadRot_xyr_xyr
      !(out) ベクトルの渦度と動径ベクトルの内積

      wr_RadRot_xyr_xyr = wa_DivLon_xya(xyr_VLAT) - wa_DivLat_xya(xyr_VLON)
      
    end function wr_RadRot_xyr_xyr

    function wr_RadRotRot_xyr_xyr_xyr(xyr_VLON,xyr_VLAT,xyr_VRAD) 
      ! 
      ! ベクトル v に対して r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
      ! 緯度成分, 動径成分を表す. 
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ 
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
      !                     + L^2 v[r]/r 
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_VRAD
      !(in) ベクトルの動径成分

      real(8), dimension((nm+1)*(nm+1),km)     :: wr_RadRotRot_xyr_xyr_xyr
      !(out) ベクトル v の r・(▽×▽×v) 

      wr_RadRotRot_xyr_xyr_xyr = &
                   wr_RotDRad_wr( &
                      wa_DivLon_xya(xyr_VLON)+ wa_DivLat_xya(xyr_VLAT)) &
             - wa_Lapla_wa(wr_xyr(xyr_VRAD/xyr_RAD))

    end function wr_RadRotRot_xyr_xyr_xyr

    function wq_RadRotRot_xyr_xyr_xyr(xyr_VLON,xyr_VLAT,xyr_VRAD) 
      ! 
      ! ベクトル v に対して r・(▽×▽×v) を計算する.
      !
      ! 第 1, 2, 3 引数(v[λ], v[φ], v[r])がそれぞれベクトルの経度成分, 
      ! 緯度成分, 動径成分を表す. 
      !
      !    r・(▽×▽×v)  = 1/r ∂/∂r (r・( 1/cosφ・∂v[λ]/∂λ 
      !                                  + 1/cosφ・∂(v[φ] cosφ)/∂φ ) ) 
      !                     + L^2 v[r]/r 
      !
      ! のスペクトルデータが返される.
      !
      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_VLON
      !(in) ベクトルの経度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_VLAT
      !(in) ベクトルの緯度成分

      real(8), dimension(0:im-1,1:jm,km), intent(in) :: xyr_VRAD
      !(in) ベクトルの動径成分

      real(8), dimension((nm+1)*(nm+1),0:lm)     :: wq_RadRotRot_xyr_xyr_xyr
      !(out) ベクトル v の r・(▽×▽×v) 

      wq_RadRotRot_xyr_xyr_xyr = &
                   wq_RotDRad_wr( &
                      wa_DivLon_xya(xyr_VLON)+ wa_DivLat_xya(xyr_VLAT)) &
             - wa_Lapla_wa(wq_xyr(xyr_VRAD/xyr_RAD))

    end function wq_RadRotRot_xyr_xyr_xyr

    subroutine wq_Potential2Vector(&
         xyr_VLON,xyr_VLAT,xyr_VRAD,wq_TORPOT,wq_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! の各成分を計算する
      !
      real(8), dimension(0:im-1,1:jm,km)     :: xyr_VLON
      !(out) ベクトル場の経度成分

      real(8), dimension(0:im-1,1:jm,km)     :: xyr_VLAT
      !(out) ベクトル場の緯度成分

      real(8), dimension(0:im-1,1:jm,km)     :: xyr_VRAD
      !(out) ベクトル場の動径成分

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_POLPOT
      !(in) ポロイダルポテンシャル

      xyr_VLON =   xyr_RAD * xyr_GradLat_wq(wq_TORPOT) &
                 + xya_GradLon_wa(wr_RotDRad_wq(wq_POLPOT))
      xyr_VLAT = - xyr_RAD * xyr_GradLon_wq(wq_TORPOT) &
                 + xya_GradLat_wa(wr_RotDRad_wq(wq_POLPOT))
      xyr_VRAD = xyr_wq(wq_L2_wq(wq_POLPOT))/xyr_RAD

    end subroutine wq_Potential2Vector

    subroutine wq_Potential2Rotation(&
       xyr_RotVLON,xyr_RotVLAT,xyr_RotVRAD,wq_TORPOT,wq_POLPOT)
      !
      ! トロイダルポロイダルポテンシャルΨ,Φで表される非発散ベクトル場
      !
      !     v = ▽x(Ψr) + ▽x▽x(Φr) 
      !
      ! に対して, その回転
      !
      !     ▽xv = ▽x▽x(Ψr) + ▽x▽x▽x(Φr) = ▽x▽x(Ψr) - ▽x((▽^2Φ)r)
      !
      ! を計算する. 
      
      ! ベクトル場の回転
      real(8), dimension(0:im-1,1:jm,km), intent(OUT) :: xyr_RotVLON
      !(out) 回転の経度成分

      real(8), dimension(0:im-1,1:jm,km), intent(OUT) :: xyr_RotVLAT
      !(out) 回転の緯度成分

      real(8), dimension(0:im-1,1:jm,km), intent(OUT) :: xyr_RotVRAD
      !(out) 回転の動径成分

      ! 入力ベクトル場を表すポテンシャル
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_POLPOT
      !(in) ポロイダルポテンシャル

      call wq_Potential2Vector( &
           xyr_RotVLON,xyr_RotVLAT,xyr_RotVRAD, &
           -wq_Lapla_wq(wq_POLPOT), wq_TORPOT)

    end subroutine wq_Potential2Rotation

  !--------------- ポロイダル/トロイダルモデル用スペクトル解析 ----------------

    function nmr_ToroidalEnergySpectrum_wq(wq_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n, 帯状波数 m 成分のトロイダルエネルギー
      !    スペクトルは  (1/2)n(n+1)4πr^2ψ(n,m,r)^2  と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !    
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    wq_VMiss によって設定できる (初期値は -999.0)
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,-nm:nm,km) :: nmr_ToroidalEnergySpectrum_wq
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension((nm+1)*(nm+1),km) ::wr_DATA   ! 作業領域
!!$       integer :: n, m
      integer :: l, n, m, nm_ary(2)

      nmr_ToroidalEnergySpectrum_wq = 0.0D0

      wr_DATA = wr_wq(wq_TORPOT)
      do l=1,(nm+1)*(nm+1)
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               nmr_ToroidalEnergySpectrum_wq(n,m,:) &
                    = nmr_ToroidalEnergySpectrum_wq(n,m,:) &
                    + 0.5 * n*(n+1) * (4*pi) * r_Rad**2 * wr_Data(l,:)**2
               !  + 0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
            else
               nmr_ToroidalEnergySpectrum_wq(n,m,:) &
                    = nmr_ToroidalEnergySpectrum_wq(n,m,:) &                    
                    +  0.5 * n*(n+1) * (4*pi) * r_Rad**2 * wr_Data(l,:)**2
               !  +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
               nmr_ToroidalEnergySpectrum_wq(n,-m,:) &
                    = nmr_ToroidalEnergySpectrum_wq(n,-m,:) &
                    +  0.5 * n*(n+1) * (4*pi) * r_Rad**2 * wr_Data(l,:)**2
               !  +  0.5 * n*(n+1) * (4*pi) * z_Rad**2 * wz_Data(l,:)**2
            endif
         endif
      end do
      do m=1,nm
         
         do n=0,m-1
            nmr_ToroidalEnergySpectrum_wq(n,m,:)  = wq_Vmiss
            nmr_ToroidalEnergySpectrum_wq(n,-m,:) = wq_Vmiss
         enddo
      enddo

!!$      do n=0,nm
!!$         do m=-n,n
!!$            nmr_ToroidalEnergySpectrum_wq(n,m,:) &
!!$              = 0.5 * n*(n+1)* (4*pi) * r_Rad**2 &
!!$                * wr_DATA(l_nm(n,m),:)**2
!!$         enddo
!!$      enddo

    end function nmr_ToroidalEnergySpectrum_wq

    function nr_ToroidalEnergySpectrum_wq(wq_TORPOT)
      !
      ! トロイダルポテンシャルから, トロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のトロイダルポテンシャルのスペクトル成分
      !    ψ(n,m,r)から全波数 n 成分のトロイダルエネルギースペクトルは
      !    Σ[m=-n]^n(1/2)n(n+1)4πr^2ψ(n,m,r)^2 と計算される.
      !
      ! * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_TORPOT
      !(in) トロイダルポテンシャル

      real(8), dimension(0:nm,km) :: nr_ToroidalEnergySpectrum_wq 
      !(out) エネルギースペクトルトロイダル成分

      real(8), dimension((nm+1)*(nm+1),km) ::wr_DATA   ! 作業領域
!!$      integer :: n, m
      integer :: l, n, m, nm_ary(2)
      real(8) :: factor

      wr_DATA = wr_wq(wq_TORPOT)

      nr_ToroidalEnergySpectrum_wq = 0.0D0

      do l=1,(nm+1)*(nm+1)
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( m == 0 ) then
            factor = 1.0D0
         else
            factor = 2.0D0
         endif
         if ( n .ge. 0 ) then
         nr_ToroidalEnergySpectrum_wq(n,:) &
              = nr_ToroidalEnergySpectrum_wq(n,:) &
              + factor * 0.5 * n*(n+1)* (4*pi) * r_Rad**2 * wr_Data(l,:)**2
            !  + 0.5 * n*(n+1)* (4*pi) * z_Rad**2 * wz_Data(l,:)**2
         endif
      enddo
!!$      do n=0,nm
!!$         nr_ToroidalEnergySpectrum_wq(n,:) &
!!$              = 0.5 * n*(n+1)* (4*pi) * r_Rad**2 &
!!$                * sum(wr_Data(l_nm(n,(/(m,m=-n,n)/)),:)**2,1)
!!$      enddo

    end function nr_ToroidalEnergySpectrum_wq

    function nmr_PoloidalEnergySpectrum_wq(wq_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数 n, 帯状波数 m の各成分を計算する.
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n, 帯状波数 m 成分のポロイダルエネルギー
      !    スペクトルは 
      !
      !      (1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2 + n(n+1)φ(n,m,r)^2} 
      !
      !    と計算される.
      !
      !  * 全てのエネルギースペクトル成分の和を動径積分したもの(r^2の重み無し)
      !    が球殻内での全エネルギーに等しい.
      !
      !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
      !    欠損値の値はモジュール変数 wq_VMiss によって設定できる
      !    (初期値は -999.0)
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:nm,-nm:nm,km) :: nmr_PoloidalEnergySpectrum_wq 
      !(out) エネルギースペクトルポロイダル成分


      real(8), dimension((nm+1)*(nm+1),km) ::wr_DATA1   ! 作業領域
      real(8), dimension((nm+1)*(nm+1),km) ::wr_DATA2   ! 作業領域
!!$      integer :: n, m
      integer :: l, n, m, nm_ary(2)

      nmr_PoloidalEnergySpectrum_wq = 0.0D0

      wr_Data1 = wr_wq(wq_POLPOT)
      wr_Data2 = wr_wq(wq_RadDRad_wq(wq_POLPOT)+wq_POLPOT)  ! d(rφ)/dr
                                                            ! = rdφ/dr+φ

      do l=1,(nm+1)*(nm+1)
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( n .ge. 0 ) then
            if ( m == 0 ) then
               nmr_PoloidalEnergySpectrum_wq(n,m,:) &
                    = nmr_PoloidalEnergySpectrum_wq(n,m,:)&
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wr_Data2(l,:)**2 +  n*(n+1)*wr_Data1(l,:)**2 )
                  !  +  0.5 * n*(n+1) * (4*pi) &
                  !  * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
            else
               nmr_PoloidalEnergySpectrum_wq(n,m,:) &
                    = nmr_PoloidalEnergySpectrum_wq(n,m,:)&
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wr_Data2(l,:)**2 +  n*(n+1)*wr_Data1(l,:)**2 )
                  !  +  0.5 * n*(n+1) * (4*pi) &
                  !  * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
               nmr_PoloidalEnergySpectrum_wq(n,-m,:) &
                    = nmr_PoloidalEnergySpectrum_wq(n,-m,:)&
                    +  0.5 * n*(n+1) * (4*pi) &
                    * ( wr_Data2(l,:)**2 +  n*(n+1)*wr_Data1(l,:)**2 )
                  ! +  0.5 * n*(n+1) * (4*pi) &
                  ! * ( wz_Data2(l,:)**2 +  n*(n+1)*wz_Data1(l,:)**2 )
            endif
         endif
      enddo
      
      do m=1,nm
         do n=0,m-1
            nmr_PoloidalEnergySpectrum_wq(n,m,:)  = wq_Vmiss
            nmr_PoloidalEnergySpectrum_wq(n,-m,:) = wq_Vmiss
         enddo
      enddo
!!$      do n=0,nm
!!$         do m=-n,n
!!$            nmr_PoloidalEnergySpectrum_wq(n,m,:) = &
!!$                 + 0.5* n*(n+1)* (4*pi) &
!!$                 *( wr_Data2(l_nm(n,m),:)**2  &
!!$                   + n*(n+1)*wr_Data1(l_nm(n,m),:)**2 )
!!$         enddo
!!$      enddo

    end function nmr_PoloidalEnergySpectrum_wq

    function nr_PoloidalEnergySpectrum_wq(wq_POLPOT)
      !
      ! ポロイダルポテンシャルから, ポロイダルエネルギーの
      ! 球面調和函数全波数の各成分を計算する
      !
      !  * 全波数 n, 帯状波数 m のポロイダルポテンシャルのスペクトル成分
      !    φ(n,m,r)から全波数 n 成分のポロイダルエネルギースペクトルは
      !
      !      Σ[m=-n]^n ((1/2)n(n+1)4πr^2{[d(rφ(n,m,r))/dr]^2 
      !                 + n(n+1)φ(n,m,r)^2} 
      !
      !    と計算される.
      !
      !  * 全ての全波数に対してのエネルギースペクトル成分の和を動径積分したもの
      !    (r^2の重み無し)が球殻内での全エネルギーに等しい.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm), intent(in) :: wq_POLPOT
      !(in) ポロイダルポテンシャル

      real(8), dimension(0:nm,km) :: nr_PoloidalEnergySpectrum_wq
      !(out) エネルギースペクトルポロイダル成分

      real(8), dimension((nm+1)*(nm+1),km) ::wr_DATA1   ! 作業領域
      real(8), dimension((nm+1)*(nm+1),km) ::wr_DATA2   ! 作業領域
!!$      integer :: n, m
      integer :: l, n, m, nm_ary(2)
      real(8) :: factor

      wr_Data1 = wr_wq(wq_POLPOT)
      wr_Data2 = wr_wq(wq_RadDRad_wq(wq_POLPOT)+wq_POLPOT)  ! d(rφ)/dr
                                                            ! = rdφ/dr+φ
      nr_PoloidalEnergySpectrum_wq = 0.0D0

      do l=1,(nm+1)*(nm+1)
         nm_ary = nm_l(l)
         n = nm_ary(1) ; m = abs(nm_ary(2))
         if ( m == 0 ) then
            factor = 1.0D0
         else
            factor = 2.0D0
         endif
         if ( n .ge. 0 ) then
            nr_PoloidalEnergySpectrum_wq(n,:) &            
                 = nr_PoloidalEnergySpectrum_wq(n,:) & 
                 + factor * 0.5* n*(n+1)* (4*pi) &
                 *( wr_Data2(l,:)**2 + n*(n+1)*wr_Data1(l,:)**2 )
         endif
      enddo
!!$      do n=0,nm
!!$         nr_PoloidalEnergySpectrum_wq(n,:) = &
!!$              + 0.5* n*(n+1)* (4*pi) &
!!$              *( sum(wr_Data2(l_nm(n,(/(m,m=-n,n)/)),:)**2,1)  &
!!$                + n*(n+1)*sum(wr_Data1(l_nm(n,(/(m,m=-n,n)/)),:)**2,1) )
!!$      enddo

    end function nr_PoloidalEnergySpectrum_wq

  !--------------- 境界値問題 -----------------

    subroutine wq_BoundaryTau(wq,value,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! Chebyshev 空間での境界条件適用(タウ法)
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を
      ! 定める方法をとっている(タウ法).
      !
      real(8), dimension((nm+1)*(nm+1),0:lm),intent(inout)      :: wq
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension((nm+1)*(nm+1)), intent(in), optional   :: value
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
              !     省略時は値/勾配 0 となる. 

      character(len=1), intent(in), optional                    :: cond
              !(in) 境界条件. 省略時は 'D'
              !        D : 外側ディリクレ条件
              !        N : 外側ノイマン条件

      if (.not. present(cond)) then
         if (present(value)) then
            call aq_BoundaryTau_D(wq,value)
         else
            call aq_BoundaryTau_D(wq)
         endif
         return
      endif

      select case(cond)
      case ('N')
         if (present(value)) then
            call aq_BoundaryTau_N(wq,value)
         else
            call aq_BoundaryTau_N(wq)
         endif
      case ('D')
         if (present(value)) then
            call aq_BoundaryTau_D(wq,value)
         else
            call aq_BoundaryTau_D(wq)
         endif
      case default
         call MessageNotify('E','wq_BoundaryTau','B.C. not supported')
      end select

    end subroutine wq_BoundaryTau

    subroutine wr_BoundaryGrid(wr,value,cond)
      !
      ! スペクトルデータにディリクレ・ノイマン境界条件を適用する
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). 
      !
      real(8), dimension((nm+1)*(nm+1),km),intent(inout)      :: wr
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension((nm+1)*(nm+1)), intent(in), optional   :: value
              !(in) 境界での 値/勾配 分布を水平スペクトル変換したものを与える. 
              !    省略時は値/勾配 0 となる. 

      character(len=1), intent(in), optional             :: cond
              !(in) 境界条件. 省略時は 'D'
              !        D : 外側ディリクレ条件
              !        N : 外側ノイマン条件

      if (.not. present(cond)) then
         if (present(value)) then
            call ag_BoundaryGrid_D(wr,value)
         else
            call ag_BoundaryGrid_D(wr)
         endif
         return
      endif

      select case(cond)
      case ('N')
         if (present(value)) then
            call ag_BoundaryGrid_N(wr,value)
         else
            call ag_BoundaryGrid_N(wr)
         endif
      case ('D')
         if (present(value)) then
            call ag_BoundaryGrid_D(wr,value)
         else
            call ag_BoundaryGrid_D(wr)
         endif
      case default
         call MessageNotify('E','wr_BoundaryGrid','B.C. not supported')
      end select

    end subroutine wr_BoundaryGrid

    subroutine wq_TorBoundaryTau(wq_TORPOT,value,cond,new) 
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する. 
      ! Chebyshev 空間での境界条件適用. 
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
      !                                   default は 0(静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm),intent(inout)      :: wq_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension((nm+1)*(nm+1)), intent(in), optional :: value
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=1), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'R'
              !     R    : 上側粘着条件
              !     F    : 上側応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp
      real(8), dimension((nm+1)*(nm+1),0:lm)  :: wq_data
      real(8), dimension((nm+1)*(nm+1),km)    :: wr_data
      logical                                 :: rigid        ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: n, l, lend
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid=.TRUE.
      else
         select case (cond)
         case ('R')
            rigid = .TRUE.
         case ('F')
            rigid = .FALSE.
         case default
            call MessageNotify('E','wq_TorBoundaryTau','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((nm+1)*(nm+1),0:lm,0:lm),kp((nm+1)*(nm+1),0:lm))

         alu = 0.0D0
         do l=0,lm
            alu(:,l,l)=1.0D0
         enddo

         ! 力学的条件

         do l=0,lm
            wq_data = 0.0 ; wq_data(:,l) = 1.0D0

            if ( rigid ) then          ! 力学的条件粘着
               wr_data = wr_wq(wq_data)
            else                       ! 力学的条件自由すべり
               wr_data = wr_wq(wq_RadDRad_wq(wq_data)- wq_data)/wr_Rad
            endif

            do n=1,(nm+1)**2
!!$               if ( mod(nd(n),2) .eq. mod(lm,2) ) then
                  alu(n,lm,l) = wr_data(n,km)
!!$               else
!!$                  alu(n,lm-1,l) = wr_data(n,km)
!!$               endif
            end do
         enddo

!!$         ! 関係ないところを 0 で埋める.
!!$         do n=1,(nm+1)**2
!!$            if ( mod(nd(n),2) .eq. mod(lm,2) ) then
!!$               lend = lm
!!$            else
!!$               lend = lm-1
!!$            endif
!!$
!!$            do l=0,nd(n)-1
!!$               alu(n,lend,l) = 0.0D0
!!$            enddo
!!$            do l=nd(n)+1,lm,2
!!$               alu(n,lend,l) = 0.0D0
!!$            enddo
!!$         enddo

         call ludecomp(alu,kp)

         if ( rigid .AND. present(value) ) then 
            call MessageNotify('M','wq_TorBoundaryTau',&
                 'Toroidal potential at k=km was given by the optional variable.')
         else if ( rigid .AND. (.NOT.present(value)) ) then
            call MessageNotify('M','wq_TorBoundaryTau',&
                 'Toroidal potential at k=km was set to zero.')
         else if ( (.NOT. rigid) .AND. present(value) ) then
            call MessageNotify('W','wq_TorBoundaryTau',&
                 'Boundary value k=km cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','wq_TorBoundaryTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      do n=1,(nm+1)**2
!!$         if ( mod(nd(n),2) .eq. mod(lm,2) ) then
!!$            lend = lm
!!$         else
!!$            lend = lm-1
!!$         endif

         if ( rigid .AND. present(value) ) then
!!$            wq_torpot(n,lend) = value(n)
            wq_torpot(n,lm) = value(n)
         else
!!$            wq_torpot(n,lend) = 0.0D0
            wq_torpot(n,lm) = 0.0D0
         endif
      enddo

      wq_torpot = lusolve(alu,kp,wq_TORPOT)

    end subroutine wq_TorBoundaryTau

    subroutine wr_TorBoundaryGrid(wr_TORPOT,value,cond,new) 
      !
      ! 速度トロイダルポテンシャルに対して境界条件を適用する.
      ! 実空間での境界条件適用
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). 
      !
      ! 速度トロイダルポテンシャルΨに対して与えられる境界条件は
      !
      !   * 粘着条件 : Ψ = Ψb(lon,lat). Ψb は境界球面での速度分布. 
      !                                   default は 0 (静止状態).
      !
      !   * 応力なし条件 : ∂(Ψ/r)/∂r = 0.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension((nm+1)*(nm+1),km),intent(inout)    :: wr_TORPOT
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      real(8), dimension((nm+1)*(nm+1)), intent(in), optional :: value
              !(in) 両端境界でのトロイダルポテンシャル
              !     粘着条件の時のみ有効

      character(len=1), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'R'
              !     R    : 上側粘着条件
              !     F    : 上側応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp
      real(8), dimension((nm+1)*(nm+1),0:lm)  :: wq_data
      real(8), dimension((nm+1)*(nm+1),km)    :: wr_data
      logical                                 :: rigid   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k
      save    :: alu, kp, first

      if (.not. present(cond)) then
         rigid=.TRUE.
      else
         select case (cond)
         case ('R')
            rigid = .TRUE.
         case ('F')
            rigid = .FALSE.
         case default
            call MessageNotify('E','wr_TorBoundaryGrid','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((nm+1)*(nm+1),km,km),kp((nm+1)*(nm+1),km))

         alu = 0.0D0
         do k=1,km
            wr_data = 0.0D0
            wr_data(:,k)=1.0D0
            alu(:,:,k) = wr_data
         enddo

         if ( .not. rigid ) then
            do k=1,km
               wr_data = 0.0D0
               wr_data(:,k)=1.0D0
               wq_data = wq_wr(wr_data)
               wr_data = wr_wq(wq_RadDRad_wq(wq_data) - wq_data)/wr_Rad
               alu(:,km,k) = wr_data(:,km)
            enddo
         endif

         call ludecomp(alu,kp)

         if ( rigid .AND. present(value) ) then 
            call MessageNotify('M','wr_TorBoundaryGrid',&
                 'Toroidal potential at k=km was given by the optional variable.')
         else if ( rigid .AND. (.NOT.present(value)) ) then
            call MessageNotify('M','wr_TorBoundaryGrid',&
                 'Toroidal potential at k=km was set to zero.')
         else if ( (.NOT. rigid) .AND. present(value) ) then
            call MessageNotify('W','wr_TorBoundaryGrid',&
                 'Boundary value at k=km cannot be set under stress-free condition.')
         endif

         call MessageNotify('M','wr_TorBoundaryGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      if ( rigid .AND. present(value) ) then
         wr_TorPot(:,km)  = value
      else
         wr_TorPot(:,km)  = 0.0D0
      endif

      wr_TorPot = lusolve(alu,kp,wr_TorPot)

    end subroutine wr_TorBoundaryGrid

    function wq_LaplaPol2PolTau_wq(wq,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      !
      ! スペクトル空間で境界条件を適用している(タウ法). 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !   ▽^2Φ = f
      !     Φ = const. at Boundary.
      !     ∂Φ/∂r = 0 at Boundary           (粘着条件) 
      !     or ∂^2Φ/∂r^2 = 0 at Boundary    (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm),intent(in)  :: wq
              !(in) 入力▽^2φ分布

      real(8), dimension((nm+1)*(nm+1),0:lm)  :: wq_LaplaPol2PolTau_wq
              !(out) 出力ポロイダルポテンシャル分布

      character(len=1), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'R'
              !     R    : 上側粘着条件
              !     F    : 上側応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu     ! 内部領域計算用
      integer, dimension(:,:), allocatable    :: kp      ! 内部領域計算用

      real(8), dimension(:,:,:), allocatable  :: alub    ! 境界条件計算用
      integer, dimension(:,:), allocatable    :: kpb     ! 境界条件計算用

      real(8), dimension((nm+1)*(nm+1),km)    :: wr_work
      real(8), dimension((nm+1)*(nm+1),0:lm)  :: wq_work
      logical                                 :: rigid   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: l,n, lend
      save    :: alu, kp, first
      save    :: alub, kpb

      if (.not. present(cond)) then
         rigid=.TRUE. 
      else
         select case (cond)
         case ('R')
            rigid = .TRUE.
         case ('F')
            rigid = .FALSE.
         case default
            call MessageNotify('E','wq_laplapol2pol_wq','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(alub) ) deallocate(alub)
         if ( allocated(kpb) ) deallocate(kpb)
         allocate(alu((nm+1)*(nm+1),0:lm,0:lm),kp((nm+1)*(nm+1),0:lm))
         allocate(alub((nm+1)*(nm+1),0:lm,0:lm),kpb((nm+1)*(nm+1),0:lm))


         !---- 内部領域計算用行列 -----
         do l=0,lm
            wq_work = 0.0
            wq_work(:,l) = 1.0D0
            alu(:,:,l) = wq_Lapla_wq(wq_work)
         enddo

         ! alu(:,:,0) 列は 0 なので 1 をいれておく. 
         ! l=0 成分は境界条件で決める. 
         do n=1,(nm+1)**2
            alu(n,lm,0) = 1.0D0
         enddo

         call ludecomp(alu,kp)

         !---- 境界条件計算用行列 -----

         alub = 0.0D0
         do l=0,lm
            alub(:,l,l) = 1.0D0
         enddo

         do l=0,lm
            wq_work=0.0D0 ; wq_work(:,l)=1.0D0
            wr_work = wr_wq(wq_work)

            ! 運動学的条件. 流線は境界で一定
            !     l=nd(n) 成分を境界条件で決める. 
            do n=1,(nm+1)**2
               alub(n,0,l) = wr_work(n,km)
            enddo

            ! 力学的条件粘着条件 
            !     l=lend 成分を境界条件で決める. 
            if ( rigid ) then
               wr_work=wr_wq(wq_RadDRad_wq(wq_work))/wr_Rad
            else
               wr_work=wr_wq(wq_RadDRad_wq(wq_RadDRad_wq(wq_work)) &
                                           -wq_RadDRad_wq(wq_work) )&
                            /wr_Rad**2
            endif
            
            do n=1,(nm+1)**2
               alub(n,lm,l) = wr_work(n,km)
            enddo
         enddo

         call ludecomp(alub,kpb)

         if ( rigid ) then
            call MessageNotify('M','wq_LaplaPol2PolTau_wq',&
                              'Matrix to apply rigid b.c. newly produced.')
         else
            call MessageNotify('M','wq_LaplaPol2PolTau_wq',&
                              'Matrix to apply stress-free b.c. newly produced.')
         endif
      endif

      ! 内部領域計算
      wq_work = wq

      wq_work = lusolve(alu,kp,wq_work)

      ! 境界条件計算
      do n=1,(nm+1)**2
         wq_work(n,0) = 0
         wq_work(n,lm)   = 0.0D0
      enddo

      wq_laplapol2polTau_wq = lusolve(alub,kpb,wq_work)

    end function wq_LaplaPol2PolTau_wq

    function wr_LaplaPol2Pol_wr(wr,cond,new)
      !
      ! 速度ポロイダルポテンシャルΦを▽^2Φから計算する.
      !
      ! 格子点空間で境界条件を適用している. 
      !
      ! 速度ポロイダルポテンシャルΦを f = ▽^2Φから定める式は
      !
      !   ▽^2Φ = f
      !     Φ = const. at Boundary.
      !     ∂Φ/∂r = 0 at Boundary           (粘着条件) 
      !     or ∂^2Φ/∂r^2 = 0 at Boundary    (応力なし条件)
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      ! 注意 : この関数は完成していない. 使用禁止. 
      !
      real(8), dimension((nm+1)*(nm+1),km),intent(in)  :: wr
              !(in) 入力▽^2φ分布

      real(8), dimension((nm+1)*(nm+1),km)         :: wr_LaplaPol2Pol_wr
              !(out) 出力ポロイダルポテンシャル分布

      character(len=1), intent(in), optional  :: cond
              !(in) 境界条件スイッチ. 省略時は 'R'
              !     R    : 上側粘着条件
              !     F    : 上側応力なし条件

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:,:), allocatable  :: alub
      integer, dimension(:,:), allocatable    :: kpb

      real(8), dimension((nm+1)*(nm+1),km)    :: wr_work
      logical                                 :: rigid   ! 境界条件

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: k
      save    :: alu, kp, first
      save    :: alub, kpb

      if (.not. present(cond)) then
         rigid=.TRUE. 
      else
         select case (cond)
         case ('R')
            rigid = .TRUE.
         case ('F')
            rigid = .FALSE.
         case default
            call MessageNotify('E','wr_laplapol2pol_wr','B.C. not supported')
         end select
      endif

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         allocate(alu((nm+1)*(nm+1),0:lm,0:lm),kp((nm+1)*(nm+1),0:lm))

         if ( allocated(alub) ) deallocate(alub)
         if ( allocated(kpb) ) deallocate(kpb)
         allocate(alub((nm+1)*(nm+1),km,km),kpb((nm+1)*(nm+1),km))

         !---- 内部領域計算用行列 -----
         do k=1,km
            wr_work = 0.0D0 ; wr_work(:,k) = 1.0D0

            ! 各水平波数に関して独立の式
            alu(:,:,k) = wr_wq(wq_Lapla_wq(wq_wr(wr_work)))
         enddo

         do k=1,km
            wr_work=0.0D0 ; wr_work(:,k)=1.0D0
            alu(:,km,k)  = wr_work(:,km)
         enddo


         !---- 境界条件計算用 ----
         alub = 0.0D0
         do k=1,km
            alub(:,k,k) = 1.0D0
         enddo

         ! 運動学的条件. 流線は境界で一定
         !   k=km の値を定める
         do k=1,km
            wr_work=0.0D0 ; wr_work(:,k)=1.0D0
            alub(:,km,k)  = wr_work(:,km)
         enddo

         ! 力学的条件粘着条件 
         !   k=km-1 の値を定める
         if ( rigid ) then
            do k=1,km
               wr_work = 0.0D0 ; wr_work(:,k) = 1.0D0
               wr_work=wr_wq(wq_RadDRad_wq(wq_wr(wr_work)))/wr_Rad
               alub(:,km-1,k) = wr_work(:,km)
            enddo
         else
            do k=1,km
               wr_work = 0.0D0 ; wr_work(:,k) = 1.0D0
               wr_work=wr_wq(wq_RadDRad_wq(wq_RadDRad_wq(wq_wr(wr_work))) &
                                          -wq_RadDRad_wq(wq_wr(wr_work)))&
                       /wr_Rad**2
               alub(:,km-1,k) = wr_work(:,km)
            enddo
         endif

         call ludecomp(alub,kpb)

         if ( rigid ) then
            call MessageNotify('M','wr_LaplaPol2Pol_wr',&
                              'Matrix to apply rigid b.c. newly produced.')
         else
            call MessageNotify('M','wr_LaplaPol2Pol_wr',&
                              'Matrix to apply stress-free b.c. newly produced.')
         endif
      endif

      wr_work         = wr
      wr_work         = lusolve(alu,kp,wr_work)

      wr_work(:,km-1) = 0.0D0               ! 力学的条件
      wr_work(:,km)   = 0.0D0               ! 運動学的条件

      wr_laplapol2pol_wr = lusolve(alub,kpb,wr_work)

    end function wr_LaplaPol2Pol_wr

    subroutine wq_TormagBoundaryTau(wq_TOR,new)
      
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    wq_psi = 0   at the outer boundary
      ! 
      ! であるから wq_Boundary で対応可能だが, 将来のため別途作成しておく.
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm),intent(inout)   :: wq_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wq_I
      real(8), dimension(:,:), allocatable    :: wr_PSI

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer :: n, l, lend
      save    :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wq_I) ) deallocate(wq_I)
         if ( allocated(wr_PSI) ) deallocate(wr_PSI)
         allocate(alu((nm+1)*(nm+1),0:lm,0:lm),kp((nm+1)*(nm+1),0:lm))
         allocate(wq_I((nm+1)*(nm+1),0:lm),wr_PSI((nm+1)*(nm+1),km))

         alu = 0.0D0
         do l=0,lm
            alu(:,l,l) = 1.0D0
         enddo

         do l=0,lm
            wq_I = 0.0 ; wq_I(:,l) = 1.0
            ! 非電気伝導体
            wr_PSI = wr_wq(wq_I)

            do n=1,(nm+1)**2
               if ( mod(nd(n),2) .eq. mod(lm,2) ) then
                  alu(n,lm,l) = wr_Psi(n,km)
                  lend = lm
               else
                  alu(n,lm-1,l) = wr_Psi(n,km)
               endif
            enddo
         enddo

         call ludecomp(alu,kp)

         deallocate(wq_I,wr_PSI)

         call MessageNotify('M','TormagBoundaryTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      do n=1,(nm+1)**2
         if ( mod(nd(n),2) .eq. mod(lm,2) ) then
            wq_TOR(n,lm)   = 0.0
         else
            wq_TOR(n,lm-1) = 0.0
         endif
      enddo
      wq_TOR = lusolve(alu,kp,wq_TOR)

    end subroutine wq_TormagBoundaryTau

    subroutine wr_TormagBoundaryGrid(wr_TOR,new)
      !
      ! 磁場トロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用.
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場トロイダルポテンシャルの境界条件は
      !
      ! 外側
      !    wq_psi = 0   at the outer boundary
      ! 
      ! であるので wq_Boundary で対応可能だが, 将来のため別途作成しておく
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension((nm+1)*(nm+1),km),intent(inout)   :: wr_TOR
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 
      
      logical, intent(IN), optional :: new
              !(in) (ダミー) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      wr_TOR(:,km)  = 0.0D0

    end subroutine wr_TormagBoundaryGrid

    subroutine wq_PolmagBoundaryTau(wq_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! Chebyshev 空間での境界条件適用
      !
      ! チェビシェフ空間において境界条件を満たすべく高次の係数を定める方法を
      ! とっている(タウ法). 現在のところ境界物質が非電気伝導体の場合のみ
      ! 対応している. その場合, 磁場ポロイダルポテンシャルの各水平スペクトル
      ! 成分 h にたいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !
      ! である. ここで n は h の水平全波数である. 
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension((nm+1)*(nm+1),0:lm),intent(inout)   :: wq_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wq_I
      real(8), dimension(:,:), allocatable    :: wr_PSI
      real(8), dimension(:,:), allocatable    :: wr_DPSIDR

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: l, n, nn(2), lend
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wq_I) ) deallocate(wq_I)
         if ( allocated(wr_PSI) ) deallocate(wr_PSI)
         if ( allocated(wr_DPSIDR) ) deallocate(wr_DPSIDR)

         allocate(alu((nm+1)*(nm+1),0:lm,0:lm),kp((nm+1)*(nm+1),0:lm))
         allocate(wq_I((nm+1)*(nm+1),0:lm))
         allocate(wr_PSI((nm+1)*(nm+1),km),wr_DPSIDR((nm+1)*(nm+1),km))

         alu = 0.0D0
         do l=0,lm
            alu(:,l,l) = 1.0D0
         enddo

         ! 非電気伝導体
         do l=0,lm
            wq_I = 0.0D0  ; wq_I(:,l) = 1.0D0
            wr_PSI = wr_wq(wq_I)
            wr_DPSIDR = wr_wq(wq_RadDRad_wq(wq_I))/wr_Rad

            do n=1,(nm+1)**2
               if ( mod(nd(n),2) .eq. mod(lm,2) ) then
                  lend = lm
               else
                  lend = lm-1
               endif
               nn=nm_l(n)
               alu(n,lend,l) = wr_DPSIDR(n,km) + (nn(1)+1) * wr_PSI(n,km)/r_RAD(km)
            enddo
         enddo

         call ludecomp(alu,kp)

         deallocate(wq_I,wr_PSI,wr_DPSIDR)

         call MessageNotify('M','PolmagBoundaryTau',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      do n=1,(nm+1)**2
         if ( mod(nd(n),2) .eq. mod(lm,2) ) then
            wq_POL(n,lm)   = 0.0
         else
            wq_POL(n,lm-1) = 0.0
         endif
      enddo
      wq_POL = lusolve(alu,kp,wq_POL)

    end subroutine wq_PolmagBoundaryTau

    subroutine wr_PolmagBoundaryGrid(wr_POL,new)
      !
      ! 磁場ポロイダルポテンシャルに対して境界条件を適用する.
      ! 鉛直実空間での境界条件適用. 
      !
      ! 鉛直実格子点空間において内部領域の値と境界条件を満たすように
      ! 条件を課している(選点法). 
      !
      ! 現在のところ境界物質が非電気伝導体の場合のみ対応している. 
      ! その場合, 磁場ポロイダルポテンシャルの各水平スペクトル成分 h に
      ! たいして境界条件が与えられ,
      !
      !  * 外側境界 : dh/dr + (n+1)h/r = 0
      !
      ! である. ここで n は h の水平全波数である. 
      !
      ! 最初に呼ばれるときはオプショナル引数 new に関係なく行列が設定される.
      !
      real(8), dimension((nm+1)*(nm+1),km),intent(inout)   :: wr_POL
              !(inout) 境界条件を適用するデータ. 修正された値を返す. 

      logical, intent(IN), optional :: new
              !(in) true だと境界条件計算用行列を強制的に新たに作る.
              !     default は false.

      real(8), dimension(:,:,:), allocatable  :: alu
      integer, dimension(:,:), allocatable    :: kp

      real(8), dimension(:,:), allocatable    :: wr_I
      real(8), dimension(:,:), allocatable    :: wr_PSI
      real(8), dimension(:,:), allocatable    :: wr_DPSIDR

      logical :: first = .true.
      logical :: new_matrix = .false.
      integer  :: k, n, nn(2)
      save     :: alu, kp, first

      if (.not. present(new)) then
         new_matrix=.false.
      else 
         new_matrix=new
      endif

      if ( first .OR. new_matrix ) then
         first = .false.

         if ( allocated(alu) ) deallocate(alu)
         if ( allocated(kp) ) deallocate(kp)
         if ( allocated(wr_I) ) deallocate(wr_I)
         if ( allocated(wr_PSI) ) deallocate(wr_PSI)
         if ( allocated(wr_DPSIDR) ) deallocate(wr_DPSIDR)

         allocate(alu((nm+1)*(nm+1),km,km),kp((nm+1)*(nm+1),km))
         allocate(wr_I((nm+1)*(nm+1),km))
         allocate(wr_PSI((nm+1)*(nm+1),km),wr_DPSIDR((nm+1)*(nm+1),km))

         do k=1,km
            wr_I = 0.0D0
            wr_I(:,k)=1.0D0
            alu(:,:,k) = wr_I                 ! 内部領域は値そのまま.
         enddo

         ! 非電気伝導体
         do k=1,km
            wr_I = 0.0D0
            wr_I(:,k) = 1.0D0
            wr_PSI = wr_I
            wr_DPSIDR = wr_wq(wq_RadDRad_wq(wq_wr(wr_I)))/wr_Rad

            do n=1,(nm+1)*(nm+1)
               nn=nm_l(n)
               alu(n,km,k) = wr_DPSIDR(n,km) + (nn(1)+1) * wr_PSI(n,km)/r_RAD(km)
            enddo
         end do

         call ludecomp(alu,kp)

         deallocate(wr_I,wr_PSI,wr_DPSIDR)

         call MessageNotify('M','PolmagBoundaryGrid',&
                           'Matrix to apply  b.c. newly produced.')
      endif

      wr_POL(:,km)  = 0.0D0
      wr_POL = lusolve(alu,kp,wr_POL)

    end subroutine wr_PolmagBoundaryGrid

end module wq_module

!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wb_spectrum_module テストプログラム :: スペクトル関数のテスト
!
!履歴  2020/08/02  竹広真一
!
program wb_spectrum_mpi_module
  use mpi
  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wb_mpi_module
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=2, npv=2
!!$  integer, parameter :: im=64, jm=32, nm=21, km=2, npv=2

  real(8), allocatable ::  wb_data(:,:)
  real(8), allocatable ::  pva_data(:,:,:)
  real(8), allocatable ::  b_data(:)
  real(8), allocatable ::  a_data(:)
  real(8), allocatable ::  ab_data(:,:)
  real(8), allocatable ::  aa_data(:,:)
  real(8), allocatable ::  nmb_data(:,:,:)
  real(8), allocatable ::  nb_data(:,:)


  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: n,m
  integer :: ip, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call wb_mpi_Initial( nm, im, jm, km, npv=npv )

  allocate(wb_data(nc,kc))
  allocate(pva_data(ic,1:jc,km))
  allocate(b_data(kc))
  allocate(a_data(km))
  allocate(ab_data(1,kc))
  allocate(aa_data(1,km))
  allocate(nmb_data(0:nm,-nm:nm,kc))
  allocate(nb_data(0:nm,kc))

  call MessageNotify('M','wb_spectrum_mpi_module_test',&
                         'wb_spectrum_module functions tests.')

  ! 2Y_1^0+3Y_2^1
  pva_data(:,:,1) = 2*sqrt(3.0D0)*sin(pv_Lat) &
       + 3*sqrt(5.0D0/6)*3*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)!
  ! 3*Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2
  pva_data(:,:,2) = 3*sqrt(3.0D0)*sin(pv_Lat) &
                + 2* sqrt(3.0D0/2)*cos(pv_Lat)*cos(pv_Lon) &
                + 2*sqrt(5.0D0)*(3.0/2*sin(pv_Lat)**2-1/2.0) &
                - sqrt(5.0D0/24)*3.0*cos(pv_Lat)**2*sin(2*pv_Lon)

  wb_data = wb_pva(pva_data)

  !--------- Energy spectrum ---------
  nmb_data=wb_spectrum_VMiss

  do n=0,nm
     do m=-n,n
        nmb_data(n,m,:) = 0.0D0
     enddo
  enddo

  if ( kp_kl(1) /= 0 ) then
     nmb_data(1,0,kp_kl(1)) = 4.0D0
     nmb_data(2,1,kp_kl(1)) = 2*3*(3.0D0/2)**2/2
     nmb_data(2,-1,kp_kl(1))= nmb_data(2,1,kp_kl(1))
  endif
  if ( kp_kl(2) /= 0 ) then
     nmb_data(1,0,kp_kl(2)) = 9.0D0
     nmb_data(1,1,kp_kl(2)) = 1*2*(2/2)**2/2
     nmb_data(1,-1,kp_kl(2))= nmb_data(1,1,kp_kl(2))
     nmb_data(2,0,kp_kl(2)) = 12.0D0
     nmb_data(2,-2,kp_kl(2))= 2*3*(1.0D0/2)**2/2
     nmb_data(2,2,kp_kl(2)) = nmb_data(2,-2,kp_kl(2))
  endif
  
  call AssertEqual(&
    message='nmb_EnergyFromStreamfunc_wb',                        &
    answer = nmb_EnergyFromStreamfunc_wb(wb_data),                &
    check =  nmb_data,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nb_data = 0.0D0
  if ( kp_kl(1) /= 0 ) then
     nb_data(1,kp_kl(1)) = 4.0D0
     nb_data(2,kp_kl(1)) = 2 * 3 *(3.0D0/2)**2
  endif
  if ( kp_kl(2) /= 0 ) then
     nb_data(1,kp_kl(2)) = 9.0D0 + 1*2*(2.0D0/2)**2
     nb_data(2,kp_kl(2)) = 12.0D0 + 2*3*(1.0D0/2)**2
  endif
  
  call AssertEqual(&
    message='nb_EnergyFromStreamfunc_wb',                         &
    answer = nb_EnergyFromStreamfunc_wb(wb_data),                 &
    check =  nb_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nmb_Data = nmb_EnergyFromStreamfunc_wb(wb_data)
  b_data = 0.0D0
  do n=0,nm
     do m=-n,n
        b_data = b_data + nmb_Data(n,m,:)
     enddo
  enddo
  ab_data(1,:) = b_data
  aa_data = aa_ab(ab_data)
  a_data  = aa_data(1,:)
!!$  a_data = reshape(aa_ab(reshape(b_data,(/1,kc/))),(/km/))
!!$  a_data = reshape(aa_ab(reshape(b_data,(/1,kc/))),(/km/))

  call AssertEqual(&
    message='total energy by nm-spectrum',                        &
    answer = a_AvrLonLat_pva(                                     &
    0.5D0*(pva_GradLon_wb(wb_data)**2+pva_GradLat_wb(wb_data)**2) ),&
    check = a_data,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  b_data = sum(nb_EnergyFromStreamfunc_wb(wb_data),1)
  ab_data(1,:) = b_data
  aa_data = aa_ab(ab_data)
  a_data  = aa_data(1,:)
!!$  a_data = reshape(aa_ab(reshape(b_data,(/1,kc/))),(/km/))

  call AssertEqual(&
    message='total energy with n-spectrum',                       &
    answer = a_AvrLonLat_pva(                                     &
    0.5*(pva_GradLon_wb(wb_data)**2+pva_GradLat_wb(wb_data)**2) ),&
    check =  a_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nmb_data=wb_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nmb_data(n,m,:) = 0.0D0
     enddo
  enddo

  if ( kp_kl(1) /= 0 ) then
     nmb_data(1,0,kp_kl(1)) = 8.0D0
     nmb_data(2,1,kp_kl(1)) = 2**2*3**2*(3.0D0/2)**2/2
     nmb_data(2,-1,kp_kl(1)) = nmb_data(2,1,kp_kl(1))
  endif
  if ( kp_kl(2) /= 0 ) then
     nmb_data(1,0,kp_kl(2))  = 18.0D0
     nmb_data(1,1,kp_kl(2))  = 1**2 * 2**2 * (2/2)**2 / 2
     nmb_data(1,-1,kp_kl(2)) = nmb_data(1,1,kp_kl(2))
     nmb_data(2,0,kp_kl(2))  = 72.0D0
     nmb_data(2,-2,kp_kl(2)) = 2**2 * 3**2 * (1.0D0/2)**2 /2
     nmb_data(2,2,kp_kl(2))  = nmb_data(2,-2,kp_kl(2))
  endif

  call AssertEqual(&
    message='nmb_EnstrophyFromStreamfunc_wb',                     &
    answer = nmb_EnstrophyFromStreamfunc_wb(wb_data),             &
    check =  nmb_data,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nb_data = 0.0
  if ( kp_kl(1) /= 0 ) then
     nb_data(1,kp_kl(1)) = 8.0D0
     nb_data(2,kp_kl(1)) = 2**2*3**2*(3.0D0/2)**2
  endif
    
  if ( kp_kl(2) /= 0 ) then
     nb_data(1,kp_kl(2)) = 18.0D0 + 1**2 * 2**2 * (2/2)**2
     nb_data(2,kp_kl(2)) = 72.0D0 + 2**2 * 3**2 * (1.0D0/2)**2
  endif

  call AssertEqual(&
    message='nb_EnstrophyFromStreamfunc_wb',                      &
    answer = nb_EnstrophyFromStreamfunc_wb(wb_data),              &
    check =  nb_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nmb_Data = nmb_EnstrophyFromStreamfunc_wb(wb_data)
  b_data = 0.0D0
  do n=0,nm
     do m=-n,n
        b_data = b_data + nmb_Data(n,m,:)
     enddo
  enddo
  ab_data(1,:) = b_data
  aa_data = aa_ab(ab_data)
  a_data  = aa_data(1,:)
!!$  a_data = reshape(aa_ab(reshape(b_data,(/kc,1/))),(/km/))

  call AssertEqual(&
    message='total enstrophy by nm-spectrum',                     &
    answer = a_AvrLonLat_pva( 0.5*(pva_wb(wb_Lapla_wb(wb_data))**2)),&
    check = a_data,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  b_data = sum(nb_EnstrophyFromStreamfunc_wb(wb_data),1)
  call AssertEqual(&
    message='total energy with n-spectrum',                       &
    answer = a_AvrLonLat_pva( 0.5*(pva_wb(wb_Lapla_wb(wb_data))**2)), &
    check =  a_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wb_spectrum_mpi_module_test', &
                     'wb_spectrum_module tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wb_spectrum_mpi_module

!--
!----------------------------------------------------------------------
!     Copyright (c) 2024-2025 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_zonal_module_base
!
!  spml/w_zonal_module_base モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するためのモジュール 
!  w_zonal_module の下部モジュールであり, スペクトル計算の基本的な 
!  Fortran90 関数を提供する.
!
!  内部で ISPACK3 の LXPACK(SXPACK の Fortran サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算
!  法については ISPACK3/SXPACK のマニュアルを参照されたい.
!
!== 履歴
!
!      2024/02/15  竹広真一  w_wave_module_base.90 より改造
!      2025/11/27  竹広真一  w_base_initial interface を変更
!      2025/12/10  竹広真一  経度座標変数を追加
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!         ・波数切断の仕方は三角波数切断に決めうち. 
!
!++
module w_zonal_module_base
  !
  != w_zonal_module_base
  !
  !== 概要.
  !
  !  spml/w_zonal_module_base モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するためのモジュール 
  !  w_zonal_module の下部モジュールであり, スペクトル計算の基本的な 
  !  Fortran90 関数を提供する.
  !
  !  内部で ISPACK3 の LXPACK(SXPACK の Fortran サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算
  !  法については ISPACK3/SXPACK のマニュアルを参照されたい.
  !
  !
  use dc_message, only : MessageNotify
  implicit none

  integer(8)            :: im=1             ! 東西波数成分
  integer(8)            :: jm=32            ! 格子点の設定(南北)
  integer(8)            :: nm=21            ! 計算する最大の全波数の設定
  integer(8)            :: nn=22            ! 切断波数(全波数)の設定
  integer(8)            :: mm=21            ! 切断波数(東西波数)の設定
  integer(8)            :: ig=1             ! 緯度格子点種類
  
  real(8),    allocatable  :: pz(:,:)       ! 変換用配列
  real(8),    allocatable  :: rm(:)         ! 変換用配列
  real(8),    allocatable  :: cm(:)         ! 作業配列

  real(8), allocatable  :: x_Lon(:)         ! 経度経度
  real(8), allocatable  :: x_Lon_Weight(:)  ! 座標重み
  real(8), allocatable  :: y_Lat(:)         ! 緯度経度
  real(8), allocatable  :: y_Lat_Weight(:)  ! 座標重み
  real(8), allocatable  :: xy_Lon(:,:), xy_Lat(:,:)

  logical               :: w_zonal_base_initialize=.false.   ! 初期化フラッグ

  real(8), parameter    :: pi=3.1415926535897932385D0

  private

  public im, jm, nn, mm, nm                   ! 格子点数, 切断波数
  public pz, rm, cm                           ! 変換用作業配列

  public w_base_Initial                       ! 初期化サブルーチン
  public w_base_Finalize                      ! 終了サブルーチン

  public x_Lon, y_Lat                         ! 格子座標
  public x_Lon_weight, y_Lat_Weight           ! 格子座標重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public l_nm, nm_l                           ! 波数格納位置
  public xy_w, w_xy                           ! 変換関数
  public w_DLon_w                             ! 経度微分

  interface l_nm
     module procedure l_nm_array00
     module procedure l_nm_array01
     module procedure l_nm_array10
     module procedure l_nm_array11
     module procedure l_nm_darray00
     module procedure l_nm_darray01
     module procedure l_nm_darray10
     module procedure l_nm_darray11
  end interface

  interface nm_l
     module procedure nm_l_int
     module procedure nm_l_array
     module procedure nm_l_dint
     module procedure nm_l_darray
  end interface

  save im, jm, nm, mm, nn, ig                 ! 格子点数, 切断波数を記憶
  save pz, rm                                 ! 変換用配列を記憶
  save cm                                     ! 変換用配列の大きさ  
  save w_zonal_base_initialize                ! 初期化フラグ

contains
  !--------------- 初期化 -----------------
  subroutine w_base_Initial(n_in,i_in,j_in)
    !
    ! スペクトル変換の格子点数, 波数を設定する.
    !
    ! 実際の使用には上位サブルーチン w_zonal_Initial を用いること.
    !
    integer,intent(in) :: i_in              !(in) 格子点数(東西), 2の巾乗(<=2048)
    integer,intent(in) :: j_in              !(in) 格子点数(南北), 4 の倍数
    integer,intent(in) :: n_in              !(in) 切断全波数

    integer :: i, j

    im = i_in   ; jm = j_in
    nn = n_in   ; nm = n_in+1 ;  mm = n_in    ! default は三角波数切断

    allocate(x_Lon(0:im-1))                   ! 格子点座標格納配列(経度)
    allocate(x_Lon_Weight(0:im-1))
    allocate(y_Lat(1:jm))
    allocate(y_Lat_Weight(1:jm))              ! 格子点座標格納配列
    allocate(xy_Lon(0:im-1,1:jm))             ! 格子点座標格納配列
    allocate(xy_Lat(0:im-1,1:jm))             ! 格子点座標格納配列

    allocate(pz(jm/2,5))                      ! 変換用配列
    allocate(rm(nm/2*3+nm+1))                 ! 変換用配列
    allocate(cm(2*nn+1))                      ! 変換用配列      


    do i=0,im-1
       x_Lon(i)  = 2*pi/im*i                  ! 経度座標
       x_Lon_Weight(i) = 2*pi/im              ! 経度座標重み
    enddo

    call lxinig(jm,pz,ig)
    call lxinir(nm,0_8,rm)
    call lxinic(nn,0_8,cm)

    do j=1,jm/2
       y_Lat(jm/2+j)   =  asin(pz(j,1))        ! 緯度座標
       y_Lat(jm/2-j+1) = -asin(pz(j,1))        ! 緯度座標
       y_Lat_Weight(jm/2+j)   = 2*pz(j,2)      ! 緯度重み(Gauss grid)
       y_Lat_Weight(jm/2-j+1) = 2*pz(j,2)      ! 緯度重み(Gauss grid)
    enddo

    do j=1,jm
       xy_Lon(:,j) = x_Lon
    enddo

    do i=0,im-1
       xy_Lat(i,:) = y_Lat
    enddo

    w_zonal_base_initialize = .true.

    call MessageNotify('M','w_base_initial',&
         'w_zonal_module_base (2025/12/10) is initialized')

  end subroutine w_base_Initial

  !--------------- 基本関数 -----------------

  function l_nm_array00(n_in,m_in)
    !
    ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
    ! 
    ! 引数 n,m がともに整数値の場合, 整数値を返す. 
    !
    integer               :: l_nm_array00
    !(out) スペクトルデータの格納位置 

    integer, intent(in)   :: n_in     !(in) 全波数
    integer, intent(in)   :: m_in     !(in) 帯状波数           

    if ( m_in /= 0 ) then
       call MessageNotify('E','l_nm_array00', &
            'longitudinal wavenumber m must be zero')
    else
       l_nm_array00 = n_in-m_in+1
    endif

  end function l_nm_array00

  function l_nm_darray00(n_in,m_in)
    !
    ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
    ! 
    ! 引数 n,m がともに整数値の場合, 整数値を返す. 
    !
    integer               :: l_nm_darray00   
    !(out) スペクトルデータの格納位置 

    integer(8), intent(in)   :: n_in     !(in) 全波数
    integer(8), intent(in)   :: m_in     !(in) 帯状波数           

    if ( m_in /= 0 ) then
       call MessageNotify('E','l_nm_darray00', &
            'longitudinal wavenumber m must be zero')
    else
    l_nm_darray00 = n_in+m_in+1
    endif

  end function l_nm_darray00

  function l_nm_array01(n,marray)           ! スペクトルデータの格納位置 
    !
    ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
    ! 
    ! 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合, 
    ! marray と同じ大きさの 1 次元整数配列を返す. 
    !
    integer, intent(in)  :: n               !(in) 全波数
    integer, intent(in)  :: marray(:)       !(in) 帯状波数
    integer              :: l_nm_array01(size(marray))
    !(out) スペクトルデータ位置

    integer              :: i 

    do i=1, size(marray)
       l_nm_array01(i) = l_nm_array00(n,marray(i))
    enddo
  end function l_nm_array01

  function l_nm_darray01(n,marray)           ! スペクトルデータの格納位置 
    !
    ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
    ! 
    ! 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合, 
    ! marray と同じ大きさの 1 次元整数配列を返す. 
    !
    integer(8), intent(in)  :: n               !(in) 全波数
    integer(8), intent(in)  :: marray(:)       !(in) 帯状波数
    integer                 :: l_nm_darray01(size(marray))
    !(out) スペクトルデータ位置

    integer              :: i 

    do i=1, size(marray)
       l_nm_darray01(i) = l_nm_darray00(n,marray(i))
    enddo
  end function l_nm_darray01

  function l_nm_array10(narray,m_in)
    !
    ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
    ! 
    ! 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合, 
    ! narray と同じ大きさの 1 次元整数配列を返す. 
    !
    integer, intent(in)  :: narray(:)           !(in) 全波数  
    integer, intent(in)  :: m_in                !(in) 帯状波数
    integer              :: l_nm_array10(size(narray))
    !(out) スペクトルデータ位置

    integer              :: i 

    do i=1, size(narray)
       l_nm_array10(i) = l_nm_array00(narray(i),m_in)
    enddo
  end function l_nm_array10

  function l_nm_darray10(narray,m_in)
    !
    ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
    ! 
    ! 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合, 
    ! narray と同じ大きさの 1 次元整数配列を返す. 
    !
    integer(8), intent(in)  :: narray(:)           !(in) 全波数  
    integer(8), intent(in)  :: m_in                !(in) 帯状波数
    integer                 :: l_nm_darray10(size(narray))
    !(out) スペクトルデータ位置

    integer              :: i 

    do i=1, size(narray)
       l_nm_darray10(i) = l_nm_darray00(narray(i),m_in)
    enddo
  end function l_nm_darray10

  function l_nm_array11(narray,marray)
    !
    ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
    ! 
    ! 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合, 
    ! narray, marray と同じ大きさの 1 次元整数配列を返す. 
    ! narray, marray は同じ大きさでなければならない. 
    !
    integer, intent(in)  :: narray(:)          !(in) 全波数  
    integer, intent(in)  :: marray(:)          !(in) 帯状波数
    integer              :: l_nm_array11(size(narray))
    !(out) スペクトルデータ位置

    integer              :: i 

    if ( size(narray) .ne. size(marray) ) then
       call MessageNotify('E','l_nm_array11',&
            'dimensions of input arrays  n and m are different.')
    endif

    do i=1, size(narray)
       l_nm_array11(i) = l_nm_array00(narray(i),marray(i))
    enddo
  end function l_nm_array11

  function l_nm_darray11(narray,marray)
    !
    ! 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
    ! 
    ! 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合, 
    ! narray, marray と同じ大きさの 1 次元整数配列を返す. 
    ! narray, marray は同じ大きさでなければならない. 
    !
    integer(8), intent(in)  :: narray(:)          !(in) 全波数  
    integer(8), intent(in)  :: marray(:)          !(in) 帯状波数
    integer                 :: l_nm_darray11(size(narray))
    !(out) スペクトルデータ位置

    integer              :: i 

    if ( size(narray) .ne. size(marray) ) then
       call MessageNotify('E','l_nm_darray11',&
            'dimensions of input arrays  n and m are different.')
    endif

    do i=1, size(narray)
       l_nm_darray11(i) = l_nm_darray00(narray(i),marray(i))
    enddo
  end function l_nm_darray11

  function nm_l_int(l)
    ! 
    ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
    !
    ! 引数 l が整数値の場合, 対応する全波数と帯状波数を
    ! 長さ 2 の 1 次元整数値を返す. 
    ! nm_l(1) が全波数, nm_l(2) が帯状波数である. 
    !
    integer               :: nm_l_int(2)  !(out) 全波数, 帯状波数
    integer, intent(in)   :: l            !(in) スペクトルデータの格納位置

    nm_l_int(1) = l-1
    nm_l_int(2) = 0

  end function nm_l_int

  function nm_l_dint(l)
    ! 
    ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
    !
    ! 引数 l が整数値の場合, 対応する全波数と帯状波数を
    ! 長さ 2 の 1 次元整数値を返す. 
    ! nm_l(1) が全波数, nm_l(2) が帯状波数である. 
    !
    integer                  :: nm_l_dint(2)  !(out) 全波数, 帯状波数
    integer(8), intent(in)   :: l             !(in) スペクトルデータの格納位置

    nm_l_dint(1) = l-1
    nm_l_dint(2) = 0

  end function nm_l_dint

  function nm_l_array(larray)
    ! 
    ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
    !
    ! 引数 larray が整数 1 次元配列の場合, 
    ! larray に対応する n, m を格納した 2 次元整数配列を返す. 
    ! nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である. 
    !
    integer, intent(in)  :: larray(:)
    !(out) 全波数, 帯状波数

    integer              :: nm_l_array(size(larray),2)
    !(in) スペクトルデータの格納位置

    integer              :: i

    do i=1, size(larray)
       nm_l_array(i,:) = nm_l_int(larray(i))
    enddo
  end function nm_l_array

  function nm_l_darray(larray)
    ! 
    ! スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
    !
    ! 引数 larray が整数 1 次元配列の場合, 
    ! larray に対応する n, m を格納した 2 次元整数配列を返す. 
    ! nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である. 
    !
    integer(8), intent(in)  :: larray(:)
    !(out) 全波数, 帯状波数

    integer                 :: nm_l_darray(size(larray),2)
    !(in) スペクトルデータの格納位置

    integer              :: i

    do i=1, size(larray)
       nm_l_darray(i,:) = nm_l_dint(larray(i))
    enddo
  end function nm_l_darray

  !--------------- 基本変換 -----------------
  function w_DLon_w(w_data)
    !
    ! 入力スペクトルデータに経度微分∂/∂λを作用する. 
    !
    ! スペクトルデータの経度微分とは, 対応する格子点データに
    ! 経度微分を作用させたデータのスペクトル変換のことである. 
    !
    real(8)              :: w_DLon_w(nn+1)
    !(out) 入力スペクトルデータのラプラシアン

    real(8), intent(in)  :: w_data(nn+1)
    !(in) 入力スペクトルデータ

    integer :: n, n1, n2

    w_DLon_w = 0.0D0

  end function w_DLon_w

  function xy_w(w_data,ipow,iflag)
    !
    ! スペクトルデータから格子データへ変換する(1 層用).
    !
    real(8)               :: xy_w(0:im-1,1:jm)
    !(out) 格子点データ

    real(8), intent(in)   :: w_data(nn+1)
    !(in) スペクトルデータ

    integer, intent(in), optional  :: ipow      
    !(in) 作用させる 1/cosφ の次数. 省略時は 0. 

    integer, intent(in), optional  :: iflag
    !(in) 変換の種類
    !    0 : 通常の正変換
    !   -1 : 経度微分を作用させた逆変換
    !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
    !    2 : sinφを作用させた逆変換
    !    省略時は 0.
    !
    integer, parameter  :: ipow_default  = 0
    integer, parameter  :: iflag_default = 0

    integer(8) ipval, ifval

    real(8)             :: w_Ydata(nn+2)
    ! 作業用スペクトルデータ(LXCSWY 出力用)

    if ( .not. w_zonal_base_initialize ) then
       call MessageNotify('E','xy_w',&
            'w_zonal_base_module_svpack not initialize yet.')
    endif

    if (present(ipow)) then
       ipval = ipow
    else
       ipval = ipow_default
    endif

    if (present(iflag)) then
       ifval = iflag
    else
       ifval = iflag_default
    endif

    if ( ifval==0 ) then
       call lxtszg(nm,nn,jm,w_Data,xy_w,pz,rm,ipval)
    else if( ifval==-1 ) then
       call lxtszg(nm,nn,jm,w_DLon_w(w_Data),xy_w,pz,rm,ipval)
    else if( ifval==1 ) then
       call lxcszy(nn,w_data,w_Ydata,cm)
       call lxtszg(nm,nm,jm,w_YData,xy_w,pz,rm,ipval)
    else if( ifval==2 ) then
       call lxtszg(nm,nn,jm,w_data,xy_w,pz,rm,ipval)
       xy_w = xy_w * sin(xy_Lat)
    else
       call MessageNotify('E','xy_w','invalid value of iflag')
    endif

  end function xy_w

  function w_xy(xy_data,ipow,iflag)
    !
    ! 格子データからスペクトルデータへ(正)変換する(1 層用).
    !
    real(8)               :: w_xy(nn+1)
    !(out) スペクトルデータ

    real(8), intent(in)   :: xy_data(0:im-1,1:jm)
    !(in) 格子点データ

    integer, intent(in), optional  :: ipow
    !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

    integer, intent(in), optional  :: iflag
    ! 変換の種類
    !    0 : 通常の正変換
    !   -1 : 経度微分を作用させた正変換 
    !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
    !    2 : sinφを作用させた正変換
    !  省略時は 0.


    integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
    integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

    integer(8) ipval, ifval

    real(8)             :: w_Ydata(2*(nn+2))
    ! 作業用スペクトルデータ(LXCYWS 出力用)

    if ( .not. w_zonal_base_initialize ) then
       call MessageNotify('E','w_xy',&
            'w_zonal_module_base not initialize yet.')
    endif

    if (present(ipow)) then
       ipval = ipow
    else
       ipval = ipow_default
    endif

    if (present(iflag)) then
       ifval = iflag
    else
       ifval = iflag_default
    endif

    if ( ifval == 0 ) then
       call lxtgzs(nm,nn,jm,w_xy,xy_data,pz,rm,ipval)
    else if ( ifval == -1 ) then
       call lxtgzs(nm,nn,jm,w_xy,xy_data,pz,rm,ipval)
       w_xy = w_Dlon_w(w_xy)
    else if ( ifval == 1 ) then
       call lxtgzs(nm,nm,jm,w_Ydata,xy_data,pz,rm,ipval)
       call lxcyzs(nn,w_Ydata,w_xy,cm)
    else if ( ifval == 2 ) then
       call lxtgzs(nm,nn,jm,w_xy,xy_data*sin(xy_Lat),pz,rm,ipval)
    end if

  end function w_xy

  !--------------- 終了処理 -----------------
  subroutine w_base_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
    !
    ! 実際の使用には上位サブルーチン w_Finalize を用いること.
    !
    if ( .not. w_zonal_base_initialize ) then
       call MessageNotify('W','w_base_Finalize',&
            'w_zonal_module_base not initialized yet')
       return
    endif

    deallocate(pz)                  ! 変換用配列
    deallocate(rm)                  ! 変換用配列
    deallocate(cm)                  ! 変換用作業配列      

    deallocate(x_Lon)
    deallocate(x_Lon_Weight)       ! 格子点座標格納配列
    deallocate(xy_Lon)             ! 格子点座標格納配列
    deallocate(y_Lat)
    deallocate(y_Lat_Weight)       ! 格子点座標格納配列
    deallocate(xy_Lat)             ! 格子点座標格納配列

    w_zonal_base_initialize = .false.

    call MessageNotify('M','w_base_Finalize',&
         'w_zonal_module_base (2025/12/10) is finalized')

  end subroutine w_base_Finalize

end module w_zonal_module_base

!----------------------------------------------------------------------
!     Copyright (c) 2019-2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_spectrum_module テストプログラム :: スペクトル解析関数のテスト
!
!履歴  2019/03/16  竹広真一
!      2020/11/07  竹広真一 セクター計算テスト
!
program w_spectrum_module_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module_mint
  implicit none

!!$  integer, parameter :: im=32, jm=16, nm=10
  integer, parameter :: im=16, jm=16, nm=10, mint=2
  integer, parameter :: nc=(nm/mint+1)*(2*(nm+1)-nm/mint*mint)

  real(8), dimension(nc)          ::  w_data
  real(8), dimension(0:im-1,1:jm) ::  xy_data

  real(8), dimension(0:nm,-nm:nm) ::  nm_data
  real(8), dimension(0:nm)        ::  n_data
  real(8)                         ::  data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: n,m

  call w_Initial( nm, im, jm, mint=mint )

  call MessageNotify('M','w_spectrum_module_mint_test', &
       'w_spectrum_module tests')

!!$  !================= 2Y_1^0+3Y_2^1 のテスト ================
!!$  xy_data = 2*sqrt(3.0D0)*sin(xy_Lat) &        ! 2Y_1^0+3Y_2^1
!!$       + 3*sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat) * cos(xy_Lon)!
!!$  w_data = w_xy(xy_data)
!!$
!!$  !--------- Energy spectrum ---------
!!$  nm_data=w_spectrum_VMiss
!!$  do n=0,nm
!!$     do m=-n,n
!!$        nm_data(n,m) = 0.0
!!$     enddo
!!$  enddo
!!$  nm_data(1,0) = 1*2*(2**2)/2
!!$  nm_data(2,1) = 2*3*(3.0D0/2)**2/2
!!$  nm_data(2,-1) =  nm_data(2,1)
!!$  call AssertEqual(&
!!$    message='nm_EnergyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',      &
!!$    answer = nm_data,                                             &
!!$    check = nm_EnergyFromStreamfunc_w(w_data),                    &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  n_data = 0.0; n_data(1) = 4.0D0 ;   n_data(2) = 2*3*(3.0D0/2)**2
!!$  call AssertEqual(&
!!$    message='n_EnergyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',       &
!!$    answer = n_data,                                              &
!!$    check = n_EnergyFromStreamfunc_w(w_data),                     &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  nm_Data = nm_EnergyFromStreamfunc_w(w_data)
!!$  data = 0.0D0
!!$  do n=0,nm
!!$     do m=-n,n
!!$        data = data + nm_Data(n,m)
!!$     enddo
!!$  enddo
!!$
!!$  call AssertEqual(&
!!$    message='total energy by nm-spectrum with 2Y_1^0+3Y_2^1 ',    &
!!$    answer = AvrLonLat_xy( &
!!$         0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) ), &
!!$    check = data,                                                 &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  data = AvrLonLat_xy( 0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) )
!!$  call AssertEqual(&
!!$    message='total energy by n-spectrum with 2Y_1^0+3Y_2^1 ',     &
!!$    answer = data,                                                &
!!$    check = sum(n_EnergyFromStreamfunc_w(w_data)),                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  !--------- Enstrophy spectrum ---------
!!$  nm_data=w_spectrum_VMiss
!!$  do n=0,nm
!!$     do m=-n,n
!!$        nm_data(n,m) = 0.0
!!$     enddo
!!$  enddo
!!$  nm_data(1,0) = (1**2)*(2**2)*(2**2)/2
!!$  nm_data(2,1) = (2**2)*(3**2)*(3.0D0/2.0D0)**2/2
!!$  nm_data(2,-1) = nm_data(2,1)
!!$  call AssertEqual(&
!!$    message='nm_EnstrophyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',   &
!!$    answer = nm_data,                                             &
!!$    check = nm_EnstrophyFromStreamfunc_w(w_data),                 &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  n_data = 0.0;
!!$  n_data(1) = (1**2)*(2**2)*(2**2)/2
!!$  n_data(2) = (2**2)*(3**2)*(3.0D0/2.0D0)**2
!!$  call AssertEqual(&
!!$    message='n_EnstrophyFromStreamfunc_w with 2Y_1^0+3Y_2^1 ',    &
!!$    answer = n_data,                                              &
!!$    check = n_EnstrophyFromStreamfunc_w(w_data),                  &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  nm_Data = nm_EnstrophyFromStreamfunc_w(w_data)
!!$  data = 0.0D0
!!$  do n=0,nm
!!$     do m=-n,n
!!$        data = data + nm_Data(n,m)
!!$     enddo
!!$  enddo
!!$
!!$  call AssertEqual(&
!!$    message='total enstrophy by nm-spectrum with 2Y_1^0+3Y_2^1 ', &
!!$    answer =  AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2)),    &
!!$    check = data,                                                 &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  data = AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2))
!!$  call AssertEqual(&
!!$    message='total enstrophy by n-spectrum with 2Y_1^0+3Y_2^1 ',  &
!!$    answer = data,                                                &
!!$    check = sum(n_EnstrophyFromStreamfunc_w(w_data)),             &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )

  !======== 3*Y_1^0 + 2Y_2^0 +Y_2^-2 のテスト ========
  xy_data = 3*sqrt(3.0D0)*sin(xy_Lat) &
          + 2*sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0) &
          - sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)
  w_data = w_xy(xy_data)

  !--------- Energy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0)  = 1*2*3**2/2
  nm_data(2,0)  = 2*3*2**2/2
  nm_data(2,-2) = 2*3*(1.0D0/2.0D0)**2/2
  nm_data(2,2)  = nm_data(2,-2)
  call AssertEqual(&
    message='nm_EnergyFromStreamfunc_w with 3Y_1^0 + 2Y_2^0 +Y_2^-2',&
    answer = nm_data,                                             &
    check = nm_EnergyFromStreamfunc_w(w_data),                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0
  n_data(1) = 1*2*3**2/2
  n_data(2) = 2*3*2**2/2 + 2*3*(1.0D0/2.0D0)**2
  call AssertEqual(&
    message='n_EnergyFromStreamfunc_w with 3Y_1^0 + 2Y_2^0 +Y_2^-2', &
    answer = n_data,                                              &
    check = n_EnergyFromStreamfunc_w(w_data),                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnergyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total energy by nm-spectrum with 3Y_1^0 + 2Y_2^0 +Y_2^-2', &
    answer = AvrLonLat_xy( &
         0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) ), &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_GradLon_w(w_data)**2+xy_GradLat_w(w_data)**2) )
  call AssertEqual(&
    message='total energy by n-spectrum with 3Y_1^0 + 2Y_2^0 +Y_2^-2', &
    answer = data,                                                &
    check = sum(n_EnergyFromStreamfunc_w(w_data)),                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !--------- Enstrophy spectrum ---------
  nm_data=w_spectrum_VMiss
  do n=0,nm
     do m=-n,n
        nm_data(n,m) = 0.0
     enddo
  enddo
  nm_data(1,0)  = (1**2)*(2**2)*3**2/2
  nm_data(2,0)  = (2**2)*(3**2)*2**2/2
  nm_data(2,-2) = (2**2)*(3**2)*(1.0D0/2.0D0)**2/2
  nm_data(2,2)  = nm_data(2,-2)
  call AssertEqual(&
    message='nm_EnstrophyFromStreamfunc_w with 3Y_1^0 + 2Y_2^0 +Y_2^-2', &
    answer = nm_data,                                             &
    check = nm_EnstrophyFromStreamfunc_w(w_data),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  n_data = 0.0
  n_data(1) = (1**2)*(2**2)*3**2/2
  n_data(2) = (2**2)*(3**2)*2**2/2 + (2**2)*(3**2)*(1.0D0/2.0D0)**2
  call AssertEqual(&
    message='n_EnstrophyFromStreamfunc_w with 3Y_1^0 + 2Y_2^0 +Y_2^-2', &
    answer = n_data,                                              &
    check = n_EnstrophyFromStreamfunc_w(w_data),                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nm_Data = nm_EnstrophyFromStreamfunc_w(w_data)
  data = 0.0D0
  do n=0,nm
     do m=-n,n
        data = data + nm_Data(n,m)
     enddo
  enddo

  call AssertEqual(&
    message='total enstrophy by nm-spectrum with 3Y_1^0 + 2Y_2^0 +Y_2^-2',&
    answer =  AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2)),    &
    check = data,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  data = AvrLonLat_xy( 0.5*(xy_w(w_Lapla_w(w_data))**2))
  call AssertEqual(&
    message='total enstrophy by n-spectrum with 3Y_1^0 + 2Y_2^0 +Y_2^-2',&
    answer = data,                                                &
    check = sum(n_EnstrophyFromStreamfunc_w(w_data)),             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_spectrum_module_mint_test', &
                         'w_spectrum_module tests succeeded!')

end program w_spectrum_module_mint_test

! -*- mode: f90; coding: utf-8 -*-
! ----------------------------------------------------------------------------
! 定数・関数ユーティリティ/Constant and Function Utilities
! ----------------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2026
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @ja
!> @brief 定数・関数ユーティリティ
!>
!> @details
!> 複数のモジュールで個別に設定していた定数, 関数をまとめた.
!> また, 単精度/倍精度両対応にした固有値計算と並び替え関数も提供している.
!> @endja
!> @en
!> @brief Constant and Function Utilities
!>
!> @details
!> Constants and functions previously configured individually across
!> multiple modules have been consolidated. Furthermore, eigenvalue
!> calculations and sorting functions supporting both single-precision
!> and double-precision are now provided.
!> @enden
module spml_utils
  use dc_message, only : MessageNotify
  use dc_types, only: DP, DP_EPS, SP, SP_EPS
  implicit none
  private
  public pi
  public gammaln
  public factrl

#ifdef EIG_LAPACK
  public eigen
  public ceigen

  ! --------------------------------------------------------------------------
  !> LAPACK interfaces
  !> (explicit interface for Fortran 2003 conformance)
  interface
    subroutine DGEEV(jobvl, jobvr, n, a, lda, wr, wi, &
      & vl, ldvl, vr, ldvr, work, lwork, info)
      use dc_types, only: DP
      implicit none
      character(len=1), intent(in) :: jobvl, jobvr
      integer, intent(in) :: n, lda, ldvl, ldvr, lwork
      real(DP), intent(inout) :: a(lda,*)
      real(DP), intent(out)   :: wr(*), wi(*)
      real(DP), intent(out)   :: vl(ldvl,*), vr(ldvr,*)
      real(DP), intent(inout) :: work(*)
      integer, intent(out) :: info
    end subroutine DGEEV

    subroutine SGEEV(jobvl, jobvr, n, a, lda, wr, wi, &
      vl, ldvl, vr, ldvr, work, lwork, info)
      use dc_types, only: SP
      implicit none
      character(len=1), intent(in) :: jobvl, jobvr
      integer, intent(in) :: n, lda, ldvl, ldvr, lwork
      real(SP), intent(inout) :: a(lda,*)
      real(SP), intent(out)   :: wr(*), wi(*)
      real(SP), intent(out)   :: vl(ldvl,*), vr(ldvr,*)
      real(SP), intent(inout) :: work(*)
      integer, intent(out) :: info
    end subroutine SGEEV

    subroutine ZGEEV(jobvl, jobvr, n, a, lda, w, &
      & vl, ldvl, vr, ldvr, work, lwork, rwork, info)
      use dc_types, only: DP
      implicit none
      character(len=1), intent(in) :: jobvl, jobvr
      integer, intent(in) :: n, lda, ldvl, ldvr, lwork
      complex(DP), intent(inout) :: a(lda,*)
      complex(DP), intent(out)   :: w(*)
      complex(DP), intent(out)   :: vl(ldvl,*), vr(ldvr,*)
      complex(DP), intent(inout) :: work(*)
      real(DP), intent(inout)    :: rwork(*)
      integer, intent(out) :: info
    end subroutine ZGEEV
  end interface

  interface eigen
    module procedure deigen
    module procedure seigen
  end interface eigen

  interface indexx
    module procedure indexx_d
    module procedure indexx_s
  end interface indexx

  interface merge_sort
    module procedure merge_sort_d
    module procedure merge_sort_s
  end interface merge_sort
#endif
  ! --------------------------------------------------------------------------
  !> PI: 3.14159265358979323846264338327950288
  real(DP), parameter :: pi = 3.141592653589793238d0

  !> -------------------------------------------------------------------------
  !> external file: dlgamma.f90
  interface
    real(DP) function dlgamma(x)
      use dc_types, only: DP
      real(DP), intent(in) :: x
    end function dlgamma
  end interface

contains
  ! --------------------------------------------------------------------------
  !> Returns the vaule \f$ ln[Γ(x)] for x >= 0 \f$
  function gammaln(xx)
    real(DP), intent(in) :: xx
    real(DP)             :: gammaln

    gammaln = dlgamma(xx)

  end function gammaln

  ! --------------------------------------------------------------------------
  !> Returns the value \f$n!\f$ as a floating point number
  function factrl(n)
    integer, intent(in)  :: n
    real(DP)             :: factrl

    factrl = exp(gammaln(n+1.0d0))

  end function factrl

#ifdef EIG_LAPACK
  !---------------------------------------------------------------------
  !> @ja
  !> 実行列の固有値計算: DGEEV/LAPACK の wrapper
  !> * 行列 AMAT の i 番目固有値を eigen_r(i), eigen_i(i) に格納
  !> * 対応する固有ベクトルを eigvec_r(:,i), eigvec_i(:,i) に格納
  !> * 格納する固有値の数は引数 eigen_r の大きさで決まる
  !> * 固有値の順番は sort と order で定められる.
  !> * sort によって順番を定めるために用いる量を指定する.
  !> 実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
  !> * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
  !> * デフォルトは sort='R', reverse=.false.
  !> @endja
  !> @en
  !> Eigenvalue calculation for matrix AMAT: DGEEV/LAPACK wrapper @enden
  !> * Stores the i-th eigenvalue of matrix AMAT in eigen_r(i) and eigen_i(i)
  !> * Stores the corresponding eigenvector in eigvec_r(:,i) and eigvec_i(:,i)
  !> * The number of eigenvalues stored is determined by the size of the
  !>   eigen_r argument
  !> * The order of eigenvalues is determined by sort and order.
  !> * sort specifies the quantity used to determine the order.
  !>   Real part (R), absolute real part (RA), imaginary part (I), absolute
  !>   imaginary part (IA)
  !> * reverse specifies ascending (.false.) or descending (.true.) order.
  !> * Default is sort=‘R’, reverse=.false.
  !> @enden
  subroutine deigen(                            &
    & amat,eigen_r, eigen_i, eigvec_r,eigvec_i, &
    & info, sort, reverse )

    ! 入力正方行列
    real(DP), dimension(:,:)                  :: amat
    ! 固有値実数部
    real(DP), intent(out), dimension(:)       :: eigen_r
    ! 固有値虚数部
    real(DP), intent(out), dimension(:)       :: eigen_i
    ! 固有ベクトル実部
    real(DP), intent(out), &
      & dimension(size(amat,1),size(eigen_r)) :: eigvec_r
    ! 固有ベクトル虚部
    real(DP), intent(out), &
      & dimension(size(amat,1),size(eigen_i)) :: eigvec_i
    ! ステータス
    integer, intent(out)                      :: info
    ! 並び変えの量
    character(len=2), intent(in), optional    :: sort
    ! 並び変えスイッチ
    logical, intent(in), optional             :: reverse

    integer :: nm, i, j
    integer :: lwork, nout
    integer :: lo, hi, tmp
    real(DP), allocatable, dimension(:)       :: wr
    real(DP), allocatable, dimension(:)       :: wi
    real(DP), allocatable, dimension(:)       :: work
    real(DP), allocatable, dimension(:,:)     :: vr
    integer,  allocatable, dimension(:)       :: index
    real(DP), dimension(1,1)                  :: vl
    character(len=1), parameter               :: jobvl='N'
    character(len=1), parameter               :: jobvr='V'

    !------- 形状チェック ------
    nm = size(amat,1)
    if ( nm /= size(amat,2))then
      call MessageNotify('E','DEIGEN_LAPACK','Input matrix not square')
      return
    end if

    allocate(wr(nm), wi(nm), vr(nm,nm), index(nm))

    !------- DGEEV/LAPACK による計算 ----------------------------------------
    ! workspace size query
    allocate(work(1))
    lwork = -1
    call DGEEV( jobvl, jobvr, nm, amat, nm, wr, wi, &
      & vl, nm, vr, nm, work, lwork, info )
    lwork = max(1, int(work(1)))
    deallocate(work)
    ! main
    allocate(work(lwork))
    call DGEEV( jobvl, jobvr, nm, amat, nm, wr, wi, &
      & vl, nm, vr, nm, work, lwork, info )

    !------- サブルーチンエラー処理 -------
    if ( info /= 0 ) then
      call MessageNotify('E','DEIGEN_LAPACK',&
        'Error in calculating eigenvalues/vectors...',i=(/info/) )
      deallocate(wr, wi, vr, work, index)
      return
    end if

    !------- 固有ベクトル入れ換え -------
    if ( present(sort) ) then
      select case (trim(sort))
      case('RA')
        index = indexx(abs(wr))
      case('I ')
        index = indexx(wi)
      case('IA')
        index = indexx(abs(wi))
      case default
        index = indexx(wr)
      end select
    else
      index = indexx(wr)
    end if

    if ( present(reverse) )then
      if ( reverse ) then               ! 大きい順詰め変え
        ! index = index(size(index):1:-1)
        ! 陽にループ展開
        lo = 1; hi = nm
        do while (lo < hi)
          tmp = index(lo)
          index(lo) = index(hi)
          index(hi) = tmp
          lo = lo + 1
          hi = hi - 1
        end do
      end if
    end if

    i = 1
    nout = min(size(eigen_r), size(eigen_i), nm)
    do while (i <= nout)
      j = index(i)
      eigen_r(i) = wr(j)
      eigen_i(i) = wi(j)

      if ( abs(wi(j)) <= DP_EPS ) then
        eigvec_r(:,i) = vr(:,j)
        eigvec_i(:,i) = 0.0_DP
        i = i +1
      elseif ( wi(j) > 0.0_DP) then
        if (i + 1 > nout) exit
        if (j >= nm) exit
        eigvec_r(:,i)   = vr(:,j)
        eigvec_i(:,i)   = vr(:,j+1)
        eigvec_r(:,i+1) = vr(:,j)
        eigvec_i(:,i+1) = -vr(:,j+1)
        eigen_r(i+1)    = wr(j+1)
        eigen_i(i+1)    = wi(j+1)
        i = i + 2
      else
        i = i + 1
      end if
    end do

  end subroutine deigen

  !---------------------------------------------------------------------
  !> @ja
  !> 実行列の固有値計算: DGEEV/LAPACK の wrapper (eigen の単精度版)
  !> * 行列 AMAT の i 番目固有値を eigen_r(i), eigen_i(i) に格納
  !> * 対応する固有ベクトルを eigvec_r(:,i), eigvec_i(:,i) に格納
  !> * 格納する固有値の数は引数 eigen_r の大きさで決まる
  !> * 固有値の順番は sort と order で定められる.
  !> * sort によって順番を定めるために用いる量を指定する.
  !>   実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
  !> * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
  !> * デフォルトは sort='R', reverse=.false.
  !> @endja
  !> @en
  !> Eigenvalue calculation for matrix AMAT: DGEEV/LAPACK wrapper (single-precision)
  !> * Stores the i-th eigenvalue of matrix AMAT in eigen_r(i) and eigen_i(i)
  !> * Stores the corresponding eigenvector in eigvec_r(:,i) and eigvec_i(:,i)
  !> * The number of eigenvalues stored is determined by the size of the
  !>   eigen_r argument
  !> * The order of eigenvalues is determined by sort and order.
  !> * sort specifies the quantity used to determine the order.
  !>   Real part (R), absolute real part (RA), imaginary part (I), absolute
  !>   imaginary part (IA)
  !> * reverse specifies ascending (.false.) or descending (.true.) order.
  !> * Default is sort=‘R’, reverse=.false.
  !> @enden
  !>
  subroutine seigen(                            &
    & amat,eigen_r, eigen_i, eigvec_r,eigvec_i, &
    & info, sort, reverse )

    !> 入力正方行列
    real(SP), dimension(:,:)                  :: amat
    !> 固有値実数部
    real(SP), intent(out), dimension(:)       :: eigen_r
    !> 固有値虚数部
    real(SP), intent(out), dimension(:)       :: eigen_i
    !> 固有ベクトル実部
    real(SP), intent(out), &
      & dimension(size(amat,1),size(eigen_r)) :: eigvec_r
    !> 固有ベクトル虚部
    real(SP), intent(out), &
      & dimension(size(amat,1),size(eigen_i)) :: eigvec_i
    !> ステータス
    integer, intent(out)                      :: info
    !> 並び変えの量
    character(len=2), intent(in), optional    :: sort
    !> 並び変えスイッチ
    logical, intent(in), optional             :: reverse

    integer :: nm, i, j
    integer :: lwork, nout
    integer :: lo, hi, tmp
    real(SP), allocatable, dimension(:)       :: wr
    real(SP), allocatable, dimension(:)       :: wi
    real(SP), allocatable, dimension(:)       :: work
    real(SP), allocatable, dimension(:,:)     :: vr
    integer,  allocatable, dimension(:)       :: index
    real(SP), dimension(1,1)                  :: vl
    character(len=1), parameter               :: jobvl='N'
    character(len=1), parameter               :: jobvr='V'

    !------- 形状チェック ------
    nm = size(amat,1)
    if ( nm /= size(amat,2))then
      call MessageNotify('E','DEIGEN_LAPACK','Input matrix not square')
      return
    end if

    allocate(wr(nm), wi(nm), vr(nm,nm), index(nm))

    !------- SGEEV/LAPACK による計算 ------
    ! workspace quer
    allocate(work(1))
    lwork = -1
    call SGEEV( jobvl, jobvr, nm, amat, nm, wr, wi, &
      & vl, nm, vr, nm, work, lwork, info )
    lwork = max(1, int(work(1)))
    deallocate(work)
    ! 本計算
    allocate(work(lwork))
    call SGEEV( jobvl, jobvr, nm, amat, nm, wr, wi, &
      & vl, nm, vr, nm, work, lwork, info )

    !------- サブルーチンエラー処理 -------
    if ( info /= 0 ) then
      call MessageNotify('E','DEIGEN_LAPACK',&
        'Error in calculating eigenvalues/vectors...',i=(/info/) )
      deallocate(wr, wi, vr, work, index)
      return
    end if

    !------- 固有ベクトル入れ換え -------
    if ( present(sort) ) then
      select case (trim(sort))
      case('RA')
        index = indexx(abs(wr))
      case('I ')
        index = indexx(wi)
      case('IA')
        index = indexx(abs(wi))
      case default
        index = indexx(wr)
      end select
    else
      index = indexx(wr)
    end if

    if ( present(reverse) )then
      if ( reverse ) then               ! 大きい順
        ! index = index(size(index):1:-1)
        ! 陽にループ展開
        lo = 1; hi = nm
        do while (lo < hi)
          tmp = index(lo)
          index(lo) = index(hi)
          index(hi) = tmp
          lo = lo + 1
          hi = hi - 1
        end do
      end if
    end if

    i = 1
    nout = min(size(eigen_r), size(eigen_i), nm)
    do while (i <= nout)
      j = index(i)
      eigen_r(i) = wr(j)
      eigen_i(i) = wi(j)

      if ( abs(wi(j)) <= SP_EPS ) then
        eigvec_r(:,i) = vr(:,j)
        eigvec_i(:,i) = 0.0_SP
        i = i +1
      elseif ( wi(j) > 0.0_SP ) then
        if (i + 1 > nout) exit
        if (j >= nm) exit
        eigvec_r(:,i)   = vr(:,j)
        eigvec_i(:,i)   = vr(:,j+1)
        eigvec_r(:,i+1) = vr(:,j)
        eigvec_i(:,i+1) = -vr(:,j+1)
        eigen_r(i+1)    = wr(j+1)
        eigen_i(i+1)    = wi(j+1)
        i = i + 2
      else
        i = i + 1
      end if
    end do

  end subroutine seigen

  !---------------------------------------------------------------------
  !> @ja
  !> 複素行列の固有値計算: ZGEEV/LAPACK の wrapper
  !> * 行列 CMAT の i 番目固有値を eigen(i) に格納
  !> * 対応する固有ベクトルを eigvec(:,i) に格納
  !> * 格納する固有値の数は引数 eigen の大きさで決まる
  !> * 固有値の順番は sort と order で定められる.
  !> * sort によって順番を定めるために用いる量を指定する.
  !> 実部(R), 実部の絶対値(RA), 虚部(I), 虚部の絶対値(IA)
  !> * reverse によって小さい順(.false.), 大きい順(.true.)を指定できる.
  !> * デフォルトは sort='R', reverse=.false.
  !> * 行列 CMAT は保存されない.
  !> @endja
  !> @en
  !> Eigenvalue Calculation for Complex Matrices: ZGEEV/LAPACK Wrapper
  !>
  !> * The i-th eigenvalue of matrix CMAT must be stored in eigen(i).
  !> * Similarly, the corresponding eigenvector must be stored in eigvec(:,i).
  !> * The number of eigenvalues that are stored is determined by the size of
  !> the eigen argument.
  !> * Finally, the order of eigenvalues is determined by sort and order.
  !> * Please specify the quantity utilized to ascertain the order via sort.
  !>   The real part (R), absolute real part (RA), imaginary part (I), and
  !>   absolute imaginary part (IA) must be designated.
  !> * Employ the reverse function to stipulate ascending order (.false.) or
  !>   descending order (.true.).
  !> * The default setting is sort=‘R’, reverse=.false.
  !> * It is imperative to note that the matrix CMAT is not saved.
  !> @enden
  subroutine ceigen(cmat,eigen,eigvec,info,sort,reverse)
    !> 入力正方行列
    complex(DP), dimension(:,:)               :: cmat
    !> 固有値実数部
    complex(DP), intent(out), dimension(:)    :: eigen
    !> 固有ベクトル実部
    complex(DP), intent(out), &
      & dimension(size(cmat,1),size(eigen))   :: eigvec
    !> ステータス
    integer, intent(out)                      :: info
    !> 並び変えの量
    character(len=2), intent(in), optional    :: sort
    !> 並び変えスイッチ
    logical, intent(in), optional             :: reverse

    !------------ 作業変数 ------------
    integer :: nm, i, j
    integer :: lwork, nout
    integer :: lo, hi, tmp
    complex(DP), allocatable, dimension(:)    :: ceig
    complex(DP), allocatable, dimension(:,:)  :: vl
    complex(DP), allocatable, dimension(:,:)  :: vr
    complex(DP), allocatable, dimension(:)    :: work
    real(DP),  allocatable, dimension(:)      :: rwork
    integer,  allocatable, dimension(:)       :: index
    character(len=1), parameter               :: jobvl='N'
    character(len=1), parameter               :: jobvr='V'

    !------- 形状チェック ------
    nm = size(cmat,1)
    if (nm  /= size(cmat,2))then
      call MessageNotify('E','DCEIGEN_LAPACK','Input matrix not square')
      return
    end if

    allocate(vl(nm, nm), vr(nm, nm))
    allocate(ceig(nm), index(nm))
    allocate(rwork(2*nm))

    !------- ZGEEV/LAPACK による計算 -----------------------------------------
    ! workspace query
    allocate(work(1))
    lwork = -1
    call ZGEEV( jobvl, jobvr, nm, cmat, nm, ceig,   &
      & vl, nm, vr, nm, work, lwork, rwork, info )
    lwork = max(1, int(real(work(1))))
    deallocate(work)
    ! 本計算    --------------------------------------------------------------
    allocate(work(lwork))
    call ZGEEV( jobvl, jobvr, nm, cmat, nm, ceig,   &
      & vl, nm, vr, nm, work, lwork, rwork, info )

    !------- サブルーチンエラー処理 -------
    if ( info /= 0 ) then
      call MessageNotify('E','DCEIGEN_LAPACK',&
        'Error in calculating eigenvalues/vectors...',i=(/info/) )
      deallocate(ceig, vl, vr, work, rwork, index)
      return
    end if

    !------- 固有ベクトル入れ換え -------
    if ( present(sort) ) then
      select case (trim(sort))
      case('RA')
        index = indexx(abs(dble(ceig)))
      case('I ')
        index = indexx(aimag(ceig))
      case('IA')
        index = indexx(abs(aimag(ceig)))
      case default
        index = indexx(dble(ceig))
      end select
    else
      index = indexx(dble(ceig))
    end if

    if ( present(reverse) )then
      if ( reverse ) then               ! 大きい順
        ! index = index(size(index):1:-1)
        ! 陽にループ展開
        lo = 1; hi = nm
        do while (lo < hi)
          tmp = index(lo)
          index(lo) = index(hi)
          index(hi) = tmp
          lo = lo + 1
          hi = hi - 1
        end do
      end if
    end if

    nout = min(size(eigen), nm)
    do i=1,nout
      j = index(i)
      eigen(i)    = ceig(j)
      eigvec(:,i) = vr(:,j)
    end do

  end subroutine ceigen

  !---------------------------------------------------------------------
  !> @ja
  !> 与えられた配列を値の小さい順に sort する (倍精度)
  !>
  !> @endja
  !> @en
  !> The given array must be sorted in ascending order by value (double precision)
  !> @enden
  function indexx_d(arrin) result(indexx)
    implicit none
    real(DP), dimension(:), intent(in)  :: arrin
    integer, allocatable, dimension(:)   :: indexx

    integer :: n, i
    integer, allocatable :: temp(:)

    n = size(arrin)
    allocate(indexx(n), temp(n))

    ! 初期インデックス
    indexx = (/ (i, i=1,n) /)

    call merge_sort(arrin, indexx, temp, 1, n)

  end function indexx_d
  !---------------------------------------------------------------------
  !> @ja
  !> 与えられた配列を値の小さい順に sort する (単精度)
  !> @endja
  !> @en
  !> The given array must be sorted in ascending order by value (single precision)
  !> @enden
  function indexx_s(arrin) result(indexx)
    implicit none
    real(SP), dimension(:), intent(in)  :: arrin
    integer, allocatable, dimension(:)   :: indexx

    integer :: n, i
    integer, allocatable :: temp(:)

    n = size(arrin)
    allocate(indexx(n), temp(n))

    ! 初期インデックス
    indexx = (/ (i, i=1,n) /)

    call merge_sort(arrin, indexx, temp, 1, n)

  end function indexx_s

  !---------------------------------------------------------------------
  !> merge sort (double precision)
  recursive subroutine merge_sort_d(a, idx, temp, left, right)
    real(DP), dimension(:), intent(in)  :: a
    integer, dimension(:), intent(inout) :: idx
    integer, dimension(:), intent(inout) :: temp
    integer, intent(in) :: left, right

    integer :: mid, i, j, k

    if (left >= right) return

    mid = (left + right) / 2
    call merge_sort_d(a, idx, temp, left, mid)
    call merge_sort_d(a, idx, temp, mid+1, right)

    ! マージ処理
    i = left
    j = mid + 1
    k = left

    ! メイン（両方残っている間だけ比較）
    do while (i <= mid .and. j <= right)
      if (a(idx(i)) <= a(idx(j))) then
        temp(k) = idx(i); i = i + 1
      else
        temp(k) = idx(j); j = j + 1
      end if
      k = k + 1
    end do

    ! tail copy（片側は丸ごと）
    do while (i <= mid)
      temp(k) = idx(i); i = i + 1; k = k + 1
    end do
    do while (j <= right)
      temp(k) = idx(j); j = j + 1; k = k + 1
    end do

    !$omp simd
    do i = left, right
      idx(i) = temp(i)
    end do
  end subroutine merge_sort_d

  !---------------------------------------------------------------------
  !> merge sort (single precision)
  recursive subroutine merge_sort_s(a, idx, temp, left, right)
    real(SP), dimension(:), intent(in)  :: a
    integer, dimension(:), intent(inout) :: idx
    integer, dimension(:), intent(inout) :: temp
    integer, intent(in) :: left, right

    integer :: mid, i, j, k

    if (left >= right) return

    mid = (left + right) / 2
    call merge_sort_s(a, idx, temp, left, mid)
    call merge_sort_s(a, idx, temp, mid+1, right)

    ! マージ処理
    i = left
    j = mid + 1
    k = left

    ! メイン（両方残っている間だけ比較）
    do while (i <= mid .and. j <= right)
      if (a(idx(i)) <= a(idx(j))) then
        temp(k) = idx(i); i = i + 1
      else
        temp(k) = idx(j); j = j + 1
      end if
      k = k + 1
    end do

    ! tail copy（片側は丸ごと）
    do while (i <= mid)
      temp(k) = idx(i); i = i + 1; k = k + 1
    end do
    do while (j <= right)
      temp(k) = idx(j); j = j + 1; k = k + 1
    end do

    !$omp simd
    do i = left, right
      idx(i) = temp(i)
    end do
  end subroutine merge_sort_s
#endif

end module spml_utils

!----------------------------------------------------------------------
!     Copyright (c) 2018--2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム
!
!      トロイダルポロイダル関係微分関数のテスト
!
!履歴  2018/08/09  竹広真一
!      2020/11/11  竹広真一  セクター計算オプション導入
!      2021/11/15  竹広真一  ut_RadRot_RadRotRot テスト追加
!
program ut_mpi_module_derivative_mint_test2

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_mint
  use mpi
  implicit none

!!$  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
!!$  integer,parameter  :: mint=1               ! 経度方向対称性
  integer,parameter  :: im=16, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: mint=2               ! 経度方向対称性
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
!!$  integer,parameter  :: im=16, jm=16, km=32  ! 格子点の設定(経度, 緯度, 動径)
!!$  integer,parameter  :: mint=2               ! 経度方向対称性
!!$  integer,parameter  :: nm=10, lm=32         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv=2

  ! 判定誤差設定
  integer, parameter :: check_digits = 7
  integer, parameter :: ignore = -8

  real(8), allocatable :: ut_Psi(:,:)
  real(8), allocatable :: ut_Phi(:,:)

  real(8), allocatable :: xvh_DData(:,:,:)
  real(8), allocatable :: xvh_Psi(:,:,:)

  real(8), allocatable :: xvh_VLon(:,:,:)
  real(8), allocatable :: xvh_VLat(:,:,:)
  real(8), allocatable :: xvh_VRad(:,:,:)
  real(8), allocatable :: xvh_RadRot(:,:,:)
  real(8), allocatable :: xvh_RadRotRot(:,:,:)

  integer, parameter :: n=2
  integer :: iproc, np, ierr

  !---------------- MPI スタート ---------------------
  !call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_derivative_mint_test2', &
       'ut_mpi_module_mint derivative function test #2')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro,npv=npv,mint=mint)

  allocate(ut_Psi(nmc,0:lm))
  allocate(ut_Phi(nmc,0:lm))

  allocate(xvh_DData(0:im-1,1:jc,kc))
  allocate(xvh_Psi(0:im-1,1:jc,kc))

  allocate(xvh_VLon(0:im-1,1:jc,kc))
  allocate(xvh_VLat(0:im-1,1:jc,kc))
  allocate(xvh_VRad(0:im-1,1:jc,kc))
  allocate(xvh_RadRot(0:im-1,1:jc,kc))
  allocate(xvh_RadRotRot(0:im-1,1:jc,kc))

  !========== ut_RadRot_xvh_xvh, ut_RadRotRot_xvh_xvh_xvh ==========

  !---------- 単純流れ v_r=r ----------
  xvh_VLon = 0 ; xvh_VLat = 0 ; xvh_VRad = xvh_Rad
  xvh_RadRot = 0 ; xvh_RadRotRot = 0

  call AssertEqual(&
       message='ut_RadRot_xvh_xvh with v_r=r',                       &
       answer = xvh_RadRot,                                          &
       check = xvh_ut(ut_RadRot_xvh_xvh(xvh_VLon,xvh_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='ut_RadRotRot_xvh_xvh with v_r=r',                    &
       answer = xvh_RadRotRot,                                       &
       check = xvh_ut(ut_RadRotRot_xvh_xvh_xvh(xvh_VLon,xvh_VLat,xvh_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call ut_RadRot_RadRotRot( &
       xvh_VLon, xvh_VLat, xvh_VRad, ut_Psi, ut_Phi )
  
  call AssertEqual(&
       message='ut_RadRot_RadRotRot_xvh (RadRot) with v_r=r',        &
       answer = xvh_RadRot,                                          &
       check = xvh_ut(ut_Psi),                                       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='ut_RadRot_RadRotRot_xvh (RadRotRot) with v_r=r',     &
       answer = xvh_RadRotRot,                                       &
       check = xvh_ut(ut_Phi),                                       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !---------- 剛体回転解非線形項(東西流れ) ----------
  xvh_VLon = 0
  xvh_VLat = xvh_Rad*sin(xvh_Lat)*cos(xvh_Lat)
  xvh_VRad = -xvh_Rad*cos(xvh_Lat)**2

  xvh_RadRot = 0 ; xvh_RadRotRot = 0

  call AssertEqual(&
       message='ut_RadRot_xvh_xvh with rigid rotation(E-W)',         &
       answer = xvh_RadRot,                                          &
       check = xvh_ut(ut_RadRot_xvh_xvh(xvh_VLon,xvh_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='ut_RadRotRot_xvh_xvh with rigid rotation(E-W)',      &
       answer = xvh_RadRotRot,                                       &
       check = xvh_ut(ut_RadRotRot_xvh_xvh_xvh(xvh_VLon,xvh_VLat,xvh_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call ut_RadRot_RadRotRot( &
       xvh_VLon, xvh_VLat, xvh_VRad, ut_Psi, ut_Phi )
  
  call AssertEqual(&
       message='ut_RadRot_RadRotRot_xvh (RadRot) with rigid rotation(E-W)',        &
       answer = xvh_RadRot,                                          &
       check = xvh_ut(ut_Psi),                                       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='ut_RadRot_RadRotRot_xvh (RadRotRot) with rigid rotation(E-W)',     &
       answer = xvh_RadRotRot,                                       &
       check = xvh_ut(ut_Phi),                                       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

!!$  !---------- 剛体回転解非線形項(南北流れ) ----------
!!$  xvh_VLon = xvh_Rad*cos(xvh_Lat)*sin(xvh_Lon)*cos(xvh_Lon)
!!$  xvh_VLat = -xvh_Rad*sin(xvh_Lat)*cos(xvh_Lat)*sin(xvh_Lon)**2
!!$  xvh_VRad = -xvh_Rad*(sin(xvh_Lat)**2*sin(xvh_Lon)**2 + cos(xvh_Lon)**2)
!!$  xvh_RadRot = 0 ; xvh_RadRotRot = 0
!!$
!!$  call AssertEqual(&
!!$      message='ut_RadRot_xvh_xvh with rigid rotation(N-S)',          &
!!$       answer = xvh_RadRot,                                          &
!!$       check = xvh_ut(ut_RadRot_xvh_xvh(xvh_VLon,xvh_VLat)),         &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  call AssertEqual(&
!!$       message='ut_RadRotRot_xvh_xvh with rigid rotation(N-S)',      &
!!$       answer = xvh_RadRotRot,                                       &
!!$       check = xvh_ut(ut_RadRotRot_xvh_xvh_xvh(xvh_VLon,xvh_VLat,xvh_VRad)), &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
  !--------- 鉛直渦度を伴うベクトル場 ----------
  xvh_Psi = xvh_Rad**3 * cos(xvh_Lat)**2*sin(2*xvh_Lon)   ! r**2 P_2^-2

  xvh_VLon =   xvh_gRadLat_ut(ut_xvh(xvh_Psi*xvh_Rad))
  xvh_VLat = - xvh_gRadLon_ut(ut_xvh(xvh_Psi*xvh_Rad))
  xvh_VRad = 0
  xvh_RadRot = 6 * xvh_Psi                           ! r・▽×▽×(ψr) = L_2ψ
  xvh_RadRotRot = 0

  call AssertEqual(&
      message='ut_RadRot_xvh_xvh with r^2 Y_2^-2 toroidal field',    &
       answer = xvh_RadRot,                                          &
       check = xvh_ut(ut_RadRot_xvh_xvh(xvh_VLon,xvh_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='ut_RadRotRot_xvh_xvh with r^2 Y_2^-2 toroidal field',&
       answer = xvh_RadRotRot,                                       &
       check = xvh_ut(ut_RadRotRot_xvh_xvh_xvh(xvh_VLon,xvh_VLat,xvh_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call ut_RadRot_RadRotRot( &
       xvh_VLon, xvh_VLat, xvh_VRad, ut_Psi, ut_Phi )
  
  call AssertEqual(&
       message='ut_RadRot_RadRotRot_xvh (RadRot) with r^2 Y_2^-2 toroidal field',&
       answer = xvh_RadRot,                                          &
       check = xvh_ut(ut_Psi),                                       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='ut_RadRot_RadRotRot_xvh (RadRotRot) with r^2 Y_2^-2 toroidal field',&
       answer = xvh_RadRotRot,                                       &
       check = xvh_ut(ut_Phi),                                       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !---------- 鉛直速度を伴うベクトル場 -----------
                 ! r・▽×▽×▽×▽×(ψr) = -L_2▽^2ψ
  xvh_VRad = xvh_ut(ut_l2_ut(ut_xvh(xvh_Psi/xvh_Rad)))
  xvh_VLat = xvh_GradLat_ut(ut_DRad_ut(ut_xvh(xvh_Psi*xvh_Rad)))
  xvh_VLon = xvh_GradLon_ut(ut_DRad_ut(ut_xvh(xvh_Psi*xvh_Rad)))

  xvh_RadRot = 0
  xvh_RadRotRot = -xvh_ut(ut_l2_ut(ut_lapla_ut(ut_xvh(xvh_Psi))))
                 ! r・▽×▽×▽×▽×(ψr) = -L_2▽^2ψ

  call AssertEqual(&
      message='ut_RadRot_xvh_xvh with non-vortical field',           &
       answer = xvh_RadRot,                                          &
       check = xvh_ut(ut_RadRot_xvh_xvh(xvh_VLon,xvh_VLat)),         &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='ut_RadRotRot_xvh_xvh with r^2 Y_2^-2 Poloidal field',&
       answer = xvh_RadRotRot,                                       &
       check = xvh_ut(ut_RadRotRot_xvh_xvh_xvh(xvh_VLon,xvh_VLat,xvh_VRad)), &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call ut_RadRot_RadRotRot( &
       xvh_VLon, xvh_VLat, xvh_VRad, ut_Psi, ut_Phi )
  
  call AssertEqual(&
       message='ut_RadRot_RadRotRot_xvh (RadRot) with r^2 Y_2^-2 Poloidal field',&
       answer = xvh_RadRot,                                          &
       check = xvh_ut(ut_Psi),                                       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='ut_RadRot_RadRotRot_xvh (RadRotRot) with r^2 Y_2^-2 Poloidal field',&
       answer = xvh_RadRotRot,                                       &
       check = xvh_ut(ut_Phi),                                       &
       significant_digits = check_digits, ignore_digits = ignore     &
       )


  !========== ut_Potential2Vector, ut_Potential2Rotation ==========

  !----------------- 剛体回転場 --------------------
  !
  ut_Psi = ut_xvh(xvh_Rad * sin(xvh_Lat))
  ut_Phi = 0.0D0

  call ut_Potential2VectorMPI(&
       xvh_VLon,xvh_VLat,xvh_VRad, ut_Psi, ut_Phi )

  xvh_DData = xvh_Rad * cos(xvh_Lat)
  call AssertEqual(&
      message='ut_Potential2VectorMPI (Lon) with rigid rotation field(E-W)', &
       answer = xvh_VLon,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 0.0D0
  call AssertEqual(&
      message='ut_Potential2VectorMPI (Lat) with rigid rotation field(E-W)', &
       answer = xvh_VLat,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 0.0D0
  call AssertEqual(&
      message='ut_Potential2VectorMPI (Rad) with rigid rotation field(E-W)', &
       answer = xvh_VRad,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call ut_Potential2RotationMPI(&
       xvh_VLon,xvh_VLat,xvh_VRad, ut_Psi, ut_Phi )

  xvh_DData = 0.0D0
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Lon) with rigid rotation field(E-W)', &
       answer = xvh_VLon,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 2*cos(xvh_LAT)
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Lat) with rigid rotation field(E-W)', &
       answer = xvh_VLat,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 2*sin(xvh_LAT)
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Rad) with rigid rotation field(E-W)', &
       answer = xvh_VRad,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

!!$  !----------------- 剛体回転場(南北流) --------------------
!!$  !
!!$  ut_Psi = ut_xvh(xvh_Rad * cos(xvh_Lat) * sin(xvh_Lon))
!!$  ut_Phi = 0.0D0
!!$
!!$  call ut_Potential2VectorMPI(&
!!$       xvh_VLon,xvh_VLat,xvh_VRad, ut_Psi, ut_Phi )
!!$
!!$  xvh_DData = -xvh_Rad*sin(xvh_Lat)*sin(xvh_Lon)
!!$  call AssertEqual(&
!!$      message='ut_Potential2VectorMPI (Lon) with rigid rotation field(N-S)', &
!!$       answer = xvh_VLon,                                            &
!!$       check = xvh_DData,                                            &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  xvh_DData = -xvh_Rad*cos(xvh_Lon)
!!$  call AssertEqual(&
!!$      message='ut_Potential2VectorMPI (Lat) with rigid rotation field(N-S)', &
!!$       answer = xvh_VLat,                                            &
!!$       check = xvh_DData,                                            &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  xvh_DData = 0.0D0
!!$  call AssertEqual(&
!!$      message='ut_Potential2VectorMPI (Rad) with rigid rotation field(N-S)', &
!!$       answer = xvh_VRad,                                            &
!!$       check = xvh_DData,                                            &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  call ut_Potential2RotationMPI(&
!!$       xvh_VLon,xvh_VLat,xvh_VRad, ut_Psi, ut_Phi )
!!$
!!$  xvh_DData = 2*cos(xvh_Lon)
!!$  call AssertEqual(&
!!$      message='ut_Potential2RotationMPI (Lon) with rigid rotation field(N-S)', &
!!$       answer = xvh_VLon,                                            &
!!$       check = xvh_DData,                                            &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  xvh_DData = -2*sin(xvh_Lon)*sin(xvh_Lat)
!!$  call AssertEqual(&
!!$      message='ut_Potential2RotationMPI (Lat) with rigid rotation field(N-S)', &
!!$       answer = xvh_VLat,                                            &
!!$       check = xvh_DData,                                            &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$
!!$  xvh_DData = 2*sin(xvh_Lon)*cos(xvh_Lat)
!!$  call AssertEqual(&
!!$      message='ut_Potential2RotationMPI (Rad) with rigid rotation field(N-S)', &
!!$       answer = xvh_VRad,                                            &
!!$       check = xvh_DData,                                            &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )

  ! ----------------- 渦無し場 --------------------
  ut_Psi = 0.0D0
  ut_Phi = ut_xvh(xvh_Rad * sin(xvh_Lat))

  call ut_Potential2VectorMPI(&
       xvh_VLon,xvh_VLat,xvh_VRad, ut_Psi, ut_Phi )

  xvh_DData = 0
  call AssertEqual(&
       message='ut_Potential2VectorMPI (Lon) with non-vortical field',&
       answer = xvh_VLon,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 2 * cos(xvh_Lat)
  call AssertEqual(&
       message='ut_Potential2VectorMPI (Lat) with non-vortical field',&
       answer = xvh_VLat,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 2 * sin(xvh_Lat)
  call AssertEqual(&
      message='ut_Potential2VectorMPI (Rad) with non-vortical field', &
       answer = xvh_VRad,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call ut_Potential2RotationMPI(&
       xvh_VLon,xvh_VLat,xvh_VRad, ut_Psi, ut_Phi )

  xvh_DData = 0.0D0
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Lon) with non-vortical field', &
       answer = xvh_VLon,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 0.0D0
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Lat) with non-vortical field', &
       answer = xvh_VLat,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 0.0D0
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Rad) with non-vortical field', &
       answer = xvh_VRad,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

! ----------------- 例 4 --------------------
 ! ポロイダル速度場

  ut_Psi = 0.0D0
  ut_Phi = ut_xvh(xvh_Rad**3 * cos(xvh_Lat)**2*cos(2*xvh_Lon))

  call ut_Potential2VectorMPI(&
       xvh_VLon,xvh_VLat,xvh_VRad, ut_Psi, ut_Phi )

  xvh_DData = 4*xvh_Rad**2 * cos(xvh_Lat) *(-2)*sin(2*xvh_Lon)
  call AssertEqual(&
      message='ut_Potential2VectorMPI (Lon) with poloidal field',    &
       answer = xvh_VLon,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 4*xvh_Rad**2 * (-2)*cos(xvh_Lat)*sin(xvh_Lat)*cos(2*xvh_Lon)
  call AssertEqual(&
      message='ut_Potential2VectorMPI (Lat) with poloidal field',    &
       answer = xvh_VLat,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 6 * xvh_Rad**2 * cos(xvh_Lat)**2 * cos(2*xvh_Lon)
  call AssertEqual(&
      message='ut_Potential2VectorMPI (Rad) with poloidal field',    &
       answer = xvh_VRad,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call ut_Potential2RotationMPI(&
       xvh_VLon,xvh_VLat,xvh_VRad, ut_Psi, ut_Phi )

  xvh_DData = 6* xvh_Rad * 2*cos(xvh_Lat)*sin(xvh_Lat)*cos(2*xvh_Lon)
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Lon) with poloidal field',  &
       answer = xvh_VLon,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 6* xvh_Rad * cos(xvh_Lat)*(-2)*sin(2*xvh_Lon)
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Lat) with poloidal field',  &
       answer = xvh_VLat,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_DData = 0.0D0
  call AssertEqual(&
      message='ut_Potential2RotationMPI (Rad) with poloidal field',  &
       answer = xvh_VRad,                                            &
       check = xvh_DData,                                            &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','ut_mpi_module_derivative_mint_test2', &
       'ut_mpi_module_mint derivative function test #2 succeeded!')

  !------ MPIの終了 ------
  call MPI_FINALIZE(IERR)

end program ut_mpi_module_derivative_mint_test2

!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_mpi_module テストプログラム (正逆変換)
!
!履歴  2016/08/07  竹広真一
!
program ee_mpi_module_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=64, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=21, lm=10            ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable  :: vx_Data(:,:)         ! 格子データ
  real(8), allocatable  :: ef_Data(:,:)         ! スペクトルデータ
  real(8), allocatable  :: ef_Data1(:,:)        ! スペクトルデータ

  integer            :: k=2,l=5
  integer            :: np, ip, ierr

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  
  call MessageNotify('M','ee_mpi_module_base_test', &
       'ee_mpi_module basic function tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
 
 !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_Data(js(ip):je(ip),0:im-1))
  allocate(ef_Data(-lm:lm,2*kc(ip)))
  allocate(ef_Data1(-lm:lm,2*kc(ip)))
  
 !------------------- 初期値設定 ----------------------
  vx_Data = sin(k*pi*vx_X) * sin(2*l*pi*vx_Y)
  ef_Data = 0.0
  if ( kf_k(k) > 0 ) then
     ef_Data(-l,kf_k(k)) = 0.25  ; ef_Data(l,kf_k(k)) = -0.25
  endif
  call check(ef_vx(vx_Data), ef_Data, &
       'Transform sin(k*pi*X)*sin(2*l*pi*Y)')
  call check(ef_vx(vx_Data), ef_Data, &
       'Transform sin(k*pi*X)*sin(2*l*pi*Y)')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, &
       'Inverse transform sin(k*pi*X)*sin(2*l*pi*Y)')

  vx_Data = cos(k*pi*vx_X) * cos(2*l*pi*vx_Y)
  ef_Data = 0.0
  if ( kf_k(k) > 0 ) then
     ef_Data(l,kf_k(k)) = 0.25  ; ef_Data(-l,kf_k(k)) = 0.25
  endif
  call check(ef_vx(vx_Data), ef_Data, &
       'Transform cos(k*pi*X)*cos(2*l*pi*Y)')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, &
       'Inverse transoform cos(k*pi*X)*cos(2*l*pi*Y)')

  vx_Data = sin(k*pi*vx_X) * cos(2*l*pi*vx_Y)
  ef_Data = 0.0
  if ( kf_k(k) > 0 ) then
     ef_Data(-l,kf_k(-k)) = -0.25  ; ef_Data(l,kf_k(-k)) = - 0.25
  endif
  call check(ef_vx(vx_Data), ef_Data, &
       'Transform sin(k*pi*X)*cos(2*l*pi*Y)')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, &
       'Inverse transform sin(k*pi*X)*cos(2*l*pi*Y)')

  vx_Data = cos(k*pi*vx_X) * sin(2*l*pi*vx_Y)
  ef_Data = 0.0
  if ( kf_k(k) > 0 ) then
     ef_Data(-l,kf_k(-k)) = -0.25  ; ef_Data(l,kf_k(-k)) = 0.25
  endif
  call check(ef_vx(vx_Data), ef_Data, &
       'Transform cos(k*pi*X)*sin(2*l*pi*Y)')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, &
       'Inverse transform cos(k*pi*X)*sin(2*l*pi*Y)')

  !------ l=0 モード ------
  vx_Data = sin(k*pi*vx_X)
  ef_Data = 0.0
  if ( kf_k(-k) > 0 ) then
     ef_Data(0,kf_k(-k)) = -0.5
  endif
  call check(ef_vx(vx_Data), ef_Data, 'Transform sin(k*pi*X)')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, 'Inverse transform sin(k*pi*X)')

  vx_Data = cos(k*pi*vx_X)
  ef_Data = 0.0
  if ( kf_k(k) > 0 ) then
     ef_Data(0,kf_k(k)) = 0.5
  endif
  call check(ef_vx(vx_Data), ef_Data, 'Transform cos(k*pi*X)')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, 'Inverse transform cos(k*pi*X)')
  
  !------ k=0 モード ------
  vx_Data = sin(2*l*pi*vx_Y)
  ef_Data = 0.0
  if ( kf_k(0) > 0 ) then
     ef_Data(-l,kf_k(0)) = -0.5
  endif
  call check(ef_vx(vx_Data), ef_Data, 'Transform sin(2*l*pi*Y)')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, 'Inverse transform sin(2*l*pi*Y)')

  vx_Data = cos(2*l*pi*vx_Y)
  ef_Data = 0.0
  if ( kf_k(0) > 0 ) then
     ef_Data(l,kf_k(0)) = 0.5
  endif
  ef_Data1 = ef_vx(vx_Data)

  call check(ef_vx(vx_Data), ef_Data, 'Transform cos(2*l*pi*Y)')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, 'Inverse transform cos(2*l*pi*Y)')

  !------ k=l=0 モード ------
  vx_Data = 1.0D0
  ef_Data = 0.0
  if ( kf_k(0) > 0 ) then
     ef_Data(0,kf_k(0)) = 1.0
  endif
  call check(ef_vx(vx_Data), ef_Data, 'Transform constatn field')
  call check(vx_ef(ef_vx(vx_Data)), vx_Data, 'Inverse transform constant field')

  call MPI_FINALIZE(IERR)
 
  call MessageNotify('M','ee_test_transform', &
       'ee_module transform function tests succeeded!')
contains

  subroutine check(var,sol,funcname)
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)                ! 誤差
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check

end program ee_mpi_module_base_test

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2018/06/08  竹広真一
!
program ut_mpi_module_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv=2

  real(8), allocatable :: ut_data(:,:)
  real(8), allocatable :: wt_data(:,:)
  real(8), allocatable :: wh_data(:,:)
  real(8), allocatable :: wz_data(:,:)
  real(8), allocatable :: xvh_data(:,:,:)
  real(8), allocatable :: xvh_xi(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

  !---------------- MPI スタート ---------------------
  ! call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','ut_mpi_module_test_base', &
                         'ut_mpi_module basic transformation functions tests')

  call ut_mpi_Initial(im,jm,km,nm,lm,ri,ro,npv=npv)

  allocate(ut_data(nmc,0:lm))
  allocate(wt_data(nc,0:lm))
  allocate(wz_data(nc,0:km))
  allocate(wh_data(nc,kc))
  allocate(xvh_data(0:im-1,jc,kc))
  allocate(xvh_xi(0:im-1,jc,kc))

  xvh_xi = (xvh_Rad - (ro+ri)/2 )*2/(ro-ri)

  !---- Y_1^* のテスト ----
  xvh_data = sqrt(3.0D0)*sin(xvh_Lat)*xvh_xi         ! Y_1^0 T_1
  wt_data= 0.0D0 ; if (l_nm(1,0).ne.0) wt_data(l_nm(1,0),1)=1.0D0
  wz_data= 0.0D0 ; if (l_nm(1,0).ne.0) wz_data(l_nm(1,0),:)=(z_Rad - (ro+ri)/2 )*2/(ro-ri)
  wh_data = 0.0D0 ; if (l_nm(1,0).ne.0) wh_data(l_nm(1,0),:)=(h_Rad - (ro+ri)/2 )*2/(ro-ri)

  ut_data = 0.0D0
  if ( lu_nm(1,0) .ne. 0 ) ut_data(lu_nm(1,0),1) = 1.0D0

  call AssertEqual(&
    message='ut_wt with Y_1^0 T_1',                               &
    answer = ut_data,                                             &
    check = ut_wt(wt_data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wt_ut with Y_1^0 T_1',                               &
    answer = wt_data,                                             &
    check = wt_ut(ut_data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='ut_wh with Y_1^0 T_1',                               &
    answer = ut_data,                                             &
    check = ut_wh(wh_data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='wh_ut with Y_1^0 T_1',                               &
    answer = wh_data,                                             &
    check = wh_ut(ut_data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='ut_xvh with Y_1^0 T_1',                              &
    answer = ut_data,                                             &
    check = ut_xvh(xvh_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvh_ut with Y_1^0 T_1',                              &
    answer = xvh_data,                                            &
    check = xvh_ut(ut_data),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvh_data = -sqrt(3.0D0/2)*cos(xvh_Lat)*sin(xvh_Lon)*(2*xvh_xi**2-1) !Y_1^{-1}T_2
  ut_data= 0.0D0 ; if(lu_nm(1,-1).ne.0) ut_data(lu_nm(1,-1),2)=1.0D0/2.0D0

  call AssertEqual(&
    message='ut_xvh with Y_1^-1 T_2',                             &
    answer = ut_data,                                             &
    check = ut_xvh(xvh_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvh_ut with Y_1^-1 T_2',                             &
    answer = xvh_data,                                            &
    check = xvh_ut(ut_xvh(xvh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  ! Y_2^0 T_3
  xvh_data = sqrt(5.0D0)*(3.0/2*sin(xvh_Lat)**2-1/2.0)*(4*xvh_xi**3-3*xvh_xi)
  ut_data= 0.0D0 ; if(lu_nm(2,0).ne.0) ut_data(lu_nm(2,0),3)=1.0D0

  call AssertEqual(&
    message='ut_xvh with Y_2^0 T_3',                              &
    answer = ut_data,                                             &
    check = ut_xvh(xvh_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvh_ut with Y_2^0 T_3',                              &
    answer = xvh_data,                                            &
    check = xvh_ut(ut_xvh(xvh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !Y_2^1 T_4
  xvh_data = sqrt(5.0D0/6)*3.0*sin(xvh_Lat)*cos(xvh_Lat)*cos(xvh_Lon) &
            *(8*xvh_xi**4 - 8*xvh_xi**2 + 1 )
  ut_data= 0.0D0 ; if (lu_nm(2,1).ne.0) ut_data(lu_nm(2,1),4)=1.0D0/2.0D0

  call AssertEqual(&
    message='ut_xvh with Y_2^1 T_4',                              &
    answer = ut_data,                                             &
    check = ut_xvh(xvh_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvh_ut with Y_2^1 T_4',                              &
    answer = xvh_data,                                            &
    check = xvh_ut(ut_xvh(xvh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! Y_2^-2
  xvh_data = -sqrt(5.0D0/24)*3.0*cos(xvh_Lat)**2*sin(2*xvh_Lon) &
            *(16*xvh_xi**5-20*xvh_xi**3+5*xvh_xi)
  ut_data= 0.0D0 ; if(lu_nm(2,-2).ne.0) ut_data(lu_nm(2,-2),5)=1.0D0/2.0D0

  call AssertEqual(&
    message='ut_xvh with Y_2^-2 T_5',                             &
    answer = ut_data,                                             &
    check = ut_xvh(xvh_data),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xvh_ut with Y_2^-2 T_5',                             &
    answer = xvh_data,                                            &
    check = xvh_ut(ut_xvh(xvh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xvh_data = cos(2*xvh_Lon-pi/3) &
       *(sin(xvh_Lat)-1)**2*(sin(xvh_Lat)-0.5)*(sin(xvh_Lat)+1) &
       *exp(xvh_Rad)

  call AssertEqual(&
    message='xvh_ut and ut_xvh with a general function',          &
    answer = xvh_data,                                            &
    check = xvh_ut(ut_xvh(xvh_data)),                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ut_mpi_module_test_base', &
                         'ut_mpi_module basic functions tests succeeded!')

  !------ MPIの終了 ------
  call MPI_FINALIZE(IERR)


end program ut_mpi_module_base_test

! -*- mode: f90; coding: utf-8 -*-
!----------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2016/03/09  竹広真一
!       2019/10/04  佐々木洋平
!       2019/10/09  佐々木洋平
!       2020/11/06  竹広真一   セクター計算オプション導入
!----------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief 2次元球面: 球面調和関数展開
!>
!> @details
!> spml/w_module モジュールは球面上での 2 次元流体運動を
!> 球面調和函数を用いたスペクトル法によって数値計算するための
!> Fortran90 関数を提供する.
!> w_module は実際には以下の下部モジュールからなる．
!> * w_module_base: 基本変換
!> * w_module_deriv: 微分計算
!> * w_module_integral: 積分・平均計算
!> * w_module_spectrum: スペクトル解析
!> * w_module_interpolate: 補間計算
!>
!> 内部で ISPACK3 の SXPACKサブルーチンを呼んでいる. スペクトルデータお
!> よび格子点データの格納方法や変換の詳しい計算法については
!> ISPACK3/SXPACK のマニュアルを参照されたい.
!>
!> @warning
!> 後方非互換である点に注意されたい
!> * 旧版と異なり (ISPACK/SXPACKのレベルで) 球面調和関数の正規化が異なる．
!> * 旧版と異なり,
!>   [l_nm](@ref w_module_base#l_nm),
!>   [nm_l](@ref w_module_base#nm_l)
!>   は初期化したのちにしか使うことができない.
!>
!> ## 関数・変数の名前と型について
!>
!> ### 命名法
!>
!>  * 関数名の先頭 (`w_`, `nm_`, `n_`, `xy_`, `x_`, `y_`) は,
!>  返す値の形を示している.
!>    * `w_`  : スペクトルデータ
!>    * `xy_` : 2 次元格子点データ
!>    * `nm_` : スペクトルデータの並んだ 3 次元配列
!>    * `n_`  : スペクトルデータの並んだ 2 次元配列
!>    * `x_`  : 経度方向 1 次元格子点データ
!>    * `y_`  : 緯度方向 1 次元格子点データ
!>
!>  * 関数名の間の文字列(`DLon`, `GradLat`, `GradLat`, `DivLon`, `DivLat`,
!>    `Lapla`, `LaplaInv`, `Jacobian`)は, その関数の作用を表している.
!>
!>  * 関数名の最後 (`_w_w`, `_w`, `_xy`, `_x`, `_y`) は,
!>    入力変数の形スペクトルデータおよび格子点データであることを示している.
!>    * `_w`   :: スペクトルデータ
!>    * `_w_w` :: 2 つのスペクトルデータ
!>    * `_xy`  :: 2 次元格子点データ
!>    * `_x`   :: 経度方向 1 次元格子点データ
!>    * `_y`   :: 緯度方向 1 次元格子点データ
!>
!> ### 各データの種類の説明
!>
!>  * 以下, `DP = kind(1.0D0)`
!>  * `xy` : 2 次元格子点データ.
!>    * 変数の種類と次元は `real(DP), dimension(0:im-1,1:jm)`.
!>    * `im`, `jm` はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
!>      [w_Initial](@ref w_initial) にてあらかじめ設定しておく.
!>
!>  * `w` : スペクトルデータ.
!>    * 変数の種類と次元は `real(DP), dimension((nm+1)*(nm+1))`.
!>    * nm は球面調和函数の最大全波数であり, サブルーチン w_Initial にて
!>      あらかじめ設定しておく.
!>    * スペクトルデータの格納のされ方は関数
!>      [l_nm](@ref w_module_base#l_nm),
!>      [nm_l](@ref w_module_base#nm_l) によって
!>      調べることができる.
!>
!>  * `nm` : スペクトルデータの並んだ 2 次元配列.
!>    * 変数の種類と次元は `real(DP), dimension(0:nm,-nm:nm)`.
!>      第 1 次元が水平全波数,  第 2 次元が帯状波数を表す.
!>    * `nm` は球面調和函数の最大全波数であり,
!>      サブルーチン [w_Initial](@ref w_initial)
!>      にてあらかじめ設定しておく.
!>
!>  * `n` : スペクトルデータの並んだ 1 次元配列.
!>    * 変数の種類と次元は `real(DP), dimension(0:nm)`.
!>    * 第 1 次元が水平全波数を表す. nm は球面調和函数の最大全波数であり,
!>      サブルーチン [w_Initial](@ref w_initial)
!>      にてあらかじめ設定しておく.
!>
!>  * `x`, `y` : 経度, 緯度方向 1 次元格子点データ.
!>    * 変数の種類と次元はそれぞれ `real(DP), dimension(0:im-1)`
!>      および `real(DP), dimension(1:jm)`.
!>
!>  * `w_` で始まる関数が返す値はスペクトルデータに同じ.
!>
!>  * `xy_` で始まる関数が返す値は 2 次元格子点データに同じ.
!>
!>  * `x_`, `y_` で始まる関数が返す値は 1 次元格子点データに同じ.
!>
!>  * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
!>    微分などを作用させたデータをスペクトル変換したものことである.
!>
!> ## 変数・手続き群の要約
!>
!> ### 初期化, 終了処理
!>
!> w_module_base にて定義
!>
!> * [w_Initial]
!>   (@ref w_initial)
!>   : スペクトル変換の格子点数, 波数, 領域の大きさの設定
!> * [w_Finalize]
!>   (@ref w_finalize)
!>   : モジュールの終了処理(割り付け配列の解放)をおこなう.
!>
!> ### 座標変数
!>
!> * [x_Lon]
!>   (@ref w_module_base#x_lon)
!>   : 経度座標格子点を格納した 1 次元配列
!> * [y_Lat]
!>   (@ref w_module_base#y_lat)
!>   : 緯度座標格子点を格納した 1 次元配列
!> * [x_Lon_Weight]
!>   (@ref w_module_base#x_lon_weight)
!>   : 重み座標を格納した 1 次元配列
!> * [y_Lat_Weight]
!>   (@ref w_module_base#y_lat_weight)
!>   : 重み座標を格納した 1 次元配列
!> * [xy_Lon]
!>   (@ref w_module_base#xy_lon)
!>   : 経度座標(X,Y)の格子点データ(2 次元配列)
!> * [xy_Lat]
!>   (@ref w_module_base#xy_lat)
!>   : 緯度座標(X,Y)の格子点データ(2 次元配列)
!>
!> ### 基本変換
!>
!> * [xy_w]
!>   (@ref w_module_base#xy_w)
!>   : スペクトルデータから格子データへの変換
!> * [w_xy]
!>   (@ref w_module_base#w_xy)
!>   : 格子データからスペクトルデータへの変換
!> * [l_nm]
!>   (@ref w_module_base#l_nm),
!>   [nm_l]
!>   (@ref w_module_base#nm_l)
!>   : スペクトルデータの格納位置と全波数・帯状波数の変換
!> * [w_StreamPotential2Vector]
!>   (@ref w_module_base#w_streampotential2vector)
!>   : 流線ポテンシャルから速度場計算
!> * [w_Vector2VorDiv]
!>   (@ref w_module_base#w_vector2vordiv)
!>   : 速度場から渦度発散を計算
!> * [w_VectorCosLat2VorDiv]
!>   (@ref w_module_base#w_vectorcoslat2vordiv)
!>   : 速度場から渦度発散を計算
!>
!> ### 微分
!>
!> w_module_deriv にて定義
!>
!> * [w_Lapla_w]
!>   (@ref w_module_deriv#w_lapla_w)
!>   : スペクトルデータにラプラシアンを作用させる
!> * [rn]
!>   (@ref w_module_deriv#rn)
!>   : スペクトルデータのラプラシアンを計算するための係数.
!> * [w_LaplaInv_w]
!>   (@ref w_module_deriv#w_laplainv_w)
!>   : スペクトルデータにラプラシアンの逆変換を作用させる
!> * [w_DLon_w]
!>   (@ref w_module_deriv#w_dlon_w)
!>   : スペクトルデータに経度微分\f$∂/∂λ\f$を作用させる
!> * [xy_GradLon_w]
!>   (@ref w_module_deriv#xy_gradlon_w)
!>   : スペクトルデータに勾配型経度微分
!>   \f$1/\cosφ・∂/∂λ\f$を作用させる
!> * [xy_GradLat_w]
!>   (@ref w_module_deriv#xy_gradlat_w)
!>   : スペクトルデータに勾配型緯度微分\f$∂/∂φ\f$を作用させる
!> * [w_DivLon_xy]
!>   (@ref w_module_deriv#w_divlon_xy)
!>   : 格子データに発散型経度微分
!>   \f$1/\cosφ・∂/∂λ\f$を作用させる
!> * [w_DivLat_xy]
!>   (@ref w_module_deriv#w_divlat_xy)
!>   : 格子データに発散型緯度微分
!>   \f$1/\cosφ・∂(g \cosφ)/∂φ\f$を作用させる
!> * [w_Div_xy_xy]
!>   (@ref w_module_deriv#w_div_xy_xy)
!>   : ベクトル成分である 2 つの格子データに発散を作用させる
!> * [w_Jacobian_w_w]
!>   (@ref w_module_deriv#w_jacobian_w_w)
!>   : 2 つのスペクトルデータからヤコビアンを計算する
!>
!>  \f$(λ,μ)\f$ 座標 \f$(μ=\sinφ)\f$ での微分
!>
!> * [xy_GradLambda_w]
!>   (@ref w_module_deriv#xy_gradlambda_w)
!>   : スペクトルデータに勾配型経度微分\f$∂/∂λ\f$を作用させる
!> * [xy_GradMu_w]
!>   (@ref w_module_deriv#xy_gradmu_w)
!>   : スペクトルデータに勾配型緯度微分\f$(1-μ^2)∂/∂μ\f$を作用させる
!> * [w_DivLambda_xy]
!>   (@ref w_module_deriv#w_divlambda_xy)
!>   : 格子データに発散型経度微分\f$1/(1-μ^2)・∂/∂λ\f$を作用させる
!> * [w_DivMu_xy]
!>   (@ref w_module_deriv#w_divmu_xy)
!>   : 格子データに発散型緯度微分\f$∂/∂μ\f$を作用させる
!>
!> ### 補間
!>
!> w_module_interpolate にて定義
!>
!> * [Interpolate_w]
!>   (@ref w_module_interpolate#interpolate_w)
!>   : スペクトルデータから任意の点での値を求める.
!>
!> ### 積分・平均
!>
!> w_module_integral にて定義
!>
!> * [IntLonLat_xy]
!>   (@ref w_module_integral#intlonlat_xy)
!>   : 2 次元格子点データの全領域積分
!> * [AvrLonLat_xy]
!>   (@ref w_module_integral#avrlonlat_xy)
!>   : 2 次元格子点データの全領域平均
!> * [y_IntLon_xy]
!>   (@ref w_module_integral#y_intlon_xy)
!>   : 2 次元格子点データの経度方向積分
!> * [y_AvrLon_xy]
!>   (@ref w_module_integral#y_avrlon_xy)
!>   : 2 次元格子点データの経度方向平均
!> * [IntLon_x]
!>   (@ref w_module_integral#intlon_x)
!>   : 1 次元(X)格子点データの経度方向積分
!> * [AvrLon_x]
!>   (@ref w_module_integral#avrlon_x)
!>   : 1 次元(X)格子点データの経度方向平均
!> * [x_IntLat_xy]
!>   (@ref w_module_integral#x_intlat_xy)
!>   : 2 次元格子点データの緯度方向積分
!> * [x_AvrLat_xy]
!>   (@ref w_module_integral#x_avrlat_xy)
!>   : 2 次元格子点データの緯度方向平均
!> * [IntLat_y]
!>   (@ref w_module_integral#intlat_y)
!>   : 1 次元(Y)格子点データの緯度方向積分
!> * [AvrLat_y]
!>   (@ref w_module_integral#avrlat_y)
!>   : 1 次元(Y)格子点データの緯度方向平均
!>
!> ### スペクトル解析
!>
!> w_module_spectrum にて定義
!>
!> * [nm_EnergyFromStreamfunc_w]
!>   (@ref w_module_spectrum#nm_energyfromstreamfunc_w)
!>   : 流線関数からエネルギースペクトルを計算する(水平全波数 n, 帯状波数 m 空間)
!> * [n_EnergyFromStreamfunc_w]
!>   (@ref w_module_spectrum#n_energyfromstreamfunc_w)
!>   : 流線関数からエネルギースペクトルを計算する(水平全波数 n 空間)
!> * [nm_EnstrophyFromStreamfunc_w]
!>   (@ref w_module_spectrum#nm_enstrophyfromstreamfunc_w)
!>   : 流線関数からエンストロフィースペクトルを計算する (水平全波数 n, 帯状波数 m 空間)
!> * [n_EnstrophyFromStreamfunc_w]
!>   (@ref w_module_spectrum#n_enstrophyfromstreamfunc_w)
!>   : 流線関数からエンストロフィースペクトルを計算する (水平全波数 n 空間)
!> * [w_spectrum_VMiss]
!>   (@ref w_module_spectrum#w_spectrum_vmiss)
!>   :  欠損値
!>
module w_module_mint
  use dc_message, only : MessageNotify
  use w_module_base_mint, only :    &
    & x_Lon, y_Lat,                 &
    & x_Lon_weight, y_Lat_Weight,   &
    & xy_Lon, xy_Lat,               &
    & xy_w, w_xy, l_nm, nm_l,       &
    & w_StreamPotential2Vector,     &
    & w_Vector2VorDiv,              &
    & w_VectorCosLat2VorDiv,        &
    & w_base_initial,               &
    & w_base_finalize
  use w_module_deriv_mint, only:    &
    & w_Lapla_w, w_LaplaInv_w,      &
    & rn,                           &
    & w_DLon_w,                     &
    & xy_GradLon_w, xy_GradLat_w,   &
    & w_DivLon_xy, w_DivLat_xy,     &
    & w_Div_xy_xy,                  &
    & w_Jacobian_w_w,               &
    & xy_GradLambda_w, xy_GradMu_w, &
    & w_DivLambda_xy, w_DivMu_xy,   &
    & w_deriv_initial,              &
    & w_deriv_Finalize
  use w_module_integral_mint, only: &
    & IntLonLat_xy,                 &
    & y_IntLon_xy, IntLon_x,        &
    & x_IntLat_xy, IntLat_y,        &
    & AvrLonLat_xy,                 &
    & y_AvrLon_xy, AvrLon_x,        &
    & x_AvrLat_xy, AvrLat_y
  use w_module_spectrum_mint, only: &
    & nm_EnergyFromStreamfunc_w,    &
    & n_EnergyFromStreamfunc_w,     &
    & nm_EnstrophyFromStreamfunc_w, &
    & n_EnstrophyFromStreamfunc_w,  &
    & w_spectrum_VMiss
  use w_module_interpolate_mint, only:  &
    & Interpolate_w

  private
  public w_Initial
  public w_Finalize
  ! w_base_module
  public x_Lon
  public y_Lat
  public x_Lon_weight
  public y_Lat_Weight
  public xy_Lon
  public xy_Lat
  public xy_w
  public w_xy
  public l_nm
  public nm_l
  public w_StreamPotential2Vector
  public w_Vector2VorDiv
  public w_VectorCosLat2VorDiv
  ! w_derive_module
  public w_Lapla_w
  public w_LaplaInv_w
  public rn
  public w_DLon_w
  public xy_GradLon_w
  public xy_GradLat_w
  public w_DivLon_xy
  public w_DivLat_xy
  public w_Div_xy_xy
  public w_Jacobian_w_w
  public xy_GradLambda_w
  public xy_GradMu_w
  public w_DivLambda_xy
  public w_DivMu_xy
  ! w_integral_module
  public IntLonLat_xy
  public y_IntLon_xy
  public IntLon_x
  public x_IntLat_xy
  public IntLat_y
  public AvrLonLat_xy
  public y_AvrLon_xy
  public AvrLon_x
  public x_AvrLat_xy
  public AvrLat_y
  ! w_spectrum_module
  public nm_EnergyFromStreamfunc_w
  public n_EnergyFromStreamfunc_w
  public nm_EnstrophyFromStreamfunc_w
  public n_EnstrophyFromStreamfunc_w
  public w_spectrum_VMiss
  ! w_interpolate_module
  public Interpolate_w
contains

  !---------------------------------------------------------------------
  !> @brief
  !> スペクトル変換の格子点数, 波数および OPENMP 使用時の
  !> 最大スレッド数を設定する.
  !>
  !> @details
  !> 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
  !> しなければならない.
  !>
  !> np_in に 1 より大きな値を指定すれば ISPACK の球面調和函数変換
  !> OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには,
  !> 実行時に環境変数 OMP_NUM_THREADS を np_in 以下の数字に設定する等の
  !> システムに応じた準備が必要となる.
  !>
  !> np_in に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
  !>
  subroutine w_initial(n_in,i_in,j_in,np,mint)
    !> 格子点数(東西)
    integer,intent(in) :: i_in
    !> 格子点数(南北)
    integer,intent(in) :: j_in
    !> 切断波数の設定
    integer,intent(in) :: n_in
    !> OPENMP での最大スレッド数
    integer,intent(in), optional :: np
    !> 経度方向対称性
    integer,intent(in), optional :: mint

    if ( present (np) ) then
      call MessageNotify('M','w_Initial', &
        & 'Optional argnument np is dummy.')
    endif

    if ( present (mint) ) then
       call w_base_initial(n_in,i_in,j_in,mint=mint)
    else
       call w_base_initial(n_in,i_in,j_in)
    endif
    call w_deriv_initial

    call MessageNotify('M','w_initial',&
      'w_module_mint (2020/11/18) is initialized')

  end subroutine w_initial

  !---------------------------------------------------------------------
  !> @brief
  !> モジュールの終了処理(割り付け配列の解放)をおこなう.
  !>
  !> @warning
  !> 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
  !> おこなったのちに再度 w_Initial で初期設定しなければ
  !> ならない.
  !>
  subroutine w_Finalize
    call w_base_Finalize
    call w_deriv_Finalize

    call MessageNotify('M','w_Finalize',&
      'w_module_mint (2020/11/18) is finalized')

  end subroutine w_Finalize

end module w_module_mint

! -*- mode: f90; coding: utf-8 -*-
!-------------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2019/03/13  竹広真一
!       2019/10/04  佐々木洋平
!-------------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief
!> @ref w_module の下部モジュール: 積分・平均
!>
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは @ref w_module を呼ぶこと．
!>
module w_module_integral
  use dc_types, only: DP
  use w_module_base, only : im, jm, x_Lon_Weight, y_Lat_Weight
  implicit none
  private
  public IntLonLat_xy
  public y_IntLon_xy
  public IntLon_x
  public x_IntLat_xy
  public IntLat_y
  public AvrLonLat_xy
  public y_AvrLon_xy
  public AvrLon_x
  public x_AvrLat_xy
  public AvrLat_y

contains

  !---------------------------------------------------------------------
  !> 1 次元緯度(Y)格子点データの Y 方向積分(1 層用).
  function IntLat_y(y_data)
    !> 1 次元緯度(Y)格子点データ
    real(DP), intent(in) :: y_data(1:jm)
    !> 積分値
    real(DP)             :: IntLat_y

    IntLat_y = sum(y_data * y_Lat_weight)

  end function IntLat_y

  !---------------------------------------------------------------------
  !> 1 次元経度(X)格子点データの X 方向積分(1 層用).
  function IntLon_x(x_data)
    !> 1 次元経度(X)格子点データ
    real(DP), intent(in) :: x_data(0:im-1)
    !> 積分値
    real(DP)             :: IntLon_x

    IntLon_x = sum(x_data * x_Lon_weight)

  end function IntLon_x

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの緯度(Y)方向積分(1 層用).
  function x_IntLat_xy(xy_data)
    !> 2 次元経度緯度格子点データ(0:im-1,1:jm)
    real(DP), intent(in) :: xy_data(0:im-1,1:jm)
    !> 積分された 1 次元経度(X)格子点データ
    real(DP)             :: x_IntLat_xy(0:im-1)

    integer(8) :: j

    x_IntLat_xy = 0.0D0
    do j=1,jm
      x_IntLat_xy = x_IntLat_xy + xy_data(:,j) * y_Lat_weight(j)
    enddo

  end function x_IntLat_xy

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの経度(X)方向積分(1 層用).
  function y_IntLon_xy(xy_data)
    !> 2 次元経度緯度格子点データ(0:im-1,1:jm)
    real(DP), intent(in) :: xy_data(0:im-1,1:jm)
    !> 積分された 1 次元緯度(Y)格子点データ
    real(DP)             :: y_IntLon_xy(1:jm)

    integer(8) :: i

    y_IntLon_xy = 0.0D0
    do i=0,im-1
      y_IntLon_xy = y_IntLon_xy + xy_data(i,:) * x_Lon_weight(i)
    enddo

  end function y_IntLon_xy

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの全領域積分(1 層用).
  function IntLonLat_xy(xy_data)
    !> 2 次元経度緯度格子点データ(0:im-1,1:jm)
    real(DP), intent(in)   :: xy_data(0:im-1,1:jm)
    !> 積分値
    real(DP) :: IntLonLat_xy

    IntLonLat_xy = IntLon_x(x_IntLat_xy(xy_data))

  end function IntLonLat_xy

  !---------------------------------------------------------------------
  !> 1 次元(Y)格子点データの緯度(Y)方向平均(1 層用).
  function AvrLat_y(y_data)
    !>  1 次元緯度格子点データ
    real(DP), intent(in) :: y_data(1:jm)
    !> 平均値
    real(DP)             :: AvrLat_y

    AvrLat_y = IntLat_y(y_data)/sum(y_Lat_weight)

  end function AvrLat_y

  !---------------------------------------------------------------------
  !> 1 次元(X)格子点データの経度(X)方向平均(1 層用).
  function AvrLon_x(x_data)
    !>  1 次元経度(X)格子点データ
    real(DP), intent(in) :: x_data(0:im-1)
    !> 平均値
    real(DP)             :: AvrLon_x

    AvrLon_x = IntLon_x(x_data)/sum(x_Lon_weight)

  end function AvrLon_x

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの緯度(Y)方向平均(1 層用).
  function x_AvrLat_xy(xy_data)
    !> 2 次元経度緯度格子点データ(0:im-1,1:jm)
    real(DP), intent(in) :: xy_data(0:im-1,1:jm)
    !> 平均された 1 次元経度(X)格子点データ
    real(DP)             :: x_AvrLat_xy(im)

    x_AvrLat_xy = x_IntLat_xy(xy_data)/sum(y_Lat_weight)

  end function x_AvrLat_xy

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの経度(X)方向平均(1 層用).
  function y_AvrLon_xy(xy_data)
    !> 2 次元経度緯度格子点データ(0:im-1,1:jm)
    real(DP), intent(in) :: xy_data(0:im-1,1:jm)
    !> 平均された 1 次元緯度(Y)格子点
    real(DP)             :: y_AvrLon_xy(1:jm)

    y_AvrLon_xy = y_IntLon_xy(xy_data)/sum(x_Lon_weight)

  end function y_AvrLon_xy

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの全領域平均(1 層用).
  function AvrLonLat_xy(xy_data)
    !> 2 次元経度緯度格子点データ
    real(DP), intent(in)   :: xy_data(0:im-1,1:jm)
    !> 平均値
    real(DP) :: AvrLonLat_xy

    AvrLonLat_xy = AvrLon_x(x_AvrLat_xy(xy_data))

  end function AvrLonLat_xy


end module w_module_integral

!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_interpolate_module テストプログラム :: 補間関数のテスト
!
!履歴  2020/08/04  竹広真一
!      2020/11/10  竹広真一  セクター計算オプション導入
!
program ua_mpi_module_interpolate_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_mint
  use mpi
  implicit none

!!$  integer, parameter :: im=32, jm=16, nm=10, km=3, npv=2, mint=1
  integer, parameter :: im=32, jm=16, nm=10, km=3, npv=2, mint=2

  real(8), allocatable :: pva_data(:,:,:)
  real(8), allocatable :: ua_data(:,:)
  real(8), allocatable :: wb_data(:,:)
  real(8), allocatable :: b_data_sol(:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call ua_mpi_Initial( nm, im, jm, km, npv=npv, mint=mint )

  call MessageNotify('M','ua_mpi_module_Interpolate_mint_test', &
                         'ua_mpi_module_mint interpolate (00) tests')

  allocate(pva_data(ic,jc,km))
  allocate(ua_data(nmc,km))
  allocate(wb_data(nc,kc))
  allocate(b_data_sol(kc))

  !---- Y_1^* のテスト ----
  pva_data(:,:,1) = sin(pv_Lat)                              ! Y_1^0
  pva_data(:,:,2) = 3.0D0/2.0D0*sin(pv_Lat)**2 - 1.0D0/2.0D0 ! Y_2^0
  pva_data(:,:,3) = -cos(pv_Lat)**2*sin(2*pv_Lon)            ! Y_2^-2

  if ( kp_kl(1) /= 0 ) b_data_sol(kp_kl(1)) = sin(ALat)
  if ( kp_kl(2) /= 0 ) b_data_sol(kp_kl(2)) = 3.0D0/2.0D0*sin(ALat)**2-1.0D0/2.0D0
  if ( kp_kl(3) /= 0 ) b_data_sol(kp_kl(3)) = -cos(ALat)**2*sin(2*ALon)

  ua_data = ua_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_ua with Y_1^*',                        &
    answer = b_Interpolate_ua(ua_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  wb_data = wb_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_wb with Y_1^*',                        &
    answer = b_Interpolate_wb(wb_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ua_mpi_module_interpolate_mint_test', &
       'ua_mpi_module_mint interpolate(00) tests succeeded')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_mpi_module_interpolate_mint_test

! -*- mode: f90; coding: utf-8 -*-
! ----------------------------------------------------------------------------
! 定数・関数ユーティリティ/Constant and Function Utilities
! ----------------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2026
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @ja
!> @brief 定数・関数ユーティリティ
!>
!> @details
!> 複数のモジュールで個別に設定していた定数, 関数をまとめた.
!> また, 単精度/倍精度両対応にした固有値計算と並び替え関数も提供している.
!> @endja
!> @en
!> @brief Constant and Function Utilities
!>
!> @details
!> Constants and functions previously configured individually across
!> multiple modules have been consolidated. Furthermore, eigenvalue
!> calculations and sorting functions supporting both single-precision
!> and double-precision are now provided.
!> @enden
module spml_utils
  use dc_message, only : MessageNotify
  use dc_types, only: DP, DP_EPS, SP, SP_EPS
  implicit none
  private
  public pi
  public gammaln
  public factrl
  ! --------------------------------------------------------------------------
  !> PI: 3.14159265358979323846264338327950288
  real(DP), parameter :: pi = 3.141592653589793238d0
  !> -------------------------------------------------------------------------
  !> external file: dlgamma.f90
  interface
    real(DP) function dlgamma(x)
      use dc_types, only: DP
      real(DP), intent(in) :: x
    end function dlgamma
  end interface
contains
  ! --------------------------------------------------------------------------
  !> Returns the vaule \f$ ln[Γ(x)] for x >= 0 \f$
  function gammaln(xx)
    real(DP), intent(in) :: xx
    real(DP)             :: gammaln
    gammaln = dlgamma(xx)
  end function gammaln
  ! --------------------------------------------------------------------------
  !> Returns the value \f$n!\f$ as a floating point number
  function factrl(n)
    integer, intent(in)  :: n
    real(DP)             :: factrl
    factrl = exp(gammaln(n+1.0d0))
  end function factrl
end module spml_utils

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム (境界値問題,Grid)
!
!履歴  2016/09/20  竹広真一
!
program tee_mpi_module_boundariesgrid_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=16       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=16       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: zvx_Data(:,:,:)         ! 格子データ
  real(8), allocatable :: zvx_Data_orig(:,:,:)    ! 格子データ

  real(8), allocatable :: vx_BoundaryTop(:,:)     ! 格子データ
  real(8), allocatable :: vx_BoundaryBtm(:,:)     ! 格子データ

  real(8), allocatable :: tef_Data(:,:,:)      ! スペクトルデータ

  real(8), allocatable :: aef_Boundaries(:,:,:)   ! スペクトルデータ

  integer            :: l=2, m=5
  integer            :: np, ip, ierr

 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_mpi_module_BoundariesGrid_test', &
       'tee_mpi_module boundary condition subruoutine tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
   
 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Data(0:km,jc(ip),0:im-1))        ! 格子データ
  allocate(zvx_Data_orig(0:km,jc(ip),0:im-1))   ! 格子データ  

  allocate(vx_BoundaryTop(jc(ip),0:im-1))       ! 格子データ
  allocate(vx_BoundaryBtm(jc(ip),0:im-1))       ! 格子データ

  allocate(tef_Data(0:nm,-mm:mm,2*lc(ip)))      ! スペクトルデータ

  allocate(aef_Boundaries(2,-mm:mm,2*lc(ip)))   ! スペクトルデータ

 !-------------------BC-DD(Grid) ----------------------
  zvx_Data = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  vx_BoundaryTop = 0.0D0
  vx_BoundaryBtm = 0.0D0

  zvx_Data_orig = zvx_Data
  tef_Data = tef_zvx(zvx_Data)

  call tef_BoundariesGrid(tef_Data)
  zvx_Data = zvx_tef(tef_Data)

  call AssertEqual(&
    message='tef_BoundariesGrid [DD,internal]',                   &
    answer = zvx_Data_orig(1:km-1,:,:),                           &
    check = zvx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tef_BoundariesGrid [DD,Top]',                        &
    answer = zvx_Data(0,:,:),                                     &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tef_BoundariesGrid [DD,Bottom]',                     &
    answer = zvx_Data(km,:,:),                                    &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z
  vx_BoundaryTop = sin(m*pi*vx_X) * cos(l*pi*vx_Y)
  vx_BoundaryBtm = cos(m*pi*vx_X) * sin(l*pi*vx_Y)
  aef_Boundaries(1,:,:)=ef_vx(vx_Boundarytop)
  aef_Boundaries(2,:,:)=ef_vx(vx_BoundaryBtm)

  zvx_Data_orig = zvx_Data
  tef_Data = tef_zvx(zvx_Data)

  call tef_BoundariesGrid(tef_Data,values=aef_Boundaries)
  zvx_Data = zvx_tef(tef_Data)

  call AssertEqual(&
    message='tef_BoundariesGrid [DD,vaules,internal]',            &
    answer = zvx_Data_orig(1:km-1,:,:),                           &
    check = zvx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tef_BoundariesGrid [DD,values,Top]',                 &
    answer = zvx_Data(0,:,:),                                     &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tef_BoundariesGrid [DD,values,Bottom]',              &
    answer = zvx_Data(km,:,:),                                    &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-NN(Grid) ----------------------
  zvx_Data = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  vx_BoundaryTop = 0.0D0
  vx_BoundaryBtm = 0.0D0

  zvx_Data_orig = zvx_Data
  tef_Data = tef_zvx(zvx_Data)

  call tef_BoundariesGrid(tef_Data,cond='NN')

  call AssertEqual(&
    message='tef_BoundariesGrid [NN,internal]',                   &
    answer = zvx_Data_orig(1:km-1,:,:),                           &
    check = zvx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Dz_tef(tef_Data))
  call AssertEqual(&
    message='tef_BoundariesGrid [NN,Top]',                        &
    answer = zvx_Data(0,:,:),                                     &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tef_BoundariesGrid [NN,Bottom]',                     &
    answer = zvx_Data(km,:,:),                                    &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z
  vx_BoundaryTop = sin(m*pi*vx_X) * cos(l*pi*vx_Y)
  vx_BoundaryBtm = cos(m*pi*vx_X) * sin(l*pi*vx_Y)
  aef_Boundaries(1,:,:)=ef_vx(vx_Boundarytop)
  aef_Boundaries(2,:,:)=ef_vx(vx_BoundaryBtm)

  zvx_Data_orig = zvx_Data
  tef_Data = tef_zvx(zvx_Data)

  call tef_BoundariesGrid(tef_Data,cond='NN',values=aef_Boundaries)

  call AssertEqual(&
    message='tef_BoundariesGrid [NN,vaules,internal]',            &
    answer = zvx_Data_orig(1:km-1,:,:),                           &
    check = zvx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Dz_tef(tef_Data))
  call AssertEqual(&
    message='tef_BoundariesGrid [NN,values,Top]',                 &
    answer = zvx_Data(0,:,:),                                     &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='tef_BoundariesGrid [NN,values,Bottom]',              &
    answer = zvx_Data(km,:,:),                                    &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-DN(Grid) ----------------------
  zvx_Data = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  vx_BoundaryTop = 0.0D0
  vx_BoundaryBtm = 0.0D0

  zvx_Data_orig = zvx_Data
  tef_Data = tef_zvx(zvx_Data)

  call tef_BoundariesGrid(tef_Data,cond='DN')

  call AssertEqual(&
    message='tef_BoundariesGrid [DN,internal]',                   &
    answer = zvx_Data_orig(1:km-1,:,:),                           &
    check = zvx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Data)
  call AssertEqual(&
    message='tef_BoundariesGrid [DN,Top]',                        &
    answer = zvx_Data(0,:,:),                                     &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Dz_tef(tef_Data))
  call AssertEqual(&
    message='tef_BoundariesGrid [DN,Bottom]',                     &
    answer = zvx_Data(km,:,:),                                    &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z
  vx_BoundaryTop = sin(m*pi*vx_X) * cos(l*pi*vx_Y)
  vx_BoundaryBtm = cos(m*pi*vx_X) * sin(l*pi*vx_Y)
  aef_Boundaries(1,:,:)=ef_vx(vx_Boundarytop)
  aef_Boundaries(2,:,:)=ef_vx(vx_BoundaryBtm)

  zvx_Data_orig = zvx_Data
  tef_Data = tef_zvx(zvx_Data)

  call tef_BoundariesGrid(tef_Data,cond='DN',values=aef_Boundaries)

  call AssertEqual(&
    message='tef_BoundariesGrid [DN,vaules,internal]',            &
    answer = zvx_Data_orig(1:km-1,:,:),                           &
    check = zvx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Data)
  call AssertEqual(&
    message='tef_BoundariesGrid [DN,values,Top]',                 &
    answer = zvx_Data(0,:,:),                                     &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Dz_tef(tef_Data))
  call AssertEqual(&
    message='tef_BoundariesGrid [DN,values,Bottom]',              &
    answer = zvx_Data(km,:,:),                                    &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !-------------------BC-ND(Grid) ----------------------
  zvx_Data = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  vx_BoundaryTop = 0.0D0
  vx_BoundaryBtm = 0.0D0

  zvx_Data_orig = zvx_Data
  tef_Data = tef_zvx(zvx_Data)

  call tef_BoundariesGrid(tef_Data,cond='ND')

  call AssertEqual(&
    message='tef_BoundariesGrid [ND,internal]',                   &
    answer = zvx_Data_orig(1:km-1,:,:),                           &
    check = zvx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Dz_tef(tef_Data))
  call AssertEqual(&
    message='tef_BoundariesGrid [ND,Top]',                        &
    answer = zvx_Data(0,:,:),                                     &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Data)
  call AssertEqual(&
    message='tef_BoundariesGrid [ND,Bottom]',                     &
    answer = zvx_Data(km,:,:),                                    &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = sin(l*pi*zvx_X) * sin(m*pi*zvx_Y) * zvx_Z
  vx_BoundaryTop = sin(m*pi*vx_X) * cos(l*pi*vx_Y)
  vx_BoundaryBtm = cos(m*pi*vx_X) * sin(l*pi*vx_Y)
  aef_Boundaries(1,:,:)=ef_vx(vx_Boundarytop)
  aef_Boundaries(2,:,:)=ef_vx(vx_BoundaryBtm)

  zvx_Data_orig = zvx_Data
  tef_Data = tef_zvx(zvx_Data)

  call tef_BoundariesGrid(tef_Data,cond='ND',values=aef_Boundaries)

  call AssertEqual(&
    message='tef_BoundariesGrid [ND,vaules,internal]',            &
    answer = zvx_Data_orig(1:km-1,:,:),                           &
    check = zvx_Data(1:km-1,:,:),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Dz_tef(tef_Data))
  call AssertEqual(&
    message='tef_BoundariesGrid [ND,values,Top]',                 &
    answer = zvx_Data(0,:,:),                                     &
    check = vx_BoundaryTop,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zvx_Data = zvx_tef(tef_Data)
  call AssertEqual(&
    message='tef_BoundariesGrid [ND,values,Bottom]',              &
    answer = zvx_Data(km,:,:),                                    &
    check = vx_BoundaryBtm,                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)

  call MessageNotify('M','tee_mpi_module_BoundariesGrid_test', &
       'tee_mpi_module boundary condition subroutine tests succeeded!')

end program tee_mpi_module_boundariesgrid_test

!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム
!
!履歴  2016/08/08  竹広真一
!
program ee_mpi_module_intavr_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, jm=16            ! 格子点の設定(X,Y)
  integer, parameter :: km=5, lm=5              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: vx_Data(:,:)          ! 格子データ
  real(8), allocatable :: x_Data(:)             ! 格子データ
  real(8), allocatable :: v_Data(:)             ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11
  integer :: i, j

  integer            :: np, ip, ierr
  real(8), parameter :: pi=3.1415926535897932385D0

  call MessageNotify('M','ee_mpi_module_intavr_test', &
       'ee_mpi_module integral/average function tests')

  !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_Data(jc(ip),0:im-1))    ! 格子データ
  allocate(x_Data(0:im-1))            ! 格子データ
  allocate(v_Data(jc(ip)))            ! 格子データ

  !------------------- 初期値設定 ----------------------
  vx_Data = sin(pi*vx_X) * cos(pi*vx_Y)
  write(6,*) 'f = sin(pi*X)*cos(pi*Y)'

    call check0d(IntYX_vx(vx_Data),  0.0d0, 'IntYX_vx')
    call check0d(AvrYX_vx(vx_Data),  0.0d0, 'AvrYX_vx')

    call check1d(v_IntX_vx(vx_Data), (/(0.0d0, j=1,jc(ip))/), 'v_IntX_vx')
    call check1d(v_AvrX_vx(vx_Data), (/(0.0d0, j=1,jc(ip))/), 'v_AvrX_vx')

    call check1d(x_IntY_vx(vx_Data), (/(0.0d0, i=0,im-1)/), 'x_IntY_vx')
    call check1d(x_AvrY_vx(vx_Data), (/(0.0d0, i=0,im-1)/), 'x_AvrY_vx')

  vx_Data = (1 - sin(pi*vx_X)) * cos(pi*vx_Y)**2
  write(6,*) 'f = (1-sin(pi*X)) * cos(pi*Y)**2'

    call check0d(IntYX_vx(vx_Data), 2.0d0, 'IntYX_vx')
    call check0d(AvrYX_vx(vx_Data), 5.0d-1, 'AvrYX_vx')

    call check1d(v_IntX_vx(vx_Data), 2.0d0*cos(pi*v_Y)**2, 'y_IntX_vx')
    call check1d(v_AvrX_vx(vx_Data), cos(pi*v_Y)**2, 'y_AvrX_vx')

    call check1d(x_IntY_vx(vx_Data), &
      (1.0d0-sin(pi*x_X)), 'x_IntY_vx')
    call check1d(x_AvrY_vx(vx_Data), &
      (5.0d-1)*(1.0d0-sin(pi*x_X)), 'x_AvrY_vx')

  x_Data = 1 - sin(2*pi*x_X)
  write(6,*) 'f = 1-sin(2*pi*X)'

    call check0d(IntX_x(x_Data), 2.0d0, 'IntX_x')
    call check0d(AvrX_x(x_Data), 1.0d0, 'AvrX_x')

  v_Data = cos(pi*v_Y)**2
  write(6,*) 'f = cos(pi*Y)**2'

    call check0d(IntY_v(v_Data), 1.0d0, 'IntY_y')
    call check0d(AvrY_v(v_Data), 5.0d-1, 'AvrY_y')


  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','ee_test_intavr', &
       'ee_module integral/average function tests succeeded!')

contains

  subroutine check1d(var1,sol1,funcname)
    real(8) :: var1(:)                  ! 判定する配列
    real(8) :: sol1(:)                  ! 解析解
    character(len=*) :: funcname        ! 関数名

    call AssertEqual(     &
      message = funcname, &
      answer = sol1,       &
      check = var1,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check1d

  subroutine check0d(var0,sol0,funcname)
    real(8) :: var0                       ! 判定する配列
    real(8) :: sol0                       ! 解析解
    character(len=*) :: funcname          ! 関数名

    call AssertEqual(      &
      message = funcname,  &
      answer = sol0,       &
      check = var0,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check0d

end program ee_mpi_module_intavr_test

! -*- mode: f90; coding: utf-8 -*-
!----------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief
!> @ref w_module の下部モジュール: 補間計算
!> @note
!> 補間計算の方法については doc/w_module.tex を参照のこと.
!> @warning
!> * 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!>   ユーザは @ref w_module を呼ぶこと．
!> * 変換する格子点データ, スペクトルデータの配列の大きさは決めうちである
!----------------------------------------------------------------------
!履歴  2019/03/16  竹広真一
!      2019/10/04  佐々木洋平
!----------------------------------------------------------------------
module w_module_interpolate
  use dc_types, only: DP
  use dc_message, only : MessageNotify
  use spml_utils, only: gammaln
  use w_module_base, only : nm=>nn, l_nm
  implicit none
  private
  public Interpolate_w

  interface Interpolate_w
    module procedure Interpolate_array00_w
  end interface Interpolate_w

  interface alpha
    module procedure alpha_array0
  end interface alpha

  interface Pmm
    module procedure Pmm_array0
  end interface Pmm

contains

  !----------------------------------------------------------
  !> 緯度 alat, 経度 alon における関数値を
  !> その球面調和変換係数 w_data から補間計算する
  !----------------------------------------------------------
  function Interpolate_array00_w(w_data,alon,alat)
    !> スペクトルデータ
    real(DP), intent(IN) :: w_data((nm+1)*(nm+1))
    !> 補間する位置(経度)
    real(DP), intent(IN) :: alon
    !> 補間する位置(緯度)
    real(DP), intent(IN) :: alat
    !> 補間した値
    real(DP)             :: Interpolate_array00_w

    real(DP)   :: mu
    real(DP)   :: y0
    real(DP)   :: y1
    real(DP)   :: y2
    real(DP)   :: AnmPnm
    integer(8) :: k
    integer(8) :: m

    mu = sin(alat)
    Interpolate_array00_w = 0.0D0

    !---- Σa_n^0 P_n^0 の計算
    y2 = 0.0D0
    y1 = 0.0D0
    do k=nm,1,-1
      y0 =   alpha(k,0_8,mu) * y1  &
        &  + beta(k+1_8,0_8) * y2  &
        &  + w_data(l_nm(int(k),0))
      y2 = y1
      y1 = y0
    enddo
    Interpolate_array00_w =  &
      & ( beta(1_8,0_8) * y2 + mu*sqrt(3.0D0) * y1 &
      &   + w_data(l_nm(0,0))  ) * Pmm(0_8,mu)

    !----  Σ Re[s_n^m] P_n^m exp(imλ)の計算
    do m=1,nm
      y2 = 0.0D0
      y1 = 0.0D0
      do k=nm,m+1,-1
        y0 =   alpha(k,m,mu) * y1  &
          &  + beta(k+1_8,m) * y2  &
          &  + w_data(l_nm(int(k),int(m)))
        y2 = y1
        y1 = y0
      enddo

      AnmPnm = ( w_data(l_nm(int(m),int(m))) &
        &        + beta(m+1_8,m)*y2 &
        &        + mu*sqrt(2.0D0*m+3) * y1 ) * Pmm(m,mu)

      Interpolate_array00_w = Interpolate_array00_w &
        &                     + AnmPnm * 2 * cos(m*alon)
      end do

      !----  Σ Im[s_n^m] P_n^m exp(imλ)の計算
      do m=1,nm
        y2 = 0.0D0
        y1 = 0.0D0
        do k=nm,m+1,-1
          y0 =   alpha(k,m,mu) * y1 &
            &  + beta(k+1_8,m) * y2 &
            &  + w_data(l_nm(int(k),-int(m)))
          y2 = y1
          y1 = y0
        enddo

        AnmPnm =( w_data(l_nm(int(m),-int(m)))  &
          &       + beta(m+1_8,m) * y2          &
          &       + mu*dsqrt(2.0D0*m+3) * y1 ) * Pmm(m,mu)


        Interpolate_array00_w = Interpolate_array00_w &
          &                     - AnmPnm * 2 * sin(m*alon)
      end do

    end function Interpolate_array00_w

    !----------------------------------------------------------
    !> 漸化式の \f$P_{n}^{m}\f$ の係数
    !----------------------------------------------------------
    function alpha_array0(n,m,x)
      integer(8), intent(IN)  :: n
      integer(8), intent(IN)  :: m
      real(DP), intent(IN) :: x
      real(DP)             :: alpha_array0

      alpha_array0 = dsqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n-m+1)*(n+m+1)) ) * x
    end function alpha_array0

    !----------------------------------------------------------
    !> 漸化式の \f$P_{n-1}^m\f$ の係数
    !----------------------------------------------------------
    function beta(n,m)
      integer(8), intent(IN) :: n
      integer(8), intent(IN) :: m
      real(DP)               :: beta

      beta = - dsqrt( (2.0D0*n+3)*(n+m)*(n-m)/((2*n-1)*(n+m+1)*(n-m+1)) )
    end function beta

    !----------------------------------------------------------
    !> ルジャンドル陪函数 P_m^m(x) の計算
    !>
    !>         sqrt( factrl(2*m+1) )/(2.0D0**m * factrl(m)) &
    !>          * (1-x**2)**(m/2.0D0)
    !>
    !> 係数が発散しないように対数で計算する
    !----------------------------------------------------------
    function Pmm_array0(m,x)
      !> ルジャンドル陪函数の次数
      integer(8),  intent(IN) :: m
      !> 引き数
      real(DP), intent(IN) :: x
      !> ルジャンドル陪函数の値
      real(DP)             :: Pmm_array0

      if ( m < 0 ) call MessageNotify('E', &
        & 'Pmm in w_Intepolate_module',    &
        & 'order m should be larger equal to zero')

      Pmm_array0 = 1.0D0
      if ( m > 0 )then
        Pmm_array0 = exp(gammaln(2.0D0*m+2.0D0)/2.0D0        &
          &              - m*dlog(2.0D0) - gammaln(m+1.0D0)) &
          &          *(1-x**2)**(m/2.0D0)
      endif
    end function Pmm_array0

end module w_module_interpolate

!--
!----------------------------------------------------------------------
!     Copyright (c) 2024-2025 SPMODEL Development Group.
!----------------------------------------------------------------------
!表題  w_zonal_interpolate_module
!
!  spml/w_zonal_interpolate_module モジュールは球面上での 
!  2 次元流体運動を球面調和函数を用いたスペクトル法によって
!  東西 1 波数数値計算するためのモジュール w_zonal_module の
!  下部モジュールであり, スペクトル法による補間計算のための 
!  Fortran90 関数を提供する. 
!
!  補間計算の方法については doc/w_module.tex を参照のこと. 
!  このサブルーチンは内部で ISPACK3 の LXPACK のサブルーチンを
!  呼んでいない. 
!
!履歴  2024/02/15  竹広真一 w_zonal_module_interpolate より改造
!      2025/11/27  竹広真一  w_base_initial interface を変更
!
!
!++
module w_zonal_module_interpolate
  !
  !=  w_zonal_interpolate_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: w_zonal_interpolate_module.f90 590 2013-08-19 08:48:21Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/w_zonal_interpolate_module モジュールは球面上での 
  !  2 次元流体運動を球面調和函数を用いたスペクトル法によって
  !  東西 1 波数数値計算するためのモジュール w_zonal_module の
  !  下部モジュールであり, スペクトル法による補間計算のための 
  !  Fortran90 関数を提供する. 
  !
  !  このサブルーチンは内部で ISPACK3 の LXPACK のサブルーチンを
  !  呼んでいない. 
  !
  use dc_message, only : MessageNotify
  use spml_utils, only : gammaln
  use w_zonal_module_base, only : nm=>nn, l_nm
  implicit none
  private

  public Interpolate_w                        ! 補間関数

  interface Interpolate_w
     !
     ! 緯度 alon, 経度 alat における関数値を
     ! その球面調和変換係数 w_data から補間計算する
     !
     ! 入力する緯度経度座標は, 
     !       １点, 経度1点緯度複数点, 経度複数点緯度1点, 経度緯度複数点
     ! の 4 種類
     !
     module procedure Interpolate_array00_w
  end interface

!!$  interface alpha
!!$     module procedure alpha_array0
!!$  end interface alpha
!!$
!!$  interface Pmm
!!$     module procedure Pmm_array0
!!$  end interface Pmm

contains

  !--------------- 補間計算 -----------------    
  function Interpolate_array00_w(w_data,alon,alat)
    !
    ! 緯度 alat, 経度 alon における関数値を
    ! その球面調和変換係数 w_data から補間計算する
    !
    real(8), intent(IN) :: w_data(nm+1)           ! スペクトルデータ
    real(8), intent(IN) :: alon                   ! 補間する位置(経度)
    real(8), intent(IN) :: alat                   ! 補間する位置(緯度)
    real(8)             :: Interpolate_array00_w  ! 補間した値

    real(8) :: mu
    real(8) :: y0, y1, y2
    integer :: k

    mu = sin(alat)
    Interpolate_array00_w = 0.0D0

    !---- Σa_n^0 L_n^0 の計算
    y2 = 0 ; y1 = 0
    do k=nm,1,-1
       y0 = alpha(k,mu) * y1 + beta(k+1)*y2 + w_data(l_nm(k,0))
       y2 = y1 ; y1 = y0
    enddo
    Interpolate_array00_w = beta(1) * y2 + mu*sqrt(3.0D0) * y1 + w_data(l_nm(0,0)) 

  end function Interpolate_array00_w

  !--------------- 下部ルーチン -----------------
  function alpha(n,x)
    !
    !  漸化式の P_n の係数
    !
    integer, intent(IN) :: n
    real(8), intent(IN) :: x
    real(8)             :: alpha

    alpha = sqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n+1)*(n+1)) ) * x
  end function alpha

  function beta(n)
    !
    !  漸化式の P_{n-1} の係数
    !
    integer, intent(IN) :: n
    real(8)             :: beta

    beta = - sqrt( (2.0D0*n+3)*n*n/((2*n-1)*(n+1)*(n+1)) )
  end function beta

end module w_zonal_module_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2019-2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_base_module テストプログラム :: ベクトル用サブルーチンのテスト
!
!履歴  2019/03/13  竹広真一
!      2020/11/06  竹広真一 セクター計算テスト
!
program w_module_base_vector_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module_mint
  implicit none

!  integer, parameter :: im=64, jm=32, nm=21, mint=1
  integer, parameter :: im=32, jm=32, nm=21, mint=2  
  integer, parameter :: nc=(nm/mint+1)*(2*(nm+1)-nm/mint*mint)

  real(8), dimension(0:im-1,1:jm)  ::  xy_U              ! 速度経度成分
  real(8), dimension(0:im-1,1:jm)  ::  xy_V              ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm)  ::  xy_UCosLat        ! 速度経度成分
  real(8), dimension(0:im-1,1:jm)  ::  xy_VCosLat        ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm)  ::  xy_Uans           ! 速度経度成分
  real(8), dimension(0:im-1,1:jm)  ::  xy_Vans           ! 速度緯度成分

  real(8), dimension(0:im-1,1:jm)  ::  xy_Psi            ! 流線関数
  real(8), dimension(0:im-1,1:jm)  ::  xy_Chi            ! 速度ポテンシャル

  real(8), dimension(nc)           ::  w_Vor             ! 渦度
  real(8), dimension(nc)           ::  w_Div             ! 発散

  real(8), dimension(0:im-1,1:jm)  ::  xy_Vorans         ! 渦度
  real(8), dimension(0:im-1,1:jm)  ::  xy_Divans         ! 発散


  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  call MessageNotify('M','w_module_base_vector_test', &
                         'w_module_base vector subroutine tests')

  call w_Initial( nm, im, jm, mint=mint )

  !---- Y_1^0 のテスト ----
  xy_Psi = sin(xy_Lat)       ! Y_1^0
  xy_Chi = 0.0D0

  xy_Uans = -cos(xy_Lat)
  xy_Vans = 0.0D0

  xy_Vorans = -2*sin(xy_Lat)
  xy_Divans = 0.0D0

  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )

  call AssertEqual(&
    message='Psi = Y_1^0 test of w_StreamPotential2Vector(U)',   &
    answer = xy_Uans,                                             &
    check  = xy_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^0 test of w_StreamPotential2Vector(V)',   &
    answer = xy_Vans,                                             &
    check  = xy_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_1^0 test of w_Vector2VorDiv(Vor)',          &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^0 test of w_Vector2VorDiv(Div)',          &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)

  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_1^0 test of w_VectorCosLat2VorDiv(Vor)',    &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_1^0 test of w_VectorCosLat2VorDiv(Div)',    &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Psi = 0.0D0
  xy_Chi = sin(xy_Lat)       ! Y_1^0

  xy_Uans = 0.0D0
  xy_Vans = cos(xy_Lat)

  xy_Vorans = 0.0D0
  xy_Divans = -2*sin(xy_Lat)

  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )

  call AssertEqual(&
    message='Chi = Y_1^0 test of w_StreamPotential2Vector(U)',   &
    answer = xy_Uans,                                             &
    check  = xy_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_1^0 test of w_StreamPotential2Vector(V)',   &
    answer = xy_Vans,                                             &
    check  = xy_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Chi = Y_1^0 test of w_Vector2VorDiv(Vor)',          &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_1^0 test of w_Vector2VorDiv(Div)',          &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)

  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Chi = Y_1^0 test of w_VectorCosLat2VorDiv(Vor)',    &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_1^0 test of w_VectorCosLat2VorDiv(Div)',    &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^2 のテスト ----
  xy_Psi = cos(xy_Lat)**2*cos(2*xy_Lon)       ! Y_2^2
  xy_Chi = 0.0D0

  xy_Uans = 2*sin(xy_Lat)*cos(xy_Lat)*cos(2*xy_Lon)
  xy_Vans = -2*cos(xy_Lat)*sin(2*xy_Lon)

  xy_Vorans = -6*cos(xy_Lat)**2*cos(2*xy_Lon)      ! Y_2^2
  xy_Divans = 0.0D0

  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )

  call AssertEqual(&
    message='Psi = Y_2^2 test of w_StreamPotential2Vector(U)',    &
    answer = xy_Uans,                                             &
    check  = xy_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^2 test of w_StreamPotential2Vector(V)',    &
    answer = xy_Vans,                                             &
    check  = xy_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_2^2 test of w_Vector2VorDiv(Vor)',           &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^2 test of w_Vector2VorDiv(Div)',           &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)

  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_2^2 test of w_VectorCosLat2VorDiv(Vor)',     &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_2^2 test of w_VectorCosLat2VorDiv(Div)',     &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Psi = 0.0D0
  xy_Chi = cos(xy_Lat)**2*cos(2*xy_Lon)       ! Y_2^2

  xy_Uans = - 2*cos(xy_Lat)*sin(2*xy_Lon)
  xy_Vans = - 2*sin(xy_Lat)*cos(xy_Lat)*cos(2*xy_Lon)

  xy_Vorans = 0.0D0
  xy_Divans = -6*cos(xy_Lat)**2*cos(2*xy_Lon)        ! Y_2^2

  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )

  call AssertEqual(&
    message='Chi = Y_2^2 test of w_StreamPotential2Vector(U)',    &
    answer = xy_Uans,                                             &
    check  = xy_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_2^2 test of w_StreamPotential2Vector(V)',    &
    answer = xy_Vans,                                             &
    check  = xy_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Chi = Y_2^2 test of w_Vector2VorDiv(Vor)',           &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_2^2 test of w_Vector2VorDiv(Div)',           &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)

  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Chi = Y_2^2 test of w_VectorCosLat2VorDiv(Vor)',     &
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Chi = Y_2^2 test of w_VectorCosLat2VorDiv(Div)',     &
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_4^2, Y_4^-4 のテスト ----
  xy_Psi = cos(xy_Lat)**2*(7*sin(xy_Lat)**2-1)*cos(2*xy_Lon)  ! Y_4^2
  xy_Chi = cos(xy_Lat)**4*sin(4*xy_Lon)                       ! Y_4^-4

  xy_Uans = -( -2*cos(xy_Lat)*sin(xy_Lat)*(7*sin(xy_Lat)**2-1) &
               + cos(xy_Lat)**2*14*sin(xy_Lat)*cos(xy_Lat) )*cos(2*xy_Lon) &
            + cos(xy_Lat)**3*4*cos(4*xy_Lon)
  xy_Vans =   cos(xy_Lat)*(7*sin(xy_Lat)**2-1)*(-2)*sin(2*xy_Lon) &
            + (-4)*cos(xy_Lat)**3*sin(xy_Lat)*sin(4*xy_Lon) 
  xy_Vorans = -20*cos(xy_Lat)**2*(7*sin(xy_Lat)**2-1)*cos(2*xy_Lon)
  xy_Divans = -20*cos(xy_Lat)**4*sin(4*xy_Lon)

  call w_StreamPotential2Vector( w_xy(xy_Psi), w_xy(xy_Chi), xy_U, xy_V )

  call AssertEqual(&
    message='Psi = Y_4^-4, Chi = Y_4^2 test of w_StreamPotential2Vector(U)',     &
    answer = xy_Uans,                                             &
    check  = xy_U,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_4^-4, Chi = Y_4^2 test of w_StreamPotential2Vector(V)',     &
    answer = xy_Vans,                                             &
    check  = xy_V,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call w_Vector2VorDiv( xy_U, xy_V, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_4^-4, Chi=Y_4^2 test of w_Vector2VorDiv(Vor)',&
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_4^-4, Chi=Y_4^2 test of w_Vector2VorDiv(Div)',&
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_UCosLat = xy_U * cos(xy_Lat) ; xy_VCosLat = xy_V * cos(xy_Lat)

  call w_VectorCosLat2VorDiv( xy_UCosLat, xy_VCosLat, w_Vor, w_Div )

  call AssertEqual(&
    message='Psi = Y_4^-4, Chi=Y_4^2 test of w_VectorCosLat2VorDiv(Vor)',&
    answer = xy_Vorans,                                           &
    check  = xy_w(w_Vor),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Psi = Y_4^-4, Chi=Y_4^2 test of w_VectorCosLat2VorDiv(Div)',&
    answer = xy_Divans,                                           &
    check  = xy_w(w_Div),                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','w_module_base_vector_mint_test', &
                         'w_module_base vector subroutine tests succeeded!')

end program w_module_base_vector_mint_test

! -*- mode: f90; coding: utf-8 -*-
!-------------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!-------------------------------------------------------------------------
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @brief
!> @ref w_mpi_module の下部モジュール: 積分・平均
!>
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは w_mpi_module を呼ぶこと．
!>
!
! 履歴  2019/03/21 竹広真一
!       2019/10/09 佐々木洋平
!
module w_mpi_module_integral
  use dc_types, only: DP
  use w_mpi_module_base, only : &
    & im, jc=>jl, x_Lon_Weight, v_Lat_Weight, icom
  use mpi

  implicit none
  private

  public IntLonLat_xv ! 緯度経度積分
  public v_IntLon_xv  ! 経度積分
  public IntLon_x     ! 経度積分
  public x_IntLat_xv  ! 緯度積分
  public IntLat_v     ! 緯度積分
  public AvrLonLat_xv ! 緯度経度平均
  public v_AvrLon_xv  ! 経度平均
  public AvrLon_x     ! 経度平均
  public x_AvrLat_xv  ! 緯度平均
  public AvrLat_v     ! 緯度平均

  integer :: ierr

contains

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの全領域積分(1 層用).
  !>
  !> 実際には格子点データ各点毎に x_X_Weight, v_V_Weight をかけた
  !> 総和を計算している.
  !>
  function IntLonLat_xv(xv_data)
    !> 2 次元経度緯度格子点データ(0:im-1,jc)
    real(DP), intent(in)   :: xv_data(0:im-1,jc)
    !> 積分値
    real(DP) :: IntLonLat_xv

    IntLonLat_xv = IntLon_x(x_IntLat_xv(xv_data))

  end function IntLonLat_xv

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの緯度(Y)方向積分(1 層用).
  !>
  !> 実際には格子点データ各点毎に v_Y_Weight をかけた総和を計算している.
  !>
  function x_IntLat_xv(xv_data)
    !> 2 次元経度緯度格子点データ(0:im-1,jc)
    real(DP), intent(in) :: xv_data(0:im-1,jc)
    !> 積分された 1 次元経度(X)格子点データ
    real(DP)             :: x_IntLat_xv(0:im-1)

    real(DP)             :: x_IntLatTmp(0:im-1)
    integer :: j

    x_IntLat_xv = 0.0D0
    do j=1,jc
      x_IntLat_xv = x_IntLat_xv + xv_data(:,j) * v_Lat_weight(j)
    enddo

    x_IntLatTmp=x_IntLat_xv
    CALL MPI_ALLREDUCE(x_IntLatTMP, x_IntLat_xv, int(im), MPI_REAL8, &
      & MPI_SUM, int(icom), IERR)
  end function x_IntLat_xv

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの経度(X)方向積分(1 層用).
  !>
  !> 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
  !>
  function v_IntLon_xv(xv_data)
    !> 2 次元経度緯度格子点データ(0:im-1,jc)
    real(DP), intent(in) :: xv_data(0:im-1,jc)
    !> 積分された 1 次元緯度(Y)格子点データ
    real(DP)             :: v_IntLon_xv(jc)

    integer :: i

    v_IntLon_xv = 0.0D0
    do i=0,int(im)-1
      v_IntLon_xv = v_IntLon_xv + xv_data(i,:) * x_Lon_weight(i)
    enddo

  end function v_IntLon_xv

  !---------------------------------------------------------------------
  !> 1 次元経度(X)格子点データの X 方向積分(1 層用).
  !>
  !> 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
  !>
  function IntLon_x(x_data)
    !> 1 次元経度(X)格子点データ
    real(DP), intent(in) :: x_data(0:im-1)
    !> 積分値
    real(DP)             :: IntLon_x

    IntLon_x = sum(x_data * x_Lon_weight)

  end function IntLon_x

  !---------------------------------------------------------------------
  !> 1 次元緯度(Y)格子点データの Y 方向積分(1 層用).
  !>
  !> 実際には格子点データ各点毎に v_Y_Weight をかけた総和を計算している.
  !>
  function IntLat_v(v_data)
    !> 1 次元緯度(Y)格子点データ
    real(DP), intent(in) :: v_data(jc)
    !> 積分値
    real(DP)             :: IntLat_v

    real(DP)             :: IntLatTmp

    IntLat_v = sum(v_data * v_Lat_weight)
    IntLatTmp=IntLat_v
    CALL MPI_ALLREDUCE(IntLatTMP, IntLat_v, 1, MPI_REAL8, &
      & MPI_SUM, int(icom), IERR)

  end function IntLat_v

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの全領域平均(1 層用).
  !>
  !> 実際には格子点データ各点毎に x_X_Weight, v_Y_Weight をかけた
  !> 総和を計算し, x_X_Weight*v_Y_Weight の総和で割ることで平均している.
  !>
  function AvrLonLat_xv(xv_data)
    !> 2 次元経度緯度格子点データ(0:im-1,jc)
    real(DP), intent(in)   :: xv_data(0:im-1,jc)
    !> 平均値
    real(DP) :: AvrLonLat_xv

    AvrLonLat_xv = AvrLon_x(x_AvrLat_xv(xv_data))

  end function AvrLonLat_xv

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの緯度(Y)方向平均(1 層用).
  !>
  !> 実際には格子点データ各点毎に v_Lat_Weight をかけた総和を計算し,
  !> y_Lat_Weight の総和で割ることで平均している.
  !>
  function x_AvrLat_xv(xv_data)
    !> 2 次元経度緯度格子点データ(0:im-1,jc)
    real(DP), intent(in) :: xv_data(0:im-1,jc)
    !> 平均された 1 次元経度(X)格子点データ
    real(DP)             :: x_AvrLat_xv(im)

    real(DP)             :: Tmp
    real(DP)             :: Lat_Weight_Sum

    Tmp = sum(v_Lat_weight)
    CALL MPI_ALLREDUCE(TMP, Lat_Weight_Sum, 1, MPI_REAL8, &
      & MPI_SUM, int(icom), IERR)

    x_AvrLat_xv = x_IntLat_xv(xv_data)/Lat_Weight_Sum

  end function x_AvrLat_xv

  !---------------------------------------------------------------------
  !> 2 次元緯度経度格子点データの経度(X)方向平均(1 層用).
  !>
  !> 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
  !> x_X_Weight の総和で割ることで平均している.
  !>
  function v_AvrLon_xv(xv_data)
    !> 2 次元経度緯度格子点データ(0:im-1,jc)
    real(DP), intent(in) :: xv_data(0:im-1,jc)
    !> 平均された 1 次元緯度(Y)格子点
    real(DP)             :: v_AvrLon_xv(jc)

    v_AvrLon_xv = v_IntLon_xv(xv_data)/sum(x_Lon_weight)

  end function v_AvrLon_xv

  !---------------------------------------------------------------------
  !> 1 次元(X)格子点データの経度(X)方向平均(1 層用).
  !>
  !> 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
  !> x_X_Weight の総和で割ることで平均している.
  !>
  function AvrLon_x(x_data)
    !> 1 次元経度(X)格子点データ
    real(DP), intent(in) :: x_data(0:im-1)
    !> 平均値
    real(DP)             :: AvrLon_x

    AvrLon_x = IntLon_x(x_data)/sum(x_Lon_weight)

  end function AvrLon_x

  !---------------------------------------------------------------------
  !> 1 次元(Y)格子点データの緯度(Y)方向平均(1 層用).
  !>
  !> 実際には格子点データ各点毎に v_Y_Weight をかけた総和を計算し,
  !> v_Y_Weight の総和で割ることで平均している.
  !>
  function AvrLat_v(v_data)
    !> 1 次元緯度格子点データ
    real(DP), intent(in) :: v_data(jc)
    !> 平均値
    real(DP)             :: AvrLat_v

    real(DP)             :: Tmp
    real(DP)             :: Lat_Weight_Sum

    Tmp = sum(v_Lat_weight)
    CALL MPI_ALLREDUCE(TMP, Lat_Weight_Sum, 1, MPI_REAL8, &
      & MPI_SUM, int(icom), IERR)
    AvrLat_v = IntLat_v(v_data)/Lat_Weight_Sum

  end function AvrLat_v

end module w_mpi_module_integral

! -*- mode: f90; coding: utf-8 -*-
!-----------------------------------------------------------------------
! Copyright (c) 2019-2021 SPMODEL Development Group. All rights reserved.
!
! 履歴  2019/03/21  竹広真一
!       2019/10/09  佐々木洋平
!       2021/02/18  竹広真一
!
!-----------------------------------------------------------------------
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @brief
!> @ref w_mpi_module の下部モジュール: 補間
!>
!> @details
!> 補間計算の方法については doc/w_module.tex を参照のこと.
!> 内部で ISPACK3 の SYPACK を呼んでいる.
!> スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!> ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!>
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは w_mpi_module を呼ぶこと．
module w_mpi_module_interpolate
  use dc_message, only : MessageNotify
  use dc_types, only: DP
  use spml_utils, only: gammaln
  use w_mpi_module_base, only : &
    & nm=>nn, nc, l_nm, icom
  use mpi
  implicit none
  private

  public Interpolate_w

  !----------------------------------------------------------
  !>  入力緯度 `alon`, 入力経度 `alat` における関数値を
  !>  その球面調和変換係数 w_data から補間計算する
  !>
  !>  入力を受けつける緯度経度座標は,
  !>  * 1点,
  !>  * 経度1点, 緯度複数点,
  !>  * 経度複数点, 緯度1点,
  !>  * 経度複数点, 緯度複数点
  !>  の 4 種類
  !>
  interface Interpolate_w
    module procedure Interpolate_array00_w
    module procedure Interpolate_array10_w
  end interface Interpolate_w

  interface alpha
    module procedure alpha_array0
  end interface alpha

  interface Pmm
    module procedure Pmm_array0
  end interface Pmm

contains

  !---------------------------------------------------------------------
  !> 緯度 `alat`, 経度 `alon` における関数値を
  !> その球面調和変換係数 `w_data` から補間計算する
  !>
  function Interpolate_array00_w(w_data,alon,alat)
    real(DP), intent(IN) :: w_data(nc)             ! スペクトルデータ
    real(DP), intent(IN) :: alon                   ! 補間する位置(経度)
    real(DP), intent(IN) :: alat                   ! 補間する位置(緯度)
    real(DP)             :: Interpolate_array00_w  ! 補間した値

    real(DP) :: mu
    real(DP) :: y0, y1, y2, AnmPnm
    real(DP) :: gdata
    logical  :: LFlagAnd, LFlagOr
    integer  :: k,m
    integer  :: ierr
    logical, parameter :: wdata_check = .false.

    mu = sin(alat)
    gdata = 0.0D0

    if ( wdata_check ) then
      !---- 波数チェック
      LFlagAnd = .true. ; LFlagOr  = .false.
      do k=int(nm),0,-1
        LFlagAnd = (l_nm(k,0) /= 0) .and. LFlagAnd
        LFlagOr = (l_nm(k,0) /= 0) .or. LFlagOr
      enddo
      if ( (.not. LFlagAnd) .and. LFlagOr ) then
        call MessageNotify &
          ('E','w_Interpolate_array00','Invalid spectral data for m=0')
      endif

      do m=1,int(nm)
        LFlagAnd = .true. ; LFlagOr  = .false.
        do k=int(nm),m,-1
          LFlagAnd = (l_nm(k,m) /= 0) .and. LFlagAnd
          LFlagOr = (l_nm(k,m) /= 0) .or. LFlagOr
        enddo
        if ( (.not. LFlagAnd) .and. LFlagOr ) then
          call MessageNotify                         &
            & ('E','w_Interpolate_array00',          &
            & 'Invalid spectral data for m nonzedo')
        endif
      end do

      do m=1,int(nm)
        LFlagAnd = .true. ; LFlagOr  = .false.
        do k=int(nm),m,-1
          LFlagAnd = (l_nm(k,-m) /= 0) .and. LFlagAnd
          LFlagOr = (l_nm(k,-m) /= 0) .or. LFlagOr
        enddo
        if ( (.not. LFlagAnd) .and. LFlagOr ) then
          call MessageNotify                         &
            & ('E','w_Interpolate_array00',          &
            & 'Invalid spectral data for m nonzedo')
        endif
      end do
    endif

    !---- Σa_n^0 P_n^0 の計算
    if ( l_nm(0,0) /= 0 ) then
      y2 = 0 ; y1 = 0
      do k=int(nm),1,-1
        y0 = alpha(k,0,mu) * y1 + beta(k+1,0)*y2 + w_data(l_nm(k,0))
        y2 = y1 ; y1 = y0
      enddo
      gdata = gdata + (  beta(1,0) * y2 + mu*sqrt(3.0D0) * y1 &
        + w_data(l_nm(0,0))  ) * Pmm(0,mu)
    endif

    !----  Σ Re[s_n^m] P_n^m exp(imλ)の計算
    do m=1,int(nm)
      if ( l_nm(m,m) /= 0 ) then
        y2 = 0 ; y1 = 0
        do k=int(nm),m+1,-1
          y0 = alpha(k,m,mu) * y1 + beta(k+1,m) * y2 + w_data(l_nm(k,m))
          y2 = y1 ; y1 = y0
        enddo

        AnmPnm =(w_data(l_nm(m,m)) + beta(m+1,m)*y2 &
          + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)

        gdata = gdata + AnmPnm * 2 * cos(m*alon)
      endif
    end do

    !----  Σ Im[s_n^m] P_n^m exp(imλ)の計算
    do m=1,int(nm)
      if ( l_nm(m,-m) /= 0 ) then
        y2 = 0 ; y1 = 0
        do k=int(nm),m+1,-1
          y0 = alpha(k,m,mu) * y1 + beta(k+1,m)*y2 + w_data(l_nm(k,-m))
          y2 = y1 ; y1 = y0
        enddo

        AnmPnm =(w_data(l_nm(m,-m)) + beta(m+1,m)*y2 &
          + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)


        gdata = gdata - AnmPnm * 2 * sin(m*alon)
      endif
    end do

    CALL MPI_ALLREDUCE(gdata,Interpolate_array00_w,1,&
      MPI_REAL8,MPI_SUM,int(icom),IERR)

  end function Interpolate_array00_w

  !---------------------------------------------------------------------
  !> 緯度 `alat`, 経度 `alon` における関数値を
  !> その球面調和変換係数 `w_data` から補間計算する
  !>
  function Interpolate_array10_w(w_data,alon,alat)
    !> スペクトルデータ
    real(DP), intent(IN) :: w_data(nc)
    !> 補間する位置(経度)
    real(DP), intent(IN) :: alon(:)
    !> 補間する位置(緯度)
    real(DP), intent(IN) :: alat
    !> 補間した値
    real(DP)             :: Interpolate_array10_w(size(alon))

    real(DP) :: mu
    real(DP) :: y0, y1, y2, AnmPnm
    real(DP) :: gdata(size(alon))
    logical :: LFlagAnd, LFlagOr
    integer :: i,k,m
    integer :: ierr
    logical,parameter :: wdata_check = .false.

    mu = sin(alat)
    !$omp parallel
    !$omp workshare
    gdata = 0.0D0
    !$omp end workshare
    !$omp end parallel

    if ( wdata_check ) then
      !---- 波数チェック
      LFlagAnd = .true. ; LFlagOr  = .false.
      do k=int(nm),0,-1
        LFlagAnd = (l_nm(k,0) /= 0) .and. LFlagAnd
        LFlagOr = (l_nm(k,0) /= 0) .or. LFlagOr
      enddo
      if ( (.not. LFlagAnd) .and. LFlagOr ) then
        call MessageNotify &
          ('E','w_Interpolate_array00','Invalid spectral data for m=0')
      endif

      do m=1,int(nm)
        LFlagAnd = .true. ; LFlagOr  = .false.
        do k=int(nm),m,-1
          LFlagAnd = (l_nm(k,m) /= 0) .and. LFlagAnd
          LFlagOr = (l_nm(k,m) /= 0) .or. LFlagOr
        enddo
        if ( (.not. LFlagAnd) .and. LFlagOr ) then
          call MessageNotify &
            ('E','w_Interpolate_array00','Invalid spectral data for m nonzedo')
        endif
      end do

      do m=1,int(nm)
        LFlagAnd = .true. ; LFlagOr  = .false.
        do k=int(nm),m,-1
          LFlagAnd = (l_nm(k,-m) /= 0) .and. LFlagAnd
          LFlagOr = (l_nm(k,-m) /= 0) .or. LFlagOr
        enddo
        if ( (.not. LFlagAnd) .and. LFlagOr ) then
          call MessageNotify &
            ('E','w_Interpolate_array00','Invalid spectral data for m nonzedo')
        endif
      end do
    endif

    !---- Σa_n^0 P_n^0 の計算
    if ( l_nm(0,0) /= 0 ) then
      y2 = 0 ; y1 = 0
      do k=int(nm),1,-1
        y0 = alpha(k,0,mu) * y1 + beta(k+1,0)*y2 + w_data(l_nm(k,0))
        y2 = y1 ; y1 = y0
      enddo

      AnmPnm = (  beta(1,0) * y2 + mu*sqrt(3.0D0) * y1 &
        + w_data(l_nm(0,0))  ) * Pmm(0,mu)

      !$omp parallel
      !$omp workshare
      gdata = gdata + AnmPnm
      !$omp end workshare
      !$omp end parallel
    endif

    !----  Σ Re[s_n^m] P_n^m exp(imλ)の計算
    do m=1,int(nm)
      if ( l_nm(m,m) /= 0 ) then
        y2 = 0 ; y1 = 0
        do k=int(nm),m+1,-1
          y0 = alpha(k,m,mu) * y1 + beta(k+1,m) * y2 + w_data(l_nm(k,m))
          y2 = y1 ; y1 = y0
        enddo

        AnmPnm =(w_data(l_nm(m,m)) + beta(m+1,m)*y2 &
          + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)

        !$omp parallel do default(shared)
        do i=1,size(alon)
          gdata(i) = gdata(i) + AnmPnm * 2 * cos(m*alon(i))
        enddo
        !$omp end parallel do
      endif
    end do

    !----  Σ Im[s_n^m] P_n^m exp(imλ)の計算
    do m=1,int(nm)
      if ( l_nm(m,-m) /= 0 ) then
        y2 = 0 ; y1 = 0
        do k=int(nm),m+1,-1
          y0 = alpha(k,m,mu) * y1 + beta(k+1,m)*y2 + w_data(l_nm(k,-m))
          y2 = y1 ; y1 = y0
        enddo

        AnmPnm =(w_data(l_nm(m,-m)) + beta(m+1,m)*y2 &
          + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m,mu)

        !$omp parallel do default(shared)
        do i=1,size(alon)
          gdata(i) = gdata(i) - AnmPnm * 2 * sin(m*alon(i))
        enddo
        !$omp end parallel do
      endif
    end do

    CALL MPI_ALLREDUCE(gdata,Interpolate_array10_w,size(alon),&
      MPI_REAL8,MPI_SUM,int(icom),IERR)

  end function Interpolate_array10_w

  !---------------------------------------------------------------------
  !>  漸化式の P_n^m の係数
  function alpha_array0(n,m,x)
    integer, intent(IN) :: n,m
    real(DP), intent(IN) :: x
    real(DP)             :: alpha_array0

    alpha_array0 = sqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n-m+1)*(n+m+1)) ) * x
  end function alpha_array0

  !---------------------------------------------------------------------
  !>  漸化式の P_{n-1}^m の係数
  function beta(n,m)
    integer, intent(IN) :: n,m
    real(DP)             :: beta

    beta = - sqrt( (2.0D0*n+3)*(n+m)*(n-m)/((2*n-1)*(n+m+1)*(n-m+1)) )
  end function beta

  !---------------------------------------------------------------------
  !> ルジャンドル陪函数 P_m^m(x) の計算
  !>
  !> 係数が発散しないように対数で計算する
  function Pmm_array0(m,x)
    integer, intent(IN)  :: m           ! ルジャンドル陪函数の次数
    real(DP), intent(IN) :: x           ! 引き数
    real(DP)             :: Pmm_array0  ! ルジャンドル陪函数の値

    if ( m < 0 ) call MessageNotify('E','Pmm in w_Intepolate_module',&
      'order m should be larger equal to zero')

    Pmm_array0 = 1.0D0
    if ( m > 0 )then
      Pmm_array0 = &
        exp(gammaln(2.0D0*m+2.0)/2.0D0 - m*log(2.0D0) - gammaln(m+1.0D0)) &
        * (1-x**2)**(m/2.0D0)
    endif
  end function Pmm_array0

end module w_mpi_module_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2019-2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム
!
!      微分のテスト
!
!履歴  2019/05/28  竹広真一
!      2020/11/11  竹広真一  セクター計算オプション導入
!
program ut_mpi_module_derivative_mint_test1

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_mint
  use mpi
  implicit none

!!$  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
!!$  integer,parameter  :: mint=1               ! 経度方向対称性
  integer,parameter  :: im=16, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: mint=2               ! 経度方向対称性
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv=2

  real(8), allocatable              :: xvh_Data(:,:,:)
  real(8), allocatable              :: xvh_DData(:,:,:)

  real(8), allocatable              :: uz_Data(:,:)
  real(8), allocatable              :: uz_DData(:,:)

  real(8), allocatable              :: xvh_VLon(:,:,:)
  real(8), allocatable              :: xvh_VLat(:,:,:)
  real(8), allocatable              :: xvh_VRad(:,:,:)
  real(8), allocatable              :: xvh_Div(:,:,:)
  real(8), allocatable              :: xvh_Psi(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer, parameter :: nmin=1, nmax=9

  integer :: n
  integer :: iproc, np, ierr

  !---------------- MPI スタート ---------------------
  !call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_derivative_mint_test1', &
       'ut_mpi_module_mint derivative function test #1')

  call ut_mpi_Initial(im,jm,km,nm,lm,ri,ro,npv=npv,mint=mint)

  allocate(xvh_Data(0:im-1,1:jc,kc))
  allocate(xvh_DData(0:im-1,1:jc,kc))

  allocate(uz_Data(nmc,0:km))
  allocate(uz_DData(nmc,0:km))

  allocate(xvh_VLon(0:im-1,1:jc,kc))
  allocate(xvh_VLat(0:im-1,1:jc,kc))
  allocate(xvh_VRad(0:im-1,1:jc,kc))
  allocate(xvh_Div(0:im-1,1:jc,kc))
  allocate(xvh_Psi(0:im-1,1:jc,kc))

  uz_Data = 0.0D0 ; uz_Data = uz_ut(ut_xvh(xvh_ut(uz_ut(uz_Data))))
  !==================== ut_DivRad_ut ====================
  do n=nmin,nmax
     write(6,*) 'n=',n

     uz_Data = uz_Rad**n
     uz_DData = (n+2)*uz_Rad**(n-1)

     call AssertEqual(&
       message='ut_Divrad_ut with r^n',                             &
       answer = uz_DData,                                           &
       check = uz_ut(ut_DivRad_ut(ut_uz(uz_Data))),                 &
       significant_digits = check_digits, ignore_digits = ignore    &
       )

!!$     xvh_Data = xvh_Rad**n
!!$     xvh_DData = (n+2)*xvh_Rad**(n-1)
!!$
!!$     call AssertEqual(&
!!$       message='ut_Divrat_ut with r^n',                              &
!!$       answer = xvh_DData,                                           &
!!$       check = xvh_ut(ut_DivRad_ut(ut_xvh(xvh_Data))),               &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
  enddo

  !========== xvz_GradLon_ut, xvz_GradLat_ut, wt_Div_xvz_xvz_xvz ==========

  ! ------ r^2 Y_1^0 Toridal field -----
  n = 2
  write(6,*) 'n=',n
  xvh_Psi = xvh_Rad**n * sin(xvh_Lat)                       ! r^2 Y_1^0
  xvh_VRad = 0

  xvh_VLon =  0.0D0
  call AssertEqual(&
       message='xvh_GradLon_ut with r^2 Y_1^0',                      &
       answer = xvh_VLon,                                            &
       check = xvh_GradLon_ut(ut_xvh(xvh_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_VLat = xvh_Rad**(n-1)*cos(xvh_Lat)
  call AssertEqual(&
       message='xvh_GradLat_ut with r^2 Y_1^0',                      &
       answer = xvh_VLat,                                            &
       check = xvh_GradLat_ut(ut_xvh(xvh_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_Div = - 2 * xvh_Psi/xvh_Rad**2
  call AssertEqual(&
       message='ut_Div_xvh_xvh_xvh_ut with Toroiral r^2 Y_1^0',       &
       answer = xvh_Div,                                              &
       check = xvh_ut(ut_Div_xvh_xvh_xvh(xvh_VLon,xvh_VLat,xvh_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore      &
       )

  ! ------ r^2 Y_2^-2 Toridal field -----
  n = 2
  xvh_VRad = 0
  xvh_Psi = xvh_Rad**n * cos(xvh_Lat)**2 * sin(2*xvh_Lon) ! r^2 Y_2^-2

  xvh_VLon =  xvh_Rad**(n-1)*cos(xvh_Lat) * 2*cos(2*xvh_Lon)
  call AssertEqual(&
       message='xvh_GradLon_ut with r^2 Y_2^-2',                     &
       answer = xvh_VLon,                                            &
       check =  xvh_GradLon_ut(ut_xvh(xvh_Psi)),                     &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_VLat = -xvh_Rad**(n-1)*2*cos(xvh_Lat)*sin(xvh_Lat)*sin(2*xvh_Lon)
  call AssertEqual(&
       message='xvh_GradLat_ut with r^2 Y_2^-2',                     &
       answer = xvh_VLat,                                            &
       check = xvh_GradLat_ut(ut_xvh(xvh_Psi)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_Div = - 6* xvh_Psi/xvh_Rad**2
  call AssertEqual(&
       message='ut_Div_xvh_xvh_xvh_ut with Toroiral r2 Y_1^-2',      &
       answer = xvh_Div,                                             &
       check = xvh_ut(ut_Div_xvh_xvh_xvh(xvh_VLon,xvh_VLat,xvh_VRad)),&
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  !==================== ut_DivLon_xyz, ut_DivLat_xyz ====================
  n=2
  write(6,*)'n =',n

  xvh_VLon  = xvh_rad**n * cos(xvh_Lat)**3*sin(2*xvh_Lon)
  xvh_DData = xvh_rad**(n-1)*cos(xvh_Lat)**2* 2*cos(2*xvh_Lon)
  call AssertEqual(&
       message='ut_DivLon_xvh with r^n Y_2^-2 cos^2 φ',             &
       answer = xvh_DData,                                           &
       check = xvh_ut(ut_DivLon_xvh(xvh_VLon)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xvh_VLat   = xvh_rad**n * cos(xvh_Lat)**3*sin(2*xvh_Lon)
  xvh_DData = -4*xvh_rad**(n-1)*cos(xvh_Lat)**2*sin(xvh_Lat)*sin(2*xvh_Lon)
  call AssertEqual(&
       message='ut_DivLat_xvh with r^n Y_2^-2 cos φ',               &
       answer = xvh_DData,                                           &
       check = xvh_ut(ut_DivLat_xvh(xvh_VLat)),                      &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','ut_mpi_module_derivative_test1', &
       'ut_mpi_module_mint derivative function test #1 succeeded!')

  !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ut_mpi_module_derivative_mint_test1

! -*- mode: f90; coding: utf-8 -*-
!-----------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!-----------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief  2次元球面: 球面調和関数展開，MPI並列
!> @details
!> spml/w_mpi_module モジュールは球面上での 2 次元流体運動を
!> 球面調和函数を用いたスペクトル法と MPI 並列化によって数値計算するための
!> Fortran90 関数を提供する.
!>
!> w_mpi_module は実際には以下の下部モジュールからなる．
!> * w_mpi_module_base: 基本変換
!> * w_mpi_module_deriv: 微分計算
!> * w_mpi_module_integral: 積分・平均計算
!> * w_mpi_module_spectrum: スペクトル解析
!> * w_mpi_module_interpolate: 補間計算
!>
!> 内部で ISPACK3 の SYPACK のサブルーチンを呼んでいる.
!> スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!> ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!
! 履歴  2019/03/17  竹広真一
!       2019/10/05  佐々木洋平
!
!>
!> ## 関数・変数の名前と型について
!>
!> ### 命名法
!>
!> * 関数名の先頭 (`w_`, `nm_`, `n_`, `xy_`, `xv_`, `x_`, `y_`, `v_`) は,
!>   返す値の形を示している.
!>   *  `w_` :: スペクトルデータ
!>   * `xy_` :: 2 次元格子点データ
!>   * `xv_` :: 2 次元分散格子点データ
!>   * `nm_` :: スペクトルデータの並んだ 3 次元配列(スペクトルデータの並びは
!>              全波数 n, 帯状波数 m で指定される 2 次元配列)
!>   *  `n_` :: スペクトルデータの並んだ 2 次元配列 (スペクトルデータの並びは
!>              全波数 n で指定される 1 次元配列)
!>   *  `x_` :: 経度方向 1 次元格子点データ
!>   *  `y_` :: 緯度方向 1 次元格子点データ
!>   *  `v_ `:: 緯度方向 1 次元分散格子点データ
!>
!> * 関数名の間の文字列
!>   `DLon`, `GradLat`, `GradLat`, `DivLon`, `DivLat`,
!>   `Lapla`, `LaplaInv`, `Jacobian` は, その関数の作用を表している.
!>
!> * 関数名の最後 (`_w_w`, `_w`, `_xy`, `_x`, `_y`) は,
!>   入力変数の形スペクトルデータおよび格子点データであることを示している.
!>   * `_w`   :: スペクトルデータ
!>   * `_w_w` :: 2 つのスペクトルデータ
!>   * `_xy`  :: 2 次元格子点データ
!>   * `_xv`  :: 2 次元分散格子点データ
!>   * `_x`   :: 経度方向 1 次元格子点データ
!>   * `_y`   :: 緯度方向 1 次元格子点データ
!>   * `_v`   :: 緯度方向 1 次元分散格子点データ
!>
!> ### 各データの種類の説明
!>
!> * 以下 `DP  = kind(1.0D)` である
!>
!> * `xy` : 2 次元格子点データ.
!>   * 変数の種類と次元は `real(DP), dimension(im,jm)`
!>   * `im`, `jm` はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
!>     @ref w_mpi_initial にてあらかじめ設定しておく.
!>
!> * `xv` : 2 次元分散格子点データ.
!>   * 変数の種類と次元は `real(DP), dimension(im,jc)`.
!>   * `im`, `jc` はそれぞれ経度の格子点数および
!>     プロセスで保有する緯度方向の格子点数である.
!>   * `jc` はサブルーチン @ref w_mpi_initial にて設定して
!>     おくことにより設定される public 変数である.
!>
!> * `w` : スペクトルデータ.
!>   * 変数の種類と次元は `real(DP), dimension((nm+1)*(nm+1))`.
!>     `nm` は球面調和函数の最大全波数であり,
!>     サブルーチン @ref w_mpi_initial にてあらかじめ設定しておく.
!>   * スペクトルデータの格納のされ方は
!>     関数  [l_nm](@ref w_mpi_module_base#l_nm),
!>     [nm_l](@ref w_mpi_module_base#nm_l) によって調べることができる.
!>
!> * `nm` : スペクトルデータの並んだ 2 次元配列.
!>   * 変数の種類と次元は `real(DP), dimension(0:nm,-nm:nm)`.
!>     第 1 次元が水平全波数,  第 2 次元が帯状波数を表す.
!>   * `nm` は球面調和函数の最大全波数であり,
!>     サブルーチン w_mpi_initial にてあらかじめ設定しておく.
!>
!> * `n` : スペクトルデータの並んだ 1 次元配列.
!>   * 変数の種類と次元は `real(DP), dimension(0:nm)`.
!>   * 第 1 次元が水平全波数を表す. `nm` は球面調和函数の最大全波数であり,
!>     サブルーチン w_mpi_initial にてあらかじめ設定しておく.
!>
!> * `x`, `y` : 経度, 緯度方向 1 次元格子点データ.
!>   * 変数の種類と次元はそれぞれ `real(DP), dimension(im)`
!>     および `real(DP), dimension(jm)`.
!>
!> * `w_` で始まる関数が返す値はスペクトルデータに同じ.
!>
!> * `xy_` で始まる関数が返す値は 2 次元格子点データに同じ.
!>
!> * `xv_` で始まる関数が返す値は 2 次元分散格子点データに同じ.
!>
!> * `x_`, `y_`, `v_` で始まる関数が返す値は 1 次元格子点データに同じ.
!>
!> * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
!>   微分などを作用させたデータをスペクトル変換したものことである.
!>
!> ## 変数・手続き群の要約
!>
!> ### 初期化・終了処理
!>
!> * @ref w_mpi_initial
!>   : スペクトル変換の格子点数, 波数, 領域の大きさの設定
!> * @ref w_mpi_finalize
!>   : モジュールの終了処理(割り付け配列の解放)をおこなう.
!> * [x_Lon](@ref w_mpi_module_base#x_lon),
!>   [x_Lon_Weight](@ref w_mpi_module_base#x_lon_weight)
!>   : 格子点座標(経度)と重みを格納した 1 次元配列
!> * [y_Lat](@ref w_mpi_module_base#y_lat),
!>   [y_Lat_Weight](@ref w_mpi_module_base#y_lat_weight)
!>   : 格子点座標(緯度)と重みを格納した 1 次元配列
!> * [v_Lat](@ref w_mpi_module_base#v_lat),
!>   [v_Lat_Weight](@ref w_mpi_module_base#v_lat_weight)
!>   : 分散格子点座標(緯度)と重みを格納した 1 次元配列
!> * [xy_Lon](@ref w_mpi_module_base#xy_lon),
!>   [xy_Lat](@ref w_mpi_module_base#xy_lat)
!>   : 格子点データの経度・緯度座標(X,Y), 格子点データ型 2 次元配列
!> * [xv_Lon](@ref w_mpi_module_base#xv_lon),
!>   [xv_Lat](@ref w_mpi_module_base#xv_lat),
!>   : 分散格子点データの経度・緯度座標(X,Y), 格子点データ型 2 次元配列
!>
!> ### 基本変換
!>
!> 格子点データとスペクトルの変換．@ref w_mpi_module_base で定義.
!>
!> * [xv_w](@ref w_mpi_module_base#xv_w)
!>   : スペクトルデータから分散格子データへの変換
!> * [w_xv](@ref w_mpi_module_base#w_xv)
!>   : 分散格子データからスペクトルデータへの変換
!> * [l_nm](@ref w_mpi_module_base#l_nm),
!>   [nm_l](@ref w_mpi_module_base#nm_l)
!>   : スペクトルデータの格納位置と全波数・帯状波数の変換
!> * [w_StreamPotential2VectorMPI]
!>   (@ref w_mpi_module_base#w_streampotential2vectormpi)
!>   : 流線ポテンシャルから速度場計算
!> * [w_Vector2VorDivMPI]
!>   (@ref w_mpi_module_base#w_vector2vordivmpi)
!>   : 速度場から渦度発散を計算
!> * [w_VectorCosLat2VorDivMPI]
!>   (@ref w_mpi_module_base#w_vectorcoslat2vordivmpi)
!>   : 速度場から渦度発散を計算
!>
!> ### 微分
!>
!> 微分演算. @ref w_mpi_module_deriv で定義.
!>
!> * [w_Lapla_w]
!>   (@ref w_mpi_module_deriv#w_lapla_w)
!>   : スペクトルデータにラプラシアンを作用させる
!> * [rn]
!>   (@ref w_mpi_module_deriv#rn)
!>   : スペクトルデータのラプラシアンを計算するための係数.
!> * [w_LaplaInv_w]
!>   (@ref w_mpi_module_deriv#w_laplainv_w)
!>  : スペクトルデータにラプラシアンの逆変換を作用させる
!> * [w_DLon_w]
!>   (@ref w_mpi_module_deriv#w_dlon_w)
!>  : スペクトルデータに経度微分∂/∂λを作用させる
!> * [xv_GradLon_w]
!>   (@ref w_mpi_module_deriv#xv_gradlon_w)
!>  : スペクトルデータに勾配型経度微分
!>  \f$1/\cosφ・∂/∂λ\f$ を作用させる
!> * [xv_GradLat_w]
!>   (@ref w_mpi_module_deriv#xv_gradlat_w)
!>  : スペクトルデータに勾配型緯度微分\f$∂/∂φ\f$を作用させる
!> * [w_DivLon_xv]
!>   (@ref w_mpi_module_deriv#w_divlon_xv)
!>  : 格子データに発散型経度微分
!>  \f$1/\cosφ・∂/∂λ\f$ を作用させる
!> * [w_DivLat_xv]
!>   (@ref w_mpi_module_deriv#w_divlat_xv)
!>   : 格子データに発散型緯度微分
!>   \f$1/\cosφ・∂(g \cosφ)/∂φ\f$ を作用させる
!> * [xv_GradLon_w]
!>   (@ref w_mpi_module_deriv#xv_gradlon_w)
!>   : スペクトルデータに勾配型経度微分
!>   \f$ 1/\cosφ・∂/∂λ\f$ を作用させる
!> * [xv_GradLat_w]
!>   (@ref w_mpi_module_deriv#xv_gradlat_w)
!>   : スペクトルデータに勾配型緯度微分\f$∂/∂φ\f$を作用させる
!> * [w_DivLon_xv]
!>   (@ref w_mpi_module_deriv#w_divlon_xv)
!>   : 格子データに発散型経度微分 \f$1/\cosφ・∂/∂λ\f$を作用させる
!> * [w_DivLat_xv]
!>   (@ref w_mpi_module_deriv#w_divlat_xv)
!>   : 格子データに発散型緯度微分
!>   \f$1/\cosφ・∂(g \cosφ)/∂φ\f$ を作用させる
!> * [w_Div_xv_xv]
!>   (@ref w_mpi_module_deriv#w_div_xv_xv)
!>   : ベクトル成分である 2 つの格子データに発散を作用させる
!> * [w_JacobianMPI_w_w]
!>   (@ref w_mpi_module_deriv#w_jacobianmpi_w_w)
!>   : 2 つのスペクトルデータからヤコビアンを計算する
!>
!> \f$(λ,μ)\f$ 座標(\f$μ=\sinφ)\f$での微分
!>
!>  * [xv_GradLambda_w]
!>   (@ref w_mpi_module_deriv#xv_gradlambda_w)
!>    : スペクトルデータに勾配型経度微分\f$∂/∂λ\f$を作用させる
!>  * [xv_Gradmu_w]
!>   (@ref w_mpi_module_deriv#xv_gradmu_w)
!>    : スペクトルデータに勾配型緯度微分
!>    \f$(1-μ^2)∂/∂μ\f$を作用させる
!>  * [xv_GradLambda_w]
!>   (@ref w_mpi_module_deriv#xv_gradlambda_w)
!>    : スペクトルデータに勾配型経度微分\f$∂/∂λ\f$を作用させる
!>  * [xv_GradMu_w]
!>   (@ref w_mpi_module_deriv#xv_gradmu_w)
!>    : スペクトルデータに勾配型緯度微分
!>    \f$(1-μ^2)∂/∂μ\f$を作用させる
!>  * [w_DivLambda_xv]
!>   (@ref w_mpi_module_deriv#w_divlambda_xv)
!>    : 格子データに発散型経度微分
!>    \f$1/(1-μ^2)・∂/∂λ\f$を作用させる
!>  * [w_DivMu_xv]
!>   (@ref w_mpi_module_deriv#w_divmu_xv)
!>    : 格子データに発散型緯度微分\f$∂/∂μ\f$を作用させる
!>
!> ### 補間
!>
!> 補間. @ref w_mpi_module_interpolate で定義.
!>
!>  * [Interpolate_w]
!>    (@ref w_mpi_module_interpolate#interpolate_w)
!>    : スペクトルデータから任意の点での値を求める.
!>
!> ### 積分・平均
!>
!> @ref w_mpi_module_integral で定義.
!>
!>  * [IntLonLat_xv]
!>    (@ref w_mpi_module_integral#intlonlat_xv)
!>    : 2 次元格子点データの全領域積分
!>  * [avrlonlat_xv]
!>    (@ref w_mpi_module_integral#avrlonlat_xv)
!>    : 2 次元格子点データの全領域平均
!>  * [v_intlon_xv]
!>    (@ref w_mpi_module_integral#v_intlon_xv)
!>    : 2 次元格子点データの経度方向積分
!>  * [v_avrlon_xv]
!>    (@ref w_mpi_module_integral#v_avrlon_xv)
!>    : 2 次元格子点データの経度方向平均
!>  * [intlon_x]
!>    (@ref w_mpi_module_integral#intlon_x)
!>    : 1 次元(x)格子点データの経度方向積分
!>  * [avrlon_x]
!>    (@ref w_mpi_module_integral#avrlon_x)
!>    : 1 次元(x)格子点データの経度方向平均
!>  * [x_intlat_xv]
!>    (@ref w_mpi_module_integral#x_intlat_xv)
!>    : 2 次元格子点データの緯度方向積分
!>  * [x_avrlat_xv]
!>    (@ref w_mpi_module_integral#x_avrlat_xv)
!>    : 2 次元格子点データの緯度方向平均
!>  * [IntLat_v]
!>    (@ref w_mpi_module_integral#intlat_v)
!>    : 1 次元(Y)格子点データの緯度方向積分
!>  * [AvrLat_v]
!>    (@ref w_mpi_module_integral#avrlat_v)
!>    : 1 次元(Y)格子点データの緯度方向平均
!>
!> ### スペクトル解析
!>
!> @ref w_mpi_module_spectrum で定義.
!>
!> * [nm_EnergyFromStreamfunc_w]
!>   (@ref w_mpi_module_spectrum#nm_energyfromstreamfunc_w)
!>   : 流線関数からエネルギースペクトルを計算する
!>   (水平全波数 n, 帯状波数 m 空間)
!> * [n_EnergyFromStreamfunc_w]
!>   (@ref w_mpi_module_spectrum#n_energyfromstreamfunc_w)
!>   : 流線関数からエネルギースペクトルを計算する
!>   (水平全波数 n 空間)
!> * [nm_EnstrophyFromStreamfunc_w]
!>   (@ref w_mpi_module_spectrum#nm_enstrophyfromstreamfunc_w)
!>   : 流線関数からエンストロフィースペクトルを計算する
!>   (水平全波数 n, 帯状波数 m 空間)
!> * [n_EnstrophyFromStreamfunc_w]
!>   (@ref w_mpi_module_spectrum#n_enstrophyfromstreamfunc_w)
!>   : 流線関数からエンストロフィースペクトルを計算する
!>    (水平全波数 n 空間)
!> * [w_spectrum_VMiss]
!>   (@ref w_mpi_module_spectrum#w_spectrum_vmiss)
!>   :  欠損値
module w_mpi_module
  use dc_message, only : MessageNotify
  use w_mpi_module_base, only :    &
    & jc => jl, nc,                &
    & x_Lon, x_Lon_Weight,         &
    & v_Lat, v_Lat_Weight,         &
    & xv_Lon, xv_Lat,              &
    & y_Lat, y_lat_Weight,         &
    & xy_Lon, xy_Lat,              &
    & w_base_mpi_Initial,          &
    & w_base_mpi_Finalize,         &
    & nm_l, l_nm, xv_w, w_xv,      &
    & w_StreamPotential2VectorMPI, &
    & w_Vector2VorDivMPI,          &
    & w_VectorCosLat2VorDivMPI,    &
    & ay_av, av_ay
  use w_mpi_module_deriv, only :    &
    & rn,                           &
    & w_Lapla_w, w_LaplaInv_w,      &
    & w_DLon_w,                     &
    & xv_GradLon_w, xv_GradLat_w,   &
    & w_DivLon_xv, w_DivLat_xv,     &
    & w_Div_xv_xv,                  &
    & w_JacobianMPI_w_w,            &
    & xv_GradLambda_w, xv_GradMu_w, &
    & w_DivLambda_xv, w_DivMu_xv,   &
    & w_deriv_mpi_initial,          &
    & w_deriv_mpi_Finalize
  use w_mpi_module_integral
  use w_mpi_module_interpolate
  use w_mpi_module_spectrum

  implicit none
  private

  public jc                                   ! 緯度方向分散格子点数
  public nc                                   ! スペクトル分散格子点数

  public w_mpi_Initial                        ! 初期化
  public w_mpi_Finalize                       ! 終了処理

  public x_Lon, x_Lon_Weight                  ! 経度分散格子座標・重み
  public v_Lat, v_Lat_Weight                  ! 経度分散格子座標・重み
  public y_Lat, y_Lat_Weight                  ! 経度分散格子座標・重み
  public xv_Lon, xv_Lat                       ! 分散格子座標(im,jc)
  public xy_Lon, xy_Lat                       ! 全格子座標(im,jm)
  public l_nm, nm_l                           ! 波数格納位置
  public xv_w, w_xv                           ! 変換関数
  public w_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算
  public ay_av, av_ay                         ! 分散データ/全データ変換

  public rn                                   ! ラプラシアン演算用配列
  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xv_GradLon_w, xv_GradLat_w           ! 勾配型微分
  public w_DivLon_xv, w_DivLat_xv             ! 発散型微分
  public w_Div_xv_xv                          ! 発散型微分
  public w_JacobianMPI_w_w                    ! ヤコビアン
  public xv_GradLambda_w, xv_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xv, w_DivMu_xv           ! 発散型微分(λ,μ座標)

  public IntLonLat_xv                         ! 緯度経度積分
  public v_IntLon_xv, IntLon_x                ! 経度積分
  public x_IntLat_xv, IntLat_v                ! 緯度積分
  public AvrLonLat_xv                         ! 緯度経度平均
  public v_AvrLon_xv, AvrLon_x                ! 経度平均
  public x_AvrLat_xv, AvrLat_v                ! 緯度平均

  !> 補間関数
  public Interpolate_w

  public nm_EnergyFromStreamfunc_w            ! エネルギースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_w             ! エネルギースペクトル
                                              ! (水平全波数 n 空間)
  public nm_EnstrophyFromStreamfunc_w         ! エンストロフィースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_w          ! エンストロフィースペクトル
                                              ! (水平全波数 n 空間)
  public w_spectrum_VMiss                     ! 欠損値

contains

  !----------------------------------------------------------
  !> スペクトル変換の格子点数, 波数および OPENMP 使用時の
  !> 最大スレッド数を設定する.
  !>
  !> 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
  !> しなければならない.
  !>
  !> np_in に 1 より大きな値を指定すれば ISPACK の球面調和函数変換
  !> OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには,
  !> 実行時に環境変数 OMP_NUM_THREADS を np_in 以下の数字に設定する等の
  !> システムに応じた準備が必要となる.
  !>
  !> np_in に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
  !----------------------------------------------------------
  subroutine w_mpi_initial(n_in,i_in,j_in,np_in)
    !> 格子点数(東西)
    integer,intent(in) :: i_in
    !> 格子点数(南北)
    integer,intent(in) :: j_in
    !> 切断波数の設定
    integer,intent(in) :: n_in
    !> OPENMP での最大スレッド数
    integer,intent(in), optional :: np_in

    if ( present (np_in) ) then
      call MessageNotify('M','w_mpi_base_Initial', &
        'Optional argument "NP_IN" is dummy in w_mpi_module')
      call w_base_mpi_initial(n_in,i_in,j_in)
    else
      call w_base_mpi_initial(n_in,i_in,j_in)
    endif

    call w_deriv_mpi_initial

    call MessageNotify('M','w_mpi_initial', &
      'w_mpi_module (2019/03/17) is initialized')

  end subroutine w_mpi_initial

  !----------------------------------------------------------
  !> モジュールの終了処理(割り付け配列の解放)をおこなう.
  !>
  !> 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
  !> おこなったのちに再度 w_mpi_Initial で初期設定しなければ
  !> ならない.
  !----------------------------------------------------------
  subroutine w_mpi_Finalize
    call w_base_mpi_Finalize
    call w_deriv_mpi_Finalize

    call MessageNotify('M','w_mpi_Finalize',&
      'w_mpi_module (2019/03/21) is finalized')

  end subroutine w_mpi_Finalize

end module w_mpi_module

!----------------------------------------------------------------------
!     Copyright (c) 2011 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module テストプログラム (補間計算)
!
!履歴  2011/12/03  竹広真一
!
program et_test_interpolate

  use et_module
  use dc_test
  implicit none

  integer, parameter :: im = 32,  km=10
  integer, parameter :: jm = 16,  lm=10
  real(8), parameter :: xmin=0.0, xmax=2.0
  real(8), parameter :: ymin=0.0, ymax=1.0
  
  real(8)            :: yx_Data(0:jm,0:im-1)
  real(8)            :: et_Data(-km:km,0:lm)

  real(8)            :: xobs = 0.3d0,  yobs=0.2d0
  real(8)            :: PI

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  PI = 4.0D0 * atan(1.0D0)

  call et_Initial(im,jm,km,lm,xmin,xmax,ymin,ymax)

  yx_Data = sin(PI*yx_X)**2 * sin(PI*yx_Y)  
  et_Data = et_yx(yx_Data)

  call AssertEqual(&
    message = '2-dim Interpolation ',                           &
    answer = sin(PI*xobs)**2*sin(PI*yobs),                      &
    check =  Interpolate_et(et_Data,xobs,yobs),                 &
    significant_digits = check_digits, ignore_digits = ignore   &
  )

end program et_test_interpolate

!----------------------------------------------------------------------
!     Copyright (C) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム
!
!      トロイダルポテンシャルの境界値問題
!
!履歴  2019/05/29  竹広真一
!
program ut_mpi_module_test_torvelbc_tau

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=10         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv = 2
  integer :: iproc, np, ierr

  real(8), allocatable :: xvh_TorVel0(:,:,:)
  real(8), allocatable :: xvh_TorVel(:,:,:)
  real(8), allocatable :: ut_TorVel(:,:)
  real(8), allocatable :: xvh_Zero(:,:,:)
  real(8), allocatable :: xvh_True(:,:,:)

  character(len=2), dimension(4) :: BCond=(/'FF','FR','RF','RR'/)


  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: l

  !---------------- MPI スタート ---------------------
  !call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_torvelbc_test', &
       'ut_mpi_module wt_TorgBoundariesTau subroutine test')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro,npv=npv)

  allocate(xvh_TorVel0(0:im-1,jc,kc))
  allocate(xvh_TorVel(0:im-1,jc,kc))
  allocate(ut_TorVel(nmc,0:lm))
  allocate(xvh_Zero(0:im-1,jc,kc))
  allocate(xvh_True(0:im-1,jc,kc))

  xvh_Zero = 0.0D0

  do l=1,4

     ! P_10
     !xvh_TorVel = sin(xvh_lat) * cos( pi*(xvh_rad-ri)/(ro-ri) )
     ! P_1_1
     !xvh_TorVel = cos(xvh_lat)*cos(xvh_lon)* cos( pi*(xvh_rad-ri)/(ro-ri) )
     !xvh_TorVel = 2*sin(xvh_lat)**2 * cos( pi*(xvh_rad-ri)/(ro-ri) )

     select case (BCOND(l))
     case ('FF')
        xvh_TorVel = sin(xvh_Lat) * xvh_Rad * (xvh_Rad-ri)**2 * (xvh_Rad-ro)**2
     case('FR')
        xvh_TorVel = cos(xvh_lat)*cos(xvh_lon) * xvh_Rad * (xvh_Rad-ri) * (xvh_Rad-ro)**2
     case('RF')
        xvh_TorVel = 2*sin(xvh_lat)**2 * xvh_Rad * (xvh_Rad-ri)**2 * (xvh_Rad-ro)
     case('RR')
        xvh_TorVel = sin(xvh_Lat) * xvh_Rad * (xvh_Rad-ri) * (xvh_Rad-ro)
     end select

     xvh_TorVel0 = xvh_TorVel
     ut_TorVel = ut_xvh(xvh_TorVel)
     call ut_TorBoundariesTau(ut_TorVel,cond=BCond(l),new=.true.)
     xvh_TorVel = xvh_ut(ut_TorVel)

     ! 内部チェック
     call AssertEqual(&
          message='ut_TorBoundariesTau_ut (intenal value)',            &
          answer = xvh_Torvel(:,:,2:kc-1),                              &
          check = xvh_Torvel0(:,:,2:kc-1),                              &
          significant_digits = check_digits, ignore_digits = ignore     &
          )

     ! 上端境界チェック
     if( BCond(l)(1:1) == 'F' ) then
        xvh_True = xvh_ut(ut_DRad_ut(ut_xvh(xvh_TorVel/xvh_Rad)))
     else
        xvh_True = xvh_TorVel
     endif

     if ( ks == 0 ) then
        call AssertEqual(&
             message='ut_TorvelBoundariesTau_ut ('//BCond(l)//'-Top B.C)',&
             answer = xvh_Zero(:,:,1),                                     &
             check = xvh_True(:,:,1),                                      &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     else
        call AssertEqual(&
             message='ut_TorvelBoundariesTau_ut ('//BCond(l)//'-Top B.C)',&
             answer = xvh_Torvel(:,:,1),                                   &
             check = xvh_Torvel0(:,:,1),                                   &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif

     ! 下端境界チェック
     if( BCond(l)(2:2) == 'F' ) then
        xvh_True = xvh_ut(ut_DRad_ut(ut_xvh(xvh_TorVel/xvh_Rad)))
     else
        xvh_True = xvh_TorVel
     endif

     if ( ke == km ) then
        call AssertEqual(&
             message='ut_TorvelBoundariesTau_ut ('//BCond(l)//'-Bottom B.C)',&
             answer = xvh_Zero(:,:,kc),                                    &
             check = xvh_True(:,:,kc),                                     &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     else
        call AssertEqual(&
             message='ut_TorvelBoundariesTau_ut ('//BCond(l)//'-Bottom B.C)',&
             answer = xvh_Torvel(:,:,kc),                                  &
             check = xvh_Torvel0(:,:,kc),                                  &
             significant_digits = check_digits, ignore_digits = ignore     &
             )
     endif
  enddo

  call MessageNotify('M','ut_mpi_module_torvelbc_test', &
       'ut_mpi_module  ut_TorvelBoundariesTau subroutine test succeeded!')

  !------ MPIの終了 ------
  call MPI_FINALIZE(IERR)

end program ut_mpi_module_test_torvelbc_tau

!--
!----------------------------------------------------------------------
!     Copyright (c) 2019 SPMODEL Development Group.
!----------------------------------------------------------------------
!表題  wb_interpolate_mpi_module
!
!  spml/wb_interpolate_mpi_module モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための
!  モジュール wb_mpi_module の下部モジュールであり, スペクトル法による
!  補間計算のための Fortran90 関数を提供する.
!
!  補間計算の方法については doc/wa_module.tex を参照のこと.
!  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!
!履歴  2020/08/02  竹広真一
!
!++
module wb_mpi_module_interpolate
  !
  !=  wb_mpi_module_interpolate
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: wb_mpi_module_interpolate.f90 590 2013-08-19 08:48:21Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/wb_interpolate_mpi_module モジュールは球面上での 2 次元流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための
  !  モジュール wb_mpi_module の下部モジュールであり, スペクトル法による
  !  補間計算のための Fortran90 関数を提供する.
  !
  !  補間計算の方法については doc/wa_module.tex を参照のこと.
  !  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use w_mpi_module_interpolate
  use wb_mpi_module_base, only : nc, km, kc
  implicit none
  private

  public b_Interpolate_wb                        ! 補間関数

  interface b_Interpolate_wb
     !
     ! 緯度 alon, 経度 alat における関数値を
     ! その球面調和変換係数 wb_data から補間計算する
     !
     ! 入力する緯度経度座標は,
     !       １点, 経度1点緯度複数点, 経度複数点緯度1点, 経度緯度複数点
     ! の 4 種類
     !
     module procedure b_Interpolate_array00_wb
  end interface

  contains

  !--------------- 補間計算 -----------------
    function b_Interpolate_array00_wb(wb_data,alon,alat)
      !
      ! 緯度 alat, 経度 alon における関数値を
      ! その球面調和変換係数 wb_data から補間計算する
      !
      real(8), intent(IN) :: wb_data(nc,kc)         ! スペクトルデータ
      real(8), intent(IN) :: alon                   ! 補間する位置(経度)
      real(8), intent(IN) :: alat                   ! 補間する位置(緯度)
      real(8) :: b_Interpolate_array00_wb(kc)       ! 補間した値

      integer :: k

      do k=1,kc
         b_Interpolate_array00_wb(k) = Interpolate_w(wb_data(:,k),alon,alat)
      end do

    end function b_Interpolate_array00_wb

end module wb_mpi_module_interpolate

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXINMC(MM,NT,C,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NT,M,IS,MI
  INTEGER(8) :: N1,M1,MN,NS,K
!!$  REAL(8) :: C((2*NT-MM+1)*(MM+1))
  REAL(8) :: C((MM/MI+1)*(2*(NT+1)-MM/MI*MI))
  INTEGER(8) :: NPMAX

  CALL MXGOMP(NPMAX)  

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  !$omp parallel private(NS,M) num_threads(NPMAX)
  !$omp do schedule(dynamic)
  DO K=0,MN-1
     M=K*MI
     NS=K*(2*(NT+1)-(K-1)*MI)+1
     CALL LXINIC(NT,M,C(NS))
  END DO
  !$omp end do
  !$omp end parallel

END SUBROUTINE SXINMC

!--
!----------------------------------------------------------------------
!     Copyright (c) 2019-2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  ua_deriv_mpi_module_sypack
!
!  spml/ua_deriv_mpi_module_sypack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための
!  モジュール ua_mpi_module_sypack の下部モジュールであり, スペクトル法の
!  微分計算のための Fortran90 関数を提供する.
!
!  球面上の 1 層モデル用 u_deriv_mpi_module_sypack モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!
!履歴  2019/04/30  竹広真一
!      2020/08/05  竹広真一  xvb <=> pva と wb 関数を追加
!      2020/08/11  竹広真一  bug fixed
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
module ua_mpi_module_deriv
  !
  != ua_mpi_module_deriv
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/ua_mpi_module_deriv モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための
  !  モジュール ua_mpi_module の下部モジュールであり, スペクトル法の
  !  微分計算のための Fortran90 関数を提供する.
  !
  !  球面上の 1 層モデル用 u_deriv_mpi_module モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
  !
  use dc_types, only: DP
  use dc_message, only : MessageNotify
  use w_mpi_module_base, only : im, jm, nm=>nn, jc=>jl
  use w_mpi_module_deriv
  use ua_mpi_module_base, only : &
       & pva_ua, ua_pva, xvb_ua, ua_xvb, pva_wb, wb_pva, &
       & xv_u, u_xv, pv_w, w_pv, pv_u, u_pv, &
       & ic, nc, nmc, nms, nme, kc, km, ua_wb, wb_ua, ua_wa, wa_ua

  implicit none

  real(DP), allocatable  :: rnu(:,:)
  ! ラプラシアン演算用配列(u_module と互換性を保つため)
  !
  ! スペクトルデータのラプラシアンを計算するための係数
  ! 配列のサイズは(nmc, 2)
  !
  ! r(L,1) には L 番目の格納位置のスペクトルに対するラプラシアン計算の
  ! 係数 -n(n+1) の値が格納されている.

  ! private im, jm, nm, nc, kc                  ! for Intel Fortran
  private

  public ua_deriv_mpi_Initial
  public ua_deriv_mpi_Finalize

  public ua_Lapla_ua, ua_LaplaInv_ua          ! ラプラシアンと逆演算
  public ua_DLon_ua                           ! 経度微分
  public pva_GradLon_ua, pva_GradLat_ua       ! 勾配型微分
  public xvb_GradLon_ua, xvb_GradLat_ua       ! 勾配型微分
  public ua_DivLon_pva, ua_DivLat_pva         ! 発散型微分
  public ua_DivLon_xvb, ua_DivLat_xvb         ! 発散型微分
  public ua_Div_pva_pva                       ! 発散型微分
  public ua_Div_xvb_xvb                       ! 発散型微分
  public ua_JacobianMPI_ua_ua                 ! ヤコビアン
  public pva_GradLambda_ua, pva_GradMu_ua     ! 勾配型微分(λ,μ座標)
  public xvb_GradLambda_ua, xvb_GradMu_ua     ! 勾配型微分(λ,μ座標)
  public ua_DivLambda_pva, ua_DivMu_pva       ! 発散型微分(λ,μ座標)
  public ua_DivLambda_xvb, ua_DivMu_xvb       ! 発散型微分(λ,μ座標)

  public wb_Lapla_wb, wb_LaplaInv_wb          ! ラプラシアンと逆演算
  public wb_DLon_wb                           ! 経度微分
  public pva_GradLon_wb, pva_GradLat_wb       ! 勾配型微分
  public wb_DivLon_pva, wb_DivLat_pva         ! 発散型微分
  public wb_Div_pva_pva                       ! 発散型微分
  public wb_JacobianMPI_wb_wb                 ! ヤコビアン
  public pva_GradLambda_wb, pva_GradMu_wb     ! 勾配型微分(λ,μ座標)
  public wb_DivLambda_pva, wb_DivMu_pva       ! 発散型微分(λ,μ座標)

  public u_Lapla_u, u_LaplaInv_u              ! ラプラシアンと逆演算
  public u_DLon_u                             ! 経度微分
  public pv_GradLon_u, pv_GradLat_u           ! 勾配型微分
  public xv_GradLon_u, xv_GradLat_u           ! 勾配型微分
  public u_DivLon_pv, u_DivLat_pv             ! 発散型微分
  public u_DivLon_xv, u_DivLat_xv             ! 発散型微分
  public u_Div_pv_pv                          ! 発散型微分
  public u_Div_xv_xv                          ! 発散型微分  
  public u_JacobianMPI_u_u                    ! ヤコビアン
  public pv_GradLambda_u, pv_GradMu_u         ! 勾配型微分(λ,μ座標)
  public xv_GradLambda_u, xv_GradMu_u         ! 勾配型微分(λ,μ座標)
  public u_DivLambda_pv, u_DivMu_pv           ! 発散型微分(λ,μ座標)
  public u_DivLambda_xv, u_DivMu_xv           ! 発散型微分(λ,μ座標)

  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public pv_GradLon_w, pv_GradLat_w           ! 勾配型微分
  public w_DivLon_pv, w_DivLat_pv             ! 発散型微分
  public w_Div_pv_pv                          ! 発散型微分
  public w_JacobianMPI_w_w                    ! ヤコビアン
  public pv_GradLambda_w, pv_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_pv, w_DivMu_pv           ! 発散型微分(λ,μ座標)
  
  public rn, rnu                              ! ラプラシアン演算用配列

contains

    !--------------- 初期化 -----------------
    subroutine ua_deriv_mpi_initial
      !
      ! スペクトル微分計算に必要となる作業領域を設定する.
      !
      ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで
      ! 初期設定をしなければならない.
      !
      ! 上位サブルーチン ua_mpi_Initial を使用すること.
      !

      call w_deriv_mpi_initial

      allocate(rnu(nmc,2))                    ! ラプラシアン演算用配列
      rnu = rn(nms:nme,:)

      call MessageNotify('M','ua_deriv_mpi_initial', &
           'ua_mpi_module_deriv (2020/08/11)is initialized')

    end subroutine ua_deriv_mpi_initial

    !--------------- 微分計算(ua, 多層) -----------------
    function ua_Lapla_ua(ua_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: ua_data(:,:)
      !(in) 入力スペクトルデータ
      real(DP)              :: ua_lapla_ua(nmc,size(ua_data,2))
      !(out) 入力スペクトルデータのラプラシアン
      integer :: k

      do k=1,size(ua_data,2)
         ua_Lapla_ua(:,k) = rnu(:,1)*ua_data(:,k)
      enddo

    end function ua_Lapla_ua

    function ua_LaplaInv_ua(ua_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: ua_data(:,:)
      !(in) 入力スペクトルデータ
      real(DP)              :: ua_LaplaInv_ua(nmc,size(ua_data,2))
      !(out) スペクトルデータの逆ラプラシアン
      integer :: k

      do k=1,size(ua_data,2)
         ua_LaplaInv_ua(:,k) = rnu(:,2)*ua_data(:,k)
      enddo

    end function ua_LaplaInv_ua

    function ua_DLon_ua(ua_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(多層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: ua_data(:,:)
      !(in) 入力スペクトルデータ
      real(DP)              :: ua_DLon_ua(nmc,size(ua_data,2))
      !(out) スペクトルデータの経度微分
      integer :: k

      real(DP) :: wb_data(nc,kc)

      wb_data = wb_ua(ua_data)
      do k=1,kc
         wb_data(:,k) = w_DLon_w(wb_data(:,k))
      enddo
      ua_DLon_ua = ua_wb(wb_data)

    end function ua_DLon_ua

    function pva_GradLon_ua(ua_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(DP), intent(in)  :: ua_data(nmc,km)
      !(in) 入力スペクトルデータ
      real(DP)              :: pva_GradLon_ua(0:ic-1,jc,km)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      pva_GradLon_ua = pva_ua(ua_data,ipow=1,iflag=-1)

    end function pva_GradLon_ua

    function xvb_GradLon_ua(ua_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(DP), intent(in)  :: ua_data(nmc,km)
      !(in) 入力スペクトルデータ
      real(DP)              :: xvb_GradLon_ua(0:im-1,jc,kc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xvb_GradLon_ua = xvb_ua(ua_data,ipow=1,iflag=-1)

    end function xvb_GradLon_ua

    function pva_GradLat_ua(ua_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: ua_data(nmc,km)
      !(in) 入力スペクトルデータ
      real(DP)              :: pva_GradLat_ua(0:ic-1,jc,km)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      pva_GradLat_ua = pva_ua(ua_data,ipow=1,iflag=1)

    end function pva_GradLat_ua

    function xvb_GradLat_ua(ua_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: ua_data(nmc,km)
      !(in) 入力スペクトルデータ
      real(DP)              :: xvb_GradLat_ua(0:im-1,jc,kc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xvb_GradLat_ua = xvb_ua(ua_data,ipow=1,iflag=1)

    end function xvb_GradLat_ua

    function ua_DivLon_pva(pva_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pva_data(0:ic-1,jc,kc)
      !(in) 入力格子点データ
      real(DP)              :: ua_DivLon_pva(nmc,km)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      ua_DivLon_pva = ua_pva(pva_data,ipow=1,iflag=-1)

    end function ua_DivLon_pva
    
    function ua_DivLon_xvb(xvb_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: xvb_data(0:im-1,jc,kc)
      !(in) 入力格子点データ
      real(DP)              :: ua_DivLon_xvb(nmc,km)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      ua_DivLon_xvb = ua_xvb(xvb_data,ipow=1,iflag=-1)

    end function ua_DivLon_xvb
    
    function ua_DivLat_pva(pva_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pva_data(0:ic-1,jc,kc)
      !(in) 入力格子点データ
      real(DP)              :: ua_DivLat_pva(nmc,km)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      ua_DivLat_pva = ua_pva(pva_data,ipow=1,iflag=1)

    end function ua_DivLat_pva

    function ua_DivLat_xvb(xvb_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: xvb_data(0:im-1,jc,kc)
      !(in) 入力格子点データ
      real(DP)              :: ua_DivLat_xvb(nmc,km)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      ua_DivLat_xvb = ua_xvb(xvb_data,ipow=1,iflag=1)

    end function ua_DivLat_xvb

    function ua_Div_pva_pva(pva_u,pva_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し,
      ! スペクトルデータとして返す(多層用).
      !
      real(DP), intent(in)  :: pva_u(0:ic-1,jc,kc)
      !(in) ベクトル経度成分の格子点データ
      real(DP), intent(in)  :: pva_v(0:ic-1,jc,kc)
      !(in) ベクトル緯度成分の格子点データ
      real(DP)              :: ua_Div_pva_pva(nmc,km)
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      ua_Div_pva_pva = ua_DivLon_pva(pva_u) + ua_DivLat_pva(pva_v)

    end function ua_Div_pva_pva

    function ua_Div_xvb_xvb(xvb_u,xvb_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し,
      ! スペクトルデータとして返す(多層用).
      !
      real(DP), intent(in)  :: xvb_u(0:im-1,jc,kc)
      !(in) ベクトル経度成分の格子点データ
      real(DP), intent(in)  :: xvb_v(0:im-1,jc,kc)
      !(in) ベクトル緯度成分の格子点データ
      real(DP)              :: ua_Div_xvb_xvb(nmc,km)
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      ua_Div_xvb_xvb = ua_DivLon_xvb(xvb_u) + ua_DivLat_xvb(xvb_v)

    end function ua_Div_xvb_xvb

    function ua_JacobianMPI_ua_ua(ua_a,ua_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(多層用).
      !
      real(DP), intent(in) :: ua_a(nmc,km)
      !(in) 1つ目の入力スペクトルデータ
      real(DP), intent(in) :: ua_b(nmc,km)
      !(in) 2つ目の入力スペクトルデータ
      real(DP)             :: ua_JacobianMPI_ua_ua(nmc,km)
      !(out) 2 つのスペクトルデータのヤコビアン
      integer :: k

      real(DP) :: wb_a(nc,kc)
      real(DP) :: wb_b(nc,kc)

      wb_a = wb_ua(ua_a) ; wb_b = wb_ua(ua_b)

      do k=1,kc
         wb_a(:,k) = w_JacobianMPI_w_w(wb_a(:,k),wb_b(:,k))
      end do

      ua_JacobianMPI_ua_ua = ua_wb(wb_a)

    end function ua_JacobianMPI_ua_ua

    !--------------- 微分計算(wb 多層) -----------------
    function wb_Lapla_wb(wb_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: wb_data(:,:)
      !(in) 入力スペクトルデータ
      real(DP)              :: wb_lapla_wb(nc,size(wb_data,2))
      !(out) 入力スペクトルデータのラプラシアン
      integer :: k

      do k=1,size(wb_data,2)
         wb_Lapla_wb(:,k) = rn(:,1)*wb_data(:,k)
      enddo

    end function wb_Lapla_wb

    function wb_LaplaInv_wb(wb_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: wb_data(:,:)
      !(in) 入力スペクトルデータ
      real(DP)              :: wb_LaplaInv_wb(nc,size(wb_data,2))
      !(out) スペクトルデータの逆ラプラシアン
      integer :: k

      do k=1,size(wb_data,2)
         wb_LaplaInv_wb(:,k) = rn(:,2)*wb_data(:,k)
      enddo

    end function wb_LaplaInv_wb

    function wb_DLon_wb(wb_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(多層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: wb_data(:,:)
      !(in) 入力スペクトルデータ
      real(DP)              :: wb_DLon_wb(nc,size(wb_data,2))
      !(out) スペクトルデータの経度微分
      integer :: k

      do k=1,kc
         wb_DLon_wb(:,k) = w_DLon_w(wb_data(:,k))
      enddo

    end function wb_DLon_wb

    function pva_GradLon_wb(wb_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(DP), intent(in)  :: wb_data(nc,kc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pva_GradLon_wb(0:ic-1,jc,km)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      pva_GradLon_wb = pva_wb(wb_data,ipow=1,iflag=-1)

    end function pva_GradLon_wb

    function pva_GradLat_wb(wb_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: wb_data(nc,kc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pva_GradLat_wb(0:ic-1,jc,km)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      pva_GradLat_wb = pva_wb(wb_data,ipow=1,iflag=1)

    end function pva_GradLat_wb

    function wb_DivLon_pva(pva_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pva_data(0:ic-1,jc,km)
      !(in) 入力格子点データ
      real(DP)              :: wb_DivLon_pva(nc,kc)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      wb_DivLon_pva = wb_pva(pva_data,ipow=1,iflag=-1)

    end function wb_DivLon_pva

    function wb_DivLat_pva(pva_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pva_data(0:ic-1,jc,km)
      !(in) 入力格子点データ
      real(DP)              :: wb_DivLat_pva(nc,kc)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      wb_DivLat_pva = wb_pva(pva_data,ipow=1,iflag=1)

    end function wb_DivLat_pva

    function wb_Div_pva_pva(pva_u,pva_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し,
      ! スペクトルデータとして返す(多層用).
      !
      real(DP), intent(in)  :: pva_u(0:ic-1,jc,km)
      !(in) ベクトル経度成分の格子点データ
      real(DP), intent(in)  :: pva_v(0:ic-1,jc,km)
      !(in) ベクトル緯度成分の格子点データ
      real(DP)              :: wb_Div_pva_pva(nc,kc)
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      wb_Div_pva_pva = wb_DivLon_pva(pva_u) + wb_DivLat_pva(pva_v)

    end function wb_Div_pva_pva

    function wb_JacobianMPI_wb_wb(wb_a,wb_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(多層用).
      !
      real(DP), intent(in) :: wb_a(nc,kc)
      !(in) 1つ目の入力スペクトルデータ
      real(DP), intent(in) :: wb_b(nc,kc)
      !(in) 2つ目の入力スペクトルデータ
      real(DP)             :: wb_JacobianMPI_wb_wb(nc,kc)
      !(out) 2 つのスペクトルデータのヤコビアン
      integer :: k

      do k=1,kc
         wb_JacobianMPI_wb_wb(:,k) = w_JacobianMPI_w_w(wb_a(:,k),wb_b(:,k))
      end do

    end function wb_JacobianMPI_wb_wb

    !--------------- 微分計算(u 一層) -----------------
    function u_Lapla_u(u_data)
      !
      ! 入力スペクトルデータにラプラシアン
      !
      !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータのラプラシアンとは, 対応する格子点データに
      ! ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: u_data(:)
      !(in) 入力スペクトルデータ
      real(DP)              :: u_lapla_u(nmc)
      !(out) 入力スペクトルデータのラプラシアン

      u_Lapla_u = rnu(:,1)*u_data

    end function u_Lapla_u

    function u_LaplaInv_u(u_data)
      !
      ! 入力スペクトルデータに逆ラプラシアン
      !
      !    ▽^{-2}
      !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
      !
      ! を作用する(多層用).
      !
      ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
      ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: u_data(:)
      !(in) 入力スペクトルデータ
      real(DP)              :: u_LaplaInv_u(nmc)
      !(out) スペクトルデータの逆ラプラシアン

      u_LaplaInv_u = rnu(:,2)*u_data

    end function u_LaplaInv_u

    function u_DLon_u(u_data)
      !
      ! スペクトルデータに経度微分 ∂/∂λ を作用させる(多層用).
      !
      ! スペクトルデータの経度微分とは, 対応する格子点データに
      ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
      !
      real(DP), intent(in)  :: u_data(:)
      !(in) 入力スペクトルデータ
      real(DP)              :: u_DLon_u(nmc)
      !(out) スペクトルデータの経度微分

      real(DP) :: ua_data(nmc,1)

      ua_data(:,1) = u_data
      ua_data = ua_DLon_ua(ua_data)
      u_DLon_u = ua_data(:,1)

    end function u_DLon_u

    function pv_GradLon_u(u_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(DP), intent(in)  :: u_data(nmc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pv_GradLon_u(0:ic-1,jc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      pv_GradLon_u = pv_u(u_data,ipow=1,iflag=-1)

    end function pv_GradLon_u

    function xv_GradLon_u(u_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(DP), intent(in)  :: u_data(nmc)
      !(in) 入力スペクトルデータ
      real(DP)              :: xv_GradLon_u(0:im-1,jc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xv_GradLon_u = xv_u(u_data,ipow=1,iflag=-1)

    end function xv_GradLon_u

    function pv_GradLat_u(u_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: u_data(nmc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pv_GradLat_u(0:ic-1,jc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      pv_GradLat_u = pv_u(u_data,ipow=1,iflag=1)

    end function pv_GradLat_u

    function xv_GradLat_u(u_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: u_data(nmc)
      !(in) 入力スペクトルデータ
      real(DP)              :: xv_GradLat_u(0:im-1,jc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xv_GradLat_u = xv_u(u_data,ipow=1,iflag=1)

    end function xv_GradLat_u

    function u_DivLon_pv(pv_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pv_data(0:ic-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: u_DivLon_pv(nmc)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      u_DivLon_pv = u_pv(pv_data,ipow=1,iflag=-1)

    end function u_DivLon_pv

    function u_DivLon_xv(xv_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: xv_data(0:im-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: u_DivLon_xv(nmc)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      u_DivLon_xv = u_xv(xv_data,ipow=1,iflag=-1)

    end function u_DivLon_xv

    function u_DivLat_pv(pv_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pv_data(0:ic-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: u_DivLat_pv(nmc)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      u_DivLat_pv = u_pv(pv_data,ipow=1,iflag=1)

    end function u_DivLat_pv

    function u_DivLat_xv(xv_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: xv_data(0:im-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: u_DivLat_xv(nmc)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      u_DivLat_xv = u_xv(xv_data,ipow=1,iflag=1)

    end function u_DivLat_xv

    function u_Div_pv_pv(pv_Uvel,pv_Vvel)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し,
      ! スペクトルデータとして返す(多層用).
      !
      real(DP), intent(in)  :: pv_Uvel(0:ic-1,jc)
      !(in) ベクトル経度成分の格子点データ
      real(DP), intent(in)  :: pv_Vvel(0:ic-1,jc)
      !(in) ベクトル緯度成分の格子点データ
      real(DP)              :: u_Div_pv_pv(nmc)
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      u_Div_pv_pv = u_DivLon_pv(pv_Uvel) + u_DivLat_pv(pv_Vvel)

    end function u_Div_pv_pv

    function u_Div_xv_xv(xv_Uvel,xv_Vvel)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し,
      ! スペクトルデータとして返す(多層用).
      !
      real(DP), intent(in)  :: xv_Uvel(0:im-1,jc)
      !(in) ベクトル経度成分の格子点データ
      real(DP), intent(in)  :: xv_Vvel(0:im-1,jc)
      !(in) ベクトル緯度成分の格子点データ
      real(DP)              :: u_Div_xv_xv(nmc)
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      u_Div_xv_xv = u_DivLon_xv(xv_Uvel) + u_DivLat_xv(xv_Vvel)

    end function u_Div_xv_xv

    function u_JacobianMPI_u_u(u_a,u_b)
      ! 2 つのスペクトルデータにヤコビアン
      !
      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
      !
      ! を作用させる(多層用).
      !
      real(DP), intent(in) :: u_a(nmc)
      !(in) 1つ目の入力スペクトルデータ
      real(DP), intent(in) :: u_b(nmc)
      !(in) 2つ目の入力スペクトルデータ
      real(DP)             :: u_JacobianMPI_u_u(nmc)
      !(out) 2 つのスペクトルデータのヤコビアン

      real(DP) :: ua_a(nmc,1)
      real(DP) :: ua_b(nmc,1)
      real(DP) :: wa_a(nc,1)
      real(DP) :: wa_b(nc,1)

      ua_a(:,1) = u_a ; ua_b(:,1) = u_b
      wa_a = wa_ua(ua_a) ; wa_b = wa_ua(ua_b)
      wa_a(:,1) = w_JacobianMPI_w_w(wa_a(:,1),wa_b(:,1))
      ua_a = ua_wa(wa_a)
      u_JacobianMPI_u_u = ua_a(:,1)

    end function u_JacobianMPI_u_u

    !--------------- 微分計算(u 一層) -----------------
    
    function pv_GradLon_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
      ! 作用させた格子点データを返す(多層用).
      !
      real(DP), intent(in)  :: w_data(nc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pv_GradLon_w(0:ic-1,jc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      pv_GradLon_w = pv_w(w_data,ipow=1,iflag=-1)

    end function pv_GradLon_w

    function pv_GradLat_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
      ! 格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: w_data(nc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pv_GradLat_w(0:ic-1,jc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      pv_GradLat_w = pv_w(w_data,ipow=1,iflag=1)

    end function pv_GradLat_w

    function w_DivLon_pv(pv_data)
      !
      ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pv_data(0:ic-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: w_DivLon_pv(nc)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      w_DivLon_pv = w_pv(pv_data,ipow=1,iflag=-1)

    end function w_DivLon_pv

    function w_DivLat_pv(pv_data)
      !
      ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pv_data(0:ic-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: w_DivLat_pv(nc)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      w_DivLat_pv = w_pv(pv_data,ipow=1,iflag=1)

    end function w_DivLat_pv

    function w_Div_pv_pv(pv_u,pv_v)
      !
      ! 2 つの入力格子点データをベクトル成分とする発散を計算し,
      ! スペクトルデータとして返す(多層用).
      !
      real(DP), intent(in)  :: pv_u(0:ic-1,jc)
      !(in) ベクトル経度成分の格子点データ
      real(DP), intent(in)  :: pv_v(0:ic-1,jc)
      !(in) ベクトル緯度成分の格子点データ
      real(DP)              :: w_Div_pv_pv(nc)
      !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

      w_Div_pv_pv = w_DivLon_pv(pv_u) + w_DivLat_pv(pv_v)

    end function w_Div_pv_pv

    !--------------- 微分計算 (λ,μ座標系用, ua 多層) -----------------
    function pva_GradLambda_ua(ua_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(DP), intent(in)  :: ua_data(nmc,km)
      !(in) 入力スペクトルデータ
      real(DP)              :: pva_GradLambda_ua(0:ic-1,jc,km)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      pva_GradLambda_ua = pva_ua(ua_data,ipow=0,iflag=-1)

    end function pva_GradLambda_ua

    function xvb_GradLambda_ua(ua_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(DP), intent(in)  :: ua_data(nmc,km)
      !(in) 入力スペクトルデータ
      real(DP)              :: xvb_GradLambda_ua(0:im-1,jc,kc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xvb_GradLambda_ua = xvb_ua(ua_data,ipow=0,iflag=-1)

    end function xvb_GradLambda_ua

    function pva_GradMu_ua(ua_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: ua_data(nmc,km)
      !(in) 入力スペクトルデータ
      real(DP)              :: pva_GradMu_ua(0:ic-1,jc,km)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      pva_GradMu_ua = pva_ua(ua_data,ipow=0,iflag=1)

    end function pva_GradMu_ua

    function xvb_GradMu_ua(ua_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: ua_data(nmc,km)
      !(in) 入力スペクトルデータ
      real(DP)              :: xvb_GradMu_ua(0:im-1,jc,kc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xvb_GradMu_ua = xvb_ua(ua_data,ipow=0,iflag=1)

    end function xvb_GradMu_ua

    function ua_DivLambda_pva(pva_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ)
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pva_data(0:ic-1,jc,km)
      !(in) 入力格子点データ
      real(DP)              :: ua_DivLambda_pva(nmc,km)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      ua_DivLambda_pva = ua_pva(pva_data,ipow=2,iflag=-1)

    end function ua_DivLambda_pva

    function ua_DivLambda_xvb(xvb_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ)
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: xvb_data(0:im-1,jc,kc)
      !(in) 入力格子点データ
      real(DP)              :: ua_DivLambda_xvb(nmc,km)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      ua_DivLambda_xvb = ua_xvb(xvb_data,ipow=2,iflag=-1)

    end function ua_DivLambda_xvb

    function ua_DivMu_pva(pva_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pva_data(0:ic-1,jc,km)
      !(in) 入力格子点データ
      real(DP)              :: ua_DivMu_pva(nmc,km)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      ua_DivMu_pva = ua_pva(pva_data,ipow=2,iflag=1)

    end function ua_DivMu_pva

    function ua_DivMu_xvb(xvb_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: xvb_data(0:im-1,jc,kc)
      !(in) 入力格子点データ
      real(DP)              :: ua_DivMu_xvb(nmc,km)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      ua_DivMu_xvb = ua_xvb(xvb_data,ipow=2,iflag=1)

    end function ua_DivMu_xvb

    !--------------- 微分計算 (λ,μ座標系用, wb 多層) -----------------
    function pva_GradLambda_wb(wb_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(DP), intent(in)  :: wb_data(nc,kc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pva_GradLambda_wb(0:ic-1,jc,km)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      pva_GradLambda_wb = pva_wb(wb_data,ipow=0,iflag=-1)

    end function pva_GradLambda_wb

    function pva_GradMu_wb(wb_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: wb_data(nc,kc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pva_GradMu_wb(0:ic-1,jc,km)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      pva_GradMu_wb = pva_wb(wb_data,ipow=0,iflag=1)

    end function pva_GradMu_wb

    function wb_DivLambda_pva(pva_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ)
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pva_data(0:ic-1,jc,km)
      !(in) 入力格子点データ
      real(DP)              :: wb_DivLambda_pva(nc,kc)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      wb_DivLambda_pva = wb_pva(pva_data,ipow=2,iflag=-1)

    end function wb_DivLambda_pva

    function wb_DivMu_pva(pva_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pva_data(0:ic-1,jc,km)
      !(in) 入力格子点データ
      real(DP)              :: wb_DivMu_pva(nc,kc)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      wb_DivMu_pva = wb_pva(pva_data,ipow=2,iflag=1)

    end function wb_DivMu_pva

    !--------------- 微分計算 (λ,μ座標系用, u 一層) -----------------
    function pv_GradLambda_u(u_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(DP), intent(in)  :: u_data(nmc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pv_GradLambda_u(0:ic-1,jc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      pv_GradLambda_u = pv_u(u_data,ipow=0,iflag=-1)

    end function pv_GradLambda_u

    function xv_GradLambda_u(u_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(DP), intent(in)  :: u_data(nmc)
      !(in) 入力スペクトルデータ
      real(DP)              :: xv_GradLambda_u(0:im-1,jc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      xv_GradLambda_u = xv_u(u_data,ipow=0,iflag=-1)

    end function xv_GradLambda_u

    function pv_GradMu_u(u_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: u_data(nmc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pv_GradMu_u(0:ic-1,jc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      pv_GradMu_u = pv_u(u_data,ipow=0,iflag=1)

    end function pv_GradMu_u

    function xv_GradMu_u(u_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: u_data(nmc)
      !(in) 入力スペクトルデータ
      real(DP)              :: xv_GradMu_u(0:im-1,jc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      xv_GradMu_u = xv_u(u_data,ipow=0,iflag=1)

    end function xv_GradMu_u

    function u_DivLambda_pv(pv_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ)
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pv_data(0:ic-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: u_DivLambda_pv(nmc)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      u_DivLambda_pv = u_pv(pv_data,ipow=2,iflag=-1)

    end function u_DivLambda_pv

    function u_DivLambda_xv(xv_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ)
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: xv_data(0:im-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: u_DivLambda_xv(nmc)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      u_DivLambda_xv = u_xv(xv_data,ipow=2,iflag=-1)

    end function u_DivLambda_xv

    function u_DivMu_pv(pv_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pv_data(0:ic-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: u_DivMu_pv(nmc)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      u_DivMu_pv = u_pv(pv_data,ipow=2,iflag=1)

    end function u_DivMu_pv

    function u_DivMu_xv(xv_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: xv_data(0:im-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: u_DivMu_xv(nmc)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      u_DivMu_xv = u_xv(xv_data,ipow=2,iflag=1)

    end function u_DivMu_xv

    !--------------- 微分計算 (λ,μ座標系用, w 一層) -----------------
    function pv_GradLambda_w(w_data)
      !
      ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
      !
      real(DP), intent(in)  :: w_data(nc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pv_GradLambda_w(0:ic-1,jc)
      !(out) スペクトルデータを勾配型経度微分した格子点データ

      pv_GradLambda_w = pv_w(w_data,ipow=0,iflag=-1)

    end function pv_GradLambda_w

    function pv_GradMu_w(w_data)
      !
      ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
      ! を作用させて格子点データに変換して返す(多層用).
      !
      real(DP), intent(in)  :: w_data(nc)
      !(in) 入力スペクトルデータ
      real(DP)              :: pv_GradMu_w(0:ic-1,jc)
      !(out) スペクトルデータを勾配型緯度微分した格子点データ

      pv_GradMu_w = pv_w(w_data,ipow=0,iflag=1)

    end function pv_GradMu_w

    function w_DivLambda_pv(pv_data)
      !
      ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ)
      ! を作用させてスペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pv_data(0:ic-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: w_DivLambda_pv(nc)
      !(out) 格子点データを発散型経度微分したスペクトルデータ

      w_DivLambda_pv = w_pv(pv_data,ipow=2,iflag=-1)

    end function w_DivLambda_pv

    function w_DivMu_pv(pv_data)
      !
      ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
      ! スペクトルデータに変換して返す(多層用).
      !
      real(DP), intent(in)  :: pv_data(0:ic-1,jc)
      !(in) 入力格子点データ
      real(DP)              :: w_DivMu_pv(nc)
      !(out) 格子点データを発散型緯度微分したスペクトルデータ

      w_DivMu_pv = w_pv(pv_data,ipow=2,iflag=1)

    end function w_DivMu_pv

    !--------------- 終了処理 -----------------
    subroutine ua_deriv_mpi_Finalize
      !
      ! モジュールの終了処理(割り付け配列の解放)をおこなう.
      !

      deallocate(rnu)                    ! ラプラシアン演算用配列

      call w_deriv_mpi_Finalize

      call MessageNotify('M','ua_deriv_mpi_finalize',&
           'ua_mpi_module_deriv is finalized (2020/01/25) ')

    end subroutine ua_deriv_mpi_Finalize

end module ua_mpi_module_deriv

!----------------------------------------------------------------------
!     Copyright (c) 2018--2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム
!      積分・平均計算
!
!履歴  2018/06/09  竹広真一
!      2020/11/11  竹広真一  セクター計算オプション導入
!
program ut_mpi_module_integral_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_mint
  use mpi

  implicit none

!!$  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
!!$  integer,parameter  :: mint=1               ! 経度方向対称性
  integer,parameter  :: im=16, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: mint=2               ! 経度方向対称性
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv = 2
  integer :: iproc, np, ierr

  real(8), dimension(0:im-1)                 :: x_Data
  real(8)                                    :: Data

  real(8), allocatable :: xvh_Data(:,:,:)

  real(8), allocatable :: yh_Data(:,:)
  real(8), allocatable :: xh_Data(:,:)
  real(8), allocatable :: xv_Data(:,:)
  real(8), allocatable :: vh_Data(:,:)
  real(8), allocatable :: v_Data(:)
  real(8), allocatable :: h_Data(:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 8
  integer, parameter :: ignore = -9

  real(8), parameter  :: pi=3.1415926535897932385D0

  !---------------- MPI スタート ---------------------
  !call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  !============================ 積分(xyz,xvh) ==============================

  call MessageNotify('M','ut_mpi_module_integral_mint_test', &
       'ut_mpi_module_mint integration functions tests')

  call ut_mpi_Initial(im,jm,km,nm,lm,ri,ro,npv=npv,mint=mint)

  allocate(xvh_Data(0:im-1,1:jc,kc))
  allocate(xh_Data(0:im-1,1:kc))
  allocate(yh_Data(jc,1:kc))

  allocate(xv_Data(0:im-1,1:jc))
  allocate(vh_Data(1:jc,kc))
  allocate(v_Data(1:jc))
  allocate(h_Data(1:kc))

 !---------- 定数 ----------
  xvh_Data = 1.0D0

  vh_Data = 2*pi/mint
  call AssertEqual(&
       message='vh_IntLon_xvh with constant field',                &
       answer = vh_Data,                                           &
       check = vh_IntLon_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 2.0D0
  call AssertEqual(&
       message='xh_IntLat_xvh with constant field',                &
       answer = xh_Data,                                           &
       check = xh_IntLat_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='xv_IntRad_xvh with constant field',                &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 4*pi/mint
  call AssertEqual(&
       message='h_IntLonLat_xvh with constant field',              &
       answer = h_Data,                                            &
       check = h_IntLonLat_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntLatRad_xvh with constant field',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 2*pi/3.0D0*(ro**3-ri**3)/mint
  call AssertEqual(&
       message='v_IntLonRad_xvh with constant field',              &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 4*pi/3*(ro**3-ri**3)/mint
  call AssertEqual(&
       message='IntLonLatRad_xvh with constant field',             &
       answer = Data,                                              &
       check = IntLonLatRad_xvh(xvh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )


  !------------------ r -----------------------
  xvh_Data = xvh_Rad

  vh_Data = 2*pi* xvh_Rad(1,:,:)/mint
  call AssertEqual(&
       message='vh_IntLon_xvh with r-field',                       &
       answer = vh_Data,                                           &
       check = vh_IntLon_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 2.0D0 * xvh_Data(:,1,:)
  call AssertEqual(&
       message='xh_IntLat_xvh with r-field',                       &
       answer = xh_Data,                                           &
       check = xh_IntLat_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1/4.0D0*(ro**4-ri**4)
  call AssertEqual(&
       message='xv_IntRad_xvh with r field',                       &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 4*pi * xvh_Data(1,1,:)/mint
  call AssertEqual(&
       message='h_IntLonLat_xvh with r field',                     &
       answer = h_Data,                                            &
       check = h_IntLonLat_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/2.0D0*(ro**4-ri**4)
  call AssertEqual(&
       message='x_IntLatRad_xvh with r field',                     &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = pi/2.0D0*(ro**4-ri**4)/mint
  call AssertEqual(&
       message='v_IntLonRad_xvh with constant field',              &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = pi*(ro**4-ri**4)/mint
  call AssertEqual(&
       message='IntLonLatRad_xvh with constant field',              &
       answer = Data,                                            &
       check = IntLonLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !--------- sin(phi)**2  ---------
  xvh_Data = sin(xvh_Lat)**2

  vh_Data = 2*pi* xvh_Data(1,:,:)/mint
  call AssertEqual(&
       message='vh_IntLon_xvh with sin^2φ field',                 &
       answer = vh_Data,                                           &
       check = vh_IntLon_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='xh_IntLat_xvh with sin^2φ field',                 &
       answer = xh_Data,                                           &
       check = xh_IntLat_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1/3.0D0*(ro**3-ri**3) * xvh_Data(:,:,1)
  call AssertEqual(&
       message='xv_IntRad_xvh with sin^2φ field',                 &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 4*pi/3.0/mint
  call AssertEqual(&
       message='h_IntLonLat_xvh with sin^2φ field',               &
       answer = h_Data,                                            &
       check = h_IntLonLat_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2/9.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntLatRad_xvh with sin^2φ field',               &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 2*pi/3.0D0*(ro**3-ri**3) * xvh_Data(1,:,1)/mint
  call AssertEqual(&
       message='v_IntLonRad_xvh with sin^2φ field',               &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 4*pi/9*(ro**3-ri**3)/mint
  call AssertEqual(&
       message='IntLonLatRad_xvh with constant field',             &
       answer = Data,                                              &
       check = IntLonLatRad_xvh(xvh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xvh_Data = sin(xvh_Lon)**2

  vh_Data = pi/mint
  call AssertEqual(&
       message='vh_IntLon_xvh with sin(lambda)**2',                &
       answer = vh_Data,                                           &
       check = vh_IntLon_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 2.0D0 * xvh_Data(:,1,:)
  call AssertEqual(&
       message='xh_IntLat_xvh with sin(lambda)**2',                &
       answer = xh_Data,                                           &
       check = xh_IntLat_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1/3.0D0*(ro**3-ri**3) * xvh_Data(:,:,1)
  call AssertEqual(&
       message='xv_IntRad_xvh with sin(lambda)**2',                &
       answer = xv_Data,                                           &
       check = xv_IntRad_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 2*pi/mint
  call AssertEqual(&
       message='h_IntLonLat_xvh with sin(lambda)**2',              &
       answer = h_Data,                                            &
       check = h_IntLonLat_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0/3.0D0*(ro**3-ri**3) * xvh_Data(:,1,1)
   call AssertEqual(&
       message='x_IntLatRad_xvh with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_IntLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = pi/3.0D0*(ro**3-ri**3)/mint
  call AssertEqual(&
       message='v_IntLonRad_xvh with sin(lambda)**2',              &
       answer = v_Data,                                            &
       check = v_IntLonRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLatRad_xvh with sin(lambda)**2',             &
       answer = 2*pi/3*(ro**3-ri**3)/mint,                         &
       check = IntLonLatRad_xvh(xvh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !============================ 積分(xy,xv) =============================
  ! 定数
  xv_Data = 1.0D0

  v_Data = 2*pi/mint
  call AssertEqual(&
       message='v_IntLon_xv with constant field',                  &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0
   call AssertEqual(&
       message='x_IntLat_xv with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xv with constant field',                 &
       answer = 4*pi/mint,                                         &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xv_Data = sin(xv_Lon)**2

  v_Data = pi/mint
  call AssertEqual(&
       message='v_IntLon_xv with sin(lambda)**2',                  &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0d0 * xv_Data(:,1)
   call AssertEqual(&
       message='x_IntLat_xv with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xv with sin(lambda)**2',                 &
       answer = 2*pi/mint,                                         &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2
  xv_Data = sin(xv_Lat)**2

  v_Data = 2*pi* xv_Data(1,:)/mint
  call AssertEqual(&
       message='v_IntLon_xv with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_IntLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='x_IntLat_xv with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_IntLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonLat_xv with sin(phi)**2',                    &
       answer = 4*pi/3.0/mint,                                     &
       check = IntLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(yz,vh) =============================
  ! 定数
  vh_Data = 1.0D0

  h_Data = 2.0D0
  call AssertEqual(&
       message='h_IntLat_vh with constant field',                  &
       answer = h_Data,                                            &
       check = h_IntLat_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='v_IntRad_vh with constant field',                  &
       answer = v_Data,                                            &
       check = v_IntRad_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_vh with constant field',                 &
       answer = 2/3.0D0*(ro**3-ri**3),                             &
       check = IntLatRad_vh(vh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2
  vh_Data = xvh_Rad(0,:,:)**2

  h_Data = 2.0D0 * vh_Data(1,:)
  call AssertEqual(&
       message='h_IntLat_vh with r^2',                             &
       answer = h_Data,                                            &
       check = h_IntLat_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1/5.0D0*(ro**5-ri**5)
  call AssertEqual(&
       message='v_IntRad_vh with r^2',                             &
       answer = v_Data,                                            &
       check = v_IntRad_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_vh with r^2',                            &
       answer = 2/5.0D0*(ro**5-ri**5),                             &
       check = IntLatRad_vh(vh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2
  vh_Data = sin(xvh_Lat(0,:,:))**2

  h_Data = 2.0D0/3.0D0
  call AssertEqual(&
       message='h_IntLat_vh with sin(phi)**2',                     &
       answer = h_Data,                                            &
       check = h_IntLat_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1/3.0D0*(ro**3-ri**3) * vh_Data(:,1)
  call AssertEqual(&
       message='v_IntRad_vh with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_IntRad_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLatRad_vh with sin(phi)**2',                    &
       answer = 2/9.0D0*(ro**3-ri**3),                             &
       check = IntLatRad_vh(vh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )
!!$
 !============================ 積分(xh) =============================
  ! 定数
  xh_Data = 1.0D0

  h_Data = 2*pi/mint
  call AssertEqual(&
       message='h_IntLon_xh with constant field',                  &
       answer = h_Data,                                            &
       check = h_IntLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/3.0D0*(ro**3-ri**3)
  call AssertEqual(&
       message='x_IntRad_xh with constant field',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xh with constant field',                 &
       answer = 2*pi/3.0D0*(ro**3-ri**3)/mint,                     &
       check = IntLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xh_Data = sin(xvh_Lon(:,1,:))**2

  h_Data = pi/mint
  call AssertEqual(&
       message='h_IntLon_xh with sin(lambda)**2',                  &
       answer = h_Data,                                            &
       check = h_IntLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/3.0D0*(ro**3-ri**3) * xh_Data(:,1)
  call AssertEqual(&
       message='x_IntRad_xh with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_IntRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xh with sin(lambda)**2',                 &
       answer = pi/3.0D0*(ro**3-ri**3)/mint,                       &
       check = IntLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2
  xh_Data = spread(h_Rad**2,1,im)

  h_Data = 2*pi* h_Rad**2/mint
  call AssertEqual(&
       message='h_IntLon_xh with r^2',                             &
       answer = h_Data,                                            &
       check = h_IntLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/5.0D0*(ro**5-ri**5)
  call AssertEqual(&
       message='x_IntRad_xh with r^2',                             &
       answer = x_Data,                                            &
       check = x_IntRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='IntLonRad_xh with r^2',                            &
       answer = 2*pi/5.0D0*(ro**5-ri**5)/mint,                     &
       check = IntLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='IntLon_x with constant field',                     &
       answer = 2*pi/mint,                                         &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  x_Data = sin(x_Lon)**2

  call AssertEqual(&
       message='IntLon_x with sin(lambda)**2',                     &
       answer = pi/mint,                                           &
       check = IntLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 積分(y,v) =============================
  ! 定数
  v_Data = 1.0D0

  call AssertEqual(&
       message='IntLat_v with constant field',                     &
       answer = 2.0D0,                                             &
       check = IntLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2
  v_Data = sin(v_Lat)**2

  call AssertEqual(&
       message='IntLat_v with sin(phi)**2',                        &
       answer = 2.0D0/3.0D0,                                       &
       check = IntLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !============================ 積分(z) =============================
  ! 定数
  h_Data = 1.0D0

  call AssertEqual(&
       message='IntRad_r with constant field',                     &
       answer = 1/3.0D0*(ro**3-ri**3),                             &
       check = IntRad_h(h_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2
  h_Data = h_Rad**2

  call AssertEqual(&
       message='IntRad_r with r^2',                                &
       answer = 1/5.0D0*(ro**5-ri**5),                             &
       check = IntRad_h(h_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

!============================ 平均(xyz,xvh) ==============================

 !---------- 定数 ----------
  xvh_Data = 1.0D0

  vh_Data = 1.0D0
  call AssertEqual(&
       message='vh_AvrLon_xvh with constant field',                &
       answer = vh_Data,                                           &
       check = vh_AvrLon_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 1.0D0
  call AssertEqual(&
       message='xh_AvrLat_xvh with constant field',                &
       answer = xh_Data,                                           &
       check = xh_AvrLat_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1.0D0
  call AssertEqual(&
       message='xv_AvrRad_xvh with constant field',                &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 1.0D0
  call AssertEqual(&
       message='h_AvrLonLat_xvh with constant field',              &
       answer = h_Data,                                            &
       check = h_AvrLonLat_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xvh with constant field',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrLonRad_xvh with constant field',              &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 1.0D0
  call AssertEqual(&
       message='AvrLonLatRad_xvh with constant field',             &
       answer = Data,                                              &
       check = AvrLonLatRad_xvh(xvh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !------------------ r -----------------------
  xvh_Data = xvh_Rad

  vh_Data = xvh_Rad(1,:,:)
  call AssertEqual(&
       message='vh_AvrLon_xvh with r-field',                &
       answer = vh_Data,                                           &
       check = vh_AvrLon_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = xvh_Data(:,1,:)
  call AssertEqual(&
       message='xh_AvrLat_xvh with r-field',                &
       answer = xh_Data,                                           &
       check = xh_AvrLat_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = 1.0D0/4.0D0*(ro**4-ri**4)/(1/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='xv_AvrRad_xvh with r field',                &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = xvh_Data(1,1,:)
  call AssertEqual(&
       message='h_AvrLonLat_xvh with r field',                     &
       answer = h_Data,                                            &
       check = h_AvrLonLat_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1/2.0D0*(ro**4-ri**4)/(2/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='x_AvrLatRad_xvh with r field',                     &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = pi/2.0D0*(ro**4-ri**4)/(2*pi/3.0D0*(ro**3-ri**3))
  call AssertEqual(&
       message='v_AvrLonRad_xvh with constant field',              &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = pi*(ro**4-ri**4)/(4*pi/3*(ro**3-ri**3))
  call AssertEqual(&
       message='AvrLonLatRad_xvh with constant field',              &
       answer = Data,                                            &
       check = AvrLonLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  !--------- sin(phi)**2  ---------
  xvh_Data = sin(xvh_Lat)**2

  vh_Data = xvh_Data(1,:,:)
  call AssertEqual(&
       message='vh_AvrLon_xvh with sin^2φ field',                 &
       answer = vh_Data,                                           &
       check = vh_AvrLon_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='xh_AvrLat_xvh with sin^2φ field',                 &
       answer = xh_Data,                                           &
       check = xh_AvrLat_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = xvh_Data(:,:,1)
  call AssertEqual(&
       message='xv_AvrRad_xvh with sin^2φ field',                 &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='h_AvrLonLat_xvh with sin^2φ field',               &
       answer = h_Data,                                            &
       check = h_AvrLonLat_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLatRad_xvh with sin^2φ field',               &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = xvh_Data(1,:,1)
  call AssertEqual(&
       message='v_AvrLonRad_xvh with sin^2φ field',               &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  Data = 1.0D0/3D0
  call AssertEqual(&
       message='AvrLonLatRad_xvh with constant field',             &
       answer = Data,                                              &
       check = AvrLonLatRad_xvh(xvh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xvh_Data = sin(xvh_Lon)**2

  vh_Data = 0.5D0
  call AssertEqual(&
       message='vh_AvrLon_xvh with sin(lambda)**2',                &
       answer = vh_Data,                                           &
       check = vh_AvrLon_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xh_Data = xvh_Data(:,1,:)
  call AssertEqual(&
       message='xh_AvrLat_xvh with sin(lambda)**2',                &
       answer = xh_Data,                                           &
       check = xh_AvrLat_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  xv_Data = xvh_Data(:,:,1)
  call AssertEqual(&
       message='xv_AvrRad_xvh with sin(lambda)**2',                &
       answer = xv_Data,                                           &
       check = xv_AvrRad_xvh(xvh_Data),                            &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  h_Data = 0.5D0
  call AssertEqual(&
       message='h_AvrLonLat_xvh with sin(lambda)**2',              &
       answer = h_Data,                                            &
       check = h_AvrLonLat_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xvh_Data(:,1,1)
  call AssertEqual(&
       message='x_AvrLatRad_xvh with sin(lambda)**2',              &
       answer = x_Data,                                            &
       check = x_AvrLatRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 0.5D0
  call AssertEqual(&
       message='v_AvrLonRad_xvh with sin(lambda)**2',              &
       answer = v_Data,                                            &
       check = v_AvrLonRad_xvh(xvh_Data),                          &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLatRad_xvh with sin(lambda)**2',             &
       answer = 0.5D0,                                             &
       check = AvrLonLatRad_xvh(xvh_Data),                         &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xy,xv) =============================
  ! 定数
  xv_Data = 1.0D0

  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrLon_xv with constant field',                  &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrLat_xv with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xv with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xv_Data = sin(xv_Lon)**2

  v_Data = 0.5D0
  call AssertEqual(&
       message='v_AvrLon_xv with sin(lambda)**2',                  &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xv_Data(:,1)
  call AssertEqual(&
       message='x_AvrLat_xv with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xv with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2
  xv_Data = sin(xv_Lat)**2

  v_Data = xv_Data(1,:)
  call AssertEqual(&
       message='v_AvrLon_xv with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_AvrLon_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='x_AvrLat_xv with sin(phi)**2',                     &
       answer = x_Data,                                            &
       check = x_AvrLat_xv(xv_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonLat_xv with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLonLat_xv(xv_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(yz,vh) =============================
  ! 定数
  vh_Data = 1.0D0

  h_Data = 1.0D0
  call AssertEqual(&
       message='h_AvrLat_vh with constant field',                  &
       answer = h_Data,                                            &
       check = h_AvrLat_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 1.0D0
  call AssertEqual(&
       message='v_AvrRad_vh with constant field',                  &
       answer = v_Data,                                            &
       check = v_AvrRad_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_vh with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLatRad_vh(vh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2
  vh_Data = xvh_Rad(0,:,:)**2

  h_Data = vh_Data(1,:)
  call AssertEqual(&
       message='h_AvrLat_vh with r^2',                             &
       answer = h_Data,                                            &
       check = h_AvrLat_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3)
  call AssertEqual(&
       message='v_AvrRad_vh with r^2',                             &
       answer = v_Data,                                            &
       check = v_AvrRad_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_vh with r^2',                            &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrLatRad_vh(vh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2
  vh_Data = sin(xvh_Lat(0,:,:))**2

  h_Data = 1.0D0/3.0D0
  call AssertEqual(&
       message='h_AvrLat_vh with sin(phi)**2',                     &
       answer = h_Data,                                            &
       check = h_AvrLat_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  v_Data = vh_Data(:,1)
  call AssertEqual(&
       message='v_AvrRad_vh with sin(phi)**2',                     &
       answer = v_Data,                                            &
       check = v_AvrRad_vh(vh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLatRad_vh with sin(phi)**2',                    &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLatRad_vh(vh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(xh) =============================
  ! 定数
  xh_Data = 1.0D0

  h_Data = 1.0D0
  call AssertEqual(&
       message='h_AvrLon_xh with constant field',                  &
       answer = h_Data,                                            &
       check = h_AvrLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 1.0D0
  call AssertEqual(&
       message='x_AvrRad_xh with constant field',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xh with constant field',                 &
       answer = 1.0D0,                                             &
       check = AvrLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  xh_Data = sin(xvh_Lon(:,1,:))**2

  h_Data = 0.5D0
  call AssertEqual(&
       message='h_AvrLon_xh with sin(lambda)**2',                  &
       answer = h_Data,                                            &
       check = h_AvrLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = xh_Data(:,1)
  call AssertEqual(&
       message='x_AvrRad_xh with sin(lambda)**2',                  &
       answer = x_Data,                                            &
       check = x_AvrRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xh with sin(lambda)**2',                 &
       answer = 0.5D0,                                             &
       check = AvrLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2
  xh_Data = spread(h_Rad**2,1,im)

  h_Data = h_Rad**2
  call AssertEqual(&
       message='h_AvrLon_xh with r^2',                             &
       answer = h_Data,                                            &
       check = h_AvrLon_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  x_Data = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3)
  call AssertEqual(&
       message='x_AvrRad_xh with r^2',                             &
       answer = x_Data,                                            &
       check = x_AvrRad_xh(xh_Data),                               &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call AssertEqual(&
       message='AvrLonRad_xh with r^2',                            &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrLonRad_xh(xh_Data),                              &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(x) =============================
  ! 定数
  x_Data = 1.0D0

  call AssertEqual(&
       message='AvrLon_x with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(lambda)**2
  x_Data = sin(x_Lon)**2

  call AssertEqual(&
       message='AvrLon_x with sin(lambda)**2',                     &
       answer = 0.5D0,                                             &
       check = AvrLon_x(x_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(y,v) =============================
  ! 定数
  v_Data = 1.0D0

  call AssertEqual(&
       message='AvrLat_v with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! sin(phi)**2
  v_Data = sin(v_Lat)**2

  call AssertEqual(&
       message='AvrLat_v with sin(phi)**2',                        &
       answer = 1.0D0/3.0D0,                                       &
       check = AvrLat_v(v_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

 !============================ 平均(r) =============================
  ! 定数
  h_Data = 1.0D0

  call AssertEqual(&
       message='AvrRad_h with constant field',                     &
       answer = 1.0D0,                                             &
       check = AvrRad_h(h_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  ! r^2
  h_Data = h_Rad**2

  call AssertEqual(&
       message='AvrRad_h with r^2',                                &
       answer = 3.0D0/5.0D0*(ro**5-ri**5)/(ro**3-ri**3),           &
       check = AvrRad_h(h_Data),                                   &
       significant_digits = check_digits, ignore_digits = ignore   &
       )

  call MessageNotify('M','ut_mpi_module_integral_mint_test', &
       'ut_mpi_module_mint integration/averaging function tests succeeded!')

  !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ut_mpi_module_integral_mint_test

!----------------------------------------------------------------------
!     Copyright (c) 2024 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wa_zonal_module_interpolate テストプログラム :: 補間関数のテスト
!
!履歴  2024/02/17  竹広真一 wa_wave_module_interpolate_test.f90 より改造
!
program wa_zonal_module_interpolate_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wa_zonal_module
  implicit none

  integer, parameter :: im=1, jm=16, nm=10, km=2

  real(8), allocatable, dimension(:,:) ::  wa_data
  real(8), dimension(0:im-1,1:jm,km)   ::  xya_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8), dimension(km) :: a_data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call MessageNotify('M','wa_zonal_module_interpolate_test', &
                         'wa_zonal_module_interpolate tests') 


  !---- Y_1^0 Y_2^0 のテスト ----
  call wa_Initial( nm, im, jm, km )
  allocate(wa_data(nm+1,km))

  xya_data(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)              ! Y_1^0
  a_data_sol(1) = sqrt(3.0D0)*sin(ALat)

  xya_data(:,:,2)  = sqrt(5.0D0)*(3.0D0*sin(xy_Lat)**2-1.0D0)/2.0D0  ! P_2^0
  a_data_sol(2) = sqrt(5.0D0)*(3.0D0*sin(ALat)**2-1.0D0)/2.0D0

  wa_data = wa_xya(xya_data)
  call AssertEqual(&
    message='a_Interpolate_wa with Y_1^0, Y_2^0',                 &
    answer = a_Interpolate_wa(wa_data,alon,alat),                 &
    check =  a_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wa_zonal_module_interpolate_test', &
                      'wa_zonal_module_interpolate function tests succeeded') 

end program wa_zonal_module_interpolate_test

!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wb_base_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2020/07/31  竹広真一
!
program wb_base_mpi_module_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wb_mpi_module
  use wb_mpi_module_base, only : nnc => nc
  use mpi
  implicit none

  integer, parameter :: im=64, jm=32, nm=21, km=3
!  integer, parameter :: im=32, jm=16, nm=10, km=3
  integer, parameter :: npv=2

  real(8), allocatable ::  wb_data(:,:)
  real(8), allocatable ::  pva_data(:,:,:)
  real(8), allocatable ::  xvb_data(:,:,:)
  real(8), allocatable ::  w_data(:)
  real(8), allocatable ::  pv_data(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: ierr
  integer :: ip, np

  !---------------- MPI スタート ---------------------
  CALL MPI_INIT(IERR)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wb_base_mpi_module_test', &
                         'wb_base_mpi_module functions tests')

  call wb_mpi_Initial( nm, im, jm, km, npv=npv )

  allocate(wb_data(nnc,kc))
  allocate(pva_data(ic,jc,km))
  allocate(xvb_data(0:im-1,jc,kc))
  allocate(pv_data(ic,jc))
  allocate(w_data(nc))

  !========================= xvb_wb, wb_xvb のテスト===========================

  !---- Y_1^* のテスト ----
  wb_data = 0.0D0 ; xvb_data = 0.0D0
  pva_data(:,:,1) = sqrt(3.0D0)*sin(pv_Lat)                   ! Y_1^0
  if ( kp_kl(1) .ne. 0 .AND. l_nm(1,0) .ne. 0 ) &
       wb_data(l_nm(1,0),kp_kl(1))=1.0D0
  if ( kp_kl(1) .ne. 0 ) &
       xvb_data(:,:,kp_kl(1)) = sqrt(3.0D0)*sin(xv_Lat)                ! Y_1^0
       
  pva_data(:,:,2) = sqrt(3.0D0/2)*cos(pv_Lat)*cos(pv_Lon)     ! Y_1^1
  if ( kp_kl(2) .ne. 0 .AND. l_nm(1,1) .ne. 0 ) &
       wb_data(l_nm(1,1),kp_kl(2))=1.0D0/2.0D0
  if ( kp_kl(2) .ne. 0 ) &
       xvb_data(:,:,kp_kl(2)) = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon)   ! Y_1^1
     
  pva_data(:,:,3) = -sqrt(3.0D0/2)*cos(pv_Lat)*sin(pv_Lon)    ! Y_1^{-1}
  if ( kp_kl(3) .ne. 0 .AND. l_nm(1,-1) .ne. 0 ) &
       wb_data(l_nm(1,-1),kp_kl(3))=1.0D0/2.0D0
  if ( kp_kl(3) .ne. 0 ) &
       xvb_data(:,:,kp_kl(3)) = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon)    ! Y_1^{-1}

!!$  call AssertEqual(&
!!$       message='wb_pva with Y_1^*',                                  &
!!$       answer = wb_pva(pva_data),                                    &
!!$       check = wb_data,                                              &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$  call AssertEqual(&
!!$       message='pva_wb with Y_1^*',                                  &
!!$       answer = pva_wb(wb_data),                                     &
!!$       check = pva_data,                                             &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
  call AssertEqual(&
       message='wb_xvb with Y_1^*',                                  &
       answer = wb_xvb(xvb_data),                                    &
       check = wb_data,                                              &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='xvb_wb with Y_1^*',                                  &
       answer = xvb_wb(wb_data),                                     &
       check = xvb_data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  pv_data = sqrt(3.0D0)*sin(pv_Lat)
  w_data = 0.0D0
  if ( l_nm(1,0) .ne. 0 ) w_data(l_nm(1,0))=1.0D0
  call AssertEqual(&
       message='w_pv with Y_1^0',                                 &
       answer = w_pv(pv_data),                                    &
       check = w_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_w with Y_1^0',                                 &
       answer = pv_w(w_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  pv_data = sqrt(3.0D0/2)*cos(pv_Lat)*cos(pv_Lon) ! Y_1^1
  w_data = 0.0D0
  if ( l_nm(1,1) .ne. 0 ) w_data(l_nm(1,1))=1.0D0/2.0D0
  call AssertEqual(&
       message='w_pv with Y_1^1',                                 &
       answer = w_pv(pv_data),                                    &
       check = w_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_w with Y_1^1',                                 &
       answer = pv_w(w_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  pv_data = -sqrt(3.0D0/2)*cos(pv_Lat)*sin(pv_Lon) ! Y_1^{-1}
  w_data = 0.0D0
  if ( l_nm(1,-1) .ne. 0 ) w_data(l_nm(1,-1))=1.0D0/2.0D0
  call AssertEqual(&
       message='w_pv with Y_1^-1',                                &
       answer = w_pv(pv_data),                                    &
       check = w_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_w with Y_1^-1',                                &
       answer = pv_w(w_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  !---- Y_2^* のテスト ----
  wb_data = 0.0D0 ; xvb_data = 0.0D0
  pva_data(:,:,1) = sqrt(5.0D0)*(3.0/2*sin(pv_Lat)**2-1/2.0)             ! Y_2^0
  if ( kp_kl(1) .ne. 0 .AND. l_nm(2,0) .ne. 0 ) &
       wb_data(l_nm(2,0),kp_kl(1))=1.0D0
  if ( kp_kl(1) .ne. 0 ) &
       xvb_data(:,:,kp_kl(1)) = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0)
       
  pva_data(:,:,2) = sqrt(5.0D0/6)*3.0*sin(pv_Lat)*cos(pv_Lat)*cos(pv_Lon) !Y_2^1
  if ( kp_kl(2) .ne. 0 .AND. l_nm(2,1) .ne. 0 ) &
       wb_data(l_nm(2,1),kp_kl(2))=1.0D0/2.0D0
  if ( kp_kl(2) .ne. 0 ) &
       xvb_data(:,:,kp_kl(2)) = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*cos(xv_Lon)
     
  pva_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(pv_Lat)**2*sin(2*pv_Lon)   ! Y_2^-2
  if ( kp_kl(3) .ne. 0 .AND. l_nm(2,-2) .ne. 0 ) &
       wb_data(l_nm(2,-2),kp_kl(3))=1.0D0/2.0D0
  if ( kp_kl(3) .ne. 0 ) &
       xvb_data(:,:,kp_kl(3)) = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)

!!$  call AssertEqual(&
!!$       message='wb_pva with Y_2^*',                                  &
!!$       answer = wb_pva(pva_data),                                    &
!!$       check = wb_data,                                              &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
!!$  call AssertEqual(&
!!$       message='pva_wb with Y_2^*',                                  &
!!$       answer = pva_wb(wb_data),                                     &
!!$       check = pva_data,                                             &
!!$       significant_digits = check_digits, ignore_digits = ignore     &
!!$       )
  call AssertEqual(&
       message='wb_xvb with Y_2^*',                                  &
       answer = wb_xvb(xvb_data),                                    &
       check = wb_data,                                              &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='xvb_wb with Y_2^*',                                  &
       answer = xvb_wb(wb_data),                                     &
       check = xvb_data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  pv_data = sqrt(5.0D0)*(3.0/2*sin(pv_Lat)**2-1/2.0) ! Y_2^0
  w_data = 0.0D0
  if ( l_nm(2,0) .ne. 0 ) w_data(l_nm(2,0))=1.0D0
  call AssertEqual(&
       message='w_pv with Y_2^0',                                 &
       answer = w_pv(pv_data),                                    &
       check = w_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_w with Y_2^0',                                 &
       answer = pv_w(w_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  pv_data = sqrt(5.0D0/6)*3.0*sin(pv_Lat)*cos(pv_Lat)*cos(pv_Lon)!Y_2^1
  w_data = 0.0D0
  if ( l_nm(2,1) .ne. 0 ) w_data(l_nm(2,1))=1.0D0/2.0D0
  call AssertEqual(&
       message='w_pv with Y_2^1',                                 &
       answer = w_pv(pv_data),                                    &
       check = w_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_w with Y_2^1',                                 &
       answer = pv_w(w_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  pv_data = -sqrt(5.0D0/24)*3.0*cos(pv_Lat)**2*sin(2*pv_Lon)   ! Y_2^-2
  w_data = 0.0D0
  if ( l_nm(2,-2) .ne. 0 ) w_data(l_nm(2,-2))=1.0D0/2.0D0
  call AssertEqual(&
       message='w_pv with Y_2^-2',                                &
       answer = w_pv(pv_data),                                    &
       check = w_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_w with Y_2^-2',                                &
       answer = pv_w(w_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  !---- 一般的関数のテスト ----
  pva_data(:,:,1) = cos(2*pv_Lon-pi/3) &
       *(sin(pv_Lat)-1)**2*(sin(pv_Lat)-0.5)*(sin(pv_Lat)+1)
  pva_data(:,:,2) = sin(2*pv_Lon+pi/2) &
       *(sin(pv_Lat)-1)**2*(sin(pv_Lat)+1)**2
  pva_data(:,:,3) = cos(2*pv_Lon+pi/3) &
       *(sin(pv_Lat)-1)*(sin(pv_Lat)-0.5)**2*(sin(pv_Lat)+1)
  
!!$  call AssertEqual(&
!!$    message='wb_pva, pva_wb with a general function',             &
!!$    answer = pva_wb(wb_pva(pva_data)),                            &
!!$    check = pva_data,                                             &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )

  pv_data = cos(2*pv_Lon-pi/3) &
       *(sin(pv_Lat)-1)**2*(sin(pv_Lat)-0.5)*(sin(pv_Lat)+1)
  call AssertEqual(&
       message='pv_w with a general function',                    &
       answer = pv_w(w_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  call MessageNotify('M','wb_base_mpi_module_test', &
                         'wb_base_mpi_module functions tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wb_base_mpi_module_test

!----------------------------------------------------------------------
! Copyright (c) 2002-2025 SPMODEL Development Group. All rights reserved.!
!----------------------------------------------------------------------
!
!表題  aq_module テストプログラム
!
!履歴  2008/04/01  竹広真一
!      2008/07/07  佐々木洋平 誤差範囲を修正
!      2008/08/13  竹広真一 q_r2_q テスト追加
!      2009/07/22  佐々木洋平 dc_test を使用するように修正
!      2025/12/22  竹広真一 spml2 版対応
!
program aq_test_base1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use aq_module
  implicit none

  integer, parameter :: im=16, km=10         ! 格子点数, 切断波数
  real(8), parameter :: ra=2.0d0             ! 領域の大きさ

  ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: alpha=1.0D0        
  ! 展開多項式パラメター  0 < β
  real(8), parameter :: beta= 1.0D0        

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8), dimension(im)   :: g_z
  real(8), dimension(0:km) :: q_z

  call MessageNotify('M','aq_test_base1d',&
    'aq_module basic function test')

  call aq_Initial(im,km,ra,alpha,beta,(/1/))

  g_z = g_R**5.0D0
  q_z = q_g(g_z)

  call AssertEqual(&
    message='Transform',                                        &
    answer = g_z,                                               &
    check  = g_q(q_g(g_z)),                                     &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message='differentation',                                   &
    answer = 5.0D0*g_R**5.0D0,                                  &
    check  = g_q(q_rDr_q(q_g((g_z)))),                          &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  call AssertEqual(&
    message='r^2 multipilication',                              &
    answer = g_R**7.0D0,                                        &
    check  = g_q(q_r2_q(q_g(g_z))),                             &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  call AssertEqual(&
    message='r^-2 multipilication',                             &
    answer = g_R**3.0d0,                                        &
    check  = g_q(q_r2Inv_q(q_z)),                               &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call aq_Initial(im,km,ra,alpha,beta,(/2/))

  g_z = g_R**6.0D0
  q_z = q_g(g_z)

  call AssertEqual(&
    message='differentation',                                   &
    answer = 6.0D0*g_R**6.0D0,                                  &
    check  = g_q(q_rDr_q(q_g((g_z)))),                          &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  call AssertEqual(&
    message='r^2 multipilication',                              &
    answer = g_R**8.0D0,                                        &
    check  = g_q(q_r2_q(q_g(g_z))),                             &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  call AssertEqual(&
    message='r^-2 multipilication',                             &
    answer = g_R**4.0d0,                                        &
    check  = g_q(q_r2Inv_q(q_z)),                               &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M','aq_test_base1d', &
       'Tests of basic functions g_q, q_g, q_rDr_q suceeded!')

end program aq_test_base1d

!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wb_integrale_module テストプログラム :: 積分・平均関数のテスト
!
!履歴  2020/08/03  竹広真一
!      2020/11/10  竹広真一  セクター計算オプション導入
!
program ua_mpi_module_integral_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_mint
  use mpi
  implicit none

!!$  integer, parameter :: im=64, jm=32, nm=21, km=2, npv=2, mint=1
  integer, parameter :: im=32, jm=32, nm=21, km=2, npv=2, mint=2

  real(8), allocatable             ::  a_idata(:)          ! 積分・平均の正解
  real(8), allocatable             ::  pva_data(:,:,:)     ! 元の関数
  real(8), allocatable             ::  pa_idata(:,:)       ! 積分・平均の正解
  real(8), allocatable             ::  va_idata(:,:)       ! 積分・平均の正解

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','ua_mpi_module_integral_mint_test', &
                         'ua_mpi_module_mint integral function tests')

  call ua_mpi_Initial( nm, im, jm, km, npv=2, mint=mint )

  allocate(pva_data(ic,jc,km))
  allocate(pa_idata(ic,km))
  allocate(va_idata(jc,km))
  allocate(a_idata(km))

  !---- 積分のテスト(分割領域) ----
  pva_data = 0.0D0
  pva_data(:,:,1) = sin(pv_Lat)**2*(1-cos(pv_Lon)**2)
  pva_data(:,:,2) = sin(pv_Lat)**4*(1-sin(pv_Lon)**2)

  a_idata(1) = 2*pi/3/mint       ! a_IntLonLat_pva
  a_idata(2) = 2*pi/5/mint       ! a_IntLonLat_pva
  call AssertEqual(&
    message='a_IntLonLat_pva',                                    &
    answer = a_IntLonLat_pva(pva_data),                           &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='IntLonLat_pv',                                       &
    answer = IntLonLat_pv(pva_data(:,:,1)),                       &
    check =  a_idata(1),                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  va_idata(:,1) = pi*sin(v_Lat)**2/mint  ! v_IntLon_pva
  va_idata(:,2) = pi*sin(v_Lat)**4/mint  ! v_IntLon_pva
  call AssertEqual(&
    message='va_IntLon_pva',                                      &
    answer = va_IntLon_pva(pva_data),                             &
    check =  va_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLat_va',                                        &
    answer = a_IntLat_va(va_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pa_idata(:,1) = 2.0D0/3*(1-cos(p_Lon)**2)       ! x_IntLat_pva
  pa_idata(:,2) = 2.0D0/5*(1-sin(p_Lon)**2)       ! x_IntLat_pva

  call AssertEqual(&
    message='pa_IntLat_pva',                                      &
    answer = pa_IntLat_pva(pva_data),                             &
    check =  pa_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_IntLon_pa',                                        &
    answer = a_IntLon_pa(pa_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='IntLon_p',                                           &
    answer = IntLon_p(pa_idata(:,1)),                             &
    check =  a_idata(1),                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト(分割領域) ----
  pva_data(:,:,1) = sin(pv_Lat)**2*(1-cos(pv_Lon)**2)
  pva_data(:,:,2) = sin(pv_Lat)**4*(1-sin(pv_Lon)**2)

  a_idata(1) = 1.0D0/6       ! AvrLonLat_pva
  a_idata(2) = 1.0D0/10      ! AvrLonLat_pva
  call AssertEqual(&
    message='a_AvrLonLat_pva',                                    &
    answer = a_AvrLonLat_pva(pva_data),                           &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrLonLat_pv',                                       &
    answer = AvrLonLat_pv(pva_data(:,:,2)),                       &
    check =  a_idata(2),                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  va_idata(:,1) = 0.5*sin(v_Lat)**2   ! v_AvrLon_pva
  va_idata(:,2) = 0.5*sin(v_Lat)**4   ! v_AvrLon_pva
  call AssertEqual(&
    message='va_AvrLon_pva',                                      &
    answer = va_AvrLon_pva(pva_data),                             &
    check =  va_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_AvrLat_va',                                        &
    answer = a_AvrLat_va(va_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pa_idata(:,1) = 1.0D0/3*(1-cos(p_Lon)**2)       ! x_AvrLat_pva
  pa_idata(:,2) = 1.0D0/5*(1-sin(p_Lon)**2)       ! x_AvrLat_pva

  call AssertEqual(&
    message='pa_AvrLat_pva',                                      &
    answer = pa_AvrLat_pva(pva_data),                             &
    check =  pa_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='a_AvrLon_pa',                                        &
    answer = a_AvrLon_pa(pa_idata),                               &
    check =  a_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='AvrLon_p',                                           &
    answer = AvrLon_p(pa_idata(:,2)),                             &
    check =  a_idata(2),                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','ua_mpi_module_integral_mint_test', &
       'ua_mpi_module_mint integral function tests succeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_mpi_module_integral_mint_test

!------------------------------------------------------------------------
! Copyright (c) 2005-2011 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ceigen/eigmatrix テストプログラム
!
!履歴  2005/01/26  竹広真一
!      2007/11/02  竹広真一  メッセージ, 正誤判定追加
!      2008/12/05  佐々木洋平. 文字列 sort の長さを 2 に
!      2011/02/18  佐々木洋平 dc_test を使用するように修正
!      2011/11/05  竹広真一  ceigen 用に改造
!      2019/10/10  佐々木洋平 module rename
!
program ceigen_test

  use dc_message, only : MessageNotify
  use dc_types, only: DP
  use dc_test, only : AssertEqual
  use spml_utils, only: ceigen
  implicit none

  complex(DP), dimension(:,:), allocatable  :: cmatrix
  complex(DP), dimension(:),   allocatable  :: eigval
  complex(DP), dimension(:,:), allocatable  :: eigvec

  complex(DP), dimension(:),   allocatable       :: eigval_sol
  complex(DP), dimension(:,:), allocatable       :: eigvec_sol
  integer                     :: info
  integer                     :: i
  complex(DP), parameter      :: EI = (0.0D0, 1.0D0)
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ceigen_test','Test of ceigen/eigmatrix')

!--------------- 2x2 行列 ------------------
!  VALUE = (0,1), (0,-1)
!  VECTOR = (-1,1), (1,1)

  allocate(cmatrix(2,2))
  allocate(eigval(2),eigval_sol(2))
  allocate(eigvec(2,2),eigvec_sol(2,2))


  !---- 行列 ----
  cmatrix(1,:) = (/ (0.0d0,0.0D0),     EI/)
  cmatrix(2,:) = (/ EI,     (0.0d0,0.0D0)/)

  !---- 正解 ----
  eigval_sol = (/EI,-EI/)

  eigvec_sol(:,1) = (/(1.0d0,0.0d0),(1.0d0,0.0d0)/)
  eigvec_sol(:,2) = (/(-1.0d0,0.0d0),(1.0d0,0.0d0)/)

  !---- 固有値計算 ----
  call ceigen(cmatrix,eigval,eigvec,info,sort='I ',reverse=.true.)
  do i=1,2
     eigvec(:,i) = eigvec(:,i)/eigvec(1,i)
     eigvec_sol(:,i) = eigvec_sol(:,i)/eigvec_sol(1,i)
  enddo

  !---- 判定 ----
  call AssertEqual(                                           &
    message= '2x2 arrray eigenvalue(real part)',              &
    answer = dble(eigval_sol),                                &
    check = dble(eigval),                                     &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '2x2 arrray eigenvalue(imaginary part)',         &
    answer = aimag(eigval_sol),                               &
    check = aimag(eigval),                                    &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '2x2 arrray eigenvector(real part)',             &
    answer = dble(eigvec_sol),                                &
    check = dble(eigvec),                                     &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '2x2 arrray eigenvector(imaginary part)',        &
    answer = aimag(eigvec_sol),                               &
    check = aimag(eigvec),                                    &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call MessageNotify('M','Test of ceigen/eigmatrix','Test of 2x2 array succeeded!')

  deallocate(cmatrix)
  deallocate(eigval,eigval_sol)
  deallocate(eigvec,eigvec_sol)

!--------------- 3x3 行列 ------------------
!  VALUE = (6,0), (3,0), (2,0)
!  VECTOR = (-1,2i,1), (1,i,-1),(1,0,1)

  allocate(cmatrix(3,3))
  allocate(eigval(3), eigval_sol(3))
  allocate(eigvec(3,3), eigvec_sol(3,3))

  !---- 行列 ----
  cmatrix(1,:) = (/(3.0d0,0.0D0),       EI, (-1.0D0,0.0D0)/)
  cmatrix(2,:) = (/ -EI,     (5.0d0,0.0D0),             EI/)
  cmatrix(3,:) = (/(-1.0d0,0.0d0),     -EI,  (3.0d0,0.0D0)/)

  !---- 正解 ----
  eigval_sol = (/(6.0D0,0.0D0),(3.0d0,0.0d0),(2.0d0,0.0d0)/)

  eigvec_sol(:,1) = (/(-1.0d0,0.0d0),      2.0d0*EI,  (1.0d0,0.0d0)/)
  eigvec_sol(:,2) = (/ (1.0d0,0.0d0),            EI, (-1.0d0,0.0d0)/)
  eigvec_sol(:,3) = (/ (1.0d0,0.0d0), (0.0d0,0.0d0),  (1.0d0,0.0d0)/)

  !---- 固有値計算 ----
  call ceigen(cmatrix,eigval,eigvec,info,sort='R ',reverse=.true.)

  do i=1,3
     eigvec(:,i) = eigvec(:,i)/eigvec(1,i)
     eigvec_sol(:,i) = eigvec_sol(:,i)/eigvec_sol(1,i)
  enddo

  !---- 判定 ----
  call AssertEqual(                                           &
    message= '3x3 arrray eigenvalue(real part)',              &
    answer = dble(eigval_sol),                                &
    check = dble(eigval),                                     &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '3x3 arrray eigenvalue(imaginary part)',         &
    answer = aimag(eigval_sol),                               &
    check = aimag(eigval),                                    &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '3x3 arrray eigenvector(real part)',             &
    answer = dble(eigvec_sol),                                &
    check = dble(eigvec),                                     &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '3x3 arrray eigenvector(imaginary part)',        &
    answer = aimag(eigvec_sol),                               &
    check = aimag(eigvec),                                    &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call MessageNotify('M','Test of ceigen/eigmatrix','Test of 3x3 array succeeded!')

  deallocate(cmatrix)
  deallocate(eigval,eigval_sol)
  deallocate(eigvec,eigvec_sol)

end program ceigen_test

!----------------------------------------------------------------------
!     Copyright (C) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム
!
!      磁場ポロイダルポテンシャルの境界値問題
!
!履歴  2019/05/29  竹広真一
!
program ut_mpi_module_test_polmagbc

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module
  use mpi

  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv = 2
  integer :: iproc, np, ierr

  real(8), allocatable  :: xvh_POLMAG(:,:,:)
  real(8), allocatable  :: ut_POLMAG(:,:)
  real(8), allocatable  :: ut_POLMAG0(:,:)

  real(8), allocatable  :: uz_POLMAG(:,:)
  real(8), allocatable  :: uz_POLMAG0(:,:)

  real(8), allocatable  :: uz_TopBoundary(:,:)
  real(8), allocatable  :: uz_BottomBoundary(:,:)

  real(8), allocatable  :: uz_Zero(:,:)

  real(8), allocatable  :: uz_n(:,:)   ! 全波数

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  integer :: k, n, nn(2)

  !---------------- MPI スタート ---------------------
  !call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_test_polmagbc', &
       'ut_mpi_module ut_PolmagBoundaries subroutine test')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro,npv=npv)

  allocate(xvh_POLMAG(0:im-1,jc,kc))
  allocate(ut_POLMAG(nmc,0:lm))
  allocate(ut_POLMAG0(nmc,0:lm))
  allocate(uz_POLMAG(nmc,0:km))
  allocate(uz_POLMAG0(nmc,0:km))

  allocate(uz_TopBoundary(nmc,0:km))
  allocate(uz_BottomBoundary(nmc,0:km))

  allocate(uz_Zero(nmc,0:km))

  allocate(uz_n(nmc,0:km))


  !=================== ut_PolmagBoundaries =======================
  ! P_10
  xvh_POLMAG = sin(xvh_lat) * sin( pi*(xvh_rad-ri)/(ro-ri) )

  ! P_1_1
  !xvh_POLMAG = cos(xvh_lat)*cos(xvh_lon)* sin( pi*(xvh_rad-ri)/(ro-ri) )
  !xvh_POLMAG = 2*sin(xvh_lat)**2 * sin( pi*(xvh_rad-ri)/(ro-ri) )

  ut_POLMAG = ut_xvh(xvh_POLMAG)
  ut_POLMAG0 = ut_POLMAG
  call ut_PolmagBoundaries(ut_POLMAG)

  do k=0,km
     do n=1,nmc
        nn=nm_l(n)
        uz_n(n,k) = nn(1)
     enddo
  enddo

  uz_Zero = 0.0D0
  uz_TopBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     + (uz_n +1)*uz_ut(ut_POLMAG)/uz_RAD
  uz_BottomBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     - uz_n * uz_ut(ut_POLMAG)/uz_RAD

  call AssertEqual(&
       message='ut_PolmagBoundaries (internal value)',           &
       answer = ut_POLMAG0(:,0:lm-2),                            &
       check = ut_POLMAG(:,0:lm-2),                              &
       significant_digits = check_digits, ignore_digits = ignore &
       )

  call AssertEqual(&
       message='ut_PolmagBoundaries (Top B.C.)',                 &
       answer = uz_Zero(:,0),                                    &
       check = uz_TopBoundary(:,0),                              &
       significant_digits = check_digits, ignore_digits = ignore &
       )

  call AssertEqual(&
       message='ut_PolmagBoundaries (Bottom B.C.)',              &
       answer = uz_Zero(:,km),                                   &
       check = uz_BottomBoundary(:,km),                          &
       significant_digits = check_digits, ignore_digits = ignore &
       )

  !=================== ut_PolmagBoundariesGrid =======================
  ! P_10
  !xyz_POLMAG = sin(xyz_lat) * sin( pi*(xyz_rad-ri)/(ro-ri) )

  ! P_1_1
  !xvh_POLMAG = cos(xvh_lat)*cos(xvh_lon)* sin( pi*(xvh_rad-ri)/(ro-ri) )
  xvh_POLMAG = 2*sin(xvh_lat)**2 * sin( pi*(xvh_rad-ri)/(ro-ri) )

  ut_POLMAG = ut_xvh(xvh_POLMAG)
  uz_POLMAG0 = uz_ut(ut_POLMAG)

  call ut_PolmagBoundariesGrid(ut_POLMAG)
  uz_POLMAG = uz_ut(ut_POLMAG)

  do k=0,km
     do n=1,nmc
        nn=nm_l(n)
        uz_n(n,k) = nn(1)
     enddo
  enddo

  uz_TopBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     + (uz_n +1)*uz_ut(ut_POLMAG)/uz_RAD
  uz_BottomBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     - uz_n * uz_ut(ut_POLMAG)/uz_RAD

  uz_Zero = 0.0D0
  uz_TopBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     + (uz_n +1)*uz_ut(ut_POLMAG)/uz_RAD
  uz_BottomBoundary = uz_ut(ut_DRad_ut(ut_POLMAG)) &
                     - uz_n * uz_ut(ut_POLMAG)/uz_RAD

  call AssertEqual(&
       message='ut_PolmagBoundariesGrid (internal value)',       &
       answer = uz_POLMAG0(:,1:km-1),                            &
       check = uz_POLMAG(:,1:km-1),                              &
       significant_digits = check_digits, ignore_digits = ignore &
       )

  call AssertEqual(&
       message='ut_PolmagBoundarieGrid (Top B.C.)',                  &
       answer = uz_Zero(:,0),                                        &
       check = uz_TopBoundary(:,0),                                  &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call AssertEqual(&
       message='ut_PolmagBoundariesGrid (Bottom B.C.)',              &
       answer = uz_Zero(:,km),                                       &
       check = uz_BottomBoundary(:,km),                              &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','ut_mpi_module_test_polmagbc', &
       'ut_mpi_module ut_PolmagBoundaries subroutine test succeeded!')

  !------ MPIの終了 ------
  call MPI_FINALIZE(IERR)

end program ut_mpi_module_test_polmagbc

!-------------------------------------------------------------------------
! Copyright (c) 2007-2012 SPMODEL Development Group. All rights reserved.!
!-------------------------------------------------------------------------
!
!表題  et_module テストプログラム
!      渦度から流線を求める関数
!
!履歴  2007/11/20  竹広真一
!      2011/03/06  佐々木洋平 dc_test を使うように修正
!      2012/07/06  竹広真一   RF, FR, RR 条件のテスト追加
!
program et_test_Vor2StrmGrid

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use et_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=32             ! 切断波数の設定(X,Y)

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8)            :: yx_Vor(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_Psi(0:jm,0:im-1)     ! 格子データ
  real(8)            :: yx_Vor_sol(0:jm,0:im-1) ! 格子データ
  real(8)            :: yx_Psi_sol(0:jm,0:im-1) ! 格子データ
  real(8)            :: yx_dPsidy(0:jm,0:im-1)  ! 格子データ
  real(8)            :: yx_d2Psidy2(0:jm,0:im-1)! 格子データ
  real(8)            :: x_Zero(0:im-1) = 0.0D0  ! 格子データ

  integer            :: k=2

  call MessageNotify('M','et_test_Vor2StrmGrid', &
       'et_module Stream function calculation from vorticity tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

!----- et_Vor2Strm (FF) ------
  yx_Vor_sol = sin(k*pi*yx_X)*sin(pi*yx_Y)
  yx_Psi_sol = -sin(k*pi*yx_X)*sin(pi*yx_Y)/((k*pi)**2+pi**2)
  yx_Psi = yx_ey(ey_Vor2Strm_ey(ey_yx(yx_Vor_sol), &
                                      cond='FF',new=.true.))
  yx_Vor = yx_et(et_Lapla_et(et_yx(yx_Psi)))
  yx_dPsidy = yx_et(et_Dy_et(et_yx(yx_Psi)))
  yx_d2Psidy2 = yx_et(et_Dy_et(et_Dy_et(et_yx(yx_Psi))))

  call AssertEqual(&
    message='ey_Vor2Strm_ey (FF)',                                &
    answer =yx_Psi_sol,                                           &
    check = yx_Psi,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (FF, vorticity)',                     &
    answer =yx_Vor_sol(2:jm-2,:),                                 &
    check = yx_Vor(2:jm-2,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (FF, Top)',                           &
    answer =x_Zero,                                               &
    check = yx_d2Psidy2(0,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (FF, Bottom)',                        &
    answer =x_Zero,                                               &
    check = yx_d2Psidy2(jm,:),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!----- et_Vor2Strm (RF) ------
  yx_Psi_sol = sin(k*pi*yx_X)*(yx_Y-ymin)**3*(yx_Y-ymax)**2
  yx_Vor_sol = yx_et(et_Lapla_et(et_yx(yx_Psi_sol)))

  yx_Psi = yx_ey(ey_Vor2Strm_ey(ey_yx(yx_Vor_sol), &
                                      cond='RF',new=.true.))
  yx_Vor = yx_et(et_Lapla_et(et_yx(yx_Psi)))
  yx_dPsidy = yx_et(et_Dy_et(et_yx(yx_Psi)))
  yx_d2Psidy2 = yx_et(et_Dy_et(et_Dy_et(et_yx(yx_Psi))))

  call AssertEqual(&
    message='ey_Vor2Strm_ey (RF)',                                &
    answer =yx_Psi_sol,                                           &
    check = yx_Psi,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (RF, vorticity)',                     &
    answer =yx_Vor_sol(2:jm-2,:),                                 &
    check = yx_Vor(2:jm-2,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (RF, Top)',                           &
    answer =x_Zero,                                               &
    check = yx_dPsidy(0,:),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (RF, Bottom)',                        &
    answer =x_Zero,                                               &
    check = yx_d2Psidy2(jm,:),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!----- et_Vor2Strm (FR) ------
  yx_Psi_sol = sin(k*pi*yx_X)*(yx_Y-ymin)**2*(yx_Y-ymax)**3
  yx_Vor_sol = yx_et(et_Lapla_et(et_yx(yx_Psi_sol)))
  yx_Psi = yx_ey(ey_Vor2Strm_ey(ey_yx(yx_Vor_sol), &
                                      cond='FR',new=.true.))
  yx_Vor = yx_et(et_Lapla_et(et_yx(yx_Psi)))
  yx_dPsidy = yx_et(et_Dy_et(et_yx(yx_Psi)))
  yx_d2Psidy2 = yx_et(et_Dy_et(et_Dy_et(et_yx(yx_Psi))))

  call AssertEqual(&
    message='ey_Vor2Strm_ey (FR)',                                &
    answer =yx_Psi_sol,                                           &
    check = yx_Psi,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (FR, vorticity)',                     &
    answer =yx_Vor_sol(2:jm-2,:),                                 &
    check = yx_Vor(2:jm-2,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (FR, Top)',                           &
    answer =x_Zero,                                               &
    check = yx_d2Psidy2(0,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (FR, Bottom)',                        &
    answer =x_Zero,                                               &
    check = yx_dPsidy(jm,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!----- et_Vor2Strm (RR) ------
  yx_Psi_sol = sin(k*pi*yx_X)*(yx_Y-ymin)**2*(yx_Y-ymax)**2
  yx_Vor_sol = yx_et(et_Lapla_et(et_yx(yx_Psi_sol)))
  yx_Psi = yx_ey(ey_Vor2Strm_ey(ey_yx(yx_Vor_sol), &
                                      cond='RR',new=.true.))
  yx_Vor = yx_et(et_Lapla_et(et_yx(yx_Psi)))
  yx_dPsidy = yx_et(et_Dy_et(et_yx(yx_Psi)))
  yx_d2Psidy2 = yx_et(et_Dy_et(et_Dy_et(et_yx(yx_Psi))))

  call AssertEqual(&
    message='ey_Vor2Strm_ey (RR)',                                &
    answer =yx_Psi_sol,                                           &
    check = yx_Psi,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (RR, vorticity)',                     &
    answer =yx_Vor_sol(2:jm-2,:),                                 &
    check = yx_Vor(2:jm-2,:),                                     &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (RR, Top)',                           &
    answer =x_Zero,                                               &
    check = yx_dPsidy(0,:),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='ey_Vor2Strm_ey (RR, Bottom)',                        &
    answer =x_Zero,                                               &
    check = yx_dPsidy(jm,:),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','et_test_Vor2StrmGrid', &
       'et_module Stream function calculation from vorticity tests OK!')

end program et_test_Vor2StrmGrid

!--
!----------------------------------------------------------------------
!     Copyright (c) 2024 SPMDOEL Development Group
!----------------------------------------------------------------------
!表題  wa_zonal_module_base
!
!  spml/wa_zonal_module_base モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって帯状波数数値計算するための 
!  モジュール wa_zonal_module の下部モジュールであり, スペクトル計算の
!  基本的な Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_zonal_module_base モジュールを
!  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
!  格子点データに対する変換が行える.
!
!  内部で ISPACK3 の LXPACK の Fortran サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある. 
!
!
!履歴
!      2024/02/24  竹広真一  wa_wave_module_base より改造
!
!++
module wa_zonal_module_base
  !
  != wa_zonal_module_base
  !
  !== 概要
  !
  !  spml/wa_wave_module_base モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって帯状波数数値計算するための 
  !  モジュール wa_zonal_module の下部モジュールであり, スペクトル計算の
  !  基本的な Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_zonal_module_base モジュールを
  !  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
  !  格子点データに対する変換が行える.
  !
  !  内部で ISPACK3 の LXPACK の Fortran サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
  !
  !  このモジュールを使うためには前もって w_base_initial を呼んで
  !  切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message
  use w_zonal_module_base, only : im, jm, nm=>nn, xy_w, w_xy

  implicit none

  integer               :: km=16         ! 同時に処理する最大データ数(層の数).
                                         ! SNPACK 用ルーチンとの互換性のため.
                                         ! wa_base_module では
                                         ! このパラメタによる制限がない.

  private

  public km                                    ! 層数
  public wa_base_Initial                       ! 初期化サブルーチン
  public wa_base_Finalize                      ! 終了処理

  public xya_wa, wa_xya                        ! 変換関数

  save km                                      ! 最大データ数(層数)を記憶

contains
  !--------------- 初期化 -----------------
  subroutine wa_base_initial(k_in)
    ! 
    ! SNPACK 用 wa_base_initial の互換のためのダミーサブルーチン
    !
    integer,intent(in) :: k_in               !(in) 最大データ数(層数)

    km = k_in

    call MessageNotify('M','wa_base_initial',&
         'No need to set maximum level number and in wa_zonal_module_base (2024/02/17) ')

  end subroutine wa_base_Initial

  !--------------- 基本変換 -----------------

  function xya_wa(wa_data,ipow,iflag)    ! 球面調和関数スペクトル -> 格子点
    !
    ! スペクトルデータから格子データへ変換する(多層用).
    !
    real(8), intent(in)   :: wa_data(:,:)
    !(in) スペクトルデータ(2*(nm-m+1))
    !
    real(8)               :: xya_wa(0:im-1,1:jm,size(wa_data,2))
    !(out) 格子点データ(0:im-1,1:jm,:)
    !
    integer, intent(in), optional  :: ipow
    !(in) 作用させる 1/cosφ の次数. 省略時は 0. 
    integer, intent(in), optional  :: iflag
    !(in) 変換の種類
    !    0 : 通常の正変換
    !   -1 : 経度微分を作用させた逆変換
    !    1 : 緯度微分 cosφ・∂/∂φ を作用させた逆変換
    !    2 : sinφを作用させた逆変換
    !    省略時は 0.
    !
    integer, parameter  :: ipow_default  = 0
    integer, parameter  :: iflag_default = 0
    integer ipval, ifval
    integer k

    if (present(ipow)) then
       ipval = ipow
    else
       ipval = ipow_default
    endif

    if (present(iflag)) then
       ifval = iflag
    else
       ifval = iflag_default
    endif

    do k=1,size(wa_data,2)
       xya_wa(:,:,k) = xy_w(wa_data(:,k),iflag=ifval,ipow=ipval)
    enddo

  end function xya_wa

  function wa_xya(xya_data,ipow,iflag) ! 格子点 -> 球面調和関数スペクトル
    !
    ! 格子データからスペクトルデータへ(正)変換する(多層用).
    !
    real(8), intent(in)   :: xya_data(0:,:,:)
    !(in) 格子点データ(0:im-1,1:jm,:)

    real(8)               :: wa_xya(nm+1,size(xya_data,3))
    !(out) スペクトルデータ(2*(nm-m+1),:)

    integer, intent(in), optional  :: ipow
    !(in) 変換時に同時に作用させる 1/cosφ の次数. 省略時は 0.

    integer, intent(in), optional  :: iflag
    ! 変換の種類
    !    0 : 通常の正変換
    !   -1 : 経度微分を作用させた正変換 
    !    1 : 緯度微分 1/cosφ・∂(f cos^2φ)/∂φ を作用させた正変換
    !    2 : sinφを作用させた正変換
    !  省略時は 0.
    !
    integer, parameter  :: ipow_default  = 0      ! スイッチデフォルト値
    integer, parameter  :: iflag_default = 0      ! スイッチデフォルト値

    integer ipval, ifval
    integer k

    if (present(ipow)) then
       ipval = ipow
    else
       ipval = ipow_default
    endif

    if (present(iflag)) then
       ifval = iflag
    else
       ifval = iflag_default
    endif

    do k=1,size(xya_data,3)
       wa_xya(:,k) = w_xy(xya_data(:,:,k),iflag=ifval,ipow=ipval)
    enddo

  end function wa_xya

  !--------------- 終了処理 -----------------
  subroutine wa_base_Finalize
    ! 
    !
    ! このサブルーチンを単独で用いるのでなく, 
    ! 上位サブルーチン wa_Finalize を使用すること.
    !
    call MessageNotify('M','wa_base_finalize',&
         'wa_wave_module_base is finalized (dummy, 2024/02/17) ')

  end subroutine wa_base_Finalize

end module wa_zonal_module_base

!----------------------------------------------------------------------
!     Copyright (c) 2018-2021 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム :: 補間関数のテスト
!
!履歴  2018/06/01  竹広真一
!履歴  2021/02/18  竹広真一  a_Interpolate_array100_ut のテスト
!
program ut_mpi_module_interpol

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module
  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, km=16, nm=42, lm=16
  real(8), parameter :: ri = 0.5, ro= 1.5
  
  integer :: npv = 2
  integer :: iproc, np, ierr

  real(8), allocatable  ::  ut_data(:,:)
  real(8), allocatable  ::  xvh_data(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: Arad
  real(8) :: data_sol

  integer, parameter :: ndata=3
  real(8) :: Alon_ary(ndata)
  real(8) :: data_sol_ary(ndata)

  real(8) :: pi

  !---------------- MPI スタート ---------------------
  !call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_interpolate_test', &
                         'ut_mpi_module interpolate tests')

  pi = atan(1.0D0)*4.0D0

  Alon = pi/3
  Alat = pi/3
  Arad = 0.75

  Alon_ary = (/pi/4,pi/3,pi/2/)

!!$  Alon =pi/4
!!$  Alat =pi/5
!!$  Arad =0.99
!!$  Alon = 3*pi/5
!!$  Alat = -pi/7
!!$  Arad = 1.333

  call ut_mpi_Initial( im, jm, km, nm, lm, ri, ro, npv=npv )

  allocate(ut_data(nmc,0:lm))
  allocate(xvh_data(0:im-1,1:jc,kc))

  !---- Interpolaate_array000_ut のテスト ----
  xvh_data = sqrt(3.0D0/2)*cos(xvh_Lat)*cos(xvh_Lon) & ! Y_1^1
            * (xvh_Rad-ri) *  (xvh_Rad-ro)

  data_sol = sqrt(3.0D0/2)*cos(ALat)*cos(ALon) * (ARad-ri) *  (ARad-ro)

  ut_data = ut_xvh(xvh_data)

  call AssertEqual(&
       message='Interpolate_array000_ut Y_1^-1',                     &
       answer = data_sol,                                            &
       check = Interpolate_ut(ut_data,alon,alat,arad),             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','ut_mpi_module_interpolate_test',&
                         'ut_mpi_module interpolate function test succeeded!')

  !---- a_Interpolaate_array100_ut のテスト ----
  data_sol_ary = sqrt(3.0D0/2)*cos(ALat)*cos(ALon_ary)*(ARad-ri)*(ARad-ro)

  call AssertEqual(&
       message='a_Interpolate_array100_ut Y_1^-1',                   &
       answer = data_sol_ary,                                        &
       check = Interpolate_ut(ut_data,alon_ary,alat,arad),           &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  call MessageNotify('M','ut_mpi_module_interpolate_test',&
                         'ut_mpi_module interpolate function test succeeded!')

  !------ MPIの終了 ------
  call MPI_FINALIZE(IERR)

end program ut_mpi_module_interpol

!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wb_deriv_mpi_module_sypack テストプログラム :: 微分関数のテスト
!
!履歴  2020/08/01  竹広真一
!
program wb_deriv_mpi_module_sypack_test

  use dc_types, only: DP
  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use wb_mpi_module
!!$  use ua_base_mpi_module_sypack, only : ua_base_mpi_Initial, kp_kl, &
!!$       xvb_ua, ua_xvb, jc, kc, xv_Lon, xv_Lat
!!$  use ua_deriv_mpi_module_sypack
  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=2, npv=2
!!$  integer, parameter :: im=64, jm=32, nm=21, km=2, npv=2

  real(DP), allocatable  ::  pva_data1(:,:,:)              ! 元の関数
  real(DP), allocatable  ::  pva_data2(:,:,:)              ! 元の関数
  real(DP), allocatable  ::  pva_ddata(:,:,:)              ! 微分の正解
  real(DP), allocatable  ::  pv_data1(:,:)                 ! 元の関数
  real(DP), allocatable  ::  pv_data2(:,:)                 ! 元の関数
  real(DP), allocatable  ::  pv_ddata(:,:)                 ! 微分の正解
  real(DP), allocatable  ::  pv_mu(:,:)                    ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: ip, np, ierr


 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','wb_deriv_mpi_module_sypack_test', &
                         'wb_deriv_mpi_module_sypack function tests')

!!$  call wb_base_mpi_Initial( nm, im, jm, km, npv=npv )
!!$  call wb_deriv_mpi_Initial
  call wb_mpi_Initial( nm, im, jm, km, npv=npv )

  allocate(pva_data1(ic,jc,km))
  allocate(pva_data2(ic,jc,km))
  allocate(pva_ddata(ic,jc,km))
  allocate(pv_data1(ic,jc))
  allocate(pv_data2(ic,jc))
  allocate(pv_ddata(ic,jc))
  allocate(pv_mu(ic,jc))

  !============== 微分計算 (lon,lat座標系用) のテスト ==============

  !---- Y_1^-1 Y_2^1 のテスト ----
  pva_data1(:,:,1) = -cos(pv_Lat)*sin(pv_Lon)               ! Y_1^{-1}
  pva_data1(:,:,2)  = sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon) ! Y_2^1

  pva_ddata(:,:,1) = 2*cos(pv_Lat)*sin(pv_Lon)                ! wb_Lapla_wb
  pva_ddata(:,:,2) = -6*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon) ! wb_Lapla_wb

  call AssertEqual(&
    message='wb_Lapla_wb with Y_1^-1 and Y^2_1',                  &
    answer = pva_wb(wb_Lapla_wb(wb_pva(pva_data1))),              &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  pva_ddata(:,:,1) = 1.0/2.0*cos(pv_Lat)*sin(pv_Lon)      ! wb_LaplaInv_wb
  pva_ddata(:,:,2) = -1.0D0/6.0*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)
  call AssertEqual(&
    message='wb_LaplaInv_wb with Y_1^-1 and Y^2_1',               &
    answer = pva_wb(wb_LaplaInv_wb(wb_pva(pva_data1))),           &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = -cos(pv_Lat)*cos(pv_Lon)         ! wb_DLon_wb
  pva_ddata(:,:,2) = -sin(pv_Lat)*cos(pv_Lat) * sin(pv_Lon)
  call AssertEqual(&
    message='wb_DLon_wb with Y_1^-1 and Y^2_1',                   &
    answer = pva_wb(wb_DLon_wb(wb_pva(pva_data1))),               &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = -cos(pv_Lon)                     ! pva_GradLon_wb
  pva_ddata(:,:,2) = -sin(pv_Lat) * sin(pv_Lon)
  call AssertEqual(&
    message='pva_GradLon_wb with Y_1^-1 and Y^2_1',               &
    answer = pva_GradLon_wb(wb_pva(pva_data1)),                   &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = sin(pv_Lat)*sin(pv_Lon)         ! pva_GradLat_wb
  pva_ddata(:,:,2) = cos(2*pv_Lat) * cos(pv_Lon)
  call AssertEqual(&
    message='pva_GradLat_wb with Y_1^-1 and Y^2_1',               &
    answer = pva_GradLat_wb(wb_pva(pva_data1)),                   &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = -cos(pv_Lat)*sin(pv_Lon)                 ! Y_1^{-1}
  pv_ddata = 2*cos(pv_Lat)*sin(pv_Lon)                ! wb_Lapla_wb
  call AssertEqual(&
    message='w_Lapla_w with Y_1^-1',                              &
    answer = pv_w(w_Lapla_w(w_pv(pv_data1))),                     &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pv_ddata = 1.0/2.0*cos(pv_Lat)*sin(pv_Lon)          ! wb_LaplaInv_wb
  call AssertEqual(&
    message='w_LaplaInv_w with Y_1^-1',                           &
    answer = pv_w(w_LaplaInv_w(w_pv(pv_data1))),                  &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pv_ddata = sin(pv_Lat)*sin(pv_Lon)                  ! pva_GradLat_wb
  call AssertEqual(&
    message='pv_GradLat_w with Y_1^-1',                           &
    answer = pv_GradLat_w(w_pv(pv_data1)),                        &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)    ! Y_2^1
  pv_ddata = -6*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon) ! wb_Lapla_wb
  call AssertEqual(&
    message='w_Lapla_w with Y_2^1',                               &
    answer = pv_w(w_Lapla_w(w_pv(pv_data1))),                     &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pv_ddata = -1.0D0/6.0*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon) ! wb_LaplaInv_wb
  call AssertEqual(&
    message='w_LaplaInv_w with Y_2^1',                            &
    answer = pv_w(w_LaplaInv_w(w_pv(pv_data1))),                  &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pv_ddata = cos(2*pv_Lat) * cos(pv_Lon)                      ! pva_GradLat_wb
  call AssertEqual(&
    message='pv_GradLat_w with Y_2^1',                            &
    answer = pv_GradLat_w(w_pv(pv_data1)),                        &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  !---- Y_1^-1 cosφ, Y_2^1 cosφ のテスト ----
  pva_data1(:,:,1) = -cos(pv_Lat)**2*sin(pv_Lon)              ! Y_1^-1 cosφ
  pva_data1(:,:,2) = sin(pv_Lat)*cos(pv_Lat)**2 * cos(pv_Lon) ! Y_2^1 cosφ

  pva_ddata(:,:,1) = -cos(pv_Lat)*cos(pv_Lon)                ! wb_DivLon_pv
  pva_ddata(:,:,2) = -sin(pv_Lat)*cos(pv_Lat)*sin(pv_Lon)    ! wb_DivLon_pv
  call AssertEqual(&
    message='wb_DivLon_pva with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = pva_wb(wb_DivLon_pva(pva_data1)),                    &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = 3*sin(pv_Lat)*cos(pv_Lat)*sin(pv_Lon)        !wb_DivLat_wb
  pva_ddata(:,:,2) = cos(pv_Lat)*(1-4*sin(pv_Lat)**2)*cos(pv_Lon) !wb_DivLat_wb
  call AssertEqual(&
    message='wb_DivLat_pva with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = pva_wb(wb_DivLat_pva(pva_data1)),                    &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = -cos(pv_Lat)**2*sin(pv_Lon)              ! Y_1^-1 cosφ
  pv_ddata = -cos(pv_Lat)*cos(pv_Lon)                ! w_DivLon_pv
  call Assertequal(&
    message='w_DivLon_pv with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = pv_w(w_DivLon_pv(pv_data1)),                       &
    check = pv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  pv_ddata = 3*sin(pv_Lat)*cos(pv_Lat)*sin(pv_Lon)        !w_DivLat_w
  call Assertequal(&
    message='w_DivLat_pv with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = pv_w(w_DivLat_pv(pv_data1)),                       &
    check = pv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  pv_data1 = sin(pv_Lat)*cos(pv_Lat)**2 * cos(pv_Lon) ! Y_2^1 cosφ
  pv_ddata = -sin(pv_Lat)*cos(pv_Lat)*sin(pv_Lon)    ! w_DivLon_pv
  call Assertequal(&
    message='w_DivLon_pv with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = pv_w(w_DivLon_pv(pv_data1)),                       &
    check = pv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  pv_ddata = cos(pv_Lat)*(1-4*sin(pv_Lat)**2)*cos(pv_Lon)     !w_DivLat_w
  call Assertequal(&
    message='w_DivLat_pv with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = pv_w(w_DivLat_pv(pv_data1)),                       &
    check = pv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )


  !---- Jacobian のテスト ----
  pva_data1(:,:,1) = -cos(pv_Lat)*sin(pv_Lon)          ! Y_1^{-1}
  pva_data1(:,:,2) = -cos(pv_Lat)*sin(pv_Lon)          ! Y_1^{-1}

  pva_data2(:,:,1) = -cos(pv_Lat)*sin(pv_Lon)         ! Y_1^{-1}
  pva_data2(:,:,2) = sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)   ! Y_2^1

  pva_ddata(:,:,1) = 0.0
  pva_ddata(:,:,2) = sin(pv_Lat)**2 - cos(pv_Lat)**2*cos(pv_Lon)**2

  call AssertEqual(&
    message='wb_JacobianMPI_wb_wb Y_1^-1 and Y^2_1',              &
    answer = pva_wb(wb_JacobianMPI_wb_wb(wb_pva(pva_data1),wb_pva(pva_data2))), &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = -cos(pv_Lat)*sin(pv_Lon)         ! Y_1^{-1}
  pv_data2 = -cos(pv_Lat)*sin(pv_Lon)         ! Y_1^{-1}
  pv_ddata = 0.0
  call AssertEqual(&
    message='w_JacobianMPI_w_w Y_1^-1 and Y^2_1',                    &
    answer = pv_w(w_JacobianMPI_w_w(w_pv(pv_data1),w_pv(pv_data2))), &
    check = pv_ddata,                                                &
    significant_digits = check_digits, ignore_digits = ignore        &
    )

  pv_data1 = -cos(pv_Lat)*sin(pv_Lon)                ! Y_1^{-1}
  pv_data2 = sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)   ! Y_2^1
  pv_ddata = sin(pv_Lat)**2 - cos(pv_Lat)**2*cos(pv_Lon)**2
  call AssertEqual(&
    message='w_JacobianMPI_w_w Y_1^-1 and Y^2_1',                    &
    answer = pv_w(w_JacobianMPI_w_w(w_pv(pv_data1),w_pv(pv_data2))), &
    check = pv_ddata,                                                &
    significant_digits = check_digits, ignore_digits = ignore        &
    )


  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  pv_mu = sin(pv_Lat)

  !----- Y_2^0, Y_1^1 のテスト -----
  pva_data1(:,:,1) = 3*pv_mu**2-1                              ! Y_2^0
  pva_data1(:,:,2) = sqrt(1-pv_mu**2)*cos(pv_Lon)              ! Y_1^1

  pva_ddata(:,:,1) = 0.0
  pva_ddata(:,:,2) = -sqrt(1-pv_mu**2)*sin(pv_Lon)
  call AssertEqual(&
    message='pva_GradLambda_wb with Y_2^0 and Y^1_1',             &
    answer = pva_GradLambda_wb(wb_pva(pva_data1)),                &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pva_ddata(:,:,1) = 6*pv_mu*(1-pv_mu**2)
  pva_ddata(:,:,2) = -pv_mu*sqrt(1-pv_mu**2)*cos(pv_Lon)
  call AssertEqual(&
    message='pva_GradMu_wb with Y_2^0 and Y^1_1',                 &
    answer = pva_GradMu_wb(wb_pva(pva_data1)),                    &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = 3*pv_mu**2-1                              ! Y_2^0
  pv_ddata = 0.0
  call AssertEqual(&
    message='pv_GradLambda_w with Y_2^0',                        &
    answer = pv_GradLambda_w(w_pv(pv_data1)),                    &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  pv_ddata = 6*pv_mu*(1-pv_mu**2)
  call AssertEqual(&
    message='pv_GradMu_w with Y_2^0',                             &
    answer = pv_GradMu_w(w_pv(pv_data1)),                         &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = sqrt(1-pv_mu**2)*cos(pv_Lon)              ! Y_1^1
  pv_ddata = -sqrt(1-pv_mu**2)*sin(pv_Lon)
  call AssertEqual(&
    message='pv_GradLambda_w with Y^1_1',                        &
    answer = pv_GradLambda_w(w_pv(pv_data1)),                    &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  pv_ddata = -pv_mu*sqrt(1-pv_mu**2)*cos(pv_Lon)
  call AssertEqual(&
    message='pv_GradMu_w with Y_1^1',                             &
    answer = pv_GradMu_w(w_pv(pv_data1)),                         &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  !----- Y_2^0(1-μ^2), Y_1^1 (1-μ^2) のテスト -----
  pva_data1(:,:,1) = (3*pv_mu**2-1)*(1-pv_mu**2)       ! Y_2^0 (1-μ^2)
  pva_data1(:,:,2) = (1-pv_mu**2)**(3.0/2)*cos(pv_Lon) ! Y_1^1 (1-μ^2)

  pva_ddata(:,:,1) = 0.0
  pva_ddata(:,:,2) = -(1-pv_mu**2)**(1.0d0/2)*sin(pv_Lon)
  call AssertEqual(&
    message='wb_DivLambda_pva with Y_2^0 (1-μ^2) and Y^1_1 √(1-μ^2)',&
    answer = pva_wb(wb_DivLambda_pva(pva_data1)),                 &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = (2-3*pv_mu**2)*4*pv_mu
  pva_ddata(:,:,2) = -3.0D0*pv_mu*(1-pv_mu**2)**(1.0D0/2)*cos(pv_Lon)
  call AssertEqual(&
    message='wb_DivMu_pva with Y_2^0 (1-μ^2) and Y^1_1 √(1-μ^2)',&
    answer = pva_wb(wb_DivMu_pva(pva_data1)),                     &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  pv_data1 = (3*pv_mu**2-1)*(1-pv_mu**2)       ! Y_2^0 (1-μ^2)
  pv_ddata = 0.0
  call AssertEqual(&
    message='w_DivLambda_pv with Y_2^0 (1-μ^2)',                &
    answer = pv_w(w_DivLambda_pv(pv_data1)),                     &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  pv_ddata = (2-3*pv_mu**2)*4*pv_mu
  call AssertEqual(&
    message='w_DivMu_pv with Y_2^0 (1-μ^2)',                    &
    answer = pv_w(w_DivMu_pv(pv_data1)),                         &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  pv_data1 = (1-pv_mu**2)**(3.0/2)*cos(pv_Lon) ! Y_1^1 (1-μ^2)
  pv_ddata = -(1-pv_mu**2)**(1.0d0/2)*sin(pv_Lon)
  call AssertEqual(&
    message='w_DivLambda_pv with Y^1_1 √(1-μ^2)',              &
    answer = pv_w(w_DivLambda_pv(pv_data1)),                     &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  pv_ddata = -3.0D0*pv_mu*(1-pv_mu**2)**(1.0D0/2)*cos(pv_Lon)
  call AssertEqual(&
    message='w_DivMu_pv with  Y^1_1 √(1-μ^2)',                 &
    answer = pv_w(w_DivMu_pv(pv_data1)),                         &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )


  call MessageNotify('M','wb_deriv_mpi_module_sypack_test', &
                         'wb_deriv_mpi_module_sypack function tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program wb_deriv_mpi_module_sypack_test

!----------------------------------------------------------------------
!     Copyright (c) 2007 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  et_module テストプログラム (正逆変換)
!
!履歴  2007/11/14 竹広真一
!
program et_test_transform

  use dc_message, only : MessageNotify
  use et_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8)            :: yx_Data(0:jm,0:im-1)    ! 格子データ
  real(8)            :: et_Data(-km:km,0:lm)    ! スペクトルデータ
  real(8)            :: yx_xi(0:jm,0:im-1)      ! チェビシェフ座標

  integer            :: k=2

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin =  0.0d0, ymax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), parameter :: eps = 1.0d-10            ! 判定誤差

  call MessageNotify('M','et_test_transform', &
       'et_module transform function tests')

 !---------------- 座標値の設定 ---------------------
  call et_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  yx_xi = (yx_Y - (ymin+ymax)/2 )*2/(ymax-ymin)

 !------------------- 初期値設定 ----------------------
  write(6,*) '*** Test of et_module : grid -> spectral -> grid transformation check.'
  write(6,*) '  The result will be printed '
  write(6,*) '  only when the error is larger than ', eps
  write(6,*)

!!$  write(6,*) '  Input wavenumbers of the grid data, k and l :'
!!$  read(5,*) k,l

  yx_Data = sin(k*pi*yx_X) * yx_xi
  et_Data = 0.0 ; et_Data(-k,1) = -0.5
  call check2d(et_yx(yx_Data)-et_Data, eps, &
       'Transform sin(k*pi*X)*T_1(Y)')
  call check2d(yx_et(et_yx(yx_Data))-yx_Data, eps, &
       'Inverse transform sin(k*pi*X)*T_1(Y)')

  yx_Data = cos(k*pi*yx_X) * (2*yx_xi**2 -1)
  et_Data = 0.0 ; et_Data(k,2) = 0.5
  call check2d(et_yx(yx_Data)-et_Data, eps, &
       'Transform cos(k*pi*X)*T_2(Y)')
  call check2d(yx_et(et_yx(yx_Data))-yx_Data, eps,&
       'Inverse transoform cos(k*pi*X)*T_2(Y)')

  yx_Data = sin(k*pi*yx_X)
  et_Data = 0.0 ; et_Data(-k,0) = -1.0
  call check2d(et_yx(yx_Data)-et_Data, eps, &
       'Transform sin(k*pi*X)*T_0(Y)')
  call check2d(yx_et(et_yx(yx_Data))-yx_Data, eps, &
       'Inverse transform sin(k*pi*X)*T_0(Y)')

  yx_Data = cos(k*pi*yx_X) * (4*yx_xi**3 - 3*yx_xi)
  et_Data = 0.0 ; et_Data(k,3) = 0.5
  call check2d(et_yx(yx_Data)-et_Data, eps, &
       'Transform cos(k*pi*X)*T_3(Y)')
  call check2d(yx_et(et_yx(yx_Data))-yx_Data, eps,&
       'Inverse transform cos(k*pi*X)*T_3(Y)')

  call MessageNotify('M','et_test_transform', &
       'et_module transform function tests succeeded!')

 stop
contains

  subroutine check2d(var,eps,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: eps                     ! 誤差
    character(len=*), optional :: funcname
    integer i, j

    if ( present(funcname) )then
       write(6,*) '  Checking ', funcname, '...'
    endif

    do i=1,size(var,1)
       do j=1,size(var,2)
          if (abs(var(i,j)) .gt. eps ) then
             write(6,*) &
                  '    Value larger than EPS : i= ', i, '  j= ', j, var(i,j)
             call MessageNotify('E','et_test_transform', &
                  'transform error too large')
          endif
       enddo
    enddo
  end subroutine check2d
  
end program et_test_transform

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム :: スペクトル関数のテスト
!
!履歴  2019/05/29  竹広真一
!
program ut_mpi_module_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module
  use mpi
  implicit none

  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv=2

  real(8), allocatable ::  xvh_Torvel(:,:,:)
  real(8), allocatable ::  ut_Torvel(:,:)

  real(8), allocatable ::  xvh_Polvel(:,:,:)
  real(8), allocatable ::  ut_Polvel(:,:)

  real(8), allocatable ::  xvh_Vlon(:,:,:)
  real(8), allocatable ::  xvh_Vlat(:,:,:)
  real(8), allocatable ::  xvh_Vrad(:,:,:)

  real(8), allocatable ::  nmz_EkTor(:,:,:)
  real(8), allocatable ::  nmz_EkPol(:,:,:)

  real(8), allocatable ::  nz_EkTor(:,:)
  real(8), allocatable ::  nz_EkPol(:,:)

  real(8), allocatable ::  z_Data(:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: PI
  integer :: n,m
  integer :: iproc, np, ierr

  !---------------- MPI スタート ---------------------
  !call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  PI = 4.0D0*Atan(1.0D0)

  call MessageNotify('M','ut_mpi_module_spectrum_test',&
                         'ut_mpi_module spectrum functions tests.')

  call ut_mpi_Initial(im,jm,km,nm,lm,ri,ro,npv=npv)


  allocate(xvh_Torvel(0:im-1,1:jc,kc))
  allocate(ut_Torvel(nmc,0:lm))
  allocate(xvh_Polvel(0:im-1,1:jc,kc))
  allocate(ut_Polvel(nmc,0:lm))

  allocate(xvh_Vlon(0:im-1,1:jc,kc))
  allocate(xvh_Vlat(0:im-1,1:jc,kc))
  allocate(xvh_Vrad(0:im-1,1:jc,kc))

  allocate(nmz_EkTor(0:nm,-nm:nm,0:km))
  allocate(nmz_EkPol(0:nm,-nm:nm,0:km))

  allocate(nz_EkTor(0:nm,0:km))
  allocate(nz_EkPol(0:nm,0:km))

  allocate(z_Data(0:km))

  ut_Torvel = 0.0D0
  ut_Torvel = ut_xvh(xvh_ut(ut_Torvel))

  ! (2Y_1^0+3Y_2^1) * r
!!$  xvz_Torvel =( 2 * sin(xvz_Lat) &
!!$              + 3 * 3*sin(xvz_Lat)*cos(xvz_Lat)*cos(xvz_Lon) )&
!!$              * xvz_Rad
!!$  xvz_Torvel =( 2*sqrt(3.0D0/2.0D0)*sin(xvz_Lat) &
!!$              + 3*sqrt(5.0D0/6.0D0/2.0D0)*3.0*sin(xvz_Lat)*cos(xvz_Lat)*cos(xvz_Lon) )&
!!$              * xvz_Rad
  xvh_Torvel =( 2*sqrt(3.0D0)*sin(xvh_Lat) &
              + 3*sqrt(5.0D0/6)*3.0*sin(xvh_Lat)*cos(xvh_Lat)*cos(xvh_Lon) )&
              * xvh_Rad

  ! (3*Y_1^0 + 2Y_1^1 + 2Y_2^0 +Y_2^-2) * r^2
  xvh_Polvel =( 3*sqrt(3.0D0)*sin(xvh_Lat) &
                + 2* sqrt(3.0D0/2)*cos(xvh_Lat)*cos(xvh_Lon) &
                + 2*sqrt(5.0D0)*(3.0/2*sin(xvh_Lat)**2-1/2.0) &
                - sqrt(5.0D0/24)*3.0*cos(xvh_Lat)**2*sin(2*xvh_Lon) ) &
              * xvh_Rad**2

  ut_Torvel = ut_xvh(xvh_Torvel)
  ut_Polvel = ut_xvh(xvh_Polvel)

  !--------- Energy spectrum ---------
  nmz_EkTor=ut_VMiss
  nmz_EkPol=ut_VMiss

  do n=0,nm
     do m=-n,n
        nmz_EkTor(n,m,:) = 0.0D0
        nmz_EkPol(n,m,:) = 0.0D0
     enddo
  enddo

  nmz_EkTor(1,0,:) = 4.0D0 * z_Rad**2 * (4*pi)*z_Rad**2
  nmz_EkTor(2,1,:) = 2*3*(3.0D0/2)**2/2 * z_Rad**2 * (4*pi)*z_Rad**2
  nmz_EkTor(2,-1,:) = nmz_EkTor(2,1,:)

  nmz_EkPol(1,0,:)  = 9.0D0 * (9*z_Rad**4 + 2.0D0*z_Rad**4) * (4*pi)
  nmz_EkPol(1,1,:)  = 1*2*(2/2)**2/2 * (9*z_Rad**4 + 1*2* z_Rad**4) * (4*pi)
  nmz_EkPol(1,-1,:) = nmz_EkPol(1,1,:)
  nmz_EkPol(2,0,:)  = 12.0D0 * (9*z_Rad**4 + 6.0D0*z_Rad**4) * (4*pi)
  nmz_EkPol(2,-2,:) = 2*3*(1.0D0/2)**2/2 * (9*z_Rad**4 + 2*3* z_Rad**4 ) * (4*pi)
  nmz_EkPol(2,2,:)  = nmz_EkPol(2,-2,:)

  call AssertEqual(&
    message='nmz_ToroidalEnergySpectrum_ut',                      &
    answer = nmz_ToroidalEnergySpectrum_ut(ut_Torvel),            &
    check =  nmz_EkTor,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nmz_PoloidalEnergySpectrum_ut',                      &
    answer = nmz_PoloidalEnergySpectrum_ut(ut_Polvel),            &
    check =  nmz_EkPol,                                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nz_EkTor = 0.0D0
  nz_EkTor(1,:) = 4.0D0  * z_Rad**2 * (4*pi)*z_Rad**2
  nz_EkTor(2,:) = 2 * 3 *(3.0D0/2)**2 * z_Rad**2 * (4*pi)*z_Rad**2

  nz_EkPol = 0.0D0
  nz_EkPol(1,:) = (9.0D0+1*2*(2/2)**2/2*2 )*(9*z_Rad**4+2*z_Rad**4)*(4*pi)
  nz_EkPol(2,:) = (12.0D0+2*3*(1.0D0/2)**2)*(9*z_Rad**4+2*3*z_Rad**4)*(4*pi)

  call AssertEqual(&
    message='nz_ToroidalEnergySpectrum_ut',                       &
    answer = nz_ToroidalEnergySpectrum_ut(ut_Torvel),             &
    check =  nz_EkTor,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='nz_PoloidalEnergySpectrum_ut',                       &
    answer = nz_PoloidalEnergySpectrum_ut(ut_Polvel),             &
    check =  nz_EkPol,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call ut_Potential2VectorMPI(xvh_Vlon,xvh_Vlat,xvh_Vrad,ut_Torvel,ut_Polvel)

  nmz_EkTor = nmz_ToroidalEnergySpectrum_ut(ut_Torvel)
  nmz_EkPol = nmz_PoloidalEnergySpectrum_ut(ut_Polvel)

  z_Data = 0.0D0
  do n=0,nm
     do m=-n,n
        z_Data = z_Data + nmz_EkTor(n,m,:) + nmz_EkPol(n,m,:)
     enddo
  enddo

  call AssertEqual(&
    message='Total energy by nmz-spectrum',                        &
    answer = IntLonLatRad_xvh(xvh_VLon**2+xvh_VLat**2+xvh_VRad**2)/2.0D0, &
    check =  IntRad_z(z_Data/z_Rad**2),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  nz_EkTor = nz_ToroidalEnergySpectrum_ut(ut_Torvel)
  nz_EkPol = nz_PoloidalEnergySpectrum_ut(ut_Polvel)

  call AssertEqual(&
    message='Total energy by nz-spectrum',                        &
    answer = IntLonLatRad_xvh(xvh_VLon**2+xvh_VLat**2+xvh_VRad**2)/2.0D0, &
    check =   IntRad_z(sum(nz_EkTor,1)/z_Rad**2) &
            + IntRad_z(sum(nz_EkPol,1)/z_Rad**2), &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ut_mpi_module_spectrum_test',&
                         'ut_mpi_module spectrum functions tests suceeded!')

  !------ MPIの終了 ------
  call MPI_FINALIZE(IERR)

end program ut_mpi_module_spectrum_test

!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  wb_base_mpi_module_sypack テストプログラム :: ベクトル用サブルーチンのテスト
!
!履歴  2020/08/05  竹広真一
!
program ua_base_mpi_module_sypack_vector_test_wb

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module

  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=6, npv=2

  real(8), allocatable ::  pva_U(:,:,:)              ! 速度経度成分
  real(8), allocatable ::  pva_V(:,:,:)              ! 速度緯度成分

  real(8), allocatable ::  pva_UCosLat(:,:,:)        ! 速度経度成分
  real(8), allocatable ::  pva_VCosLat(:,:,:)        ! 速度緯度成分

  real(8), allocatable ::  pva_Uans(:,:,:)           ! 速度経度成分
  real(8), allocatable ::  pva_Vans(:,:,:)           ! 速度緯度成分

  real(8), allocatable ::  pva_Psi(:,:,:)            ! 流線関数
  real(8), allocatable ::  pva_Chi(:,:,:)            ! 速度ポテンシャル

  real(8), allocatable ::  wb_Vor(:,:)               ! 渦度
  real(8), allocatable ::  wb_Div(:,:)               ! 発散

  real(8), allocatable ::  pva_Vorans(:,:,:)         ! 渦度
  real(8), allocatable ::  pva_Divans(:,:,:)         ! 発散


  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  integer :: ip, np, ierr
  integer :: k

  call MessageNotify('M','wb_base_mpi_module_vector_sypack_test', &
                         'wb_base_mpi_module_sypack subroutine tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call ua_mpi_Initial( nm, im, jm, km, npv=2 )

  allocate(pva_U(ic,jc,km))
  allocate(pva_V(ic,jc,km))
  allocate(pva_UCosLat(ic,jc,km))
  allocate(pva_VCosLat(ic,jc,km))
  allocate(pva_Uans(ic,jc,km))
  allocate(pva_Vans(ic,jc,km))
  allocate(pva_Psi(ic,jc,km))
  allocate(pva_Chi(ic,jc,km))
  allocate(pva_Vorans(ic,jc,km))
  allocate(pva_Divans(ic,jc,km))

  allocate(wb_Vor(nc,kc))
  allocate(wb_Div(nc,kc))

  pva_Psi(:,:,1) = cos(pv_Lat)*sin(pv_Lon)       ! Y_1^{-1}
  pva_Chi(:,:,1) = 0.0D0

  pva_Uans(:,:,1) = sin(pv_Lat)*sin(pv_Lon)
  pva_Vans(:,:,1) = cos(pv_Lon)

  pva_Vorans(:,:,1) = -2*cos(pv_Lat)*sin(pv_Lon)
  pva_Divans(:,:,1) = 0.0D0

  pva_Psi(:,:,2) = 0.0D0
  pva_Chi(:,:,2) = cos(pv_Lat)*sin(pv_Lon)       ! Y_1^{-1}

  pva_Uans(:,:,2) = cos(pv_Lon)
  pva_Vans(:,:,2) = - sin(pv_Lat)*sin(pv_Lon)

  pva_Vorans(:,:,2) = 0.0D0
  pva_Divans(:,:,2) = -2*cos(pv_Lat)*sin(pv_Lon)

  pva_Psi(:,:,3) = sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)       ! Y_2^1
  pva_Chi(:,:,3) = 0.0D0

  pva_Uans(:,:,3) = - cos(2*pv_Lat)*cos(pv_Lon)
  pva_Vans(:,:,3) = - sin(pv_Lat)*sin(pv_Lon)

  pva_Vorans(:,:,3) = -6*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon) ! Y_2^1
  pva_Divans(:,:,3) = 0.0D0

  pva_Psi(:,:,4) = 0.0D0
  pva_Chi(:,:,4) = sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)       ! Y_2^1

  pva_Uans(:,:,4) = - sin(pv_Lat)*sin(pv_Lon)
  pva_Vans(:,:,4) =   cos(2*pv_Lat)*cos(pv_Lon)

  pva_Vorans(:,:,4) = 0.0D0
  pva_Divans(:,:,4) = -6*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon) ! Y_2^1

  pva_Psi(:,:,5) = sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)       ! Y_2^1
  pva_Chi(:,:,5) = cos(pv_Lat)*sin(pv_Lon)                     ! Y_1^{-1}

  pva_Uans(:,:,5) = - cos(2*pv_Lat)*cos(pv_Lon) + cos(pv_Lon)
  pva_Vans(:,:,5) = - sin(pv_Lat)*sin(pv_Lon) - sin(pv_Lat)*sin(pv_Lon)

  pva_Vorans(:,:,5) = -6*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon) ! Y_2^1
  pva_Divans(:,:,5) = -2*cos(pv_Lat)*sin(pv_Lon)            ! Y_1^{-1}

  pva_Psi(:,:,6) = cos(pv_Lat)*sin(pv_Lon)                ! Y_1^{-1}
  pva_Chi(:,:,6) = sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)  ! Y_2^1

  pva_Uans(:,:,6) = 0.0D0
  pva_Vans(:,:,6) = cos(2*pv_Lat)*cos(pv_Lon) + cos(pv_Lon)

  pva_Vorans(:,:,6) = -2*cos(pv_Lat)*sin(pv_Lon)            ! Y_1^{-1}
  pva_Divans(:,:,6) = -6*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon) ! Y_2^1

  call wb_StreamPotential2VectorMPI &
       ( wb_pva(pva_Psi), wb_pva(pva_Chi), pva_U, pva_V )

  call AssertEqual(&
    message='Test of wb_StreamPotential2VectorMPI(U)',            &
    answer = pva_Uans,                                            &
    check  = pva_U,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of wb_StreamPotential2VectorMPI(V)',            &
    answer = pva_Vans,                                            &
    check  = pva_V,                                               &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call wb_Vector2VorDivMPI( pva_U, pva_V, wb_Vor, wb_Div )

  call AssertEqual(&
    message='Test of wb_Vector2VorDivMPI(Vor)',                   &
    answer = pva_Vorans,                                          &
    check  = pva_wb(wb_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of wb_Vector2VorDivMPI(Div)',                   &
    answer = pva_Divans,                                          &
    check  = pva_wb(wb_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  do k=1,km
     pva_UCosLat(:,:,k) = pva_U(:,:,k) * cos(pv_Lat)
     pva_VCosLat(:,:,k) = pva_V(:,:,k) * cos(pv_Lat)
  enddo

  call wb_VectorCosLat2VorDivMPI( pva_UCosLat, pva_VCosLat, wb_Vor, wb_Div )

  call AssertEqual(&
    message='Test of wb_VectorCosLat2VorDivMPI(Vor)',             &
    answer = pva_Vorans,                                          &
    check  = pva_wb(wb_Vor),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Test of wb_VectorCosLat2VorDivMPI(Div)',             &
    answer = pva_Divans,                                          &
    check  = pva_wb(wb_Div),                                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','wb_base_mpi_module_vector sypack_test', &
                         'wb_base_mpi_module_sypack subroutine tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_base_mpi_module_sypack_vector_test_wb

!--
!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_deriv_module
!
!  spml/wa_wave_module_deriv モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって東西 1 波数数値計算するための 
!  モジュール wa_wave_module の下部モジュールであり, スペクトル法の
!  微分計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_wave_module_deriv モジュールを
!  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
!  格子点データに対する変換が行える.
!
!  内部で ISPACK3 の LXPACK の Fortran サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
!
!履歴  2020/11/24  竹広真一 wa_wave_deriv_module_svpack より改造
!      2024/02/17  竹広真一 配列大きさ bug fix (wa_Div_xya_xya)
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
module wa_wave_module_deriv
  !
  != wa_wave_deriv_module
  !
  !== 概要
  !
  !  spml/wa_wave_module_deriv モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって東西 1 波数数値計算するための 
  !  モジュール wa_wave_module の下部モジュールであり, スペクトル法の
  !  微分計算のための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_wave_module_deriv モジュールを
  !  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータ, 
  !  格子点データに対する変換が行える.
  !
  !  内部で ISPACK3 の LXPACK の Fortran サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use w_wave_module_base, only : im, jm, nm=>nn, m
  use wa_wave_module_base, only : xya_wa, wa_xya
  use w_wave_module, only : w_xy, xy_w, w_Lapla_w, w_LaplaInv_w, &
                                   w_DLon_w

  implicit none

  private
 
  public wa_Lapla_wa, wa_LaplaInv_wa          ! ラプラシアンと逆演算
  public wa_DLon_wa                           ! 経度微分
  public xya_GradLon_wa, xya_GradLat_wa       ! 勾配型微分
  public wa_DivLon_xya, wa_DivLat_xya         ! 発散型微分
  public wa_Div_xya_xya                       ! 発散型微分
  public xya_GradLambda_wa, xya_GradMu_wa     ! 勾配型微分(λ,μ座標)
  public wa_DivLambda_xya, wa_DivMu_xya       ! 発散型微分(λ,μ座標)

contains

  !--------------- 微分計算 -----------------
  function wa_Lapla_wa(wa_data)
    !
    ! 入力スペクトルデータにラプラシアン
    !
    !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
    !
    ! を作用する(多層用).
    !
    ! スペクトルデータのラプラシアンとは, 対応する格子点データに
    ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
    !
    real(8), intent(in)  :: wa_data(:,:)
    !(in) 入力スペクトルデータ
    real(8)              :: wa_lapla_wa(2*(nm-m+1),size(wa_data,2))
    !(out) 入力スペクトルデータのラプラシアン
    integer :: k

    do k=1,size(wa_data,2)
       wa_Lapla_wa(:,k) = w_Lapla_w(wa_data(:,k))
    enddo

  end function wa_Lapla_wa

  function wa_LaplaInv_wa(wa_data)
    !
    ! 入力スペクトルデータに逆ラプラシアン
    !
    !    ▽^{-2}
    !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
    !
    ! を作用する(多層用).
    !
    ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
    ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
    !
    real(8), intent(in)  :: wa_data(:,:)
    !(in) 入力スペクトルデータ
    real(8)              :: wa_LaplaInv_wa(2*(nm-m+1),size(wa_data,2))
    !(out) スペクトルデータの逆ラプラシアン
    integer :: k

    do k=1,size(wa_data,2)
       wa_LaplaInv_wa(:,k) = w_LaplaInv_w(wa_data(:,k))
    enddo

  end function wa_LaplaInv_wa

  function wa_DLon_wa(wa_data)
    !
    ! スペクトルデータに経度微分 ∂/∂λ を作用させる(多層用).
    !
    ! スペクトルデータの経度微分とは, 対応する格子点データに
    ! 経度微分∂/∂λを作用させたデータのスペクトル変換のことである.
    ! 
    real(8), intent(in)  :: wa_data(:,:)
    !(in) 入力スペクトルデータ
    real(8)              :: wa_DLon_wa(2*(nm-m+1),size(wa_data,2))
    !(out) スペクトルデータの経度微分
    integer :: k

    do k=1,size(wa_data,2)
       wa_DLon_wa(:,k) = w_DLon_w(wa_Data(:,k))
    enddo

  end function wa_DLon_wa

  function xya_GradLon_wa(wa_data)
    !
    ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
    ! 作用させた格子点データを返す(多層用).
    !
    real(8), intent(in)  :: wa_data(:,:)
    !(in) 入力スペクトルデータ
    real(8)              :: xya_GradLon_wa(0:im-1,1:jm,size(wa_data,2))
    !(out) スペクトルデータを勾配型経度微分した格子点データ

    xya_GradLon_wa = xya_wa(wa_data,ipow=1,iflag=-1)

  end function xya_GradLon_wa

  function xya_GradLat_wa(wa_data)
    !
    ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
    ! 格子点データに変換して返す(多層用).
    !
    real(8), intent(in)  :: wa_data(:,:)
    !(in) 入力スペクトルデータ
    real(8)              :: xya_GradLat_wa(0:im-1,1:jm,size(wa_data,2))
    !(out) スペクトルデータを勾配型緯度微分した格子点データ

    xya_GradLat_wa = xya_wa(wa_data,ipow=1,iflag=1)

  end function xya_GradLat_wa

  function wa_DivLon_xya(xya_data)
    !
    ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
    ! スペクトルデータに変換して返す(多層用).
    !
    real(8), intent(in)  :: xya_data(0:,:,:)
    !(in) 入力格子点データ
    real(8)              :: wa_DivLon_xya(2*(nm-m+1),size(xya_data,3))
    !(out) 格子点データを発散型経度微分したスペクトルデータ

    wa_DivLon_xya = wa_xya(xya_data,ipow=1,iflag=-1)

  end function wa_DivLon_xya

  function wa_DivLat_xya(xya_data)
    !
    ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
    ! スペクトルデータに変換して返す(多層用).
    !
    real(8), intent(in)  :: xya_data(0:,:,:)
    !(in) 入力格子点データ
    real(8)              :: wa_DivLat_xya(2*(nm-m+1),size(xya_data,3))
    !(out) 格子点データを発散型緯度微分したスペクトルデータ

    wa_DivLat_xya = wa_xya(xya_data,ipow=1,iflag=1)

  end function wa_DivLat_xya

  function wa_Div_xya_xya(xya_u,xya_v)
    !
    ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
    ! スペクトルデータとして返す(多層用).
    !
    real(8), intent(in)  :: xya_u(0:,:,:)
    !(in) ベクトル経度成分の格子点データ
    real(8), intent(in)  :: xya_v(0:,:,:)
    !(in) ベクトル緯度成分の格子点データ
    real(8)              :: wa_Div_xya_xya(2*(nm+m-1),size(xya_u,3))
    !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

    wa_Div_xya_xya = wa_DivLon_xya(xya_u) + wa_DivLat_xya(xya_v)

  end function wa_Div_xya_xya

  !--------------- 微分計算 (λ,μ座標系用) -----------------
  function xya_GradLambda_wa(wa_data)
    !
    ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(多層用).
    !
    real(8), intent(in)  :: wa_data(:,:)
    !(in) 入力スペクトルデータ
    real(8)              :: xya_GradLambda_wa(0:im-1,1:jm,size(wa_data,2))
    !(out) スペクトルデータを勾配型経度微分した格子点データ

    xya_GradLambda_wa = xya_wa(wa_data,ipow=0,iflag=-1)

  end function xya_GradLambda_wa

  function xya_GradMu_wa(wa_data)
    !
    ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
    ! を作用させて格子点データに変換して返す(多層用).
    !
    real(8), intent(in)  :: wa_data(:,:)
    !(in) 入力スペクトルデータ
    real(8)              :: xya_GradMu_wa(0:im-1,1:jm,size(wa_data,2))
    !(out) スペクトルデータを勾配型緯度微分した格子点データ

    xya_GradMu_wa = xya_wa(wa_data,ipow=0,iflag=1)

  end function xya_GradMu_wa

  function wa_DivLambda_xya(xya_data)
    !
    ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
    ! を作用させてスペクトルデータに変換して返す(多層用).
    !
    real(8), intent(in)  :: xya_data(0:,:,:)
    !(in) 入力格子点データ
    real(8)              :: wa_DivLambda_xya(2*(nm-m+1),size(xya_data,3))
    !(out) 格子点データを発散型経度微分したスペクトルデータ

    wa_DivLambda_xya = wa_xya(xya_data,ipow=2,iflag=-1)

  end function wa_DivLambda_xya

  function wa_DivMu_xya(xya_data)
    !
    ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
    ! スペクトルデータに変換して返す(多層用).
    !
    real(8), intent(in)  :: xya_data(0:,:,:)
    !(in) 入力格子点データ
    real(8)              :: wa_DivMu_xya(2*(nm-m+1),size(xya_data,3))
    !(out) 格子点データを発散型緯度微分したスペクトルデータ

    wa_DivMu_xya = wa_xya(xya_data,ipow=2,iflag=1)

  end function wa_DivMu_xya

end module wa_wave_module_deriv

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
!***********************************************************************
!     REPACKING SPECTRA FOR x-grad                            
!***********************************************************************
SUBROUTINE SYCSMX(MM,NT,S,SX,ICOM,MI)

  IMPLICIT NONE    
  INCLUDE 'mpif.h'
  INTEGER(8) :: MM,M,N,L,N1,M1,MN,K,NS,NT,ICOM,MI
  REAL(8) :: S(*) ! S((MM/NP/MI+1)*(2*(NT+1)-MM/NP/MI*NP*MI))
  REAL(8) :: SX(*) ! SX((MM/NP/MI+1)*(2*(NT+1)-MM/NP/MI*NP*MI))
  INTEGER :: NP,IP,IERR,ICOM4
  INTEGER(8) :: NTHMAX

  CALL MXGOMP(NTHMAX)  

  ICOM4=ICOM
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)
  CALL MPI_COMM_RANK(ICOM4,IP,IERR)

  N1=(MM/MI+1)/NP
  M1=N1*NP*MI
  MN=N1
  IF(MOD(N1,2).EQ.0) THEN
     IF(IP.LE.MM/MI-M1/MI) THEN
        MN=MN+1
     END IF
  ELSE
     IF(IP.GE.NP-MM/MI+M1/MI-1) THEN
        MN=MN+1
     END IF
  END IF

  !$omp parallel do num_threads(NTHMAX)  
  DO L=1,(MM/(NP*MI)+1)*(2*(NT+1)-MM/(NP*MI)*NP*MI)
     SX(L)=0
  END DO
  !$omp end parallel do     

  !$omp parallel private(NS,M,N,L) num_threads(NTHMAX)  
  !$omp do schedule(dynamic)
  DO K=0,MN-1
     M=(K*NP+IP+MOD(K,2)*(NP-2*IP-1))*MI
     NS=K*(2*(MM+1)-(K-1)*NP*MI)+1
     IF(M.EQ.0) THEN
        DO N=0,NT
           SX(N+1)=0
        END DO
     ELSE
        DO N=M,NT
           L=NS+2*(N-M)
           SX(L)=-M*S(L+1)
           SX(L+1)=M*S(L)
        END DO
     END IF
  END DO
  !$omp end do
  !$omp end parallel

END SUBROUTINE SYCSMX

!--
!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  w_wave_deriv_module
!
!  spml/w_wave_module_deriv モジュールは球面上での 2 次元
!  流体運動を球面調和函数を用いたスペクトル法によって数値計算する
!  ための モジュール w_wave_module_ の下部モジュールであり, 
!  スペクトル法の微分計算のための Fortran90 関数を提供する. 
!
!  内部で ISPACK3 の LXPACK の Fortran サブルーチンを呼んでいる. 
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある. 
!
!
!履歴  
!      2020/11/24  竹広真一  w_wave_deriv_module_svpack より改造
!
!      制限
!         ・変換する格子点データ, スペクトルデータの配列の大きさは決めうち
!
!++
module w_wave_module_deriv
  !
  != w_wave_deriv_module
  !
  !== 概要
  !
  !  spml/w_wave_module_deriv モジュールは球面上での 2 次元
  !  流体運動を球面調和函数を用いたスペクトル法によって数値計算する
  !  ための モジュール w_wave_module_ の下部モジュールであり, 
  !  スペクトル法の微分計算のための Fortran90 関数を提供する. 
  !
  !  内部で ISPACK3 の LXPACK の Fortran サブルーチンを呼んでいる. 
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
  !
  !  このモジュールを使うためには前もって w_base_initial を呼んで
  !  切断波数, 格子点数の設定をしておく必要がある. 
  !
  use dc_message, only : MessageNotify
  use w_wave_module_base, only : im, jm, nm=>nn, mm, m, &
                                 w_base_Initial, xy_w, w_xy, w_DLon_w
  implicit none

  real(8), allocatable  :: D(:)
  ! ラプラシアン演算用配列
  !
  ! スペクトルデータのラプラシアンを計算するための係数
  ! 配列のサイズは(2*(nm-m+1))
  !

  real(8), allocatable  :: rn(:,:)            
  ! ラプラシアン演算用配列(w_module と互換性を保つため)
  !
  ! スペクトルデータのラプラシアンを計算するための係数
  ! 配列のサイズは(2*(nm-m+1), 2)
  !
  ! r(L,1) には L 番目の格納位置のスペクトルに対するラプラシアン計算の
  ! 係数 -n(n+1) の値が格納されている.
  !

  logical               :: w_wave_deriv_initialize=.false.   ! 初期化フラッグ

  private

  public w_deriv_Initial                      ! 初期化
  public w_deriv_Finalize                     ! 終了処理

  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
!!$  public w_Jacobian_w_w                       ! ヤコビアン
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)
  public rn                                   ! ラプラシアン演算用配列

  save D, rn

contains

  !--------------- 初期化 -----------------
  subroutine w_deriv_initial
    !
    ! スペクトル微分計算に必要となる作業領域を設定する. 
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで
    ! 初期設定をしなければならない. 
    !
    ! このサブルーチンを単独で用いるのでなく, 
    ! 上位サブルーチン w_Initial を使用すること.
    !
    integer :: n

    w_wave_deriv_initialize=.true.

    allocate(D(2*(nm-m+1)))
    allocate(rn(2*(nm-m+1),2))

    do n=m,nm
       D(2*(n-m+1)-1) = -n*(n+1)
       D(2*(n-m+1))   = -n*(n+1)
       rn(2*(n-m+1)-1,1) = -n*(n+1)
       rn(2*(n-m+1),1)   = -n*(n+1)
       rn(2*(n-m+1)-1,2) = -1/(n*(n+1))
       rn(2*(n-m+1),2)   = -1/(n*(n+1))
    end do

    call MessageNotify('M','w_deriv_initial',&
         'w_wave_module_deriv (2020/11/24) is initialized')

  end subroutine w_deriv_initial

  !--------------- 微分計算 -----------------
  function w_Lapla_w(w_data)
    !
    ! 入力スペクトルデータにラプラシアン
    !
    !    ▽^2 = 1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)
    !
    ! を作用する(1 層用).
    !
    ! スペクトルデータのラプラシアンとは, 対応する格子点データに
    ! ラプラシアンを作用させたデータのスペクトル変換のことである. 
    !
    real(8)              :: w_Lapla_w(2*(nm-m+1))
    !(out) 入力スペクトルデータのラプラシアン

    real(8), intent(in)  :: w_data(2*(nm-m+1))
    !(in) 入力スペクトルデータ

    w_Lapla_w = D*w_Data

  end function w_Lapla_w

  function w_LaplaInv_w(w_data)
    !
    ! 入力スペクトルデータに逆ラプラシアン
    !
    !    ▽^{-2}
    !      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
    !
    ! を作用する(1 層用).
    !
    ! スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
    ! 逆ラプラシアンを作用させたデータのスペクトル変換のことである. 
    !
    real(8)              :: w_LaplaInv_w(2*(nm-m+1))
    !(out) スペクトルデータの逆ラプラシアン

    real(8), intent(in)  :: w_data(2*(nm-m+1))
    !(in) 入力スペクトルデータ

    w_LaplaInv_w = w_data/D

  end function w_LaplaInv_w

  function xy_GradLon_w(w_data)
    !
    ! スペクトルデータに勾配型経度微分 1/cosφ・∂/∂λ を
    ! 作用させた格子点データを返す(1 層用).
    !
    real(8)              :: xy_GradLon_w(0:im-1,1:jm)
    !(out) スペクトルデータを勾配型経度微分した格子点データ

    real(8), intent(in)  :: w_data(2*(nm-m+1))
    !(in) 入力スペクトルデータ

    xy_GradLon_w = xy_w(w_data,ipow=1,iflag=-1)

  end function xy_GradLon_w

  function xy_GradLat_w(w_data)
    !
    ! スペクトルデータに勾配型緯度微分 ∂/∂φ を作用させて
    ! 格子点データに変換して返す(1 層用).
    !
    real(8)              :: xy_GradLat_w(0:im-1,1:jm)
    !(out) スペクトルデータを勾配型緯度微分した格子点データ

    real(8), intent(in)  :: w_data(2*(nm-m+1))
    !(in) 入力スペクトルデータ

    xy_GradLat_w = xy_w(w_data,ipow=1,iflag=1)

  end function xy_GradLat_w

  function w_DivLon_xy(xy_data)
    !
    ! 格子点データに発散型経度微分 1/cosφ・∂/∂λ を作用させて
    ! スペクトルデータに変換して返す(1 層用).
    !
    real(8)              :: w_DivLon_xy(2*(nm-m+1))
    !(out) 格子点データを発散型経度微分したスペクトルデータ
    real(8), intent(in)  :: xy_data(0:im-1,1:jm)
    !(in) 入力格子点データ

    w_DivLon_xy = w_xy(xy_data,ipow=1,iflag=-1)

  end function w_DivLon_xy

  function w_DivLat_xy(xy_data)
    !
    ! 格子点データに発散型緯度微分 1/cosφ・∂(f cosφ)/∂φ を作用させて
    ! スペクトルデータに変換して返す(1 層用).
    !
    real(8)              :: w_DivLat_xy(2*(nm-m+1))
    !(out) 格子点データを発散型緯度微分したスペクトルデータ

    real(8), intent(in)  :: xy_data(0:im-1,1:jm)
    !(in) 入力格子点データ

    w_DivLat_xy = w_xy(xy_data,ipow=1,iflag=1)

  end function w_DivLat_xy

  function w_Div_xy_xy(xy_u,xy_v)
    !
    ! 2 つの入力格子点データをベクトル成分とする発散を計算し, 
    ! スペクトルデータとして返す(1 層用).
    !
    real(8)              :: w_Div_xy_xy(2*(nm-m+1))
    !(out) 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ

    real(8), intent(in)  :: xy_u(0:im-1,1:jm)
    !(in) ベクトル経度成分の格子点データ

    real(8), intent(in)  :: xy_v(0:im-1,1:jm)
    !(in) ベクトル緯度成分の格子点データ

    w_Div_xy_xy = w_Divlon_xy(xy_u) + w_Divlat_xy(xy_v)

  end function w_Div_xy_xy

!!$    function w_Jacobian_w_w(w_a,w_b)
!!$      ! 2 つのスペクトルデータにヤコビアン
!!$      !
!!$      !   J(f,g) = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ
!!$      !          = ∂f/∂λ・1/cosφ・∂g/∂φ
!!$      !             - ∂g/∂λ・1/cosφ・∂f/∂φ
!!$      !
!!$      ! を作用させる(1 層用).
!!$
!!$      real(8)             :: w_Jacobian_w_w(2*(nm-m+1))
!!$      !(out) 2 つのスペクトルデータのヤコビアン
!!$
!!$      real(8), intent(in) :: w_a(2*(nm-m+1))
!!$      !(in) 1つ目の入力スペクトルデータ
!!$      
!!$      real(8), intent(in) :: w_b(2*(nm-m+1))
!!$      !(in) 2つ目の入力スペクトルデータ
!!$
!!$      w_Jacobian_w_w = w_xy( &
!!$                  xy_w(w_DLon_w(w_a))*xy_w(w_b,ipow=2,iflag=1) &
!!$                - xy_w(w_DLon_w(w_b))*xy_w(w_a,ipow=2,iflag=1) )
!!$
!!$    end function w_Jacobian_w_w

  !--------------- 微分計算 (λ,μ座標系用) -----------------
  function xy_GradLambda_w(w_data)
    !
    ! スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(1 層用).
    !
    real(8)              :: xy_GradLambda_w(0:im-1,1:jm)
    !(out) スペクトルデータを勾配型経度微分した格子点データ

    real(8), intent(in)  :: w_data(2*(nm-m+1))
    !(in) 入力スペクトルデータ

    xy_GradLambda_w = xy_w(w_data,ipow=0,iflag=-1)

  end function xy_GradLambda_w

  function xy_GradMu_w(w_data)
    !
    ! スペクトルデータに勾配型緯度微分 (1-μ^2)∂/∂μ  (μ=sinφ)
    ! を作用させて格子点データに変換して返す(1 層用).
    !
    real(8)              :: xy_GradMu_w(0:im-1,1:jm)
    !(out) スペクトルデータを勾配型緯度微分した格子点データ

    real(8), intent(in)  :: w_data(2*(nm-m+1))
    !(in) 入力スペクトルデータ

    xy_GradMu_w = xy_w(w_data,ipow=0,iflag=1)

  end function xy_GradMu_w

  function w_DivLambda_xy(xy_data)
    !
    ! 格子点データに発散型経度微分 1/(1-μ^2)・∂/∂λ (μ=sinφ) 
    ! を作用させてスペクトルデータに変換して返す(1 層用).
    !
    real(8)              :: w_DivLambda_xy(2*(nm-m+1))
    !(out) 格子点データを発散型経度微分したスペクトルデータ

    real(8), intent(in)  :: xy_data(0:im-1,1:jm)
    !(in) 入力格子点データ

    w_DivLambda_xy = w_xy(xy_data,ipow=2,iflag=-1)

  end function w_DivLambda_xy

  function w_DivMu_xy(xy_data)
    !
    ! 格子点データに発散型緯度微分 ∂/∂μ (μ=sinφ)を作用させて
    ! スペクトルデータに変換して返す(1 層用).
    !
    real(8)              :: w_DivMu_xy(2*(nm-m+1))
    !(out) 格子点データを発散型緯度微分したスペクトルデータ

    real(8), intent(in)  :: xy_data(0:im-1,1:jm)
    !(in) 入力格子点データ

    w_DivMu_xy = w_xy(xy_data,ipow=2,iflag=1)

  end function w_DivMu_xy

  !--------------- 終了処理 -----------------
  subroutine w_deriv_finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう. 
    !
    ! このサブルーチンを単独で用いるのでなく, 
    ! 上位サブルーチン w_Finalize を使用すること.
    !
    if ( .not. w_wave_deriv_initialize ) then
       call MessageNotify('W','w_deriv_Finalize',&
            'w_wave_module_deriv_ not initialized yet')
       return
    endif

    deallocate(D)           ! ラプラシアン演算用配列
    deallocate(rn)          ! ラプラシアン演算用配列

    w_wave_deriv_initialize = .false.

    call MessageNotify('M','w_deriv_Finalize',&
         'w_wave_module_deriv (2020/11/24) is finalized')

  end subroutine w_deriv_finalize

end module w_wave_module_deriv

!----------------------------------------------------------------------
! Copyright (c) 2009 SPMODEL Development Group. All rights reserved.!
!----------------------------------------------------------------------
!
!表題  lumatrix テストプログラム
!
!履歴  2009/08/06  竹広真一
!      2009/10/24  佐々木洋平 幾つかの数値代入を倍精度に変更
!                  dc_test を使用するように修正
!
program lumatrix_test

  use lumatrix
  use dc_types, only: DP
  use dc_message, only: MessageNotify
  use dc_test, only: AssertEqual, AssertGreaterThan


  integer,parameter  :: idim=2, jdim=2, ndim=2

  real(DP) :: alu3(jdim,ndim,ndim)
  real(DP) :: b3(idim,jdim,ndim)
  real(DP) :: b3sol(idim,jdim,ndim)
  integer :: kp2(jdim,ndim)
  real(DP) :: b2(jdim,ndim)
  real(DP) :: b2sol(jdim,ndim)

  real(DP) :: alu2(ndim,ndim)
  integer :: kp1(ndim)
  real(DP) :: bb2(idim,ndim)
  real(DP) :: bb2sol(idim,ndim)
  real(DP) :: bb1(ndim)
  real(DP) :: bb1sol(ndim)

  real(DP) :: alu3_A0(jdim,ndim,ndim)
  real(DP) :: b3_B0(idim,jdim,ndim)
  real(DP) :: b2_B0(jdim,ndim)
  real(DP) :: alu2_A0(ndim,ndim)
  real(DP) :: bb2_B0(idim,ndim)
  real(DP) :: bb1_B0(ndim)

  real(DP), parameter :: tol = 1.0d-12

  ! 判定誤差設定
  integer, parameter :: check_digits = 15
  integer, parameter :: ignore = -16

  call MessageNotify('M','lumatrix_test','lumatrix test')

  alu3(1,1,:) = (/1.0d0,1.0d0/)
  alu3(1,2,:) = (/1.0d0,0.0d0/)
  alu3(2,1,:) = (/0.0d0,1.0d0/)
  alu3(2,2,:) = (/1.0d0,-1.0d0/)

  b3(1,1,:)     = (/2.0d0,0.0d0/)
  b3(2,1,:)     = (/4.0d0,0.0d0/)
  b3(1,2,:)     = (/2.0d0,0.0d0/)
  b3(2,2,:)     = (/4.0d0,0.0d0/)

  b3sol(1,1,:)     = (/0.0d0,2.0d0/)
  b3sol(2,1,:)     = (/0.0d0,4.0d0/)
  b3sol(1,2,:)     = (/2.0d0,2.0d0/)
  b3sol(2,2,:)     = (/4.0d0,4.0d0/)

  b2(1,:)     = (/2.0d0,0.0d0/)
  b2(2,:)     = (/2.0d0,0.0d0/)

  b2sol(1,:)     = (/0.0d0,2.0d0/)
  b2sol(2,:)     = (/2.0d0,2.0d0/)

  alu3_A0 = alu3
  b3_B0   = b3
  b2_B0   = b2

  call ludecomp(alu3,kp2)

  b3=lusolve(alu3,kp2,b3)

  call AssertEqual(&
    & message = 'Test 323',                                        &
    & answer  = b3sol,                                             &
    & check   = b3,                                                &
    & significant_digits = check_digits, ignore_digits = ignore    &
    )

  call Assert_Residual_323(&
    & 'Test 323', alu3_A0, b3, b3_B0, tol)

  b2=lusolve(alu3,kp2,b2)

  call AssertEqual(&
    message = 'Test 322',                                         &
    answer  = b2sol,                                              &
    check   = b2,                                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call Assert_Residual_322('Test 322', alu3_A0, b2, b2_B0, tol)

  alu2(1,:) = (/1.0d0,1.0d0/)
  alu2(2,:) = (/1.0d0,0.0d0/)

  bb2(1,:)     = (/2.0d0,0.0d0/)
  bb2(2,:)     = (/4.0d0,0.0d0/)

  bb2sol(1,:)  = (/0.0d0,2.0d0/)
  bb2sol(2,:)  = (/0.0d0,4.0d0/)

  bb1(:)     = (/2.0d0,0.0d0/)
  bb1sol(:)  = (/0.0d0,2.0d0/)

  alu2_A0 = alu2
  bb2_B0  = bb2
  bb1_B0  = bb1

  call ludecomp(alu2,kp1)

  bb2=lusolve(alu2,kp1,bb2)

  call AssertEqual(&
    message = 'Test 212',                                         &
    answer  = bb2sol,                                             &
    check   = bb2,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call Assert_Residual_212('Test 212', alu2_A0, bb2, bb2_B0, tol)

  bb1=lusolve(alu2,kp1,bb1)

  call AssertEqual(&
    message = 'Test 211',                                         &
    answer  = bb1sol,                                             &
    check   = bb1,                                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call Assert_Residual_211('Test 211', alu2_A0, bb1, bb1_B0, tol)

  call MessageNotify('M','lumatrix_test','lumatrix test succeeded')

  ! ---- pivot必須ケース（先頭ピボット0） ----
  alu2 = 0.0_DP
  alu2(1,:) = (/0.0d0, 1.0d0/)
  alu2(2,:) = (/1.0d0, 1.0d0/)
  alu2_A0 = alu2

  bb1 = (/1.0d0, 2.0d0/)   ! 例：解が [1,1] になる
  bb1_B0 = bb1

  call ludecomp(alu2, kp1)
  bb1 = lusolve(alu2, kp1, bb1)

  call Assert_Residual_211('PivotCase 211', alu2_A0, bb1, bb1_B0, tol)

  ! ---- 同じLUで別RHSを2回解く ----
  bb1 = (/2.0d0, 0.0d0/)
  bb1_B0 = bb1
  bb1 = lusolve(alu2, kp1, bb1)
  call Assert_Residual_211('ReuseLU 1', alu2_A0, bb1, bb1_B0, tol)

  bb1 = (/3.0d0, 1.0d0/)
  bb1_B0 = bb1
  bb1 = lusolve(alu2, kp1, bb1)
  call Assert_Residual_211('ReuseLU 2', alu2_A0, bb1, bb1_B0, tol)


contains

  pure real(DP) function norm2_vec(x) result(n2)
    real(DP), intent(in) :: x(:)
    n2 = sqrt(sum(x*x))
  end function norm2_vec

  subroutine Assert_Residual_211(msg, A, x, b, tol)
    character(*), intent(in) :: msg
    real(DP), intent(in) :: A(:,:), x(:), b(:)
    real(DP), intent(in) :: tol
    real(DP) :: r(size(b)), rel

    r = matmul(A, x) - b
    rel = norm2_vec(r) / max(norm2_vec(b), tiny(1.0_DP))

    call AssertEqual(&
      & message=trim(msg)//' residual', &
      & answer=0.0_DP, check=rel,       &
      & significant_digits=check_digits, ignore_digits=ignore)
    call AssertGreaterThan(&
      & message=trim(msg)//' residual', &
      & answer = rel,                   &
      & check  = tol        )
  end subroutine Assert_Residual_211

  subroutine Assert_Residual_212(msg, A, x, b, tol)
    character(*), intent(in) :: msg
    real(DP), intent(in) :: A(:,:), x(:,:), b(:,:)
    real(DP), intent(in) :: tol
    integer :: j
    real(DP) :: r(size(b,2)), rel

    do j = 1, size(b,1)
      r = matmul(A, x(j,:)) - b(j,:)
      rel = norm2_vec(r) / max(norm2_vec(b(j,:)), tiny(1.0_DP))
      call AssertGreaterThan( &
        & message=trim(msg)//' residual', &
        & answer = rel,                   &
        & check  = tol        )
    end do
  end subroutine Assert_Residual_212

  subroutine Assert_Residual_322(msg, A, x, b, tol)
    character(*), intent(in) :: msg
    real(DP), intent(in) :: A(:,:,:), x(:,:), b(:,:)
    real(DP), intent(in) :: tol
    integer :: j
    real(DP) :: r(size(b,2)), rel

    do j = 1, size(b,1)
      r = matmul(A(j,:,:), x(j,:)) - b(j,:)
      rel = norm2_vec(r) / max(norm2_vec(b(j,:)), tiny(1.0_DP))
      call AssertGreaterThan( &
        & message=trim(msg)//' residual', &
        & answer = rel,                   &
        & check  = tol        )
    end do
  end subroutine Assert_Residual_322

  subroutine Assert_Residual_323(msg, A, x, b, tol)
    character(*), intent(in) :: msg
    real(DP), intent(in) :: A(:,:,:), x(:,:,:), b(:,:,:)
    real(DP), intent(in) :: tol
    integer :: i, j
    real(DP) :: r(size(b,3)), rel

    do i = 1, size(b,1)
      do j = 1, size(b,2)
        r = matmul(A(j,:,:), x(i,j,:)) - b(i,j,:)
        rel = norm2_vec(r) / max(norm2_vec(b(i,j,:)), tiny(1.0_DP))
        call AssertGreaterThan( &
          & message=trim(msg)//' residual', &
          & answer = rel,                   &
          & check  = tol        )
      end do
    end do
  end subroutine Assert_Residual_323


end program lumatrix_test

!----------------------------------------------------------------------
!     Copyright (c) 2019-2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_base_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2020/08/05  竹広真一
!      2020/11/10  竹広真一  セクター計算オプション導入
!
program ua_mpi_module_base_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_mint
  use w_mpi_module_mint, only : w_xv
  use mpi
  implicit none

!!$  integer, parameter :: im=64, jm=32, nm=21, km=3, mint=1
  integer, parameter :: im=32, jm=32, nm=21, km=3, mint=2
  integer, parameter :: npv=2

  real(8), allocatable ::  ua_data(:,:)
  real(8), allocatable ::  xvb_data(:,:,:)
  real(8), allocatable ::  pva_data(:,:,:)
  real(8), allocatable ::  u_data(:)
  real(8), allocatable ::  xv_data(:,:)
  real(8), allocatable ::  pv_data(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: ierr
  integer :: ip, np

  !---------------- MPI スタート ---------------------
  CALL MPI_INIT(IERR)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','ua_base_mpi_module_test', &
                         'ua_base_mpi_module functions tests')

  call ua_mpi_Initial( nm, im, jm, km, npv=npv, mint=mint )

  allocate(ua_data(nmc,km))
  allocate(pva_data(0:ic-1,jc,km))
  allocate(pv_data(0:ic-1,jc))
  allocate(u_data(nmc))

  !========================= xvb_wb, wb_xvb のテスト===========================

  !---- Y_1^0, Y_2^* のテスト ----
  ua_data = 0.0D0
  if ( lu_nm(1,0).ne.0) ua_data(lu_nm(1,0),1)=1.0D0
  pva_data(:,:,1) = sqrt(3.0D0)*sin(pv_Lat)                          ! Y_1^0

  if ( lu_nm(2,0).ne.0) ua_data(lu_nm(2,0),2)=1.0D0
  pva_data(:,:,2) = sqrt(5.0D0)*(3.0/2*sin(pv_Lat)**2-1/2.0)         ! Y_2^0

  if (lu_nm(2,-2).ne.0) ua_data(lu_nm(2,-2),3)=1.0D0/2.0D0
  pva_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(pv_Lat)**2*sin(2*pv_Lon) ! Y_2^-2
  
  call AssertEqual(&
       message='ua_pva with Y_1^0 and Y_2^*',                        &
       answer = ua_pva(pva_data),                                    &
       check = ua_data,                                              &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='pva_ua with Y_1^0 and Y_2^*',                                  &
       answer = pva_ua(ua_data),                                     &
       check = pva_data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  pv_data = sqrt(5.0D0)*(3.0/2*sin(pv_Lat)**2-1/2.0) ! Y_2^0
  u_data = 0.0D0 ; if ( lu_nm(2,0).ne.0) u_data(lu_nm(2,0))=1.0D0
  call AssertEqual(&
       message='u_pv with Y_2^0',                                 &
       answer = u_pv(pv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_u with Y_2^0',                                 &
       answer = pv_u(u_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  pv_data = -sqrt(5.0D0/24)*3.0*cos(pv_Lat)**2*sin(2*pv_Lon)   ! Y_2^-2
  u_data = 0.0D0 ; if (lu_nm(2,-2).ne.0) u_data(lu_nm(2,-2))=1.0D0/2.0D0
  call AssertEqual(&
       message='u_pv with Y_2^-2',                                &
       answer = u_pv(pv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_u with Y_2^-2',                                &
       answer = pv_u(u_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  !---- Y_4^* のテスト ----
  ua_data = 0.0D0
  if ( lu_nm(4,0).ne.0) ua_data(lu_nm(4,0),1)=1.0D0
  pva_data(:,:,1) = sqrt(9.0D0)*(35.0/8*sin(pv_Lat)**4-30.0/8*sin(pv_Lat)**2+3.0/8) ! Y_4^0
  if ( lu_nm(4,2).ne.0) ua_data(lu_nm(4,2),2)=1.0D0/2.0D0
  pva_data(:,:,2) = sqrt(9.0D0/360)*15.0/2*cos(pv_Lat)**2*(7*sin(pv_Lat)**2-1)*cos(2*pv_Lon)         ! Y_4^2  
  if ( lu_nm(4,4).ne.0) ua_data(lu_nm(4,4),3)=1.0D0/2.0D0
  pva_data(:,:,3) = sqrt(9.0D0/40320)*105.0*cos(pv_Lat)**4*cos(4*pv_Lon)         ! Y_4^4

  call AssertEqual(&
       message='ua_pva with Y_4^*',                                  &
       answer = ua_pva(pva_data),                                    &
       check = ua_data,                                              &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='pva_ua with Y_4^*',                                  &
       answer = pva_ua(ua_data),                                     &
       check = pva_data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  pv_data = sqrt(9.0D0)*(35.0/8*sin(pv_Lat)**4-30.0/8*sin(pv_Lat)**2+3.0/8) ! Y_4^0
  u_data = 0.0D0 ; if ( lu_nm(4,0).ne.0) u_data(lu_nm(4,0))=1.0D0
  call AssertEqual(&
       message='u_pv with Y_4^0',                                 &
       answer = u_pv(pv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_u with Y_4^0',                                 &
       answer = pv_u(u_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  pv_data = -sqrt(9.0D0/360)*15.0/2*cos(pv_Lat)**2*(7*sin(pv_Lat)**2-1)*sin(2*pv_Lon)         ! Y_4^-2  
  u_data = 0.0D0 ; if ( lu_nm(4,-2).ne.0) u_data(lu_nm(4,-2))=1.0D0/2.0D0
  call AssertEqual(&
       message='u_pv with Y_4^-2',                                &
       answer = u_pv(pv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_u with Y_4^-2',                                &
       answer = pv_u(u_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  pv_data = -sqrt(9.0D0/40320)*105.0*cos(pv_Lat)**4*sin(4*pv_Lon)         ! Y_4^-4
  u_data = 0.0D0 ; if ( lu_nm(4,-4).ne.0) u_data(lu_nm(4,-4))=1.0D0/2.0D0
  call AssertEqual(&
       message='u_pv with Y_4^-4',                                &
       answer = u_pv(pv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='pv_u with Y_4^-4',                                &
       answer = pv_u(u_pv(pv_data)),                              &
       check = pv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  call MessageNotify('M','ua_mpi_module_base_test', &
                         'ua_mpi_module_mint base functions tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_mpi_module_base_mint_test

!--
!----------------------------------------------------------------------
!     Copyright (c) 2025 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_zonal_module_integral
!
!  spml/wa_zonal_module_integral モジュールは球面上での帯状的な流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するためのモジュール
!  wa_zonal_module の下部モジュールであり, 積分・平均計算のための 
!  Fortran90 関数を提供する.
!
!  球面上の 1 層モデル用 w_zonal_module_integral モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK3 の LXPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
!
!
!履歴  2025/12/25  竹広真一
!
!++
module wa_zonal_module_integral
  !
  != wa_zonal_integral_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/wa_zonal_integral_module モジュールは球面上での帯状的な流体運動を
  !  球面調和函数を用いたスペクトル法によって数値計算するための
  !  モジュール wa_zonal_module の下部モジュールであり,
  !  積分・平均計算のための Fortran90 関数を提供する.
  !
  !  球面上の 1 層モデル用 w_integral_module モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK3 の LXPACK の Fortran77 サブルーチンを呼んでいる.
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/LXPACK のマニュアルを参照されたい.
  !
  !
  use dc_types, only: DP
  use w_zonal_module_base, only : im, jm, x_Lon_Weight, y_Lat_Weight
  implicit none

  private

  public a_IntLonLat_xya                      ! 緯度経度積分
  public ya_IntLon_xya, a_IntLon_xa           ! 経度積分
  public xa_IntLat_xya, a_IntLat_ya           ! 緯度積分
  public a_AvrLonLat_xya                      ! 緯度経度平均
  public ya_AvrLon_xya, a_AvrLon_xa           ! 経度平均
  public xa_AvrLat_xya, a_AvrLat_ya           ! 緯度平均

contains

  !--------------- 積分計算 -----------------
  function a_IntLonLat_xya(xya_data)
    !
    ! 2 次元緯度経度格子点データの全領域積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算している.
    !
    real(DP), intent(in)   :: xya_data(0:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)
    real(DP) :: a_IntLonLat_xya(size(xya_data,3))
    !(out) 積分されたデータの並び(*)

    a_IntLonLat_xya = a_IntLon_xa(xa_IntLat_xya(xya_data))

  end function a_IntLonLat_xya

  function xa_IntLat_xya(xya_data)
    !
    ! 2 次元緯度経度格子点データの緯度(Y)方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
    !
    real(DP), intent(in) :: xya_data(0:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)
    real(DP)             :: xa_IntLat_xya(0:im-1,size(xya_data,3))
    !(out) 積分された 1 次元経度(X)格子点データの並び
    integer :: j
    integer :: i_jm

    i_jm = int(jm)
    xa_IntLat_xya = 0.0D0
    do j=1,i_jm
      xa_IntLat_xya = xa_IntLat_xya + xya_data(:,j,:) * y_Lat_Weight(j)
    enddo

  end function xa_IntLat_xya

  function ya_IntLon_xya(xya_data)
    !
    ! 2 次元緯度経度格子点データの経度(X)方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(DP), intent(in) :: xya_data(0:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

    real(DP)             :: ya_IntLon_xya(1:jm,size(xya_data,3))
    !(out) 積分された 1 次元緯度(Y)格子点データの並び

    integer :: i
    integer :: i_im

    i_im = int(im)

    ya_IntLon_xya = 0.0D0
    do i=0,i_im-1
      ya_IntLon_xya = ya_IntLon_xya + xya_data(i,:,:) * x_Lon_Weight(i)
    enddo

  end function ya_IntLon_xya

  function a_IntLat_ya(ya_data)
    !
    ! 1 次元緯度(Y)格子点データの Y 方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
    !
    real(DP), intent(in) :: ya_data(:,:)
    !(in)  1 次元緯度(Y)格子点データの並び(1:jm,*)

    real(DP)             :: a_IntLat_ya(size(ya_data,2))
    !(out) 積分値の並び(*)

    integer :: i_jm
    integer :: j

    i_jm = int(jm)

    a_IntLat_ya = 0.0D0
    do j=1,i_jm
      a_IntLat_ya = a_IntLat_ya + ya_data(j,:) * y_Lat_Weight(j)
    enddo

  end function a_IntLat_ya

  function a_IntLon_xa(xa_data)          ! 経度積分
    !
    ! 1 次元経度(X)格子点データの X 方向積分(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(DP), intent(in) :: xa_data(0:,:)
    !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)
    real(DP)             :: a_IntLon_xa(size(xa_data,2))
    !(out) 積分値の並び(*)
    integer :: i_im
    integer :: i

    i_im = int(im)
    a_IntLon_xa = 0.0D0
    do i=0,i_im-1
      a_IntLon_xa = a_IntLon_xa + xa_data(i,:) * x_Lon_Weight(i)
    enddo

  end function a_IntLon_xa

  !--------------- 平均計算 -----------------
  function a_AvrLonLat_xya(xya_data)
    !
    ! 2 次元緯度経度格子点データの全領域平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している.
    !
    real(DP), intent(in)   :: xya_data(0:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

    real(DP) :: a_AvrLonLat_xya(size(xya_data,3))
    !(out) 平均値の並び(*)

    a_AvrLonLat_xya = a_AvrLon_xa(xa_AvrLat_xya(xya_data))

  end function a_AvrLonLat_xya

  function xa_AvrLat_xya(xya_data)
    !
    ! 2 次元緯度経度格子点データの緯度(Y)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
    ! y_Y_Weight の総和で割ることで平均している.
    !
    real(DP), intent(in) :: xya_data(0:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

    real(DP)             :: xa_AvrLat_xya(0:im-1,size(xya_data,3))
    !(out) 平均された 1 次元経度(X)格子点データの並び(im,*)

    xa_AvrLat_xya = xa_IntLat_xya(xya_data)/sum(y_Lat_Weight)

  end function xa_AvrLat_xya

  function ya_AvrLon_xya(xya_data)
    !
    ! 2 次元緯度経度格子点データの経度(X)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
    ! x_X_Weight の総和で割ることで平均している.
    !
    real(DP), intent(in) :: xya_data(0:,:,:)
    !(in) 2 次元経度緯度格子点データの並び(0:im-1,1:jm,*)

    real(DP)             :: ya_AvrLon_xya(1:jm,size(xya_data,3))
    !(out) 平均された 1 次元緯度(Y)格子点の並び(1:jm,*)

    ya_AvrLon_xya = ya_IntLon_xya(xya_data)/sum(x_Lon_Weight)

  end function ya_AvrLon_xya

  function a_AvrLat_ya(ya_data)
    !
    ! 1 次元(Y)格子点データの緯度(Y)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
    ! y_Y_Weight の総和で割ることで平均している.
    !
    real(DP), intent(in) :: ya_data(:,:)
    !(in)  1 次元緯度格子点データの並び(1:jm,*)

    real(DP)             :: a_AvrLat_ya(size(ya_data,2))
    !(out) 平均値の並び(*)

    a_AvrLat_ya = a_IntLat_ya(ya_data)/sum(y_Lat_Weight)

  end function a_AvrLat_ya

  function a_AvrLon_xa(xa_data)          ! 経度平均
    !
    ! 1 次元(X)格子点データの経度(X)方向平均(多層用).
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
    ! x_X_Weight の総和で割ることで平均している.
    !
    real(DP), intent(in) :: xa_data(0:,:)
    !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)

    real(DP)             :: a_AvrLon_xa(size(xa_data,2))
    !(out) 平均値の並び(*)

    a_AvrLon_xa = a_IntLon_xa(xa_data)/sum(x_Lon_Weight)

  end function a_AvrLon_xa

end module wa_zonal_module_integral

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_base_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2020/08/12  竹広真一
!
program ua_base_mpi_module_test_ua_xvb

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module
  use w_mpi_module, only : w_xv
  use mpi
  implicit none

  integer, parameter :: im=64, jm=32, nm=21, km=3
!  integer, parameter :: im=32, jm=16, nm=10, km=3
  integer, parameter :: npv=2

  real(8), allocatable ::  ua_data(:,:)
  real(8), allocatable ::  xvb_data(:,:,:)
  real(8), allocatable ::  u_data(:)
  real(8), allocatable ::  xv_data(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: ierr
  integer :: ip, np

  !---------------- MPI スタート ---------------------
  CALL MPI_INIT(IERR)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','ua_base_mpi_module_test', &
                         'ua_base_mpi_module functions tests (ua_xvb)')

  call ua_mpi_Initial( nm, im, jm, km, npv=npv )
  call MPI_Barrier(MPI_COMM_WORLD,IERR)

  allocate(ua_data(nmc,km))
  allocate(xvb_data(0:im-1,jc,kc))
  allocate(xv_data(0:im-1,jc))
  allocate(u_data(nmc))

  !========================= xvb_wb, wb_xvb のテスト===========================

  !---- Y_1^* のテスト ----
  xvb_data = 0.0D0 ; ua_data = 0.0D0
  !ua_data = ua_xvb(xvb_data)
  if ( kp_kl(1) .ne. 0 ) &
       xvb_data(:,:,kp_kl(1)) = sqrt(3.0D0)*sin(xv_Lat)          ! Y_1^0
  if ( lu_nm(1,0).ne.0) ua_data(lu_nm(1,0),1)=1.0D0

  if ( kp_kl(2) .ne. 0 ) &
       xvb_data(:,:,kp_kl(2)) = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon) ! Y_1^1
  if (lu_nm(1,1).ne.0) ua_data(lu_nm(1,1),2)=1.0D0/2.0D0

  if ( kp_kl(3) .ne. 0 ) &
       xvb_data(:,:,kp_kl(3)) = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon) ! Y_1^{-1}
  if (lu_nm(1,-1).ne.0) ua_data(lu_nm(1,-1),3)=1.0D0/2.0D0

  call AssertEqual(&
       message='ua_xvb with Y_1^*',                                  &
       answer = ua_xvb(xvb_data),                                    &
       check = ua_data,                                              &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='xvb_ua with Y_1^*',                                  &
       answer = xvb_ua(ua_xvb(xvb_data)),                            &
       check = xvb_data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xv_data = sqrt(3.0D0)*sin(xv_Lat)
  u_data = 0.0D0 ; if ( lu_nm(1,0).ne.0) u_data(lu_nm(1,0))=1.0D0
  call AssertEqual(&
       message='u_xv with Y_1^0',                                 &
       answer = u_xv(xv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='xv_u with Y_1^0',                                 &
       answer = xv_u(u_xv(xv_data)),                              &
       check = xv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  xv_data = sqrt(3.0D0/2)*cos(xv_Lat)*cos(xv_Lon) ! Y_1^1
  u_data = 0.0D0 ; if (lu_nm(1,1).ne.0) u_data(lu_nm(1,1))=1.0D0/2.0D0
  call AssertEqual(&
       message='u_xv with Y_1^1',                                 &
       answer = u_xv(xv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='xv_u with Y_1^1',                                 &
       answer = xv_u(u_xv(xv_data)),                              &
       check = xv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  xv_data = -sqrt(3.0D0/2)*cos(xv_Lat)*sin(xv_Lon) ! Y_1^{-1}
  u_data = 0.0D0 ; if (lu_nm(1,-1).ne.0) u_data(lu_nm(1,-1))=1.0D0/2.0D0
  call AssertEqual(&
       message='u_xv with Y_1^-1',                                &
       answer = u_xv(xv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='xv_u with Y_1^-1',                                &
       answer = xv_u(u_xv(xv_data)),                              &
       check = xv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  !---- Y_2^* のテスト ----
  xvb_data = 0.0D0 ; ua_data = 0.0D0
  if ( kp_kl(1) .ne. 0 ) &
       xvb_data(:,:,kp_kl(1)) = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0) ! Y_2^0
  if ( lu_nm(2,0).ne.0) ua_data(lu_nm(2,0),1)=1.0D0

  if ( kp_kl(2) .ne. 0 ) &
       xvb_data(:,:,kp_kl(2)) = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*cos(xv_Lon)!Y_2^1
  if ( lu_nm(2,1).ne.0) ua_data(lu_nm(2,1),2)=1.0D0/2.0D0
  
  if ( kp_kl(3) .ne. 0 ) &
       xvb_data(:,:,kp_kl(3)) = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)   ! Y_2^-2
  if (lu_nm(2,-2).ne.0) ua_data(lu_nm(2,-2),3)=1.0D0/2.0D0
  
  call AssertEqual(&
       message='ua_xvb with Y_2^*',                                  &
       answer = ua_xvb(xvb_data),                                    &
       check = ua_data,                                              &
       significant_digits = check_digits, ignore_digits = ignore     &
       )
  call AssertEqual(&
       message='xvb_ua with Y_2^*',                                  &
       answer = xvb_ua(ua_xvb(xvb_data)),                            &
       check = xvb_data,                                             &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  xv_data = sqrt(5.0D0)*(3.0/2*sin(xv_Lat)**2-1/2.0) ! Y_2^0
  u_data = 0.0D0 ; if ( lu_nm(2,0).ne.0) u_data(lu_nm(2,0))=1.0D0
  call AssertEqual(&
       message='u_xv with Y_2^0',                                 &
       answer = u_xv(xv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='xv_u with Y_2^0',                                 &
       answer = xv_u(u_xv(xv_data)),                              &
       check = xv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  xv_data = sqrt(5.0D0/6)*3.0*sin(xv_Lat)*cos(xv_Lat)*cos(xv_Lon)!Y_2^1
  u_data = 0.0D0 ; if ( lu_nm(2,1).ne.0) u_data(lu_nm(2,1))=1.0D0/2.0D0
  call AssertEqual(&
       message='u_xv with Y_2^1',                                 &
       answer = u_xv(xv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='xv_u with Y_2^1',                                 &
       answer = xv_u(u_xv(xv_data)),                              &
       check = xv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  xv_data = -sqrt(5.0D0/24)*3.0*cos(xv_Lat)**2*sin(2*xv_Lon)   ! Y_2^-2
  u_data = 0.0D0 ; if (lu_nm(2,-2).ne.0) u_data(lu_nm(2,-2))=1.0D0/2.0D0
  call AssertEqual(&
       message='u_xv with Y_2^-2',                                &
       answer = u_xv(xv_data),                                    &
       check = u_data,                                            &
       significant_digits = check_digits, ignore_digits = ignore  &
       )
  call AssertEqual(&
       message='xv_u with Y_2^-2',                                &
       answer = xv_u(u_xv(xv_data)),                              &
       check = xv_data,                                           &
       significant_digits = check_digits, ignore_digits = ignore  &
       )

  !---- 一般的関数のテスト ----
  if ( kp_kl(1) .ne. 0 ) &
       xvb_data(:,:,kp_kl(1)) = cos(2*xv_Lon-pi/3) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)-0.5)*(sin(xv_Lat)+1)

  if ( kp_kl(2) .ne. 0 ) &
       xvb_data(:,:,kp_kl(2)) = sin(2*xv_Lon+pi/2) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)+1)**2

  if ( kp_kl(3) .ne. 0 ) &
       xvb_data(:,:,kp_kl(3)) = cos(2*xv_Lon+pi/3) &
       *(sin(xv_Lat)-1)*(sin(xv_Lat)-0.5)**2*(sin(xv_Lat)+1)
  
  call AssertEqual(&
    message='ua_xvb, xvb_ua with a general function',             &
    answer = xvb_ua(ua_xvb(xvb_data)),                            &
    check = xvb_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data = cos(2*xv_Lon-pi/3) &
       *(sin(xv_Lat)-1)**2*(sin(xv_Lat)-0.5)*(sin(xv_Lat)+1)
  call AssertEqual(&
    message='u_xv, xv_u with a general function',                 &
    answer = xv_u(u_xv(xv_data)),                                 &
    check = xv_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  
  call MessageNotify('M','ua_base_mpi_module_test', &
                         'ua_base_mpi_module functions tests (ua_xvb) succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_base_mpi_module_test_ua_xvb

!------------------------------------------------------------------------
! Copyright (c) 2016 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  ee_module テストプログラム (補間計算)
!
!履歴  2016/08/08  竹広真一
!
program ee_mpi_module_transform_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32            ! 格子点の設定(X,Y)
  integer, parameter :: km=10, lm=10              ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: vx_Data(:,:)    ! 格子データ
  real(8), allocatable :: vx_Data1(:,:)   ! 格子データ
  real(8), allocatable :: ef_Data(:,:)    ! スペクトルデータ

  integer            :: k=2,l=5
  integer            :: np, ip, ierr

 !---- 座標変数など ----
!!$  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: xmin = 0.0d0, xmax=4.0d0
!!$  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0
  real(8), parameter :: ymin = 2.0d0, ymax=4.0d0

  real(8), parameter :: x0 = 2.0/3.0, x1=3.0/5.0d0
  real(8), parameter :: y0 = 1.0/7.0, y1=5.0/9.0d0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','ee_mpi_module_interpolate_test', &
       'ee_mpi_module interpolate function tests')

  !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  !---------------- 座標値の設定 ---------------------
  call ee_mpi_initial(im,jm,km,lm,xmin,xmax,ymin,ymax)    ! スペクトル初期化

  allocate(vx_Data(jc(ip),0:im-1))      ! 格子データ
  allocate(vx_Data1(jc(ip),0:im-1))     ! 格子データ
  allocate(ef_Data(-lm:lm,2*kc(ip)))    ! スペクトルデータ

  !------------------- 初期値設定 ----------------------
  vx_Data = sin(k*pi*vx_X) * sin(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(sin(k*pi*x0)*sin(l*pi*y0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1)*sin(l*pi*y1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = cos(k*pi*vx_X) * cos(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(cos(k*pi*x0)*cos(l*pi*y0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1)*cos(l*pi*y1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = sin(k*pi*vx_X) * cos(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(sin(k*pi*x0)*cos(l*pi*y0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1)*cos(l*pi*y1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = cos(k*pi*vx_X) * sin(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(cos(k*pi*x0)*sin(l*pi*y0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1)*sin(l*pi*y1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = sin(k*pi*vx_X)
  ef_Data = ef_vx(vx_Data)
  call check0d(sin(k*pi*x0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(sin(k*pi*x1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = cos(k*pi*vx_X)
  ef_Data = ef_vx(vx_Data)
  call check0d(cos(k*pi*x0), Interpolate_ef(ef_Data, x0, y0), &
    'check (x0, y0)')
  call check0d(cos(k*pi*x1), Interpolate_ef(ef_Data, x1, y1), &
    'check (x1, y1)')

  vx_Data = cos(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(cos(l*pi*y0), Interpolate_ef(ef_Data, x0, y0),&
    'check (x0, y0)')
  call check0d(cos(l*pi*y1), Interpolate_ef(ef_Data, x1, y1),&
    'check (x1, y1)')

  vx_Data = sin(l*pi*vx_Y)
  ef_Data = ef_vx(vx_Data)
  call check0d(sin(l*pi*y0), Interpolate_ef(ef_Data, x0, y0),&
    'check (x0, y0)')
  call check0d(sin(l*pi*y1), Interpolate_ef(ef_Data, x1, y1),&
    'check (x1, y1)')

  vx_Data = 1.0D0
  ef_Data = ef_vx(vx_Data)
  call check0d(1.0D0, Interpolate_ef(ef_Data, x0, y0), 'check (x0, y0)')
  call check0d(1.0D0, Interpolate_ef(ef_Data, x1, y1), 'check (x1, y1)')

  
  call MPI_FINALIZE(IERR)

  call MessageNotify('M','ee_mpi_module_interpolate_test', &
       'ee_mpi_module Interpolate function tests succeeded!')

 stop
contains

  subroutine check0d(var0,sol0,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var0                     ! 判定する配列
    real(8) :: sol0                     ! 誤差
    character(len=*)  :: funcname
    call AssertEqual(      &
      message = funcname,  &
      answer = sol0,       &
      check = var0,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check0d

  subroutine check2d(var,sol,funcname) ! 絶対値が eps 以上の var の要素を出力
    real(8) :: var(:,:)                ! 判定する配列
    real(8) :: sol(:,:)
    character(len=*) :: funcname

    call AssertEqual(     &
      message = funcname, &
      answer = sol,       &
      check = var,        &
      significant_digits = check_digits, ignore_digits = ignore     )

  end subroutine check2d

end program ee_mpi_module_transform_test

!----------------------------------------------------------------------
!     Copyright (c) 2019--2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ut_mpi_module テストプログラム
!
!      磁場トロイダルポテンシャルの境界値問題
!
!履歴  2019/05/29  竹広真一
!      2020/11/11  竹広真一  セクター計算オプション導入
!
program ut_mpi_module_tormagbc_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ut_mpi_module_mint
  use mpi

  implicit none

!!$  integer,parameter  :: im=32, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
!!$  integer,parameter  :: mint=1               ! 経度方向対称性
  integer,parameter  :: im=16, jm=16, km=16  ! 格子点の設定(経度, 緯度, 動径)
  integer,parameter  :: mint=2               ! 経度方向対称性
  integer,parameter  :: nm=10, lm=16         ! 切断波数の設定(水平, 動径)
  real(8),parameter  :: ri=0.5, ro=1.5       ! 内外半径

  integer :: npv = 2
  integer :: iproc, np, ierr

  real(8), allocatable :: xvh_TORMAG(:,:,:)
  real(8), allocatable :: xvh_TORMAG0(:,:,:)
  real(8), allocatable :: ut_TORMAG(:,:)
  real(8), allocatable :: xvh_Zero(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  real(8), parameter  :: pi=3.1415926535897932385D0

  !---------------- MPI スタート ---------------------
  !call get_ENV_INT('NPV',npv)

  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ut_mpi_module_tormagbc_mint_test', &
       'ut_mpi_module_mint ut_TormagBoundaries subroutine test')

  call ut_mpi_initial(im,jm,km,nm,lm,ri,ro,npv=npv,mint=mint)

  allocate(xvh_TORMAG(0:im-1,jc,kc))
  allocate(xvh_TORMAG0(0:im-1,jc,kc))
  allocate(ut_TORMAG(nmc,0:lm))
  allocate(xvh_Zero(0:im-1,jc,kc))

  xvh_Zero = 0.0D0

  !==================== ut_TormagBoundaries =========================
  ! P_10
  xvh_TORMAG = sin(xvh_lat) * (xvh_Rad-ri) * (xvh_Rad-ro)
  ! P_1_1
  !xvh_TORMAG = cos(xvh_lat)*cos(xvh_lon)* cos( pi*(xvh_rad-ri)/(ro-ri) )
  !xvh_TORMAG = 2*sin(xvh_lat)**2 * cos( pi*(xvh_rad-ri)/(ro-ri) )

  xvh_TORMAG0 = xvh_TORMAG
  ut_TORMAG = ut_xvh(xvh_TORMAG)
  call ut_TormagBoundaries(ut_TORMAG)
  xvh_TORMAG = xvh_ut(ut_TORMAG)

  call AssertEqual(&
       message='ut_TormagBoundariesTau (internal value)',            &
       answer = xvh_TORMAG0(:,:,2:kc-1),                             &
       check = xvh_TORMAG(:,:,2:kc-1),                               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  if ( ks == 0 ) then
     call AssertEqual(&
          message='ut_TormagBoundaries (Top B.C.)',                     &
          answer = xvh_Zero(:,:,1),                                     &
          check = xvh_TORMAG(:,:,1),                                    &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  else
     call AssertEqual(&
          message='ut_TormagBoundariesTau (internal value)',            &
          answer = xvh_TORMAG0(:,:,1),                                  &
          check = xvh_TORMAG(:,:,1),                                    &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  endif

  if ( ke == km ) then
     call AssertEqual(&
          message='ut_TormagBoundaries (Bottom B.C.)',                  &
          answer = xvh_Zero(:,:,kc),                                    &
          check = xvh_TORMAG(:,:,kc),                                   &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  else
     call AssertEqual(&
          message='ut_TormagBoundariesTau (internal value)',            &
          answer = xvh_TORMAG0(:,:,kc),                                 &
          check = xvh_TORMAG(:,:,kc),                                   &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  endif

  !==================== ut_TormagBoundariesGrid =========================
  ! P_10
  !xvh_TORMAG = sin(xvh_lat) * cos( pi*(xvh_rad-ri)/(ro-ri) )
  ! P_2_2
  xvh_TORMAG = cos(xvh_lat)**2*cos(2*xvh_lon)* cos( pi*(xvh_rad-ri)/(ro-ri) )

  xvh_TORMAG0 = xvh_TORMAG
  ut_TORMAG = ut_xvh(xvh_TORMAG)
  call ut_TormagBoundariesGrid(ut_TORMAG)
  xvh_TORMAG = xvh_ut(ut_TORMAG)

  call AssertEqual(&
       message='ut_TormagBoundariesGrid (internal value)',           &
       answer = xvh_TORMAG0(:,:,2:kc-1),                             &
       check = xvh_TORMAG(:,:,2:kc-1),                               &
       significant_digits = check_digits, ignore_digits = ignore     &
       )

  if ( ks == 1 ) then
     call AssertEqual(&
          message='ut_TormagBoundariesGrid (Top B.C.)',                 &
          answer = xvh_Zero(:,:,1),                                     &
          check = xvh_TORMAG(:,:,1),                                    &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  else
     call AssertEqual(&
          message='ut_TormagBoundariesGrid (internal value)',           &
          answer = xvh_TORMAG0(:,:,1),                                  &
          check = xvh_TORMAG(:,:,1),                                    &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  endif

  if ( ke == km+1 ) then
     call AssertEqual(&
          message='ut_TormagBoundariesGrid (Bottom B.C.)',              &
          answer = xvh_Zero(:,:,kc),                                    &
          check = xvh_TORMAG(:,:,kc),                                   &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  else
     call AssertEqual(&
          message='ut_TormagBoundariesGrid (internal value)',           &
          answer = xvh_TORMAG0(:,:,kc),                                 &
          check = xvh_TORMAG(:,:,kc),                                   &
          significant_digits = check_digits, ignore_digits = ignore     &
          )
  endif

  call MessageNotify('M','ut_mpi_module_tormagbc_mint_test', &
       'ut_mpi_module_mint ut_TormagBoundaries subroutine test succeeded!')

  !------ MPIの終了 ------
  call MPI_FINALIZE(IERR)

end program ut_mpi_module_tormagbc_mint_test

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SYCMPK(MM,NT1,NT2,S1,S2,ICOM,MI)

  IMPLICIT NONE    
  INCLUDE 'mpif.h'
  INTEGER(8) :: MM,M1,N1,MN,NS,NSG,M,N,K,NT1,NT2,L,ICOM,MI
  REAL(8) :: S1(*) ! S1((MM/(NP*MI)+1)*(2*(NT1+1)-MM/(NP*MI)*NP*MI))
  REAL(8) :: S2(*) ! S2((MM/(NP*MI)+1)*(2*(NT2+1)-MM/(NP*MI)*NP*MI))
  INTEGER :: NP,IP,IERR,ICOM4
  INTEGER(8) :: NTHMAX

  CALL MXGOMP(NTHMAX)  

  ICOM4=ICOM
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)
  CALL MPI_COMM_RANK(ICOM4,IP,IERR)

  N1=(MM/MI+1)/NP
  M1=N1*NP*MI
  MN=N1
  IF(MOD(N1,2).EQ.0) THEN
     IF(IP.LE.MM/MI-M1/MI) THEN
        MN=MN+1
     END IF
  ELSE
     IF(IP.GE.NP-MM/MI+M1/MI-1) THEN
        MN=MN+1
     END IF
  END IF

  !$omp parallel do num_threads(NTHMAX)
  DO L=1,(MM/(NP*MI)+1)*(2*(NT2+1)-MM/(NP*MI)*NP*MI)
     S2(L)=0
  END DO
  !$omp end parallel do     

  IF(NT2.GT.NT1) THEN
     !$omp parallel private(NS,NSG,N,M,L) num_threads(NTHMAX)
     !$omp do schedule(dynamic)
     DO K=0,MN-1
        M=(K*NP+IP+MOD(K,2)*(NP-2*IP-1))*MI
        IF(M.EQ.0) THEN
           DO N=0,NT1
              S2(N+1)=S1(N+1)
           END DO
           DO N=NT1+1,NT2
              S2(N+1)=0
           END DO
        ELSE
           NS=K*(2*(NT1+1)-(K-1)*NP*MI)+1
           NSG=K*(2*(NT2+1)-(K-1)*NP*MI)+1
           DO L=0,2*(NT1-M+1)-1
              S2(NSG+L)=S1(NS+L)
           END DO
           DO L=2*(NT1-M+1),2*(NT2-M+1)-1
              S2(NSG+L)=0
           END DO
        END IF
     END DO
     !$omp end do
     !$omp end parallel
  ELSE IF(NT2.LT.NT1) THEN
     !$omp parallel private(NS,NSG,N,M,L) num_threads(NTHMAX)  
     !$omp do schedule(dynamic)
     DO K=0,MN-1
        M=(K*NP+IP+MOD(K,2)*(NP-2*IP-1))*MI
        IF(M.EQ.0) THEN
           DO N=0,NT2
              S2(N+1)=S1(N+1)
           END DO
        ELSE
           NS=K*(2*(NT1+1)-(K-1)*NP*MI)+1
           NSG=K*(2*(NT2+1)-(K-1)*NP*MI)+1
           DO L=0,2*(NT2-M+1)-1
              S2(NSG+L)=S1(NS+L)
           END DO
        END IF
     END DO
     !$omp end do
     !$omp end parallel
  ELSE
     !$omp parallel do num_threads(NTHMAX)  
     DO L=1,(MM/(NP*MI)+1)*(2*(NT2+1)-MM/(NP*MI)*NP*MI)
        S2(L)=S1(L)
     END DO
     !$omp end parallel do     
  END IF

END SUBROUTINE SYCMPK

!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_deriv_mpi_module テストプログラム :: 微分関数のテスト
!
!履歴  2020/08/04  竹広真一
!
program ua_deriv_mpi_module_test_ua_xvb

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module
  use mpi
  implicit none

  integer, parameter :: im=64, jm=32, nm=21, km=2, npv=2

  real(8), allocatable  ::  xvb_data1(:,:,:)              ! 元の関数
  real(8), allocatable  ::  xvb_data2(:,:,:)              ! 元の関数
  real(8), allocatable  ::  xvb_ddata(:,:,:)              ! 微分の正解
  real(8), allocatable  ::  xv_data1(:,:)                 ! 元の関数
  real(8), allocatable  ::  xv_data2(:,:)                 ! 元の関数
  real(8), allocatable  ::  xv_ddata(:,:)                 ! 微分の正解
  real(8), allocatable  ::  xv_mu(:,:)                    ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: ip, np, ierr


 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ua_deriv_mpi_module_test', &
                         'ua_deriv_mpi_module function tests (ua-xvb)')

  call ua_mpi_Initial( nm, im, jm, km, npv=npv )

  allocate(xvb_data1(0:im-1,jc,kc))
  allocate(xvb_data2(0:im-1,jc,kc))
  allocate(xvb_ddata(0:im-1,jc,kc))
  allocate(xv_data1(0:im-1,jc))
  allocate(xv_data2(0:im-1,jc))
  allocate(xv_ddata(0:im-1,jc))
  allocate(xv_mu(0:im-1,jc))

  !============== 微分計算 (lon,lat座標系用) のテスト ==============

  xvb_data1 = 0.0D0
  xvb_ddata = 0.0D0
  !---- Y_1^-1 Y_2^1 のテスト ----
  if ( kp_kl(1) /= 0 ) &
       xvb_data1(:,:,kp_kl(1)) = -cos(xv_Lat)*sin(xv_Lon)             ! Y_1^{-1}
  if ( kp_kl(2) /= 0 ) &
       xvb_data1(:,:,kp_kl(2))  = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! Y_2^1

  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = 2*cos(xv_Lat)*sin(xv_Lon)             ! ua_Lapla_ua
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! ua_Lapla_ua
  call AssertEqual(&
    message='ua_Lapla_ua with Y_1^-1 and Y^2_1',                  &
    answer = xvb_ua(ua_Lapla_ua(ua_xvb(xvb_data1))),              &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 
  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = 1.0/2.0*cos(xv_Lat)*sin(xv_Lon)      ! ua_LaplaInv_ua
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -1.0D0/6.0*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='ua_LaplaInv_ua with Y_1^-1 and Y^2_1',               &
    answer = xvb_ua(ua_LaplaInv_ua(ua_xvb(xvb_data1))),           &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = -cos(xv_Lat)*cos(xv_Lon)         ! ua_DLon_ua
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -sin(xv_Lat)*cos(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='ua_DLon_ua with Y_1^-1 and Y^2_1',                   &
    answer = xvb_ua(ua_DLon_ua(ua_xvb(xvb_data1))),               &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = -cos(xv_Lon)                     ! xvb_GradLon_ua
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -sin(xv_Lat) * sin(xv_Lon)
  call AssertEqual(&
    message='xvb_GradLon_ua with Y_1^-1 and Y^2_1',               &
    answer = xvb_GradLon_ua(ua_xvb(xvb_data1)),                   &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = sin(xv_Lat)*sin(xv_Lon)         ! xvb_GradLat_ua
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = cos(2*xv_Lat) * cos(xv_Lon)
  call AssertEqual(&
    message='xvb_GradLat_ua with Y_1^-1 and Y^2_1',               &
    answer = xvb_GradLat_ua(ua_xvb(xvb_data1)),                   &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data1 = -cos(xv_Lat)*sin(xv_Lon)                 ! Y_1^{-1}
  xv_ddata = 2*cos(xv_Lat)*sin(xv_Lon)                ! ua_Lapla_ua
  call AssertEqual(&
    message='u_Lapla_u with Y_1^-1',                              &
    answer = xv_u(u_Lapla_u(u_xv(xv_data1))),                     &
    check = xv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  xv_ddata = 1.0/2.0*cos(xv_Lat)*sin(xv_Lon)          ! ua_LaplaInv_ua
  call AssertEqual(&
    message='u_LaplaInv_u with Y_1^-1',                           &
    answer = xv_u(u_LaplaInv_u(u_xv(xv_data1))),                  &
    check = xv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  xv_ddata = sin(xv_Lat)*sin(xv_Lon)                  ! xvb_GradLat_ua
  call AssertEqual(&
    message='xv_GradLat_u with Y_1^-1',                           &
    answer = xv_GradLat_u(u_xv(xv_data1)),                        &
    check = xv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data1 = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)    ! Y_2^1
  xv_ddata = -6*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! ua_Lapla_ua
  call AssertEqual(&
    message='u_Lapla_u with Y_2^1',                               &
    answer = xv_u(u_Lapla_u(u_xv(xv_data1))),                     &
    check = xv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  xv_ddata = -1.0D0/6.0*sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon) ! ua_LaplaInv_ua
  call AssertEqual(&
    message='u_LaplaInv_u with Y_2^1',                            &
    answer = xv_u(u_LaplaInv_u(u_xv(xv_data1))),                  &
    check = xv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  xv_ddata = cos(2*xv_Lat) * cos(xv_Lon)                      ! xvb_GradLat_ua
  call AssertEqual(&
    message='xv_GradLat_u with Y_2^1',                            &
    answer = xv_GradLat_u(u_xv(xv_data1)),                        &
    check = xv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  
  !---- Y_1^-1 cosφ, Y_2^1 cosφ のテスト ----
  xvb_data1 = 0.0D0
  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_data1(:,:,kp_kl(1)) = -cos(xv_Lat)**2*sin(xv_Lon)              ! Y_1^-1 cosφ
  if ( kp_kl(2) /= 0 ) &
       xvb_data1(:,:,kp_kl(2)) = sin(xv_Lat)*cos(xv_Lat)**2 * cos(xv_Lon) ! Y_2^1 cosφ

  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = -cos(xv_Lat)*cos(xv_Lon)                ! ua_DivLon_xv
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -sin(xv_Lat)*cos(xv_Lat)*sin(xv_Lon)    ! ua_DivLon_xv
  call AssertEqual(&
    message='ua_DivLon_xvb with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xvb_ua(ua_DivLon_xvb(xvb_data1)),                    &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = 3*sin(xv_Lat)*cos(xv_Lat)*sin(xv_Lon)        !ua_DivLat_ua
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = cos(xv_Lat)*(1-4*sin(xv_Lat)**2)*cos(xv_Lon) !ua_DivLat_ua
  call AssertEqual(&
    message='ua_DivLat_xvb with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xvb_ua(ua_DivLat_xvb(xvb_data1)),                    &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data1 = -cos(xv_Lat)**2*sin(xv_Lon)              ! Y_1^-1 cosφ
  xv_ddata = -cos(xv_Lat)*cos(xv_Lon)                ! u_DivLon_xv
  call Assertequal(&
    message='u_DivLon_xv with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xv_u(u_DivLon_xv(xv_data1)),                       &
    check = xv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  xv_ddata = 3*sin(xv_Lat)*cos(xv_Lat)*sin(xv_Lon)        !u_DivLat_u
  call Assertequal(&
    message='u_DivLat_xv with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xv_u(u_DivLat_xv(xv_data1)),                       &
    check = xv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  
  xv_data1 = sin(xv_Lat)*cos(xv_Lat)**2 * cos(xv_Lon) ! Y_2^1 cosφ
  xv_ddata = -sin(xv_Lat)*cos(xv_Lat)*sin(xv_Lon)    ! u_DivLon_xv
  call Assertequal(&
    message='u_DivLon_xv with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xv_u(u_DivLon_xv(xv_data1)),                       &
    check = xv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  xv_ddata = cos(xv_Lat)*(1-4*sin(xv_Lat)**2)*cos(xv_Lon)     !u_DivLat_u
  call Assertequal(&
    message='u_DivLat_xv with Y_1^-1 cosφ and Y^2_1 cosφ',    &
    answer = xv_u(u_DivLat_xv(xv_data1)),                       &
    check = xv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  
  !---- Jacobian のテスト ----
  xvb_data1 = 0.0D0
  xvb_data2 = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_data1(:,:,kp_kl(1)) = -cos(xv_Lat)*sin(xv_Lon)          ! Y_1^{-1}

  if ( kp_kl(2) /= 0 ) &
       xvb_data1(:,:,kp_kl(2)) = -cos(xv_Lat)*sin(xv_Lon)          ! Y_1^{-1}

  if ( kp_kl(1) /= 0 ) &
       xvb_data2(:,:,kp_kl(1)) = -cos(xv_Lat)*sin(xv_Lon)         ! Y_1^{-1}
  if ( kp_kl(2) /= 0 ) &
       xvb_data2(:,:,kp_kl(2)) = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)   ! Y_2^1

  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = 0.0
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = sin(xv_Lat)**2 - cos(xv_Lat)**2*cos(xv_Lon)**2

  call AssertEqual(&
    message='ua_JacobianMPI_ua_ua Y_1^-1 and Y^2_1',                 &
    answer = xvb_ua(ua_JacobianMPI_ua_ua(ua_xvb(xvb_data1),ua_xvb(xvb_data2))), &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data1 = -cos(xv_Lat)*sin(xv_Lon)         ! Y_1^{-1}
  xv_data2 = -cos(xv_Lat)*sin(xv_Lon)         ! Y_1^{-1}
  xv_ddata = 0.0
  call AssertEqual(&
    message='u_JacobianMPI_u_u Y_1^-1 and Y^2_1',                    &
    answer = xv_u(u_JacobianMPI_u_u(u_xv(xv_data1),u_xv(xv_data2))), &
    check = xv_ddata,                                                &
    significant_digits = check_digits, ignore_digits = ignore        &
    )

  xv_data1 = -cos(xv_Lat)*sin(xv_Lon)                ! Y_1^{-1}
  xv_data2 = sin(xv_Lat)*cos(xv_Lat) * cos(xv_Lon)   ! Y_2^1
  xv_ddata = sin(xv_Lat)**2 - cos(xv_Lat)**2*cos(xv_Lon)**2
  call AssertEqual(&
    message='u_JacobianMPI_u_u Y_1^-1 and Y^2_1',                    &
    answer = xv_u(u_JacobianMPI_u_u(u_xv(xv_data1),u_xv(xv_data2))), &
    check = xv_ddata,                                                &
    significant_digits = check_digits, ignore_digits = ignore        &
    )
 

  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  xv_mu = sin(xv_Lat)

  !----- Y_2^0, Y_1^1 のテスト -----
  xvb_data1 = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_data1(:,:,kp_kl(1)) = 3*xv_mu**2-1                              ! Y_2^0
  if ( kp_kl(2) /= 0 ) &
       xvb_data1(:,:,kp_kl(2)) = sqrt(1-xv_mu**2)*cos(xv_Lon)              ! Y_1^1

  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = 0.0
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -sqrt(1-xv_mu**2)*sin(xv_Lon)
  call AssertEqual(&
    message='xvb_GradLambda_ua with Y_2^0 and Y^1_1',             &
    answer = xvb_GradLambda_ua(ua_xvb(xvb_data1)),                &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = 6*xv_mu*(1-xv_mu**2)
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -xv_mu*sqrt(1-xv_mu**2)*cos(xv_Lon)
  call AssertEqual(&
    message='xvb_GradMu_ua with Y_2^0 and Y^1_1',                 &
    answer = xvb_GradMu_ua(ua_xvb(xvb_data1)),                    &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data1 = 3*xv_mu**2-1                              ! Y_2^0
  xv_ddata = 0.0
  call AssertEqual(&
    message='xv_GradLambda_u with Y_2^0',                        &
    answer = xv_GradLambda_u(u_xv(xv_data1)),                    &
    check = xv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  xv_ddata = 6*xv_mu*(1-xv_mu**2)
  call AssertEqual(&
    message='xv_GradMu_u with Y_2^0',                             &
    answer = xv_GradMu_u(u_xv(xv_data1)),                         &
    check = xv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_data1 = sqrt(1-xv_mu**2)*cos(xv_Lon)              ! Y_1^1
  xv_ddata = -sqrt(1-xv_mu**2)*sin(xv_Lon)
  call AssertEqual(&
    message='xv_GradLambda_u with Y^1_1',                        &
    answer = xv_GradLambda_u(u_xv(xv_data1)),                    &
    check = xv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  xv_ddata = -xv_mu*sqrt(1-xv_mu**2)*cos(xv_Lon)
  call AssertEqual(&
    message='xv_GradMu_u with Y_1^1',                             &
    answer = xv_GradMu_u(u_xv(xv_data1)),                         &
    check = xv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  !----- Y_2^0(1-μ^2), Y_1^1 (1-μ^2) のテスト -----
  xvb_data1 = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_data1(:,:,kp_kl(1)) = (3*xv_mu**2-1)*(1-xv_mu**2)       ! Y_2^0 (1-μ^2)
  if ( kp_kl(2) /= 0 ) &
       xvb_data1(:,:,kp_kl(2)) = (1-xv_mu**2)**(3.0/2)*cos(xv_Lon) ! Y_1^1 (1-μ^2)

  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = 0.0
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -(1-xv_mu**2)**(1.0d0/2)*sin(xv_Lon)
  call AssertEqual(&
    message='ua_DivLambda_xvb with Y_2^0 (1-μ^2) and Y^1_1 √(1-μ^2)',&
    answer = xvb_ua(ua_DivLambda_xvb(xvb_data1)),                 &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xvb_ddata = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_ddata(:,:,kp_kl(1)) = (2-3*xv_mu**2)*4*xv_mu
  if ( kp_kl(2) /= 0 ) &
       xvb_ddata(:,:,kp_kl(2)) = -3.0D0*xv_mu*(1-xv_mu**2)**(1.0D0/2)*cos(xv_Lon)
  call AssertEqual(&
    message='ua_DivMu_xvb with Y_2^0 (1-μ^2) and Y^1_1 √(1-μ^2)',&
    answer = xvb_ua(ua_DivMu_xvb(xvb_data1)),                     &
    check = xvb_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  
  xv_data1 = (3*xv_mu**2-1)*(1-xv_mu**2)       ! Y_2^0 (1-μ^2)
  xv_ddata = 0.0
  call AssertEqual(&
    message='u_DivLambda_xv with Y_2^0 (1-μ^2)',                &
    answer = xv_u(u_DivLambda_xv(xv_data1)),                     &
    check = xv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  xv_ddata = (2-3*xv_mu**2)*4*xv_mu
  call AssertEqual(&
    message='u_DivMu_xv with Y_2^0 (1-μ^2)',                    &
    answer = xv_u(u_DivMu_xv(xv_data1)),                         &
    check = xv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  xv_data1 = (1-xv_mu**2)**(3.0/2)*cos(xv_Lon) ! Y_1^1 (1-μ^2)
  xv_ddata = -(1-xv_mu**2)**(1.0d0/2)*sin(xv_Lon)
  call AssertEqual(&
    message='u_DivLambda_xv with Y^1_1 √(1-μ^2)',              &
    answer = xv_u(u_DivLambda_xv(xv_data1)),                     &
    check = xv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  xv_ddata = -3.0D0*xv_mu*(1-xv_mu**2)**(1.0D0/2)*cos(xv_Lon)
  call AssertEqual(&
    message='u_DivMu_xv with  Y^1_1 √(1-μ^2)',                 &
    answer = xv_u(u_DivMu_xv(xv_data1)),                         &
    check = xv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  
  call MessageNotify('M','ua_deriv_mpi_module_test', &
                         'ua_deriv_mpi_module function tests (ua-xvb) succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_deriv_mpi_module_test_ua_xvb

!----------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  wb_integral_mpi_module_sypack
!
!  spml/wb_integral_mpi_module_sypack モジュールは球面上での流体運動を
!  球面調和函数と MPI 並列ライブラリを用いたスペクトル法によって
!  数値計算するための モジュール wb_mpi_module_sypack の下部モジュールであり,
!  積分・平均計算のための Fortran90 関数を提供する.
!
!  球面上の 1 層モデル用 u_integral_module_sypack モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!
!
!履歴  2020/08/02  竹広真一
!
module wb_mpi_module_integral
  !
  ! wb_mpi_module_integral
  !
  !  spml/wb_mpi_module_integral モジュールは球面上での流体運動を
  !  球面調和函数と MPI 並列ライブラリを用いたスペクトル法によって
  !  数値計算するための モジュール wb_mpi_module の下部モジュールであり,
  !  積分・平均計算のための Fortran90 関数を提供する.
  !
  !  球面上の 1 層モデル用 u_integral_module モジュールを多層モデル用に
  !  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  !  対する変換が行える.
  !
  !  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
  !  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  !  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
  !
  !
  use mpi
  use wb_mpi_module_base, only : MPI_COMM_H, MPI_COMM_V, &
       ic, p_Lon_Weight, jc, v_Lat_Weight
  use w_mpi_module, only : IntLat_v, AvrLat_v
  
  implicit none
  integer :: ierr

  private

  public a_IntLonLat_pva, IntLonLat_pv        ! 緯度経度積分
  public va_IntLon_pva, a_IntLon_pa, IntLon_p ! 経度積分
  public pa_IntLat_pva, a_IntLat_va           ! 緯度積分
  public a_AvrLonLat_pva, AvrLonLat_pv        ! 緯度経度平均
  public va_AvrLon_pva, a_AvrLon_pa, AvrLon_p ! 経度平均
  public pa_AvrLat_pva, a_AvrLat_va           ! 緯度平均

  contains

  !--------------- 積分計算 -----------------
    function a_IntLonLat_pva(pva_data)
      !
      ! 2 次元緯度経度格子点データの全領域積分(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している.
      !
      real(8), intent(in)   :: pva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(ic,jc,*)

      real(8) :: a_IntLonLat_pva(size(pva_data,3))
      !(out) 積分されたデータの並び(*)

      a_IntLonLat_pva = a_IntLon_pa(pa_IntLat_pva(pva_data))
    end function a_IntLonLat_pva

    function IntLonLat_pv(pv_data)
      !
      ! 2 次元緯度経度格子点データの全領域積分(一層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算している.
      !
      real(8), intent(in)   :: pv_data(:,:)
      !(in) 2 次元経度緯度格子点データの並び(ic,jc)

      real(8) :: IntLonLat_pv
      !(out) 積分されたデータの並び(*)

      IntLonLat_pv = IntLat_v(a_IntLon_pa(pv_Data))
    end function IntLonLat_pv

    function pa_IntLat_pva(pva_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: pva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8)             :: pa_IntLat_pva(ic,size(pva_data,3))
      !(out) 積分された 1 次元経度(X)格子点データの並び

      real(8)             :: pa_IntLatTmp(ic,size(pva_data,3))
      Integer :: j

      pa_IntLat_pva = 0
      do j=1,jc
         pa_IntLat_pva = pa_IntLat_pva + pva_data(:,j,:) * v_Lat_Weight(j)
      enddo

      pa_IntLatTmp=pa_IntLat_pva
      CALL MPI_ALLREDUCE(pa_IntLatTMP,pa_IntLat_pva,ic*size(pva_data,3),&
           MPI_REAL8, MPI_SUM,MPI_COMM_H,IERR)

    end function pa_IntLat_pva

    function va_IntLon_pva(pva_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: pva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8)             :: va_IntLon_pva(jc,size(pva_data,3))
      !(out) 積分された 1 次元緯度(Y)格子点データの並び

      real(8)             :: va_IntLonTmp(jc,size(pva_data,3))
      integer :: i

      va_IntLon_pva = 0
      do i=1,ic
         va_IntLon_pva = va_IntLon_pva + pva_data(i,:,:) * p_Lon_Weight(i)
      enddo

      va_IntLonTmp=va_IntLon_pva
      CALL MPI_ALLREDUCE(va_IntLonTMP,va_IntLon_pva,jc*size(pva_data,3),&
           MPI_REAL8, MPI_SUM, MPI_COMM_V, IERR)

    end function va_IntLon_pva

    function a_IntLon_pa(pa_data)          ! 経度積分
      !
      ! 1 次元経度(X)格子点データの X 方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: pa_data(:,:)
      !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)
      real(8)             :: a_IntLon_pa(size(pa_data,2))
      !(out) 積分値の並び(*)
      integer :: i

      real(8)             :: a_IntLonTmp(size(pa_data,2))

      a_IntLon_pa = 0.0D0
      do i=1,ic
         a_IntLon_pa = a_IntLon_pa + pa_data(i,:) * p_Lon_Weight(i)
      enddo

      a_IntLonTmp = a_IntLon_pa
      CALL MPI_ALLREDUCE(a_IntLonTMP,a_IntLon_pa,size(pa_data,2),&
           MPI_REAL8, MPI_SUM, MPI_COMM_V, IERR)

    end function a_IntLon_pa

    function IntLon_p(p_data)          ! 経度積分
      !
      ! 1 次元経度(X)格子点データの X 方向積分(一層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: p_data(:)
      !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)
      real(8)             :: IntLon_p
      !(out) 積分値の並び(*)

      real(8)             :: IntLonTmp

      IntLonTmp= sum(p_data*p_Lon_Weight)

      CALL MPI_ALLREDUCE(IntLonTMP,IntLon_p,1,&
           MPI_REAL8, MPI_SUM, MPI_COMM_V, IERR)

    end function IntLon_p
    
    function a_IntLat_va(va_data)
      !
      ! 1 次元緯度(Y)格子点データの Y 方向積分(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: va_data(:,:)
      !(in)  1 次元緯度(Y)格子点データの並び(jc,*)

      real(8)             :: a_IntLat_va(size(va_data,2))
      !(out) 積分値の並び(*)

      real(8)             :: a_IntLatTmp(size(va_data,2))
      integer :: j

      a_IntLat_va = 0
      do j=1,jc
         a_IntLat_va = a_IntLat_va + va_data(j,:) * v_Lat_Weight(j)
      enddo

      a_IntLatTmp=a_IntLat_va
      CALL MPI_ALLREDUCE(a_IntLatTMP,a_IntLat_va,size(va_data,2),MPI_REAL8, &
                         MPI_SUM,MPI_COMM_H,IERR)

    end function a_IntLat_va

    !--------------- 平均計算 -----------------
    function a_AvrLonLat_pva(pva_data)
      !
      ! 2 次元緯度経度格子点データの全領域平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している.
      !
      real(8), intent(in)   :: pva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8) :: a_AvrLonLat_pva(size(pva_data,3))
      !(out) 平均値の並び(*)

      a_AvrLonLat_pva = a_AvrLon_pa(pa_AvrLat_pva(pva_data))
    end function a_AvrLonLat_pva

    function AvrLonLat_pv(pv_data)
      !
      ! 2 次元緯度経度格子点データの全領域平均(一層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
      ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している.
      !
      real(8), intent(in)   :: pv_data(:,:)
      !(in) 2 次元経度緯度格子点データの並び(ic,jc,*)

      real(8) :: AvrLonLat_pv
      !(out) 平均値の並び(*)

      AvrLonLat_pv = AvrLat_v(a_AvrLon_pa(pv_data))
    end function AvrLonLat_pv

    function pa_AvrLat_pva(pva_data)
      !
      ! 2 次元緯度経度格子点データの緯度(Y)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
      ! y_Y_Weight の総和で割ることで平均している.
      !
      real(8), intent(in) :: pva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8)             :: pa_AvrLat_pva(ic,size(pva_data,3))
      !(out) 平均された 1 次元経度(X)格子点データの並び(0:im-1,*)

      real(8)             :: Tmp
      real(8)             :: Lat_Weight_Sum

      Tmp = sum(v_Lat_weight)
      CALL MPI_ALLREDUCE(TMP,Lat_Weight_Sum,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_H,IERR)

      pa_AvrLat_pva = pa_IntLat_pva(pva_data)/Lat_Weight_Sum

    end function pa_AvrLat_pva

    function va_AvrLon_pva(pva_data)
      !
      ! 2 次元緯度経度格子点データの経度(X)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
      ! x_X_Weight の総和で割ることで平均している.
      !
      real(8), intent(in) :: pva_data(:,:,:)
      !(in) 2 次元経度緯度格子点データの並び(0:im-1,jc,*)

      real(8)             :: va_AvrLon_pva(jc,size(pva_data,3))
      !(out) 平均された 1 次元緯度(Y)格子点の並び(jc,*)

      real(8)             :: Tmp
      real(8)             :: Lon_Weight_Sum

      Tmp = sum(p_Lon_weight)
      CALL MPI_ALLREDUCE(TMP,Lon_Weight_Sum,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_V,IERR)

      va_AvrLon_pva = va_IntLon_pva(pva_data)/Lon_Weight_Sum

    end function va_AvrLon_pva

    function a_AvrLon_pa(pa_data)          ! 経度平均
      !
      ! 1 次元(X)格子点データの経度(X)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
      ! x_X_Weight の総和で割ることで平均している.
      !
      real(8), intent(in) :: pa_data(0:,:)
      !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)

      real(8)             :: a_AvrLon_pa(size(pa_data,2))
      !(out) 平均値の並び(*)

      real(8)             :: Tmp
      real(8)             :: Lon_Weight_Sum

      Tmp = sum(p_Lon_weight)
      CALL MPI_ALLREDUCE(TMP,Lon_Weight_Sum,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_V,IERR)

      a_AvrLon_pa = a_IntLon_pa(pa_data)/Lon_Weight_Sum

    end function a_AvrLon_pa

    function AvrLon_p(p_data)          ! 経度積分
      !
      ! 1 次元経度(X)格子点データの X 方向積分(一層用).
      !
      ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
      !
      real(8), intent(in) :: p_data(:)
      !(in)  1 次元経度(X)格子点データの並び(0:im-1,*)
      real(8)             :: AvrLon_p
      !(out) 積分値の並び(*)

      real(8)             :: Tmp
      real(8)             :: Lon_Weight_Sum

      Tmp = sum(p_Lon_weight)
      CALL MPI_ALLREDUCE(TMP,Lon_Weight_Sum,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_V,IERR)

      AvrLon_p = IntLon_p(p_data)/Lon_Weight_Sum

    end function AvrLon_p

    function a_AvrLat_va(va_data)
      !
      ! 1 次元(Y)格子点データの緯度(Y)方向平均(多層用).
      !
      ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
      ! y_Y_Weight の総和で割ることで平均している.
      !
      real(8), intent(in) :: va_data(:,:)
      !(in)  1 次元緯度格子点データの並び(jc,*)

      real(8)             :: a_AvrLat_va(size(va_data,2))
      !(out) 平均値の並び(*)

      real(8)             :: Tmp
      real(8)             :: Lat_Weight_Sum

      Tmp = sum(v_Lat_weight)
      CALL MPI_ALLREDUCE(TMP,Lat_Weight_Sum,1,MPI_REAL8, &
                         MPI_SUM,MPI_COMM_H,IERR)

      a_AvrLat_va = a_IntLat_va(va_data)/Lat_Weight_Sum

    end function a_AvrLat_va

end module wb_mpi_module_integral

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SYINM2(MM,NM,JM,IG,P,R,JC,ICOM,MI)

  IMPLICIT NONE
  INCLUDE 'mpif.h'
  INTEGER :: NP,IP,IERR,ICOM4
  INTEGER(8) :: MM,NM,JM,IG,M,IE,IJ,K,ICOM,MI
  INTEGER(8) :: N1,M1,MN
  REAL(8) :: P(JM/2,*) ! P(JM/2,5+2*(MM/(NP*MI)+1))
  REAL(8) :: R(*) ! R(5*(MM/(NP*MI)+1)*(2*NM-MM/(NP*MI)*NP*MI)/4+MM/(NP*MI)+1)
  INTEGER(8) :: JC(*) ! JC((MM/(NP*MI)+1)*(2*NM-MM/(NP*MI)*NP*MI)/16+MM/(NP*MI)+1)
  INTEGER(8) :: NTHMAX

  CALL MXGOMP(NTHMAX)  

  ICOM4=ICOM
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)
  CALL MPI_COMM_RANK(ICOM4,IP,IERR)

  N1=(MM/MI+1)/NP
  M1=N1*NP*MI
  MN=N1
  IF(MOD(N1,2).EQ.0) THEN
     IF(IP.LE.MM/MI-M1/MI) THEN
        MN=MN+1
     END IF
  ELSE
     IF(IP.GE.NP-MM/MI+M1/MI-1) THEN
        MN=MN+1
     END IF
  END IF

  CALL LXINIG(JM,P,IG)

  !$omp parallel private(K,M,IE,IJ) num_threads(NTHMAX)
  !$omp do schedule(dynamic)
  DO K=0,MN-1
     IE=5*K*(2*NM-NP*MI*(K-1))/4+K+1 ! サイズを変えたのでこうなる
     IJ=K*(2*NM-NP*MI*(K-1))/16+K+1
     M=(K*NP+IP+MOD(K,2)*(NP-2*IP-1))*MI
     IF(M.NE.0) THEN     
        CALL LXINIW(NM,JM,M,P,P(1,5+2*K+1),R(IE),JC(IJ))
     END IF
  END DO
!$omp end do
!$omp end parallel  
  
END SUBROUTINE SYINM2

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_deriv_mpi_module テストプログラム :: 微分関数のテスト
!
!履歴  2019/03/19  竹広真一
!      2020/11/09  竹広真一 セクター計算テスト
!
program w_mpi_module_deriv_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_mpi_module_mint
  use mpi

  implicit none

!!$  integer, parameter :: im=64, jm=32, nm=21, mint=1
  integer, parameter :: im=32, jm=32, nm=21, mint=2
  
  real(8), allocatable  ::  xv_data1(:,:)              ! 元の関数
  real(8), allocatable  ::  xv_data2(:,:)              ! 元の関数
  real(8), allocatable  ::  xv_ddata(:,:)              ! 微分の正解
  real(8), allocatable  ::  xv_mu(:,:)                 ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','w_mpi_module_deriv_mint_test', &
                         'w_deriv_mpi_module_mint function tests')

  call w_mpi_Initial( nm, im, jm, mint=mint )

  !------------ 変数割付け -------------
  allocate(xv_data1(0:im-1,jc))
  allocate(xv_data2(0:im-1,jc))
  allocate(xv_ddata(0:im-1,jc))
  allocate(xv_mu(0:im-1,jc))


  !========== 微分計算 (lon,lat座標系用) のテスト(領域分割) ==========

  !---- Y_1^0 のテスト ----
  xv_data1 = sin(xv_Lat)                     ! Y_1^0

  xv_ddata = -2*sin(xv_Lat)                  ! w_Lapla_w
  call AssertEqual(&
    message='Y_1^0 test of w_Lapla_w',                            &
    answer = xv_ddata,                                            &
    check = xv_w(w_Lapla_w(w_xv(xv_data1))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = -1.0/2.0*sin(xv_Lat)            ! w_LaplaInv_w
  call AssertEqual(&
    message='Y_1^0 test of w_LaplaInv_w',                         &
    answer = xv_ddata,                                            &
    check = xv_w(w_LaplaInv_w(w_xv(xv_data1))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = 0.0D0                           ! w_DLon_w
  call AssertEqual(&
    message='Y_1^0 test of w_DLon_w',                             &
    answer = xv_ddata,                                            &
    check = xv_w(w_DLon_w(w_xv(xv_data1))),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = cos(xv_Lat)**2                           ! w_cosLatDLat_w
  call AssertEqual(&
    message='Y_1^0 test of w_cosLatDLat_w',                       &
    answer = xv_ddata,                                            &
    check = xv_w(w_cosLatDLat_w(w_xv(xv_data1))),                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = 0.0D0                           ! xv_GradLon_w
  call AssertEqual(&
    message='Y_1^0 test of xv_GradLon_w',                         &
    answer = xv_ddata,                                            &
    check = xv_GradLon_w(w_xv(xv_data1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = cos(xv_Lat)                     ! xv_GradLat_w
  call AssertEqual(&
    message='Y_1^0 test of xv_GradLat_w',                         &
    answer = xv_ddata,                                            &
    check = xv_GradLat_w(w_xv(xv_data1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_1^0 cosφ のテスト ----
  xv_data1 = sin(xv_Lat)*cos(xv_Lat)                 ! Y_1^0 cosφ
  xv_ddata = 0.0D0                                   ! w_DivLon_xv
  call AssertEqual(&
    message='Y_1^0 cosφ test of xv_DivLon_w',                    &
    answer = xv_ddata,                                            &
    check = xv_w(w_DivLon_xv(xv_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = cos(xv_Lat)**2 - 2*sin(xv_Lat)**2       ! w_DivLat_w
  call AssertEqual(&
    message='Y_1^0 cosφ test of xv_DivLat_w',                    &
    answer = xv_ddata,                                            &
    check = xv_w(w_DivLat_xv(xv_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Jacobian のテスト ----
  xv_data1 = sin(xv_Lat)                             ! Y_1^0
  xv_data2 = cos(xv_Lat)**2*sin(2*xv_Lon)            ! Y_2^-2

  xv_ddata = 0.0
  call AssertEqual(&
    message='Y_1^0 test of w_JacobianMPI_w_w',                        &
    answer = xv_ddata,                                            &
    check = xv_w(w_JacobianMPI_w_w(w_xv(xv_data1),w_xv(xv_data1))),  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = - cos(xv_Lat) * cos(xv_Lat)*2*cos(2*xv_Lon)
  call AssertEqual(&
    message='Y_1^0 and Y_2^-2 test of w_JacobianMPI_w_w',            &
    answer = xv_ddata,                                            &
    check = xv_w(w_JacobianMPI_w_w(w_xv(xv_data1),w_xv(xv_data2))),  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = cos(xv_Lat) * cos(xv_Lat)*2*cos(2*xv_Lon)
  call AssertEqual(&
    message='Y_2^-2 and Y_1^0 test of w_JacobianMPI_w_w',            &
    answer = xv_ddata,                                            &
    check = xv_w(w_JacobianMPI_w_w(w_xv(xv_data2),w_xv(xv_data1))),  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  !---- Y_2^2 のテスト ----
  xv_data1 = cos(xv_Lat)**2*cos(2*xv_Lon)       ! Y_2^2

  xv_ddata = -6*cos(xv_Lat)**2*cos(2*xv_Lon)    ! w_Lapla_w
  call AssertEqual(&
    message='Y_2^2 test of w_Lapla_w',                            &
    answer = xv_ddata,                                            &
    check = xv_w(w_Lapla_w(w_xv(xv_data1))),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = -1.0D0/6.0D0*cos(xv_Lat)**2*cos(2*xv_Lon) ! w_LaplaInv_w
  call AssertEqual(&
    message='Y_2^2 test of w_LaplaInv_w',                         &
    answer = xv_ddata,                                            &
    check = xv_w(w_LaplaInv_w(w_xv(xv_data1))),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = cos(xv_Lat)**2*(-2)*sin(2*xv_Lon)     ! w_DLon_w
  call AssertEqual(&
    message='Y_2^2 test of w_DLon_w',                             &
    answer = xv_ddata,                                            &
    check = xv_w(w_DLon_w(w_xv(xv_data1))),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = cos(xv_Lat)*(-2)*sin(2*xv_Lon)        ! xv_GradLon_w
  call AssertEqual(&
    message='Y_2^2 test of xv_GradLon_w',                         &
    answer = xv_ddata,                                            &
    check = xv_GradLon_w(w_xv(xv_data1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = (-2)*cos(xv_Lat)*sin(xv_Lat)*cos(2*xv_Lon)  ! xv_GradLat_w
  call AssertEqual(&
    message='Y_2^2 test of xv_GradLat_w',                         &
    answer = xv_ddata,                                            &
    check = xv_GradLat_w(w_xv(xv_data1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^2 cosφ のテスト ----
  xv_data1 = cos(xv_Lat)**3*cos(2*xv_Lon)            ! Y_2^2 cosφ

  xv_ddata = cos(xv_Lat)**2*(-2)*sin(2*xv_Lon)       ! w_DivLon_xv
  call AssertEqual(&
    message='Y_2^2 cosφ test of xv_DivLon_w',                    &
    answer = xv_ddata,                                            &
    check = xv_w(w_DivLon_xv(xv_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = (-4)*cos(xv_Lat)**2*sin(xv_Lat)*cos(2*xv_Lon) ! w_DivLat_w
  call AssertEqual(&
    message='Y_2^2 cosφ test of xv_DivLat_w',                    &
    answer = xv_ddata,                                            &
    check = xv_w(w_DivLat_xv(xv_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

!!$  !---- Jacobian のテスト ----
!!$  xv_data1 = sin(xv_Lat)                             ! Y_2^2
!!$  xv_data2 = sin(xv_Lat)                             ! Y_2^2
!!$
!!$  xv_ddata = 0.0
!!$  call AssertEqual(&
!!$    message='Y_2^2 test of w_JacobianMPI_w_w',                        &
!!$    answer = xv_ddata,                                            &
!!$    check = xv_w(w_JacobianMPI_w_w(w_xv(xv_data1),w_xv(xv_data1))),  &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  xv_mu = sin(xv_Lat)

  !----- Y_2^0 のテスト -----
  xv_data1 = 3*xv_mu**2-1                              ! Y_2^0

  xv_ddata = 0.0
  call AssertEqual(&
    message='Y_2^0 test of xv_GradLambda_w',                      &
    answer = xv_ddata,                                            &
    check = xv_GradLambda_w(w_xv(xv_data1)),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = 6*xv_mu*(1-xv_mu**2)
  call AssertEqual(&
    message='Y_2^0 test of xv_GradMu_w',                          &
    answer = xv_ddata,                                            &
    check = xv_GradMu_w(w_xv(xv_data1)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !----- Y_2^0 cosφ のテスト -----
  xv_data1 = (3*xv_mu**2-1)*(1-xv_mu**2)                ! Y_2^0 (1-μ^2)

  xv_ddata = 0.0
  call AssertEqual(&
    message='Y_2^0 (1-μ^2) test of xv_DivLambda_w',                 &
    answer = xv_ddata,                                            &
    check = xv_w(w_DivLambda_xv(xv_data1)),                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xv_ddata = (2-3*xv_mu**2)*4*xv_mu
  call AssertEqual(&
    message='Y_2^0 (1-μ^2) test of xv_DivMu_w',                  &
    answer = xv_ddata,                                            &
    check = xv_w(w_DivMu_xv(xv_data1)),                           &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','w_mpi_module_deriv_mint_test', &
                         'w_deriv_module_mint function tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program w_mpi_module_deriv_mint_test

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
!***********************************************************************
!     Operate Laplacian
!***********************************************************************
SUBROUTINE SYCLAM(MM,NT,S,SL,D,IFLAG,ICOM,MI)

  IMPLICIT NONE    
  INCLUDE 'mpif.h'
  INTEGER(8) :: MM,IFLAG,ND,L,NT,ICOM,MI
  REAL(8) :: S(*)  ! S((MM/(NP*MI)+1)*(2*(NT+1)-MM/(NP*MI)*NP*MI))
  REAL(8) :: SL(*) ! SL((MM/(NP*MI)+1)*(2*(NT+1)-MM/(NP*MI)*NP*MI))
  REAL(8) :: D(*)  ! D((MM/(NP*MI)+1)*(2*(NT+1)-MM/(NP*MI)*NP*MI)*2)
  INTEGER :: NP,IP,IERR,ICOM4
  INTEGER(8) :: NTHMAX

  CALL MXGOMP(NTHMAX)  

  ICOM4=ICOM
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)
  CALL MPI_COMM_RANK(ICOM4,IP,IERR)

  ND=(MM/(NP*MI)+1)*(2*(NT+1)-MM/(NP*MI)*NP*MI)

  !$omp parallel do num_threads(NTHMAX)
  DO L=1,ND
     SL(L)=D(L+(IFLAG-1)*ND)*S(L)
  END DO
  !$omp end parallel do

END SUBROUTINE SYCLAM

!----------------------------------------------------------------------
! Copyright (c) 2013-2019 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_base_module テストプログラム :: 終了処理のテスト
!
!履歴  2013/02/23  竹広真一
!      2019/12/24  佐々木洋平 正規化の変更: 1/sqrt(2) -> 1/2
!
program wa_base_module_finalize_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use dc_types, only: DP
  use wa_module
  implicit none

  integer, parameter :: im1=32, jm1=16, nm1=10, km1=3
  integer, parameter :: im2=64, jm2=32, nm2=21, km2=3

  real(DP), allocatable ::  wa_data(:,:)
  real(DP), allocatable ::  xya_data(:,:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(DP) :: pi

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','wa_base_module_test', &
                         'wa_base_module finalize subroutine tests')

  call wa_Initial( nm1, im1, jm1, km1 )

  allocate(wa_data((nm1+1)**2,km1))
  allocate(xya_data(0:im1-1,1:jm1,km1))

  !---- Y_1^* のテスト ----
  xya_data(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)                       ! Y_1^0
  wa_data= 0.0D0 ; wa_data(l_nm(1,0),1)=1.0D0
  xya_data(:,:,2) = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)     ! Y_1^1
  wa_data(l_nm(1,1),2)=1.0D0/2.0D0
  xya_data(:,:,3) = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)    ! Y_1^{-1}
  wa_data(l_nm(1,-1),3)=1.0D0/2.0D0

  call AssertEqual(&
    message='wa_xya with Y_1^*',                                  &
    answer = wa_xya(xya_data),                                    &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xya_wa with Y_1^*',                                  &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  xya_data(:,:,1) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)           ! Y_2^0
  wa_data= 0.0D0 ; wa_data(l_nm(2,0),1)=1.0D0
  xya_data(:,:,2) = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*cos(xy_Lon)!Y_2^1
  wa_data(l_nm(2,1),2)=1.0D0/2.0D0
  xya_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)   ! Y_2^-2
  wa_data(l_nm(2,-2),3)=1.0D0/2.0D0

  call AssertEqual(&
    message='wa_xya with Y_2^*',                                  &
    answer = wa_xya(xya_data),                                    &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xya_wa with Y_2^*',                                  &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xya_data(:,:,1) = cos(2*xy_Lon-pi/3) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  xya_data(:,:,2) = sin(2*xy_Lon+pi/2) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)+1)**2
  xya_data(:,:,3) = cos(2*xy_Lon+pi/3) &
       *(sin(xy_Lat)-1)*(sin(xy_Lat)-0.5)**2*(sin(xy_Lat)+1)

  call AssertEqual(&
    message='wa_xya, xya_wa with a general function',             &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !========================= 解像度変更 ===============================

  call wa_Finalize
  call wa_Initial( nm2, im2, jm2, km2 )

  deallocate(wa_data)
  deallocate(xya_data)

  allocate(wa_data((nm2+1)**2,km2))
  allocate(xya_data(0:im2-1,1:jm2,km2))

  !---- Y_1^* のテスト ----
  xya_data(:,:,1) = sqrt(3.0D0)*sin(xy_Lat)                       ! Y_1^0
  wa_data= 0.0D0 ; wa_data(l_nm(1,0),1)=1.0D0
  xya_data(:,:,2) = sqrt(3.0D0/2)*cos(xy_Lat)*cos(xy_Lon)     ! Y_1^1
  wa_data(l_nm(1,1),2)=1.0D0/2.0D0
  xya_data(:,:,3) = -sqrt(3.0D0/2)*cos(xy_Lat)*sin(xy_Lon)    ! Y_1^{-1}
  wa_data(l_nm(1,-1),3)=1.0D0/2.0D0

  call AssertEqual(&
    message='wa_xya with Y_1^*',                                  &
    answer = wa_xya(xya_data),                                    &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xya_wa with Y_1^*',                                  &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  xya_data(:,:,1) = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)           ! Y_2^0
  wa_data= 0.0D0 ; wa_data(l_nm(2,0),1)=1.0D0
  xya_data(:,:,2) = sqrt(5.0D0/6)*3.0*sin(xy_Lat)*cos(xy_Lat)*cos(xy_Lon)!Y_2^1
  wa_data(l_nm(2,1),2)=1.0D0/2.0D0
  xya_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)   ! Y_2^-2
  wa_data(l_nm(2,-2),3)=1.0D0/2.0D0

  call AssertEqual(&
    message='wa_xya with Y_2^*',                                  &
    answer = wa_xya(xya_data),                                    &
    check = wa_data,                                              &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='xya_wa with Y_2^*',                                  &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的関数のテスト ----
  xya_data(:,:,1) = cos(2*xy_Lon-pi/3) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)-0.5)*(sin(xy_Lat)+1)
  xya_data(:,:,2) = sin(2*xy_Lon+pi/2) &
       *(sin(xy_Lat)-1)**2*(sin(xy_Lat)+1)**2
  xya_data(:,:,3) = cos(2*xy_Lon+pi/3) &
       *(sin(xy_Lat)-1)*(sin(xy_Lat)-0.5)**2*(sin(xy_Lat)+1)

  call AssertEqual(&
    message='wa_xya, xya_wa with a general function',             &
    answer = xya_wa(wa_xya(xya_data)),                            &
    check = xya_data,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','wa_base_module', &
       'wa_base_module finalize subroutine tests succeeded!')

end program wa_base_module_finalize_test

!----------------------------------------------------------------------
! Copyright (c) 2002-2010 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  at_module テストプログラム
!
!履歴  2002/08/20  竹広真一
!      2007/10/24  竹広真一  エラーメッセージ追加
!      2010/01/01  佐々木洋平 dc_test を使うように修正
!
program at_intavr

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use at_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32            ! 格子点の設定
  integer, parameter :: km=32,lm=2        ! 切断波数の設定

 !---- 変数 ----
  real(8)            :: g_Data(0:im)     ! 格子データ
  real(8)            :: ag_Data(lm,0:im)    ! 格子データ

 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0D0, xmax=1.0D0

  real(8), parameter :: pi=3.1415926535897932385D0
  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  integer :: i

 !---------------- 座標値の設定 ---------------------

  call MessageNotify('M','at_test_intavr', &
    & 'Test of integral/average functions')

  call MessageNotify('M', 'test function', &
    & 'f = 1-sin(2*pi*X)')

  do i=1,2
    call at_Initial(im,km/i,xmin,xmax)

    !------------------- 初期値設定 ----------------------
    g_Data = 1.0d0 - sin(2.0d0*pi*g_X)

    call check0d(Int_g(g_Data), 2.0d0, 'test of Int_g')
    call check0d(Avr_g(g_Data), 1.0d0, 'test of Avr_g')

    call MessageNotify('M','Test of Int_g, Avr_g', &
      & 'suceeded!')

    ag_Data(1,:) = cos(pi*g_X)**2
    ag_Data(2,:) = sin(pi*g_X)**2

    call check1d(a_Int_ag(ag_Data), (/1.0d0,1.0d0/),    'test of a_Int_ag')
    call check1d(a_Avr_ag(ag_Data), (/5.0d-1,5.0d-1/),  'test of a_Avr_ag')

    call MessageNotify('M','Test of a_Int_ag, a_Avr_ag', &
      & 'suceeded!')

    call at_Finalize

  end do

  call MessageNotify('M','at_test_intavr', &
    & 'Test of integral/average functions succeeded!')

contains
  subroutine check1d(var,true,funcname)
    real(8) :: var(:)
    real(8) :: true(:)
    character(len=*), optional :: funcname

    call AssertEqual(&
      & message = funcname,   &
      & answer  = true,       &
      & check   = var,        &
      significant_digits = check_digits, ignore_digits = ignore   &
      )
  end subroutine check1d

  subroutine check0d(var0,true0,funcname)
    real(8) :: var0
    real(8) :: true0
    real(8) :: vartmp(1)
    real(8) :: truetmp(1)
    character(len=*), optional :: funcname

    vartmp(1) = var0
    truetmp(1) = true0
    call check1d(vartmp,truetmp, funcname)
  end subroutine check0d

end program at_intavr

! -*- mode: f90; coding: utf-8 -*-
!----------------------------------------------------------------------
! Copyright(c) 2023-2025 SPMDODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief 2 次元水路領域: Fourier 展開 + Chebyshev 展開法
!>
!> @details
!>
!> spml/et_mpi_module モジュールは 2 次元水路領域での流体運動を
!> スペクトル法により数値計算を実行するための Fortran90 関数を提供する.
!> 周期的な境界条件を扱うための X 方向へのフーリエ変換と境界壁を扱うための
!> Y 方向のチェビシェフ変換を用いる場合のスペクトル計算のためのさまざまな
!> 関数を提供する.
!>
!> 内部で ae_module, at_module を用いている.
!> 最下部ではフーリエ変換およびチェビシェフ変換のエンジンとして
!> ISPACK3/FXPACKを用いている.
!>
!> ## 関数・変数の名前と型について
!>
!> ### 命名法
!>
!> * 関数名の先頭 (et_, yx_, x_, y_) は, 返す値の形を示している.
!>   et_ :: 2次元スペクトルデータ
!>   yx_ :: 2 次元格子点データ
!>   x_  :: X 方向 1 次元格子点データ
!>   y_  :: Y 方向 1 次元格子点データ
!>
!> * 関数名の間の文字列(Dx, Dy, Lapla, LaplaInv, Jacobian)は,
!>   その関数の作用を表している.
!>
!> * 関数名の最後 (_et_et, _et, _yx, _x, _y) は, 入力変数のスペクトルデータ
!>   および格子点データであることを示している.
!>   _et    :: 2次元スペクトルデータ
!>   _et_et :: 2 つの2次元スペクトルデータ
!>   _yx    :: 2 次元格子点データ
!>   _x     :: X 方向 1 次元格子点データ
!>   _y     :: Y 方向 1 次元格子点データ
!>
!> ### 各データの種類の説明
!>
!> * yx : 2 次元格子点データ.
!>   * 変数の種類と次元は real(DP), dimension(0:jm,0:im-1).
!>   * im, jm はそれぞれ X, Y 座標の格子点数であり, サブルーチン
!>     et_initial にてあらかじめ設定しておく.
!>   * 第 1 次元が Y 座標の格子点位置番号, 第 2 次元が X 座標の
!>     格子点位置番号である (X, Y の順ではない)ことに注意.
!>
!> * et : 2 次元スペクトルデータ.
!>   * 変数の種類と次元は real(DP), dimension(-km:km,0:lm).
!>   * km, lm はそれぞれ X, Y 方向の最大波数であり, サブルーチン
!>     et_initial にてあらかじめ設定しておく.
!>   * スペクトルデータの格納のされ方については...
!>
!> * x, y : X, Y 方向 1 次元格子点データ.
!>   * 変数の種類と次元はそれぞれ real(DP), dimension(0:im-1)
!>     および real(DP), dimension(0:jm).
!>
!> * e, t : 1 次元スペクトルデータ.
!>   * 変数の種類と次元は real(DP), dimension(-km:km)
!>     および real(DP), dimension(-lm:lm).
!>
!> * ax, ay : 1 次元格子点データの並んだ 2 次元配列.
!>   * 変数の種類と次元は real(DP), dimension(:,0:im-1)
!>     および real(DP), dimension(:,0:jm).
!>
!> * ae, at : 1 次元スペクトルデータの並んだ 2 次元配列.
!>   * 変数の種類と次元は real(DP), dimension(:,-km:km)
!>     および real(DP), dimension(:,0:lm).
!>
!> * et_ で始まる関数が返す値はスペクトルデータに同じ.
!>
!> * yx_ で始まる関数が返す値は 2 次元格子点データに同じ.
!>
!> * x_, y_ で始まる関数が返す値は 1 次元格子点データに同じ.
!>
!> * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
!>   微分などを作用させたデータをスペクトル変換したものことである.
!----------------------------------------------------------------------
!履歴  2023/03/04  竹広真一
!      2025/11/20  竹広真一  f_e, e_f, y_v を追加
!----------------------------------------------------------------------
module et_mpi_module
  !
  !== 変数・手続き群の要約
  !
  !==== 初期化
  !
  ! et_mpi_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさの設定
  ! kf_k           :: X 方向波数の位置情報
  !
  !==== 座標変数
  !
  ! x_X, y_Y     ::  格子点座標(X,Y座標)を格納した 1 次元配列
  ! x_X_Weight, y_Y_Weight ::  重み座標を格納した 1 次元配列
  ! yx_X, yx_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列)
  !
  ! v_Y          ::  格子点座標(Y座標, 分割格子)を格納した 1 次元配列
  ! v_Y_Weight   ::  重み座標を格納した 1 次元配列(分割格子)
  ! vx_X, vx_Y   :: 格子点データの XY 座標(X,Y)(格子点データ型 2 次元配列, 分割格子)
  !
  !==== 基本変換
  !
  ! vx_ft :: スペクトルデータから格子データへの変換
  ! ft_vx :: 格子データからスペクトルデータへの変換
  ! vx_ft, x_e :: X 方向のスペクトルデータから格子データへの変換
  ! fy_ft, y_t :: Y 方向のスペクトルデータから格子データへの変換
  ! fy_yx, e_x :: X 方向の格子点データからスペクトルデータへの変換
  ! ft_fy, t_y :: Y 方向の格子点データからスペクトルデータへの変換
  !
  !==== 微分
  !
  ! ft_Lapla_ft  :: スペクトルデータにラプラシアンを作用させる
  ! ft_Dx_ft, ae_Dx_ae, e_Dx_e :: スペクトルデータに X 微分を作用させる
  ! ft_Dy_ft, at_Dy_at, t_Dy_t :: スペクトルデータに Y 微分を作用させる
  ! ft_Jacobian_ft_ft :: 2 つのスペクトルデータからヤコビアンを計算する
  !
  !==== 境界値問題
  !
  ! ft_Boundaries  :: ディリクレ, ノイマン境界条件の適用
  ! ft_LaplaInv_ft :: スペクトルデータにラプラシアンの逆変換を作用させる
  ! ft_Vor2Strm_ft :: 渦度から流線を計算する
  ! fy_Vor2Strm_fy :: 渦度から流線を計算する
  !
  !==== 積分・平均
  !
  ! IntYX_vx, AvrYX_vx   :: 2 次元格子点データの全領域積分および平均
  ! v_IntX_vx, v_AvrX_vx :: 2 次元格子点データの X 方向積分および平均
  ! IntX_x, AvrX_x       :: 1 次元(X)格子点データの X 方向積分および平均
  ! x_IntY_vx, x_AvrY_vx :: 2 次元格子点データの Y 方向積分および平均
  ! IntY_y, AvrY_v       :: 1 次元(Y)格子点データの Y 方向積分および平均
  !
  !==== 補間
  !
  ! Interpolate_ft       :: スペクトルデータからの特定の座標の値の補間
  !
  use dc_types, only: DP
  use dc_message, only: MessageNotify
  use mpi
  use lumatrix
  use spml_utils, only: pi
  use ae_module, only : x_X => g_X, x_X_weight => g_X_Weight, &
    ae_initial, &
    e_x => e_g, ae_ax => ae_ag, &
    x_e => g_e, ax_ae => ag_ae, &
    Interpolate_e, a_Interpolate_ae
  use at_module, only : y_Y => g_X, y_Y_Weight => g_X_Weight, &
    at_initial, &
    at_ay => at_ag, t_y => t_g, &
    ay_at => ag_at, y_t => g_t, &
    t_Dy_t => t_Dx_t, at_Dy_at => at_Dx_at, &
    at_Boundaries_DD, at_Boundaries_DN, at_Boundaries_ND, at_Boundaries_NN, &
    ft_BoundariesGrid => at_BoundariesGrid, &
    Interpolate_t, a_Interpolate_at
  implicit none

  private

  public ks, ke, kc
  public js, je, jc
  public kf_k

  public et_mpi_Initial                                   ! 初期化

  public x_X, y_Y, x_X_Weight, y_Y_Weight, yx_X, yx_Y     ! 座標変数
  public v_Y, v_Y_Weight, vx_X, vx_Y                      ! 座標変数

  public vx_ft, ft_vx                                     ! 基本変換
  public ve_fy, fy_ve                                     ! 基本変換
  public ft_fy, fy_ft                                     ! 基本変換
  public vx_fy, fy_vx                                     ! 基本変換
  public ae_af, af_ae                                     ! 基本変換
  public ay_av, av_ay                                     ! 基本変換
  public e_f, f_e                                         ! 基本変換
  public y_v                                              ! 基本変換
!!$  public vx_ey, ey_yx                                     ! 基本変換
!!$  public ey_et, et_ey                                     ! 基本変換
  public e_x, x_e, ae_ax, ax_ae                           ! 基本変換
  public t_y, y_t, at_ay, ay_at                           ! 基本変換

  public ft_Dx_ft                       ! 微分
  public ft_Dy_ft                       ! 微分
  public ft_Lapla_ft                                      ! 微分
!!$  public ft_Dx_ft, f_Dx_e, ae_Dx_ae                       ! 微分
!!$  public ft_Dy_ft, t_Dy_t, at_Dy_at                       ! 微分

  public ft_Jacobian_ft_ft                                ! 非線形計算

  public ft_Boundaries                                    ! 境界値問題
!!$  public at_Boundaries_DD, at_Boundaries_DN               ! 境界値問題
!!$  public at_Boundaries_ND, at_Boundaries_NN               ! 境界値問題
  public ft_BoundariesGrid                                ! 境界値問題
  public ft_LaplaInv_ft
  public fy_Vor2Strm_fy                                   ! 境界値問題
  public ft_Vor2Strm_ft                                   ! 境界値問題
  public ft_Vor2Strm2_ft                                  ! 境界値問題
  public ft_Vor2Strm3_ft                                  ! 境界値問題

  public IntYX_vx, v_IntX_vx, x_IntY_vx, IntX_x, IntY_v   ! 積分
  public AvrYX_vx, v_AvrX_vx, x_AvrY_vx, AvrX_x, AvrY_v   ! 平均

  public Interpolate_ft                                   ! 補間

  !> 格子点データの Y 座標: 格子点データ型分割(Y)
  real(DP), dimension(:), allocatable :: v_Y
  real(DP), dimension(:), allocatable :: v_Y_Weight

  !> 格子点データの X 座標: 格子点データ型 2 次元配列(X,Y)
  real(DP), dimension(:,:), allocatable :: yx_X
  real(DP), dimension(:,:), allocatable :: vx_X
  !> 格子点データの Y 座標: 格子点データ型 2 次元配列(X,Y)
  real(DP), dimension(:,:), allocatable :: yx_Y
  real(DP), dimension(:,:), allocatable :: vx_Y

  !> X方向格子点
  integer            :: im
  !> Y方向格子点
  integer            :: jm
  !> X方向切断波数
  integer            :: km
  !> Y方向切断波数
  integer            :: lm
  !> X 方向計算領域
  real(DP)           :: xl
  !> Y 方向計算領域
  real(DP)           :: yl

  real(DP) :: xmin, xmax                                 ! X 座標範囲
  real(DP) :: ymin, ymax                                 ! Y 座標範囲

  integer, dimension(:), allocatable :: ke              ! X 最大波数
  integer, dimension(:), allocatable :: ks              ! X 最小波数
  integer, dimension(:), allocatable :: kc              ! X 波数の数
  integer, dimension(:), allocatable :: je              ! Y 座標最大格子点
  integer, dimension(:), allocatable :: js              ! Y 座標最小格子点
  integer, dimension(:), allocatable :: jc              ! Y 座標格子点数
  integer :: np                                         ! MPI プロセス数
  integer :: ip                                         ! MPI プロセス ID

  save im, jm, km, lm, xl, yl
  save ks, ke, kc, js, je, jc, np, ip
  save xmin, xmax, ymin, ymax

contains
  !----------------------------------------------------------
  !> スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
  !>
  !> 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
  !> 初期設定をしなければならない.
  !----------------------------------------------------------
  subroutine et_mpi_Initial(i,j,k,l,xmin,xmax,ymin,ymax)
    !> 格子点数(X)
    integer,intent(in) :: i
    !> 格子点数(Y)
    integer,intent(in) :: j
    !> 切断波数(X)
    integer,intent(in) :: k
    !> 切断波数(Y)
    integer,intent(in) :: l
    !> X 座標範囲
    real(DP),intent(in) :: xmin, xmax
    !> Y 座標範囲
    real(DP),intent(in) :: ymin, ymax

    integer :: kint, kmod
    integer :: jint, jmod
    integer :: ierr, iip

    im = i
    jm = j
    km = k
    lm = l
    xl = xmax-xmin
    yl = ymax-ymin

    CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

    ! x 波数 MPI分割情報
    allocate(ks(0:np-1))
    allocate(ke(0:np-1))
    allocate(kc(0:np-1))

    kint = km/np
    kmod = mod(km,np)
    kc   = kint
    do iip=0,kmod
       kc(iip) = kc(iip) + 1
    end do

    ks(0)=0 ; ke(0) = ks(0) + kc(0) -1
    do iip=1,np-1
       ks(iip) = ks(iip-1) + kc(iip-1)
       ke(iip) = ks(iip) + kc(iip) - 1
    end do

    ! Y 軸 MPI分割情報
    allocate(js(0:np-1))
    allocate(je(0:np-1))
    allocate(jc(0:np-1))

    jint = (jm+1)/np
    jmod = mod(jm+1,np)
    jc   = jint
    do iip=0,jmod-1
       jc(iip) = jc(iip) + 1
    end do

    js(0)=0 ; je(0) = js(0) + jc(0) -1
    do iip=1,np-1
       js(iip) = js(iip-1) + jc(iip-1)
       je(iip) = js(iip) + jc(iip) - 1
    end do

    call ae_initial(im,km,xmin,xmax)
    call at_initial(jm,lm,ymin,ymax)

    allocate(v_Y(jc(ip)))
    allocate(v_Y_Weight(jc(ip)))

    allocate(yx_X(0:jm,0:im-1),yx_Y(0:jm,0:im-1))
    allocate(vx_X(jc(ip),0:im-1),vx_Y(jc(ip),0:im-1))

    v_Y        = y_Y(js(ip):je(ip))
    v_Y_Weight = y_Y_Weight(js(ip):je(ip))

    yx_X = spread(x_X,1,jm+1)
    yx_Y = spread(y_Y,2,im)

    vx_X = spread(x_X,1,jc(ip))
    vx_Y = spread(v_Y,2,im)

    call MessageNotify('M','et_mpi_initial', &
      & 'et_mpi_module (2025/11/20) is initialized')
  end subroutine et_mpi_Initial

  !--------------- 波数位置問い合わせ -----------------
  function kf_k(k)
    !
    ! スペクトルデータ ft(2*kc,0:lm) での
    ! X 方向波数 k の位置情報(第 1 添え字)を調べる.
    !
    ! X 方向波数については ks,ks+1,... ke, -ke,-ke+1,...,-ks
    ! の順に格納されている.
    !
    integer, intent(IN)  ::  k        ! X 方向波数
    integer              ::  kf_k     ! スペクトルデータ第 2 添え字

    if ( abs(k) < ks(ip) .OR. ke(ip) < abs(k) ) then
       kf_k = -1
    else if ( k >= 0 ) then
       kf_k = k-ks(ip)+1
    else
       kf_k = ks(ip)+2*kc(ip)-abs(k)
    endif

  end function kf_k

  !----------------------------------------------------------
  !> スペクトルデータから格子データへ変換する.
  !----------------------------------------------------------
  function vx_ft(ft)
    !> スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm), intent(in)  :: ft
    !> 格子点データ
    real(DP), allocatable, dimension(:,:)           :: vx_ft

!!     real(DP), dimension(2*kc(ip),0:jm)              :: fy
!!     real(DP), dimension(js(ip):je(ip),-km:km)       :: ve
!!
!!     fy = ay_at(ft)
!!     ve = ve_fy(fy)
!!     vx_ft = ax_ae(ve)
    allocate(vx_ft(js(ip):je(ip),0:im-1))
    vx_ft = ax_ae(ve_fy(ay_at(ft)))

  end function vx_ft

  !----------------------------------------------------------
  ! 格子データからスペクトルデータへ変換する.
  !----------------------------------------------------------
  function ft_vx(vx)
    !> 格子点データ
    real(DP), dimension(js(ip):je(ip),0:im-1), intent(in) :: vx
    !> スペクトルデータ
    real(DP), allocatable, dimension(:,:)                 :: ft_vx

!!     real(DP), dimension(2*kc(ip),0:jm)              :: fy
!!     real(DP), dimension(js(ip):je(ip),-km:km)       :: ve
!!
!!     ve = ae_ax(vx)
!!     fy = fy_ve(ve)
!!     ft_vx = at_ay(fy)
    allocate(ft_vx(2*kc(ip),0:lm))
    ft_vx = at_ay(fy_ve(ae_ax(vx)))
  end function ft_vx

  !----------------------------------------------------------
  !> X スペクトル・Y 格子の転置
  !----------------------------------------------------------
  function ve_fy(fy)
    !> スペクトルデータ
    real(DP), dimension(2*kc(ip),0:jm), intent(in)  :: fy

    !> 格子点データ
    real(DP), dimension(js(ip):je(ip),-km:km)       :: ve_fy

    integer :: j, k, iip
    integer :: ierr
    integer :: isndc(0:np-1)
    integer :: isdsp(0:np-1)
    integer :: ircvc(0:np-1)
    integer :: irdsp(0:np-1)
    real(DP), allocatable :: aa_work(:,:)
    integer :: kcm
    integer :: ind1, ind2

    kcm = maxval(kc)
    allocate(aa_work(kcm*2*jc(ip),0:np-1))
    aa_work = 0.0D0

    isndc = kc(ip)*2*jc
    ircvc = jc(ip)*2*kc
    do iip=0,np-1
       isdsp(iip) = sum(isndc(0:iip-1))
       irdsp(iip) = kcm*2*jc(ip)*iip
    end do

    call MPI_AlltoAllV(fy,isndc,isdsp,MPI_REAL8,&
         aa_work,ircvc,irdsp,MPI_REAL8,MPI_COMM_WORLD,IERR)

    do iip=0,np-1
       do k=1,kc(iip)
          do j=1,jc(ip)
             ind1 = k           + kc(iip)*2*(j-1)
             ind2 = k + kc(iip) + kc(iip)*2*(j-1)
             ve_fy(js(ip)+j-1,-ke(iip)-1+k) = aa_work(ind2,iip)
             ve_fy(js(ip)+j-1, ks(iip)-1+k) = aa_work(ind1,iip)
          end do
       end do
    end do

    deallocate(aa_work)

  end function ve_fy

  function fy_ve(ve)
    real(DP), dimension(jc(ip),-km:km),intent(IN) :: ve
    real(DP), dimension(2*kc(ip),0:jm)            :: fy_ve

    integer :: j, k, iip
    integer :: ierr
    integer :: isndc(0:np-1)
    integer :: isdsp1(0:np-1)
    integer :: isdsp2(0:np-1)
    integer :: ircvc(0:np-1)
    integer :: irdsp(0:np-1)
    real(DP), allocatable :: aa_work1(:,:)
    real(DP), allocatable :: aa_work2(:,:)
    integer :: jcm
    integer :: ind

    jcm = maxval(jc)
    allocate(aa_work1(jcm*kc(ip),0:np-1))
    allocate(aa_work2(jcm*kc(ip),0:np-1))
    aa_work1 = 0.0D0 ; aa_work2 = 0.0D0

    isndc = jc(ip)*kc
    ircvc = kc(ip)*jc
    do iip=0,np-1
       isdsp1(iip) = (km + ks(iip))*jc(ip)
       isdsp2(iip) = (km - ke(iip))*jc(ip)
       irdsp(iip) = jcm*kc(ip)*iip
    end do

    call MPI_AlltoAllV(ve,isndc,isdsp1,MPI_REAL8,&
         aa_work1,ircvc,irdsp,MPI_REAL8,MPI_COMM_WORLD,IERR)
    call MPI_AlltoAllV(ve,isndc,isdsp2,MPI_REAL8,&
         aa_work2,ircvc,irdsp,MPI_REAL8,MPI_COMM_WORLD,IERR)

    do iip=0,np-1
       do j=1,jc(iip)
          do k=1,kc(ip)
             ind = j           + jc(iip)*(k-1)
             fy_ve(k,js(iip)+j-1)        = aa_work1(ind,iip)
             fy_ve(kc(ip)+k,js(iip)+j-1) = aa_work2(ind,iip)
          end do
       end do
    end do

    deallocate(aa_work1)
    deallocate(aa_work2)

  end function fy_ve

  !----------------------------------------------------------
  !> X スペクトルの分散・統合
  !----------------------------------------------------------
  function ae_af(af)
    real(DP), dimension(:,:),intent(IN)       :: af
    real(DP), dimension(size(af,1),-km:km)    :: ae_af

    integer :: icm
    integer :: ircvc(0:np-1)
    integer :: irdsp1(0:np-1)
    integer :: irdsp2(0:np-1)
    integer :: ierr, ipp

    icm = size(af,1)
    do ipp=0,np-1
       ircvc(ipp) = icm*kc(ipp)
    end do
    irdsp1(0) = 0
    do ipp=1,np-1
       irdsp1(ipp) = sum(ircvc(0:ipp-1))
    end do
    do ipp=0,np-1
       irdsp2(ipp) = icm*(km+1) - sum(ircvc(0:ipp))
    end do

    call MPI_AllGatherV(af(:,kc(ip)+1:2*kc(ip)),icm*kc(ip),MPI_REAL8,&
         ae_af(:,-km:0),ircvc,irdsp2,MPI_REAL8,MPI_COMM_WORLD,IERR)
    call MPI_AllGatherV(af(:,1:kc(ip)),icm*kc(ip),MPI_REAL8,&
         ae_af(:,0:km),ircvc,irdsp1,MPI_REAL8,MPI_COMM_WORLD,IERR)

  end function ae_af

  function af_ae(ae)
    real(DP), dimension(:,-km:),intent(IN)      :: ae
    real(DP), dimension(size(ae,1),2*kc(ip))    :: af_ae

    integer :: k, kk

    do kk=1,kc(ip)
       k = ks(ip)+kk-1
       af_ae(:,kk) = ae(:,k)
       af_ae(:,2*kc(ip)-kk+1) = ae(:,-k)
    end do

  end function af_ae

  function e_f(f)
    real(DP), dimension(2*kc(ip)),intent(IN) :: f
    real(DP), dimension(-km:km)              :: e_f

    real(DP), dimension(1,2*kc(ip)) :: af
    real(DP), dimension(1,-km:km)   :: ae

    af(1,:) = f
    ae = ae_af(af)
    e_f = ae(1,:)
  end function e_f

  function f_e(e)
    real(DP), dimension(-km:km),intent(IN) :: e
    real(DP), dimension(2*kc(ip))          :: f_e

    real(DP), dimension(1,2*kc(ip)) :: af
    real(DP), dimension(1,-km:km)   :: ae

    ae(1,:) = e
    af = af_ae(ae)
    f_e = af(1,:)
  end function f_e

  !----------------------------------------------------------
  !> Y 格子の分散・統合
  !----------------------------------------------------------
  function ay_av(av)
    real(DP), dimension(:,:),intent(IN)       :: av
    real(DP), dimension(size(av,1),0:jm)      :: ay_av

    integer :: icm
    integer :: ircvc(0:np-1)
    integer :: irdsp(0:np-1)
    integer :: ierr, ipp

    icm = size(av,1)
    do ipp=0,np-1
       ircvc(ipp) = icm*jc(ipp)
    end do
    irdsp(0) = 0
    do ipp=1,np-1
       irdsp(ipp) = sum(ircvc(0:ipp-1))
    end do

    call MPI_AllGatherV(av,icm*jc(ip),MPI_REAL8,&
         ay_av,ircvc,irdsp,MPI_REAL8,MPI_COMM_WORLD,IERR)

  end function ay_av

  function av_ay(ay)
    real(DP), dimension(:,0:),intent(IN)      :: ay
    real(DP), dimension(size(ay,1),jc(ip))    :: av_ay

    av_ay = ay(:,js(ip):je(ip))

  end function av_ay

  function y_v(v)
    real(DP), dimension(jc(ip)),intent(IN) :: v
    real(DP), dimension(0:jm)              :: y_v

    real(DP), dimension(1,0:jm)    :: ay
    real(DP), dimension(1,jc(ip))  :: av

    av(1,:) = v
    ay = ay_av(av)
    y_v = ay(1,:)
  end function y_v

  !----------------------------------------------------------
  !> Y 座標の格子データから格子データへ変換する.
  !----------------------------------------------------------
  function vx_fy(fy)
    !> 格子点データ
    real(DP), dimension(2*kc(ip),0:jm), intent(in)  :: fy
    !> スペクトルデータ
    real(DP), dimension(jc(ip),0:im-1)              :: vx_fy
    vx_fy = ax_ae(ve_fy(fy))

  end function vx_fy

  !----------------------------------------------------------
  !> Y 座標の格子データから格子データへ変換する.
  !----------------------------------------------------------
  function fy_vx(vx)
    !> 格子点データ
    real(DP), dimension(jc(ip),0:im-1), intent(in)  :: vx
    !> スペクトルデータ
    real(DP), dimension(2*kc(ip),0:jm)              :: fy_vx
    fy_vx = fy_ve(ae_ax(vx))

  end function fy_vx

  !----------------------------------------------------------
  !> Y 座標の格子データからスペクトルデータへ変換する.
  !----------------------------------------------------------
  function ft_fy(fy)
    !> 格子点データ
    real(DP), dimension(2*kc(ip),0:jm), intent(in)  :: fy
    !> スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm)              :: ft_fy
    ft_fy = at_ay(fy)

  end function ft_fy

  !----------------------------------------------------------
  !> Y 座標スペクトルデータから格子データへ変換する.
  !----------------------------------------------------------
  function fy_ft(ft)
    !> スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm), intent(in)  :: ft
    !> 格子点データ
    real(DP), dimension(2*kc(ip),0:jm)              :: fy_ft

    fy_ft = ay_at(ft)

  end function fy_ft

  !----------------------------------------------------------
  !>  入力スペクトルデータに X 微分 \f$\partial_x\f$ を作用する.
  !----------------------------------------------------------
  function ft_Dx_ft(ft)
    !> 入力スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm), intent(in)    :: ft
    real(DP), dimension(2*kc(ip),0:lm)                :: ft_Dx_ft

    integer k, kp, km
    do kp=1,kc(ip)
       km = 2*kc(ip)-kp+1
       k = ks(ip)+kp-1
       ft_Dx_ft(kp,:) = (-2*pi*k/xl)*ft(km,:)
       ft_Dx_ft(km,:) = ( 2*pi*k/xl)*ft(kp,:)
    enddo

  end function ft_Dx_ft

  !----------------------------------------------------------
  !>  入力スペクトルデータに Y 微分 \f$\partial_y\f$ を作用する.
  !----------------------------------------------------------
  function ft_Dy_ft(ft)
    !> 入力スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm), intent(in)   :: ft
    real(DP), dimension(2*kc(ip),0:lm)               :: ft_Dy_ft

    ft_Dy_ft = at_Dy_at(ft)

  end function ft_Dy_ft

  !----------------------------------------------------------
  !> 入力スペクトルデータにラプラシアン
  !> \f$(\partial_{xx}+\partial_{yy})\f$ を作用する.
  !----------------------------------------------------------
  function ft_Lapla_ft(ft)
    !> 入力スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm), intent(in)    :: ft
    real(DP), dimension(2*kc(ip),0:lm)                :: ft_Lapla_ft

    integer k, kp, km
    do kp=1,kc(ip)
       km = 2*kc(ip)-kp+1
       k = ks(ip)+kp-1
       ft_Lapla_ft(kp,:) = -(2*pi*k/xl)**2*ft(kp,:)
       ft_Lapla_ft(km,:) = -(2*pi*k/xl)**2*ft(km,:)
    enddo

    ft_Lapla_ft = ft_Lapla_ft + ft_Dy_ft(ft_Dy_ft(ft))

  end function ft_Lapla_ft

  !----------------------------------------------------------
  !> 2 つのスペクトルデータからヤコビアン
  !> \f$ J(A,B) = (\partial_{x}A)(\partial_{y}B)
  !>            -(\partial_{y}A)(\partial_{x}B)\f$ を計算する.
  !----------------------------------------------------------
  function ft_Jacobian_ft_ft(ft_a,ft_b)
    !> 1つ目の入力スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm), intent(in)    :: ft_a
    !> 2つ目の入力スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm), intent(in)    :: ft_b
    !> 2 つのスペクトルデータのヤコビアン
    real(DP), dimension(2*kc(ip),0:lm)                :: ft_Jacobian_ft_ft
    ft_Jacobian_ft_ft = ft_vx(                           &
      &  vx_ft(ft_Dx_ft(ft_a)) * vx_ft(ft_Dy_ft(ft_b))   &
      & - vx_ft(ft_Dy_ft(ft_a)) * vx_ft(ft_Dx_ft(ft_b)) )

  end function ft_Jacobian_ft_ft


  !----------------------------------------------------------
  !> ディリクレ, ノイマン条件の適用. チェビシェフ空間での計算
  !>
  !> 実際には中で呼ばれている at_module のサブルーチン at_Boundaries_DD,
  !> at_Boundaries_DN, at_Boundaries_ND, at_Boundaries_NN を用いている.
  !> これらを直接呼ぶことも出来る.
  !----------------------------------------------------------
  subroutine ft_Boundaries(ft,values,cond)
    !> 境界での 値/勾配 分布を水平スペクトル変換したものを与える.
    !> 省略時は値/勾配 0 となる.
    real(DP), dimension(2*kc(ip),2), intent(in), optional :: values

    !> 境界条件を適用するデータ. 修正された値を返す.
    real(DP), dimension(2*kc(ip),0:lm),intent(inout)      :: ft

    !> 境界条件. 省略時は 'RR'
    !> * DD : 両端ディリクレ
    !> * DN,ND : ディリクレ/ノイマン条件
    !> * NN : 両端ノイマン
    character(len=2), intent(in), optional             :: cond

    if (.not. present(cond)) then
       if (present(values)) then
          call at_Boundaries_DD(ft,values)
       else
          call at_Boundaries_DD(ft)
       endif
       return
    endif

    select case(cond)
    case ('NN')
       if (present(values)) then
          call at_Boundaries_NN(ft,values)
       else
          call at_Boundaries_NN(ft)
       endif
    case ('DN')
       if (present(values)) then
          call at_Boundaries_DN(ft,values)
       else
          call at_Boundaries_DN(ft)
       endif
    case ('ND')
       if (present(values)) then
          call at_Boundaries_ND(ft,values)
       else
          call at_Boundaries_ND(ft)
       endif
    case ('DD')
       if (present(values)) then
          call at_Boundaries_DD(ft,values)
       else
          call at_Boundaries_DD(ft)
       endif
    case default
       call MessageNotify('E','ft_Boundaries','B.C. not supported')
    end select

  end subroutine ft_Boundaries

  !----------------------------------------------------------
  !> 境界で一様な値を与える条件(ディリクレ条件)下で
  !> 入力スペクトルデータに逆ラプラシアン
  !> \f$(\partial_{xx}+\partial_{yy})^{-1}\f$ を作用する
  !> (Chebyshev-tau法)
  !----------------------------------------------------------
  function ft_LaplaInv_ft(ft,values)
    !> スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm),intent(in)  :: ft
    !> 境界値. 省略時は 0 が設定される.
    real(DP), dimension(2*kc(ip),2), intent(in), optional :: values
    !> スペクトルデータの逆ラプラシアン
    real(DP), dimension(2*kc(ip),0:lm)             :: ft_LaplaInv_ft

    real(DP), dimension(:,:,:), allocatable  :: alu
    integer,  dimension(:,:), allocatable    :: kp
    real(DP), dimension(2*kc(ip),0:lm)       :: ft_work
    real(DP), dimension(2*kc(ip),0:jm)       :: fy_work
    real(DP), dimension(2*kc(ip))            :: value1, value2   ! 境界値

    logical :: first = .true.
    integer :: l
    save    :: alu, kp, first

    if (.not. present(values)) then
      value1=0.0D0
      value2=0.0D0
    else
      value1 = values(:,1)
      value2 = values(:,2)
    endif

    if ( first ) then
      first = .false.

      allocate(alu(2*kc(ip),0:lm,0:lm),kp(2*kc(ip),0:lm))

      do l=0,lm
        ft_work=0.0D0
        ft_work(:,l) = 1.0D0
        alu(:,:,l) = ft_Lapla_ft(ft_work)
        fy_work = ay_at(ft_work)
        alu(:,lm-1,l) = fy_work(:,0)
        alu(:,lm,l)   = fy_work(:,jm)
      enddo

      call ludecomp(alu,kp)
    endif

    ft_work = ft
    ft_work(:,lm-1) = value1
    ft_work(:,lm)   = value2
    ft_LaplaInv_ft = lusolve(alu,kp,ft_work)

  end function ft_LaplaInv_ft

  !----------------------------------------------------------
  !> @brief
  !> Y 方向格子点空間での Chebyshev-Collocation 法により，
  !> 渦度から流線を求める.
  !>
  !> @details
  !> 渦度 \f$\zeta\f$ を与えて流線 \f$\psi\f$ を求める.
  !> \f{align*}{
  !>    \nabla^2 \psi & = \zeta, \\
  !>    \psi & = \mbox{const. at boundaries.}
  !> \f}
  !> 粘着条件
  !> \f[ \partial_{y} \psi  = 0 \, \mbox{at boundaries} \f]
  !> 応力なし条件
  !> \f[ (\partial_{y})^{2} \psi = 0\, \mbox{at boundaries} \f]
  !----------------------------------------------------------
  function fy_Vor2Strm_fy(fy,values,cond,new)
    !> 入力渦度分布
    real(DP), dimension(2*kc(ip),0:jm),intent(in)  :: fy
    !> 流線境界値. 境界で一定なので波数 0 成分のみ. 省略時は 0.
    real(DP), dimension(2), intent(in), optional :: values
    !> 境界条件スイッチ. 省略時は 'RR'
    !> * RR : 両端粘着条件
    !> * RF : 上端粘着下端応力なし条件
    !> * FR : 上端応力なし下端粘着条件
    !> * FF : 両端応力なし条件
    character(len=2), intent(in), optional  :: cond
    !> true だと境界条件計算用行列を強制的に新たに作る. default は false.
    logical, intent(IN), optional :: new
    !> 出力流線分布
    real(DP), dimension(2*kc(ip),0:jm)             :: fy_Vor2Strm_fy

    real(DP), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable     :: kp

    real(DP), dimension(2*kc(ip),0:jm)         :: fy_work
    real(DP), dimension(2*kc(ip),0:jm)         :: fy_I
    real(DP)                                 :: value1, value2   ! 境界値
    logical                                  :: rigid1 = .true.
    logical                                  :: rigid2 = .true.
    logical :: first = .true.
    logical :: new_matrix = .false.
    integer :: j
    save    :: alu, kp, first

    if (.not. present(values)) then
      value1=0.0D0
      value2=0.0D0
    else
      value1 = values(1)
      value2 = values(2)
    endif

    if ( present(cond) ) then
      select case (cond)
      case ('RR')
        rigid1 = .TRUE.
        rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.
        rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE.
        rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE.
        rigid2 = .FALSE.
      case default
        call MessageNotify('E','fy_Vor2Strm_fy','B.C. not supported')
      end select
    else
      rigid1 = .TRUE.
      rigid2 = .TRUE.
    endif

    if (.not. present(new)) then
      new_matrix=.false.
    else
      new_matrix=new
    endif

    if ( first .OR. new_matrix ) then
      first = .false.

      if ( allocated(alu) ) deallocate(alu)
      if ( allocated(kp) ) deallocate(kp)
      allocate(alu(2*kc(ip),0:jm,0:jm),kp(2*kc(ip),0:jm))

      do j=0,jm
        fy_I = 0.0D0
        fy_I(:,j) = 1.0D0
        alu(:,:,j) = fy_ft(ft_Lapla_ft(ft_fy(fy_I)))
      enddo

      do j=0,jm
        fy_I = 0.0D0
        fy_I(:,j) = 1.0D0

        ! 運動学的条件. 流線は境界で一定
        alu(:,0,j)   = fy_I(:,0)
        alu(:,jm,j)  = fy_I(:,jm)

        if ( rigid1 ) then                               ! 粘着条件(top)
          fy_work=fy_ft(ft_Dy_ft(ft_fy(fy_I)))
        else
          fy_work=fy_ft(ft_Dy_ft(ft_Dy_ft(ft_fy(fy_I)))) ! すべり条件(top)
        endif

        alu(:,1,j) = fy_work(:,0)

        if ( rigid2 ) then                               ! 粘着条件(bottom)
          fy_work=fy_ft(ft_Dy_ft(ft_fy(fy_I)))
        else
          fy_work=fy_ft(ft_Dy_ft(ft_Dy_ft(ft_fy(fy_I)))) ! すべり条件(bottom)
        endif
        alu(:,jm-1,j) = fy_work(:,jm)
      enddo

      call ludecomp(alu,kp)

      call MessageNotify('M','fy_Vor2Strm_fy',&
        'Matrix for stream func. calc. produced')
    endif

    fy_work = fy
    fy_work(:,1)    = 0.0D0               ! 力学的条件
    fy_work(:,jm-1) = 0.0D0               ! 力学的条件

    fy_work(:,0) = 0.0D0                  ! 運動学的条件. 波数 0 以外は 0
    if ( kf_k(0) > 0 ) then
       fy_work(kf_k(0),0) = value1               ! 運動学的条件.
       fy_work(2*kc(ip)-kf_k(0)+1,0) = value1    ! 運動学的条件.
    endif

    fy_work(:,jm)   = 0.0D0               ! 運動学的条件. 波数 0 以外は 0
    if ( kf_k(0) > 0 ) then
       fy_work(kf_k(0),jm)   = value2                 ! 運動学的条件.
       fy_work(2*kc(ip)-kf_k(0)+1,jm)   = value2      ! 運動学的条件.
    endif

    fy_Vor2Strm_fy = lusolve(alu,kp,fy_work)

  end function fy_Vor2Strm_fy

  !----------------------------------------------------------
  !> @brief Chebyshev-tau 法により，渦度から流線を求める(境界値は定数)
  !> @details
  !> 渦度 \f$\zeta\f$ を与えて流線 \f$\psi\f$ を求める.
  !> \f{align*}{
  !>    \nabla^2\psi & = \zeta, \\
  !>    \psi & = \mbox{const. at boundaries.}
  !> \f}
  !> 粘着条件
  !> \f[   \partial_{y} \psi = 0 \, \mbox{at boundaries} \f]
  !> 応力なし条件
  !> \f[  (\partial_{y})^{2} \psi = 0 \, \mbox{at boundaries} \f]
  !----------------------------------------------------------
  function ft_Vor2Strm_ft(ft,values,cond,new)
    !> 入力渦度分布
    real(DP), dimension(2*kc(ip),0:lm),intent(in)  :: ft
    !> 流線境界値. 境界で一定なので波数 0 成分のみ. 省略時は 0.
    real(DP), dimension(2), intent(in), optional :: values
    !> 境界条件スイッチ. 省略時は 'RR'
    !> * RR : 両端粘着条件
    !> * RF : 上端粘着下端応力なし条件
    !> * FR : 上端応力なし下端粘着条件
    !> * FF : 両端応力なし条件
    character(len=2), intent(in), optional  :: cond
    !> true だと境界条件計算用行列を強制的に新たに作る.
    !> default は false.
    logical, intent(IN), optional :: new
    !> 出力流線分布
    real(DP), dimension(2*kc(ip),0:lm)       :: ft_Vor2Strm_ft

    real(DP), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable     :: kp

    real(DP), dimension(2*kc(ip),0:lm)       :: ft_work
    real(DP), dimension(2*kc(ip),0:jm)       :: fy_work
    real(DP)                                 :: value1
    real(DP)                                 :: value2
    logical                                  :: rigid1 = .true.
    logical                                  :: rigid2 = .true.


    logical :: first = .true.
    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp, first

    if (.not. present(values)) then
      value1=0.0D0
      value2=0.0D0
    else
      value1 = values(1)
      value2 = values(2)
    endif

    if ( present(cond) ) then
      select case (cond)
      case ('RR')
        rigid1 = .TRUE.
        rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.
        rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE.
        rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE.
        rigid2 = .FALSE.
      case default
        call MessageNotify('E','ft_Vor2Strm_ft','B.C. not supported')
      end select
    endif

    if (.not. present(new)) then
      new_matrix=.false.
    else
      new_matrix=new
    endif

    if ( first .OR. new_matrix ) then
      first = .false.

      if ( allocated(alu) ) deallocate(alu)
      if ( allocated(kp) ) deallocate(kp)
      allocate(alu(2*kc(ip),0:lm,0:lm),kp(2*kc(ip),0:lm))

      alu = 0.0D0
      do l=0,lm-2
        ft_work(:,:)= 0.0D0
        ft_work(:,l)= 1.0D0

        alu(:,:,l) = ft_Lapla_ft(ft_work)
      enddo

      do l=0,lm
        ft_work(:,:)= 0.0D0
        ft_work(:,l)= 1.0D0

        ! 運動学的条件. 流線は境界で一定
        fy_work = ay_at(ft_work)
        alu(:,lm,l) = fy_work(:,0)
        alu(:,lm-1,l) = fy_work(:,jm)

        if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
          fy_work=ay_at(ft_Dy_ft(ft_work))
          alu(:,lm-2,l) = fy_work(:,0)
        else                                 ! 力学的条件すべり条件(Top)
          fy_work=ay_at(ft_Dy_ft(ft_Dy_ft(ft_work)))
          alu(:,lm-2,l) = fy_work(:,0)
        endif
        if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
          fy_work=ay_at(ft_Dy_ft(ft_work))
          alu(:,lm-3,l) = fy_work(:,jm)
        else                                 ! 力学的条件すべり条件(bottom)
          fy_work=ay_at(ft_Dy_ft(ft_Dy_ft(ft_work)))
          alu(:,lm-3,l) = fy_work(:,jm)
        endif
      enddo

      call ludecomp(alu,kp)

      call MessageNotify('M','ft_Vor2Strm_ft',&
        'Matrix for stream func. calc. produced')
    endif

    ! 内部領域計算
    ft_work = ft

    ft_work(:,lm-2) = 0.0D0           ! 力学的条件
    ft_work(:,lm-3) = 0.0D0           ! 力学的条件

    ft_work(:,lm-1) = 0.0D0        ! 運動学的条件. 波数 0 以外は 0
    !!$      ft_work(0,lm-1) = value2*2     ! 運動学的条件. 波数 0 は重み 1/2
    if ( kf_k(0) > 0 ) then
       ft_work(kf_k(0),lm-1) = value2       ! 運動学的条件. 波数 0 は重み 1/2
       ft_work(2*kc(ip)-kf_k(0)+1,lm-1) = value2       ! 運動学的条件. 波数 0 は重み 1/2
    endif

    ft_work(:,lm)   = 0.0D0        ! 運動学的条件. 波数 0 以外は 0
!!$      ft_work(0,lm)   = value1*2     ! 運動学的条件. 波数 0 は重み 1/2
    if ( kf_k(0) > 0 ) then
       ft_work(kf_k(0),lm)   = value1     ! 運動学的条件. 波数 0 は重み 1/2
       ft_work(2*kc(ip)-kf_k(0)+1,lm)   = value1     ! 運動学的条件. 波数 0 は重み 1/2
    endif
    ft_Vor2Strm_ft = lusolve(alu,kp,ft_work)

  end function ft_Vor2Strm_ft

  !----------------------------------------------------------
  !> @brief Chebyshev-tau 法により，渦度から流線を求める．
  !>        境界値として X方向の スペクトルを与えることが可能
  !> @details
  !> 渦度 \f$\zeta\f$ を与えて流線 \f$\psi\f$ を求める.
  !> \f{align*}{
  !>    \nabla^2\psi & = \zeta, \\
  !>    \psi & = \mbox{const. at boundaries.}
  !> \f}
  !> 粘着条件
  !> \f[   \partial_{y} \psi = 0 \, \mbox{at boundaries} \f]
  !> 応力なし条件
  !> \f[  (\partial_{y})^{2} \psi = 0 \, \mbox{at boundaries} \f]
  !----------------------------------------------------------
  function ft_Vor2Strm2_ft(ft,fa,cond,new)
    !> 入力渦度分布
    real(DP), dimension(2*kc(ip),0:lm),intent(in)  :: ft
    !> 流線境界値. 省略時は 0. 1:Top,2:Btm
    real(DP), dimension(2*kc(ip),2), intent(in), optional :: fa
    !> 境界条件スイッチ. 省略時は 'RR'
    !> * RR : 両端粘着条件
    !> * RF : 上端粘着下端応力なし条件
    !> * FR : 上端応力なし下端粘着条件
    !> * FF : 両端応力なし条件
    character(len=2), intent(in), optional  :: cond
    !> true だと境界条件計算用行列を強制的に新たに作る.
    !> default は false.
    logical, intent(IN), optional :: new
    !> 出力流線分布
    real(DP), dimension(2*kc(ip),0:lm)         :: ft_Vor2Strm2_ft

    real(DP), dimension(:,:,:), allocatable  :: alu
    integer, dimension(:,:), allocatable     :: kp

    real(DP), dimension(2*kc(ip),0:lm)         :: ft_work
    real(DP), dimension(2*kc(ip),0:jm)         :: fy_work
    real(DP), dimension(2*kc(ip))              :: f_Top
    real(DP), dimension(2*kc(ip))              :: f_Btm
    logical                                  :: rigid1 = .true.
    logical                                  :: rigid2 = .true.

    logical :: first = .true.
    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp, first

    if (.not. present(fa)) then
      f_Top = 0.0D0
      f_Btm = 0.0D0
    else
      f_Top = fa(:,1)
      f_Btm = fa(:,2)
    endif

    if ( present(cond) ) then
      select case (cond)
      case ('RR')
        rigid1 = .TRUE.
        rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.
        rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE.
        rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE.
        rigid2 = .FALSE.
      case default
        call MessageNotify('E','ft_Vor2Strm_ft','B.C. not supported')
      end select
    endif

    if (.not. present(new)) then
      new_matrix=.false.
    else
      new_matrix=new
    endif

    if ( first .OR. new_matrix ) then
      first = .false.

      if ( allocated(alu) ) deallocate(alu)
      if ( allocated(kp) ) deallocate(kp)
      allocate(alu(2*kc(ip),0:lm,0:lm),kp(2*kc(ip),0:lm))

      alu = 0.0D0
      do l=0,lm-2
        ft_work(:,:)= 0.0D0
        ft_work(:,l)= 1.0D0

        alu(:,:,l) = ft_Lapla_ft(ft_work)
      enddo

      do l=0,lm
        ft_work(:,:)= 0.0D0
        ft_work(:,l)= 1.0D0

        ! 運動学的条件. 流線は境界で一定
        fy_work = ay_at(ft_work)
        alu(:,lm,l) = fy_work(:,0)
        alu(:,lm-1,l) = fy_work(:,jm)

        if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
          fy_work=ay_at(ft_Dy_ft(ft_work))
          alu(:,lm-2,l) = fy_work(:,0)
        else                                 ! 力学的条件すべり条件(Top)
          fy_work=ay_at(ft_Dy_ft(ft_Dy_ft(ft_work)))
          alu(:,lm-2,l) = fy_work(:,0)
        endif
        if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
          fy_work=ay_at(ft_Dy_ft(ft_work))
          alu(:,lm-3,l) = fy_work(:,jm)
        else                                 ! 力学的条件すべり条件(bottom)
          fy_work=ay_at(ft_Dy_ft(ft_Dy_ft(ft_work)))
          alu(:,lm-3,l) = fy_work(:,jm)
        endif
      enddo

      call ludecomp(alu,kp)

      call MessageNotify('M','ft_Vor2Strm_ft',&
        'Matrix for stream func. calc. produced')
    endif

    ! 内部領域計算
    ft_work = ft

    ft_work(:,lm-2) = 0.0D0           ! 力学的条件
    ft_work(:,lm-3) = 0.0D0           ! 力学的条件

    ft_work(:,lm-1) = f_Btm           ! 運動学的条件. 波数 0 以外は 0
    ft_work(:,lm)   = f_Top           ! 運動学的条件. 波数 0 以外は 0

    ft_Vor2Strm2_ft = lusolve(alu,kp,ft_work)

  end function ft_Vor2Strm2_ft

  !----------------------------------------------------------
  !> @brief Chebyshev-tau 法により，渦度から流線を求める．
  !>        境界での値と勾配のスペクトルを与えることが可能.
  !> @details
  !> 渦度 \f$\zeta\f$ を与えて流線 \f$\psi\f$ を求める.
  !> \f{align*}{
  !>    \nabla^2\psi & = \zeta, \\
  !>    \psi & = \mbox{const. at boundaries.}
  !> \f}
  !> 粘着条件
  !> \f[   \partial_{y} \psi = 0 \, \mbox{at boundaries} \f]
  !> 応力なし条件
  !> \f[  (\partial_{y})^{2} \psi = 0 \, \mbox{at boundaries} \f]
  !----------------------------------------------------------
  function ft_Vor2Strm3_ft(ft,fa,cond,new)
    !> 入力渦度分布
    real(DP), dimension(2*kc(ip),0:lm),intent(in)  :: ft
    !> 流線/微分境界値. 省略時は 0.
    !> 1. Top 値,
    !> 2. Bottom 値
    !> 3. Top 微分(勾配)
    !> 4. Bottom 微分(勾配)
    real(DP), dimension(2*kc(ip),4), intent(in), optional :: fa
    !> 境界条件スイッチ. 省略時は 'RR'
    !> * RR : 両端粘着条件
    !> * RF : 上端粘着下端応力なし条件
    !> * FR : 上端応力なし下端粘着条件
    !> * FF : 両端応力なし条件
    character(len=2), intent(in), optional  :: cond
    !> true だと境界条件計算用行列を強制的に新たに作る.
    !> default は false.
    logical, intent(IN), optional :: new
    !> 出力流線分布
    real(DP), dimension(2*kc(ip),0:lm)             :: ft_Vor2Strm3_ft

    real(DP), dimension(:,:,:), allocatable :: alu
    integer, dimension(:,:), allocatable    :: kp

    real(DP), dimension(2*kc(ip),0:lm)        :: ft_work
    real(DP), dimension(2*kc(ip),0:jm)        :: fy_work
    real(DP), dimension(2*kc(ip))             :: f_TopValue
    real(DP), dimension(2*kc(ip))             :: f_BtmValue
    real(DP), dimension(2*kc(ip))             :: f_TopDiff
    real(DP), dimension(2*kc(ip))             :: f_BtmDiff
    logical                                 :: rigid1 = .true.
    logical                                 :: rigid2 = .true.
    logical :: first = .true.
    logical :: new_matrix = .false.
    integer :: l
    save    :: alu, kp, first

    if (.not. present(fa)) then
      f_TopValue = 0.0D0
      f_BtmValue = 0.0D0
      f_TopDiff  = 0.0D0
      f_BtmDiff  = 0.0D0
    else
      f_TopValue = fa(:,1)
      f_BtmValue = fa(:,2)
      f_TopDiff  = fa(:,3)
      f_BtmDiff  = fa(:,4)
    endif

    if ( present(cond) ) then
      select case (cond)
      case ('RR')
        rigid1 = .TRUE.
        rigid2 = .TRUE.
      case ('RF')
        rigid1 = .TRUE.
        rigid2 = .FALSE.
      case ('FR')
        rigid1 = .FALSE.
        rigid2 = .TRUE.
      case ('FF')
        rigid1 = .FALSE.
        rigid2 = .FALSE.
      case default
        call MessageNotify('E','ft_Vor2Strm_ft','B.C. not supported')
      end select
    endif

    if (.not. present(new)) then
      new_matrix=.false.
    else
      new_matrix=new
    endif

    if ( first .OR. new_matrix ) then
      first = .false.

      if ( allocated(alu) ) deallocate(alu)
      if ( allocated(kp) ) deallocate(kp)
      allocate(alu(2*kc(ip),0:lm,0:lm),kp(2*kc(ip),0:lm))

      alu = 0.0D0
      do l=0,lm-2
        ft_work(:,:)= 0.0D0
        ft_work(:,l)= 1.0D0

        alu(:,:,l) = ft_Lapla_ft(ft_work)
      enddo

      do l=0,lm
        ft_work(:,:)= 0.0D0
        ft_work(:,l)= 1.0D0

        ! 運動学的条件. 流線は境界で一定
        fy_work = ay_at(ft_work)
        alu(:,lm,l) = fy_work(:,0)
        alu(:,lm-1,l) = fy_work(:,jm)

        if ( rigid1 ) then                   ! 力学的条件粘着条件(Top)
          fy_work=ay_at(ft_Dy_ft(ft_work))
          alu(:,lm-2,l) = fy_work(:,0)
        else                                 ! 力学的条件すべり条件(Top)
          fy_work=ay_at(ft_Dy_ft(ft_Dy_ft(ft_work)))
          alu(:,lm-2,l) = fy_work(:,0)
        endif
        if ( rigid2 ) then                   ! 力学的条件粘着条件(bottom)
          fy_work=ay_at(ft_Dy_ft(ft_work))
          alu(:,lm-3,l) = fy_work(:,jm)
        else                                 ! 力学的条件すべり条件(bottom)
          fy_work=ay_at(ft_Dy_ft(ft_Dy_ft(ft_work)))
          alu(:,lm-3,l) = fy_work(:,jm)
        endif
      enddo

      call ludecomp(alu,kp)

      call MessageNotify('M','ft_Vor2Strm_ft',&
        'Matrix for stream func. calc. produced')
    endif

    ! 内部領域計算
    ft_work = ft

    ft_work(:,lm-2) = f_TopDIff         ! 力学的条件
    ft_work(:,lm-3) = f_BtmDiff         ! 力学的条件

    ft_work(:,lm-1) = f_BtmValue        ! 運動学的条件. 波数 0 以外は 0
    ft_work(:,lm)   = f_TopValue        ! 運動学的条件. 波数 0 以外は 0

    ft_Vor2Strm3_ft = lusolve(alu,kp,ft_work)

  end function ft_Vor2Strm3_ft

  !----------------------------------------------------------
  !> 2 次元格子点データの全領域積分および平均.
  !----------------------------------------------------------
  function IntYX_vx(vx)
    !> 2 次元格子点データ
    real(DP), dimension(jc(ip),0:im-1)   :: vx
    !> 積分値
    real(DP)                           :: IntYX_vx

    real(DP) :: IntYXTmp
    integer :: i, j
    integer :: ierr

    IntYXTmp = 0.0d0
    do i=0,im-1
       do j=1,jc(ip)
          IntYXTmp = IntYXTmp + vx(j,i) * v_Y_Weight(j) * x_X_Weight(i)
       enddo
    enddo

    CALL MPI_ALLREDUCE(IntYXTmp,IntYX_vx,1,MPI_REAL8, &
                       MPI_SUM,MPI_COMM_WORLD,IERR)

  end function IntYX_vx

  function v_IntX_vx(vx)
    !
    ! 2 次元格子点データの X 方向積分
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(DP), dimension(jc(ip),0:im-1)   :: vx
    !(in) 2 次元格子点データ

    real(DP), dimension(jc(ip))          :: v_IntX_vx
    !(out) 積分された 1 次元(Y)格子点データ

    integer :: i
    ! 作業変数

    v_IntX_vx = 0.0d0
    do i=0,im-1
       v_IntX_vx(:) = v_IntX_vx(:) + vx(:,i) * x_X_Weight(i)
    enddo
  end function v_IntX_vx

  function x_IntY_vx(vx)
    !
    ! 2 次元格子点データの Y 方向積分
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
    !
    real(DP), dimension(jc(ip),0:im-1)   :: vx
    !(in)  2 次元格子点データ

    real(DP), dimension(0:im-1)        :: x_IntY_vx
    !(out) 積分された 1 次元(X)格子点データ

    real(DP), dimension(0:im-1)        :: x_IntYTmp
    integer :: j, ierr
    ! 作業変数

    x_IntYTmp = 0.0d0
    do j=1,jc(ip)
       x_IntYTmp(:) = x_IntYTmp(:) + vx(j,:) * v_Y_Weight(j)
    enddo

    CALL MPI_ALLREDUCE(x_IntYTmp,x_IntY_vx,im,MPI_REAL8, &
                       MPI_SUM,MPI_COMM_WORLD,IERR)

  end function x_IntY_vx

  function IntX_x(x)
    !
    ! 1 次元(X)格子点データの X 方向積分
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算している.
    !
    real(DP), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
    real(DP)                      :: IntX_x     !(out) 積分値

    IntX_x = sum(x*x_X_Weight)
  end function IntX_x

  function IntY_v(v)      ! Y 方向積分
    !
    ! 1 次元(Y)格子点データの Y 方向積分
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算している.
    !
    real(DP), dimension(jc(ip))   :: v          !(in)  1 次元格子点データ
    real(DP)                      :: IntY_v     !(out) 積分値

    real(DP)                      :: IntYTmp     !(out) 積分値
    integer :: ierr

    IntYTmp = sum(v*v_Y_Weight)

    CALL MPI_ALLREDUCE(IntYTmp,IntY_v,1,MPI_REAL8, &
                       MPI_SUM,MPI_COMM_WORLD,IERR)

  end function IntY_v

  !--------------- 平均計算 -----------------
  function AvrYX_vx(vx)
    !
    ! 2 次元格子点データの全領域平均
    !
    ! 実際には格子点データ各点毎に x_X_Weight, y_Y_Weight をかけた
    ! 総和を計算し, x_X_Weight*y_Y_Weight の総和で割ることで平均している.
    !
    real(DP), dimension(jc(ip),0:im-1)   :: vx
    !(in)  2 次元格子点データ

    real(DP)                             :: AvrYX_vx
    !(out) 平均値

    AvrYX_vx = IntYX_vx(vx)/(xl*yl)

  end function AvrYX_vx

  function v_AvrX_vx(vx)
    !
    ! 2 次元格子点データの X 方向平均
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
    ! x_X_Weight の総和で割ることで平均している.
    !
    real(DP), dimension(jc(ip),0:im-1)   :: vx
    !(in) 2 次元格子点データ

    real(DP), dimension(jc(ip))          :: v_AvrX_vx
    !(out) 平均された 1 次元(Y)格子点データ

    v_AvrX_vx = v_IntX_vx(vx)/xl

  end function v_AvrX_vx

  function x_AvrY_vx(vx)
    !
    ! 2 次元格子点データの Y 方向平均
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
    ! y_Y_Weight の総和で割ることで平均している.
    !
    real(DP), dimension(jc(ip),0:im-1)   :: vx
    !(in) 2 次元格子点データ

    real(DP), dimension(0:im-1)          :: x_AvrY_vx
    !(out) 平均された 1 次元(X)格子点データ

    x_AvrY_vx = x_IntY_vx(vx)/yl

  end function x_AvrY_vx

  function AvrX_x(x)
    !
    ! 1 次元(X)格子点データの X 方向平均
    !
    ! 実際には格子点データ各点毎に x_X_Weight をかけた総和を計算し,
    ! x_X_Weight の総和で割ることで平均している.
    !
    real(DP), dimension(0:im-1)   :: x          !(in)  1 次元格子点データ
    real(DP)                      :: AvrX_x     !(out) 平均値

    AvrX_x = IntX_x(x)/xl

  end function AvrX_x

  function AvrY_v(v)
    !
    ! 1 次元(Y)格子点データの Y 方向平均
    !
    ! 実際には格子点データ各点毎に y_Y_Weight をかけた総和を計算し,
    ! y_Y_Weight の総和で割ることで平均している.
    !
    real(DP), dimension(jc(ip)) :: v          !(in)  1 次元格子点データ
    real(DP)                    :: AvrY_v     !(out) 平均値

    AvrY_v = IntY_v(v)/yl

  end function AvrY_v


  !----------------------------------------------------------
  !> 補間関数
  !----------------------------------------------------------
  function Interpolate_ft(ft_data,xval,yval)
    !> 入力スペクトルデータ
    real(DP), dimension(2*kc(ip),0:lm), intent(IN) :: ft_data
    !> 補間する点の X 座標
    real(DP), intent(in)                         :: xval
    !> 補間する点の Y 座標
    real(DP), intent(in)                         :: yval
    !> 補間結果
    real(DP)                                     :: Interpolate_ft
    real(DP)                                     :: af_work(1,2*kc(ip))
    real(DP)                                     :: a_work(1)

    af_work(1,:) = a_Interpolate_at(ft_data,yval)
    a_work = a_Interpolate_ae(ae_af(af_work),xval)
    Interpolate_ft = a_work(1)

  end function Interpolate_ft

end module et_mpi_module

! -*- mode: f90; coding: utf-8 -*-
!----------------------------------------------------------------------
! Copyright(c) 2019 SPMDODEL Development Group. All rights reserved.
!
! 履歴  2019/03/28 竹広真一
!       2019/09/28 佐々木洋平
!       2019/10/09 佐々木洋平
!----------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief 1 次元有限領域: チェビシェフ変換
!>
!> @details
!> 1 次元有限領域の下での流体運動をチェビシェフ変換によりスペクトル数値
!> 計算するための Fortran90 関数を提供する.
!>
!> 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
!> 関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
!>
!> このモジュールは内部で ISPACK3/FXPACK の Fortran77 サブルーチンを
!> 呼んでいる. スペクトルデータおよび格子点データの格納方法については
!> ISPACK3/FXPACK のマニュアルを参照されたい.
!>
!> ## 関数・変数の名前と型について
!>
!> ### 命名法
!>
!> * 関数名の先頭 (`t_`, `g_`, `at_`, `ag_`) は, 返す値の形を示している.
!>   * `t_`  :: チェビシェフデータ
!>   * `g_`  :: 1 次元格子点データ
!>   * `at_` :: 1 次元チェビシェフデータが複数並んだ 2 次元データ
!>   * `ag_` :: 1 次元格子点データが複数並んだ 2 次元データ.
!>
!> * 関数名の間の文字列(`Dx`)は, その関数の作用を表している.
!>
!> * 関数名の最後 (`_e`,`_at`,`_g`,`_ag`) は,
!>   入力変数の形がチェビシェフデータおよび格子点データであることを示している.
!>   * `_t`  :: チェビシェフデータ
!>   * `_g`  :: 1 次元格子点データ
!>   * `_at` :: 1 次元チェビシェフデータが複数並んだ 2 次元データ
!>   * `_ag` :: 1 次元格子点データが複数並んだ 2 次元データ
!>
!> ### 各データの種類の説明
!>
!> * 以下, `DP  = kind(1.0D)` である
!> * `g` : 1 次元格子点データ.
!>   * 変数の種類と次元は `real(DP), dimension(0:im)`.
!>   * `im` は X 座標の格子点数であり, サブルーチン at_initial() にて
!>     あらかじめ設定しておく.
!>
!> * `t` : チェビシェフデータ.
!>   * 変数の種類と次元は `real(DP), dimension(0:km)`.
!>   * `km` は X 方向の最大波数であり, サブルーチン at_initial() にて
!>     あらかじめ設定しておく.
!>
!> * `ag` : 1 次元(X)格子点データの並んだ 2 次元データ.
!>   * 変数の種類と次元は `real(DP), dimension(:,0:im)`.
!>     第 2 次元が X 方向を表す.
!>
!> * `at` : 1 次元チェビシェフデータの並んだ 2 次元データ.
!>   * 変数の種類と次元は `real(DP), dimension(:,0:km)`.
!>     第 2 次元がスペクトルを表す.
!>
!> * `g_` で始まる関数が返す値は 1 次元格子点データに同じ.
!>
!> * `t_` で始まる関数が返す値はチェビシェフデータに同じ.
!>
!> * `ag_` で始まる関数が返す値は 1 次元格子点データの並んだ
!>   2 次元データに同じ.
!>
!> * `at_` で始まる関数が返す値は 1 次元チェビシェフデータの並んだ
!>   2 次元データに同じ.
!>
!> * チェビシェフデータに対する微分等の作用とは, 対応する格子点データに
!>   微分などを作用させたデータをチェビシェフ変換したもののことである.

module at_module
  use dc_types, only: DP
  use dc_message, only: MessageNotify
  use spml_utils, only: pi
  use lumatrix, only: lusolve, ludecomp
  use ae_module, only: ae_Initial, ae_Finalize, ae_ag, ag_ae
  implicit none

  private
  public g_X
  public g_X_Weight
  public at_Initial
  public at_Initialize
  public at_Finalize
  public ag_at
  public at_ag
  public g_t
  public t_g
  public at_Dx_at
  public t_Dx_t
  public Interpolate_t
  public a_Interpolate_at
  public at_Boundaries
  public t_Boundaries
  public at_Boundaries_DD
  public at_Boundaries_DN
  public at_Boundaries_ND
  public at_Boundaries_NN
  public at_BoundariesTau_DD
  public at_BoundariesTau_DN
  public at_BoundariesTau_ND
  public at_BoundariesTau_NN
  public at_BoundariesGrid
  public t_BoundariesGrid
  public at_BoundariesGrid_DD
  public at_BoundariesGrid_DN
  public at_BoundariesGrid_ND
  public at_BoundariesGrid_NN
  public a_Int_ag
  public Int_g
  public a_Avr_ag
  public Avr_g

  !----------------------------------------------------------------------
  !> 内部波数などを Integer(8) としたために用意した互換インターフェース
  interface at_Initialize
    module procedure at_Initialize_I4
    module procedure at_Initialize_I8
  end interface at_Initialize

  !----------------------------------------------------------------------
  !> 両端ディリクレ型境界条件の適用(タウ法). 両境界での値を与える.
  interface at_Boundaries_DD
    module procedure at_BoundariesTau_DD_1d
    module procedure at_BoundariesTau_DD_2d
  end interface at_Boundaries_DD

  !----------------------------------------------------------------------
  !> ディリクレ・ノイマン型境界条件の適用(タウ法).
  !> i=0 で値, i=im で勾配の値を与える.
  interface at_Boundaries_DN
    module procedure at_BoundariesTau_DN_1d
    module procedure at_BoundariesTau_DN_2d
  end interface at_Boundaries_DN

  !----------------------------------------------------------------------
  !> ディリクレ・ノイマン型境界条件の適用(タウ法).
  !> i=0 で勾配の値, i=im で値を与える.
  interface at_Boundaries_ND
    module procedure at_BoundariesTau_ND_1d
    module procedure at_BoundariesTau_ND_2d
  end interface at_Boundaries_ND

  !----------------------------------------------------------------------
  !> 両端ノイマン型境界条件の適用(タウ法).
  !> 両境界で勾配の値を与える.
  interface at_Boundaries_NN
    module procedure at_BoundariesTau_NN_1d
    module procedure at_BoundariesTau_NN_2d
  end interface at_Boundaries_NN

  !----------------------------------------------------------------------
  !> 両端ディリクレ型境界条件の適用(タウ法).
  !> 両境界での値を与える.
  interface at_BoundariesTau_DD
    module procedure at_BoundariesTau_DD_1d
    module procedure at_BoundariesTau_DD_2d
  end interface at_BoundariesTau_DD

  !----------------------------------------------------------------------
  !> ディリクレ・ノイマン型境界条件の適用(タウ法).
  !> i=0 で値, i=im で勾配の値を与える.
  interface at_BoundariesTau_DN
    module procedure at_BoundariesTau_DN_1d
    module procedure at_BoundariesTau_DN_2d
  end interface at_BoundariesTau_DN

  !----------------------------------------------------------------------
  !> ノイマン・ディリクレ型境界条件の適用(タウ法).
  !> i=0 で勾配の値, i=im で値を与える.
  interface at_BoundariesTau_ND
    module procedure at_BoundariesTau_ND_1d
    module procedure at_BoundariesTau_ND_2d
  end interface at_BoundariesTau_ND

  !----------------------------------------------------------------------
  !> 両端ノイマン型境界条件の適用(タウ法).
  !> 両境界で勾配の値を与える.
  interface at_BoundariesTau_NN
    module procedure at_BoundariesTau_NN_1d
    module procedure at_BoundariesTau_NN_2d
  end interface at_BoundariesTau_NN

  !----------------------------------------------------------------------
  !> 両端ディリクレ型境界条件の適用(実空間での評価).
  !> 両境界での値を与える.
  interface at_BoundariesGrid_DD
    module procedure at_BoundariesGrid_DD_1d
    module procedure at_BoundariesGrid_DD_2d
  end interface at_BoundariesGrid_DD

  !----------------------------------------------------------------------
  !> ディリクレ・ノイマン型境界条件の適用(実空間での評価).
  !> i=0 で値, i=im で勾配の値を与える.
  interface at_BoundariesGrid_DN
    module procedure at_BoundariesGrid_DN_1d
    module procedure at_BoundariesGrid_DN_2d
  end interface at_BoundariesGrid_DN

  !----------------------------------------------------------------------
  !> ノイマン・ディリクレ型境界条件の適用(実空間での評価).
  !> i=0 で勾配の値, i=0 で値を与える.
  interface at_BoundariesGrid_ND
    module procedure at_BoundariesGrid_ND_1d
    module procedure at_BoundariesGrid_ND_2d
  end interface at_BoundariesGrid_ND

  !----------------------------------------------------------------------
  !> 両端ノイマン型境界条件の適用(実空間での評価).
  !> 両境界で勾配の値を与える.
  interface at_BoundariesGrid_NN
    module procedure at_BoundariesGrid_NN_1d
    module procedure at_BoundariesGrid_NN_2d
  end interface at_BoundariesGrid_NN

  !----------------------------------------------------------------------
  !> 格子点座標(X)を格納した 1 次元配列
  real(DP), allocatable, dimension(:) :: g_X
  !> 重み座標を格納した 1 次元配列
  real(DP), allocatable, dimension(:) :: g_X_Weight

  !----------------------------------------------------------------------
  integer(8), allocatable, dimension(:) :: it
  real(DP), allocatable , dimension(:)  :: t
  !> 格子点数
  integer(8) :: im
  !> 切断波数
  integer(8) :: km
  !> 領域の大きさ
  real(DP)   :: xl
  !> 初期化スイッチ
  logical :: at_Initialized = .false.
  !> 境界条件ルーチン初期化スイッチ
  logical :: at_BoundariesTau_DD_first = .true.
  !> 境界条件ルーチン初期化スイッチ
  logical :: at_BoundariesTau_DN_first = .true.
  !> 境界条件ルーチン初期化スイッチ
  logical :: at_BoundariesTau_ND_first = .true.
  !> 境界条件ルーチン初期化スイッチ
  logical :: at_BoundariesTau_NN_first = .true.
  !> 境界条件ルーチン初期化スイッチ
  logical :: at_BoundariesGrid_DD_first = .true.
  !> 境界条件ルーチン初期化スイッチ
  logical :: at_BoundariesGrid_DN_first = .true.
  !> 境界条件ルーチン初期化スイッチ
  logical :: at_BoundariesGrid_ND_first = .true.
  !> 境界条件ルーチン初期化スイッチ
  logical :: at_BoundariesGrid_NN_first = .true.

  ! 作業領域
  integer(8) :: ag_at_nm = -1_8, ag_at_im = -1_8
  real(DP), allocatable, dimension(:,:)   :: ag_at_work
  save       :: ag_at_work, ag_at_nm, ag_at_im
  !$omp threadprivate(ag_at_work, ag_at_nm, ag_at_im)

  integer(8) ::  g_t_im = -1_8, g_t_km = -1_8
  real(DP), allocatable, dimension(:,:)   :: t_work_g_t
  real(DP), allocatable, dimension(:,:)   :: g_work_g_t
  save       :: t_work_g_t, g_work_g_t, g_t_im, g_t_km
  !$omp threadprivate(t_work_g_t, g_work_g_t, g_t_im, g_t_km)

  integer(8) :: at_ag_nm = -1_8, at_ag_im = -1_8
  real(DP), allocatable, dimension(:,:)   :: at_ag_work
  save       :: at_ag_work, at_ag_nm, at_ag_im
  !$omp threadprivate(at_ag_work, at_ag_nm, at_ag_im)

  integer(8) ::  t_g_im = -1_8, t_g_km = -1_8
  real(DP), allocatable, dimension(:,:)   :: t_work_t_g
  real(DP), allocatable, dimension(:,:)   :: g_work_t_g
  save       :: t_work_t_g, g_work_t_g, t_g_im, t_g_km
  !$omp threadprivate(t_work_t_g, g_work_t_g, t_g_im, t_g_km)

  save :: im, km, xl, g_X, g_X_Weight, at_Initialized
  save :: at_BoundariesTau_DD_first
  save :: at_BoundariesTau_DN_first
  save :: at_BoundariesTau_ND_first
  save :: at_BoundariesTau_NN_first
  save :: at_BoundariesGrid_DD_first
  save :: at_BoundariesGrid_DN_first
  save :: at_BoundariesGrid_ND_first
  save :: at_BoundariesGrid_NN_first

contains
  !----------------------------------------------------------------------
  !> 関数名の変更
  subroutine at_Initial(i,k,xmin,xmax)
    !> 格子点数
    integer, intent(in)  :: i
    !> 切断波数
    integer, intent(in)  :: k
    !> 座標の範囲
    real(DP), intent(in) :: xmin, xmax

    call MessageNotify('W','at_Initial', &
      & 'at_Initial is deprecated; will be removed; use at_Initialize.')

    call at_Initialize_I8(int(i,kind(im)),int(k,kind(im)),xmin,xmax)
  end subroutine at_Initial

  !----------------------------------------------------------------------
  !> 内部波数などを Integer(8) としたために用意した互換インターフェース
  !> * Integer 用
  subroutine at_Initialize_I4(i,k,xmin,xmax)
    !> 格子点数
    integer, intent(in)  :: i
    !> 切断波数
    integer, intent(in)  :: k
    !> 座標の範囲
    real(DP), intent(in) :: xmin, xmax

    call MessageNotify('W','at_Initialize', &
      & 'INTEGER(4) im/km deprecated; will be removed; use INTEGER(8).')

    call at_Initialize_I8(int(i,kind(im)),int(k,kind(km)),xmin,xmax)
  end subroutine at_Initialize_I4

  !-----------------------------------------------------------------------
  !> チェビシェフ変換の格子点数, 波数, 領域の大きさを設定する.
  !>
  !> 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
  !> 初期設定をしなければならない.
  subroutine at_Initialize_I8(i,k,xmin,xmax)
    !> 格子点数
    integer(8), intent(in)  :: i
    !> 切断波数
    integer(8), intent(in)  :: k
    !> 座標の範囲
    real(DP), intent(in) :: xmin, xmax

    integer(8) :: ii, kk

    im = i
    km = k
    xl = xmax-xmin

    if ( im <= 0 .or. km <= 0 ) then
      call MessageNotify('E','at_initial', &
        & 'Number of grid points and waves should be positive')
    elseif ( mod(im,2_8) /= 0 ) then
      call MessageNotify('E','at_initial', &
        & 'Number of grid points should be even')
    elseif ( km > im ) then
      call MessageNotify('E','at_initial', &
        & 'KM shoud be less equal IM')
    end if

    allocate(it(im),t(3_8*im))

    call FXRINI(2_8*im,it,t)

    allocate(g_X(0:im))
    do ii=0, im
      g_X(ii) = (xmax+xmin)/2 + xl/2 * cos(pi*ii/im)
    end do

    allocate(g_X_Weight(0:im))

    do ii=0,im
      g_X_Weight(ii) = 1.0_DP
      do kk=2,km,2
        g_X_Weight(ii) = g_X_Weight(ii) &
          & + 2.0_DP/(1.0_DP - kk**2) * cos(kk*ii*pi/im)
      end do
      ! 最後の和は factor 1/2.
      if ( (km == im) .and. (mod(im,2_8) == 0) ) then
        g_X_Weight(ii) = g_X_Weight(ii) &
          & - 1.0_DP/(1.0_DP - km**2)* cos(km*ii*pi/im)
      end if
      g_X_Weight(ii) = 2.0_DP/im * g_X_Weight(ii) * (xl/2.0_DP)
    end do
    g_X_Weight(0)  = g_X_Weight(0) * 0.5_DP
    g_X_Weight(im) = g_X_Weight(im) * 0.5_DP

    at_Initialized = .true.

    call MessageNotify('M','at_initial', &
      & 'at_module (2026/02/10) is initialized')
  end subroutine at_Initialize_I8

  !----------------------------------------------------------------------
  !> モジュールの終了処理(割り付け配列の解放)をおこなう.
  !>
  subroutine at_Finalize
    use omp_lib, only: omp_in_parallel

    if ( .not. at_Initialized ) then
      call MessageNotify('W','at_Finalize',&
        'at_module not initialized yet')
      return
    end if

    if (allocated(it)) deallocate(it)
    if (allocated(t)) deallocate(t)
    if (allocated(g_X)) deallocate(g_X)
    if (allocated(g_X_Weight)) deallocate(g_X_Weight)

    at_Initialized = .false.

    at_BoundariesTau_DD_first = .true.
    at_BoundariesTau_DN_first = .true.
    at_BoundariesTau_ND_first = .true.
    at_BoundariesTau_NN_first = .true.
    at_BoundariesGrid_DD_first = .true.
    at_BoundariesGrid_DN_first = .true.
    at_BoundariesGrid_ND_first = .true.
    at_BoundariesGrid_NN_first = .true.

    if ( omp_in_parallel() ) then
      call at_Finalize_tls()
    else
      !$omp parallel
      call at_Finalize_tls()
    !$omp end parallel
    end if

    call MessageNotify(&
      & 'M','at_Finalize','at_module (2026/02/10) is finalized')
  end subroutine at_Finalize
  ! --------------------------------------------------------------------------
  subroutine at_Finalize_tls
    if (allocated(ag_at_work)) deallocate(ag_at_work)
    ag_at_nm = -1_8
    ag_at_im = -1_8
    if (allocated(t_work_g_t)) deallocate(t_work_g_t)
    if (allocated(g_work_g_t)) deallocate(g_work_g_t)
    g_t_im = -1_8
    g_t_km = -1_8
    if (allocated(at_ag_work)) deallocate(at_ag_work)
    at_ag_nm = -1_8
    at_ag_im = -1_8
    if (allocated(t_work_t_g)) deallocate(t_work_t_g)
    if (allocated(g_work_t_g)) deallocate(g_work_t_g)
    t_g_im = -1_8
    t_g_km = -1_8

  end subroutine at_Finalize_tls

  !-----------------------------------------------------------------------
  !> チェビシェフデータから格子データへ変換する(2 次元配列用).
  function ag_at(at_data)
    !> チェビシェフデータ
    real(DP), dimension(:,0:), intent(in)   :: at_data
    !> 格子点データ
    real(DP), allocatable, dimension(:,:)   :: ag_at
    integer(8) :: nm, n
    integer(8) :: k, kmax

    nm = size(at_data,1)

    if (.not. allocated(ag_at_work) .or. &
      & ag_at_im /= im .or.              &
      & ag_at_nm /= nm) then
      if (allocated(ag_at_work)) deallocate(ag_at_work)
      allocate(ag_at_work(nm,0:2*im-1))
      ag_at_im = im
      ag_at_nm = nm
    end if
    allocate(ag_at(nm,0:im))

    ag_at_work = 0.0_DP
    ag_at_work(:,0) = at_data(:,0)
    kmax = min(km,im-1)
    do k=1_8, kmax
      !$omp simd
      do n=1, nm
        ag_at_work(n,2*k)   = at_data(n,k)
        ag_at_work(n,2*k+1) = 0.0_DP
      end do
    end do
    if ( km == im ) then
      ag_at_work(:,1) = at_data(:,km)
    end if

    call FXRTBA(nm,2_8*im,ag_at_work,it,t)
    ag_at = 0.50_DP * ag_at_work(:,0:im)

  end function ag_at

  !-----------------------------------------------------------------------
  !> チェビシェフデータから格子データへ変換する(1 次元配列用).
  function g_t(t_data)
    !> チェビシェフデータ
    real(DP), dimension(0:), intent(in)    :: t_data
    !> 格子点データ
    real(DP), allocatable, dimension(:)   :: g_t

    if (.not. allocated(t_work_g_t) .or. g_t_km /= km ) then
      if (allocated(t_work_g_t)) deallocate(t_work_g_t)
      allocate(t_work_g_t(1,0:km))
      g_t_km = km
    end if
    if (.not. allocated(g_work_g_t) .or. g_t_im /= im ) then
      if (allocated(g_work_g_t)) deallocate(g_work_g_t)
      allocate(g_work_g_t(1,0:im))
      g_t_im = im
    end if

    allocate(g_t(0:im))

    t_work_g_t(1,0:km) = t_data(0:km)
    g_work_g_t = ag_at(t_work_g_t)
    g_t = g_work_g_t(1,0:im)

  end function g_t

  !-----------------------------------------------------------------------
  !> 格子データからチェビシェフデータへ変換する(2 次元配列用).
  function at_ag(ag_data)
    !> 格子点データ
    real(DP), dimension(:,0:), intent(in)   :: ag_data
    !> チェビシェフデータ
    real(DP), allocatable, dimension(:,:)   :: at_ag
    integer(8) :: nm, n
    integer(8) :: k

    nm = size(ag_data,1)
    if (.not. allocated(at_ag_work) .or. &
      & at_ag_im /= im .or.              &
      & at_ag_nm /= nm ) then
      if (allocated(at_ag_work)) deallocate(at_ag_work)
      allocate(at_ag_work(nm,0:2*im-1))
      at_ag_im = im
      at_ag_nm = nm
    end if

    allocate(at_ag(nm,0:km))

    at_ag_work(:,0) = ag_data(:,0)
    do k=1,im-1
    !$omp simd
      do n=1,nm
        at_ag_work(n,2*k)   = ag_data(n,k)
        at_ag_work(n,2*k+1) = 0.0_DP
      end do
    end do
    at_ag_work(:,1) = ag_data(:,im)

    call FXRTBA(nm, 2_8*im, at_ag_work, it, t)
    at_ag = at_ag_work(:,0:km)/real(im, DP)

  end function at_ag

  !-----------------------------------------------------------------------
  !> 格子データからチェビシェフデータへ変換する(1 次元配列用).
  function t_g(g_data)
    !> 格子点データ
    real(DP), dimension(0:), intent(in)     :: g_data
    !>  チェビシェフデータ
    real(DP), allocatable, dimension(:)    :: t_g

    if (.not. allocated(t_work_t_g) .or. t_g_km /= km ) then
      if (allocated(t_work_t_g)) deallocate(t_work_t_g)
      allocate(t_work_t_g(1,0:km))
      t_g_km = km
    end if
    if (.not. allocated(g_work_t_g) .or. t_g_im /= im ) then
      if (allocated(g_work_t_g)) deallocate(g_work_t_g)
      allocate(g_work_t_g(1,0:im))
      t_g_im = im
    end if

    allocate(t_g(0:km))

    g_work_t_g(1,0:im) = g_data(0:im)
    t_work_t_g = at_ag(g_work_t_g)
    t_g = t_work_t_g(1,0:km)

  end function t_g

  !-----------------------------------------------------------------------
  !> 入力チェビシェフデータに X 微分を作用する(2 次元配列用).
  !>
  !> チェビシェフデータの X 微分とは, 対応する格子点データに X 微分を
  !> 作用させたデータのチェビシェフ変換のことである.
  function at_Dx_at(at_data)
    !> 入力チェビシェフデータ
    real(DP), dimension(:,0:), intent(in)   :: at_data
    !> チェビシェフデータの X 微分
    real(DP), allocatable, dimension(:,:)   :: at_Dx_at

    integer(8) :: k, kmax, n, nm
    real(DP)   :: coef

    nm = size(at_data,1)
    kmax = size(at_data,2)-1

    allocate(at_Dx_at(nm,0:kmax))

    at_Dx_at = 0.0_DP

    if ( kmax == im ) then
      at_Dx_at(:,kmax-1) = km * at_data(:,kmax)
    else
      at_Dx_at(:,kmax-1) = 2.0_DP * km * at_data(:,kmax)
    end if

    do k=kmax-2, 0, -1
      coef = 2.0_DP * (k+1)
      !$omp simd
      do n=1, nm
        at_Dx_at(n,k) = at_Dx_at(n,k+2) + coef * at_data(n,k+1)
      end do
    end do

    at_Dx_at = (2.0_DP/xl) * at_Dx_at

  end function at_Dx_at

  !-----------------------------------------------------------------------
  !> 入力チェビシェフデータに X 微分を作用する(1 次元配列用).
  !>
  !> チェビシェフデータの X 微分とは, 対応する格子点データに X 微分を
  !> 作用させたデータのチェビシェフ変換のことである.
  function t_Dx_t(t_data)
    !> 入力チェビシェフデータ
    real(DP), dimension(0:), intent(in)     :: t_data
    !> チェビシェフデータの X 微分
    real(DP), allocatable, dimension(:)     :: t_Dx_t

    real(DP), allocatable, dimension(:,:)   :: at_work

    allocate(t_Dx_t(0:km))
    allocate(at_work(1,0:km))

    at_work(1,0:km) = t_data(0:km)
    at_work = at_Dx_at(at_work)
    t_Dx_t(0:km) = at_work(1,0:km)

  end function t_Dx_t

  !-----------------------------------------------------------------------
  !> 1 次元格子点データが並んだ 2 次元配列の積分
  function a_Int_ag(ag)
    !> 入力格子点データ
    real(DP), dimension(:,0:), intent(in)     :: ag
    !> 積分したデータ
    real(DP), allocatable, dimension(:)       :: a_Int_ag

    integer(8) :: i, j, jmax
    real(DP) :: g_X_Weight_i

    allocate(a_Int_ag(size(ag,1)))

    if ( size(ag,2) < im+1 ) then
      call MessageNotify('E','ae_ag', &
        'The Grid points of input data too small.')
    elseif ( size(ag,2) > im+1 ) then
      call MessageNotify('W','ae_ag', &
        'The Grid points of input data too large.')
    end if

    a_Int_ag = 0.0_DP
    jmax = size(ag,1)
    do i=0,im
      g_X_weight_i = g_X_weight(i)
      !$omp simd
      do j = 1, jmax
        a_Int_ag(j) = a_Int_ag(j) + ag(j,i) * g_X_weight_i
      end do
    end do
  end function a_Int_ag

  !-----------------------------------------------------------------------
  !> 1 次元格子点データの積分
  function Int_g(g)
    !> 格子点データ
    real(DP), dimension(0:im), intent(in)   :: g
    !> 積分値
    real(DP)                                :: Int_g
    Int_g = sum(g*g_X_Weight)
  end function Int_g

  !-----------------------------------------------------------------------
  !> 1 次元格子点データが並んだ 2 次元配列の平均
  function a_Avr_ag(ag)
    !> 入力格子点データ
    real(DP), dimension(:,0:), intent(in)   :: ag
    !> 平均したデータ
    real(DP), allocatable, dimension(:)     :: a_Avr_ag

    allocate(a_Avr_ag(size(ag,1)))
    a_Avr_ag = a_Int_ag(ag)/sum(g_X_Weight)

  end function a_Avr_ag

  !-----------------------------------------------------------------------
  !> 1 次元格子点データの平均
  function Avr_g(g)
    !> 格子点データ
    real(DP), dimension(0:im), intent(in)   :: g
    !> 積分値
    real(DP)                                :: Avr_g

    Avr_g = Int_g(g)/sum(g_X_Weight)
  end function Avr_g

  !-----------------------------------------------------------------------
  !> 1 次元データの補間
  function Interpolate_t(t_data,xval)
    !> 入力チェビシェフデータ
    real(DP), dimension(0:), intent(in)  :: t_data
    !> 補間する点の座標
    real(DP), intent(in)                 :: xval
    !> 補間した結果の値
    real(DP)                             :: Interpolate_t

    integer(8) :: kmax
    ! Crenshow's reccurence formula 計算用変数
    real(DP)   :: y2, y1, y0, x
    integer(8) :: k
    ! DO 文変数

    kmax = size(t_data)-1

    x = (xval -(g_X(0)+g_X(im))*0.5_DP )/(g_X(0)-g_X(im))*2.0_DP

    y2 = 0.0_DP
    y1 = 0.0_DP
    do k=kmax, 1, -1
      y0 = 2.0_DP*x*y1 - y2 + t_data(k)
      y2 = y1
      y1 = y0
    end do

    Interpolate_t = - y2 + x * y1 + t_data(0)*0.5_DP
    if ( kmax == im ) then
      Interpolate_t = Interpolate_t - t_data(kmax)*0.5_DP*cos(kmax*acos(x))
    end if

  end function Interpolate_t

  !-----------------------------------------------------------------------
  !> 1 次元データの並んだ 2次元配列の補間
  function a_Interpolate_at(at_data,xval)
    !> 入力チェビシェフデータ
    real(DP), dimension(:,0:), intent(in) :: at_data
    !> 補間する点の座標
    real(DP), intent(in)                  :: xval
    !> 補間した結果の値
    real(DP), allocatable, dimension(:)   :: a_Interpolate_at

    ! 入力配列の最大次数
    integer(8) :: kmax

    ! Crenshow's reccurence formula 計算用変数
    real(DP), allocatable, dimension(:)   :: y2, y1, y0
    real(DP)                              :: x

    ! DO 文変数
    integer(8) :: k, nm

    nm = size(at_data,1)
    allocate(a_Interpolate_at(nm))
    allocate(y2(nm),y1(nm),y0(nm))

    kmax = size(at_data,2)-1

    x = (xval -(g_X(0)+g_X(im))*0.5_DP )/(g_X(0)-g_X(im))*2.0_DP

    y2 = 0.0_DP
    y1 = 0.0_DP
    do k=kmax,1,-1
      y0 = 2.0_DP*x*y1 - y2 + at_data(:,k)
      y2 = y1
      y1 = y0
    end do

    a_Interpolate_at = - y2 + x*y1 + at_data(:,0)*0.5_DP
    if ( kmax == im ) then
      a_Interpolate_at = a_Interpolate_at &
        & - at_data(:,kmax)*0.5_DP*cos(kmax*acos(x))
    end if
  end function a_Interpolate_at

  !-----------------------------------------------------------------------
  !> 境界条件の適用(タウ法, 2 次元配列用)
  !>
  !> 境界条件と両境界での値をオプションで与える.
  !> デフォルトは DD, values = 0
  subroutine at_Boundaries(at_data,cond,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), intent(INOUT)                  :: at_data(:,:)
    !> 境界条件.
    !> * DD : 両端ディリクレ
    !> * DN : 上端ディリクレ, 下端ノイマン
    !> * ND : 上端ノイマン,   下端ディリクレ
    !> * NN : 両端ノイマン
    character(len=2), intent(IN), optional  :: cond
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP),allocatable, dimension(:,:)    :: BCvalues
    character(len=2)                        :: BC

    allocate(BCvalues(size(at_data,1),2))

    if ( present(cond) ) then
      BC = cond
    else
      BC = 'DD'
    end if

    if ( present(values) ) then
      BCvalues = values
    else
      BCvalues = 0.0_DP
    end if
    select case(BC)
    case ('DD')
      call at_Boundaries_DD(at_data,BCvalues)
    case ('DN')
      call at_Boundaries_DN(at_data,BCValues)
    case ('ND')
      call at_Boundaries_ND(at_data,BCValues)
    case ('NN')
      call at_Boundaries_NN(at_data,BCValues)
    case default
      call at_Boundaries_DD(at_data,BCvalues)
    end select

  end subroutine at_Boundaries

  !---------------------------------------------------------------------
  !> 境界条件の適用(タウ法, 1 次元配列用)
  !> 境界条件と両境界での値をオプションで与える.
  !> デフォルトは DD, values = 0
  subroutine t_Boundaries(t_data,cond,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), intent(INOUT)                  :: t_data(:)
    !> 境界条件.
    !> * DD : 両端ディリクレ
    !> * DN : 上端ディリクレ, 下端ノイマン
    !> * ND : 上端ノイマン,   下端ディリクレ
    !> * NN : 両端ノイマン
    character(len=2), intent(IN), optional   :: cond
    !> 境界値(2)
    real(DP), dimension(2), intent(in), optional  :: values

    real(DP), dimension(2)  :: BCvalues
    character(len=2)        :: BC


    if ( present(cond) ) then
      BC = cond
    else
      BC = 'DD'
    end if

    if ( present(values) ) then
      BCvalues = values
    else
      BCvalues = 0.0_DP
    end if

    select case(BC)
    case ('DD' )
      call at_Boundaries_DD(t_data,BCvalues)
    case ('DN' )
      call at_Boundaries_DN(t_data,BCvalues)
    case ('ND' )
      call at_Boundaries_ND(t_data,BCvalues)
    case ('NN' )
      call at_Boundaries_NN(t_data,BCvalues)
    case default
      call at_Boundaries_DD(t_data,BCvalues)
    end select

  end subroutine t_Boundaries

  !---------------------------------------------------------------------
  !> 境界条件の適用(実空間での評価, 2 次元配列用)
  !> 境界条件と両境界での値をオプションで与える.
  !> デフォルトは DD, values = 0
  subroutine at_BoundariesGrid(at_data,cond,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), intent(INOUT)                  :: at_data(:,:)
    !> 境界条件.
    !> * DD : 両端ディリクレ
    !> * DN : 上端ディリクレ, 下端ノイマン
    !> * ND : 上端ノイマン,   下端ディリクレ
    !> * NN : 両端ノイマン
    character(len=2), intent(IN), optional  :: cond
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP), allocatable, dimension(:,:)   :: BCvalues
    character(len=2)  :: BC

    allocate(BCValues(size(at_data,1),2))

    if ( present(cond) ) then
      BC = cond
    else
      BC = 'DD'
    end if

    if ( present(values) ) then
      BCvalues = values
    else
      BCvalues = 0.0_DP
    end if

    select case(BC)
    case ('DD')
      call at_BoundariesGrid_DD(at_data,BCvalues)
    case ('DN')
      call at_BoundariesGrid_DN(at_data,BCValues)
    case ('ND')
      call at_BoundariesGrid_ND(at_data,BCValues)
    case ('NN')
      call at_BoundariesGrid_NN(at_data,BCValues)
    end select

  end subroutine at_BoundariesGrid

  !---------------------------------------------------------------------
  !> 境界条件の適用(タウ法, 1 次元配列用)
  !> 境界条件と両境界での値をオプションで与える.
  !> デフォルトは DD, values = 0
  subroutine t_BoundariesGrid(t_data,cond,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), intent(INOUT)                  :: t_data(:)
    !> 境界条件.
    !> * DD : 両端ディリクレ
    !> * DN : 上端ディリクレ, 下端ノイマン
    !> * ND : 上端ノイマン,   下端ディリクレ
    !> * NN : 両端ノイマン
    character(len=2), intent(IN), optional  :: cond
    !> 境界値(2)
    real(DP), dimension(2), intent(in), optional  :: values

    real(DP), dimension(2)     :: BCvalues
    character(len=2)           :: BC

    if ( present(cond) ) then
      BC = cond
    else
      BC = 'DD'
    end if

    if ( present(values) ) then
      BCvalues = values
    else
      BCvalues = 0.0_DP
    end if
    select case(BC)
    case ('DD')
      call at_BoundariesGrid_DD(t_data,BCvalues)
    case ('DN')
      call at_BoundariesGrid_DN(t_data,BCvalues)
    case ('ND')
      call at_BoundariesGrid_ND(t_data,BCvalues)
    case ('NN')
      call at_BoundariesGrid_NN(t_data,BCvalues)
    end select

  end subroutine t_BoundariesGrid

  !----------------------------------------------------------
  ! Private function
  !----------------------------------------------------------

  !----------------------------------------------------------
  !> Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
  !> 両境界での値を与える.
  subroutine at_BoundariesTau_DD_2d(at_data,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), dimension(:,0:),intent(inout)         :: at_data
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable     :: kp
    real(DP), allocatable, dimension(:,:)  :: tt_data
    real(DP), allocatable, dimension(:,:)  :: tg_data
    real(DP), allocatable, dimension(:)    :: value1, value2  ! 境界値
    integer(8) :: k, nm
    save       :: alu, kp, tt_data, tg_data

    nm = size(at_data,1)
    allocate(value1(nm),value2(nm))

    if ( size(at_data,2)-1 < km ) then
      call MessageNotify('E','at_BoundariesTau_DD', &
        'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
      call MessageNotify('W','at_BoundariesTau_DD', &
        'The Chebyshev dimension of input data too large.')
    end if

    if ( present(values) ) then
      value1 = values(:,1)
      value2 = values(:,2)
      else
      value1=0.0_DP
      value2=0.0_DP
    end if

    if ( at_BoundariesTau_DD_first ) then
      at_BoundariesTau_DD_first = .false.

      if (allocated(alu)) deallocate(alu)
      if (allocated(kp))  deallocate(kp)
      if (allocated(tt_data)) deallocate(tt_data)
      if (allocated(tg_data)) deallocate(tg_data)

      allocate(alu(0:km,0:km),kp(0:km))
      allocate(tt_data(0:km,0:km))
      allocate(tg_data(0:km,0:im))

      tt_data=0.0_DP
      do k=0,km
        tt_data(k,k)=1.0_DP
      end do
      alu = tt_data

      tg_data = ag_at(tt_data)
      alu(km-1,:) = tg_data(:,0)
      alu(km,:)   = tg_data(:,im)

      call ludecomp(alu,kp)
    end if

    at_data(:,km-1) = value1
    at_data(:,km)   = value2
    at_data = lusolve(alu,kp,at_data)

  end subroutine at_BoundariesTau_DD_2d

  !----------------------------------------------------------
  !> Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
  !> 両境界での値を与える.
  subroutine at_BoundariesTau_DD_1d(t_data,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), dimension(0:km),intent(inout)       :: t_data
    !> 境界値
    real(DP), dimension(2), intent(in), optional  :: values

    real(DP), dimension(1,0:km)                   :: at_work
    real(DP), dimension(1,2)                      :: vwork

    if ( present(values)) then
      vwork(1,:) = values
    else
      vwork(1,1)=0.0_DP
      vwork(1,2)=0.0_DP
    end if

    at_work(1,:)=t_data
    call at_BoundariesTau_DD_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesTau_DD_1d


  !----------------------------------------------------------
  !> Dirichlet/Neumann 型境界条件の適用(タウ法, 2 次元配列用)
  !> i=0 で値, i=im で勾配の値を与える.
  subroutine at_BoundariesTau_DN_2d(at_data,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), dimension(:,0:),intent(inout)         :: at_data
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable     :: kp
    real(DP), allocatable, dimension(:,:)  :: tt_data
    real(DP), allocatable, dimension(:,:)  :: tg_data
    real(DP), allocatable, dimension(:)    :: value1, value2  ! 境界値

    integer(8) :: k, nm
    save       :: alu, kp, tt_data, tg_data

    nm = size(at_data,1)
    allocate(value1(nm),value2(nm))

    if ( size(at_data,2)-1 < km ) then
      call MessageNotify('E','at_BoundariesTau_DN', &
        'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
      call MessageNotify('W','at_BoundariesTau_DN', &
        'The Chebyshev dimension of input data too large.')
    end if

    if ( present(values)) then
      value1 = values(:,1)
      value2 = values(:,2)
    else
      value1 = 0.0_DP
      value2 = 0.0_DP
    end if

    if ( at_BoundariesTau_DN_first ) then
      at_BoundariesTau_DN_first = .false.

      if (allocated(alu)) deallocate(alu)
      if (allocated(kp)) deallocate(kp)
      if (allocated(tt_data)) deallocate(tt_data)
      if (allocated(tg_data)) deallocate(tg_data)

      allocate(alu(0:km,0:km),kp(0:km))
      allocate(tt_data(0:km,0:km))
      allocate(tg_data(0:km,0:im))

      tt_data = 0.0_DP
      do k=0,km
        tt_data(k,k)=1.0_DP
      end do
      alu = tt_data

      tg_data = ag_at(tt_data)
      alu(km-1,:) = tg_data(:,0)
      tg_data = ag_at(at_Dx_at(tt_data))
      alu(km,:)   = tg_data(:,im)

      call ludecomp(alu,kp)
    end if

    at_data(:,km-1) = value1
    at_data(:,km)   = value2
    at_data = lusolve(alu,kp,at_data)

  end subroutine at_BoundariesTau_DN_2d

  !----------------------------------------------------------
  !> Dirichlet/Neumann 型境界条件の適用(タウ法, 1 次元配列用)
  !> i=0 で値, i=im で勾配の値を与える.
  subroutine at_BoundariesTau_DN_1d(t_data,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), dimension(0:km),intent(inout)       :: t_data
    !> 境界値

    real(DP), dimension(2), intent(in), optional  :: values
    real(DP), dimension(1,0:km)                   :: at_work
    real(DP), dimension(1,2)                      :: vwork

    if ( present(values)) then
      vwork(1,:) = values
    else
      vwork(1,1)=0.0_DP
      vwork(1,2)=0.0_DP
    end if

    at_work(1,:)=t_data
    call at_BoundariesTau_DN_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesTau_DN_1d

  !----------------------------------------------------------
  !> Neumann/Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
  !> i=0 で勾配の値, i=im で値を与える.
  subroutine at_BoundariesTau_ND_2d(at_data,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), dimension(:,0:),intent(inout)         :: at_data
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable     :: kp
    real(DP), allocatable, dimension(:,:)  :: tt_data
    real(DP), allocatable, dimension(:,:)  :: tg_data
    real(DP), allocatable, dimension(:)    :: value1, value2  ! 境界値
    integer(8) :: k, nm
    save       :: alu, kp, tt_data, tg_data

    nm = size(at_data,1)
    allocate(value1(nm),value2(nm))

    if ( size(at_data,2)-1 < km ) then
      call MessageNotify('E','at_BoundariesTau_ND', &
        'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
      call MessageNotify('W','at_BoundariesTau_ND', &
        'The Chebyshev dimension of input data too large.')
    end if

    if ( present(values)) then
      value1 = values(:,1)
      value2 = values(:,2)
    else
      value1 = 0.0_DP
      value2 = 0.0_DP
    end if

    if ( at_BoundariesTau_ND_first ) then
      at_BoundariesTau_ND_first = .false.

      if (allocated(alu)) deallocate(alu)
      if (allocated(kp)) deallocate(kp)
      if (allocated(tt_data)) deallocate(tt_data)
      if (allocated(tg_data)) deallocate(tg_data)

      allocate(alu(0:km,0:km),kp(0:km))
      allocate(tt_data(0:km,0:km))
      allocate(tg_data(0:km,0:im))

      tt_data = 0.0_DP
      do k=0,km
        tt_data(k,k)=1.0_DP
      end do
      alu = tt_data

      tg_data = ag_at(at_Dx_at(tt_data))
      alu(km-1,:) = tg_data(:,0)
      tg_data = ag_at(tt_data)
      alu(km,:)   = tg_data(:,im)

      call ludecomp(alu,kp)
    end if

    at_data(:,km-1) = value1
    at_data(:,km)   = value2
    at_data = lusolve(alu,kp,at_data)

  end subroutine at_BoundariesTau_ND_2d

  !----------------------------------------------------------
  !> Neumann/Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
  !> i=0 で勾配の値, i=im で値を与える.
  subroutine at_BoundariesTau_ND_1d(t_data,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), dimension(0:km),intent(inout)       :: t_data
    !> 境界値
    real(DP), dimension(2), intent(in), optional  :: values

    real(DP), dimension(1,0:km)                   :: at_work
    real(DP), dimension(1,2)                      :: vwork

    if ( present(values)) then
      vwork(1,:) = values
    else
      vwork(1,1)=0.0_DP
      vwork(1,2)=0.0_DP
    end if

    at_work(1,:)=t_data
    call at_BoundariesTau_ND_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesTau_ND_1d

  !----------------------------------------------------------
  !> Neumann/Dirichlet 型境界条件の適用(タウ法, 2 次元配列用)
  !> 両境界で勾配の値を与える.
  subroutine at_BoundariesTau_NN_2d(at_data,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), dimension(:,0:),intent(inout)         :: at_data
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP), dimension(:,:), allocatable  :: alu
    integer, dimension(:), allocatable     :: kp
    real(DP), allocatable, dimension(:,:)  :: tt_data(:,:)
    real(DP), allocatable, dimension(:,:)  :: tg_data(:,:)
    real(DP), allocatable, dimension(:)    :: value1, value2  ! 境界値
    integer(8) :: k, nm
    save       :: alu, kp, tt_data, tg_data

    nm = size(at_data,1)
    allocate(value1(nm),value2(nm))

    if ( size(at_data,2)-1 < km ) then
      call MessageNotify('E','at_BoundariesTau_NN', &
        'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
      call MessageNotify('W','at_BoundariesTau_NN', &
        'The Chebyshev dimension of input data too large.')
    end if

    if (present(values)) then
      value1 = values(:,1)
      value2 = values(:,2)
    else
      value1 = 0.0_DP
      value2 = 0.0_DP
    end if

    if ( at_BoundariesTau_NN_first ) then
      at_BoundariesTau_NN_first = .false.

      if (allocated(alu)) deallocate(alu)
      if (allocated(kp)) deallocate(kp)
      if (allocated(tt_data)) deallocate(tt_data)
      if (allocated(tg_data)) deallocate(tg_data)

      allocate(alu(0:km,0:km),kp(0:km))
      allocate(tt_data(0:km,0:km))
      allocate(tg_data(0:km,0:im))

      tt_data = 0.0_DP
      do k=0,km
        tt_data(k,k)=1.0_DP
      end do
      alu = tt_data

      tg_data = ag_at(at_Dx_at(tt_data))
      alu(km-1,:) = tg_data(:,0)
      alu(km,:)   = tg_data(:,im)

      call ludecomp(alu,kp)
    end if

    at_data(:,km-1) = value1
    at_data(:,km)   = value2
    at_data = lusolve(alu,kp,at_data)

  end subroutine at_BoundariesTau_NN_2d

  !----------------------------------------------------------
  !> Neumann/Dirichlet 型境界条件の適用(タウ法, 1 次元配列用)
  !> 両境界で勾配の値を与える.
  subroutine at_BoundariesTau_NN_1d(t_data,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), dimension(0:km),intent(inout)       :: t_data
    !> 境界値
    real(DP), dimension(2), intent(in), optional  :: values

    real(DP), dimension(1,0:km)                   :: at_work
    real(DP), dimension(1,2)                      :: vwork

    if (present(values)) then
      vwork(1,:) = values
    else
      vwork(1,1)=0.0_DP
      vwork(1,2)=0.0_DP
    end if

    at_work(1,:)=t_data
    call at_BoundariesTau_NN_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesTau_NN_1d

  !----------------------------------------------------------
  !> Dirichlet 型境界条件の適用(実空間での評価, 2 次元配列用)
  !> 両境界での値を与える.
  subroutine at_BoundariesGrid_DD_2d(at_data,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), dimension(:,0:),intent(inout)         :: at_data
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP), dimension(:,:), allocatable     :: alu
    integer, dimension(:), allocatable        :: kp
    real(DP), dimension(:,:),allocatable      :: ag_data
    real(DP), allocatable, dimension(:,:)     :: tt_data
    real(DP), allocatable, dimension(:,:)     :: tg_data
    real(DP), allocatable, dimension(:)       :: value1, value2  ! 境界値
    integer(8) :: k, nm
    save       :: alu, kp, tt_data, tg_data

    nm = size(at_data,1)
    allocate(value1(nm),value2(nm),ag_data(nm,0:im))


    if ( im /= km ) then
      call MessageNotify('E','at_BoundariesGrid_DD', &
        'Chebyshev truncation and number of grid points should be same.')
    end if

    if ( size(at_data,2)-1 < km ) then
      call MessageNotify('E','at_BoundariesGrid_DD', &
        'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
      call MessageNotify('W','at_BoundariesGrid_DD', &
        'The Chebyshev dimension of input data too large.')
    end if

    if (present(values)) then
      value1 = values(:,1)
      value2 = values(:,2)
    else
      value1 = 0.0_DP
      value2 = 0.0_DP
    end if

    if ( at_BoundariesGrid_DD_first ) then
      at_BoundariesGrid_DD_first = .false.

      if (allocated(alu)) deallocate(alu)
      if (allocated(kp)) deallocate(kp)
      if (allocated(tt_data)) deallocate(tt_data)
      if (allocated(tg_data)) deallocate(tg_data)

      allocate(alu(0:im,0:km),kp(0:im))
      allocate(tt_data(0:km,0:km))
      allocate(tg_data(0:km,0:im))

      tt_data = 0.0_DP
      do k=0,km
        tt_data(k,k)=1.0_DP
      end do
      tg_data = ag_at(tt_data)
      alu = transpose(tg_data)
      call ludecomp(alu,kp)
    end if

    ag_data = ag_at(at_data)
    ag_data(:,0)  = value1
    ag_data(:,im) = value2
    at_data = lusolve(alu,kp,ag_data)

  end subroutine at_BoundariesGrid_DD_2d

  !----------------------------------------------------------
  !> Dirichlet 型境界条件の適用(実空間での評価, 1 次元配列用)
  !> 両境界での値を与える.
  subroutine at_BoundariesGrid_DD_1d(t_data,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), dimension(0:km),intent(inout)       :: t_data
    !> 境界値
    real(DP), dimension(2), intent(in), optional  :: values

    real(DP), dimension(1,0:km)                   :: at_work
    real(DP), dimension(1,2)                      :: vwork           ! 境界値

    if (present(values)) then
      vwork(1,:) = values
    else
      vwork(1,1) = 0.0_DP
      vwork(1,2) = 0.0_DP
    end if

    at_work(1,:)=t_data
    call at_BoundariesGrid_DD_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesGrid_DD_1d

  !----------------------------------------------------------
  !> Dirichlet/Neumann 型境界条件の適用(実空間での評価, 2 次元配列用)
  !> i=0 で値, i=im で勾配の値を与える.
  subroutine at_BoundariesGrid_DN_2d(at_data,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), dimension(:,0:),intent(inout)         :: at_data
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP), dimension(:,:), allocatable     :: alu
    integer, dimension(:), allocatable        :: kp
    real(DP), dimension(:,:),allocatable      :: ag_data
    real(DP), allocatable, dimension(:,:)     :: tt_data
    real(DP), allocatable, dimension(:,:)     :: tg_data
    real(DP), allocatable, dimension(:)       :: value1, value2  ! 境界値

    integer(8) :: k, nm
    save       :: alu, kp, tt_data, tg_data

    nm = size(at_data,1)
    allocate(value1(nm),value2(nm),ag_data(nm,0:im))

    if ( im /= km ) then
      call MessageNotify('E','at_BoundariesGrid_DN', &
        'Chebyshev truncation and number of grid points should be same.')
    end if

    if ( size(at_data,2)-1 < km ) then
      call MessageNotify('E','at_BoundariesGrid_DN', &
        'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
      call MessageNotify('W','at_BoundariesGrid_DN', &
        'The Chebyshev dimension of input data too large.')
    end if

    if (.not. present(values)) then
      value1=0.0_DP
      value2=0.0_DP
    else
      value1 = values(:,1)
      value2 = values(:,2)
    end if

    if ( at_BoundariesGrid_DN_first ) then
      at_BoundariesGrid_DN_first = .false.

      if (allocated(alu)) deallocate(alu)
      if (allocated(kp)) deallocate(kp)
      if (allocated(tt_data)) deallocate(tt_data)
      if (allocated(tg_data)) deallocate(tg_data)

      allocate(alu(0:im,0:km),kp(0:im))
      allocate(tt_data(0:km,0:km))
      allocate(tg_data(0:km,0:im))

      tt_data = 0.0_DP
      do k=0,km
        tt_data(k,k)=1.0_DP
      end do
      tg_data = ag_at(tt_data)
      alu = transpose(tg_data)

      tg_data = ag_at(at_dx_at(tt_data))
      alu(im,:) = tg_data(:,im)

      call ludecomp(alu,kp)
    end if

    ag_data = ag_at(at_data)
    ag_data(:,0)  = value1
    ag_data(:,im) = value2
    at_data = lusolve(alu,kp,ag_data)

  end subroutine at_BoundariesGrid_DN_2d

  !----------------------------------------------------------------------
  !> Dirichlet/Neumann 型境界条件の適用(実空間での評価, 1 次元配列用)
  !> i=0 で値, i=im で勾配の値を与える.
  subroutine at_BoundariesGrid_DN_1d(t_data,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), dimension(0:km),intent(inout)       :: t_data
    !> 境界値
    real(DP), dimension(2), intent(in), optional  :: values

    real(DP), dimension(1,0:km)                   :: at_work
    real(DP), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
      vwork(1,1)=0.0_DP
      vwork(1,2)=0.0_DP
    else
      vwork(1,:) = values
    end if

    at_work(1,:)=t_data
    call at_BoundariesGrid_DN_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesGrid_DN_1d

  !----------------------------------------------------------------------
  !> Neumann/Dirichlet 型境界条件の適用(実空間での評価, 2 次元配列用)
  !> i=0 で勾配の値, i=im で値を与える.
  !----------------------------------------------------------------------
  subroutine at_BoundariesGrid_ND_2d(at_data,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), dimension(:,0:),intent(inout)         :: at_data
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values

    real(DP), dimension(:,:), allocatable     :: alu
    integer, dimension(:), allocatable        :: kp
    real(DP), dimension(:,:),allocatable      :: ag_data
    real(DP), allocatable, dimension(:,:)     :: tt_data
    real(DP), allocatable, dimension(:,:)     :: tg_data
    real(DP), allocatable, dimension(:)       :: value1, value2  ! 境界値

    integer(8) :: k, nm
    save       :: alu, kp, tt_data, tg_data

    nm = size(at_data,1)
    allocate(value1(nm),value2(nm),ag_data(nm,0:im))

    if ( im /= km ) then
      call MessageNotify('E','at_BoundariesGrid_ND', &
        'Chebyshev truncation and number of grid points should be same.')
    end if

    if ( size(at_data,2)-1 < km ) then
      call MessageNotify('E','at_BoundariesGrid_ND', &
        'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
      call MessageNotify('W','at_BoundariesGrid_DD', &
        'The Chebyshev dimension of input data too large.')
    end if

    if (.not. present(values)) then
      value1=0.0_DP
      value2=0.0_DP
    else
      value1 = values(:,1)
      value2 = values(:,2)
    end if

    if ( at_BoundariesGrid_ND_first ) then
      at_BoundariesGrid_ND_first = .false.

      if (allocated(alu)) deallocate(alu)
      if (allocated(kp)) deallocate(kp)
      if (allocated(tt_data)) deallocate(tt_data)
      if (allocated(tg_data)) deallocate(tg_data)

      allocate(alu(0:im,0:km),kp(0:im))
      allocate(tt_data(0:km,0:km))
      allocate(tg_data(0:km,0:im))

      tt_data = 0.0_DP
      do k=0,km
        tt_data(k,k)=1.0_DP
      end do
      tg_data = ag_at(tt_data)
      alu = transpose(tg_data)

      tg_data = ag_at(at_dx_at(tt_data))
      alu(0,:)  = tg_data(:,0)

      call ludecomp(alu,kp)
    end if

    ag_data = ag_at(at_data)
    ag_data(:,0)  = value1
    ag_data(:,im) = value2
    at_data = lusolve(alu,kp,ag_data)

  end subroutine at_BoundariesGrid_ND_2d

  !----------------------------------------------------------------------
  !> Neumann 型境界条件の適用(実空間での評価, 1 次元配列用)
  !> i=0 で勾配の値, i=im で値を与える.
  !----------------------------------------------------------------------
  subroutine at_BoundariesGrid_ND_1d(t_data,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), dimension(0:km),intent(inout)       :: t_data
    !> 境界値
    real(DP), dimension(2), intent(in), optional  :: values

    real(DP), dimension(1,0:km)                   :: at_work
    real(DP), dimension(1,2)                      :: vwork           ! 境界値

    if (.not. present(values)) then
      vwork(1,1)=0.0_DP
      vwork(1,2)=0.0_DP
    else
      vwork(1,:) = values
    end if

    at_work(1,:)=t_data
    call at_BoundariesGrid_ND_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesGrid_ND_1d

  !----------------------------------------------------------------------
  !> Neumann 型境界条件の適用(実空間での評価, 2 次元配列用)
  !> 両境界で勾配の値を与える.
  !----------------------------------------------------------------------
  subroutine at_BoundariesGrid_NN_2d(at_data,values)
    !> 境界条件を適用するチェビシェフデータ(m,0:km)
    real(DP), dimension(:,0:),intent(inout)         :: at_data
    !> 境界値(m,2)
    real(DP), dimension(:,:), intent(in), optional  :: values


    real(DP), dimension(:,:), allocatable     :: alu
    integer,  dimension(:), allocatable       :: kp
    real(DP), dimension(:,:),allocatable      :: ag_data
    real(DP), allocatable, dimension(:,:)     :: tt_data
    real(DP), allocatable, dimension(:,:)     :: tg_data
    real(DP), allocatable, dimension(:)       :: value1, value2  ! 境界値

    integer(8) :: k, nm
    save       :: alu, kp, tt_data, tg_data

    nm = size(at_data,1)
    allocate(value1(nm),value2(nm),ag_data(nm,0:im))

    if ( im /= km ) then
      call MessageNotify('E','at_BoundariesGrid_NN', &
        'Chebyshev truncation and number of grid points should be same.')
    end if

    if ( size(at_data,2)-1 < km ) then
      call MessageNotify('E','at_BoundariesGrid_NN', &
        'The Chebyshev dimension of input data too small.')
    elseif ( size(at_data,2)-1 > km ) then
      call MessageNotify('W','at_BoundariesGrid_NN', &
        'The Chebyshev dimension of input data too large.')
    end if

    if (.not. present(values)) then
      value1=0.0_DP
      value2=0.0_DP
    else
      value1 = values(:,1)
      value2 = values(:,2)
    end if

    if ( at_BoundariesGrid_NN_first ) then
      at_BoundariesGrid_NN_first = .false.

      if (allocated(tt_data)) deallocate(tt_data)
      if (allocated(tg_data)) deallocate(tg_data)

      allocate(alu(0:im,0:km),kp(0:im))
      allocate(tt_data(0:km,0:km))
      allocate(tg_data(0:km,0:im))

      tt_data = 0.0_DP
      do k=0,km
        tt_data(k,k)=1.0_DP
      end do
      tg_data = ag_at(tt_data)
      alu = transpose(tg_data)

      tg_data = ag_at(at_dx_at(tt_data))
      alu(0,:)  = tg_data(:,0)
      alu(im,:) = tg_data(:,im)

      call ludecomp(alu,kp)
    end if

    ag_data = ag_at(at_data)
    ag_data(:,0)  = value1
    ag_data(:,im) = value2
    at_data = lusolve(alu,kp,ag_data)

  end subroutine at_BoundariesGrid_NN_2d

  !----------------------------------------------------------------------
  !> Neumann 型境界条件の適用(実空間での評価, 1 次元配列用)
  !> 両境界で勾配の値を与える.
  !----------------------------------------------------------------------
  subroutine at_BoundariesGrid_NN_1d(t_data,values)
    !> 境界条件を適用するチェビシェフデータ(0:km)
    real(DP), dimension(0:km),intent(inout)       :: t_data
    !> 境界値
    real(DP), dimension(2), intent(in), optional  :: values
    real(DP), dimension(1,0:km)                   :: at_work
    real(DP), dimension(1,2)                      :: vwork  ! 境界値

    if (.not. present(values)) then
      vwork(1,1)=0.0_DP
      vwork(1,2)=0.0_DP
    else
      vwork(1,:) = values
    end if

    at_work(1,:)=t_data
    call at_BoundariesGrid_NN_2d(at_work,vwork)
    t_data=at_work(1,:)

  end subroutine at_BoundariesGrid_NN_1d

end module at_module

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXINM1(MM,NM,IM,IT,T,R,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NM,IM,IE,MI,K,M
  INTEGER(8) :: N1,M1,MN
  INTEGER(8) :: IT(IM/2)  
  REAL(8) :: T(IM*3/2)
  REAL(8) :: R(5*(MM/MI+1)*(2*NM-MM/MI*MI)/4+MM/MI+1)
  INTEGER(8) :: NPMAX  

  CALL FXRINI(IM,IT,T)    
  CALL LXINIR(NM,0_8,R)

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  CALL MXGOMP(NPMAX)  

  !$omp parallel private(K,M,IE) num_threads(NPMAX)
  !$omp do schedule(dynamic) 
  DO K=0,MN-1
     IE=5*K*(2*NM-MI*(K-1))/4+K+1 ! サイズを変えたのでこうなる
     M=K*MI
     CALL LXINIR(NM,M,R(IE))       
  END DO
!$omp end do
!$omp end parallel  

END SUBROUTINE SXINM1

!----------------------------------------------------------------------
!     Copyright (c) 2008-2025 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  aq_module テストプログラム
!      1 次元境界値問題
!
!履歴  2008/04/02  竹広真一
!      2009/07/24  佐々木洋平 dc_test を使用するように修正
!      2025/12/22  竹広真一 spml2 版対応
!
program aq_test_boundary_tau_1d

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use aq_module
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=16, km=10       ! 格子点数, 切断波数
  real(8), parameter :: ra=2               ! 領域の大きさ

 !---- 座標変数など ----
  real(8), parameter :: alpha=0.5D0        ! 展開多項式パラメター  0 < α <= 1
  real(8), parameter :: beta= 1.0D0        ! 展開多項式パラメター  0 < β
!  real(8), parameter :: gamma=2*alpha+beta ! 展開多項式パラメター 

  real(8), parameter :: amin=2.0D0

  real(8), dimension(im)   :: g_a
  real(8), dimension(im)   :: g_dadx
  real(8), dimension(0:km) :: q_a
  real(8)                  :: value=amin

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call aq_Initial(im,km,ra,alpha,beta,(/0/))

  g_a = (g_R-ra)**2.0D0 + 1.0D0
  q_a = q_g(g_a)

!----- aq_BoundaryTau_D ------
  call MessageNotify('M', 'aq_test_boundary_tau_1d', &
       'aq_module boundary test(1d)')
  call aq_BoundaryTau_D(q_a,value)
  g_a = g_q(q_a)
  call AssertEqual(&
    message='ag_BoundaryTau_D',                                 &
    answer = amin,                                              &
    check  = g_a(im),                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

!----- aq_BoundaryTau_N ------
  call aq_BoundaryTau_N(q_a,value)
  g_dadx = g_q(q_rDr_q(q_a))/g_R
  call AssertEqual(&
    message='ag_BoundaryTau_D',                                 &
    answer = amin,                                              &
    check  = g_dadx(im),                                        &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M', 'aq_test_boundary_tau_1d', &
       'aq_module boundary test(1d) succeeded')

end program aq_test_boundary_tau_1d

!------------------------------------------------------------------------
! Copyright (c) 2005-2019 SPMODEL Development Group. All rights reserved.
!------------------------------------------------------------------------
!
!表題  eigmatrix テストプログラム
!
!履歴  2005/01/26  竹広真一
!      2007/11/02  竹広真一  メッセージ, 正誤判定追加
!      2008/12/05  佐々木洋平. 文字列 sort の長さを 2 に
!      2011/02/18  佐々木洋平 dc_test を使用するように修正
!      2019/10/10  佐々木洋平 モジュール名変更
!      2022/10/27  竹広真一 倍精度用テスト
!
program eigmatrix_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use dc_types, only: DP
  use spml_utils, only: eigen
  implicit none

  real(DP), dimension(:,:), allocatable  :: amatrix
  real(DP), dimension(:),   allocatable  :: eigval_r, eigval_i
  real(DP), dimension(:,:), allocatable  :: eigvec_r, eigvec_i

  real(DP), dimension(:),   allocatable          :: eigval_r_sol, eigval_i_sol
  real(DP), dimension(:,:), allocatable          :: eigvec_r_sol, eigvec_i_sol
  complex(kind(0d0)), dimension(:),allocatable  :: cwork
  real(DP),dimension(:), allocatable             :: rwork
  integer                     :: info
  real(DP)            :: error
  integer                     :: i
  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  call MessageNotify('M','eigen_test(double)','Test of eigmatrix')

!--------------- 3x3 行列 ------------------
!  VALUE = 1, 2, 3
!  VECTOR = (-15,12,4), (-16,13,4), (-4,3,1)

  allocate(amatrix(3,3))
  allocate(eigval_r(3), eigval_i(3))
  allocate(eigvec_r(3,3), eigvec_i(3,3))

  allocate(eigval_r_sol(3), eigval_i_sol(3))
  allocate(eigvec_r_sol(3,3), eigvec_i_sol(3,3))

  !---- 行列 ----
  amatrix(:,1) = (/ 33.0d0, -24.0d0,  -8.0d0 /)
  amatrix(:,2) = (/ 16.0d0, -10.0d0,  -4.0d0 /)
  amatrix(:,3) = (/ 72.0d0, -57.0d0, -17.0d0 /)

  !---- 正解 ----
  eigval_r_sol = (/3.0D0,2.0D0,1.0D0/)
  eigval_i_sol = (/0.0D0,0.0D0,0.0D0/)

  eigvec_r_sol(:,1) = (/-4.0D0,3.0D0,1.0D0/)
  eigvec_r_sol(:,2) = (/-16.0D0,13.0D0,4.0D0/)
  eigvec_r_sol(:,3) = (/-15.0D0,12.0D0,4.0D0/)

  eigvec_i_sol = 0.0D0

  !---- 固有値計算 ----
  call eigen(amatrix,eigval_r,eigval_i,eigvec_r,eigvec_i,info,&
    sort=' R',reverse=.true.)
  do i=1,3
     eigvec_r(:,i) = eigvec_r(:,i)/eigvec_r(1,i)
     eigvec_r_sol(:,i) = eigvec_r_sol(:,i)/eigvec_r_sol(1,i)
  enddo

  !---- 判定 ----
  call AssertEqual(                                           &
    message= '3x3 arrray eigenvalue(real part)',              &
    answer = eigval_r_sol,                                    &
    check = eigval_r,                                         &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '3x3 arrray eigenvalue(imaginary part)',              &
    answer = eigval_i_sol,                                    &
    check = eigval_i,                                         &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '3x3 arrray eigenvector(real part)',              &
    answer = eigvec_r_sol,                                    &
    check = eigvec_r,                                         &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '3x3 arrray eigenvector(imaginary part)',              &
    answer = eigvec_i_sol,                                    &
    check = eigvec_i,                                         &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call MessageNotify('M','Test of eigmatrix','Test of 3x3 array succeeded!')

  deallocate(amatrix)
  deallocate(eigval_r, eigval_i)
  deallocate(eigvec_r, eigvec_i)
  deallocate(eigval_r_sol, eigval_i_sol)
  deallocate(eigvec_r_sol, eigvec_i_sol)

!--------------- 4x4 行列 ------------------
!  VALUE = 12, 1+5I, 1-5i, 2
!  VECTOR = (1,-1,1,1), (1,i,i,-1), (1,-i,-i,-1), (1,1,-1,1)

  allocate(amatrix(4,4))
  allocate(eigval_r(4), eigval_i(4))
  allocate(eigvec_r(4,4), eigvec_i(4,4))
  allocate(eigval_r_sol(4), eigval_i_sol(4))
  allocate(eigvec_r_sol(4,4), eigvec_i_sol(4,4))
  allocate(cwork(4),rwork(4))

  !---- 行列 ----
  amatrix(:,1) = (/  4.0d0,  0.0d0,  5.0d0,  3.0d0 /)
  amatrix(:,2) = (/ -5.0d0,  4.0d0, -3.0d0,  0.0d0 /)
  amatrix(:,3) = (/  0.0d0, -3.0d0,  4.0d0,  5.0d0 /)
  amatrix(:,4) = (/  3.0d0, -5.0d0,  0.0d0,  4.0d0 /)

  !---- 正解 ----
  eigval_r_sol = (/ 1.0D0,1.0D0,2.0D0,12.0D0/)
  eigval_i_sol = (/-5.0D0,5.0D0,0.0D0, 0.0D0/)

  eigvec_r_sol(:,1) = (/1.0D0, 0.0D0, 0.0D0,-1.0D0/)
  eigvec_i_sol(:,1) = (/0.0D0,-1.0D0,-1.0D0, 0.0D0/)

  eigvec_r_sol(:,2) = (/1.0D0, 0.0D0, 0.0D0,-1.0D0/)
  eigvec_i_sol(:,2) = (/0.0D0, 1.0D0, 1.0D0, 0.0D0/)

  eigvec_r_sol(:,3) = (/1.0D0, 1.0D0,-1.0D0, 1.0D0/)
  eigvec_i_sol(:,3) = (/0.0D0, 0.0D0, 0.0D0, 0.0D0/)

  eigvec_r_sol(:,4) = (/1.0D0,-1.0D0, 1.0D0, 1.0D0/)
  eigvec_i_sol(:,4) = (/0.0D0, 0.0D0, 0.0D0, 0.0D0/)

  !---- 固有値計算 ----
  call eigen(amatrix,eigval_r,eigval_i,eigvec_r,eigvec_i,info,&
            sort='RA')

  do i=4,1,-1
     cwork = (eigvec_r(i,:)+(0,1)*eigvec_i(i,:))&
          /(eigvec_r(1,:)+(0,1)*eigvec_i(1,:))
     eigvec_r(i,:) = real(cwork)
     eigvec_i(i,:) = aimag(cwork)
  enddo

  !---- 判定 ----
  if (eigval_i(1) > 0.0 ) then
     error = eigval_r_sol(1)
     eigval_r_sol(1) = eigval_r_sol(2)
     eigval_r_sol(2) = error

     error = eigval_i_sol(1)
     eigval_i_sol(1) = eigval_i_sol(2)
     eigval_i_sol(2) = error

     do i=1,4
        rwork = eigvec_r_sol(:,1)
        eigvec_r_sol(:,1) = eigvec_r_sol(:,2)
        eigvec_r_sol(:,2) = rwork
        rwork = eigvec_i_sol(:,1)
        eigvec_i_sol(:,1) = eigvec_i_sol(:,2)
        eigvec_i_sol(:,2) = rwork
     end do
  end if
  !---- 判定 ----
  call AssertEqual(                                           &
    message= '4x4 arrray eigenvalue(real part)',              &
    answer = eigval_r_sol,                                    &
    check = eigval_r,                                         &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '4x4 arrray eigenvalue(imaginary part)',              &
    answer = eigval_i_sol,                                    &
    check = eigval_i,                                         &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '4x4 arrray eigenvector(real part)',              &
    answer = eigvec_r_sol,                                    &
    check = eigvec_r,                                         &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call AssertEqual(                                           &
    message= '4x4 arrray eigenvector(imaginary part)',              &
    answer = eigvec_i_sol,                                    &
    check = eigvec_i,                                         &
    significant_digits = check_digits, ignore_digits = ignore &
    )

  call MessageNotify('M','Test of eigmatrix(double)','Test of 4x4 array succeeded!')


end program eigmatrix_test

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_integral_mpi_module テストプログラム :: 積分・平均関数のテスト
!
!履歴  2019/03/19  竹広真一
!      2020/11/09  竹広真一 セクター計算テスト
!
program w_mpi_module_integral_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_mpi_module_mint
  use mpi
  implicit none

!!$  integer, parameter :: im=128, jm=64, nm=42, mint=1
  integer, parameter :: im=64, jm=64, nm=42, mint=2

  real(8), dimension(0:im-1)    ::  x_idata            ! 積分・平均の正解
  real(8)                       ::  idata              ! 積分・平均の正解

  real(8), allocatable          ::  xv_data(:,:)       ! 元の関数
  real(8), allocatable          ::  v_idata(:)         ! 積分・平均の正解

  real(8) :: pi
  integer :: iproc, np, ierr

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','w_mpi_module_integral_mint_test', &
                         'w_mpi_module_mint integral function tests')

  call w_mpi_Initial( nm, im, jm, mint=mint )

  allocate(xv_data(0:im-1,jc))
  allocate(v_idata(jc))

!!$  !---- 積分のテスト(全領域) ----
!!$  xy_data = sin(xy_Lat)**2*(1-cos(xy_Lon)**2)
!!$
!!$  idata = 2*pi/3       ! IntLonLat_xy
!!$  call AssertEqual(&
!!$    message='IntLonLat_xy',                                       &
!!$    answer = idata,                                               &
!!$    check = IntLonLat_xy(xy_data),                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  y_idata = pi*sin(y_Lat)**2       ! y_IntLon_xy
!!$  call AssertEqual(&
!!$    message='y_IntLon_xy',                                        &
!!$    answer = y_idata,                                             &
!!$    check = y_IntLon_xy(xy_data),                                 &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  x_idata = 2.0D0/3*(1-cos(x_Lon)**2)       ! x_IntLat_xy
!!$  call AssertEqual(&
!!$    message='x_IntLat_xy',                                        &
!!$    answer = x_idata,                                             &
!!$    check = x_IntLat_xy(xy_data),                                 &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call AssertEqual(&
!!$    message='IntLon_x',                                           &
!!$    answer = idata,                                               &
!!$    check = IntLon_x(x_idata),                                    &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call AssertEqual(&
!!$    message='IntLat_y',                                           &
!!$    answer = idata,                                               &
!!$    check = IntLat_y(y_idata),                                    &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  !---- 平均のテスト(全領域) ----
!!$  xy_data = sin(xy_Lat)**2*(1-cos(xy_Lon)**2)
!!$
!!$  idata = 1.0D0/6       ! AvrLonLat_xy
!!$  call AssertEqual(&
!!$    message='AvrLonLat_xy',                                       &
!!$    answer = idata,                                               &
!!$    check = AvrLonLat_xy(xy_data),                                &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  y_idata = 0.5*sin(y_Lat)**2       ! y_AvrLon_xy
!!$  call AssertEqual(&
!!$    message='y_AvrLon_xy',                                        &
!!$    answer = y_idata,                                             &
!!$    check = y_AvrLon_xy(xy_data),                                 &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  x_idata = 1.0D0/3*(1-cos(x_Lon)**2)       ! x_AvrLat_xy
!!$
!!$  call AssertEqual(&
!!$    message='x_AvrLat_xy',                                        &
!!$    answer = x_idata,                                             &
!!$    check = x_AvrLat_xy(xy_data),                                 &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call AssertEqual(&
!!$    message='AvrLon_x',                                           &
!!$    answer = idata,                                               &
!!$    check = AvrLon_x(x_idata),                                    &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )
!!$
!!$  call AssertEqual(&
!!$    message='AvrLat_y',                                           &
!!$    answer = idata,                                               &
!!$    check = AvrLat_y(y_idata),                                    &
!!$    significant_digits = check_digits, ignore_digits = ignore     &
!!$    )

  !---- 積分のテスト(分割領域) ----
  xv_data = sin(xv_Lat)**2*(1-cos(xv_Lon)**2)

  idata = 2*pi/3/mint       ! IntLonLat_xv
  call AssertEqual(&
    message='IntLonLat_xv',                                       &
    answer = idata,                                               &
    check = IntLonLat_xv(xv_data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_idata = pi*sin(v_Lat)**2/mint       ! y_IntLon_xv
  call AssertEqual(&
    message='v_IntLon_xv',                                        &
    answer = v_idata,                                             &
    check = v_IntLon_xv(xv_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_idata = 2.0D0/3*(1-cos(x_Lon)**2)       ! x_IntLat_xv
  call AssertEqual(&
    message='x_IntLat_xv',                                        &
    answer = x_idata,                                             &
    check = x_IntLat_xv(xv_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='IntLon_x',                                           &
    answer = idata,                                               &
    check = IntLon_x(x_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='IntLat_v',                                           &
    answer = idata,                                               &
    check = IntLat_v(v_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト(分割領域) ----
  xv_data = sin(xv_Lat)**2*(1-cos(xv_Lon)**2)

  idata = 1.0D0/6       ! AvrLonLat_xy
  call AssertEqual(&
    message='AvrLonLat_xv',                                       &
    answer = idata,                                               &
    check = AvrLonLat_xv(xv_data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_idata = 0.5*sin(v_Lat)**2       ! y_AvrLon_xy
  call AssertEqual(&
    message='v_AvrLon_xv',                                        &
    answer = v_idata,                                             &
    check = v_AvrLon_xv(xv_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_idata = 1.0D0/3*(1-cos(x_Lon)**2)       ! x_AvrLat_xv
  call AssertEqual(&
    message='x_AvrLat_xv',                                        &
    answer = x_idata,                                             &
    check = x_AvrLat_xv(xv_data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='AvrLon_x',                                           &
    answer = idata,                                               &
    check = AvrLon_x(x_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='AvrLat_v',                                           &
    answer = idata,                                               &
    check = AvrLat_v(v_idata),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','w_mpi_module_integral_mint_test', &
                         'w_mpi_module_mint integral function tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program w_mpi_module_integral_mint_test

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXCLAM(MM,NT,S,SL,D,IFLAG,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NT,L,IFLAG,MI
  REAL(8) :: S((MM/MI+1)*(2*(NT+1)-MM/MI*MI))
  REAL(8) :: SL((MM/MI+1)*(2*(NT+1)-MM/MI*MI))
  REAL(8) :: D((MM/MI+1)*(2*(NT+1)-MM/MI*MI),2)
  INTEGER(8) :: NPMAX

  CALL MXGOMP(NPMAX)  

  !$omp parallel do num_threads(NPMAX)
  DO L=1,(MM/MI+1)*(2*(NT+1)-MM/MI*MI)
     SL(L)=D(L,IFLAG)*S(L)
  END DO
  !$omp end parallel do

END SUBROUTINE SXCLAM

!----------------------------------------------------------------------
!     Copyright (c) 2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_interpolate_module テストプログラム :: 補間関数のテスト
!
!履歴  2020/08/04  竹広真一
!
program ua_interpol_mpi_module

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module
  use mpi
  implicit none

  integer, parameter :: im=32, jm=16, nm=10, km=3, npv=2

  real(8), allocatable :: pva_data(:,:,:)
  real(8), allocatable :: ua_data(:,:)
  real(8), allocatable :: wb_data(:,:)
  real(8), allocatable :: b_data_sol(:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call ua_mpi_Initial( nm, im, jm, km, npv=npv )

  call MessageNotify('M','ua_Interpolate00_mpi_module_test', &
                         'ua_interpolate_module interpolate (00) tests')

  allocate(pva_data(ic,jc,km))
  allocate(ua_data(nmc,km))
  allocate(wb_data(nc,kc))
  allocate(b_data_sol(kc))

  !---- Y_1^* のテスト ----
  pva_data(:,:,1) = sqrt(3.0D0)*sin(pv_Lat)                ! Y_1^0
  pva_data(:,:,2) = sqrt(3.0D0/2)*cos(pv_Lat)*cos(pv_Lon)  ! Y_1^1
  pva_data(:,:,3) = -sqrt(3.0D0)*cos(pv_Lat)*sin(pv_Lon)   ! Y_1^{-1}

  if ( kp_kl(1) /= 0 ) b_data_sol(kp_kl(1)) = sqrt(3.0D0)*sin(ALat)
  if ( kp_kl(2) /= 0 ) b_data_sol(kp_kl(2)) = sqrt(3.0D0/2)*cos(ALat)*cos(ALon)
  if ( kp_kl(3) /= 0 ) b_data_sol(kp_kl(3)) = -sqrt(3.0D0)*cos(ALat)*sin(ALon)

  ua_data = ua_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_ua with Y_1^*',                        &
    answer = b_Interpolate_ua(ua_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  wb_data = wb_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_wb with Y_1^*',                        &
    answer = b_Interpolate_wb(wb_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^* のテスト ----
  pva_data(:,:,1) = sqrt(5.0D0)*(3.0/2*sin(pv_Lat)**2-1/2.0)    !Y_2^0
  pva_data(:,:,2) = sqrt(5.0D0/6)*3.0*sin(pv_Lat)*cos(pv_Lat) * cos(pv_Lon)!Y_2^1
  pva_data(:,:,3) = -sqrt(5.0D0/24)*3.0*cos(pv_Lat)**2*sin(2*pv_Lon)    ! Y_2^-2

  if ( kp_kl(1) /= 0 ) b_data_sol(kp_kl(1)) = sqrt(5.0D0)*(3.0/2*sin(alat)**2-1.0/2)
  if ( kp_kl(2) /= 0 ) b_data_sol(kp_kl(2)) = sqrt(5.0D0/6)*3.0*sin(ALat)*cos(ALat) * cos(ALon)
  if ( kp_kl(3) /= 0 ) b_data_sol(kp_kl(3)) = -sqrt(5.0D0/24)*3.0*cos(ALat)**2*sin(2*ALon)

  ua_data = ua_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_ua with Y_2^*',                        &
    answer = b_Interpolate_ua(ua_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  wb_data = wb_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_wb with Y_2^*',                        &
    answer = b_Interpolate_wb(wb_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 一般的な関数のテスト ----
  pva_data(:,:,1) = cos(2*pv_Lon-pi/3) &
          *(sin(pv_Lat)-1)**2*(sin(pv_Lat)-0.5)*(sin(pv_Lat)+1)
  pva_data(:,:,2) = sin(2*pv_Lon-pi/3)*(sin(pv_Lat)-1)**2*(sin(pv_Lat)+1)**2
  pva_data(:,:,3) = sin(2*pv_Lon+pi/3)*(sin(pv_Lat)-1)**3*(sin(pv_Lat)+1)

  if ( kp_kl(1) /= 0 ) b_data_sol(kp_kl(1)) = cos(2*ALon-pi/3) &
       *(sin(ALat)-1)**2*(sin(ALat)-0.5)*(sin(ALat)+1)
  if ( kp_kl(2) /= 0 ) b_data_sol(kp_kl(2)) = sin(2*aLon-pi/3)*(sin(aLat)-1)**2*(sin(aLat)+1)**2
  if ( kp_kl(3) /= 0 ) b_data_sol(kp_kl(3)) = sin(2*aLon+pi/3)*(sin(aLat)-1)**3*(sin(aLat)+1)

  ua_data = ua_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_ua with a general function',           &
    answer = b_Interpolate_ua(ua_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  wb_data = wb_pva(pva_data)
  call AssertEqual(&
    message='b_Interpolate_wb with a general function',           &
    answer = b_Interpolate_wb(wb_data,alon,alat),                 &
    check =  b_data_sol,                                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','ub_Interpolate_mpi_module_test', &
       'ub_interpolate_module interpolate(00) tests succeeded')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_interpol_mpi_module

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXTGMS(MM,NM,NN,IM,JM,S,G,IT,T,P,R,JC,W,IPOW,MI)

  USE ISO_C_BINDING
  IMPLICIT NONE
  INTEGER(8) :: MM,NM,NN,IM,JM,JV,JR,M,IE,IJ,JD,NS,IPOW,MI
  REAL(8) ::  S((MM/MI+1)*(2*(NN+1)-MM/MI*MI)),G(JM*IM)
  REAL(8) :: T(IM*3/2),P(JM/2,5+2*(MM/MI+1)),R(*)
  INTEGER(8) :: IT(IM/2),JC(*)
  REAL(8) :: W(JM*IM)
  TYPE(C_PTR),DIMENSION(:),ALLOCATABLE :: WP(:)
  REAL(8),DIMENSION(:),POINTER:: WORK
  INTEGER(8) :: NPMAX
  INTEGER(8) :: MN,M1,N1,K
  INTEGER :: IP,NP
  LOGICAL,DIMENSION(:),ALLOCATABLE :: LP(:)
  TYPE(C_PTR),DIMENSION(:),ALLOCATABLE :: WSP(:)
  REAL(8),DIMENSION(:),POINTER:: WS(:)

!$    INTEGER :: omp_get_thread_num

  CALL SXGPRM(JM,JV,JR)

  CALL MXGOMP(NPMAX)

  NP=MIN(JM/JV,NPMAX)
  ALLOCATE(WP(0:NP-1))
  ALLOCATE(LP(0:NP-1))
  LP=.FALSE.
  IP=0

!$omp parallel private(IP,WORK) num_threads(NP)
!$omp do schedule(dynamic)
  DO JD=1,JM/JV
!$      IP=omp_get_thread_num()
     IF(.NOT.LP(IP)) THEN
        CALL MXALLC(WP(IP),JV*IM)
        CALL C_F_POINTER(WP(IP),WORK,[JV*IM])
        LP(IP)=.TRUE.
     END IF
     IF(JV.EQ.4) THEN
        CALL SXQTF2(IM,G(1+JV*IM*(JD-1)),WORK)
     ELSE IF(JV.EQ.8) THEN
        CALL SXOTF2(IM,G(1+JV*IM*(JD-1)),WORK)
     ELSE
        CALL SXLTF2(JV,IM,G(1+JV*IM*(JD-1)),WORK)
     END IF
     CALL FXRTFA(JV,IM,WORK,IT,T)
     IF(JV.EQ.4_8.AND.MOD(IM,4_8).EQ.0) THEN
        CALL SXQTF1(JM/JV,MM/MI,IM,WORK,W(1+2*JV*(JD-1)))
     ELSE IF(JV.EQ.8.AND.MOD(IM,8_8).EQ.0) THEN
        CALL SXOTF1(JM/JV,MM/MI,IM,WORK,W(1+2*JV*(JD-1)))
     ELSE
        CALL SXLTF1(JV,JM/JV,MM/MI,IM,WORK,W(1+2*JV*(JD-1)))
     END IF
  END DO
!$omp end do
!$omp end parallel

  DO IP=0,NP-1
     IF(LP(IP)) THEN
        CALL MXFREE(WP(IP))
     END IF
  END DO

  DEALLOCATE(WP)
  DEALLOCATE(LP)

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  NP=MIN(MN+1,NPMAX)
  ALLOCATE(WP(0:NP-1))
  ALLOCATE(WSP(0:NP-1))
  ALLOCATE(LP(0:NP-1))
  LP=.FALSE.
  IP=0

  S=0.0D0
!$omp parallel private(NS,IP,IJ,IE,M,WORK,WS) num_threads(NP)
!$omp do schedule(dynamic)
  DO K=0,MN-1
     !$      IP=omp_get_thread_num()
     IF(.NOT.LP(IP)) THEN
        CALL MXALLC(WP(IP),JV*7*JR)
        CALL C_F_POINTER(WP(IP),WORK,[JV*7*JR])
        CALL MXALLC(WSP(IP),2*(NM+1))
        CALL C_F_POINTER(WSP(IP),WS,[2*(NM+1)])
        LP(IP)=.TRUE.
     END IF
     IE=5*K*(2*NM-MI*(K-1))/4+K+1
     IJ=K*(2*NM-MI*(K-1))/16+K+1
     M=K*MI
     NS=K*(2*(NN+1)-(K-1)*MI)+1
     IF(M.EQ.0) THEN
        CALL LXSGZS(NM,NN,JM,JV,JR,S,W,P,R,WORK,WS,IPOW,0_8)
     ELSE
        CALL LXSGWS(NM,NN,JM,JV,JR,M,S(NS),W(1+M/MI*2*JM),P,P(1,6+K*2), &
             &        R(IE),JC(IJ),WORK,WS,IPOW,0_8)
     END IF

!!$     IF(M.EQ.0) THEN
!!$        CALL LXSGZS(NM,NN,JM,JV,JR,S,W,P,R,WORK,WS,IPOW,0_8)
!!$     ELSE
!!$        NS=1+NN+1+(M-1)*(NN+NN+2-M)
!!$        IE=(M*(2*NM-M)+1)/4*3+M*(2*NM-M+1)/2+M+1
!!$        IJ=(M-1)*(2*NM-M)/16+M
!!$        CALL LXSGWS(NM,NN,JM,JV,JR,M,S(NS),W(1+M/MI*2*JM),P,P(1,4+M*2), &
!!$        &        R(IE),JC(IJ),WORK,WS,IPOW,0_8)
!!$     END IF
  END DO
!$omp end do
!$omp end parallel

  DO IP=0,NP-1
     IF(LP(IP)) THEN
        CALL MXFREE(WP(IP))
        CALL MXFREE(WSP(IP))
     END IF
  END DO

  DEALLOCATE(WSP)
  DEALLOCATE(WP)
  DEALLOCATE(LP)


END SUBROUTINE SXTGMS

!----------------------------------------------------------------------
!     Copyright (c) 2016 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_module テストプログラム (積分・平均計算)
!
!履歴  2016/09/20  竹広真一
!
program tee_mpi_module_integral_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=32, jm=32, km=32       ! 格子点の設定(X,Y)
  integer, parameter :: lm=10, mm=10, nm=21       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: zvx_Data(:,:,:)         ! 格子データ
  real(8), allocatable :: vx_Data(:,:)            ! 格子データ
  real(8), allocatable :: zx_Data(:,:)            ! 格子データ
  real(8), allocatable :: zv_Data(:,:)            ! 格子データ
  real(8), allocatable :: x_Data(:)               ! 格子データ
  real(8), allocatable :: v_Data(:)               ! 格子データ
  real(8), allocatable :: z_Data(:)               ! 格子データ

  real(8), allocatable :: vx_Ans(:,:)             ! 格子データ
  real(8), allocatable :: zv_Ans(:,:)             ! 格子データ
  real(8), allocatable :: zx_Ans(:,:)             ! 格子データ

  real(8), allocatable :: x_Ans(:)                ! 格子データ
  real(8), allocatable :: v_Ans(:)                ! 格子データ
  real(8), allocatable :: z_Ans(:)                ! 格子データ

  real(8)              :: Ans

  integer            :: np, ip, ierr
  
 !---- 座標変数など ----
  real(8), parameter :: xmin = -1.0d0, xmax=1.0d0
  real(8), parameter :: ymin = -1.0d0, ymax=1.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','tee_mpi_module_integral_test', &
       'tee_mpi_module integral and average functions tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
   
 !---------------- 座標値の設定 ---------------------
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Data(0:km,jc(ip),0:im-1))         ! 格子データ
  allocate(vx_Data(jc(ip),0:im-1))               ! 格子データ
  allocate(zx_Data(0:km,0:im-1))                 ! 格子データ
  allocate(zv_Data(0:km,jc(ip)))                 ! 格子データ
  allocate(x_Data(0:im-1))                       ! 格子データ
  allocate(v_Data(jc(ip)))                       ! 格子データ
  allocate(z_Data(0:km))                         ! 格子データ

  allocate(vx_Ans(jc(ip),0:im-1))                ! 格子データ
  allocate(zv_Ans(0:km,jc(ip)))                  ! 格子データ
  allocate(zx_Ans(0:km,0:im-1))                  ! 格子データ

  allocate(x_Ans(0:im-1))                        ! 格子データ
  allocate(v_Ans(jc(ip)))                        ! 格子データ
  allocate(z_Ans(0:km))                          ! 格子データ

 !------------------- 3 次元関数チェック ----------------------
  zvx_Data = sin(pi*zvx_X) * cos(pi*zvx_Y) * cos(pi*zvx_Z)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntZYX_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',      &
    answer = Ans,                                                 &
    check = IntZYX_zvx(zvx_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrZYX_vx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',       &
    answer = Ans,                                                 &
    check = AvrZYX_zvx(zvx_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  vx_Ans = 0.0D0
  call AssertEqual(&
    message='vx_IntZ_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = vx_Ans,                                              &
    check = vx_IntZ_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='vx_AvrZ_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = vx_Ans,                                              &
    check = vx_AvrZ_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zv_Ans = 0.0D0
  call AssertEqual(&
    message='zv_IntX_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = zv_Ans,                                              &
    check = zv_IntX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zv_AvrX_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = zv_Ans,                                              &
    check = zv_AvrX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zx_Ans = 0.0D0
  call AssertEqual(&
    message='zx_IntY_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = zx_Ans,                                              &
    check = zx_IntY_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='zx_AvrY_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = zx_Ans,                                              &
    check = zx_AvrY_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 0.0D0
  call AssertEqual(&
    message='z_IntYX_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = z_Ans,                                               &
    check = z_IntYX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='z_AvrYX_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = z_Ans,                                               &
    check = z_AvrYX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_Ans = 0.0D0
  call AssertEqual(&
    message='v_IntZX_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = v_Ans,                                               &
    check = v_IntZX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='y_AvrZX_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = v_Ans,                                               &
    check = v_AvrZX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 0.0D0
  call AssertEqual(&
    message='x_IntZY_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = x_Ans,                                               &
    check = x_IntZY_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='x_AvrZY_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = x_Ans,                                               &
    check = x_AvrZY_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zvx_Data = (1 - sin(pi*zvx_X)) * cos(pi*zvx_Y)**2 * sin(pi*zvx_Z)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntZYX_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',      &
    answer = Ans,                                                 &
    check = IntZYX_zvx(zvx_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.25D0
  call AssertEqual(&
    message='AvrZYX_vx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',       &
    answer = Ans,                                                 &
    check = AvrZYX_zvx(zvx_Data),                                 &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  vx_Ans = (1 - sin(pi*vx_X)) * cos(pi*vx_Y)**2 
  call AssertEqual(&
    message='vx_IntZ_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = vx_Ans,                                              &
    check = vx_IntZ_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  vx_Ans = (1 - sin(pi*vx_X)) * cos(pi*vx_Y)**2/2.0D0
  call AssertEqual(&
    message='vx_AvrZ_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = vx_Ans,                                              &
    check = vx_AvrZ_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zv_Ans = 2*cos(pi*zv_Y)**2 * sin(pi*zv_Z)**2
  call AssertEqual(&
    message='zv_IntX_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = zv_Ans,                                              &
    check = zv_IntX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zv_Ans = cos(pi*zv_Y)**2 * sin(pi*zv_Z)**2
  call AssertEqual(&
    message='zv_AvrX_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = zv_Ans,                                              &
    check = zv_AvrX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zx_Ans = (1 - sin(pi*zx_X)) *  sin(pi*zx_Z)**2
  call AssertEqual(&
    message='zx_IntY_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = zx_Ans,                                              &
    check = zx_IntY_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  zx_Ans = (1 - sin(pi*zx_X)) *  sin(pi*zx_Z)**2/2.0D0
  call AssertEqual(&
    message='zx_AvrY_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = zx_Ans,                                              &
    check = zx_AvrY_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 2*sin(pi*z_Z)**2
  call AssertEqual(&
    message='z_IntYX_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = z_Ans,                                               &
    check = z_IntYX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  z_Ans = sin(pi*z_Z)**2/2.0D0
  call AssertEqual(&
    message='z_AvrYX_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = z_Ans,                                               &
    check = z_AvrYX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_Ans = 2*cos(pi*v_Y)**2
  call AssertEqual(&
    message='v_IntZX_zvx with sin(pi*X)p*cos(pi*Y)*cos(pi*Z)',    &
    answer = v_Ans,                                               &
    check = v_IntZX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  v_Ans = cos(pi*v_Y)**2/2.0D0
  call AssertEqual(&
    message='v_AvrZX_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = v_Ans,                                               &
    check = v_AvrZX_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 1 - sin(pi*x_X)
  call AssertEqual(&
    message='x_IntZY_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = x_Ans,                                               &
    check = x_IntZY_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = (1 - sin(pi*x_X))/4.0D0
  call AssertEqual(&
    message='x_AvrZY_zvx with sin(pi*X)*cos(pi*Y)*cos(pi*Z)',     &
    answer = x_Ans,                                               &
    check = x_AvrZY_zvx(zvx_Data),                                &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- 2 次元関数チェック ----------------------
  ! YX データ

  vx_Data = sin(pi*vx_X) * cos(pi*vx_Y)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntYX_vx with sin(pi*X)*cos(pi*Y)',                  &
    answer = Ans,                                                 &
    check = IntYX_vx(vx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrYX_vx with sin(pi*X)*cos(pi*Y)',                  &
    answer = Ans,                                                 &
    check = AvrYX_vx(vx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_Ans = 0.0D0
  call AssertEqual(&
    message='v_IntX_vx with sin(pi*X)*cos(pi*Y)',                 &
    answer = v_Ans,                                               &
    check = v_IntX_vx(vx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='v_AvrX_vx with sin(pi*X)*cos(pi*Y)',                 &
    answer = v_Ans,                                               &
    check = v_AvrX_vx(vx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 0.0D0
  call AssertEqual(&
    message='x_IntY_vx with sin(pi*X)*cos(pi*Y)',                 &
    answer = x_Ans,                                               &
    check = x_IntY_vx(vx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='x_AvrY_vx with sin(pi*X)*cos(pi*Y)',                 &
    answer = x_Ans,                                               &
    check = x_AvrY_vx(vx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  vx_Data = (1 - sin(pi*vx_X)) * cos(pi*vx_Y)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntYX_vx with (1-sin(pi*X)) * cos(pi*Y)**2',         &
    answer = Ans,                                                 &
    check = IntYX_vx(vx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrYX_vx with (1-sin(pi*X)) * cos(pi*Y)**2',         &
    answer = Ans,                                                 &
    check = AvrYX_vx(vx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_Ans = 2*cos(pi*v_Y)**2
  call AssertEqual(&
    message='v_IntX_vx with (1-sin(pi*X)) * cos(pi*Y)**2',        &
    answer = v_Ans,                                               &
    check = v_IntX_vx(vx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  v_Ans = cos(pi*v_Y)**2
  call AssertEqual(&
    message='v_AvrX_vx with (1-sin(pi*X)) * cos(pi*Y)**2',        &
    answer = v_Ans,                                               &
    check = v_AvrX_vx(vx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 1 - sin(pi*x_X)
  call AssertEqual(&
    message='x_IntY_vx with (1-sin(pi*X)) * cos(pi*Y)**2',        &
    answer = x_Ans,                                               &
    check = x_IntY_vx(vx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = 0.5*(1 - sin(pi*x_X))
  call AssertEqual(&
    message='x_AvrY_vx with (1-sin(pi*X)) * cos(pi*Y)**2',        &
    answer = x_Ans,                                               &
    check = x_AvrY_vx(vx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! ZY データ
  zv_Data = sin(pi*zv_Z) * cos(pi*zv_Y)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntZY_zv with sin(pi*Z)*cos(pi*Y)',                  &
    answer = Ans,                                                 &
    check = IntZY_zv(zv_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrZY_zv with sin(pi*Z)*cos(pi*Y)',                  &
    answer = Ans,                                                 &
    check = AvrZY_zv(zv_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_Ans = 0.0D0
  call AssertEqual(&
    message='v_IntX_zv with sin(pi*Z)*cos(pi*Y)',                 &
    answer = v_Ans,                                               &
    check = v_IntZ_zv(zv_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='v_AvrZ_zv with sin(pi*Z)*cos(pi*Y)',                 &
    answer = v_Ans,                                               &
    check = v_AvrZ_zv(zv_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 0.0D0
  call AssertEqual(&
    message='z_IntY_zv with sin(pi*Z)*cos(pi*Y)',                 &
    answer = z_Ans,                                               &
    check = z_IntY_zv(zv_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='z_AvrY_zv with sin(pi*Z)*cos(pi*Y)',                 &
    answer = z_Ans,                                               &
    check = z_AvrY_zv(zv_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zv_Data = (1 - sin(pi*zv_Z)) * cos(pi*zv_Y)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntZY_zv with (1-sin(pi*Z)) * cos(pi*Y)**2',         &
    answer = Ans,                                                 &
    check = IntZY_zv(zv_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrZY_zv with (1-sin(pi*Z)) * cos(pi*Y)**2',         &
    answer = Ans,                                                 &
    check = AvrZY_zv(zv_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_Ans = 2*cos(pi*v_Y)**2
  call AssertEqual(&
    message='v_IntZ_zv with (1-sin(pi*Z)) * cos(pi*Y)**2',        &
    answer = v_Ans,                                               &
    check = v_IntZ_zv(zv_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  v_Ans = cos(pi*v_Y)**2
  call AssertEqual(&
    message='v_AvrZ_zv with (1-sin(pi*Z)) * cos(pi*Y)**2',        &
    answer = v_Ans,                                               &
    check = v_AvrZ_zv(zv_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 1 - sin(pi*z_Z)
  call AssertEqual(&
    message='z_IntY_zv with (1-sin(pi*Z)) * cos(pi*Y)**2',        &
    answer = z_Ans,                                               &
    check = z_IntY_zv(zv_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  z_Ans = 0.5*(1 - sin(pi*z_Z))
  call AssertEqual(&
    message='z_AvrY_zv with (1-sin(pi*Z)) * cos(pi*Y)**2',        &
    answer = z_Ans,                                               &
    check = z_AvrY_zv(zv_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  ! ZX データ
  zx_Data = sin(pi*zx_Z) * cos(pi*zx_X)

  Ans = 0.0D0
  call AssertEqual(&
    message='IntZX_zx with sin(pi*Z)*cos(pi*X)',                  &
    answer = Ans,                                                 &
    check = IntZX_zx(zx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='AvrZX_zx with sin(pi*Z)*cos(pi*X)',                  &
    answer = Ans,                                                 &
    check = AvrZX_zx(zx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 0.0D0
  call AssertEqual(&
    message='x_IntZ_zx with sin(pi*Z)*cos(pi*X)',                 &
    answer = x_Ans,                                               &
    check = x_IntZ_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='x_AvrZ_zx with sin(pi*Z)*cos(pi*X)',                 &
    answer = x_Ans,                                               &
    check = x_AvrZ_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 0.0D0
  call AssertEqual(&
    message='z_IntX_zx with sin(pi*Z)*cos(pi*X)',                 &
    answer = z_Ans,                                               &
    check = z_IntX_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='z_AvrX_zx with sin(pi*Z)*cos(pi*X)',                 &
    answer = z_Ans,                                               &
    check = z_AvrX_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  zx_Data = (1 - sin(pi*zx_Z)) * cos(pi*zx_X)**2

  Ans = 2.0D0
  call AssertEqual(&
    message='IntZX_zx with (1-sin(pi*Z)) * cos(pi*X)**2',         &
    answer = Ans,                                                 &
    check = IntZX_zx(zx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrZX_zx with (1-sin(pi*Z)) * cos(pi*X)**2',         &
    answer = Ans,                                                 &
    check = AvrZX_zx(zx_Data),                                    &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  x_Ans = 2*cos(pi*x_X)**2
  call AssertEqual(&
    message='x_IntZ_zx with (1-sin(pi*Z)) * cos(pi*X)**2',        &
    answer = x_Ans,                                               &
    check = x_IntZ_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  x_Ans = cos(pi*x_X)**2
  call AssertEqual(&
    message='x_AvrZ_zx with (1-sin(pi*Z)) * cos(pi*X)**2',        &
    answer = x_Ans,                                               &
    check = x_AvrZ_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Ans = 1 - sin(pi*z_Z)
  call AssertEqual(&
    message='z_IntX_zx with (1-sin(pi*Z)) * cos(pi*X)**2',        &
    answer = z_Ans,                                               &
    check = z_IntX_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  z_Ans = 0.5*(1 - sin(pi*z_Z))
  call AssertEqual(&
    message='z_AvrX_zx with (1-sin(pi*Z)) * cos(pi*X)**2',        &
    answer = z_Ans,                                               &
    check = z_AvrX_zx(zx_Data),                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- 1 次元関数チェック ----------------------
  x_Data = 1 - sin(2*pi*x_X)

  Ans = 2.0D0
  call AssertEqual(&
    message='IntX_x with 1-sin(2*pi*X)',                          &
    answer = Ans,                                                 &
    check = IntX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 1.0D0
  call AssertEqual(&
    message='AvrX_x with 1-sin(2*pi*X)',                          &
    answer = Ans,                                                 &
    check = AvrX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_Data = cos(pi*v_Y)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntY_v with cos(pi*X)**2',                           &
    answer = Ans,                                                 &
    check = IntY_v(v_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrY_v with cos(pi*X)**2',                           &
    answer = Ans,                                                 &
    check = AvrY_v(v_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Data = sin(pi*z_Z)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntZ_z with sin(pi*Z)**2',                           &
    answer = Ans,                                                 &
    check = IntZ_z(z_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- 1 次元関数チェック ----------------------
  x_Data = 1 - sin(2*pi*x_X)

  Ans = 2.0D0
  call AssertEqual(&
    message='IntX_x with 1-sin(2*pi*X)',                          &
    answer = Ans,                                                 &
    check = IntX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 1.0D0
  call AssertEqual(&
    message='AvrX_x with 1-sin(2*pi*X)',                          &
    answer = Ans,                                                 &
    check = AvrX_x(x_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  v_Data = cos(pi*v_Y)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntY_v with cos(pi*X)**2',                           &
    answer = Ans,                                                 &
    check = IntY_v(v_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrY_v with cos(pi*X)**2',                           &
    answer = Ans,                                                 &
    check = AvrY_v(v_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  z_Data = sin(pi*z_Z)**2

  Ans = 1.0D0
  call AssertEqual(&
    message='IntZ_z with sin(pi*Z)**2',                           &
    answer = Ans,                                                 &
    check = IntZ_z(z_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  Ans = 0.5D0
  call AssertEqual(&
    message='AvrZ_z with sin(pi*Z)**2',                           &
    answer = Ans,                                                 &
    check = AvrZ_z(z_Data),                                       &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  
  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','tee_mpi_module_integral_test', &
       'tee_mpi_module integral and average functions tests succeeded')

end program tee_mpi_module_integral_test

!----------------------------------------------------------------------
! Copyright (c) 2002-2009 SPMODEL Development Group. All rights reserved.!
!----------------------------------------------------------------------
!
!表題  ae_module テストプログラム
!
!履歴  2002/01/25  竹広真一
!      2002/04/10  竹広真一
!      2007/11/07  竹広真一  エラーメッセージ追加
!      2009/07/09  佐々木洋平 幾つかの数値代入を倍精度に修正
!      2009/07/22  佐々木洋平 dc_test を使用するように修正
!
program ae_test_base2d

  use dc_message, only : MessageNotify
  use dc_test,    only : AssertEqual
  use ae_module
  implicit none
  integer, parameter :: im=8, km=3, nm=3
  real(8), parameter :: xmin=0.0D0, xmax=1.0D0
  real(8), parameter :: pi=3.1415926535897932385D0
  real(8), dimension(nm,0:im-1) :: ag_f, ag_dfdx_sol
  real(8), dimension(nm,-km:km) :: ae_f_sol
  ! 判定誤差設定
  integer, parameter :: check_digits = 16
  integer, parameter :: ignore = -14


  call MessageNotify('M','ae_test_base2d','ae_module 2-dim function tests')

  call ae_initial(im,km,xmin,xmax)

  ag_f(1,:) = 1.0D0
  ag_f(2,:) = sin(2.0D0*pi*g_x)
  ag_f(3,:) = cos(4.0D0*pi*g_x)

  ae_f_sol = 0.0D0
  ae_f_sol(1,0)=1.0D0
  ae_f_sol(2,-1)=-0.5D0
  ae_f_sol(3,2)=0.5D0

  ag_dfdx_sol(1,:) =  0.0D0
  ag_dfdx_sol(2,:) =  2.0D0*pi*cos(2.0D0*pi*g_x)
  ag_dfdx_sol(3,:) = -4.0D0*pi*sin(4.0D0*pi*g_x)

  call MessageNotify('M','test function ',&
    'f(1,:) = 1')
  call MessageNotify('M','test function ',&
    'f(2,:) = sin(2*pi*g_x)')
  call MessageNotify('M','test function ',&
    'f(3,:) = cos(4*pi*g_x)')

  call AssertEqual(&
    message = 'Forward Transform ',                             &
    answer = ae_f_sol,                                          &
    check = ae_ag(ag_f),                                        &
    significant_digits = check_digits, ignore_digits = ignore   &
  )
  call AssertEqual(&
    message = 'Inverse Transform ',                             &
    answer = ag_f,                                              &
    check = ag_ae(ae_ag(ag_f)),                                 &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call AssertEqual(&
    message = 'Differentiation',                                &
    answer = ag_dfdx_sol,                                       &
    check = ag_ae(ae_Dx_ae(ae_ag(ag_f))),                       &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  call MessageNotify('M',&
    'ae_test_base2d','ae_module 2-dim function tests succeeded!')

end program ae_test_base2d

!----------------------------------------------------------------------
!     Copyright (c) 2024 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_zonal_module_interpolate テストプログラム :: 補間関数のテスト
!
!履歴  2024/02/15  竹広真一    w_wave_module_interpolate_test.f90 を改造
!
program w_zonal_module_interpolate_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_zonal_module
  implicit none

  integer, parameter :: im=1, jm=32, nm=21

  real(8), allocatable             ::  w_data(:)
  real(8), dimension(0:im-1,1:jm)  ::  xy_data

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: Alon
  real(8) :: Alat
  real(8) :: data_sol
  real(8) :: pi

  pi = atan(1.0D0)*4.0D0
  Alon = pi/5 ; Alat = pi/3

  call MessageNotify('M','w_zonal_module_interpolate_test', &
                         'w_zonal_module_interpolate interpolate(00) tests') 

  !---- Y_1^0 のテスト ----
  call w_Initial( nm, im, jm )
  allocate(w_data(nm+1))

  xy_data = sqrt(3.0D0)*sin(xy_Lat)                         ! Y_1^0
  data_sol = sqrt(3.0D0)*sin(ALat)
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_1^0',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y_2^0 のテスト ----
  xy_data = sqrt(5.0D0)*(3.0D0*sin(xy_Lat)**2-1.0D0)/2.0D0        ! Y_2^0
  data_sol = sqrt(5.0D0)*(3.0D0*sin(ALat)**2-1.0D0)/2.0D0
  w_data = w_xy(xy_data)
  call AssertEqual(&
    message='Interpolate_w with Y_2^0',                           &
    answer = data_sol,                                            &
    check = Interpolate_w(w_data,alon,alat),                      &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','w_zonal_module_interpolate_test', &
                      'w_zonal_module_interpolate function tests succeeded') 

end program w_zonal_module_interpolate_test

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SYTSMV(MM,NM,NN,IM,JM,JV,S1,S2,G1,G2,IT,T,P,R,JC,W,IPOW,ICOM,MI)

  USE ISO_C_BINDING  
  IMPLICIT NONE  
  INCLUDE 'mpif.h'
  INTEGER(8) :: MM,NM,NN,IM,JM,JV,JR,M,IE,IJ,JD,NS,IPOW,ICOM,MI
  INTEGER(8) :: JI,JP1,JP2,JS,JE,K,I,IV,J,NBF
  INTEGER(8) :: IPDEST,IPSRC
  INTEGER(8) :: MN,M1,N1
  INTEGER(8) :: ITH,NTH,NTHMAX
  REAL(8) :: S1(*) ! S1((MM/NP+1)*(2*(NN+1)-MM/NP*NP))
  REAL(8) :: S2(*) ! S2((MM/NP+1)*(2*(NN+1)-MM/NP*NP))  
  REAL(8) :: G1(*) ! G1(0:IM-1,((JM/JV-1)/NP+1)*JV)
  REAL(8) :: G2(*) ! G2(0:IM-1,((JM/JV-1)/NP+1)*JV)  
  INTEGER(8) :: IT(IM/2)  
  REAL(8) :: T(IM*3/2)
  REAL(8) :: P(JM/2,*) !  P(JM/2,5+2*(MM/NP+1))
  REAL(8) :: R(*) ! R(5*(MM/NP+1)*(2*NM-MM/NP*NP)/4+MM/NP+1)
  INTEGER(8) :: JC(*) ! JC((MM/NP+1)*(2*NM-MM/NP*NP)/16+MM/NP+1)
  REAL(8) :: W(*) ! W(2*JV*((JM/JV-1)/NP+1)*(MM/NP+1)*NP*2*2)  
  TYPE(C_PTR),ALLOCATABLE :: WSP(:)
  TYPE(C_PTR),ALLOCATABLE :: WKP(:)
  TYPE(C_PTR),ALLOCATABLE :: WGP(:)
  LOGICAL,ALLOCATABLE :: LP(:)  
  REAL(8),POINTER:: WS(:)
  REAL(8),POINTER:: WK(:)
  REAL(8),POINTER:: WG(:,:)
  INTEGER :: IP,NP,IERR,NB,ICOM4

  !$ INTEGER :: omp_get_thread_num

  CALL SYGPRM(JM,JV,JR)

  CALL MXGOMP(NTHMAX) 

  ICOM4=ICOM
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)
  CALL MPI_COMM_RANK(ICOM4,IP,IERR)

  JI=((JM/JV-1)/NP+1)*JV

  !$omp parallel do num_threads(NTHMAX)
  DO IJ=1,IM*JI
     G1(IJ)=0
     G2(IJ)=0     
  END DO
  !$omp end parallel do  

  NB=JI*2*(MM/(NP*MI)+1)
  NBF=NB*NP*MI

  IF(JI*IP.LT.JM) THEN
     JP1=1+JI*IP
     JP2=MIN(JM,JI*(IP+1))
  ELSE ! そのプロセスでは全く緯度円を担当しない場合
     JP1=0
     JP2=-1
  END IF

  N1=(MM/MI+1)/NP
  M1=N1*NP*MI
  MN=N1
  IF(MOD(N1,2).EQ.0) THEN
     IF(IP.LE.MM/MI-M1/MI) THEN
        MN=MN+1
     END IF
  ELSE
     IF(IP.GE.NP-MM/MI+M1/MI-1) THEN
        MN=MN+1
     END IF
  END IF

  IF(MN.GE.1) THEN

     NTH=MIN(MN,NTHMAX)
     ITH=0
     ALLOCATE(WKP(0:NTH-1))
     ALLOCATE(WSP(0:NTH-1))
     ALLOCATE(WGP(0:NTH-1))    
     ALLOCATE(LP(0:NTH-1))
     LP=.FALSE.

     !$omp parallel private(K,NS,M,IJ,IE,WK,WS,WG,JS,JE,J,IPDEST,ITH) num_threads(NTH)
     !$omp do schedule(dynamic)
     DO K=0,MN-1
        !$ ITH=omp_get_thread_num()
        IF(.NOT.LP(ITH)) THEN
           CALL MXALLC(WKP(ITH),JV*11*JR)
           CALL C_F_POINTER(WKP(ITH),WK,[JV*11*JR])
           CALL MXALLC(WSP(ITH),4*(NM+1))
           CALL C_F_POINTER(WSP(ITH),WS,[4*(NM+1)])
           CALL MXALLC(WGP(ITH),JM*2*2)
           CALL C_F_POINTER(WGP(ITH),WG,[JM*2,2_8])
           LP(ITH)=.TRUE.
        END IF

        IE=5*K*(2*NM-NP*MI*(K-1))/4+K+1
        IJ=K*(2*NM-NP*MI*(K-1))/16+K+1     
        M=(K*NP+IP+MOD(K,2)*(NP-2*IP-1))*MI
        NS=K*(2*(NN+1)-(K-1)*NP*MI)+1
        IF(M.EQ.0) THEN
           CALL LXSSZV(NM,NN,JM,JV,JR,S1,S2,WG(1,1),WG(1,2),P,R,WK,WS,IPOW,0_8)                   
        ELSE IF(MOD(M,MI).EQ.0) THEN
           CALL LXSSWV(NM,NN,JM,JV,JR,M,S1(NS),S2(NS),WG(1,1),WG(1,2), &
                & P,P(1,6+K*2),R(IE),JC(IJ),WK,WS,IPOW,0_8)
        END IF
        JS=1
        IPDEST=-1
        DO WHILE(JS.LE.2*JM) 
           IPDEST=IPDEST+1
           JE=MIN(2*JM,2*JI*(IPDEST+1))
           DO J=JS,JE
              W(NBF*2+(IPDEST*(MM/(NP*MI)+1)+K)*JI*2+J-JS+1)=WG(J,1)
              W(NBF*3+(IPDEST*(MM/(NP*MI)+1)+K)*JI*2+J-JS+1)=WG(J,2)
           END DO
           JS=JE+1
        END DO
     END DO
     !$omp end do
     !$omp end parallel

     DO ITH=0,NTH-1
        IF(LP(ITH)) THEN
           CALL MXFREE(WKP(ITH))
           CALL MXFREE(WSP(ITH))
           CALL MXFREE(WGP(ITH))                
        END IF
     END DO

     DEALLOCATE(WSP)  
     DEALLOCATE(WKP)
     DEALLOCATE(WGP)  
     DEALLOCATE(LP)

  END IF

  CALL MPI_ALLTOALL(W(NBF*2+1),NB,MPI_REAL8,W,NB,MPI_REAL8,ICOM4,IERR)
  CALL MPI_ALLTOALL(W(NBF*3+1),NB,MPI_REAL8,W(NBF+1),NB,MPI_REAL8,ICOM4,IERR)  
  
  IF(JP1.NE.0) THEN  

     NTH=MIN((JP2-JP1+1)/JV,NTHMAX)
     ALLOCATE(WKP(0:NTH-1))
     ALLOCATE(LP(0:NTH-1))
     LP=.FALSE.

     ITH=0

     !$omp parallel private(JD,M,K,I,IPSRC,IV,ITH,WK) num_threads(NTH)
     !$omp do schedule(dynamic)
     DO JD=1,(JP2-JP1+1)/JV
        !$ ITH=omp_get_thread_num()
        IF(.NOT.LP(ITH)) THEN
           CALL MXALLC(WKP(ITH),JV*IM*2)
           CALL C_F_POINTER(WKP(ITH),WK,[JV*IM*2])
           LP(ITH)=.TRUE.
        END IF
        DO M=0,MM,MI
           K=M/NP/MI
           IF(MOD(K,2).EQ.0) THEN
              IPSRC=M/MI-K*NP
           ELSE
              IPSRC=(K+1)*NP-M/MI-1
           END IF
           DO IV=1,JV*2
              WK(IV+(JV*2)*M/MI) &
                   &  =W(IV+2*JV*(JD-1)+JI*2*(K+(MM/(NP*MI)+1)*IPSRC))
              WK(JV*IM+IV+(JV*2)*M/MI) &
                   &  =W(NBF+IV+2*JV*(JD-1)+JI*2*(K+(MM/(NP*MI)+1)*IPSRC))
           END DO
        END DO
        DO M=MM/MI+1,IM/2-1
           DO IV=1,JV*2
              WK(IV+(JV*2)*M)=0              
              WK(JV*IM+IV+(JV*2)*M)=0              
           END DO
        END DO
        CALL FXRTBA(JV,IM,WK(1),IT,T)
        CALL FXRTBA(JV,IM,WK(JV*IM+1),IT,T)                
        DO IV=1,JV
           DO I=1,IM
              G1(I+IM*(IV-1+JV*(JD-1)))=WK(IV+JV*(I-1))
              G2(I+IM*(IV-1+JV*(JD-1)))=WK(JV*IM+IV+JV*(I-1))              
           END DO
        END DO
     END DO
     !$omp end do
     !$omp end parallel

     DO ITH=0,NTH-1
        IF(LP(ITH)) THEN
           CALL MXFREE(WKP(ITH))
        END IF
     END DO
     DEALLOCATE(WKP)
     DEALLOCATE(LP)

  END IF

END SUBROUTINE SYTSMV

!----------------------------------------------------------------------
!     Copyright (c) 2016--2021 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  tee_mpi_module テストプログラム 
!      (トロイダルポロイダルポテンシャル, スペクトル)
!
!履歴  2016/09/21  竹広真一
!      2021/02/18  竹広真一
!
program tee_mpi_module_spectrum_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use tee_mpi_module
  use mpi
  implicit none

 !---- 空間解像度設定 ----
  integer, parameter :: im=64, jm=32, km=32       ! 格子点の設定(X,Y)
  integer, parameter :: lm=21, mm=10, nm=21       ! 切断波数の設定(X,Y)
!!$  integer, parameter :: im=64, jm=32, km=16       ! 格子点の設定(X,Y)
!!$  integer, parameter :: lm=21, mm=10, nm=10       ! 切断波数の設定(X,Y)

 !---- 変数 ----
  real(8), allocatable :: zvx_Torvel(:,:,:)  ! 格子データ
  real(8), allocatable :: zvx_Polvel(:,:,:)  ! 格子データ

  real(8), allocatable :: zvx_VX(:,:,:)      ! 格子データ
  real(8), allocatable :: zvx_VY(:,:,:)      ! 格子データ
  real(8), allocatable :: zvx_VZ(:,:,:)      ! 格子データ

  real(8), allocatable :: zef_Spectrum(:,:,:)! スペクトルデータ
  real(8), allocatable :: zef_Ans(:,:,:)     ! スペクトルデータ

  real(8)              :: Ans
  real(8)              :: Ek, EkTmp
  
  integer              :: l=2, m=5
  integer              :: np, ip, ierr

  
 !---- 座標変数など ----
  real(8), parameter :: xmin = 0.0d0, xmax=2.0d0
  real(8), parameter :: ymin = 0.0d0, ymax=2.0d0
  real(8), parameter :: zmin = -1.0d0, zmax=1.0d0

  real(8), parameter :: pi=3.1415926535897932385D0

  ! 判定誤差設定
  integer, parameter :: check_digits = 9
  integer, parameter :: ignore = -10

  call MessageNotify('M','tee_mpi_module_spectrum_test', &
       'tee_mpi_module toroidal poloidal potential spectrum functions tests')

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

 !---------------- 座標値の設定 ---------------------
  ! スペクトル初期化
  call tee_mpi_initial(im,jm,km,lm,mm,nm,xmin,xmax,ymin,ymax,zmin,zmax) 

  allocate(zvx_Torvel(0:km,jc(ip),0:im-1))  ! 格子データ
  allocate(zvx_Polvel(0:km,jc(ip),0:im-1))  ! 格子データ

  allocate(zvx_VX(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(zvx_VY(0:km,jc(ip),0:im-1))      ! 格子データ
  allocate(zvx_VZ(0:km,jc(ip),0:im-1))      ! 格子データ

  allocate(zef_Spectrum(0:km,-mm:mm,2*lc(ip))) ! スペクトルデータ
  allocate(zef_Ans(0:km,-mm:mm,2*lc(ip)))      ! スペクトルデータ
  
 !------------------- zef_ToroidalEnergySpectrum_tef ----------------------
  zvx_Torvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  zvx_Polvel = 0.0D0

  call tef_Potential2Vector(zvx_VX,zvx_VY,zvx_VZ,&
       tef_zvx(zvx_Torvel),tef_zvx(zvx_Polvel))

  zef_Ans= 0.0D0
  if ( lf_l(l) > 0 ) then
!!$     write(6,*) lf_l(l),lf_l(-l)
     zef_Ans(:,m,lf_l(l))   = ((l*pi)**2+(m*pi)**2)*((2*z_Z**2 -1)*0.25)**2/2
     zef_Ans(:,-m,lf_l(-l)) = zef_Ans(:,m,lf_l(l))
     zef_Ans(:,-m,lf_l(l))  = ((l*pi)**2+(m*pi)**2)*((2*z_Z**2 -1)*0.25)**2/2
     zef_Ans(:,m,lf_l(-l))  = zef_Ans(:,-m,lf_l(l))
  end if
     
  Ans = 0.5*IntZYX_zvx(zvx_VX**2 + zvx_VY**2 + zvx_VZ**2)

  zef_Spectrum=zef_ToroidalEnergySpectrum_tef(tef_zvx(zvx_Torvel))

  call AssertEqual(&
    message='zef_ToroidalEnergySpectrum_tef',                     &
    answer = zef_Ans,                                             &
    check = zef_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  EkTmp = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zef_Spectrum,3),2))
  CALL MPI_ALLREDUCE(EkTmp,Ek,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)
  
  call AssertEqual(&
    message='zef_ToroidalEnergySpectrum_tef(total)',              &
    answer = Ans,                                                 &
    check = Ek,                                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- zef_PoloidalEnergySpectrum_tef ----------------------
  zvx_Torvel = 0.0D0
  zvx_Polvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)

  call tef_Potential2Vector(zvx_VX,zvx_VY,zvx_VZ,&
       tef_zvx(zvx_Torvel),tef_zvx(zvx_Polvel))

  zef_Ans= 0.0D0
  if ( lf_l(l) > 0 ) then
    zef_Ans(:,m,lf_l(l)) = 0.5*( ((l*pi)**2+(m*pi)**2)*(4*z_Z*0.25)**2 &
                          +((l*pi)**2+(m*pi)**2)**2*((2*z_Z**2 -1)*0.25)**2 )
    zef_Ans(:,-m,lf_l(-l)) = zef_Ans(:,m,lf_l(l))

    zef_Ans(:,-m,lf_l(l))= 0.5*( ((l*pi)**2+(m*pi)**2)*(4*z_Z*0.25)**2 &
                          +((l*pi)**2+(m*pi)**2)**2*((2*z_Z**2 -1)*0.25)**2 )
    zef_Ans(:,m,lf_l(-l)) = zef_Ans(:,-m,lf_l(l))
  endif

  Ans = 0.5*IntZYX_zvx(zvx_VX**2 + zvx_VY**2 + zvx_VZ**2)

  zef_Spectrum=zef_PoloidalEnergySpectrum_tef(tef_zvx(zvx_Polvel))

  call AssertEqual(&
    message='zef_PoloidalEnergySpectrum_tef',                     &
    answer = zef_Ans,                                             &
    check = zef_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  EkTmp = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zef_Spectrum,3),2))
  CALL MPI_ALLREDUCE(EkTmp,Ek,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

  call AssertEqual(&
    message='zef_PoloidalEnergySpectrum_tef(total)',              &
    answer = Ans,                                                 &
    check = Ek,                                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- zef_ToroidalEnstrophySpectrum_tef ----------------------
  zvx_Torvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * (2*zvx_Z**2 -1)
  zvx_Polvel = 0.0D0

  call tef_Potential2Rotation(zvx_VX,zvx_VY,zvx_VZ,&
       tef_zvx(zvx_Torvel),tef_zvx(zvx_Polvel))

  zef_Ans= 0.0D0
  if ( lf_l(l) > 0 ) then
    zef_Ans(:,m,lf_l(l)) = 0.5*( ((l*pi)**2+(m*pi)**2)*(4*z_Z*0.25)**2 &
                          +((l*pi)**2+(m*pi)**2)**2*((2*z_Z**2 -1)*0.25)**2 )
    zef_Ans(:,-m,lf_l(-l)) = zef_Ans(:,m,lf_l(l))

    zef_Ans(:,-m,lf_l(l))= 0.5*( ((l*pi)**2+(m*pi)**2)*(4*z_Z*0.25)**2 &
                          +((l*pi)**2+(m*pi)**2)**2*((2*z_Z**2 -1)*0.25)**2 )
    zef_Ans(:,m,lf_l(-l)) = zef_Ans(:,-m,lf_l(l))
  endif

  Ans = 0.5*IntZYX_zvx(zvx_VX**2 + zvx_VY**2 + zvx_VZ**2)

  zef_Spectrum=zef_ToroidalEnstrophySpectrum_tef(tef_zvx(zvx_Torvel))

  call AssertEqual(&
    message='zef_ToroidalEnstrophySpectrum_tef',                  &
    answer = zef_Ans,                                             &
    check = zef_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  EkTmp = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zef_Spectrum,3),2))
  CALL MPI_ALLREDUCE(EkTmp,Ek,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)

  call AssertEqual(&
    message='zef_ToroidalEnstrophySpectrum_tef(total)',           &
    answer = Ans,                                                 &
    check = Ek,                                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

 !------------------- zef_PoloidalEnstrophySpectrum_tef ----------------------
  zvx_Torvel = 0.0D0
  zvx_Polvel = cos(l*pi*zvx_X) * cos(m*pi*zvx_Y) * sin(pi*zvx_Z) 

  call tef_Potential2Rotation(zvx_VX,zvx_VY,zvx_VZ,&
       tef_zvx(zvx_Torvel),tef_zvx(zvx_Polvel))

  zef_Ans= 0.0D0
  if ( lf_l(l) > 0 ) then
!!$     write(6,*) lf_l(l),lf_l(-l)
     zef_Ans(:,m,lf_l(l)) &
          = ((l*pi)**2+(m*pi)**2)*((l*pi)**2+(m*pi)**2+pi**2)**2*(sin(pi*z_Z)*0.25)**2/2
     zef_Ans(:,-m,lf_l(-l)) = zef_Ans(:,m,lf_l(l))
     zef_Ans(:,-m,lf_l(l)) &
          = ((l*pi)**2+(m*pi)**2)*((l*pi)**2+(m*pi)**2+pi**2)**2*(sin(pi*z_Z)*0.25)**2/2
     zef_Ans(:,m,lf_l(-l))  = zef_Ans(:,-m,lf_l(l))
  end if
     
  Ans = 0.5*IntZYX_zvx(zvx_VX**2 + zvx_VY**2 + zvx_VZ**2)

  zef_Spectrum=zef_PoloidalEnstrophySpectrum_tef(tef_zvx(zvx_Polvel))
  
  call AssertEqual(&
    message='zef_PoloidalEnstrophySpectrum_tef',                     &
    answer = zef_Ans,                                             &
    check = zef_SPectrum,                                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  EkTmp = (xmax-xmin)*(ymax-ymin)*IntZ_z(sum(sum(zef_Spectrum,3),2))
  CALL MPI_ALLREDUCE(EkTmp,Ek,1,MPI_REAL8,MPI_SUM,MPI_COMM_WORLD,IERR)
  
  call AssertEqual(&
    message='zef_PoloidalEnstrophySpectrum_tef(total)',              &
    answer = Ans,                                                 &
    check = Ek,                                                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MPI_FINALIZE(IERR)
  
  call MessageNotify('M','tee_mpi_module_spectrum_test', &
       'tee_mpi_module toroidal poloidal potential spectrum functions tests suceeded!')

end program tee_mpi_module_spectrum_test

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SYGSMS(MM,NN,S,SALL,ICOM,MI)

  IMPLICIT NONE    
  INCLUDE 'mpif.h'
  INTEGER(8) :: MM,NN,M,K,NS,LA,L,ICOM,MI
  REAL(8) :: S(*),SALL(*)
  INTEGER(8) :: IPDEST
  REAL(8),DIMENSION(:),ALLOCATABLE :: SBUF(:)
  INTEGER :: IP,NP,IERR,NB,ICOM4

  ICOM4=ICOM
!  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)
!  CALL MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)
  CALL MPI_COMM_RANK(ICOM4,IP,IERR)

  NB=(MM/(NP*MI)+1)*(2*(NN+1)-MM/(NP*MI)*NP*MI)

  IF(IP.EQ.0) THEN
     ALLOCATE(SBUF(1_8*NB*NP))
  ELSE
     ALLOCATE(SBUF(1))
  END IF

  !  CALL MPI_GATHER(S,NB,MPI_REAL8,SBUF,NB,MPI_REAL8,0,MPI_COMM_WORLD,IERR)
  CALL MPI_GATHER(S,NB,MPI_REAL8,SBUF,NB,MPI_REAL8,0,ICOM4,IERR)  

  IF(IP.EQ.0) THEN
     SALL(1:NN+1)=SBUF(1:NN+1)
     DO M=MI,MM,MI
        K=M/(NP*MI)
        NS=K*(2*(NN+1)-(K-1)*NP*MI)+1
        CALL SYNMML(NN,M,M,IPDEST,L,ICOM,MI)
        CALL SXNMML(NN,M,M,LA,MI)
        SALL(LA:LA+2*(NN+1-M)-1)=SBUF(NS+NB*IPDEST:NS+NB*IPDEST+2*(NN+1-M)-1)
     END DO
  END IF

END SUBROUTINE SYGSMS

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXCMPK(MM,NT1,NT2,S1,S2,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NT1,NT2,M,N,NS1,NS2,L,MI
  REAL(8) :: S1((MM/MI+1)*(2*(NT1+1)-MM/MI*MI))
  REAL(8) :: S2((MM/MI+1)*(2*(NT2+1)-MM/MI*MI))
  INTEGER(8) :: NPMAX
  INTEGER(8) :: MN,M1,N1,K

  CALL MXGOMP(NPMAX)  

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  IF(NT2.GT.NT1) THEN
     !$omp parallel private(NS1,NS2,N,L,M) num_threads(NPMAX)
     !$omp do schedule(dynamic)
     DO K=0,MN-1
        M=K*MI
        IF(M.EQ.0) THEN
           DO N=0,NT1
              S2(N+1)=S1(N+1)
           END DO
           DO N=NT1+1,NT2
              S2(N+1)=0
           END DO
        ELSE
           NS1=K*(2*(NT1+1)-(K-1)*MI)+1
           NS2=K*(2*(NT2+1)-(K-1)*MI)+1
!!$           NS1=(2*NT1+2-M)*(M-1)+NT1+1+1
!!$           NS2=(2*NT2+2-M)*(M-1)+NT2+1+1           
           DO L=0,2*(NT1-M+1)-1
              S2(NS2+L)=S1(NS1+L)
           END DO
           DO L=2*(NT1-M+1),2*(NT2-M+1)-1
              S2(NS2+L)=0
           END DO
        END IF
     END DO
     !$omp end do
     !$omp end parallel
  ELSE IF(NT2.LT.NT1) THEN
     !$omp parallel private(NS1,NS2,N,L,M) num_threads(NPMAX)
     !$omp do schedule(dynamic)
     DO K=0,MN-1
        M=K*MI
        IF(M.EQ.0) THEN
           DO N=0,NT2
              S2(N+1)=S1(N+1)
           END DO
        ELSE
           NS1=K*(2*(NT1+1)-(K-1)*MI)+1
           NS2=K*(2*(NT2+1)-(K-1)*MI)+1
!!$           NS1=(2*NT1+2-M)*(M-1)+NT1+1+1
!!$           NS2=(2*NT2+2-M)*(M-1)+NT2+1+1           
           DO L=0,2*(NT2-M+1)-1
              S2(NS2+L)=S1(NS1+L)
           END DO
        END IF
     END DO
     !$omp end do
     !$omp end parallel
  ELSE
     S2=S1
  END IF

END SUBROUTINE SXCMPK

!----------------------------------------------------------------------
!     Copyright (c) 2019-2020 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_deriv_mpi_module テストプログラム :: 微分関数のテスト
!
!履歴  2019/08/04  竹広真一
!      2020/11/10  竹広真一  セクター計算オプション導入
!
program ua_mpi_module_deriv_mint_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module_mint
  use mpi
  implicit none

!!$  integer, parameter :: im=64, jm=32, nm=21, km=2, npv=2, mint=1
  integer, parameter :: im=32, jm=32, nm=21, km=2, npv=2, mint=2

  real(8), allocatable  ::  pva_data1(:,:,:)              ! 元の関数
  real(8), allocatable  ::  pva_data2(:,:,:)              ! 元の関数
  real(8), allocatable  ::  pva_ddata(:,:,:)              ! 微分の正解
  real(8), allocatable  ::  pv_data1(:,:)                 ! 元の関数
  real(8), allocatable  ::  pv_data2(:,:)                 ! 元の関数
  real(8), allocatable  ::  pv_ddata(:,:)                 ! 微分の正解
  real(8), allocatable  ::  pv_mu(:,:)                    ! μ=sinφ

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  integer :: ip, np, ierr


 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IP,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  call MessageNotify('M','ua_deriv_mpi_module_mint_test', &
                         'ua_mpi_module_mint function deriv tests')

  call ua_mpi_Initial( nm, im, jm, km, npv=npv, mint=mint )

  allocate(pva_data1(0:ic-1,jc,km))
  allocate(pva_data2(0:ic-1,jc,km))
  allocate(pva_ddata(0:ic-1,jc,km))
  allocate(pv_data1(0:ic-1,jc))
  allocate(pv_data2(0:ic-1,jc))
  allocate(pv_ddata(0:ic-1,jc))
  allocate(pv_mu(0:ic-1,jc))

  !============== 微分計算 (lon,lat座標系用) のテスト ==============

  !---- Y_1^0 Y_2^2 のテスト ----
  pva_data1(:,:,1) = sin(pv_Lat)                        ! Y_1^0
  pva_data1(:,:,2) = cos(pv_Lat)**2*cos(2*pv_Lon)       ! Y_2^2

  pva_ddata(:,:,1) = -2*sin(pv_Lat)                     ! ua_Lapla_ua
  pva_ddata(:,:,2) = -6*cos(pv_Lat)**2*cos(2*pv_Lon)    ! ua_Lapla_ua
  call AssertEqual(&
    message='ua_Lapla_ua with Y_1^0 and Y^2_2',                  &
    answer = pva_ua(ua_Lapla_ua(ua_pva(pva_data1))),              &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
 
  pva_ddata(:,:,1) = -1.0/2.0*sin(pv_Lat)      ! ua_LaplaInv_ua
  pva_ddata(:,:,2) = -1.0D0/6.0D0*cos(pv_Lat)**2*cos(2*pv_Lon)
  call AssertEqual(&
    message='ua_LaplaInv_ua with Y_1^0 and Y^2_2',               &
    answer = pva_ua(ua_LaplaInv_ua(ua_pva(pva_data1))),           &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = 0.0D0         ! ua_DLon_ua
  pva_ddata(:,:,2) = cos(pv_Lat)**2*(-2)*sin(2*pv_Lon)
  call AssertEqual(&
    message='ua_DLon_ua with Y_1^0 and Y^2_2',                   &
    answer = pva_ua(ua_DLon_ua(ua_pva(pva_data1))),               &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = 0.0D0                     ! pva_GradLon_ua
  pva_ddata(:,:,2) = cos(pv_Lat)*(-2)*sin(2*pv_Lon)
  call AssertEqual(&
    message='pva_GradLon_ua with Y_1^0 and Y^2_2',               &
    answer = pva_GradLon_ua(ua_pva(pva_data1)),                   &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = cos(pv_Lat)               ! pva_GradLat_ua
  pva_ddata(:,:,2) = (-2)*cos(pv_Lat)*sin(pv_Lat)*cos(2*pv_Lon) 
  call AssertEqual(&
    message='pva_GradLat_ua with Y_1^0 and Y^2_2',               &
    answer = pva_GradLat_ua(ua_pva(pva_data1)),                   &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = sin(pv_Lat)                              ! Y_1^0
  pv_ddata = -2*sin(pv_Lat)                           ! u_Lapla_u
  call AssertEqual(&
    message='u_Lapla_u with Y_1^0',                               &
    answer = pv_u(u_Lapla_u(u_pv(pv_data1))),                     &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pv_ddata = -1.0/2.0*sin(pv_Lat)                     ! u_LaplaInv_u
  call AssertEqual(&
    message='u_LaplaInv_u with Y_1^0',                            &
    answer = pv_u(u_LaplaInv_u(u_pv(pv_data1))),                  &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pv_ddata = cos(pv_Lat)                              ! pv_GradLat_u
  call AssertEqual(&
    message='pv_GradLat_u with Y_1^0',                            &
    answer = pv_GradLat_u(u_pv(pv_data1)),                        &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = cos(pv_Lat)**2*cos(2*pv_Lon)             ! Y_2^2
  pv_ddata = -6*cos(pv_Lat)**2*cos(2*pv_Lon)          ! a_Lapla_u
  call AssertEqual(&
    message='u_Lapla_u with Y_2^2',                               &
    answer = pv_u(u_Lapla_u(u_pv(pv_data1))),                     &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pv_ddata = -1.0D0/6.0D0*cos(pv_Lat)**2*cos(2*pv_Lon)  ! u_LaplaInv_u
  call AssertEqual(&
    message='u_LaplaInv_u with Y_2^2',                            &
    answer = pv_u(u_LaplaInv_u(u_pv(pv_data1))),                  &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pv_ddata = (-2)*cos(pv_Lat)*sin(pv_Lat)*cos(2*pv_Lon)    ! pv_GradLat_u
  call AssertEqual(&
    message='pv_GradLat_u with Y_2^2',                            &
    answer = pv_GradLat_u(u_pv(pv_data1)),                        &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  
  !---- Y_1^0 cosφ, Y_2^2 cosφ のテスト ----
  pva_data1(:,:,1) = sin(pv_Lat)*cos(pv_Lat)                 ! Y_1^0 cosφ
  pva_data1(:,:,2) = cos(pv_Lat)**3*cos(2*pv_Lon)            ! Y_2^2 cosφ

  pva_ddata(:,:,1) = 0.0D0                                   ! ua_DivLon_pv
  pva_ddata(:,:,2) = cos(pv_Lat)**2*(-2)*sin(2*pv_Lon)       ! ua_DivLon_pv
  call AssertEqual(&
    message='ua_DivLon_pva with Y_1^0 cosφ and Y^2_2 cosφ',    &
    answer = pva_ua(ua_DivLon_pva(pva_data1)),                    &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = cos(pv_Lat)**2 - 2*sin(pv_Lat)**2        !ua_DivLat_ua
  pva_ddata(:,:,2) = (-4)*cos(pv_Lat)**2*sin(pv_Lat)*cos(2*pv_Lon) !ua_DivLat_ua
  call AssertEqual(&
    message='ua_DivLat_pva with Y_1^0 cosφ and Y^2_2 cosφ',    &
    answer = pva_ua(ua_DivLat_pva(pva_data1)),                    &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = sin(pv_Lat)*cos(pv_Lat)                  ! Y_1^0 cosφ
  pv_ddata = 0.0D0                                    ! u_DivLon_pv
  call Assertequal(&
    message='u_DivLon_pv with Y_1^0 cosφ',                     &
    answer = pv_u(u_DivLon_pv(pv_data1)),                       &
    check = pv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  pv_ddata = cos(pv_Lat)**2 - 2*sin(pv_Lat)**2        !u_DivLat_u
  call Assertequal(&
    message='u_DivLat_pv with Y_1^0 cosφ',                     &
    answer = pv_u(u_DivLat_pv(pv_data1)),                       &
    check = pv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  
  pv_data1 = cos(pv_Lat)**3*cos(2*pv_Lon)               ! Y_2^2 cosφ
  pv_ddata = cos(pv_Lat)**2*(-2)*sin(2*pv_Lon)          ! u_DivLon_pv
  call Assertequal(&
    message='u_DivLon_pv with Y^2_2 cosφ',                     &
    answer = pv_u(u_DivLon_pv(pv_data1)),                       &
    check = pv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )
  pv_ddata = (-4)*cos(pv_Lat)**2*sin(pv_Lat)*cos(2*pv_Lon)     !u_DivLat_u
  call Assertequal(&
    message='u_DivLat_pv with Y^2_2 cosφ',                     &
    answer = pv_u(u_DivLat_pv(pv_data1)),                       &
    check = pv_ddata,                                           &
    significant_digits = check_digits, ignore_digits = ignore   &
    )

  
  !---- Jacobian のテスト ----
  pva_data1(:,:,1) = sin(pv_Lat)                             ! Y_1^0
  pva_data1(:,:,2) = sin(pv_Lat)                             ! Y_1^0
  pva_data2(:,:,1) = 3.0D0/2.0D0*sin(pv_Lat)**2-1.0D0/2.0D0  ! Y_2^0
  pva_data2(:,:,2) = cos(pv_Lat)**2 * cos(2*pv_Lon)   ! Y_2^2
  pva_ddata(:,:,1) = 0.0
  pva_ddata(:,:,2) = -cos(pv_Lat)**2*(-2)*sin(2*pv_Lon)

  call AssertEqual(&
    message='ua_JacobianMPI_ua_ua Y_1^0 and Y^2_*',              &
    answer = pva_ua(ua_JacobianMPI_ua_ua(ua_pva(pva_data1),ua_pva(pva_data2))), &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = cos(pv_Lat)**2 * cos(2*pv_Lon)   ! Y_2^2
  pv_data2 = cos(pv_Lat)**2 * cos(2*pv_Lon)   ! Y_2^2
  pv_ddata = 0.0D0
  call AssertEqual(&
    message='u_JacobianMPI_u_u with Y^2_2',                          &
    answer = pv_u(u_JacobianMPI_u_u(u_pv(pv_data1),u_pv(pv_data2))), &
    check = pv_ddata,                                                &
    significant_digits = check_digits, ignore_digits = ignore        &
    )

  pv_data1 = sin(pv_Lat)                          ! Y_1^0
  pv_data2 = cos(pv_Lat)**2*sin(2*pv_Lon)         ! Y_2^-2
  pv_ddata = -cos(pv_Lat)**2*2*cos(2*pv_Lon)
  call AssertEqual(&
    message='u_JacobianMPI_u_u with Y_1^0 and Y_2^-2',               &
    answer = pv_u(u_JacobianMPI_u_u(u_pv(pv_data1),u_pv(pv_data2))), &
    check = pv_ddata,                                                &
    significant_digits = check_digits, ignore_digits = ignore        &
    )
 

  !============== 微分計算 (λ,μ座標系用) のテスト ==============
  pv_mu = sin(pv_Lat)

  !----- Y_2^0, Y_1^1 のテスト -----
  pva_data1(:,:,1) = 3*pv_mu**2-1                              ! Y_2^0
  pva_data1(:,:,2) = -(1-pv_mu**2)*sin(2*pv_Lon)               ! Y_2^-2

  pva_ddata(:,:,1) = 0.0D0
  pva_ddata(:,:,2) = -(1-pv_mu**2)*2*cos(2*pv_Lon)
  call AssertEqual(&
    message='pva_GradLambda_ua with Y_2^0 and Y^2_-2',            &
    answer = pva_GradLambda_ua(ua_pva(pva_data1)),                &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  pva_ddata(:,:,1) = 6*pv_mu*(1-pv_mu**2)
  pva_ddata(:,:,2) = 2*pv_mu*(1-pv_mu**2)*sin(2*pv_Lon)
  call AssertEqual(&
    message='pva_GradMu_ua with Y_2^0 and Y^2_-2',                &
    answer = pva_GradMu_ua(ua_pva(pva_data1)),                    &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = 3*pv_mu**2-1                              ! Y_2^0
  pv_ddata = 0.0
  call AssertEqual(&
    message='pv_GradLambda_u with Y_2^0',                        &
    answer = pv_GradLambda_u(u_pv(pv_data1)),                    &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  pv_ddata = 6*pv_mu*(1-pv_mu**2)
  call AssertEqual(&
    message='pv_GradMu_u with Y_2^0',                             &
    answer = pv_GradMu_u(u_pv(pv_data1)),                         &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pv_data1 = (1-pv_mu**2)*cos(2*pv_Lon)                 ! Y_2^2
  pv_ddata = -(1-pv_mu**2)*2*sin(2*pv_Lon)
  call AssertEqual(&
    message='pv_GradLambda_u with Y^2_2',                        &
    answer = pv_GradLambda_u(u_pv(pv_data1)),                    &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  pv_ddata = -2*pv_mu*(1-pv_mu**2)*cos(2*pv_Lon)
  call AssertEqual(&
    message='pv_GradMu_u with Y_2^2',                             &
    answer = pv_GradMu_u(u_pv(pv_data1)),                         &
    check = pv_ddata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  !----- Y_2^0(1-μ^2), Y_1^1 (1-μ^2) のテスト -----
  pva_data1(:,:,1) = (3*pv_mu**2-1)*(1-pv_mu**2)       ! Y_2^0 (1-μ^2)
  pva_data1(:,:,2) = (1-pv_mu**2)**2*sin(2*pv_Lon)     ! Y_2^-2 (1-μ^2)

  pva_ddata(:,:,1) = 0.0
  pva_ddata(:,:,2) = (1-pv_mu**2)*2*cos(2*pv_Lon) 

  call AssertEqual(&
    message='ua_DivLambda_pva with Y_2^0 (1-μ^2) and Y^2_-2 (1-μ^2)',&
    answer = pva_ua(ua_DivLambda_pva(pva_data1)),                 &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  pva_ddata(:,:,1) = (2-3*pv_mu**2)*4*pv_mu
  pva_ddata(:,:,2) = 2*(1-pv_mu**2)*(-2)*pv_mu*sin(2*pv_Lon)
  call AssertEqual(&
    message='ua_DivMu_pva with Y_2^0 (1-μ^2) and Y^2_-2(1-μ^2)', &
    answer = pva_ua(ua_DivMu_pva(pva_data1)),                     &
    check = pva_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  
  pv_data1 = (3*pv_mu**2-1)*(1-pv_mu**2)       ! Y_2^0 (1-μ^2)
  pv_ddata = 0.0
  call AssertEqual(&
    message='u_DivLambda_pv with Y_2^0 (1-μ^2)',                &
    answer = pv_u(u_DivLambda_pv(pv_data1)),                     &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  pv_ddata = (2-3*pv_mu**2)*4*pv_mu
  call AssertEqual(&
    message='u_DivMu_pv with Y_2^0 (1-μ^2)',                    &
    answer = pv_u(u_DivMu_pv(pv_data1)),                         &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  pv_data1 = (1-pv_mu**2)**2*cos(2*pv_Lon)     ! Y_2^2 (1-μ^2)
  pv_ddata = (1-pv_mu**2)*(-2)*sin(2*pv_Lon) 
  call AssertEqual(&
    message='u_DivLambda_pv with Y^2_2 (1-μ^2)',                &
    answer = pv_u(u_DivLambda_pv(pv_data1)),                     &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  pv_ddata = 2*(1-pv_mu**2)*(-2)*pv_mu*cos(2*pv_Lon)
  call AssertEqual(&
    message='u_DivMu_pv with  Y^2_2 (1-μ^2)',                 &
    answer = pv_u(u_DivMu_pv(pv_data1)),                         &
    check = pv_ddata,                                            &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  
  call MessageNotify('M','ua_mpi_module_deriv_test', &
                         'ua_mpi_module_mint deriv function tests succeeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_mpi_module_deriv_mint_test

! -*- mode: f90; coding: utf-8 -*-
! ----------------------------------------------------------------------------
! Copyright(c) 2002-2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2002/01/20  竹広真一
!       2002/06/10  竹広真一   ベクトル長問題回避のため lusol2 を使用
!       2005/01/10  竹広真一   msgdmp -> MessageNotify に変更
!       2006/03/04  竹広真一   コメントを RDoc 用に修正
!       2009/01/29  佐々木洋平 コメントを RDoc 用に修正
!       2009/08/06  竹広真一   ludecomp21 用ルーチン OMP 版変更
!       2013/12/14  佐々木洋平 interface 部を修正
!       2019/09/20  佐々木洋平 コメントを doxygen 用に修正, lapackと統合
! ----------------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2002-2026.
!> License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!>
!> @brief 行列の LU 分解による線形連立方程式の解法:
!> @details
!> spml/lumatrix モジュールは, LU 分解法により連立 1 次方程式を解くための
!> Fortran90 関数を提供する.
!>
!> 他のスペクトル計算用モジュールの中で登場する境界値問題を解くために用いられている.
!>
!> 同じ次数の複数個の連立 1 次方程式
!> \f[
!> A[ij] X [j] = B[i]
!> \f]
!> の解を, 同時に複数個の右辺ベクトル \f$B[i]\f$ に対して求めることが
!> できるようになっている.
!
module lumatrix
  use dc_types, only: DP
  use dc_message, only: MessageNotify
  implicit none
  private
  public LUDecomp
  public LUSolve
  !------------------------------------------------------------------------
  !> 与えられた行列の LU 分解を行い, ピボットを格納する.
  !>
  !> * LU 分解された結果は `Alu` に上書きされる.
  !>   そのピボット情報は `kp` に格納される.
  !>
  !> * LUSolve を用いる前にこのサブルーチンを呼んで `Alu` と `kp` を
  !>   計算しておく.
  interface LUDecomp
     module procedure ludecomp21
     module procedure ludecomp32
  end interface LUDecomp
  !-----------------------------------------------------------------------
  !> 連立 1 次方程式の解を求める
  !>
  !> @warning
  !> LUSolve を用いる前に LUDecompを呼んで Alu を LU 分解し,
  !> ピボット情報 kp を計算しておかねばならない.
  interface LUSolve
     module procedure lusolve211
     module procedure lusolve212
     module procedure lusolve322
     module procedure lusolve323
  end interface LUSolve
contains
  !-----------------------------------------------------------------------
  !> NDIM x NDIM の行列 ALU を LU 分解する.
  !> @note
  !> 結果は 入力行列に上書き
  subroutine ludecomp21(alu,kp)
    !> 入出力行列
    real(DP), intent(inout) :: alu(:,:)
    !> ピボット
    integer, intent(out)   :: kp(size(alu,1))
    if ( size(alu,1) > size(alu,2) ) then
      call MessageNotify('E','ludecomp',&
        'The third dimension is less than the second')
    elseif( size(alu,1) < size(alu,2) ) then
      call MessageNotify('W','ludecomp',&
        'The third dimension is grater than the second')
    endif
    call LUMAK1( alu, kp, size(alu,1) )
  end subroutine ludecomp21
  !-----------------------------------------------------------------------
  !> JDIM 個 の NDIM x NDIM の行列を一度に LU 分解.
  !> @note
  !> 結果は入力行列に上書き
  subroutine ludecomp32(alu,kp)
    !> 入力行列．JDIM が行列の個数, 後ろ二つの NDIMxNDIM が行列の形状
    real(DP), intent(inout) :: alu(:,:,:)
    !> ピボット
    integer, intent(out)    :: kp(size(alu,1),size(alu,2))
    if ( size(alu,2) > size(alu,3) ) then
      call MessageNotify('E','ludecomp',&
        'The third dimension is less than the second')
    elseif( size(alu,2) < size(alu,3) ) then
      call MessageNotify('W','ludecomp',&
        'The third dimension is grater than the second')
    endif
    call lumake( alu, kp, size(alu,1), size(alu,2) )
  end subroutine ludecomp32
  !-----------------------------------------------------------------------
  !> ALU(NDIM,NDIM), KP(NDIM), B(NDIM)
  !> NDIM x NDIM 型行列の連立方程式
  !> A X = B を 1 個の B に対して計算する.
  function lusolve211(alu,kp,b)
    !> 入力／LU 行列
    real(DP), intent(in)  :: alu(:,:)
    !> ピボット
    integer, intent(in)  :: kp(:)
    !> 右辺ベクトル
    real(DP), intent(in)  :: b(:)
    !> 解
    real(DP) :: lusolve211(size(b))
    lusolve211 = b
    call lusol2( lusolve211, alu , kp, 1, size(b) )
  end function lusolve211
  !-----------------------------------------------------------------------
  !> ALU(NDIM,NDIM), KP(NDIM), B(JDIM,NDIM)
  !> NDIM x NDIM 型行列の連立方程式
  !> A X = B を JDIM 個の B に対して計算する.
  function lusolve212(alu,kp,b)
    !> 入力／LU 行列
    real(DP), intent(in)  :: alu(:,:)
    !> ピボット
    integer,  intent(in)  :: kp(:)
    !> 右辺ベクトル
    real(DP), intent(in)  :: b(:,:)
    !> 解
    real(DP) :: lusolve212(size(b,1),size(b,2))
    lusolve212 = b
    call lusol2( lusolve212, alu , kp, size(b,1), size(b,2) )
  end function lusolve212
  !-----------------------------------------------------------------------
  !> ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(JDIM,NDIM)
  !> NDIM x NDIM 型行列を JDIM 個並べた連立方程式
  !> A X = B をひとつの B の並びに対して計算する.
  function lusolve322(alu,kp,b)
    !> 入力／LU 行列
    real(DP), intent(in)  :: alu(:,:,:)
    !> ピボット
    integer,  intent(in)  :: kp(:,:)
    !> 右辺ベクトル
    real(DP), intent(in)  :: b(:,:)
    !> 解
    real(DP) :: lusolve322(size(b,1),size(b,2))
    lusolve322 = b
    call lusol3( lusolve322, alu, kp, size(b,1), size(b,2) )
  end function lusolve322
  !-----------------------------------------------------------------------
  !> ALU(JDIM,NDIM,NDIM), KP(JDIM,NDIM), B(IDIM,JDIM,NDIM)
  !> NDIM x NDIM 型行列を JDIM 個並べた連立方程式
  !> A X = B を IDIM 個の B に対して計算する.
  function lusolve323(alu,kp,b)
    !> 入力／LU 行列
    real(DP), intent(in)  :: alu(:,:,:)
    !> ピボット
    integer, intent(in)  :: kp(:,:)
    !> 右辺ベクトル
    real(DP), intent(in)  :: b(:,:,:)
    !> 解
    real(DP) :: lusolve323(size(b,1),size(b,2),size(b,3))
    lusolve323 = b
    call lusolv( lusolve323, alu , kp, size(b,1), size(b,2), size(b,3) )
  end function lusolve323
  ! -- LAPACK が無い場合 -------------------------------------------------------
  !---------------------------------------------------------------------
  !> LU 分解: ndim x ndim の行列 jdim 個を一度に計算
  !> @note
  !> LU 行列は入力に上書きされる
  subroutine lumake(alu, kp, jdim, ndim)
    implicit none
    integer, intent(in)    :: jdim
    integer, intent(in)    :: ndim
    integer, intent(out)   :: kp(jdim, ndim)
    real(DP), intent(inout) :: alu(jdim, ndim, ndim)
    integer :: j, k, m, n
    real(DP) :: pivot, temp
   !$omp parallel do default(shared) private(j,k,m,n,pivot,temp) schedule(static)
    do j = 1, jdim
      do k = 1, ndim-1
        pivot   = alu(j,k,k)
        kp(j,k) = k
        do m = k+1, ndim
          if (abs(alu(j,m,k)) > abs(pivot)) then
            pivot   = alu(j,m,k)
            kp(j,k) = m
          end if
        end do
        if (kp(j,k) /= k) then
          do n = 1, ndim
            temp             = alu(j,k,n)
            alu(j,k,n)       = alu(j,kp(j,k),n)
            alu(j,kp(j,k),n) = temp
          end do
        end if
        do n = k+1, ndim
          alu(j,k,n) = alu(j,k,n) / pivot
          do m = k+1, ndim
            alu(j,m,n) = alu(j,m,n) - alu(j,m,k) * alu(j,k,n)
          end do
        end do
      end do
    end do
    !$omp end parallel do
  end subroutine lumake
  !---------------------------------------------------------------------
  !> LU 分解: ndim x ndim の行列一個を計算
  !> @note
  !> LU 行列は入力に上書き
  subroutine lumak1(alu, kp, ndim)
    implicit none
    integer, intent(in)       :: ndim
    real(DP), intent(inout)   :: alu(ndim,ndim)
    integer, intent(out)      :: kp(ndim)
    integer  :: k, m, n
    real(DP) :: pivot, temp
    do k = 1, ndim-1
      pivot = alu(k,k)
      kp(k) = k
      do m = k+1, ndim
        if (abs(alu(m,k)) > abs(pivot)) then
          pivot = alu(m,k)
          kp(k) = m
        end if
      end do
      if (kp(k) /= k) then
        do n = 1, ndim
          temp      = alu(k,n)
          alu(k,n)  = alu(kp(k),n)
          alu(kp(k),n) = temp
        end do
      end if
      !$omp parallel default(shared)
      !$omp do
      do n = k+1, ndim
        alu(k,n) = alu(k,n) / pivot
      end do
      !$omp end do
      !$omp do
      do n = k+1, ndim
        do m = k+1, ndim
          alu(m,n) = alu(m,n) - alu(m,k) * alu(k,n)
        end do
      end do
      !$omp end do
      !$omp end parallel
    end do
  end subroutine lumak1
  !---------------------------------------------------------------------
  !> 求解: ndim x ndim 行列を jdim 個並べた連立方程式
  !> AX = B を idim 個 の Bについて計算する.
  !> @note
  !> 解は右辺入力ベクトルに上書き
  subroutine lusolv(xv, alu, kp, idim, jdim, ndim)
    implicit none
    integer, intent(in)     :: idim
    integer, intent(in)     :: jdim
    integer, intent(in)     :: ndim
    real(DP), intent(inout) :: xv(idim, jdim, ndim)
    real(DP), intent(in)    :: alu(jdim, ndim, ndim)
    integer, intent(in)     :: kp(jdim, ndim)
    integer                 :: i, j, k, n, nn
    real(DP)                :: temp
    !$omp parallel do default(shared) private(i,j,k,n,nn,temp) schedule(static)
    do j = 1, jdim
      do k = 1, ndim-1
        do i = 1, idim
          if (kp(j,k) /= k) then
            temp            = xv(i,j,k)
            xv(i,j,k)       = xv(i,j,kp(j,k))
            xv(i,j,kp(j,k)) = temp
          end if
        end do
      end do
      do n = 1, ndim
        do i = 1, idim
          xv(i,j,n) = xv(i,j,n) / alu(j,n,n)
          do nn = n+1, ndim
            xv(i,j,nn) = xv(i,j,nn) - xv(i,j,n) * alu(j,nn,n)
          end do
        end do
      end do
      do k = ndim-1, 1, -1
        do n = k+1, ndim
          do i = 1, idim
            xv(i,j,k) = xv(i,j,k) - xv(i,j,n) * alu(j,k,n)
          end do
        end do
      end do
    end do
    !$omp end parallel do
  end subroutine lusolv
  !---------------------------------------------------------------------
  !> 求解: ndim x ndim 行列を jdim 個並べた連立方程式
  !> AX = B を jdim 個 の Bについて計算する.
  !> @note
  !> 解は右辺入力ベクトルに上書き
  subroutine lusol3(xv, alu, kp, jdim, ndim)
    implicit none
    integer, intent(in)     :: jdim
    integer, intent(in)     :: ndim
    real(DP), intent(inout) :: xv(jdim, ndim)
    real(DP), intent(in)    :: alu(jdim, ndim, ndim)
    integer, intent(in)     :: kp(jdim, ndim)
    real(DP)                :: temp
    integer                 :: j, k, n, nn
    !$omp parallel do default(shared) private(j,k,n,nn,temp) schedule(static)
    do j = 1, jdim
      do k = 1, ndim-1
        if (kp(j,k) /= k) then
          temp         = xv(j,k)
          xv(j,k)      = xv(j,kp(j,k))
          xv(j,kp(j,k)) = temp
        end if
      end do
      do n = 1, ndim
        xv(j,n) = xv(j,n) / alu(j,n,n)
        do nn = n+1, ndim
          xv(j,nn) = xv(j,nn) - xv(j,n) * alu(j,nn,n)
        end do
      end do
      do k = ndim-1, 1, -1
        do n = k+1, ndim
          xv(j,k) = xv(j,k) - xv(j,n) * alu(j,k,n)
        end do
      end do
    end do
    !$omp end parallel do
  end subroutine lusol3
  !---------------------------------------------------------------------
  !> 求解: ndim x ndim 型行列の連立方程式 A X = B を idim 個の B に対して計算.
  !> [LUSOLV](@ref lusolv) の JDIM = 1 に相当
  !> @note
  !> * 解は右辺の入力ベクトルに上書きされる.
  !> * JDIM=1 には際のベクトル長が短くなるためこのルーチンを用意
  subroutine lusol2(xv, alu, kp, idim, ndim)
    implicit none
    integer, intent(in)      :: idim
    integer, intent(in)      :: ndim
    real(DP), intent(inout)  :: xv(idim, ndim)
    real(DP), intent(in)     :: alu(ndim,ndim)
    integer, intent(in)      :: kp(ndim)
    integer  :: i, k, n, nn
    real(DP) :: temp
    !$omp parallel do default(shared) private(i,k,temp) schedule(static)
    do i = 1, idim
      do k = 1, ndim-1
        if (kp(k) /= k) then
          temp       = xv(i,k)
          xv(i,k)    = xv(i,kp(k))
          xv(i,kp(k)) = temp
        end if
      end do
    end do
    !$omp end parallel do
    !$omp parallel do default(shared) private(i,n,nn) schedule(static)
    do i = 1, idim
      do n = 1, ndim
        xv(i,n) = xv(i,n) / alu(n,n)
        do nn = n+1, ndim
          xv(i,nn) = xv(i,nn) - xv(i,n) * alu(nn,n)
        end do
      end do
    end do
    !$omp end parallel do
    !$omp parallel do default(shared) private(i,k,n) schedule(static)
    do i = 1, idim
      do k = ndim-1, 1, -1
        do n = k+1, ndim
          xv(i,k) = xv(i,k) - xv(i,n) * alu(k,n)
        end do
      end do
    end do
    !$omp end parallel do
  end subroutine lusol2
end module lumatrix

!--
!----------------------------------------------------------------------
!     Copyright (c) 2020 SPMODEL Development Group.
!----------------------------------------------------------------------
!表題  w_interpolate_module
!
!  spml/w_wave_interpolate_module モジュールは球面上での 
!  2 次元流体運動を球面調和函数を用いたスペクトル法によって
!  東西 1 波数数値計算するためのモジュール w_wave_module の
!  下部モジュールであり, スペクトル法による補間計算のための 
!  Fortran90 関数を提供する. 
!
!  補間計算の方法については doc/w_module.tex を参照のこと. 
!  このサブルーチンは内部で ISPACK3 の LXPACK のサブルーチンを
!  呼んでいない. 
!
!履歴  2020/11/24  竹広真一 w_wave_interpolate_module_svpack より改造
!
!
!++
module w_wave_module_interpolate
  !
  !=  w_wave_interpolate_module
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: w_wave_interpolate_module.f90 590 2013-08-19 08:48:21Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  !  spml/w_wave_interpolate_module モジュールは球面上での 
  !  2 次元流体運動を球面調和函数を用いたスペクトル法によって
  !  東西 1 波数数値計算するためのモジュール w_wave_module の
  !  下部モジュールであり, スペクトル法による補間計算のための 
  !  Fortran90 関数を提供する. 
  !
  ! 内部で ISPACK の SPPACK と SNPACK の Fortran77 サブルーチンを呼んでいる. 
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SNPACK,SPPACK のマニュアルを参照されたい.
  !
  use dc_message, only : MessageNotify
  use spml_utils, only : gammaln
  use w_wave_module_base, only : nm=>nn, m, l_nm
  implicit none
  private

  public Interpolate_w                        ! 補間関数

  interface Interpolate_w
     !
     ! 緯度 alon, 経度 alat における関数値を
     ! その球面調和変換係数 w_data から補間計算する
     !
     ! 入力する緯度経度座標は, 
     !       １点, 経度1点緯度複数点, 経度複数点緯度1点, 経度緯度複数点
     ! の 4 種類
     !
     module procedure Interpolate_array00_w
  end interface

  interface alpha
     module procedure alpha_array0
  end interface alpha

  interface Pmm
     module procedure Pmm_array0
  end interface Pmm

contains

  !--------------- 補間計算 -----------------
  function Interpolate_array00_w(w_data,alon,alat)
    !
    ! 緯度 alat, 経度 alon における関数値を
    ! その球面調和変換係数 w_data から補間計算する
    !
    real(8), intent(IN) :: w_data(2*(nm-m+1))     ! スペクトルデータ
    real(8), intent(IN) :: alon                   ! 補間する位置(経度)
    real(8), intent(IN) :: alat                   ! 補間する位置(緯度)
    real(8)             :: Interpolate_array00_w  ! 補間した値

    real(8) :: mu
    real(8) :: y0, y1, y2, AnmPnm
    integer :: k, m4

    m4 = m
    mu = sin(alat)
    Interpolate_array00_w = 0.0D0

    !----  Σ Re[s_n^m] P_n^m exp(imλ)の計算
    y2 = 0 ; y1 = 0
    do k=nm,m+1,-1
       y0 = alpha(k,m4,mu) * y1 + beta(k+1,m4) * y2 + w_data(l_nm(k,m4))
       y2 = y1 ; y1 = y0
    enddo

    AnmPnm =(w_data(l_nm(m4,m4)) + beta(m4+1,m4)*y2 &
         + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m4,mu)

    Interpolate_array00_w = Interpolate_array00_w &
         + AnmPnm * 2 * cos(m*alon)
    !----  Σ Im[s_n^m] P_n^m exp(imλ)の計算
    y2 = 0 ; y1 = 0
    do k=nm,m+1,-1
       y0 = alpha(k,m4,mu) * y1 + beta(k+1,m4)*y2 + w_data(l_nm(k,-m4))
       y2 = y1 ; y1 = y0
    enddo

    AnmPnm =(w_data(l_nm(m4,-m4)) + beta(m4+1,m4)*y2 &
         + mu*sqrt(2.0D0*m+3)*y1 ) * Pmm(m4,mu)


    Interpolate_array00_w = Interpolate_array00_w &
         - AnmPnm * 2 * sin(m*alon)

  end function Interpolate_array00_w

  !--------------- 下部ルーチン -----------------
  function alpha_array0(n,m,x)
    !
    !  漸化式の P_n^m の係数
    !
    integer, intent(IN) :: n,m 
    real(8), intent(IN) :: x
    real(8)             :: alpha_array0

    alpha_array0 = sqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n-m+1)*(n+m+1)) ) * x
  end function alpha_array0

  function beta(n,m)
    !
    !  漸化式の P_{n-1}^m の係数
    !
    integer, intent(IN) :: n
    integer, intent(IN) :: m 
    real(8)             :: beta
    beta = - sqrt( (2.0D0*n+3)*(n+m)*(n-m)/((2*n-1)*(n+m+1)*(n-m+1)) )

  end function beta

  function Pmm_array0(m,x)
    !
    ! ルジャンドル陪函数 P_m^m(x) の計算
    !         sqrt( factrl(2*m+1) )/(2.0D0**m * factrl(m)) &
    !          * (1-x**2)**(m/2.0D0)
    !
    ! 係数が発散しないように対数で計算する
    !
    integer, intent(IN) :: m           ! ルジャンドル陪函数の次数
    real(8), intent(IN) :: x           ! 引き数
    real(8)             :: Pmm_array0  ! ルジャンドル陪函数の値

    if ( m < 0 ) call MessageNotify('E','Pmm in w_Intepolate_module',&
         'order m should be larger equal to zero')

    Pmm_array0 = 1.0
    if ( m > 0 )then
       Pmm_array0 = &
            exp(gammaln(2.0D0*m+2.0)/2.0D0 - m*log(2.0D0) - gammaln(m+1.0D0)) &
            * (1-x**2)**(m/2.0D0)
    endif
  end function Pmm_array0

end module w_wave_module_interpolate

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXTSMV(MM,NM,NN,IM,JM,S1,S2,G1,G2,IT,T,P,R,JC,W,IPOW,MI)

  USE ISO_C_BINDING
  IMPLICIT NONE
  INTEGER(8) :: MM,NM,NN,IM,JM,JV,JR,M,IE,IJ,JD,NS,IPOW,MI
  REAL(8) ::  S1((MM/MI+1)*(2*(NN+1)-MM/MI*MI)),G1(JM*IM)
  REAL(8) ::  S2((MM/MI+1)*(2*(NN+1)-MM/MI*MI)),G2(JM*IM)
  REAL(8) :: T(IM*3/2),P(JM/2,5+2*(MM/MI+1)),R(*)
  INTEGER(8) :: IT(IM/2),JC(*)
  REAL(8) :: W(JM*IM,2)
  TYPE(C_PTR),DIMENSION(:),ALLOCATABLE :: WP(:)
  REAL(8),DIMENSION(:),POINTER:: WORK
  INTEGER(8) :: NPMAX
  INTEGER(8) :: MN,M1,N1,K
  INTEGER :: IP,NP
  LOGICAL,DIMENSION(:),ALLOCATABLE :: LP(:)
  TYPE(C_PTR),DIMENSION(:),ALLOCATABLE :: WSP(:)
  REAL(8),DIMENSION(:),POINTER:: WS(:)

!$    INTEGER :: omp_get_thread_num

  CALL SXGPRM(JM,JV,JR)
  IF(MOD(JR,2_8).EQ.0) JR=JR/2

  CALL MXGOMP(NPMAX)

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  NP=INT(MIN(MN+1,NPMAX))
  IP=0
  ALLOCATE(WP(0:NP-1))
  ALLOCATE(WSP(0:NP-1))
  ALLOCATE(LP(0:NP-1))
  LP=.FALSE.
  IP=0

!$omp parallel private(NS,IP,IJ,IE,M,WORK,WS) num_threads(NP)
!$omp do schedule(dynamic)
  DO K=0,MN-1
     !$      IP=omp_get_thread_num()
     IF(.NOT.LP(IP)) THEN
        CALL MXALLC(WP(IP),JV*11*JR)
        CALL C_F_POINTER(WP(IP),WORK,[JV*11*JR])
        CALL MXALLC(WSP(IP),4*(NM+1))
        CALL C_F_POINTER(WSP(IP),WS,[4*(NM+1)])
        LP(IP)=.TRUE.
     END IF
     IE=5*K*(2*NM-MI*(K-1))/4+K+1
     IJ=K*(2*NM-MI*(K-1))/16+K+1
     M=K*MI
     NS=K*(2*(NN+1)-(K-1)*MI)+1
     IF(M.EQ.0) THEN
        CALL LXSSZV(NM,NN,JM,JV,JR,S1,S2,W(1,1),W(1,2),P,R,WORK,WS,IPOW,0_8)
     ELSE
        CALL LXSSWV(NM,NN,JM,JV,JR,M,S1(NS),S2(NS),&
             &        W(1+M/MI*2*JM,1),W(1+M/MI*2*JM,2),P,P(1,6+K*2), &
             &        R(IE),JC(IJ),WORK,WS,IPOW,0_8)
     END IF
  END DO
!$omp end do
!$omp end parallel

  DO IP=0,NP-1
     IF(LP(IP)) THEN
        CALL MXFREE(WP(IP))
        CALL MXFREE(WSP(IP))
     END IF
  END DO

  DEALLOCATE(WSP)
  DEALLOCATE(WP)
  DEALLOCATE(LP)

  NP=INT(MIN(JM/JV,NPMAX))
  ALLOCATE(WP(0:NP-1))
  ALLOCATE(LP(0:NP-1))
  LP=.FALSE.
  IP=0
!$omp parallel private(IP,WORK) num_threads(NP)
!$omp do schedule(dynamic)
  DO JD=1,JM/JV
!$      IP=omp_get_thread_num()
     IF(.NOT.LP(IP)) THEN
        CALL MXALLC(WP(IP),JV*IM)
        CALL C_F_POINTER(WP(IP),WORK,[JV*IM])
        LP(IP)=.TRUE.
     END IF
     IF(JV.EQ.4) THEN
        CALL SXQTB1(JM/JV,MM/MI,IM,W(1+2*JV*(JD-1),1),WORK)
     ELSE IF(JV.EQ.8) THEN
        CALL SXOTB1(JM/JV,MM/MI,IM,W(1+2*JV*(JD-1),1),WORK)
     ELSE
        CALL SXLTB1(JV,JM/JV,MM/MI,IM,W(1+2*JV*(JD-1),1),WORK)
     END IF
     CALL FXRTBA(JV,IM,WORK,IT,T)
     IF(JV.EQ.4.AND.MOD(IM,4_8).EQ.0) THEN
        CALL SXQTB2(IM,WORK,G1(1+JV*IM*(JD-1)))
     ELSE IF(JV.EQ.8.AND.MOD(IM,8_8).EQ.0) THEN
        CALL SXOTB2(IM,WORK,G1(1+JV*IM*(JD-1)))
     ELSE
        CALL SXLTB2(JV,IM,WORK,G1(1+JV*IM*(JD-1)))
     END IF
  END DO
!$omp end do
!$omp end parallel
  DO IP=0,NP-1
     IF(LP(IP)) THEN
        CALL MXFREE(WP(IP))
     END IF
  END DO

  LP=.FALSE.
  IP=0
!$omp parallel private(IP,WORK) num_threads(NP)
!$omp do schedule(dynamic)
  DO JD=1,JM/JV
!$      IP=omp_get_thread_num()
     IF(.NOT.LP(IP)) THEN
        CALL MXALLC(WP(IP),JV*IM)
        CALL C_F_POINTER(WP(IP),WORK,[JV*IM])
        LP(IP)=.TRUE.
     END IF
     IF(JV.EQ.4) THEN
        CALL SXQTB1(JM/JV,MM/MI,IM,W(1+2*JV*(JD-1),2),WORK)
     ELSE IF(JV.EQ.8) THEN
        CALL SXOTB1(JM/JV,MM/MI,IM,W(1+2*JV*(JD-1),2),WORK)
     ELSE
        CALL SXLTB1(JV,JM/JV,MM/MI,IM,W(1+2*JV*(JD-1),2),WORK)
     END IF
     CALL FXRTBA(JV,IM,WORK,IT,T)
     IF(JV.EQ.4.AND.MOD(IM,4_8).EQ.0) THEN
        CALL SXQTB2(IM,WORK,G2(1+JV*IM*(JD-1)))
     ELSE IF(JV.EQ.8.AND.MOD(IM,8_8).EQ.0) THEN
        CALL SXOTB2(IM,WORK,G2(1+JV*IM*(JD-1)))
     ELSE
        CALL SXLTB2(JV,IM,WORK,G2(1+JV*IM*(JD-1)))
     END IF
  END DO
!$omp end do
!$omp end parallel

  DO IP=0,NP-1
     IF(LP(IP)) THEN
        CALL MXFREE(WP(IP))
     END IF
  END DO

  DEALLOCATE(WP)
  DEALLOCATE(LP)

END SUBROUTINE SXTSMV

! -*- mode: f90; coding: utf-8 -*-
!-------------------------------------------------------------------------
! Copyright (c) 2002-2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2019/03/13  竹広真一
!       2019/10/04  佐々木洋平
!-------------------------------------------------------------------------
!> @copyright Copyright (C) SPMODEL Development Group, 2002-2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @brief
!> @ref wa_module の下部モジュール: 基本変換
!>
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは @ref wa_module を呼ぶこと．
!--
!----------------------------------------------------------------------
!     Copyright (c) 2002-2013 SPMDOEL Development Group
!----------------------------------------------------------------------
!表題  wa_base_module_svpack
!
!  spml/wa_base_module_svpack モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための
!  モジュール wa_module_svpack の下部モジュールであり, スペクトル計算の
!  基本的な Fortran90 関数を提供する.
!
!  球面上の 1 層モデル用 w_base_module_svpack モジュールを多層モデル用に
!  拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
!  対する変換が行える.
!
!  内部で ISPACK の SVPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK/SVPACK のマニュアルを参照されたい.
!
!  このモジュールを使うためには前もって w_base_initial を呼んで
!  切断波数, 格子点数の設定をしておく必要がある.
!
!++
module wa_module_base
  !
  != wa_base_module_svpack
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id$
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/wa_base_module_svpack モジュールは球面上での流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための
  ! モジュール wa_module_svpack の下部モジュールであり, スペクトル計算の
  ! 基本的な Fortran90 関数を提供する.
  !
  ! 球面上の 1 層モデル用 w_base_module_svpack モジュールを多層モデル用に
  ! 拡張したものであり, 同時に複数個のスペクトルデータ, 格子点データに
  ! 対する変換が行える.
  !
  ! 内部で ISPACK の SVPACK の Fortran77 サブルーチンを呼んでいる.
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK/SVPACK のマニュアルを参照されたい.
  !
  ! このモジュールを使うためには前もって w_base_initial を呼んで
  ! 切断波数, 格子点数の設定をしておく必要がある.
  !
  use dc_types, only: DP
  use dc_message, only: MessageNotify
  use w_module_base, only : &
    & im, jm, nm=>nn, xy_w, w_xy, &
    & w_StreamPotential2Vector,   &
    & w_Vector2VorDiv, w_VectorCosLat2VorDiv
  implicit none
  private
  !> 同時に処理する最大データ数(層の数): SNPACK 用ルーチンとの互換性のため.
  integer(8) :: km=16
  public km                            ! 層数
  public wa_base_Initial               ! 初期化サブルーチン
  public wa_base_Finalize              ! 終了処理
  public xya_wa                        ! 変換関数
  public wa_xya                        ! 変換関数
  public wa_StreamPotential2Vector     ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDiv              ! 速度場から渦度発散を計算
  public wa_VectorCosLat2VorDiv        ! 速度場から渦度発散を計算
  save km                              ! 最大データ数(層数)を記憶
contains
  !----------------------------------------------------------
  !> SNPACK 用 wa_base_initial の互換のためのダミーサブルーチン
  subroutine wa_base_initial(k_in)
    !> 最大データ数(層数)
    integer,intent(in) :: k_in

    km = k_in
    call MessageNotify('M','wa_base_initial: dummy',&
      'No need to set maximum level number and in wa_base_module')

  end subroutine wa_base_Initial

  !----------------------------------------------------------
  !> 球面調和関数スペクトル -> 格子点:
  !> スペクトルデータから格子点へと逆変換する(多層用)
  !>
  function xya_wa(wa_data,ipow,iflag)
    !> スペクトルデータ((nm+1)*(nm+1),:)
    real(DP), intent(in)   :: wa_data(:,:)
    !> 格子点データ(0:im-1,1:jm,:)
    real(DP)               :: xya_wa(0:im-1,1:jm,size(wa_data,2))
    !> 作用させる 1/cosφ の次数. 省略時は 0.
    integer, intent(in), optional  :: ipow
    !> 変換の種類. 省略時は 0
    !> *  0 : 通常の正変換
    !> * -1 : 経度微分を作用させた逆変換
    !> *  1 : 緯度微分 \f$cosφ・∂/∂φ \f$ を作用させた逆変換
    !> *  2 : \f$sinφ\f$を作用させた逆変換
    integer, intent(in), optional  :: iflag

    integer, parameter  :: ipow_default  = 0
    integer, parameter  :: iflag_default = 0
    integer ipval, ifval
    integer k

    if (present(ipow)) then
      ipval = ipow
    else
      ipval = ipow_default
    endif

    if (present(iflag)) then
      ifval = iflag
    else
      ifval = iflag_default
    endif

    do k=1,size(wa_data,2)
      xya_wa(:,:,k) = xy_w(wa_data(:,k),iflag=ifval,ipow=ipval)
    enddo

  end function xya_wa

  !----------------------------------------------------------
  !> 格子点 -> 球面調和関数スペクトル:
  !> 格子データからスペクトルデータへ(正)変換する(多層用).
  !>
  function wa_xya(xya_data,ipow,iflag) !
    !> 格子点データ(0:im-1,1:jm,:)
    real(DP), intent(in)   :: xya_data(0:,:,:)
    !> スペクトルデータ((nm+1)*(nm+1),:)
    real(DP)               :: wa_xya((nm+1)*(nm+1),size(xya_data,3))
    !> 変換時に同時に作用させる \f$1/cosφ\f$ の次数. 省略時は 0.
    integer, intent(in), optional  :: ipow
    !> 変換の種類. 省略時は 0
    !> *   0 : 通常の正変換
    !> *  -1 : 経度微分を作用させた正変換
    !> *   1 : 緯度微分 \f$1/cosφ・∂(f \cos^2φ)/∂φ\f$ を作用させた正変換
    !> *   2 : \f$sinφ\f$を作用させた正変換
    integer, intent(in), optional  :: iflag

    ! スイッチデフォルト値
    integer, parameter  :: ipow_default  = 0
    integer, parameter  :: iflag_default = 0

    integer ipval
    integer ifval
    integer k

    if (present(ipow)) then
      ipval = ipow
    else
      ipval = ipow_default
    endif

    if (present(iflag)) then
      ifval = iflag
    else
      ifval = iflag_default
    endif

    do k=1,size(xya_data,3)
      wa_xya(:,k) = w_xy(xya_data(:,:,k),iflag=ifval,ipow=ipval)
    enddo

  end function wa_xya

  !----------------------------------------------------------
  !> 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
  !> (逆)変換する(多層用)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !>\f{align*}{
  !>   u \cosφ & =       ∂χ/∂λ - \cosφ∂ψ/∂φ, \\
  !>   v \cosφ   = \cosφ∂χ/∂φ +       ∂ψ/∂λ
  !>\f}
  subroutine wa_StreamPotential2Vector(wa_Psi, wa_Chi, xya_U, xya_V)
    !> 流線関数((nm+1)*(nm+1),:)
    real(DP), intent(in)   :: wa_Psi(:,:)
    !> 速度ポテンシャル((nm+1)*(nm+1),:)
    real(DP), intent(in)   :: wa_Chi(:,:)
    !> 速度経度成分(0:im-1,1:jm,:)
    real(DP), intent(out)   :: xya_U(0:im-1,1:jm,size(wa_Psi,2))
    !> 速度緯度成分(0:im-1,1:jm,:)
    real(DP), intent(out)   :: xya_V(0:im-1,1:jm,size(wa_Psi,2))

    integer :: k

    do k=1,size(wa_Psi,2)
      call w_StreamPotential2Vector( &
        & wa_Psi(:,k), wa_Chi(:,k), xya_U(:,:,k), xya_V(:,:,k) )
    enddo

  end subroutine wa_StreamPotential2Vector

  !----------------------------------------------------------
  !> 速度場(格子データ)から渦度・発散(スペクトルデータ)に
  !> (正)変換する(多層用)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !> \f{align*}{
  !>   ζ & = 1/\cosφ ∂v/∂λ - 1/\cosφ ∂(u \cosφ)/∂φ, \\
  !>    D   = 1/\cosφ ∂u/∂λ + 1/\cosφ ∂(v \cosφ)/∂φ
  !>\f}
  subroutine wa_Vector2VorDiv(xya_U, xya_V, wa_Vor, wa_Div)
    !> 速度経度成分(0:im-1,1:jm,:)
    real(DP), intent(in)   :: xya_U(0:,:,:)
    !> 速度緯度成分(0:im-1,1:jm,:)
    real(DP), intent(in)   :: xya_V(0:,:,:)
    !> 流線関数
    real(DP), intent(out)   :: wa_Vor((nm+1)*(nm+1),size(xya_U,3))
    !> 速度ポテンシャル
    real(DP), intent(out)   :: wa_Div((nm+1)*(nm+1),size(xya_U,3))

    integer :: k

    do k=1,size(xya_U,3)
      call w_Vector2VorDiv( &
        & xya_U(:,:,k), xya_V(:,:,k), wa_Vor(:,k), wa_Div(:,k))
    enddo
  end subroutine wa_Vector2VorDiv

  !----------------------------------------------------------
  !> 速度場(格子データ)から渦度・発散(スペクトルデータ)に
  !> (正)変換する(多層用)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !> \f{align*}{
  !>   ζ & = 1/\cosφ∂v/∂λ - 1/\cosφ ∂(u \cosφ)/∂φ, \\
  !>    D & = 1/\cosφ∂u/∂λ + 1/\cosφ ∂(v \cosφ)/∂φ
  !> \f}
  subroutine wa_VectorCosLat2VorDiv(xya_UCosLat, xya_VCosLat, wa_Vor, wa_Div)
    !> 速度経度成分 * cos(lat) (0:im-1,1:jm,:)
    real(DP), intent(in)   :: xya_UCosLat(0:,:,:)
    !> 速度緯度成分 * cos(lat) (0:im-1,1:jm,:)
    real(DP), intent(in)   :: xya_VCosLat(0:,:,:)
    !> 流線関数
    real(DP), intent(out)   :: wa_Vor((nm+1)*(nm+1),size(xya_UCosLat,3))
    !> 速度ポテンシャル
    real(DP), intent(out)   :: wa_Div((nm+1)*(nm+1),size(xya_UCosLat,3))

    integer :: k

    do k=1,size(xya_UCosLat,3)
      call w_VectorCosLat2VorDiv &
        (xya_UCosLat(:,:,k), xya_VCosLat(:,:,k), wa_Vor(:,k), wa_Div(:,k))
    enddo
  end subroutine wa_VectorCosLat2VorDiv

  !----------------------------------------------------------
  !> 後方互換性のためのダミールーチン.
  !> 上位サブルーチン wa_Finalize を使用すること.
  !>
  subroutine wa_base_Finalize
    call MessageNotify('M','wa_base_finalize: dummy', &
      & 'wa_base_module is finalized')

  end subroutine wa_base_Finalize

end module wa_module_base

!----------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_base_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2019/03/13  竹広真一
!     2020/11/06  竹広真一 セクター計算テスト
!
program w_base_module_mint_test
  use dc_types, only: DP
  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_module_mint
  use spml_utils, only: pi
  implicit none

!  integer, parameter :: im=32, jm=16, nm=10, mint=1
  integer, parameter :: im=32, jm=16, nm=10, mint=2
  integer, parameter :: nc=(nm/mint+1)*(2*(nm+1)-nm/mint*mint)
  
  real(DP), dimension(nc)            ::  w_data
  real(DP), dimension(0:im-1,1:jm)   ::  xy_data
  real(DP), dimension(0:im-1,1:jm)   ::  xy_Ddata

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  call MessageNotify('M','w_base_module', &
                         'w_base_module functions tests')

  call w_Initial( nm, im, jm, mint=mint )

  !==================== Y_1^0 のテスト ====================
  xy_data = sqrt(3.0D0)*sin(xy_Lat)                      ! Y_1^0
  w_data= 0.0D0 ; w_data(l_nm(1,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_1^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(3.0D0) * ( cos(xy_Lat)**2 - 2*sin(xy_Lat)**2 )
  call AssertEqual(&      ! (1/\cos\phi)d/\phi(f\cos^2\phi)
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(3.0D0)*cos(xy_Lat)
  call AssertEqual(&      ! df/\phi
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(3.0D0) * sin(xy_Lat)**2
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_1^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_1^0','Test of Y_1^0 succeeded!')


  !==================== Y_2^0 のテスト ====================
  xy_data = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)                 ! Y_2^0
  w_data= 0.0D0 ; w_data(l_nm(2,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0)*(   3.0*sin(xy_Lat)*cos(xy_Lat)**2  &
                           - 3.0*sin(xy_Lat)**3 + sin(xy_Lat)  )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0)*3.0*sin(xy_Lat)*cos(xy_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0)*(3.0/2*sin(xy_Lat)**2-1/2.0)*sin(xy_Lat)
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^0','Test of Y_2^0 succeeded!')


  !==================== Y_2^2 のテスト ====================
  xy_data = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*cos(2*xy_Lon)         ! Y_2^2
  w_data= 0.0D0 ; w_data(l_nm(2,2))=1.0D0/2.0D0
  
  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2* (-2)* sin(2*xy_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = - sqrt(5.0D0/24)*3.0*4*sin(xy_Lat)*cos(xy_Lat)**2*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = -sqrt(5.0D0/24)*3.0*2*cos(xy_Lat)*sin(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^2 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^2','Test of Y_2^2 succeeded!')

  !==================== Y_2^-2 のテスト ====================
  xy_data = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(2*xy_Lon)         ! Y_2^-2
  w_data= 0.0D0 ; w_data(l_nm(2,-2))=1.0D0/2.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_2^-2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data))',                 &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2* 2*cos(2*xy_Lon)  ! Y_2^2
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=-1))',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=-1)',        &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = sqrt(5.0D0/24)*3.0*4*sin(xy_Lat)*cos(xy_Lat)**2*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(5.0D0/24)*3.0*2*cos(xy_Lat)*sin(xy_Lat)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',  &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = -sqrt(5.0D0/24)*3.0*cos(xy_Lat)**2*sin(xy_Lat)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data,iflag=2))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_2^-2 Test of xy_w(w_xy(xy_data),iflag=2)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_2^-2','Test of Y_2^-2 succeeded!')

  !==================== Y_4^0 のテスト ====================
  xy_data = sqrt(9.0D0)*(35.0/8*sin(xy_Lat)**4-30.0/8*sin(xy_Lat)**2+3.0/8) ! Y_4^0
  w_data= 0.0D0 ; w_data(l_nm(4,0))=1.0D0

  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_4^0 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^0 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = 0.0D0
  call AssertEqual(&
    message='Y_4^0 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^0 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = -2*sin(xy_Lat)*xy_data &
       + sqrt(9.0D0)*(35.0/2*sin(xy_Lat)**3-30.0/4*sin(xy_Lat))*cos(xy_Lat)**2
  call AssertEqual(&
    message='Y_4^0 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(9.0D0)*(35.0/2*sin(xy_Lat)**3-30.0/4*sin(xy_Lat))*cos(xy_Lat)
  call AssertEqual(&
    message='Y_4^0 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(9.0D0)*(35.0/8*sin(xy_Lat)**4-30.0/8*sin(xy_Lat)**2+3.0/8)*sin(xy_Lat)

  call AssertEqual(&
    message='Y_4^0 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^0 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_4^0','Test of Y_4^0 succeeded!')


  !==================== Y_4^2 のテスト ====================
  xy_data = sqrt(9.0D0/360)*15.0/2*cos(xy_Lat)**2*(7*sin(xy_Lat)**2-1)*cos(2*xy_Lon)         ! Y_4^2
  w_data= 0.0D0 ; w_data(l_nm(4,2))=1.0D0/2.0D0
  
  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_4^2 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^2 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = sqrt(9.0D0/360)*15.0/2*cos(xy_Lat)**2*(7*sin(xy_Lat)**2-1) &
       * (-2)*sin(2*xy_Lon)
  call AssertEqual(&
    message='Y_4^2 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^2 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = -2*sin(xy_Lat)*xy_data &
       + sqrt(9.0D0/360)*( &
             - 15.0*sin(xy_Lat)*cos(xy_Lat)*(7*sin(xy_Lat)**2-1)  &
             + 15.0/2*cos(xy_Lat)**2*14*sin(xy_Lat)*cos(xy_Lat)  )&
          *cos(xy_Lat)*cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_4^2 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = sqrt(9.0D0/360) &
       * ( -15.0*sin(xy_Lat)*cos(xy_Lat)*(7*sin(xy_Lat)**2-1)    &
           +15.0/2*cos(xy_Lat)**2*14*sin(xy_Lat)*cos(xy_Lat)   ) &
       *cos(2*xy_Lon)
  call AssertEqual(&
    message='Y_4^2 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(9.0D0/360)*15.0/2*cos(xy_Lat)**2*(7*sin(xy_Lat)**2-1)*sin(xy_Lat)*cos(2*xy_Lon)         ! Y_4^2
  call AssertEqual(&
    message='Y_4^2 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^2 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_4^2','Test of Y_4^2 succeeded!')

  !==================== Y_4^4 のテスト ====================
  xy_data = sqrt(9.0D0/40320)*105.0*cos(xy_Lat)**4*cos(4*xy_Lon)         ! Y_4^4
  w_data= 0.0D0 ; w_data(l_nm(4,4))=1.0D0/2.0D0
  
  !---- 通常変換 ----
  call AssertEqual(&
    message='Y_4^4 Test of w_xy(xy_data)',                        &
    answer = w_data,                                              &
    check = w_xy(xy_data),                                        &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^4 Test of xy_w(w_xy(xy_data))',                  &
    answer = xy_data,                                             &
    check = xy_w(w_xy(xy_data)),                                  &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- X 微分変換 ----
  xy_Ddata = sqrt(9.0D0/40320)*105.0*cos(xy_Lat)**4 *(-4)*sin(4*xy_Lon)
  call AssertEqual(&
    message='Y_4^4 Test of xy_w(w_xy(xy_data,iflag=-1))',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=-1)),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^4 Test of xy_w(w_xy(xy_data),iflag=-1)',         &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=-1),                         &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- Y 微分変換 ----
  xy_Ddata = -sqrt(9.0D0/40320)*105.0*6*cos(xy_Lat)**4*sin(xy_Lat)*cos(4*xy_Lon) 
  call AssertEqual(&
    message='Y_4^4 Test of xy_w(w_xy(xy_data,iflag=1,ipow=0))',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=1,ipow=0)),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  xy_Ddata = -sqrt(9.0D0/40320)*105.0*4*cos(xy_Lat)**3*sin(xy_Lat)*cos(4*xy_Lon)
  call AssertEqual(&
    message='Y_4^4 Test of xy_w(w_xy(xy_data),iflag=1,ipow=1)',   &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=1,ipow=1),                   &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- SIN 掛け算変換 ----
  xy_Ddata = sqrt(9.0D0/40320)*105.0*cos(xy_Lat)**4*cos(4*xy_Lon)*sin(xy_Lat)
  call AssertEqual(&
    message='Y_4^4 Test of xy_w(w_xy(xy_data,iflag=2))',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data,iflag=2)),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )
  call AssertEqual(&
    message='Y_4^4 Test of xy_w(w_xy(xy_data),iflag=2)',          &
    answer = xy_Ddata,                                            &
    check = xy_w(w_xy(xy_data),iflag=2),                          &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call MessageNotify('M','Test of Y_4^4','Test of Y_4^4 succeeded!')

  
  call MessageNotify('M','Test of genral function', &
       'Test of general function succeeded!')

end program w_base_module_mint_test

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SYLMNM(MM,NN,L,N,M,ICOM,MI)

  IMPLICIT NONE    
  INCLUDE 'mpif.h'
  INTEGER(8) :: MM,NN,N,M,L,K,LS,LM,ICOM,MI
  REAL(8) :: DK
  INTEGER :: NP,IP,IERR,ICOM4

  ICOM4=ICOM
  CALL MPI_COMM_SIZE(ICOM4,NP,IERR)
  CALL MPI_COMM_RANK(ICOM4,IP,IERR)

  LM=(MM/MI/NP+1)*(2*(NN+1)-MM/MI/NP*NP*MI)

  IF(L.GT.LM) THEN
     N=-1
     M=0
     RETURN
  END IF

  DK= (NN+1D0)/(NP*MI) + 0.5D0
  DK=DK-SQRT(DK*DK-(L-0.5D0)/(NP*MI))
  K=DK

  M=(K*NP+IP+MOD(K,2)*(NP-2*IP-1))*MI

  IF(M.GT.MM) THEN
     N=-1
     M=0
     RETURN
  END IF

  LS=K*(2*(NN+1)-(K-1)*MI*NP)+1

  IF(M.EQ.0) THEN
     N=L-1
  ELSE
     N=M+(L-LS)/2
     IF(MOD(L-LS,2).EQ.1) THEN
        M=-M
     END IF
  END IF

  IF(N.GT.NN) THEN
     N=-1
     M=0
  END IF

END SUBROUTINE SYLMNM

! -*- mode: f90; coding: utf-8 -*-
!-------------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2019/03/13  竹広真一
!       2019/10/04  佐々木洋平
!       2020/08/31  佐々木洋平 pointer 版に変更
!-------------------------------------------------------------------------
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @brief
!> @ref w_module の下部モジュール: 基本変換
!>
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは @ref w_module を呼ぶこと．
!>
module w_module_base
  use dc_types, only: DP
  use dc_message, only: MessageNotify
  use spml_utils, only: pi
  use iso_c_binding, only: c_ptr, c_f_pointer

  implicit none
  private
  public im
  public jm
  public mm
  public nm
  public nn
  public it
  public t
  public p
  public r
  public jc
  public w_base_Initial
  public w_base_Finalize
  public x_Lon
  public y_Lat
  public x_Lon_Weight
  public y_Lat_Weight
  public xy_Lon
  public xy_Lat
  public l_nm
  public nm_l
  public xy_w
  public w_xy
  public w_StreamPotential2Vector
  public w_Vector2VorDiv
  public w_VectorCosLat2VorDiv

  !> 緯度座標
  real(DP), allocatable    :: x_Lon(:)
  !> 緯度座標重み
  real(DP), allocatable    :: x_Lon_Weight(:)
  !> 経度座標
  real(DP), allocatable    :: y_Lat(:)
  !> 経度座標重み
  real(DP), allocatable    :: y_Lat_Weight(:)
  !> 緯度座標(2次元配列)
  real(DP), allocatable    :: xy_Lon(:,:)
  !> 経度座標(2次元配列)
  real(DP), allocatable    :: xy_Lat(:,:)
  !> 格子点の設定(東西)
  integer(8)               :: im=64
  !> 格子点の設定(南北)
  integer(8)               :: jm=32
  !> m の切断波数
  integer(8)               :: mm
  !> n の切断波数
  integer(8)               :: nn
  !> n の最大値
  integer(8)               :: nm
  !> 変換用配列
  integer(8), allocatable  :: it(:)
  !> 変換用配列
  integer(8), allocatable  :: jc(:)
  !> 変換用配列
  real(DP), allocatable    :: t(:)
  !> 変換用配列
  real(DP), allocatable    :: r(:)
  !> 変換用配列
  real(DP), pointer        :: p(:,:)

  real(DP), pointer        :: w(:)
  real(DP), pointer        :: g(:)
  real(DP), pointer        :: g1(:)
  real(DP), pointer        :: g2(:)
  real(DP), pointer        :: ww(:)
  integer(8)               :: ig=1
  type(c_ptr)              :: pp
  type(c_ptr)              :: pg
  type(c_ptr)              :: pw
  type(c_ptr)              :: pww
  type(c_ptr)              :: pg1
  type(c_ptr)              :: pg2
  real(DP), allocatable    :: c(:)
  logical                  :: w_base_initialize=.false.

  save im, jm, mm, nn, nm
  save it, t, p, r, jc, c
  save w_base_initialize

  interface l_nm
    module procedure l_nm_array00
    module procedure l_nm_darray00
    module procedure l_nm_array01
    module procedure l_nm_darray01
    module procedure l_nm_array10
    module procedure l_nm_darray10
    module procedure l_nm_array11
    module procedure l_nm_darray11
  end interface l_nm

  interface nm_l
    module procedure nm_l_int
    module procedure nm_l_dint
    module procedure nm_l_array
    module procedure nm_l_darray
  end interface nm_l

contains

  !----------------------------------------------------------
  !> スペクトル変換の格子点数, 波数および OPENMP 使用時の
  !> 最大スレッド数を設定する.
  !>
  !> @warning
  !> 実際の使用には上位サブルーチン
  !> [w_Initial](@ref w_module#w_initial) を用いること.
  !>
  subroutine w_base_Initial(n_in,i_in,j_in,np_in)
    !> 格子点数(東西)
    integer,intent(in) :: i_in
    !> 格子点数(南北)
    integer,intent(in) :: j_in
    !> 切断全波数
    integer,intent(in) :: n_in
    !> OPENMP での最大スレッド数
    integer,intent(in), optional :: np_in
    integer :: i, j
    im = i_in
    jm = j_in
    nn = n_in
    mm = nn
    nm = nn+1

    if ( present(np_in) )then
      call MessageNotify('M','w_base_Initial', &
                 'Optional argnument np is dummy.')
    endif

    allocate(t(im*3/2))
    allocate(it(im/2))
    allocate(r(((mm+1)*(2*nm-mm-1)+1)/4*3+(2*nm-mm)*(mm+1)/2+mm+1))
    allocate(jc(mm*(2*nm-mm-1)/16+mm))
    call mxallc(pp,jm/2*(2*mm+5))
    call c_f_pointer(pp,p,[jm/2,2*mm+5])

    call mxallc(pg,jm*im)
    call mxallc(pw,jm*im)
    call mxallc(pg1,jm*im)
    call mxallc(pg2,jm*im)
    call mxallc(pww,jm*im*2)
    call c_f_pointer(pg, g, [jm*im])
    call c_f_pointer(pw, w, [jm*im])
    call c_f_pointer(pg1, g1, [jm*im])
    call c_f_pointer(pg2, g2, [jm*im])
    call c_f_pointer(pww, ww, [jm*im]*2)

    allocate(c((mm+1)*(mm+1)))
    allocate(x_Lon(0:im-1))
    allocate(x_Lon_Weight(0:im-1))
    allocate(xy_Lon(0:im-1,1:jm))
    allocate(y_Lat(1:jm))
    allocate(y_Lat_Weight(1:jm))
    allocate(xy_Lat(0:im-1,1:jm))

    call sxini1(mm,nm,im,it,t,r)
    call sxini2(mm,nm,jm,ig,p,r,jc)
    call sxinic(mm,nn,c)

    do i=0,int(im)-1
      x_Lon(i)        = 2*pi/im*i
      x_Lon_Weight(i) = 2*pi/im
    enddo

    do j=1,int(jm)/2
      y_Lat(jm/2+j)          =   asin(p(j,1))
      y_Lat(jm/2-j+1)        = - asin(p(j,1))
      y_Lat_Weight(jm/2+j)   =   2*p(j,2)
      y_Lat_Weight(jm/2-j+1) =   2*p(j,2)
    enddo

    do j=1,int(jm)
      xy_Lon(:,j) = x_Lon
    enddo

    do i=0,int(im)-1
      xy_Lat(i,:) = y_Lat
    enddo

    w_base_initialize = .true.

    call MessageNotify('M','w_base_initial',&
      'w_base_module (2019/10/04) is initialized')

  end subroutine w_base_Initial

  !----------------------------------------------------------
  !> スペクトルデータから格子データへ変換する(1 層用).
  !>
  function xy_w(w_data,ipow,iflag)
    !> 格子点データ
    real(DP)               :: xy_w(0:im-1,1:jm)
    !> スペクトルデータ
    real(DP), intent(in)   :: w_data((nn+1)*(nn+1))
    !> 作用させる \f$1/\cosφ\f$ の次数. 省略時は 0.
    integer, intent(in), optional  :: ipow
    !> 変換の種類. 省略時は 0
    !> *   0 : 通常の逆変換(default)
    !> *  -1 : 経度微分を作用させた逆変換
    !> *   1 : 緯度微分 \f$\cosφ \cdot ∂/∂ φ\f$
    !>         を作用させた逆変換
    !> *   2 : \f$\sinφ\f$を作用させた逆変換
    integer, intent(in), optional  :: iflag
    !
    integer, parameter  :: ipow_default  = 0
    integer, parameter  :: iflag_default = 0

    real(DP)             :: w_Xdata((mm+1)*(mm+1))
    real(DP)             :: w_Ydata((mm+2)*(mm+2))

    integer(8) ipval, ifval

    if ( .not. w_base_initialize ) then
      call MessageNotify('E','xy_w',&
        'w_base_module not initialize yet.')
    endif

    if (present(ipow)) then
      ipval = ipow
    else
      ipval = ipow_default
    endif

    if (present(iflag)) then
      ifval = iflag
    else
      ifval = iflag_default
    endif

    if ( ifval == 0 ) then
      call sxts2g(mm,nm,nn,im,jm,w_data,g,it,t,p,r,jc,w,ipval)
      xy_w = reshape(g,(/im,jm/))
!!       call sxts2g(mm,nm,nn,im,jm,w_data,xy_w,it,t,p,r,jc,w,ipval)
    else if( ifval == -1 ) then
      call sxcs2x(mm,nn,w_data,w_Xdata)
      call sxts2g(mm,nm,nn,im,jm,w_Xdata,g,it,t,p,r,jc,w,ipval)
      xy_w = reshape(g,(/im,jm/))
!!       call sxts2g(mm,nm,nn,im,jm,w_Xdata,xy_w,it,t,p,r,jc,w,ipval)
    else if( ifval == 1 ) then
      call sxcs2y(mm,nn,w_data,w_Ydata,c)
      call sxts2g(mm,nm,nn+1_8,im,jm,w_Ydata,g,it,t,p,r,jc,w,ipval)
      xy_w = reshape(g,(/im,jm/))
!!       call sxts2g(mm,nm,nn+1_8,im,jm,w_Ydata,xy_w,it,t,p,r,jc,w,ipval)
    else if( ifval == 2 ) then
      call sxts2g(mm,nm,nn,im,jm,w_data,g,it,t,p,r,jc,w,ipval)
      xy_w = reshape(g,(/im,jm/)) * sin(xy_Lat)
!!       call sxts2g(mm,nm,nn,im,jm,w_data,xy_w,it,t,p,r,jc,w,ipval)
!!       xy_w = xy_w * sin(xy_Lat)
    else
      call MessageNotify('E','xy_w','invalid value of iflag')
    endif

  end function xy_w

  !----------------------------------------------------------
  !> 格子データからスペクトルデータへ(正)変換する(1 層用).
  !>
  function w_xy(xy_data,ipow,iflag)
    !> 格子点データ
    real(DP), intent(in)   :: xy_data(0:im-1,1:jm)
    !> 変換時に同時に作用させる \f$1/\cosφ\f$ の次数. 省略時は 0.
    integer, intent(in), optional  :: ipow
    !> 変換の種類. 省略時は 0
    !> *   0 : 通常の正変換(default)
    !> *  -1 : 経度微分を作用させた正変換
    !> *   1 : 緯度微分 \f$\cosφ \cdot ∂/∂φ\f$
    !>         を作用させた正変換
    !> *   2 : \f$\sinφ\f$を作用させた正変換
    integer, intent(in), optional  :: iflag
    !> スペクトルデータ
    real(DP)               :: w_xy((nn+1)*(nn+1))

    integer, parameter  :: ipow_default  = 0
    integer, parameter  :: iflag_default = 0
    integer(8) ipval, ifval
    real(DP)             :: w_Xdata((mm+1)*(mm+1))
    real(DP)             :: w_Ydata((mm+2)*(mm+2))

    if ( .not. w_base_initialize ) then
      call MessageNotify('E','w_xy',&
        'w_base_module not initialize yet.')
    endif

    if (present(ipow)) then
      ipval = ipow
    else
      ipval = ipow_default
    endif

    if (present(iflag)) then
      ifval = iflag
    else
      ifval = iflag_default
    endif

    if ( ifval == 0 ) then
      g = reshape(xy_data,(/im*jm/))
      call sxtg2s(mm,nm,nn,im,jm,w_xy,g,it,t,p,r,jc,w,ipval)
!!       call sxtg2s(mm,nm,nn,im,jm,w_xy,xy_data,it,t,p,r,jc,w,ipval)
    else if ( ifval == -1 ) then
      g = reshape(xy_data,(/im*jm/))
      call sxtg2s(mm,nm,nn,im,jm,w_Xdata,g,it,t,p,r,jc,w,ipval)
!!       call sxtg2s(mm,nm,nn,im,jm,w_Xdata,xy_data,it,t,p,r,jc,w,ipval)
      call sxcs2x(mm,nn,w_Xdata,w_xy)
    else if ( ifval == 1 ) then
      g = reshape(xy_data,(/im*jm/))
      call sxtg2s(mm,nm,nn+1,im,jm,w_Ydata,g,it,t,p,r,jc,w,ipval)
!!       call sxtg2s(mm,nm,nn+1,im,jm,w_Ydata,xy_data,it,t,p,r,jc,w,ipval)
      call sxcy2s(mm,nn,w_Ydata,w_xy,c)
    else if ( ifval == 2 ) then
      g = reshape(xy_data*sin(xy_Lat),(/im*jm/))
      call sxtg2s(mm,nm,nn,im,jm,w_xy,g,it,t,p,r,jc,w,ipval)
    else
      call MessageNotify('E','w_xy','invalid value of iflag')
    endif

  end function w_xy

  !----------------------------------------------------------
  !> 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
  !> (逆)変換する(1 層用)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !> \f{align*}{
  !>   u \cosφ & =       ∂χ/∂λ - \cosφ∂ψ/∂φ, \\
  !>   v \cosφ & = \cosφ∂χ/∂φ +       ∂ψ/∂λ
  !> \f}
  !>
  subroutine w_StreamPotential2Vector(w_Psi, w_Chi, xy_U, xy_V)
    !> 流線関数
    real(DP), intent(in)   :: w_Psi((nn+1)*(nn+1))
    !> 速度ポテンシャル
    real(DP), intent(in)   :: w_Chi((nn+1)*(nn+1))
    !> 速度経度成分
    real(DP), intent(out)   :: xy_U(0:im-1,1:jm)
    !> 速度緯度成分
    real(DP), intent(out)   :: xy_V(0:im-1,1:jm)

    real(DP)             :: w_Xdata((mm+1)*(mm+1))
    real(DP)             :: w_Ydata(nn+2+mm*(2*nn-mm+3))
!!$    real(DP)             :: w_Ydata((mm+2)*(mm+2))
    real(DP)             :: w_Rdata1((2*nm+1-mm)*mm+nm+1)
    real(DP)             :: w_Rdata2((2*nm+1-mm)*mm+nm+1)
!!$    real(DP)             :: w_Rdata1((mm+2)*(mm+2))
!!$    real(DP)             :: w_Rdata2((mm+2)*(mm+2))

    if ( .not. w_base_initialize ) then
      call MessageNotify('E','w_StreamPotential2Vector',&
        'w_base_module not initialize yet.')
    endif
    !
    ! $ u \cosφ = ∂χ/∂λ - \cosφ∂ψ/∂φ $
    !
    call sxcs2x(mm,nn,w_Chi,w_Xdata)
    call sxcs2y(mm,nn,w_Psi,w_Ydata,c)
    call sxcrpk(mm,nn,nm,w_Xdata,w_Rdata1)
    w_Rdata1 = w_Rdata1 - w_Ydata
    !
    ! $ v \cosφ = \cosφ∂χ/∂φ + ∂ψ/∂λ $
    !
    call sxcs2y(mm,nn,w_Chi,w_Ydata,c)
    call sxcs2x(mm,nn,w_Psi,w_Xdata)
    call sxcrpk(mm,nn,nm,w_Xdata,w_Rdata2)
    w_Rdata2= w_Rdata2 + w_Ydata
    !
    ! u,v
    !
    call sxts2v(mm,nm,nm,im,jm,w_Rdata1,w_Rdata2,g1,g2,it,t,p,r,jc,ww,1_8)
    xy_U = reshape(g1,(/im,jm/))
    xy_V = reshape(g2,(/im,jm/))
    !! call sxts2v(mm,nm,nm,im,jm,w_Rdata1,w_Rdata2,xy_U,xy_V,it,t,p,r,jc,ww,1_8)

  end subroutine w_StreamPotential2Vector

  !----------------------------------------------------------
  !> 速度場(格子データ)から渦度・発散(スペクトルデータ)に
  !> (正)変換する(1 層用)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !> \f{align}{
  !>   ζ = 1/\cosφ∂v/∂λ - 1/\cosφ ∂(u \cosφ)/∂φ, \\
  !>    D = 1/\cosφ∂u/∂λ + 1/\cosφ ∂(v \cosφ)/∂φ
  !> \f}
  !>
  subroutine w_Vector2VorDiv(xy_U, xy_V, w_Vor, w_Div)
    !> 速度経度成分
    real(DP), intent(in)   :: xy_U(0:im-1,1:jm)
    !> 速度緯度成分
    real(DP), intent(in)   :: xy_V(0:im-1,1:jm)
    !> 流線関数
    real(DP), intent(out)   :: w_Vor((nn+1)*(nn+1))
    !> 速度ポテンシャル
    real(DP), intent(out)   :: w_Div((nn+1)*(nn+1))

    real(DP)             :: w_Xdata((mm+1)*(mm+1))
    real(DP)             :: w_Ydata1((mm+2)*(mm+2))
    real(DP)             :: w_Ydata2((mm+2)*(mm+2))
    real(DP)             :: w_Data1((mm+1)*(mm+1))
    real(DP)             :: w_Data2((mm+1)*(mm+1))

    if ( .not. w_base_initialize ) then
      call MessageNotify('E','w_Vector2VorDiv',&
        'w_base_module not initialize yet.')
    endif

    !
    ! $ 1/\cosφ∂u/∂λ, 1/\cosφ ∂(u \cosφ)/∂φ$
    !
    g1 = reshape(xy_U,(/im*jm/))
    g2 = reshape(xy_V,(/im*jm/))
    call sxtv2s(mm,nm,nn+1,im,jm,w_Ydata1,w_Ydata2,g1,g2,it,t,p,r,jc,ww,1_8)
!!    call sxtv2s(mm,nm,nn+1,im,jm,w_Ydata1,w_Ydata2,xy_U,xy_V,it,t,p,r,jc,ww,1_8)

    call sxcrpk(mm,nm,nn,w_Ydata1,w_Xdata)
    call sxcs2x(mm,nn,w_Xdata,w_Div)
    call sxcy2s(mm,nn,w_Ydata2,w_Data2,c)
    !
    ! $ 1/\cosφ∂v/∂λ, 1/\cosφ ∂(v \cosφ)/∂φ $
    !
    call sxcrpk(mm,nm,nn,w_Ydata2,w_Xdata)
    call sxcs2x(mm,nn,w_Xdata,w_Vor)
    call sxcy2s(mm,nn,w_Ydata1,w_Data1,c)
    !
    ! Vorticity:
    ! $ ζ = 1/\cosφ∂v/∂λ - 1/\cosφ ∂(u cosφ)/∂φ $
    !
    w_Vor = w_Vor - w_Data1
    !
    ! Divergence:
    ! $  D = 1/\cosφ∂u/∂λ + 1/\cosφ ∂(v \cosφ)/∂φ $
    !
    w_Div = w_Div + w_Data2

  end subroutine w_Vector2VorDiv

  !----------------------------------------------------------
  !> 速度場(格子データ)から渦度・発散(スペクトルデータ)に
  !> (正)変換する(1 層用)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !> \f{align*}{
  !>   ζ = 1/\cosφ∂v/∂λ - 1/\cosφ ∂(u \cosφ)/∂φ,\\
  !>    D = 1/\cosφ∂u/∂λ + 1/\cosφ ∂(v \cosφ)/∂φ
  !> \f}
  !>
  subroutine w_VectorCosLat2VorDiv(xy_UCosLat, xy_VCosLat, w_Vor, w_Div)
    !> 速度経度成分 * cos(lat)
    real(DP), intent(in)   :: xy_UCosLat(0:im-1,1:jm)
    !> 速度緯度成分 * cos(lat)
    real(DP), intent(in)   :: xy_VCosLat(0:im-1,1:jm)
    !> 流線関数
    real(DP), intent(out)   :: w_Vor((nn+1)*(nn+1))
    !> 速度ポテンシャル
    real(DP), intent(out)   :: w_Div((nn+1)*(nn+1))

    real(DP)             :: w_Xdata((mm+1)*(mm+1))
    real(DP)             :: w_Ydata1((mm+2)*(mm+2))
    real(DP)             :: w_Ydata2((mm+2)*(mm+2))
    real(DP)             :: w_Data1((mm+1)*(mm+1))
    real(DP)             :: w_Data2((mm+1)*(mm+1))

    if ( .not. w_base_initialize ) then
      call MessageNotify('E','w_VectorCosLat2VorDiv',&
        'w_base_module not initialize yet.')
    endif
    !
    ! $1/\cosφ∂u/∂λ, 1/\cosφ∂(u cosφ)/∂φ$
    !
    g1 = reshape(xy_UCosLat,(/im*jm/))
    g2 = reshape(xy_VCosLat,(/im*jm/))
    call sxtv2s(mm,nm,nn+1,im,jm,w_Ydata1,w_Ydata2,g1,g2,it,t,p,r,jc,ww,2_8)
!    call sxtv2s(mm,nm,nn+1,im,jm,w_Ydata1,w_Ydata2,xy_UCosLat,xy_VCosLat,it,t,p,r,jc,ww,2_8)

    call sxcrpk(mm,nm,nn,w_Ydata1,w_Xdata)
    call sxcs2x(mm,nn,w_Xdata,w_Div)
    call sxcy2s(mm,nn,w_Ydata2,w_Data2,c)
    !
    ! $1/\cosφ∂v/∂λ, 1/\cosφ∂(v cosφ)/∂φ$
    !
    call sxcrpk(mm,nm,nn,w_Ydata2,w_Xdata)
    call sxcs2x(mm,nn,w_Xdata,w_Vor)
    call sxcy2s(mm,nn,w_Ydata1,w_Data1,c)
    !
    ! Vorticity:
    !   $ζ = 1/\cosφ∂v/∂λ - 1/\cosφ∂(u \cosφ)/∂φ$
    !
    w_Vor = w_Vor - w_Data1
    !
    ! Divergence:
    !   $D = 1/\cosφ∂u/∂λ + 1/\cosφ∂(v \cosφ)/∂φ$
    !
    w_Div = w_Div + w_Data2

  end subroutine w_VectorCosLat2VorDiv

  !----------------------------------------------------------
  !> 終了処理(割り付け配列の解放)をおこなう
  !>
  subroutine w_base_Finalize
    if ( .not. w_base_initialize ) then
      call MessageNotify('W','w_base_Finalize',&
        'w_base_module not initialized yet')
      return
    endif

    deallocate(it)
    deallocate(t)
    deallocate(r)
    deallocate(jc)
    deallocate(c)

    call mxfree(pp)
    call mxfree(pg)
    call mxfree(pg1)
    call mxfree(pg2)
    call mxfree(pw)
    call mxfree(pww)

    deallocate(x_Lon)
    deallocate(x_Lon_weight)
    deallocate(xy_Lon)
    deallocate(y_Lat)
    deallocate(y_Lat_Weight)
    deallocate(xy_Lat)
    w_base_initialize = .false.

    call MessageNotify('M','w_base_Finalize',&
      'w_base_module (2019/10/04) is finalized')

  end subroutine w_base_Finalize

  !-----------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す
  !>
  !> 引数 n,m がともに整数値の場合, 整数値を返す.
  !>
  function l_nm_array00(n,m)
    !> 全波数
    integer, intent(in)   :: n
    !> 帯状波数
    integer, intent(in)   :: m
    !> スペクトルデータの格納位置
    integer               :: l_nm_array00

    integer(8)   :: nd     ! 全波数
    integer(8)   :: md     ! 帯状波数
    integer(8)   :: ld     ! スペクトルデータの格納位置

    nd = n
    md = m
    call sxnm2l(nn,nd,md,ld)
    l_nm_array00 = int(ld)

  end function l_nm_array00

  !------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す
  !>
  !> 引数 n,m がともに整数値の場合, 整数値を返す.
  !>
  function l_nm_darray00(n,m)
    !> 全波数
    integer(8), intent(in)   :: n
    !> 帯状波数
    integer(8), intent(in)   :: m
    !> スペクトルデータの格納位置
    integer               :: l_nm_darray00

    integer(8)   :: nd     ! 全波数
    integer(8)   :: md     ! 帯状波数
    integer(8)   :: ld     ! スペクトルデータの格納位置

    nd = n
    md = m
    call sxnm2l(nn,nd,md,ld)
    l_nm_darray00 = int(ld)

  end function l_nm_darray00

  !----------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す
  !>
  !> 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合,
  !> marray と同じ大きさの 1 次元整数配列を返す.
  !>
  function l_nm_array01(n,marray)
    !> 全波数
    integer, intent(in)  :: n
    !> 帯状波数
    integer, intent(in)  :: marray(:)
    !> スペクトルデータ位置
    integer              :: l_nm_array01(size(marray))

    integer              :: i

    do i=1, size(marray)
      l_nm_array01(i) = l_nm_array00(n,marray(i))
    enddo
  end function l_nm_array01

  !------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す
  !>
  !> 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合,
  !> marray と同じ大きさの 1 次元整数配列を返す.
  !>
  function l_nm_darray01(n,marray)
    !> 全波数
    integer(8), intent(in)  :: n
    !> 帯状波数
    integer(8), intent(in)  :: marray(:)
    !> スペクトルデータ位置
    integer              :: l_nm_darray01(size(marray))

    integer              :: i

    do i=1, size(marray)
      l_nm_darray01(i) = l_nm_darray00(n,marray(i))
    enddo
  end function l_nm_darray01

  !------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す
  !>
  !> 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合,
  !> narray と同じ大きさの 1 次元整数配列を返す.
  !>
  function l_nm_array10(narray,m)
    !> 全波数
    integer, intent(in)  :: narray(:)
    !> 帯状波数
    integer, intent(in)  :: m
    !> スペクトルデータ位置
    integer              :: l_nm_array10(size(narray))

    integer              :: i

    do i=1, size(narray)
      l_nm_array10(i) = l_nm_array00(narray(i),m)
    enddo
  end function l_nm_array10

  !--------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す
  !>
  !> 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合,
  !> narray と同じ大きさの 1 次元整数配列を返す.
  !>
  function l_nm_darray10(narray,m)
    !> 全波数
    integer(8), intent(in)  :: narray(:)
    !> 帯状波数
    integer(8), intent(in)  :: m
    !> スペクトルデータ位置
    integer              :: l_nm_darray10(size(narray))

    integer              :: i

    do i=1, size(narray)
      l_nm_darray10(i) = l_nm_darray00(narray(i),m)
    enddo
  end function l_nm_darray10


  !--------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合,
  !> narray, marray と同じ大きさの 1 次元整数配列を返す.
  !> narray, marray は同じ大きさでなければならない.
  !>
  function l_nm_array11(narray,marray)
    !> 全波数
    integer, intent(in)  :: narray(:)
    !> 帯状波数
    integer, intent(in)  :: marray(:)
    !> スペクトルデータ位置
    integer              :: l_nm_array11(size(narray))

    integer              :: i

    if ( size(narray) .ne. size(marray) ) then
      call MessageNotify('E','l_nm_array11',&
        'dimensions of input arrays  n and m are different.')
    endif

    do i=1, size(narray)
      l_nm_array11(i) = l_nm_array00(narray(i),marray(i))
    enddo
  end function l_nm_array11

  !------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合,
  !> narray, marray と同じ大きさの 1 次元整数配列を返す.
  !> narray, marray は同じ大きさでなければならない.
  !>
  function l_nm_darray11(narray,marray)
    !> 全波数
    integer(8), intent(in)  :: narray(:)
    !> 帯状波数
    integer(8), intent(in)  :: marray(:)
    !> スペクトルデータ位置
    integer              :: l_nm_darray11(size(narray))

    integer              :: i

    if ( size(narray) .ne. size(marray) ) then
      call MessageNotify('E','l_nm_array11',&
        'dimensions of input arrays  n and m are different.')
    endif

    do i=1, size(narray)
      l_nm_darray11(i) = l_nm_darray00(narray(i),marray(i))
    enddo
  end function l_nm_darray11

  !--------------------------------------------------------------------
  !> スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
  !>
  !> 引数 l が整数値の場合, 対応する全波数と帯状波数を
  !> 長さ 2 の 1 次元整数値を返す.
  !> nm_l(1) が全波数, nm_l(2) が帯状波数である.
  !>
  function nm_l_int(l)
    !> 全波数, 帯状波数
    integer               :: nm_l_int(2)
    !> スペクトルデータの格納位置
    integer, intent(in)   :: l

    integer(8)            :: ld
    integer(8)            :: nd
    integer(8)            :: md

    ld = l
    call sxl2nm(nn,ld,nd,md)
    nm_l_int = int((/nd,md/))

  end function nm_l_int

  !----------------------------------------------------------------------
  !> スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
  !>
  !> 引数 l が整数値の場合, 対応する全波数と帯状波数を
  !> 長さ 2 の 1 次元整数値を返す.
  !> nm_l(1) が全波数, nm_l(2) が帯状波数である.
  !>
  function nm_l_dint(l)
    !> 全波数, 帯状波数
    integer                :: nm_l_dint(2)
    !> スペクトルデータの格納位置
    integer(8), intent(in) :: l

    integer(8)             :: ld
    integer(8)             :: nd
    integer(8)             :: md

    ld = l
    call sxl2nm(nn,ld,nd,md)
    nm_l_dint = int((/nd,md/))

  end function nm_l_dint

  !---------------------------------------------------------------------
  !> スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す
  !
  !> 引数 larray が整数 1 次元配列の場合,
  !> larray に対応する n, m を格納した 2 次元整数配列を返す.
  !> nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である.
  !>
  function nm_l_array(larray)
    !> 全波数, 帯状波数
    integer, intent(in)  :: larray(:)
    !> スペクトルデータの格納位置
    integer              :: nm_l_array(size(larray),2)

    integer              :: i
    do i=1, size(larray)
      nm_l_array(i,:) = nm_l_int(larray(i))
    enddo
  end function nm_l_array

  !---------------------------------------------------------------------
  !> スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す
  !
  !> 引数 larray が整数 1 次元配列の場合,
  !> larray に対応する n, m を格納した 2 次元整数配列を返す.
  !> nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である.
  !>
  function nm_l_darray(larray)
    !> 全波数, 帯状波数
    integer(8), intent(in)  :: larray(:)
    !> スペクトルデータの格納位置
    integer                 :: nm_l_darray(size(larray),2)

    integer              :: i
    do i=1, size(larray)
      nm_l_darray(i,:) = nm_l_dint(larray(i))
    enddo
  end function nm_l_darray

end module w_module_base

!--
!----------------------------------------------------------------------
!     Copyright (c) 2024 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!表題  wa_zonal_module_interpolate
!
!  spml/wa_zonal_module_interpolate モジュールは球面上での流体運動を
!  球面調和函数を用いたスペクトル法によって東西 1 波数数値計算するための
!  モジュール wa_zonal_module の下部モジュールであり, スペクトル法による
!  補間計算のための Fortran90 関数を提供する. 
!
!  球面上の 1 層モデル用 w_zonal_module_interpolate モジュールを
!  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータを
!  用いた補間計算が行える.
!
!  補間計算の方法については doc/w_module.tex を参照のこと. 
!  このサブルーチンは内部で ISPACK3 の LXACK のサブルーチンを
!  呼んでいない. 
!
!
!履歴  2024/02/17  竹広真一 wa_wave_module_interpolate より改造
!
!++
module wa_zonal_module_interpolate
  !
  != wa_zonal_module_interpolate
  !
  !== 概要
  !
  !  spml/wa_zonal_module_interpolate モジュールは球面上での流体運動を
  !  球面調和函数を用いたスペクトル法によって東西 1 波数数値計算するための
  !  モジュール wa_zonal_module の下部モジュールであり, スペクトル法による
  !  補間計算のための Fortran90 関数を提供する. 
  !
  !  球面上の 1 層モデル用 w_zonal_module_interpolate モジュールを
  !  多層モデル用に拡張したものであり, 同時に複数個のスペクトルデータを
  !  用いた補間計算が行える.
  !
  !  補間計算の方法については doc/w_module.tex を参照のこと. 
  !  このサブルーチンは内部で ISPACK3 の LXACK のサブルーチンを
  !  呼んでいない. 
  !
  use dc_message, only : MessageNotify
  use spml_utils, only : gammaln
  use w_zonal_module_base, only : nm=>nn, l_nm
  implicit none
  private

  public a_Interpolate_wa                        ! 補間関数

  interface a_Interpolate_wa
     !
     ! 緯度 alon, 経度 alat における関数値を
     ! 球面調和変換係数 wa_data から補間計算する
     !
     ! 入力する緯度経度座標は１点の 1 種類
     !
     module procedure a_Interpolate_array00_wa
  end interface

contains

  !--------------- 補間計算 -----------------    
  function a_Interpolate_array00_wa(wa_data,alon,alat)
    !
    ! 緯度 alat, 経度 alon における関数値を
    ! その球面調和変換係数 w_data から補間計算する
    !
    real(8), intent(IN) :: wa_data(:,:)             ! スペクトルデータ
    real(8), intent(IN) :: alon                     ! 補間する位置(経度)
    real(8), intent(IN) :: alat                     ! 補間する位置(緯度)
    real(8)             :: a_Interpolate_array00_wa(size(wa_data,2)) ! 補間した値

    real(8) :: mu
    real(8), dimension(size(wa_data,2)) :: y0, y1, y2
    integer :: k

    mu = sin(alat)
    a_Interpolate_array00_wa = 0.0D0

    !---- Σa_n^0 L_n^0 の計算
    y2 = 0 ; y1 = 0
    do k=nm,1,-1
       y0 = alpha(k,mu) * y1 + beta(k+1)*y2 + wa_data(l_nm(k,0),:)
       y2 = y1 ; y1 = y0
    enddo
    a_Interpolate_array00_wa = beta(1) * y2 + mu*sqrt(3.0D0) * y1 + wa_data(l_nm(0,0),:) 

  end function a_Interpolate_array00_wa

  !--------------- 下部ルーチン -----------------
  function alpha(n,x)
    !
    !  漸化式の P_n の係数
    !
    integer, intent(IN) :: n
    real(8), intent(IN) :: x
    real(8)             :: alpha

    alpha = sqrt( (2.0D0*n+3)*(2.0D0*n+1)/((n+1)*(n+1)) ) * x
  end function alpha

  function beta(n)
    !
    !  漸化式の P_{n-1} の係数
    !
    integer, intent(IN) :: n
    real(8)             :: beta

    beta = - sqrt( (2.0D0*n+3)*n*n/((2*n-1)*(n+1)*(n+1)) )
  end function beta

end module wa_zonal_module_interpolate

!----------------------------------------------------------------------
!     Copyright (c) 2024 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  w_zonal_module テストプログラム :: 基本変換関数のテスト
!
!履歴  2020/11/24  竹広真一
!
program w_zonal_module_base_test

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use w_zonal_module
  implicit none

  integer :: imm(2)=(/ 1, 1/)
  integer :: jmm(2)=(/16,32/)
  integer :: nmm(2)=(/10,21/)

  real(8), allocatable :: w_data(:)
  real(8), allocatable :: xy_data(:,:)

  ! 判定誤差設定
  integer, parameter :: check_digits = 11
  integer, parameter :: ignore = -12

  integer :: n

  call MessageNotify('M','w_zonal_module_base_test', &
                         'w_zonal_module_ basic functions tests') 

  do n=1,2

  call w_Initial( nmm(n), imm(n), jmm(n) )

  allocate(w_data(nmm(n)+1))
  allocate(xy_data(0:imm(n)-1,1:jmm(n)))

  !---- P_1^0 のテスト ----
  xy_data = sqrt(3.0D0)*sin(xy_Lat)
  w_data= 0.0D0 ; w_data(l_nm(1,0))=1.0D0

  call AssertEqual(&
    message='P_1 Test of w_xy(xy_data)',                         &
    answer = w_data,                                             &
    check = w_xy(xy_data),                                       &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  call AssertEqual(&
    message='P_1 Test of xy_w(w_xy(xy_data))',                   &
    answer = xy_data,                                            &
    check = xy_w(w_xy(xy_data)),                                 &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  !---- P_2^0 のテスト ----
  xy_data = sqrt(5.0D0)*(3.0D0*sin(xy_Lat)**2-1.0D0)/2.0D0      ! P_2
  w_data= 0.0D0 ; w_data(l_nm(2,0))=1.0D0

  call AssertEqual(&
    message='P_2 Test of w_xy(xy_data)',                         &
    answer = w_data,                                             &
    check = w_xy(xy_data),                                       &
    significant_digits = check_digits, ignore_digits = ignore    &
    )
  call AssertEqual(&
    message='P_2 Test of xy_w(w_xy(xy_data))',                   &
    answer = xy_data,                                            &
    check = xy_w(w_xy(xy_data)),                                 &
    significant_digits = check_digits, ignore_digits = ignore    &
    )

  deallocate(w_data)
  deallocate(xy_data)

  call w_Finalize

  enddo

  call MessageNotify('M','w_zonal_module_lsbase_test', &
                         'w_zonal_module basic functions tests succeeded!') 

end program w_zonal_module_base_test

! -*- mode: f90; coding: utf-8 -*-
!-------------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2019/03/25 竹広真一
!       2019/10/05 佐々木洋平
!       2020/08/12 竹広真一
!
!-------------------------------------------------------------------------
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @brief
!> @ref w_mpi_module の下部モジュール: 基本変換
!>
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは w_mpi_module を呼ぶこと．
!>
module w_mpi_module_base
  use dc_types, only: DP
  use dc_message, only: MessageNotify
  use spml_utils, only: pi
  use iso_c_binding, only: c_ptr, c_f_pointer
  use mpi
  implicit none
  private

  public im, jm, nn, mm, nm                   ! 格子点数, 切断波数
  public it, t, p, r, jc                      ! 変換用作業配列
  public j1, j2                               ! 分散格子データの大きさ
  public jl                                   ! 分散スペクトルデータの大きさ
  public nc
  public np, ip
  public icom                                 ! コミュニケーター

  public w_base_mpi_Initial                   ! 初期化サブルーチン
  public w_base_mpi_Finalize                  ! 終了サブルーチン

  public x_Lon                                ! 格子座標
  public x_Lon_Weight                         ! 格子座標重み
  public v_Lat                                ! 格子座標
  public v_Lat_Weight                         ! 格子座標重み
  public y_Lat                                ! 格子座標
  public y_Lat_Weight                         ! 格子座標重み
  public xv_Lon, xv_Lat                       ! 格子座標(im,jl)
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public l_nm, nm_l                           ! 波数格納位置
  public xv_w, w_xv                           ! 変換関数
  public w_StreamPotential2VectorMPI          ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDivMPI                   ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDivMPI             ! 速度場から渦度発散を計算
  public ay_av, av_ay

  !> 格子点の設定(東西)
  integer(8)              :: im=64
  !> 格子点の設定(南北)
  integer(8)              :: jm=32
  !> 切断波数(東西波数)の設定
  integer(8)              :: mm
  !> 切断波数(全波数)の設定
  integer(8)              :: nn
  !> 計算する最大の全波数の設定
  integer(8)              :: nm
  !> 経度座標格子点
  real(DP),   allocatable :: x_Lon(:)
  !> 経度座標格子点重み
  real(DP),   allocatable :: x_Lon_Weight(:)
  !> 緯度座標分散格子点
  real(DP),   allocatable :: v_Lat(:)
  !> 緯度座標分散格子点重み
  real(DP),   allocatable :: v_Lat_Weight(:)
  !> 緯度座標格子点
  real(DP),   allocatable :: y_Lat(:)
  !> 緯度座標格子点重み
  real(DP),   allocatable :: y_Lat_Weight(:)
  !> 分散座標経度格子点, 2次元配列
  real(DP),   allocatable :: xv_Lon(:,:)
  !> 分散座標緯度格子点, 2次元配列
  real(DP),   allocatable :: xv_Lat(:,:)
  !> 座標経度格子点, 2次元配列
  real(DP),   allocatable :: xy_Lon(:,:)
  !> 座標緯度格子点, 2次元配列
  real(DP),   allocatable :: xy_Lat(:,:)
  !> コミュニケータ
  integer(8)              :: icom
  !> 変換用配列
  integer(8), allocatable :: it(:)
  !> 変換用配列
  integer(8), allocatable :: jc(:)
  !> 変換用配列
  real(DP),   allocatable :: t(:)
  !> 変換用配列
  real(DP),   allocatable :: r(:)
  !> 変換用配列
  real(DP),   pointer     :: p(:,:)
  !> 分散配置用変数
  integer(8)              :: j1
  !> 分散配置用変数
  integer(8)              :: j2
  !> 分散格子データの大きさ
  integer                 :: jl
  !> 分散スペクトルデータの大きさ
  integer                 :: nc
  !> MPI プロセス数
  integer                 :: np
  !> MPI プロセス番号
  integer                 :: ip

  !> グリッド種類
  integer(8)              :: ig=1
  !> 変換用配列
  real(DP),   pointer     :: g(:,:)
  !> 変換用配列
  real(DP),   pointer     :: w(:)
  !> 変換用配列
  real(DP),   pointer     :: g1(:,:)
  !> 変換用配列
  real(DP),   pointer     :: g2(:,:)
  !> 変換用配列
  real(DP),   pointer     :: ww(:)
  !> 変換用配列
  type(c_ptr)             :: pp
  !> 変換用配列
  type(c_ptr)             :: pg
  !> 変換用配列
  type(c_ptr)             :: pw
  !> 変換用配列
  type(c_ptr)             :: pww
  !> 変換用配列
  type(c_ptr)             :: pg1
  !> 変換用配列
  type(c_ptr)             :: pg2
  !> 作業配列
  real(DP),   allocatable :: c(:)
  !> 分散配置用変数
  integer,    allocatable :: j1p(:)
  !> 分散配置用変数
  integer,    allocatable :: j2p(:)
  !> 分散格子データの大きさ
  integer,    allocatable :: jlp(:)
  !> 分散スペクトルデータの大きさ
  integer,    allocatable :: ncp(:)
  !> 分散/全データ変換用配列
  integer,    allocatable :: snd_rank(:)
  !> 分散/全データ変換用配列
  integer,    allocatable :: rcv_rank(:)
  !> ベクトル長
  integer(8)              :: jv
  !> 初期化フラグ
  logical                 :: w_base_mpi_initialize=.false.

  !---------------------------------------------------------------------
  !> 波数 (n,m) よりスペクトルデータの格納位置 l を返す
  !>
  interface l_nm
    module procedure l_nm_array00
    module procedure l_nm_darray00
    module procedure l_nm_array01
    module procedure l_nm_darray01
    module procedure l_nm_array10
    module procedure l_nm_darray10
    module procedure l_nm_array11
    module procedure l_nm_darray11
  end interface l_nm

  !---------------------------------------------------------------------
  !> スペクトルデータの位置(l) より，対応する波数 (n,m) を返す
  !>
  interface nm_l
    module procedure nm_l_int
    module procedure nm_l_dint
    module procedure nm_l_array
    module procedure nm_l_darray
  end interface nm_l

  save im, jm, nm, mm, nn                     ! 格子点数, 切断波数を記憶
  save it, t, p, r, jc                        ! 変換用配列を記憶
  save icom
  save jv
  save j1, j2
  save jl, nc
  save j1p, j2p
  save jlp, ncp
  save np, ip
  save snd_rank, rcv_rank
  save c                                      ! 変換用配列
  save w, g, pw, pg
  save ww, g1, g2, pww, pg1, pg2
  save w_base_mpi_initialize                  ! 初期化フラグ

contains
  !---------------------------------------------------------------------
  !> スペクトル変換の格子点数, 波数および OPENMP 使用時の
  !> 最大スレッド数を設定する.
  !>
  !> 実際の使用には上位サブルーチン w_mpi_initial() を用いること.
  !>
  subroutine w_base_mpi_Initial(n_in,i_in,j_in,mpi_comm)
    !> 格子点数(東西), 2の巾乗(<=2048)
    integer,intent(in) :: i_in
    !> 格子点数(南北), 4 の倍数
    integer,intent(in) :: j_in
    !> 切断全波数
    integer,intent(in) :: n_in
    !> コミュニケーター
    integer,intent(in), optional :: mpi_comm

    integer :: i, j
    integer :: ierr

    ! 三角波数切断
    im = i_in
    jm = j_in
    nn = n_in
    nm = n_in+1
    mm = n_in
    if ( present(mpi_comm) ) then
      icom = mpi_comm
    else
      icom = MPI_COMM_WORLD
    endif

    CALL MPI_COMM_SIZE(int(ICOM),NP,IERR)
    CALL MPI_COMM_RANK(int(ICOM),IP,IERR)

    allocate(t(im*3/2))
    allocate(it(im/2))
    allocate(r(5*(mm/np+1)*(2*nm-mm/np*np)/4+mm/np+1))
    allocate(jc((mm/np+1)*(2*nm-mm/np*np)/16+mm/np+1))
    call mxallc(pp,jm/2*(5+2*(mm/np+1)))
    call c_f_pointer(pp,p,[jm/2,5+2*(mm/np+1)])

    ! 変換用作業配列
    allocate(c((mm/np+1)*(2*(nn+1)-mm/np*np)))

    call syini1(mm,nm,im,it,t,r,icom)
    call syini2(mm,nm,jm,ig,p,r,jc,icom)
    call syinic(mm,nn,c,icom)

    ! 変換用変数割付
    call syqrjv(jm,jv)

    call mxallc(pg,im*((jm/jv-1)/np+1)*jv)
    call c_f_pointer(pg, g, [im,((jm/jv-1)/np+1)*jv])
    call mxallc(pw,2*jv*((jm/jv-1)/np+1)*(mm/np+1)*np*2)
    call c_f_pointer(pw, w, [2*jv*((jm/jv-1)/np+1)*(mm/np+1)*np*2])

    call mxallc(pg1,im*((jm/jv-1)/np+1)*jv)
    call c_f_pointer(pg1, g1, [im,((jm/jv-1)/np+1)*jv])
    call mxallc(pg2,im*((jm/jv-1)/np+1)*jv)
    call c_f_pointer(pg2, g2, [im,((jm/jv-1)/np+1)*jv])
    call mxallc(pww,2*jv*((jm/jv-1)/np+1)*(mm/np+1)*np*2*2)
    call c_f_pointer(pww, ww, [2*jv*((jm/jv-1)/np+1)*(mm/np+1)*np*2*2])


    ! 各プロセスの担当緯度, 波数情報
    call syqrnj(jm,jv,j1,j2,icom)
    ! 分散格子データの大きさ
    jl = int(j2-j1+1)
    ! 分散スペクトルデータの大きさ
    nc = int((mm/np+1)*(2*(nn+1)-mm/np*np))

    allocate(j1p(0:np-1),j2p(0:np-1))
    allocate(jlp(0:np-1))
    allocate(ncp(0:np-1))

    call MPI_ALLGATHER( jl, 1, MPI_INTEGER, &
      jlp(0), 1, MPI_INTEGER, int(icom), ierr)
    call MPI_ALLGATHER( int(j1), 1, MPI_INTEGER, &
      j1p(0), 1, MPI_INTEGER, int(icom), ierr)
    call MPI_ALLGATHER( int(j2), 1, MPI_INTEGER, &
      j2p(0), 1, MPI_INTEGER, int(icom), ierr)
!!$    call MPI_ALLGATHER( j1, 1, MPI_INTEGER, &
!!$      j1p(0), 1, MPI_INTEGER, int(icom), ierr)
!!$    call MPI_ALLGATHER( j2, 1, MPI_INTEGER, &
!!$      j2p(0), 1, MPI_INTEGER, int(icom), ierr)
    call MPI_ALLGATHER( nc, 1, MPI_INTEGER, &
      ncp(0), 1, MPI_INTEGER, int(icom), ierr)

    allocate(snd_rank(1:np-1))
    allocate(rcv_rank(1:np-1))

    do i=1,np-1
      rcv_rank(i) = mod(ip+i,np)
      snd_rank(i) = mod(ip+np-i,np)
    enddo

    ! 座標変数設定
    allocate(x_Lon(0:im-1))                       ! 格子点座標格納配列(経度)
    allocate(x_Lon_Weight(0:im-1))
    allocate(v_Lat(jl),v_Lat_Weight(jl))          ! 格子点座標格納配列
    allocate(y_Lat(jm),y_Lat_Weight(jm))          ! 格子点座標格納配列
    allocate(xv_Lon(0:im-1,jl),xv_Lat(0:im-1,jl)) ! 格子点座標格納配列
    allocate(xy_Lon(0:im-1,jm),xy_Lat(0:im-1,jm)) ! 格子点座標格納配列

    do i=0,int(im)-1
      x_Lon(i)  = 2*(pi/im)*i             ! 経度座標
      x_Lon_Weight(i) = 2*(pi/im)         ! 経度座標重み
    end do

    do j=int(j1),int(j2)
      if ( j .gt. jm/2 ) then
        v_Lat(j-j1+1)        =  asin(p(j-jm/2,1))    ! 緯度座標
        v_Lat_Weight(j-j1+1) = 2*p(j -jm/2,2)        ! 緯度重み(Gauss grid)
      else
        v_Lat(j-j1+1)        = - asin(p(jm/2-j+1,1)) ! 緯度座標
        v_Lat_Weight(j-j1+1) = 2*p(jm/2-j+1,2)       ! 緯度重み(Gauss grid)
      end if
    end do

    do i=0,int(im)-1
      xv_Lat(i,:) = v_Lat
    enddo
    xy_Lat = ay_av(xv_Lat)
    y_Lat = xy_Lat(0,:)
    y_Lat_Weight = reshape(ay_av(reshape(v_Lat_Weight, (/1,jl/))),(/jm/))

    do j=1,int(jl)
      xv_Lon(:,j) = x_Lon
    enddo
    do j=1,int(jm)
      xy_Lon(:,j) = x_Lon
    enddo

    w_base_mpi_initialize = .true.

    call MessageNotify('M','w_base_mpi_initial', &
      'w_base_mpi_module (2019/10/05) is initialized')

  end subroutine w_base_mpi_Initial

  !---------------------------------------------------------------------
  !> スペクトルデータから格子データへ変換する(1 層用).
  !>
  function xv_w(w_data,ipow,iflag)
    !> スペクトルデータ
    real(DP), intent(in)   :: w_data(nc)
    !> 作用させる \f$1/\cosφ\f$ の次数. 省略時は 0.
    integer, intent(in), optional  :: ipow
    !>変換の種類: 省略時は 0.
    !> *  0 : 通常の逆変換
    !> * -1 : 経度微分を作用させた逆変換
    !> *  1 : 緯度微分 \f$\cosφ・∂/∂φ\f$ を作用させた逆変換
    !> *  2 : \f$\sinφ\f$を作用させた逆変換
    integer, intent(in), optional  :: iflag
    !> 格子点データ
    real(DP)               :: xv_w(0:im-1,1:jl)

    integer, parameter  :: ipow_default  = 0
    integer, parameter  :: iflag_default = 0

    integer(8) :: ipval, ifval

    ! 作業用スペクトルデータ(SYCS2X 出力用)
    real(DP)             :: w_Xdata((mm/np+1)*(2*(nn+1)-mm/np*np))
    ! 作業用スペクトルデータ(SYCS2Y 出力用)
    real(DP)             :: w_Ydata((mm/np+1)*(2*(nm+1)-mm/np*np))

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','xv_w',&
        'w_base_mpi_module not initialize yet.')
    endif

    if (present(ipow)) then
      ipval = ipow
    else
      ipval = ipow_default
    endif

    if (present(iflag)) then
      ifval = iflag
    else
      ifval = iflag_default
    endif

    if ( ifval==0 ) then
      call syts2g(mm,nm,nn,im,jm,jv,w_data,g,it,t,p,r,jc,w,ipval,icom)
      xv_w = g(:,1:jl)
    else if( ifval == -1 ) then
      call sycs2x(mm,nn,w_data,w_Xdata,icom)
      call syts2g(mm,nm,nn,im,jm,jv,w_Xdata,g,it,t,p,r,jc,w,ipval,icom)
      xv_w = g(:,1:jl)
    else if( ifval == 1 ) then
      call sycs2y(mm,nn,w_data,w_Ydata,c,icom)
      call syts2g(mm,nm,nm,im,jm,jv,w_Ydata,g,it,t,p,r,jc,w,ipval,icom)
      xv_w = g(:,1:jl)
    else if( ifval == 2 ) then
      call syts2g(mm,nm,nn,im,jm,jv,w_data,g,it,t,p,r,jc,w,ipval,icom)
      xv_w = g(:,1:jl)*sin(xv_Lat)
    else
      call MessageNotify('E','xv_w','invalid value of iflag')
    endif

  end function xv_w

  !---------------------------------------------------------------------
  !> 格子データからスペクトルデータへ(正)変換する(1 層用).
  !>
  function w_xv(xv_data,ipow,iflag)
    !> 格子点データ
    real(DP), intent(in)   :: xv_data(0:im-1,1:jl)
    !> 変換時に同時に作用させる \f$1/\cosφ\f$ の次数. 省略時は 0.
    integer, intent(in), optional  :: ipow
    !> 変換の種類. 省略時は 0.
    !> *  0 : 通常の正変換
    !> * -1 : 経度微分を作用させた正変換
    !> *  1 : 緯度微分 \f$1/\cosφ・∂(f \cos^2φ)/∂φ\f$
    !>        を作用させた正変換
    !> *  2 : \f$\sinφ\f$を作用させた正変換
    integer, intent(in), optional  :: iflag
    !> スペクトルデータ
    real(DP)               :: w_xv(nc)


    integer, parameter  :: ipow_default  = 0    ! スイッチデフォルト値
    integer, parameter  :: iflag_default = 0    ! スイッチデフォルト値

    integer(8) :: ipval, ifval

    ! 作業用スペクトルデータ(SYCS2X 出力用)
    real(DP)             :: w_Xdata((mm/np+1)*(2*(nn+1)-mm/np*np))
    ! 作業用スペクトルデータ(SYCS2Y 出力用)
    real(DP)             :: w_Ydata((mm/np+1)*(2*(nm+1)-mm/np*np))

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','xv_w',&
        'w_base_mpi_module not initialize yet.')
    endif

    if (present(ipow)) then
      ipval = ipow
    else
      ipval = ipow_default
    endif

    if (present(iflag)) then
      ifval = iflag
    else
      ifval = iflag_default
    endif

    if ( ifval == 0 ) then
      g = 0.0D0 ; g(:,1:jl) = xv_data
      call sytg2s(mm,nm,nn,im,jm,jv,w_xv,g,it,t,p,r,jc,w,ipval,icom)
    else if ( ifval == -1 ) then
      g = 0.0D0 ; g(:,1:jl) = xv_data
      call sytg2s(mm,nm,nn,im,jm,jv,w_Xdata,g,it,t,p,r,jc,w,ipval,icom)
      call sycs2x(mm,nn,w_Xdata,w_xv,icom)
    else if ( ifval == 1 ) then
      g = 0.0D0 ; g(:,1:jl) = xv_data
      call sytg2s(mm,nm,nm,im,jm,jv,w_Ydata,g,it,t,p,r,jc,w,ipval,icom)
      call sycy2s(mm,nn,w_Ydata,w_xv,c,icom)
    else if ( ifval == 2 ) then
      g = 0.0D0 ; g(:,1:jl) = xv_data*sin(xv_Lat)
      call sytg2s(mm,nm,nn,im,jm,jv,w_xv,g,it,t,p,r,jc,w,ipval,icom)
    end if

  end function w_xv


  !---------------------------------------------------------------------
  !> 流線・ポテンシャル(スペクトルデータ)から速度場(格子データ)に
  !> (逆)変換する(1 層用, MPI)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !> \f{align*}{
  !>   u \cosφ &=       ∂χ/∂λ - \cosφ∂ψ/∂φ, \\
  !>   v \cosφ &= \cosφ∂χ/∂φ +       ∂ψ/∂λ
  !> \f}
  !>
  subroutine w_StreamPotential2VectorMPI(w_Psi, w_Chi, xv_U, xv_V)
    !> 流線関数
    real(DP), intent(in)   :: w_Psi(nc)
    !> 速度ポテンシャル
    real(DP), intent(in)   :: w_Chi(nc)
    !> 速度経度成分
    real(DP), intent(out)   :: xv_U(0:im-1,1:jl)
    !> 速度緯度成分
    real(DP), intent(out)   :: xv_V(0:im-1,1:jl)

    real(DP)             :: w_Rdata1((mm/np+1)*(2*(nm+1)-mm/np*np))
    real(DP)             :: w_Rdata2((mm/np+1)*(2*(nm+1)-mm/np*np))
    ! 作業用スペクトルデータ(SYTS2G 出力用)
    real(DP)             :: w_Xdata((mm/np+1)*(2*(nn+1)-mm/np*np))
    ! 作業用スペクトルデータ(SYCS2X 出力用)
    real(DP)             :: w_Ydata((mm/np+1)*(2*(nm+1)-mm/np*np))
    ! 作業用スペクトルデータ(SYCS2Y 出力用)

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','w_StreamPotential2VectorMPI',&
        'w_base_module not initialize yet.')
    endif
    !
    !   u cosφ = ∂χ/∂λ - cosφ∂ψ/∂φ
    !
    call sycs2x(mm,nn,w_Chi,w_Xdata,icom)
    call sycs2y(mm,nn,w_Psi,w_Ydata,c,icom)
    call sycrpk(mm,nn,nm,w_Xdata,w_Rdata1,icom)
    w_Rdata1 = w_Rdata1 - w_Ydata
    !
    !   v cosφ = cosφ∂χ/∂φ + ∂ψ/∂λ
    !
    call sycs2y(mm,nn,w_Chi,w_Ydata,c,icom)
    call sycs2x(mm,nn,w_Psi,w_Xdata,icom)
    call sycrpk(mm,nn,nm,w_Xdata,w_Rdata2,icom)
    w_Rdata2= w_Rdata2 + w_Ydata
    !
    call syts2v(mm,nm,nm,im,jm,jv, &
      & w_Rdata1,w_Rdata2,g1,g2,it,t,p,r,jc,ww,1_8,icom)
    ! u
    xv_U = g1(:,1:jl)
    ! v
    xv_V = g2(:,1:jl)

  end subroutine w_StreamPotential2VectorMPI

  !---------------------------------------------------------------------
  !> 速度場(格子データ)から渦度・発散(スペクトルデータ)に
  !> (正)変換する(1 層用, MPI)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !> \f{align*}{
  !>   ζ & = 1/\cosφ∂v/∂λ - 1/\cosφ ∂(u \cosφ)/∂φ, \\
  !>    D & = 1/\cosφ∂u/∂λ + 1/\cosφ ∂(v \cosφ)/∂φ
  !> \f}
  !>
  subroutine w_Vector2VorDivMPI(xv_U, xv_V, w_Vor, w_Div)
    !> 速度経度成分
    real(DP), intent(in)   :: xv_U(0:im-1,1:jl)
    !> 速度緯度成分
    real(DP), intent(in)   :: xv_V(0:im-1,1:jl)
    !> 流線関数
    real(DP), intent(out)  :: w_Vor(nc)
    !> 速度ポテンシャル
    real(DP), intent(out)  :: w_Div(nc)

    real(DP)             :: w_Xdata((mm/np+1)*(2*(nn+1)-mm/np*np))
    ! 作業用スペクトルデータ(SUCS2X 出力用)
    real(DP)             :: w_Ydata1((mm/np+1)*(2*(nm+1)-mm/np*np))
    real(DP)             :: w_Ydata2((mm/np+1)*(2*(nm+1)-mm/np*np))
    ! 作業用スペクトルデータ(SUCS2Y 出力用)
    real(DP)             :: w_Data1((mm/np+1)*(2*(nn+1)-mm/np*np))
    real(DP)             :: w_Data2((mm/np+1)*(2*(nn+1)-mm/np*np))

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','w_Vector2VorDivMPI',&
        'w_base_module not initialize yet.')
    endif
    !
    ! 1/cosφ∂u/∂λ, 1/cosφ ∂(u cosφ)/∂φ
    !
    g1 = 0.0D0 ; g1(:,1:jl) = xv_U
    g2 = 0.0D0 ; g2(:,1:jl) = xv_V
    call sytv2s(mm,nm,nn+1,im,jm,jv,&
      & w_Ydata1,w_Ydata2,g1,g2,it,t,p,r,jc,ww,1_8,icom)

    call sycrpk(mm,nm,nn,w_Ydata1,w_Xdata,icom)
    call sycs2x(mm,nn,w_Xdata,w_Div,icom)
    call sycy2s(mm,nn,w_Ydata2,w_Data2,c,icom)
    !
    ! 1/cosφ∂v/∂λ, 1/cosφ ∂(v cosφ)/∂φ
    !
    call sycrpk(mm,nm,nn,w_Ydata2,w_Xdata,icom)
    call sycs2x(mm,nn,w_Xdata,w_Vor,icom)
    call sycy2s(mm,nn,w_Ydata1,w_Data1,c,icom)
    !
    !  渦度・発散の計算
    !
    !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
    !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
    !
    w_Vor = w_Vor - w_Data1
    w_Div = w_Div + w_Data2

  end subroutine w_Vector2VorDivMPI

  !---------------------------------------------------------------------
  !> 速度場(格子データ)から渦度・発散(スペクトルデータ)に
  !> (正)変換する(1 層用, MPI)
  !>
  !> スペクトル変換を用いず微分を計算するために, 変換回数が 2 回ですむ.
  !> \f{align*}{
  !>   ζ & = 1/\cosφ∂v/∂λ - 1/\cosφ ∂(u \cosφ)/∂φ, \\
  !>    D & = 1/\cosφ∂u/∂λ + 1/\cosφ ∂(v \cosφ)/∂φ
  !> \f}
  !>
  subroutine w_VectorCosLat2VorDivMPI(xv_UCosLat, xv_VCosLat, w_Vor, w_Div)
    !> 速度経度成分 * cos(lat)
    real(DP), intent(in)   :: xv_UCosLat(0:im-1,1:jl)
    !> 速度緯度成分 * cos(lat)
    real(DP), intent(in)   :: xv_VCosLat(0:im-1,1:jl)
    !> 流線関数
    real(DP), intent(out)   :: w_Vor(nc)
    !> 速度ポテンシャル
    real(DP), intent(out)   :: w_Div(nc)

    real(DP)             :: w_Xdata((mm/np+1)*(2*(nn+1)-mm/np*np))
    ! 作業用スペクトルデータ(SUCS2X 出力用)
    real(DP)             :: w_Ydata1((mm/np+1)*(2*(nm+1)-mm/np*np))
    real(DP)             :: w_Ydata2((mm/np+1)*(2*(nm+1)-mm/np*np))
    ! 作業用スペクトルデータ(SUCS2Y 出力用)
    real(DP)             :: w_Data1((mm/np+1)*(2*(nn+1)-mm/np*np))
    real(DP)             :: w_Data2((mm/np+1)*(2*(nn+1)-mm/np*np))

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','w_VectorCosLat2VorDivMPI',&
        'w_base_module not initialize yet.')
    endif
    !
    ! 1/cosφ∂u/∂λ, 1/cosφ ∂(u cosφ)/∂φ の計算
    !
    g1 = 0.0D0 ; g1(:,1:jl) = xv_UCosLat
    g2 = 0.0D0 ; g2(:,1:jl) = xv_VCosLat
    call sytv2s(mm,nm,nn+1,im,jm,jv,w_Ydata1,w_Ydata2,g1,g2,it,t,p,r,jc,ww,2_8,icom)

    call sycrpk(mm,nm,nn,w_Ydata1,w_Xdata,icom)
    call sycs2x(mm,nn,w_Xdata,w_Div,icom)
    call sycy2s(mm,nn,w_Ydata2,w_Data2,c,icom)
    !
    ! 1/cosφ∂v/∂λ, 1/cosφ ∂(v cosφ)/∂φ の計算
    !
    call sycrpk(mm,nm,nn,w_Ydata2,w_Xdata,icom)
    call sycs2x(mm,nn,w_Xdata,w_Vor,icom)
    call sycy2s(mm,nn,w_Ydata1,w_Data1,c,icom)
    !
    !  渦度・発散の計算
    !
    !   ζ = 1/cosφ∂v/∂λ - 1/cosφ ∂(u cosφ)/∂φ
    !    D = 1/cosφ∂u/∂λ + 1/cosφ ∂(v cosφ)/∂φ
    !
    w_Vor = w_Vor - w_Data1
    w_Div = w_Div + w_Data2

  end subroutine w_VectorCosLat2VorDivMPI

  !---------------------------------------------------------------------
  !> 分割緯度データを集める.
  !>
  function ay_av(av)
    !> 緯度格子点データ(分割) (:,jl)
    real(DP), dimension(:,:), intent(in) :: av
    !> 緯度格子点データ
    real(DP), dimension(size(av,1),jm)   :: ay_av

    integer :: a_size
    integer :: IRQSTS
    integer :: IST( MPI_STATUS_SIZE )

    integer :: ierr, i
    integer, parameter :: itag=103

    a_size = size(av,1)

    call MPI_Barrier(int(icom),IERR)
    do i=1,np-1
      call MPI_ISEND(av, a_size*jl, MPI_REAL8, rcv_rank(i),&
        itag,int(icom),IRQSTS,IERR)
      if ( j1p(snd_rank(i)) .ge. 1 ) then
        call MPI_RECV(ay_av(1,j1p(snd_rank(i))),&
          a_size*jlp(snd_rank(i)), MPI_REAL8,  &
          snd_rank(i), itag, int(icom), IST, IERR)
      endif
      CALL MPI_WAIT(IRQSTS,IST,IERR)
    enddo

    ay_av(:,j1:j2) = av

  end function ay_av

  !---------------------------------------------------------------------
  !> 緯度データを分割する
  !>
  function av_ay(ay)
    !> 緯度格子点データ(分割) (:,jc)
    real(DP), dimension(:,:), intent(in) :: ay
    !> 緯度格子点データ
    real(DP), dimension(size(ay,1),jl) :: av_ay

    av_ay = ay(:,j1:j2)

  end function av_ay


  !---------------------------------------------------------------------
  !> モジュールの終了処理(割り付け配列の解放)をおこなう.
  !>
  !> 実際の使用には上位サブルーチン w_mpi_finalize() を用いること.
  !>
  subroutine w_base_mpi_Finalize
    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('W','w_base_mpi_Finalize',&
        'w_base_mpi_module not initialized yet')
      return
    endif

    deallocate(it)                 ! 変換用配列
    deallocate(t)                  ! 変換用配列
    deallocate(r)                  ! 変換用配列
    deallocate(jc)                 ! 変換用配列
    deallocate(c)                  ! 変換用作業配列

    call mxfree(pp)                ! 変換用作業配列
    call mxfree(pg)                ! 変換用作業配列
    call mxfree(pg1)               ! 変換用作業配列
    call mxfree(pg2)               ! 変換用作業配列
    call mxfree(pw)                ! 変換用作業配列
    call mxfree(pww)               ! 変換用作業配列
    deallocate(j1p,j2p)
    deallocate(jlp)
    deallocate(ncp)
    deallocate(snd_rank)
    deallocate(rcv_rank)
    deallocate(x_Lon)              ! 格子点座標格納配列(経度)
    deallocate(x_Lon_weight)
    deallocate(xv_Lon)
    deallocate(v_Lat)
    deallocate(v_Lat_Weight)       ! 格子点座標格納配列
    deallocate(xv_Lat)             ! 格子点座標格納配列
    deallocate(y_Lat,y_Lat_Weight) ! 格子点座標格納配列
    deallocate(xy_Lon,xy_Lat)      ! 格子点座標格納配列

    w_base_mpi_initialize = .false.

    call MessageNotify('M','w_base_mpi_Finalize',&
      'w_base_mpi_module (2019/10/05) is finalized')

  end subroutine w_base_mpi_Finalize

  !---------------------------------------------------------------------!
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 引数 n,m がともに整数値の場合, 整数値を返す.
  !> プロセスに n,m が存在しない場合 0 を返す
  !>
  function l_nm_array00(n_in,m_in)
    !> 全波数
    integer, intent(in)   :: n_in
    !> 帯状波数
    integer, intent(in)   :: m_in
    !>  スペクトルデータの格納位置
    integer               :: l_nm_array00

    integer(8) :: ip_w
    integer(8) :: l, n, m

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','l_nm_array00',&
        'w_base_mpi_module not initialize yet. Use synm2l routine in ISPACK3 directly.')
    end if
    n = n_in
    m = m_in
    call synm2l(nn,n,m,ip_w,l,icom)
    if ( ip_w /= ip ) then
      l_nm_array00 = 0
    else
      l_nm_array00 = int(l)
    endif
  end function l_nm_array00

  !----------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 引数 n,m がともに整数値の場合, 整数値を返す.
  !> プロセスに n,m が存在しない場合 0 を返す
  !>
  function l_nm_darray00(n_in,m_in)
    !> 全波数
    integer(8), intent(in)   :: n_in
    !> 帯状波数
    integer(8), intent(in)   :: m_in
    !>  スペクトルデータの格納位置
    integer               :: l_nm_darray00

    integer(8) :: ip_w
    integer(8) :: l, n, m

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','l_nm_array00',&
        'w_base_mpi_module not initialize yet. Use synm2l routine in ISPACK3 directly.')
    end if
    n = n_in
    m = m_in
    call synm2l(nn,n,m,ip_w,l,icom)
    if ( ip_w /= ip ) then
      l_nm_darray00 = 0
    else
      l_nm_darray00 = int(l)
    endif
  end function l_nm_darray00

  !---------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合,
  !> marray と同じ大きさの 1 次元整数配列を返す.
  !>
  function l_nm_array01(n,marray)
    !> 全波数
    integer, intent(in)  :: n
    !> 帯状波数
    integer, intent(in)  :: marray(:)
    !> スペクトルデータ位置
    integer              :: l_nm_array01(size(marray))

    integer              :: i

    do i=1, size(marray)
      l_nm_array01(i) = l_nm_array00(n,marray(i))
    enddo
  end function l_nm_array01

  !---------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 第 1 引数 n が整数, 第 2 引数 marray が整数 1 次元配列の場合,
  !> marray と同じ大きさの 1 次元整数配列を返す.
  !>
  function l_nm_darray01(n,marray)
    !> 全波数
    integer(8), intent(in)  :: n
    !> 帯状波数
    integer(8), intent(in)  :: marray(:)
    !> スペクトルデータ位置
    integer                 :: l_nm_darray01(size(marray))

    integer                 :: i

    do i=1, size(marray)
      l_nm_darray01(i) = l_nm_darray00(n,marray(i))
    enddo
  end function l_nm_darray01

  !---------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合,
  !> narray と同じ大きさの 1 次元整数配列を返す.
  !>
  function l_nm_array10(narray,m)
    !>  全波数
    integer, intent(in)  :: narray(:)
    !>  帯状波数
    integer, intent(in)  :: m
    !> スペクトルデータ位置
    integer              :: l_nm_array10(size(narray))

    integer              :: i

    do i=1, size(narray)
      l_nm_array10(i) = l_nm_array00(narray(i),m)
    enddo
  end function l_nm_array10

  !---------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 第 1 引数 narray が整数 1 次元配列, 第 2 引数  m が整数の場合,
  !> narray と同じ大きさの 1 次元整数配列を返す.
  !>
  function l_nm_darray10(narray,m)
    !>  全波数
    integer(8), intent(in)  :: narray(:)
    !>  帯状波数
    integer(8), intent(in)  :: m
    !> スペクトルデータ位置
    integer                 :: l_nm_darray10(size(narray))

    integer              :: i

    do i=1, size(narray)
      l_nm_darray10(i) = l_nm_darray00(narray(i),m)
    enddo
  end function l_nm_darray10

  !---------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合,
  !> narray, marray と同じ大きさの 1 次元整数配列を返す.
  !> narray, marray は同じ大きさでなければならない.
  !>
  function l_nm_array11(narray,marray)
    !> 全波数
    integer, intent(in)  :: narray(:)
    !> 帯状波数
    integer, intent(in)  :: marray(:)
    !> スペクトルデータ位置
    integer              :: l_nm_array11(size(narray))

    integer              :: i

    if ( size(narray) .ne. size(marray) ) then
      call MessageNotify('E','l_nm_array11',&
        'dimensions of input arrays  n and m are different.')
    endif

    do i=1, size(narray)
      l_nm_array11(i) = l_nm_array00(narray(i),marray(i))
    enddo
  end function l_nm_array11

  !---------------------------------------------------------------------
  !> 全波数(n)と東西波数(m)からそのスペクトルデータの格納位置を返す.
  !>
  !> 第 1,2 引数 narray, marray がともに整数 1 次元配列の場合,
  !> narray, marray と同じ大きさの 1 次元整数配列を返す.
  !> narray, marray は同じ大きさでなければならない.
  !>
  function l_nm_darray11(narray,marray)
    !> 全波数
    integer(8), intent(in)  :: narray(:)
    !> 帯状波数
    integer(8), intent(in)  :: marray(:)
    !> スペクトルデータ位置
    integer              :: l_nm_darray11(size(narray))

    integer              :: i

    if ( size(narray) .ne. size(marray) ) then
      call MessageNotify('E','l_nm_array11',&
        'dimensions of input arrays  n and m are different.')
    endif

    do i=1, size(narray)
      l_nm_darray11(i) = l_nm_darray00(narray(i),marray(i))
    enddo
  end function l_nm_darray11

  !---------------------------------------------------------------------
  !> スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
  !>
  !> 引数 l が整数値の場合, 対応する全波数と帯状波数を
  !> 長さ 2 の 1 次元整数値を返す.
  !> nm_l(1) が全波数, nm_l(2) が帯状波数である.
  !>
  function nm_l_int(l)
    !> スペクトルデータの格納位置
    integer, intent(in)   :: l
    !> 全波数, 帯状波数
    integer               :: nm_l_int(2)

    integer(8)            :: n,m          ! 全波数, 帯状波数

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','nm_l_int', &
        'w_base_mpi_module not initialize yet. Use syl2nm routine in ISPACK3 directly.')
    endif
    call syl2nm(mm,nn,int(l,kind=8),n,m,icom)
    nm_l_int = (/int(n),int(m)/)

  end function nm_l_int

  !---------------------------------------------------------------------
  !> スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
  !>
  !> 引数 l が整数値の場合, 対応する全波数と帯状波数を
  !> 長さ 2 の 1 次元整数値を返す.
  !> nm_l(1) が全波数, nm_l(2) が帯状波数である.
  !>
  function nm_l_dint(l)
    !> スペクトルデータの格納位置
    integer(8), intent(in)   :: l
    !> 全波数, 帯状波数
    integer               :: nm_l_dint(2)

    integer(8)            :: n,m          ! 全波数, 帯状波数

    if ( .not. w_base_mpi_initialize ) then
      call MessageNotify('E','nm_l_int', &
        'w_base_mpi_module not initialize yet. Use syl2nm routine in ISPACK3 directly.')
    endif
    call syl2nm(mm,nn,l,n,m,icom)
    nm_l_dint = (/int(n),int(m)/)

  end function nm_l_dint

  !---------------------------------------------------------------------
  !> スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
  !>
  !> 引数 larray が整数 1 次元配列の場合,
  !> larray に対応する n, m を格納した 2 次元整数配列を返す.
  !> nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である.
  !>
  function nm_l_array(larray)
    !> 全波数, 帯状波数
    integer, intent(in)  :: larray(:)
    !> スペクトルデータの格納位置
    integer              :: nm_l_array(size(larray),2)

    integer              :: i

    do i=1, size(larray)
      nm_l_array(i,:) = nm_l_int(larray(i))
    enddo
  end function nm_l_array

  !---------------------------------------------------------------------
  !> スペクトルデータの格納位置(l)から全波数(n)と東西波数(m)を返す.
  !>
  !> 引数 larray が整数 1 次元配列の場合,
  !> larray に対応する n, m を格納した 2 次元整数配列を返す.
  !> nm_l_array(:,1) が全波数, nm_l_array(:,2) が帯状波数である.
  !>
  function nm_l_darray(larray)
    !> 全波数, 帯状波数
    integer(8), intent(in)  :: larray(:)
    !> スペクトルデータの格納位置
    integer              :: nm_l_darray(size(larray),2)

    integer              :: i

    do i=1, size(larray)
      nm_l_darray(i,:) = nm_l_dint(larray(i))
    enddo
  end function nm_l_darray

end module w_mpi_module_base

! -*- mode: f90; coding: utf-8 -*-
!-----------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!-----------------------------------------------------------------------
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @brief
!> @ref w_mpi_module の下部モジュール: 微分
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは w_mpi_module を呼ぶこと．
!
! 履歴  2019/03/21  竹広真一
!       2019/10/06  佐々木洋平
!
module w_mpi_module_deriv
  use dc_types, only: DP
  use dc_message, only : MessageNotify
  use w_mpi_module_base, only : &
    & im, jm, mm, nm, nn, jc=>jl, nc, xv_w, w_xv, icom
  implicit none
  private

  public w_deriv_mpi_Initial                  ! 初期化
  public w_deriv_mpi_Finalize                 ! 終了処理
  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xv_GradLon_w, xv_GradLat_w           ! 勾配型微分
  public w_DivLon_xv, w_DivLat_xv             ! 発散型微分
  public w_Div_xv_xv                          ! 発散型微分
  public w_JacobianMPI_w_w                    ! ヤコビアン
  public xv_GradLambda_w, xv_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xv, w_DivMu_xv           ! 発散型微分(λ,μ座標)
  public rn                                   ! ラプラシアン演算用配列

  !---------------------------------------------------------------------
  !> ラプラシアン演算用配列(w_module と互換性を保つため)
  !>
  !> スペクトルデータのラプラシアンを計算するための係数
  !> 配列のサイズは(nc, 2)
  !>
  !> r(L,1) には L 番目の格納位置のスペクトルに対するラプラシアン計算の
  !> 係数 -n(n+1) の値が格納されている.
  real(DP), allocatable  :: rn(:,:)

  !---------------------------------------------------------------------
  !> ラプラシアン演算用配列
  !>
  !> スペクトルデータのラプラシアンを計算するための係数
  !> 配列のサイズは(nc*2)
  real(DP), allocatable  :: D(:)

  logical                :: w_deriv_mpi_initialize=.false.   ! 初期化フラグ

  save rn, D

contains

  !---------------------------------------------------------------------
  !> スペクトル微分計算に必要となる作業領域を設定する.
  !>
  !> 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで
  !> 初期設定をしなければならない.
  !>
  !> 上位サブルーチン w_mpi_initial() を使用すること.
  !>
  subroutine w_deriv_mpi_initial
    allocate(D(nc*2))                      ! ラプラシアン演算用配列
    allocate(rn(nc,2))                     ! ラプラシアン演算用配列

    call syinid(mm,nn,D,icom)

    rn = reshape(D,(/nc,2/))

    w_deriv_mpi_initialize=.true.

    call MessageNotify('M','w_deriv_mpi_initial', &
      'w_deriv_mpi_module (2019/10/06)is initialized')

  end subroutine w_deriv_mpi_initial

  !---------------------------------------------------------------------
  !>
  !> 入力スペクトルデータにラプラシアン
  !> \f[
  !>    ▽^2 = 1/\cos^2φ・∂^2/∂λ^2 + 1/\cosφ・∂/∂φ(\cosφ∂/∂φ)
  !> \f]
  !> を作用する(1 層用).
  !>
  !> スペクトルデータのラプラシアンとは, 対応する格子点データに
  !> ラプラシアンを作用させたデータのスペクトル変換のことである.
  function w_Lapla_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data(nc)
    !> 入力スペクトルデータのラプラシアン
    real(DP)              :: w_Lapla_w(nc)

    call syclap(mm,nn,w_data,w_Lapla_w,D,1_8,icom)

  end function w_Lapla_w

  !---------------------------------------------------------------------
  !> 入力スペクトルデータに逆ラプラシアン
  !> \f[
  !>    ▽^{-2}
  !>      =[1/cos^2φ・∂^2/∂λ^2 + 1/cosφ・∂/∂φ(cosφ∂/∂φ)]^{-1}
  !> \f]
  !> を作用する(1 層用).
  !>
  !> スペクトルデータの逆ラプラシアンとは, 対応する格子点データに
  !> 逆ラプラシアンを作用させたデータのスペクトル変換のことである.
  function w_LaplaInv_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data(nc)
    !> スペクトルデータの逆ラプラシアン
    real(DP)              :: w_LaplaInv_w(nc)

    call syclap(mm,nn,w_data,w_LaplaInv_w,D,2_8,icom)

  end function w_LaplaInv_w

  !---------------------------------------------------------------------
  !> スペクトルデータに経度微分 \f$∂/∂λ\f$ を作用させる(1 層用).
  !>
  !> スペクトルデータの経度微分とは, 対応する格子点データに
  !> 経度微分\f$∂/∂λ\f$を作用させたデータのスペクトル変換のことである.
  !>
  function w_DLon_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data(nc)
    !> スペクトルデータの経度微分
    real(DP)              :: w_DLon_w(nc)

    call sycs2x(mm,nn,w_data,w_DLon_w,icom)

  end function w_DLon_w

  !---------------------------------------------------------------------!
  !> スペクトルデータに勾配型経度微分 \f$1/\cosφ・∂/∂λ\f$ を
  !> 作用させた格子点データを返す(1 層用).
  !>
  function xv_GradLon_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data(nc)
    !> スペクトルデータを勾配型経度微分した格子点データ
    real(DP)              :: xv_GradLon_w(0:im-1,jc)

    xv_GradLon_w = xv_w(w_data,ipow=1,iflag=-1)

  end function xv_GradLon_w

  !---------------------------------------------------------------------
  !> スペクトルデータに勾配型緯度微分 \f$∂/∂φ\f$ を作用させて
  !> 格子点データに変換して返す(1 層用).
  !>
  function xv_GradLat_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data(nc)
    !> スペクトルデータを勾配型緯度微分した格子点データ
    real(DP)              :: xv_GradLat_w(0:im-1,jc)

    xv_GradLat_w = xv_w(w_data,ipow=1,iflag=1)

  end function xv_GradLat_w

  !---------------------------------------------------------------------
  !> 格子点データに発散型経度微分 \f$1/\cosφ・∂/∂λ\f$ を作用させて
  !> スペクトルデータに変換して返す(1 層用).
  !>
  function w_DivLon_xv(xv_data)
    !> 入力格子点データ
    real(DP), intent(in)  :: xv_data(0:im-1,jc)
    !>  格子点データを発散型経度微分したスペクトルデータ
    real(DP)              :: w_DivLon_xv(nc)

    w_DivLon_xv = w_xv(xv_data,ipow=1,iflag=-1)

  end function w_DivLon_xv

  !---------------------------------------------------------------------
  !> 格子点データに発散型緯度微分 \f$1/\cosφ・∂(f \cosφ)/∂φ\f$
  !> を作用させてスペクトルデータに変換して返す(1 層用).
  !>
  function w_DivLat_xv(xv_data)
    !> 入力格子点データ
    real(DP), intent(in)  :: xv_data(0:im-1,jc)
    !>  格子点データを発散型緯度微分したスペクトルデータ
    real(DP)              :: w_DivLat_xv(nc)

    w_DivLat_xv = w_xv(xv_data,ipow=1,iflag=1)

  end function w_DivLat_xv

  !---------------------------------------------------------------------
  !> 2 つの入力格子点データをベクトル成分とする発散を計算し,
  !> スペクトルデータとして返す(1 層用).
  !>
  function w_Div_xv_xv(xv_u,xv_v)
    !> ベクトル経度成分の格子点データ
    real(DP), intent(in)  :: xv_u(0:im-1,jc)
    !> ベクトル緯度成分の格子点データ
    real(DP), intent(in)  :: xv_v(0:im-1,jc)
    !>  2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ
    real(DP)              :: w_Div_xv_xv(nc)

    w_Div_xv_xv = w_Divlon_xv(xv_u) + w_Divlat_xv(xv_v)

  end function w_Div_xv_xv


  !---------------------------------------------------------------------
  !> 2 つのスペクトルデータにヤコビアン:
  !> \f{align*}{
  !>   J(f,g) &= ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ \\
  !>          &= ∂f/∂λ・1/\cosφ・∂g/∂φ
  !>             - ∂g/∂λ・1/\cosφ・∂f/∂φ
  !>\f}
  !> を作用させる(1 層用).
  !>
  function w_JacobianMPI_w_w(w_a,w_b)
    !> 1つ目の入力スペクトルデータ
    real(DP), intent(in) :: w_a(nc)
    !> 2つ目の入力スペクトルデータ
    real(DP), intent(in) :: w_b(nc)
    !>  2 つのスペクトルデータのヤコビアン
    real(DP)             :: w_JacobianMPI_w_w(nc)

    w_JacobianMPI_w_w = w_xv( &
      xv_w(w_DLon_w(w_a))*xv_w(w_b,ipow=2,iflag=1) &
      - xv_w(w_DLon_w(w_b))*xv_w(w_a,ipow=2,iflag=1) )

  end function w_JacobianMPI_w_w


  !---------------------------------------------------------------------
  !> スペクトルデータに勾配型経度微分 \f$∂/∂λ\f$ を作用する(1 層用).
  !>
  function xv_GradLambda_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data(nc)
    !>  スペクトルデータを勾配型経度微分した格子点データ
    real(DP)              :: xv_GradLambda_w(0:im-1,jc)

    xv_GradLambda_w = xv_w(w_data,ipow=0,iflag=-1)

  end function xv_GradLambda_w

  !---------------------------------------------------------------------
  !> スペクトルデータに勾配型緯度微分 \f$(1-μ^2)∂/∂μ,  (μ=\sinφ)\f$
  !> を作用させて格子点データに変換して返す(1 層用).
  !>
  function xv_GradMu_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data(nc)
    !>  スペクトルデータを勾配型緯度微分した格子点データ
    real(DP)              :: xv_GradMu_w(0:im-1,jc)

    xv_GradMu_w = xv_w(w_data,ipow=0,iflag=1)

  end function xv_GradMu_w

  !---------------------------------------------------------------------
  !> 格子点データに発散型経度微分 \f$1/(1-μ^2)・∂/∂λ, (μ=\sinφ)\f$
  !> を作用させてスペクトルデータに変換して返す(1 層用).
  !>
  function w_DivLambda_xv(xv_data)
    !> 入力格子点データ
    real(DP), intent(in)  :: xv_data(0:im-1,jc)
    !>  格子点データを発散型経度微分したスペクトルデータ
    real(DP)              :: w_DivLambda_xv(nc)

    w_DivLambda_xv = w_xv(xv_data,ipow=2,iflag=-1)

  end function w_DivLambda_xv

  !---------------------------------------------------------------------
  !> 格子点データに発散型緯度微分 \f$∂/∂μ, (μ=\sinφ)\f$ を作用させて
  !> スペクトルデータに変換して返す(1 層用).
  !>
  function w_DivMu_xv(xv_data)
    !> 入力格子点データ
    real(DP), intent(in)  :: xv_data(0:im-1,jc)
    !>  格子点データを発散型緯度微分したスペクトルデータ
    real(DP)              :: w_DivMu_xv(nc)

    w_DivMu_xv = w_xv(xv_data,ipow=2,iflag=1)

  end function w_DivMu_xv

  !---------------------------------------------------------------------
  !> モジュールの終了処理(割り付け配列の解放)をおこなう.
  !>
  !> @warning
  !> このサブルーチンを単独で用いるのでなく,
  !> 上位サブルーチン w_mpi_Finalize を使用すること.
  !>
  subroutine w_deriv_mpi_finalize
    if ( .not. w_deriv_mpi_initialize ) then
      call MessageNotify('W','w_deriv_Finalize',  &
        'w_deriv_mpi_module not initialized yet')
      return
    end if

    deallocate(D)           ! ラプラシアン演算用配列
    deallocate(rn)          ! ラプラシアン演算用配列

    w_deriv_mpi_initialize = .false.

    call MessageNotify('M','w_deriv_mpi_Finalize',&
      'w_deriv_mpi_module (2019/03/21) is finalized')

  end subroutine w_deriv_mpi_finalize

end module w_mpi_module_deriv

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXINM2(MM,NM,JM,IG,P,R,JC,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NM,JM,IG,M,IE,IJ,MI,K
  REAL(8) :: P(JM/2,5+2*(MM/MI+1))
  REAL(8) :: R(5*(MM/MI+1)*(2*NM-MM/MI*MI)/4+MM/MI+1)
  INTEGER(8) :: JC((MM/MI+1)*(2*NM-MM/MI*MI)/16+MM/MI+1)
  INTEGER(8) :: NPMAX  
  INTEGER(8) :: N1,M1,MN  

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  CALL LXINIG(JM,P,IG)

  CALL MXGOMP(NPMAX)  

!$omp parallel private(K,M,IE,IJ) num_threads(NPMAX)
!$omp do schedule(dynamic)
  DO K=0,MN-1
     IE=5*K*(2*NM-MI*(K-1))/4+K+1 ! サイズを変えたのでこうなる
     IJ=K*(2*NM-MI*(K-1))/16+K+1
     M=K*MI
     IF(M.NE.0) THEN     
        CALL LXINIW(NM,JM,M,P,P(1,5+2*K+1),R(IE),JC(IJ))
     END IF
  END DO
!$omp end do
!$omp end parallel  
  
END SUBROUTINE SXINM2

! -*- mode: f90; coding: utf-8 -*-
!-------------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2019/03/19 竹広真一
!       2019/10/09 佐々木洋平
!
!-------------------------------------------------------------------------
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @brief
!> @ref w_mpi_module の下部モジュール: スペクトル解析
!>
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは w_mpi_module を呼ぶこと．
!>
module w_mpi_module_spectrum
  use mpi
  use dc_types, only: DP
  use w_mpi_module_base, only: nm=>nn, nm_l, nc, icom

  implicit none
  private
  !> エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)
  public nm_EnergyFromStreamfunc_w
  !> エネルギースペクトル(水平全波数 n 空間)
  public n_EnergyFromStreamfunc_w
  !> エンストロフィースペクトル(水平全波数 n, 帯状波数 m 空間)
  public nm_EnstrophyFromStreamfunc_w
  !> エンストロフィースペクトル(水平全波数 n 空間)
  public n_EnstrophyFromStreamfunc_w
  !> 欠損値. 初期値は -999.000
  public w_spectrum_VMiss
  real(DP) :: w_spectrum_VMiss = -999.000

contains

  !---------------------------------------------------------------------
  !> 流線関数のスペクトルデータからエネルギーの球面調和函数成分
  !> (スペクトル)を計算する(1 層用).
  !>
  !>  * 全波数 n, 帯状波数 m の流線関数のスペクトル成分
  !>    \f$ψ(n,m)\f$ から, エネルギースペクトルは
  !>    \f$(1/2)n(n+1)|ψ(n,m)|^2\f$ と計算される.
  !>
  !>  * 全てのエネルギースペクトル成分の和に\f$4π\f$をかけたものが
  !>    球面上での全エネルギーに等しい.
  !>
  !>  * スペクトルの (n,m) 成分は全波数 n, 東西波数 m の実部成分,
  !>    (n,-m) 成分は全波数 n, 東西波数 m の虚部成分が格納されている.
  !>
  !>  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
  !>    欠損値の値はモジュール変数
  !>    [w_spectrum_VMiss](@ref w_spectrum_vmiss) によって設定できる
  !>    (初期値は -999.0)
  !>
  function nm_EnergyFromStreamfunc_w(w_Strfunc)
    !> 流線関数(スペクトルデータ)
    real(DP), intent(in)             :: w_Strfunc(nc)
    !> エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)
    real(DP), dimension(0:nm,-nm:nm) :: nm_EnergyFromStreamfunc_w

    real(DP), dimension(0:nm,-nm:nm) :: nm_Work
    integer :: l, n, m, nm_ary(2)
    integer :: ierr

    nm_work = 0.0D0
    do l=1,int(nc)
      nm_ary = nm_l(l)
      n = nm_ary(1)
      m = abs(nm_ary(2))
      if ( n .ge. 0 ) then
        if ( m == 0 ) then
          nm_Work(n,0) = nm_Work(n,0) &
            & + 0.5D0 * n*(n+1) * w_Strfunc(l)**2
        else
          nm_Work(n,m) = nm_Work(n,m) &
            & + 0.5D0 * n*(n+1) * w_Strfunc(l)**2
          nm_Work(n,-m) = nm_Work(n,-m) &
            & + 0.5D0 * n*(n+1) * w_Strfunc(l)**2
        endif
      endif
    enddo

    CALL MPI_ALLREDUCE(nm_Work,                          &
      & nm_EnergyFromStreamfunc_w, int((nm+1)*(2*nm+1)), &
      & MPI_REAL8,MPI_SUM, int(icom), IERR)

    do m=1,int(nm)
      do n=0,m-1
        nm_EnergyFromStreamfunc_w(n,m)  = w_spectrum_Vmiss
        nm_EnergyFromStreamfunc_w(n,-m) = w_spectrum_Vmiss
      end do
    end do

  end function nm_EnergyFromStreamfunc_w

  !---------------------------------------------------------------------
  !> 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
  !> 計算する(1 層用).
  !>
  !>  * 全波数 n の流線関数のスペクトル成分 \f$ψ(n,m)\f$ から
  !>    エネルギースペクトルは
  !>    \f[ \sum_{m=-nm}^{nm}(1/2)n(n+1)|ψ(n,m)|^2\f]
  !>    と計算される.
  !>
  !>  * 全てのエネルギースペクトル成分の和に \f$4π\f$ をかけたものが
  !>    球面上での全エネルギーに等しい.
  !>
  function n_EnergyFromStreamfunc_w(w_Strfunc)
    !> 流線関数(スペクトルデータ)
    real(DP), intent(in)      :: w_Strfunc(nc)
    !> エネルギースペクトル (水平全波数 n 空間)
    real(DP), dimension(0:nm) :: n_EnergyFromStreamfunc_w

    real(DP), dimension(0:nm) :: n_Work

    integer  :: l, n, m, nm_ary(2)
    real(DP) :: factor
    integer :: ierr

    n_work = 0.0D0
    do l=1,int(nc)
      nm_ary = nm_l(l)
      n = nm_ary(1)
      m = abs(nm_ary(2))
      if ( n .ge. 0 ) then
        if ( m == 0 ) then
          factor = 1.0D0
        else
          factor = 2.0D0
        endif
        n_Work(n) = n_Work(n) &
          + factor * 0.5D0 * n*(n+1) * w_Strfunc(l)**2
      endif
    enddo

    CALL MPI_ALLREDUCE(n_Work,               &
      & n_EnergyFromStreamfunc_w, int(nm+1), &
      & MPI_REAL8, MPI_SUM, int(icom), IERR)

  end function n_EnergyFromStreamfunc_w

  !---------------------------------------------------------------------
  !> 流線関数のスペクトルデータからエンストロフィーの球面調和函数成分
  !> (スペクトル)を計算する(1 層用).
  !>
  !> * 全波数 n, 帯状波数 m の流線関数のスペクトル成分 \f$ψ(n,m)\f$ から
  !>   エンストロフィースペクトルは
  !>   \f$(1/2)n^2(n+1)^2|ψ(n,m)|^2\f$と計算される.
  !>
  !> * 全てのエンストロフィースペクトル成分の和に \f$4π/R^2\f$ をかけた
  !>   ものが球面上での全エンストロフィーに等しい.
  !>   ここで \f$R\f$ は球面の半径である.
  !>
  !> * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
  !>   欠損値の値はモジュール変数 w_spectrum_VMiss によって設定できる
  !>   (初期値は -999.0)
  !>
  function nm_EnstrophyFromStreamfunc_w(w_Strfunc)
    !> 流線関数(スペクトルデータ)
    real(DP), intent(in)   :: w_Strfunc(nc)
    !> エンストロフィースペクトル (水平全波数 n, 帯状波数 m 空間)
    real(DP), dimension(0:nm,-nm:nm) :: nm_EnstrophyFromStreamfunc_w

    real(DP), dimension(0:nm,-nm:nm) :: nm_Work
    integer :: l, n, m, nm_ary(2)
    integer :: ierr

    nm_work = 0.0D0
    do l=1,int(nc)
      nm_ary = nm_l(l)
      n = nm_ary(1)
      m = abs(nm_ary(2))
      if ( n .ge. 0 ) then
        if ( m == 0 ) then
          nm_Work(n,0) = nm_Work(n,0) &
            +  0.5D0 * n**2 * (n+1)**2 * w_Strfunc(l)**2
        else
          nm_Work(n,m) = nm_Work(n,m) &
            +  0.5D0 * n**2 * (n+1)**2 * w_Strfunc(l)**2
          nm_Work(n,-m) = nm_Work(n,-m) &
            +  0.5D0 * n**2 * (n+1)**2 * w_Strfunc(l)**2
        endif
      endif
    enddo

    CALL MPI_ALLREDUCE(nm_Work,                            &
      & nm_EnstrophyFromStreamfunc_w,int((nm+1)*(2*nm+1)), &
      MPI_REAL8, MPI_SUM, int(icom), IERR)

    do m=1,int(nm)
      do n=0,m-1
        nm_EnstrophyFromStreamfunc_w(n,m)  = w_spectrum_Vmiss
        nm_EnstrophyFromStreamfunc_w(n,-m) = w_spectrum_Vmiss
      enddo
    enddo

  end function nm_EnstrophyFromStreamfunc_w

  !---------------------------------------------------------------------
  !> 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
  !> 計算する(1 層用)
  !>
  !> * 全波数 n の流線関数のスペクトル成分ψ(n,m) からエンストロフィー
  !>   スペクトルは
  !>   \f[\sum_{m=-nm}^{nm} (1/2)n^2(n+1)^2|ψ(n,m)|^2\f] と計算される.
  !>
  !> * 全てのエネルギースペクトル成分の和に \f$4π/R^2\f$ をかけたものが
  !>   球面上での全エンストフィーに等しい.
  !>   ここで \f$R\f$ は球面の半径である.
  !>
  function n_EnstrophyFromStreamfunc_w(w_Strfunc)
    !> 流線関数(スペクトルデータ)
    real(DP), intent(in)      :: w_Strfunc(nc)
    !> エンストロフィースペクトル(水平全波数 n 空間)
    real(DP), dimension(0:nm) :: n_EnstrophyFromStreamfunc_w

    real(DP), dimension(0:nm) :: n_Work

    integer :: l, n, m, nm_ary(2)
    real(DP) :: factor

    integer :: ierr

    n_work = 0.0D0
    do l=1,int(nc)
      nm_ary = nm_l(l)
      n = nm_ary(1)
      m = abs(nm_ary(2))
      if ( n .ge. 0 ) then
        if ( m == 0 ) then
          factor = 1.0D0
        else
          factor = 2.0D0
        endif
        n_Work(n) = n_Work(n) &
          + factor * 0.5D0 * n**2 * (n+1)**2 * w_Strfunc(l)**2
      endif
    enddo

    CALL MPI_ALLREDUCE(n_Work,                 &
      & n_EnstrophyFromStreamfunc_w,int(nm+1), &
      & MPI_REAL8, MPI_SUM, int(icom), IERR)

  end function n_EnstrophyFromStreamfunc_w

end module w_mpi_module_spectrum

!----------------------------------------------------------------------
!     Copyright (c) 2019 Shin-ichi Takehiro. All rights reserved.
!----------------------------------------------------------------------
!
!表題  ua_integrale_module テストプログラム :: 積分・平均関数のテスト
!
!履歴  2019/05/01  竹広真一
!
program ua_integral_mpi_module

  use dc_message, only : MessageNotify
  use dc_test, only : AssertEqual
  use ua_mpi_module
  use mpi
  implicit none

  integer, parameter :: im=128, jm=64, nm=42, km=2, npv=2

  real(8), allocatable             ::  b_idata(:)          ! 積分・平均の正解
  real(8), allocatable             ::  xvb_data(:,:,:)     ! 元の関数
  real(8), allocatable             ::  xb_idata(:,:)       ! 積分・平均の正解
  real(8), allocatable             ::  vb_idata(:,:)       ! 積分・平均の正解

  ! 判定誤差設定
  integer, parameter :: check_digits = 10
  integer, parameter :: ignore = -11

  real(8) :: pi
  integer :: iproc, np, ierr

 !---------------- MPI スタート ---------------------
  call MPI_INIT(IERR)
  call MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERR)
  call MPI_COMM_SIZE(MPI_COMM_WORLD,NP,IERR)

  pi = atan(1.0D0)*4.0D0

  call MessageNotify('M','ua_integral_mpi_module_test', &
                         'ua_integral_mpi_module function tests')

  call ua_mpi_Initial( nm, im, jm, km, npv=2 )


  allocate(xvb_data(0:im-1,jc,kc))
  allocate(xb_idata(0:im-1,kc))
  allocate(vb_idata(jc,kc))
  allocate(b_idata(kc))

  !---- 積分のテスト(分割領域) ----
  xvb_data = 0.0D0
  if ( kp_kl(1) /= 0 ) &
       xvb_data(:,:, kp_kl(1)) = sin(xv_Lat)**2*(1-cos(xv_Lon)**2)
  if ( kp_kl(2) /= 0 ) &
       xvb_data(:,:,kp_kl(2)) = sin(xv_Lat)**4*(1-sin(xv_Lon)**2)

  if ( kp_kl(1) /= 0 ) b_idata(kp_kl(1)) = 2*pi/3       ! a_IntLonLat_xvb
  if ( kp_kl(2) /= 0 ) b_idata(kp_kl(2)) = 2*pi/5       ! a_IntLonLat_xvb
  call AssertEqual(&
    message='a_IntLonLat_xvb',                                    &
    answer = b_IntLonLat_xvb(xvb_data),                           &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  if ( kp_kl(1) /= 0 ) vb_idata(:,kp_kl(1)) = pi*sin(v_Lat)**2  ! v_IntLon_xvb
  if ( kp_kl(2) /= 0 ) vb_idata(:,kp_kl(2)) = pi*sin(v_Lat)**4  ! v_IntLon_xvb
  call AssertEqual(&
    message='vb_IntLon_xvb',                                      &
    answer = vb_IntLon_xvb(xvb_data),                             &
    check =  vb_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='b_IntLat_vb',                                        &
    answer = b_IntLat_vb(vb_idata),                               &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  if ( kp_kl(1) /= 0 ) &
       xb_idata(:,kp_kl(1)) = 2.0D0/3*(1-cos(x_Lon)**2)       ! x_IntLat_xvb
  if ( kp_kl(2) /= 0 ) &
       xb_idata(:,kp_kl(2)) = 2.0D0/5*(1-sin(x_Lon)**2)       ! x_IntLat_xvb

  call AssertEqual(&
    message='xb_IntLat_xvb',                                      &
    answer = xb_IntLat_xvb(xvb_data),                             &
    check =  xb_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='b_IntLon_xb',                                        &
    answer = b_IntLon_xb(xb_idata),                               &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  !---- 平均のテスト(分割領域) ----
  if ( kp_kl(1) /= 0 ) &
       xvb_data(:,:,kp_kl(1)) = sin(xv_Lat)**2*(1-cos(xv_Lon)**2)
  if ( kp_kl(2) /= 0 ) &
       xvb_data(:,:,kp_kl(2)) = sin(xv_Lat)**4*(1-sin(xv_Lon)**2)

  if ( kp_kl(1) /= 0 ) b_idata(kp_kl(1)) = 1.0D0/6       ! AvrLonLat_xvb
  if ( kp_kl(2) /= 0 ) b_idata(kp_kl(2)) = 1.0D0/10      ! AvrLonLat_xvb
  call AssertEqual(&
    message='b_AvrLonLat_xvb',                                    &
    answer = b_AvrLonLat_xvb(xvb_data),                           &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  if ( kp_kl(1) /= 0 ) vb_idata(:,kp_kl(1)) = 0.5*sin(v_Lat)**2   ! v_AvrLon_xvb
  if ( kp_kl(2) /= 0 ) vb_idata(:,kp_kl(2)) = 0.5*sin(v_Lat)**4   ! v_AvrLon_xvb
  call AssertEqual(&
    message='vb_AvrLon_xvb',                                      &
    answer = vb_AvrLon_xvb(xvb_data),                             &
    check =  vb_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='b_AvrLat_vb',                                        &
    answer = b_AvrLat_vb(vb_idata),                               &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  if ( kp_kl(1) /= 0 ) &
       xb_idata(:,kp_kl(1)) = 1.0D0/3*(1-cos(x_Lon)**2)       ! x_AvrLat_xvb
  if ( kp_kl(2) /= 0 ) &
       xb_idata(:,kp_kl(2)) = 1.0D0/5*(1-sin(x_Lon)**2)       ! x_AvrLat_xvb

  call AssertEqual(&
    message='xb_AvrLat_xvb',                                      &
    answer = xb_AvrLat_xvb(xvb_data),                             &
    check =  xb_idata,                                            &
    significant_digits = check_digits, ignore_digits = ignore     &
    )

  call AssertEqual(&
    message='b_AvrLon_xb',                                        &
    answer = b_AvrLon_xb(xb_idata),                               &
    check =  b_idata,                                             &
    significant_digits = check_digits, ignore_digits = ignore     &
    )


  call MessageNotify('M','ua_integral_mpi_module_test', &
       'ua_integral_mpi_module function tests succeded!')

 !------ MPIの終了 ------

  call MPI_FINALIZE(IERR)

end program ua_integral_mpi_module

! -*- mode: f90; coding: utf-8 -*-
!----------------------------------------------------------------------
! Copyright (c) 2009-2016 SPMODEL Development Group. All rights reserved.
!

!履歴  2009/09/06  竹広真一  wa_deriv_module より SVPACK 用に改造
!      2009/09/20  竹広真一  使用上の注意を追加
!      2013/02/12  竹広真一  w_StreamPotential2Vector, w_Vector2VorDiv,
!                            wa_StreamPotential2Vector, wa_Vector2VorDiv 導入
!      2013/02/14  竹広真一  w_VectorCosLat2VorDiv, wa_VectorCosLat2VorDiv 導入
!      2013/02/23  竹広真一  wa_Finalize 導入
!      2019/12/24  佐々木洋平 SXPACK 用に更新
!----------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief 3次元球面: 水平球面調和関数展開: @ref w_module の多層版
!>
!> @details
!> spml/wa_module モジュールは球面での3次元流体運動を
!> 球面調和函数を用いたスペクトル法によって数値計算するための
!> Fortran90 関数を提供する.
!>
!> 球面上の 1 層モデル用 @ref w_module モジュールを多層モデル用に
!> 拡張したものであり,
!> 同時に複数個のスペクトルデータ, 格子点データに対する変換が行える.
!>
!> w_module は実際には以下の下部モジュールからなる．
!> * wa_module_base: 基本変換
!> * wa_module_deriv: 微分計算
!> * wa_module_integral: 積分・平均計算
!> * wa_module_spectrum: スペクトル解析
!> * wa_module_interpolate: 補間計算
!>
!> 内部は ISPACK3 の SXPACKサブルーチンを呼んでいる.
!> スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法
!> についてはISPACK3/SXPACK のマニュアルを参照されたい.
!>
!> @warning
!> 後方非互換である点に注意されたい
!> * 旧版と異なり (ISPACK/SXPACKのレベルで) 球面調和関数の正規化が異なる．
!> * 旧版と異なり,
!>   [l_nm](@ref w_module_base#l_nm),
!>   [nm_l](@ref w_module_base#nm_l)
!>   は初期化したのちにしか使うことができない.
!>
!>=== 命名法
!>
!> * 関数名の先頭 (wa_, nma_, na_, xya_, xa_, ya_, w_, xy_, x_, y_, a_) は,
!>   返す値の形を示している.
!>   wa_  :: 水平スペクトルデータの並んだ 2 次元配列(スペクトルデータの
!>           並びは SNPACK/ISPACK に従ったもの)
!>   nma_ :: スペクトルデータの並んだ 3 次元配列 (スペクトルデータの並びは
!>           全波数 n, 帯状波数 m で指定される 2 次元配列)
!>   na_  :: スペクトルデータの並んだ 2 次元配列 (スペクトルデータの並びは
!>           全波数 n で指定される 1 次元配列)
!>   xya_ :: 2 次元格子点データの並んだ 3 次元配列
!>   xa_  :: 経度方向 1 次元格子点データの並んだ 2 次元配列
!>   ya_  :: 緯度方向 1 次元格子点データの並んだ 2 次元配列
!>
!> * 関数名の間の文字列(DLon, GradLat, GradLat, DivLon, DivLat, Lapla,
!>   LaplaInv, Jacobian)は, その関数の作用を表している.
!>
!> * 関数名の最後 (_wa_wa, _wa, _xya, _xa, _ya, _w_w, _w, _xy, _x, _y) は,
!>   入力変数の形スペクトルデータおよび格子点データであることを示している.
!>   _wa    :: スペクトルデータの並んだ 2 次元配列
!>   _wa_wa :: 2 つのスペクトルデータの並んだ 2 次元配列
!>   _xya   :: 2 次元格子点データの並んだ 3 次元配列
!>   _xa    :: 経度方向 1 次元格子点データの並んだ 2 次元配列
!>   _ya    :: 緯度方向 1 次元格子点データの並んだ 2 次元配列
!>
!>=== 各データの種類の説明
!>
!> * xya : 2 次元格子点データの並んだ 3 次元配列.
!>   * 変数の種類と次元は real(8), dimension(0:im-1,1:jm,:).
!>   * im, jm はそれぞれ経度, 緯度座標の格子点数であり, サブルーチン
!>     wa_Initial にてあらかじめ設定しておく.
!>   * 扱う第 3 次元の大きさの最大値を wa_Initial で設定しておく.
!>
!> * wa : スペクトルデータの並んだ 2 次元配列.
!>   * 変数の種類と次元は real(8), dimension((nm+1)*(nm+1),:).
!>   * nm は球面調和函数の最大全波数であり, サブルーチン wa_Initial にて
!>     あらかじめ設定しておく.
!>   * スペクトルデータの格納のされ方は関数
!>     l_nm, nm_l によって調べることができる.
!>   * 扱う第 3 次元の大きさの最大値を wa_Initial で設定しておく.
!>
!> * xa, ya : 経度, 緯度方向 1 次元格子点データ.
!>   * 変数の種類と次元はそれぞれ real(8), dimension(0:im-1,:)
!>     および real(8), dimension(1:jm,:).
!>
!> * nma : スペクトルデータの並んだ 3 次元配列.
!>   * 変数の種類と次元は real(8), dimension(0:nm,-nm:nm,:).
!>   * 第 1 次元が水平全波数, 第 2 次元が帯状波数を表す.
!>   * nm は球面調和函数の最大全波数であり,
!>     サブルーチン wa_Initial にてあらかじめ設定しておく.
!>
!> * na : スペクトルデータの並んだ 2 次元配列.
!>   * 変数の種類と次元は real(8), dimension(0:nm,:).
!>   *  第 1 次元が水平全波数を表す.nm は球面調和函数の最大全波数であり,
!>      サブルーチン wa_Initial にてあらかじめ設定しておく.
!>
!> * wa_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
!>
!> * nma_ で始まる関数が返す値はスペクトルデータの並んだ 3 次元配列に同じ.
!>
!> * na_ で始まる関数が返す値はスペクトルデータの並んだ 2 次元配列に同じ.
!>
!> * xya_ で始まる関数が返す値は 2 次元格子点データの並んだ 3 次元配列に
!>   同じ.
!>
!> * xa_, ya_ で始まる関数が返す値は 1 次元格子点データの並んだ 2 次元
!>   配列に同じ.
!>
!> * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
!>   微分などを作用させたデータをスペクトル変換したものことである.
!>
!>
!>== 変数・手続き群の要約
!>
!>==== 初期化
!>
!> wa_Initial :: スペクトル変換の格子点数, 波数, 領域の大きさ,
!>            :: および同時に計算するデータの個数の最大値設定
!>
!>==== 終了処理
!>
!> wa_Finalize :: モジュールの終了処理(割り付け配列の解放)をおこなう.
!>
!>==== 座標変数
!>
!> x_Lon, y_Lat     ::  格子点座標(緯度, 経度座標)を格納した 1 次元配列
!> x_Lon_Weight, y_Lat_Weight ::  重み座標を格納した 1 次元配列
!> xy_Lon, xy_Lat   :: 格子点データの経度・緯度座標(X,Y)
!>                     (格子点データ型 2 次元配列)
!>
!>==== 基本変換
!>
!> xya_wa, xy_w :: スペクトルデータから格子データへの変換(多層, 1 層用)
!> wa_xya, w_xy :: 格子データからスペクトルデータへの変換(多層, 1 層用)
!> l_nm, nm_l :: スペクトルデータの格納位置と全波数・帯状波数の変換
!> w_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
!> w_Vector2VorDiv   :: 速度場から渦度発散を計算
!> w_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
!> wa_StreamPotential2Vector :: 流線ポテンシャルから速度場計算
!> wa_Vector2VorDiv   :: 速度場から渦度発散を計算
!> wa_VectorCosLat2VorDiv   :: 速度場から渦度発散を計算
!>
!>==== 微分
!>
!> wa_Lapla_wa, w_Lapla_w        :: スペクトルデータにラプラシアンを
!>                                  作用させる(多層, 1 層用)
!> rn                            :: スペクトルデータのラプラシアンを
!>                                  計算するための係数
!> irm                           :: 経度微分演算用配列(未定義)
!> wa_LaplaInv_wa, w_LaplaInv_w  :: スペクトルデータにラプラシアンの逆変換を
!>                                  作用させる(多層, 1 層用)
!> wa_DLon_wa, w_DLon_w          :: スペクトルデータに
!>                                  経度微分∂/∂λを作用させる(多層, 1 層用)
!> xya_GradLon_wa, xy_GradLon_w  :: スペクトルデータに
!>                                  勾配型経度微分 1/cosφ・∂/∂λ を
!>                                  作用させる(多層, 1 層用)
!> xya_GradLat_wa, xy_GradLat_w  :: スペクトルデータに
!>                                  勾配型緯度微分 ∂/∂φ を
!>                                  作用させる(多層, 1 層用)
!> wa_DivLon_xya, w_DivLon_xy    :: 格子データに
!>                                  発散型経度微分 1/cosφ・∂/∂λを
!>                                  作用させる(多層, 1 層用)
!> wa_DivLat_xya, w_DivLat_xy    :: 格子データに
!>                                  発散型緯度微分 1/cosφ・∂(g cosφ)/∂φを
!>                                  作用させる (多層, 1 層用)
!> wa_Div_xya_xya, w_Div_xy_xy   :: ベクトル成分である 2 つの格子データに
!>                                  発散を作用させる(多層, 1 層用)
!> wa_Jacobian_wa_wa,w_Jacobian_w_w :: 2つのスペクトルデータからヤコビアンを
!>                                     計算する(多層, 1 層用)
!>
!>==== 微分(λ,μ=sinφ 座標)
!>
!> xya_GradLambda_wa, xy_GradLambda_w  :: スペクトルデータに
!>                                        勾配型経度微分∂/∂λを作用させる
!>                                        (多層, 1 層用)
!> xya_GradMu_wa, xy_GradMu_w          :: スペクトルデータに
!>                                        勾配型緯度微分(1-μ^2)∂/∂μ
!>                                        を作用させる
!>                                        (多層, 1 層用)
!> wa_DivLambda_xya,w_DivLambda_xy     :: 格子データに発散型経度微分
!>                                        1 /(1-μ^2)・∂/∂λを作用させる
!>                                        (多層, 1 層用)
!>
!> wa_DivMu_xya,w_DivMu_xy             :: 格子データに発散型緯度微分
!>                                        ∂/∂μを作用させる(多層, 1 層用)
!>
!>==== 補間計算
!>
!> a_Interpolate_wa, Interpolate_w :: スペクトルデータから
!>                                    任意の点の関数値を計算する.
!>
!>==== 積分・平均
!>
!> a_IntLonLat_xya, a_AvrLonLat_xya :: 2 次元格子点データの
!>                                     全領域積分および平均(多層用)
!> IntLonLat_xy, AvrLonLat_xy       :: 2 次元格子点データの
!>                                     全領域積分および平均(1 層用)
!> ya_IntLon_xya, ya_AvrLon_xya     :: 2 次元格子点データの
!>                                     経度方向積分および平均(多層用)
!> y_IntLon_xy, y_AvrLon_xy         :: 2 次元格子点データの
!>                                     経度方向積分および平均(1 層用)
!> a_IntLon_xa, a_AvrLon_xa         :: 1 次元(X)格子点データの
!>                                     経度方向積分および平均(多層用)
!> IntLon_x, AvrLon_x               :: 1 次元(X)格子点データの
!>                                     経度方向積分および平均(1 層用)
!> xa_IntLat_xya, x_AvrLat_xy       :: 2 次元格子点データの
!>                                     緯度方向積分および平均(多層用)
!> x_IntLat_xy, x_AvrLat_xy         :: 2 次元格子点データの
!>                                     緯度方向積分および平均(1 層用)
!> a_IntLat_ya, a_AvrLat_ya         :: 1 次元(Y)格子点データの
!>                                     緯度方向積分および平均(多層用)
!> IntLat_y, AvrLat_y               :: 1 次元(Y)格子点データの
!>                                     緯度方向積分および平均(1 層用)
!>
!>==== スペクトル解析
!>
!> nma_EnergyFromStreamfunc_wa,nm_EnergyFromStreamfunc_w   ::
!> 流線関数からエネルギースペクトルを計算する
!> (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
!>
!> na_EnergyFromStreamfunc_wa,n_EnergyFromStreamfunc_w     ::
!> 流線関数からエネルギースペクトルを計算する
!> (水平全波数 n 空間) (多層, 1 層用)
!>
!> nma_EnstrophyFromStreamfunc_wa,nm_EnstrophyFromStreamfunc_w   ::
!> 流線関数からエンストロフィースペクトルを計算する
!> (水平全波数 n, 帯状波数 m 空間)(多層, 1 層用)
!>
!> na_EnstrophyFromStreamfunc_wa,n_EnstrophyFromStreamfunc_w ::
!> 流線関数からエンストロフィースペクトルを計算する(水平全波数 n 空間)
!> (多層, 1 層用)
!>
!> w_spectrum_VMiss              ::  欠損値
!>
module wa_module
  use dc_message, only : MessageNotify
  use w_module
  use wa_module_base
  use wa_module_deriv
  use wa_module_interpolate
  use wa_module_integral
  use wa_module_spectrum
  private
  !> 初期化
  public wa_Initial
  !> 終了処理
  public wa_Finalize

  public x_Lon, y_Lat                         ! 格子座標
  public x_Lon_Weight, y_Lat_Weight           ! 格子座標重み
  public xy_Lon, xy_Lat                       ! 格子座標(im,jm)
  public xy_w, w_xy, l_nm, nm_l               ! 変換関数
  public w_StreamPotential2Vector             ! 流線ポテンシャルから速度場計算
  public w_Vector2VorDiv                      ! 速度場から渦度発散を計算
  public w_VectorCosLat2VorDiv                ! 速度場から渦度発散を計算
  public xya_wa, wa_xya                       ! 変換関数
  public wa_StreamPotential2Vector            ! 流線ポテンシャルから速度場計算
  public wa_Vector2VorDiv                     ! 速度場から渦度発散を計算
  public wa_VectorCosLat2VorDiv               ! 速度場から渦度発散を計算

  public rn                                   ! ラプラシアンの係数配列
  public w_Lapla_w, w_LaplaInv_w              ! ラプラシアンと逆演算
  public w_DLon_w                             ! 経度微分
  public xy_GradLon_w, xy_GradLat_w           ! 勾配型微分
  public w_DivLon_xy, w_DivLat_xy             ! 発散型微分
  public w_Div_xy_xy                          ! 発散型微分
  public w_Jacobian_w_w                       ! ヤコビアン
  public xy_GradLambda_w, xy_GradMu_w         ! 勾配型微分(λ,μ座標)
  public w_DivLambda_xy, w_DivMu_xy           ! 発散型微分(λ,μ座標)

  public wa_Lapla_wa, wa_LaplaInv_wa          ! ラプラシアンと逆演算
  public wa_DLon_wa                           ! 経度微分
  public xya_GradLon_wa, xya_GradLat_wa       ! 勾配型微分
  public wa_DivLon_xya, wa_DivLat_xya         ! 発散型微分
  public wa_Div_xya_xya                       ! 発散型微分
  public wa_Jacobian_wa_wa                    ! ヤコビアン
  public xya_GradLambda_wa, xya_GradMu_wa     ! 勾配型微分(λ,μ座標)
  public wa_DivLambda_xya, wa_DivMu_xya       ! 発散型微分(λ,μ座標)

  public a_Interpolate_wa, Interpolate_w      ! 補間関数

  public IntLonLat_xy                         ! 緯度経度積分
  public y_IntLon_xy, IntLon_x                ! 経度積分
  public x_IntLat_xy, IntLat_y                ! 緯度積分
  public AvrLonLat_xy                         ! 緯度経度平均
  public y_AvrLon_xy, AvrLon_x                ! 経度平均
  public x_AvrLat_xy, AvrLat_y                ! 緯度平均

  public a_IntLonLat_xya                      ! 緯度経度積分
  public ya_IntLon_xya, a_IntLon_xa           ! 経度積分
  public xa_IntLat_xya, a_IntLat_ya           ! 緯度積分
  public a_AvrLonLat_xya                      ! 緯度経度平均
  public ya_AvrLon_xya, a_AvrLon_xa           ! 経度平均
  public xa_AvrLat_xya, a_AvrLat_ya           ! 緯度平均

  public nma_EnergyFromStreamfunc_wa          ! エネルギースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnergyFromStreamfunc_wa           ! エネルギースペクトル
                                              ! (水平全波数 n 空間)
  public nma_EnstrophyFromStreamfunc_wa       ! エンストロフィースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnstrophyFromStreamfunc_wa        ! エンストロフィースペクトル
                                              !  (水平全波数 n 空間)
  public wa_spectrum_VMiss                    ! 欠損値

  public nm_EnergyFromStreamfunc_w          ! エネルギースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnergyFromStreamfunc_w           ! エネルギースペクトル
                                            ! (水平全波数 n 空間)
  public nm_EnstrophyFromStreamfunc_w       ! エンストロフィースペクトル
                                            ! (水平全波数 n, 帯状波数 m 空間)
  public n_EnstrophyFromStreamfunc_w        ! エンストロフィースペクトル
                                            !  (水平全波数 n 空間)
  public w_spectrum_VMiss                   ! 欠損値

contains
  subroutine wa_Initial(n_in,i_in,j_in,k_in,np_in)
    !
    ! スペクトル変換の格子点数, 波数, 最大データ数(層数)および
    ! OPENMP 使用時の最大スレッド数を設定する.
    !
    ! 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで初期設定を
    ! しなければならない.
    !
    ! SNPACK 用 wa_initial との互換性のために引数 k_in が用意されているが,
    ! このパラメターによって同時に処理できる変数の数(層数)を制限される事はない.
    !
    ! np_in に 1 より大きな値を指定すれば ISPACK の球面調和函数変換
    ! OPENMP 並列計算ルーチンが用いられる. 並列計算を実行するには,
    ! 実行時に環境変数 OMP_NUM_THREADS を np_in 以下の数字に設定する等の
    ! システムに応じた準備が必要となる.
    !
    ! np_in に 1 より大きな値を指定しなければ並列計算ルーチンは呼ばれない.
    !
    integer,intent(in) :: i_in                ! 格子点数(東西)
    integer,intent(in) :: j_in                ! 格子点数(南北)
    integer,intent(in) :: n_in                ! 切断波数
    integer,intent(in), optional :: k_in      ! 最大データ数(層数)
    integer,intent(in), optional :: np_in     ! OPENMP での最大スレッド数

    if ( present(np_in) ) then
      call MessageNotify('M','wa_base_Initial', &
        & 'Optional argnument np is dummy.')
    endif

    if ( present(k_in) ) then
      call MessageNotify('M','wa_base_Initial', &
        & 'Optional argnument k is dummy.')
    endif

    call w_Initial(n_in,i_in,j_in)
    ! call wa_base_Initial(k_in)

    call MessageNotify('M','wa_initial', &
      & 'wa_module (2019/12/24) is initialized')

  end subroutine wa_Initial

  !--------------- 終了処理 -----------------
  subroutine wa_Finalize
    !
    ! モジュールの終了処理(割り付け配列の解放)をおこなう.
    !
    ! 解像度を変更する際にはこのサブルーチンを呼んで終了処理を
    ! おこなったのちに再度 wa_Initial で初期設定しなければ
    ! ならない.
    !
    call w_Finalize
    call wa_base_Finalize

    call MessageNotify('M','wa_Finalize', &
      & 'wa_module (2019/12/24) is finalized')

  end subroutine wa_Finalize

end module wa_module

!--
!----------------------------------------------------------------------
! Copyright(C) 2020 SPMODEL Development Group. All rights reserved.
!----------------------------------------------------------------------
!表題  ua_mpi_module_spectrum_mint
!
!  spml/ua_mpi_module_spectrum モジュールは球面上での 2 次元流体運動を
!  球面調和函数を用いたスペクトル法によって数値計算するための
!  モジュール ua_module_mpi の下部モジュールであり,
!  スペクトル解析計算のための Fortran90 関数を提供する.
!
!  スペクトル計算の方法については doc/ua_module_sjpack.tex を参照のこと.
!  内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
!  スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
!  ついては ISPACK3/SYPACK のマニュアルを参照されたい.
!
!
!履歴  2020/08/04  竹広真一
!
!++
module ua_mpi_module_spectrum_mint
  !
  !=  ua_mpi_module_spectrum_mint
  !
  ! Authors:: Shin-ichi Takehiro, Youhei SASAKI
  ! Version:: $Id: ua_mpi_module_spectrum.f90 590 2013-08-19 08:48:21Z uwabami $
  ! Copyright&License:: See COPYRIGHT[link:../COPYRIGHT]
  !
  !== 概要
  !
  ! spml/ua_spectrum_module_mint モジュールは球面上での 2 次元流体運動を
  ! 球面調和函数を用いたスペクトル法によって数値計算するための
  ! モジュール ua_module の下部モジュールであり,
  ! スペクトル解析計算のための Fortran90 関数を提供する.
  !
  ! スペクトル計算の方法については doc/ua_module.tex を参照のこと.
  ! 内部で ISPACK3 の SYPACK の Fortran77 サブルーチンを呼んでいる.
  ! スペクトルデータおよび格子点データの格納方法や変換の詳しい計算法に
  ! ついては ISPACK3/SYPACK のマニュアルを参照されたい.
  !
  use mpi
  use w_mpi_module_base_mint, only : nm=>nn, nm_l
  use ua_mpi_module_base_mint, only : nc, nmc, km, kc, nm_lu, nms, MPI_COMM_W, MPI_COMM_H

  implicit none

  private

  public nma_EnergyFromStreamfunc_ua          ! エネルギースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnergyFromStreamfunc_ua           ! エネルギースペクトル
                                              ! (水平全波数 n 空間)
  public nma_EnstrophyFromStreamfunc_ua       ! エンストロフィースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public na_EnstrophyFromStreamfunc_ua        ! エンストロフィースペクトル
                                              !  (水平全波数 n 空間)
  public nmb_EnergyFromStreamfunc_wb          ! エネルギースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public nb_EnergyFromStreamfunc_wb           ! エネルギースペクトル
                                              ! (水平全波数 n 空間)
  public nmb_EnstrophyFromStreamfunc_wb       ! エンストロフィースペクトル
                                              ! (水平全波数 n, 帯状波数 m 空間)
  public nb_EnstrophyFromStreamfunc_wb        ! エンストロフィースペクトル
                                              !  (水平全波数 n 空間)
  public ua_spectrum_VMiss                    ! 欠損値

  real(8) :: ua_spectrum_VMiss = -999.000     ! 欠損値初期値

contains

  !--------------- エネルギースペクトル計算 (ua) -----------------
  function nma_EnergyFromStreamfunc_ua(ua_Strfunc)
    !
    ! 流線関数のスペクトルデータからエネルギーの球面調和函数成分
    ! (スペクトル)を計算する(1 層用).
    !
    !  * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
    !    エネルギースペクトルは (1/2)n(n+1)|ψ(n,m)|^2 と計算される.
    !
    !  * 全てのエネルギースペクトル成分の和に4πをかけたものが球面上での
    !    全エネルギーに等しい.
    !
    !  * スペクトルの (n,m) 成分は全波数 n, 東西波数 m の実部成分,
    !    (n,-m) 成分は全波数 n, 東西波数 m の虚部成分が格納されている.
    !
    !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
    !    欠損値の値はモジュール変数 ua_spectrum_VMiss によって設定できる
    !    (初期値は -999.0)
    !
    real(8), intent(in)   :: ua_Strfunc(:,:)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,-nm:nm,size(ua_Strfunc,2)) &
         :: nma_EnergyFromStreamfunc_ua
    !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

    real(8), dimension(0:nm,-nm:nm,size(ua_Strfunc,2)) :: nma_work ! 作業領域

    integer :: l, n, m, nm_ary(2)

    integer :: ierr

    nma_work = 0.0D0
    do l=1,nmc
       ! nm_ary = nm_l(l+nms-1)
       nm_ary = nm_lu(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             nma_Work(n,0,:) = nma_Work(n,0,:) &
                  +  0.5 * n*(n+1) * ua_Strfunc(l,:)**2
          else
             nma_Work(n,m,:) = nma_Work(n,m,:) &
                  +  0.5 * n*(n+1) * ua_Strfunc(l,:)**2
             nma_Work(n,-m,:) = nma_Work(n,-m,:) &
                  +  0.5 * n*(n+1) * ua_Strfunc(l,:)**2
          endif
       endif
    enddo

    CALL MPI_ALLREDUCE(nma_work,nma_EnergyFromStreamfunc_ua,&
         (int(nm)+1)*(2*int(nm)+1)*size(ua_Strfunc,2), &
         MPI_REAL8,MPI_SUM,MPI_COMM_W,IERR)

    do m=1,int(nm)
       do n=0,m-1
          nma_EnergyFromStreamfunc_ua(n,m,:)  = ua_spectrum_Vmiss
          nma_EnergyFromStreamfunc_ua(n,-m,:) = ua_spectrum_Vmiss
       enddo
    enddo

  end function nma_EnergyFromStreamfunc_ua

  function na_EnergyFromStreamfunc_ua(ua_Strfunc)
    !
    ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
    ! 計算する(1 層用).
    !
    !  * 全波数 n の流線関数のスペクトル成分ψ(n,m) から
    !    エネルギースペクトルはΣ[m=-nm]^nm(1/2)n(n+1)|ψ(n,m)|^2
    !    と計算される.
    !
    !  * 全てのエネルギースペクトル成分の和に 4πをかけたものが
    !    球面上での全エネルギーに等しい.
    !

    real(8), intent(in)      :: ua_Strfunc(:,:)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,size(ua_Strfunc,2)) :: na_EnergyFromStreamfunc_ua
    !(out) エネルギースペクトル (水平全波数 n 空間)

    real(8), dimension(0:nm,size(ua_Strfunc,2)) :: na_Work ! 作業領域

    integer :: l, n, m, nm_ary(2)
    real(8) :: factor

    integer :: ierr

    na_work = 0.0D0
    do l=1,nmc
       ! nm_ary = nm_l(l+nms-1)
       nm_ary = nm_lu(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             factor = 1.0D0
          else
             factor = 2.0D0
          endif
          na_Work(n,:) = na_Work(n,:) &
               + factor * 0.5 * n*(n+1) * ua_Strfunc(l,:)**2
       endif
    enddo

    CALL MPI_ALLREDUCE(na_Work,na_EnergyFromStreamfunc_ua,&
         (int(nm)+1)*size(ua_Strfunc,2), &
         MPI_REAL8,MPI_SUM,MPI_COMM_W,IERR)

  end function na_EnergyFromStreamfunc_ua

  !--------------- エンストロフィースペクトル計算 (ua) -----------------
  function nma_EnstrophyFromStreamfunc_ua(ua_Strfunc)
    !
    ! 流線関数のスペクトルデータからエンストロフィーの球面調和函数成分
    ! (スペクトル)を計算する(1 層用).
    !
    ! * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
    !    エンストロフィースペクトルは (1/2)n^2(n+1)^2|ψ(n,m)|^2 と計算される.
    !
    ! * 全てのエンストロフィースペクトル成分の和に4π/R^2をかけたものが
    !   球面上での全エンストロフィーに等しい. ここで R は球面の半径である.
    !
    ! * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
    !   欠損値の値はモジュール変数 ua_spectrum_VMiss によって設定できる
    !   (初期値は -999.0)
    !
    real(8), intent(in)   :: ua_Strfunc(:,:)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,-nm:nm,size(ua_Strfunc,2)) &
         :: nma_EnstrophyFromStreamfunc_ua
    ! エンストロフィースペクトル (水平全波数 n, 帯状波数 m 空間)

    real(8), dimension(0:nm,-nm:nm,size(ua_Strfunc,2)) :: nma_Work ! 作業領域

    integer :: l, n, m, nm_ary(2)

    integer :: ierr

    nma_work = 0.0D0
    do l=1,nmc
       ! nm_ary = nm_l(l+nms-1)
       nm_ary = nm_lu(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             nma_Work(n,0,:) = nma_Work(n,0,:) &
                  +  0.5 * n**2 * (n+1)**2 * ua_Strfunc(l,:)**2
          else
             nma_Work(n,m,:) = nma_Work(n,m,:) &
                  +  0.5 * n**2 * (n+1)**2 * ua_Strfunc(l,:)**2
             nma_Work(n,-m,:) = nma_Work(n,-m,:) &
                  +  0.5 * n**2 * (n+1)**2 * ua_Strfunc(l,:)**2
          endif
       endif
    enddo

    CALL MPI_ALLREDUCE(nma_Work,nma_EnstrophyFromStreamfunc_ua,&
         (int(nm)+1)*(2*int(nm)+1)*size(ua_Strfunc,2), &
         MPI_REAL8,MPI_SUM,MPI_COMM_W,IERR)

    do m=1,int(nm)
       do n=0,m-1
          nma_EnstrophyFromStreamfunc_ua(n,m,:)  = ua_spectrum_Vmiss
          nma_EnstrophyFromStreamfunc_ua(n,-m,:) = ua_spectrum_Vmiss
       enddo
    enddo

  end function nma_EnstrophyFromStreamfunc_ua

  function na_EnstrophyFromStreamfunc_ua(ua_Strfunc)
    !
    ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
    ! 計算する(1 層用)
    !
    ! * 全波数 n の流線関数のスペクトル成分ψ(n,m) からエンストロフィー
    !   スペクトルはΣ[m=-nm]^nm(1/2)n^2(n+1)^2|ψ(n,m)|^2 と計算される.
    !
    ! * 全てのエネルギースペクトル成分の和に 4π/R^2 をかけたものが
    !   球面上での全エンストフィーに等しい.
    !
    real(8), intent(in)      :: ua_Strfunc(:,:)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,size(ua_Strfunc,2)) :: na_EnstrophyFromStreamfunc_ua
    !(out) エンストロフィースペクトル(水平全波数 n 空間)

    real(8), dimension(0:nm,size(ua_Strfunc,2))     :: na_Work ! 作業領域

    integer :: l, n, m, nm_ary(2)
    real(8) :: factor

    integer :: ierr

    na_work = 0.0D0
    do l=1,nmc
       ! nm_ary = nm_l(l+nms-1)
       nm_ary = nm_lu(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             factor = 1.0D0
          else
             factor = 2.0D0
          endif
          na_Work(n,:) = na_Work(n,:) &
               + factor * 0.5 * n**2 * (n+1)**2 * ua_Strfunc(l,:)**2
       endif
    enddo

    CALL MPI_ALLREDUCE(na_Work,na_EnstrophyFromStreamfunc_ua,&
         (int(nm)+1)*size(ua_Strfunc,2), &
         MPI_REAL8,MPI_SUM,MPI_COMM_W,IERR)

  end function na_EnstrophyFromStreamfunc_ua

  !--------------- エネルギースペクトル計算 (wb) -----------------
  function nmb_EnergyFromStreamfunc_wb(wb_Strfunc)
    !
    ! 流線関数のスペクトルデータからエネルギーの球面調和函数成分
    ! (スペクトル)を計算する(1 層用).
    !
    !  * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
    !    エネルギースペクトルは (1/2)n(n+1)|ψ(n,m)|^2 と計算される.
    !
    !  * 全てのエネルギースペクトル成分の和に4πをかけたものが球面上での
    !    全エネルギーに等しい.
    !
    !  * スペクトルの (n,m) 成分は全波数 n, 東西波数 m の実部成分,
    !    (n,-m) 成分は全波数 n, 東西波数 m の虚部成分が格納されている.
    !
    !  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
    !    欠損値の値はモジュール変数 wb_spectrum_VMiss によって設定できる
    !    (初期値は -999.0)
    !
    real(8), intent(in)   :: wb_Strfunc(:,:)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,-nm:nm,size(wb_Strfunc,2)) &
         :: nmb_EnergyFromStreamfunc_wb
    !(out) エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)

    real(8), dimension(0:nm,-nm:nm,size(wb_Strfunc,2)) :: nmb_work ! 作業領域

    integer :: l, n, m, nm_ary(2)

    integer :: ierr

    nmb_work = 0.0D0
    do l=1,nc
       nm_ary = nm_l(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             nmb_Work(n,0,:) = nmb_Work(n,0,:) &
                  +  0.5 * n*(n+1) * wb_Strfunc(l,:)**2
          else
             nmb_Work(n,m,:) = nmb_Work(n,m,:) &
                  +  0.5 * n*(n+1) * wb_Strfunc(l,:)**2
             nmb_Work(n,-m,:) = nmb_Work(n,-m,:) &
                  +  0.5 * n*(n+1) * wb_Strfunc(l,:)**2
          endif
       endif
    enddo

    CALL MPI_ALLREDUCE(nmb_work,nmb_EnergyFromStreamfunc_wb,&
         (int(nm)+1)*(2*int(nm)+1)*size(wb_Strfunc,2), &
         MPI_REAL8,MPI_SUM,MPI_COMM_H,IERR)

    do m=1,nm
       do n=0,m-1
          nmb_EnergyFromStreamfunc_wb(n,m,:)  = ua_spectrum_Vmiss
          nmb_EnergyFromStreamfunc_wb(n,-m,:) = ua_spectrum_Vmiss
       enddo
    enddo

  end function nmb_EnergyFromStreamfunc_wb

  function nb_EnergyFromStreamfunc_wb(wb_Strfunc)
    !
    ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
    ! 計算する(1 層用).
    !
    !  * 全波数 n の流線関数のスペクトル成分ψ(n,m) から
    !    エネルギースペクトルはΣ[m=-nm]^nm(1/2)n(n+1)|ψ(n,m)|^2
    !    と計算される.
    !
    !  * 全てのエネルギースペクトル成分の和に 4πをかけたものが
    !    球面上での全エネルギーに等しい.
    !

    real(8), intent(in)      :: wb_Strfunc(:,:)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,size(wb_Strfunc,2)) :: nb_EnergyFromStreamfunc_wb
    !(out) エネルギースペクトル (水平全波数 n 空間)

    real(8), dimension(0:nm,size(wb_Strfunc,2)) :: nb_Work ! 作業領域

    integer :: l, n, m, nm_ary(2)
    real(8) :: factor

    integer :: ierr

    nb_work = 0.0D0
    do l=1,nc
       nm_ary = nm_l(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             factor = 1.0D0
          else
             factor = 2.0D0
          endif
          nb_Work(n,:) = nb_Work(n,:) &
               + factor * 0.5 * n*(n+1) * wb_Strfunc(l,:)**2
       endif
    enddo

    CALL MPI_ALLREDUCE(nb_Work,nb_EnergyFromStreamfunc_wb,&
         (int(nm)+1)*size(wb_Strfunc,2), &
         MPI_REAL8,MPI_SUM,MPI_COMM_H,IERR)

  end function nb_EnergyFromStreamfunc_wb

  !--------------- エンストロフィースペクトル計算 (wb) -----------------
  function nmb_EnstrophyFromStreamfunc_wb(wb_Strfunc)
    !
    ! 流線関数のスペクトルデータからエンストロフィーの球面調和函数成分
    ! (スペクトル)を計算する(1 層用).
    !
    ! * 全波数 n, 帯状波数 m の流線関数のスペクトル成分ψ(n,m) から
    !    エンストロフィースペクトルは (1/2)n^2(n+1)^2|ψ(n,m)|^2 と計算される.
    !
    ! * 全てのエンストロフィースペクトル成分の和に4π/R^2をかけたものが
    !   球面上での全エンストロフィーに等しい. ここで R は球面の半径である.
    !
    ! * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納される.
    !   欠損値の値はモジュール変数 wb_spectrum_VMiss によって設定できる
    !   (初期値は -999.0)
    !
    real(8), intent(in)   :: wb_Strfunc(:,:)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,-nm:nm,size(wb_Strfunc,2)) &
         :: nmb_EnstrophyFromStreamfunc_wb
    ! エンストロフィースペクトル (水平全波数 n, 帯状波数 m 空間)

    real(8), dimension(0:nm,-nm:nm,size(wb_Strfunc,2)) :: nmb_Work ! 作業領域

    integer :: l, n, m, nm_ary(2)

    integer :: ierr

    nmb_work = 0.0D0
    do l=1,nc
       nm_ary = nm_l(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             nmb_Work(n,0,:) = nmb_Work(n,0,:) &
                  +  0.5 * n**2 * (n+1)**2 * wb_Strfunc(l,:)**2
          else
             nmb_Work(n,m,:) = nmb_Work(n,m,:) &
                  +  0.5 * n**2 * (n+1)**2 * wb_Strfunc(l,:)**2
             nmb_Work(n,-m,:) = nmb_Work(n,-m,:) &
                  +  0.5 * n**2 * (n+1)**2 * wb_Strfunc(l,:)**2
          endif
       endif
    enddo

    CALL MPI_ALLREDUCE(nmb_Work,nmb_EnstrophyFromStreamfunc_wb,&
         (int(nm)+1)*(2*int(nm)+1)*size(wb_Strfunc,2), &
         MPI_REAL8,MPI_SUM,MPI_COMM_H,IERR)

    do m=1,int(nm)
       do n=0,m-1
          nmb_EnstrophyFromStreamfunc_wb(n,m,:)  = ua_spectrum_Vmiss
          nmb_EnstrophyFromStreamfunc_wb(n,-m,:) = ua_spectrum_Vmiss
       enddo
    enddo

  end function nmb_EnstrophyFromStreamfunc_wb

  function nb_EnstrophyFromStreamfunc_wb(wb_Strfunc)
    !
    ! 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
    ! 計算する(1 層用)
    !
    ! * 全波数 n の流線関数のスペクトル成分ψ(n,m) からエンストロフィー
    !   スペクトルはΣ[m=-nm]^nm(1/2)n^2(n+1)^2|ψ(n,m)|^2 と計算される.
    !
    ! * 全てのエネルギースペクトル成分の和に 4π/R^2 をかけたものが
    !   球面上での全エンストフィーに等しい.
    !
    real(8), intent(in)      :: wb_Strfunc(:,:)
    !(in) 流線関数(スペクトルデータ)

    real(8), dimension(0:nm,size(wb_Strfunc,2)) :: nb_EnstrophyFromStreamfunc_wb
    !(out) エンストロフィースペクトル(水平全波数 n 空間)

    real(8), dimension(0:nm,size(wb_Strfunc,2))     :: nb_Work ! 作業領域

    integer :: l, n, m, nm_ary(2)
    real(8) :: factor

    integer :: ierr

    nb_work = 0.0D0
    do l=1,nc
       nm_ary = nm_l(l)
       n = nm_ary(1) ; m = abs(nm_ary(2))
       if ( n .ge. 0 ) then
          if ( m == 0 ) then
             factor = 1.0D0
          else
             factor = 2.0D0
          endif
          nb_Work(n,:) = nb_Work(n,:) &
               + factor * 0.5 * n**2 * (n+1)**2 * wb_Strfunc(l,:)**2
       endif
    enddo

    CALL MPI_ALLREDUCE(nb_Work,nb_EnstrophyFromStreamfunc_wb,&
         (int(nm)+1)*size(wb_Strfunc,2), &
         MPI_REAL8,MPI_SUM,MPI_COMM_H,IERR)

  end function nb_EnstrophyFromStreamfunc_wb
  
end module ua_mpi_module_spectrum_mint

! -*- mode: f90; coding: utf-8 -*-
!-------------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2019/03/16  竹広真一
!       2019/10/04  佐々木洋平
!
!----------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief
!> @ref w_module の下部モジュール: スペクトル解析
!> @note
!> スペクトル計算の方法については doc/w_module.tex を参照のこと.
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは w_module を呼ぶこと．
!>
module w_module_spectrum
  use dc_types, only: DP
  use w_module_base, only : nm=>nn, l_nm

  implicit none

  private

  public nm_EnergyFromStreamfunc_w
  public n_EnergyFromStreamfunc_w
  public nm_EnstrophyFromStreamfunc_w
  public n_EnstrophyFromStreamfunc_w
  public w_spectrum_VMiss

  !> 欠損値. 初期値は -999.000
  real(DP) :: w_spectrum_VMiss = -999.000

contains

  !----------------------------------------------------------
  !> 流線関数のスペクトルデータからエネルギーの球面調和函数成分
  !> (スペクトル)を計算する(1 層用).
  !>
  !>  * 全波数 n, 帯状波数 m の流線関数のスペクトル成分\f$ψ(n,m)\f$
  !>    からエネルギースペクトルは
  !>    \f$(1/2)n(n+1)|ψ(n,m)|^2\f$ と計算される.
  !>
  !>  * 全てのエネルギースペクトル成分の和に\f$4π\f$をかけたものが
  !>    球面上での全エネルギーに等しい.
  !>
  !>  * スペクトルの (n,m) 成分は全波数 n, 東西波数 m の実部成分,
  !>    (n,-m) 成分は全波数 n, 東西波数 m の虚部成分が格納されている.
  !>
  !>  * データの存在しない全波数 n, 帯状波数 m の配列には欠損値が格納
  !>    される. 欠損値の値はモジュール変数
  !>    [w_spectrum_VMiss](@ref w_spectrum_vmiss) によって
  !>    設定できる(初期値は -999.0)
  !>
  function nm_EnergyFromStreamfunc_w(w_Strfunc)
    !> 流線関数(スペクトルデータ)
    real(DP), intent(in)   :: w_Strfunc(:)
    !> エネルギースペクトル(水平全波数 n, 帯状波数 m 空間)
    real(DP), dimension(0:nm,-nm:nm) :: nm_EnergyFromStreamfunc_w

    integer(8) :: n
    integer(8) :: m

    nm_EnergyFromStreamfunc_w = w_spectrum_VMiss

    do n=0,nm
      nm_EnergyFromStreamfunc_w(n,0) &
        & = 0.5D0 * n*(n+1_8) * w_Strfunc(l_nm(n,0_8))**2_8
      do m=1,n
        nm_EnergyFromStreamfunc_w(n,m)     &
          = 0.5D0 * n*(n+1_8)              &
          * (   w_Strfunc(l_nm(n,m))**2_8  &
          &   + w_Strfunc(l_nm(n,-m))**2_8 )
        nm_EnergyFromStreamfunc_w(n,-m)    &
          = nm_EnergyFromStreamfunc_w(n,m)
      end do
    end do
  end function nm_EnergyFromStreamfunc_w

  !----------------------------------------------------------
  !> 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
  !> 計算する(1 層用).
  !>
  !>  * 全波数 n の流線関数のスペクトル成分\f$ψ(n,m)\f$から
  !>    エネルギースペクトルは
  !>    \f[\sum_{m=-nm}^{nm}(1/2)n(n+1)|ψ(n,m)|^2\f]
  !>    と計算される.
  !>
  !>  * 全てのエネルギースペクトル成分の和に \f$4π\f$ をかけたものが
  !>    球面上での全エネルギーに等しい.
  !>
  function n_EnergyFromStreamfunc_w(w_Strfunc)
    !> 流線関数(スペクトルデータ)
    real(DP), intent(in)      :: w_Strfunc(:)
    !> エネルギースペクトル (水平全波数 n 空間)
    real(DP), dimension(0:nm) :: n_EnergyFromStreamfunc_w

    integer(8) :: n
    integer(8) :: m

    n_EnergyFromStreamfunc_w = 0.0D0
    do n=0,nm
      n_EnergyFromStreamfunc_w(n) = &
        0.5D0 * n*(n+1_8) * w_StrFunc(l_nm(n,0_8))**2_8
      do m=1,n
        n_EnergyFromStreamfunc_w(n) =    &
          & n_EnergyFromStreamfunc_w(n)  &
!!           & + 2 * 0.5 * n*(n+1) &
          & + n*(n+1)  &
          & * (w_StrFunc(l_nm(n,m))**2_8 + w_StrFunc(l_nm(n,-m))**2_8)
         end do
      end do
    end function n_EnergyFromStreamfunc_w

    !----------------------------------------------------------
    !> 流線関数のスペクトルデータからエンストロフィーの球面調和函数成分
    !> (スペクトル)を計算する(1 層用).
    !>
    !> * 全波数 n, 帯状波数 m の流線関数のスペクトル成分\f$ψ(n,m)\f$
    !>   からエンストロフィースペクトルは
    !>   \f[(1/2)n^2(n+1)^2|ψ(n,m)|^2\f]
    !>   と計算される.
    !>
    !> * 全てのエンストロフィースペクトル成分の和に\f$4π/R^2\f$
    !>   をかけたものが球面上での全エンストロフィーに等しい.
    !>   ここで\f$R\f$ は球面の半径である.
    !>
    !> * データの存在しない全波数 n, 帯状波数 m の配列には
    !>   欠損値が格納される. 欠損値の値はモジュール変数
    !>   [w_spectrum_VMiss](@ref w_spectrum_vmiss)
    !>   によって設定できる(初期値は -999.0)
    !>
    function nm_EnstrophyFromStreamfunc_w(w_Strfunc)
      !> 流線関数(スペクトルデータ)
      real(DP), intent(in)   :: w_Strfunc(:)
      !> エンストロフィースペクトル (水平全波数 n, 帯状波数 m 空間)
      real(DP), dimension(0:nm,-nm:nm) :: nm_EnstrophyFromStreamfunc_w

      integer(8) :: n
      integer(8) :: m

      nm_EnstrophyFromStreamfunc_w = w_spectrum_VMiss

      do n=0,nm
        nm_EnstrophyFromStreamfunc_w(n,0) &
        &  = 0.5D0 * n**2_8 * (n+1_8)**2_8 * w_Strfunc(l_nm(n,0_8))**2_8
        do m=1,n
          nm_EnstrophyFromStreamfunc_w(n,m)    &
            &  = 0.5D0 * n**2_8 * (n+1_8)**2_8 &
            &    * ( w_Strfunc(l_nm(n,m))**2_8 +w_Strfunc(l_nm(n,-m))**2_8 )
          nm_EnstrophyFromStreamfunc_w(n,-m)   &
            &  = nm_EnstrophyFromStreamfunc_w(n,m)
        enddo
      enddo
    end function nm_EnstrophyFromStreamfunc_w

    !--------------------------------------------------------------------
    !> 流線関数のスペクトルデータから各全波数のエネルギー成分(スペクトル)を
    !> 計算する(1 層用)
    !>
    !> * 全波数 n の流線関数のスペクトル成分\f$ψ(n,m)\f$から
    !>   エンストロフィースペクトルは
    !>   \f[\sum{m=-nm}^{nm} (1/2)n^2(n+1)^2|ψ(n,m)|^2\f]
    !>   と計算される.
    !>
    !> * 全てのエネルギースペクトル成分の和に \f$4π/R^2\f$
    !>   をかけたものが球面上での全エンストフィーに等しい.
    !>   ここで\f$R\f$ は球面の半径である.
    !>
    function n_EnstrophyFromStreamfunc_w(w_Strfunc)
      !> 流線関数(スペクトルデータ)
      real(DP), intent(in)      :: w_Strfunc(:)
      !> エンストロフィースペクトル(水平全波数 n 空間)
      real(DP), dimension(0:nm) :: n_EnstrophyFromStreamfunc_w

      integer(8) :: n
      integer(8) :: m

      do n=0,nm
        n_EnstrophyFromStreamfunc_w(n)  &
          &  = 0.5D0 * n**2_8 * (n+1_8)**2_8 * w_StrFunc(l_nm(n,0_8))**2_8
        do m=1,n
          n_EnstrophyFromStreamfunc_w(n) &
            & =   n_EnstrophyFromStreamfunc_w(n) &
!!             &   + 2 * 0.5D0 * n**2_8 * (n+1)**2_8 &
            &   + n**2_8 * (n+1)**2_8 &
            &      * (w_StrFunc(l_nm(n,m))**2_8 + w_StrFunc(l_nm(n,-m))**2_8)
         end do
      end do
    end function n_EnstrophyFromStreamfunc_w

end module w_module_spectrum

! -*- mode: f90; coding: utf-8 -*-
! ----------------------------------------------------------------------------
! Copyright (c) 2019-2026 SPMODEL Development Group. All rights reserved.
! ----------------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019-2026
!>     License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief 1 次元周期境界: 実フーリエ変換
!>
!> @details
!> 1 次元周期境界条件の下での流体運動を
!> 実フーリエ変換によるスペクトル法で数値計算するための
!> Fortran90 関数を提供する.
!> 2 次元データの 1 次元に関して同時にスペクトル計算を実行するための
!> 関数も提供しており, 2, 3 次元領域での計算のベースも提供する.
!>
!> このモジュールは内部で ISPACK3/FXPACK のサブルーチンを呼んでいる.
!> スペクトルデータの格納方法については ISPACK3/FXPACK
!> と異なっているので以下のコメントに注意されたい.
!>
!> ## 関数・変数の名前と型について
!>
!> ### 命名法
!>
!> * 関数名の先頭 (`e_`, `g_`, `ae_`, `ag_`) は, 返す値の形を示している.
!> * `e_`  :: スペクトルデータ,
!> * `g_`  :: 1 次元格子点データ,
!> * `ae_` :: 1 次元スペクトルデータが複数並んだ 2 次元データ,
!> * `ag_` :: 1 次元格子点データが複数並んだ 2 次元データ.
!>
!> * 関数名の間の文字列(`Dx`)は, その関数の作用を表している.
!>
!> * 関数名の最後 (`_e`, `_ae`, `_g`, `_ag`) は,
!> 入力変数の形スペクトルデータおよび格子点データであることを示している.
!> * `_e`  :: スペクトルデータ
!> * `_g`  :: 1 次元格子点データ
!> * `_ae` :: 1 次元スペクトルデータが複数並んだ 2 次元データ
!> * `_ag` :: 1 次元格子点データが複数並んだ 2 次元データ
!>
!> ### 各データの種類の説明
!>
!> * 以下 `DP  = kind(1.0D)` である
!>
!> * `g` : 1 次元格子点データ.
!> * 変数の種類と次元は `real(DP), dimension(0:im-1)`.
!> * `im` は X 座標の格子点数であり, サブルーチン ae_initial() にて
!> あらかじめ設定しておく.
!>
!> * `e` : スペクトルデータ.
!> * 変数の種類と次元は `real(DP), dimension(-km:km)`.
!> * `km` は X 方向の最大波数であり, サブルーチン ae_initial() にて
!> あらかじめ設定しておく.
!> * スペクトルデータの格納のされ方は
!> `0:km` までが \f$\cos(kx)\f$ の係数,
!> `-km:-1` が  \f$sin(kx)\f$ の係数となっている.
!>
!> * `ag` : 1 次元(X)格子点データの並んだ 2 次元データ.
!> * 変数の種類と次元は `real(DP), dimension(:,0:im-1)`.
!> 第 2 次元が X 方向を表す.
!>
!> * `ae` : 1 次元スペクトルデータの並んだ 2 次元データ.
!> * 変数の種類と次元は `real(DP), dimension(:,-km:km)`.
!> 第 2 次元がスペクトルを表す.
!>
!> * `g_` で始まる関数が返す値は 1 次元格子点データに同じ.
!>
!> * `e_` で始まる関数が返す値はスペクトルデータに同じ.
!>
!> * `ag_` で始まる関数が返す値は 1 次元格子点データの並んだ
!> 2 次元データに同じ.
!>
!> * `ae_` で始まる関数が返す値は 1 次元スペクトルデータの並んだ
!> 2 次元データに同じ.
!>
!> * スペクトルデータに対する微分等の作用とは, 対応する格子点データに
!> 微分などを作用させたデータをスペクトル変換したもののことである.
!>
module ae_module
  use dc_message, only: MessageNotify
  use dc_types, only: DP
  use spml_utils, only: pi
  implicit none

  private
  public ae_Initial
  public ae_Initialize
  public ae_Finalize
  public ag_ae
  public ae_ag
  public g_e
  public e_g
  public ae_Dx_ae
  public e_Dx_e
  public a_Int_ag
  public Int_g
  public a_Avr_ag
  public Avr_g
  public Interpolate_e
  public a_Interpolate_ae
  public g_X
  public g_X_Weight

  ! --------------------------------------------------------------------------
  ! for backward compatibility
  interface ae_Initialize
    module procedure ae_Initialize_I4
    module procedure ae_Initialize_I8
  end interface ae_Initialize

  !> 格子点座標(X)を格納した1次元配列.
  real(DP), allocatable :: g_X(:)
  !> 重み座標を格納した 1 次元配列. X方向の格子点の間隔が格納してある.
  real(DP), allocatable :: g_X_Weight(:)

  integer(8) :: im     !> 格子点の数
  integer(8) :: km     !> 切断波数
  real(DP) :: xl       !> 領域の大きさ
  integer(8), allocatable :: it(:)
  real(DP), allocatable :: t(:)
  logical :: ae_Initialized = .false.

  save im, km, it, t, xl, g_X, g_X_Weight

  !> 作業領域/Workspace: ae_ag
  real(DP), allocatable, dimension(:, :) :: ag_work_ae_ag
  integer(8) :: ae_ag_im = -1_8, ae_ag_nm = -1_8
  save :: ag_work_ae_ag, ae_ag_im
  !$omp threadprivate(ag_work_ae_ag, ae_ag_im, ae_ag_nm)
  !> 作業領域: g_e
  real(DP), allocatable, dimension(:, :) :: ae_work_g_e
  real(DP), allocatable, dimension(:, :) :: ag_work_g_e
  integer(8) :: g_e_km = -1_8, g_e_im = -1_8
  save :: ae_work_g_e, ag_work_g_e, g_e_km, g_e_im
  !$omp threadprivate(ag_work_g_e, ae_work_g_e, g_e_km, g_e_im)
  !> 作業領域: e_g
  real(DP), allocatable, dimension(:, :) :: ag_work_e_g
  real(DP), allocatable, dimension(:, :) :: ae_work_e_g
  integer(8) :: e_g_km = -1_8, e_g_im = -1_8
  save :: ag_work_e_g, ae_work_e_g, e_g_im
  !$omp threadprivate(ag_work_e_g, ae_work_e_g, e_g_im)
  !> 作業領域: e_Dx_e
  real(DP), allocatable, dimension(:, :) :: ae_work_e_Dx_e
  integer(8) :: e_Dx_e_km = -1_8
  save :: ae_work_e_Dx_e, e_Dx_e_km
  !$omp threadprivate(ae_work_e_Dx_e, e_Dx_e_km)

contains
  ! --------------------------------------------------------------------------
  !> 関数名の変更
  subroutine ae_Initial(i, k, xmin, xmax)
    !> 格子点の数
    integer, intent(in) :: i
    !> 切断波数
    integer, intent(in) :: k
    !> X座標下端
    real(DP), intent(in) :: xmin
    !> X座標上端
    real(DP), intent(in) :: xmax

    call MessageNotify('W', 'ae_Initial', &
      & 'ae_Initial is deprecated; will be removed; use ae_Initialize.')

    call ae_Initialize_I8(int(i, kind(im)), int(k, kind(km)), xmin, xmax)

  end subroutine ae_Initial

  ! --------------------------------------------------------------------------
  !> 内部で利用する波数, 格子点数を Integer(8) としたため,
  !> 後方互換性を維持するために用意したインターフェース
  !> * Integer 用
  subroutine ae_Initialize_I4(i, k, xmin, xmax)
    !> 格子点の数
    integer, intent(in) :: i
    !> 切断波数
    integer, intent(in) :: k
    !> X座標下端
    real(DP), intent(in) :: xmin
    !> X座標上端
    real(DP), intent(in) :: xmax

    call MessageNotify('W', 'ae_Initialize', &
      & 'INTEGER(4) im/km deprecated; will be removed; use INTEGER(8).')

    call ae_Initialize_I8(int(i, kind(im)), int(k, kind(km)), xmin, xmax)

  end subroutine ae_Initialize_I4

  !-----------------------------------------------------------------------
  !> スペクトル変換の格子点数, 波数, 領域の大きさを設定する.
  !>
  !> 他の関数や変数を呼ぶ前に, 最初にこのサブルーチンを呼んで
  !> 初期設定をしなければならない.
  !>
  subroutine ae_Initialize_I8(i, k, xmin, xmax)
    !> 格子点の数
    integer(8), intent(in) :: i
    !> 切断波数
    integer(8), intent(in) :: k
    !> X座標下端
    real(DP), intent(in) :: xmin
    !> X座標上端
    real(DP), intent(in) :: xmax
    integer(8) :: ii

    im = i
    km = k
    xl = xmax - xmin

    if (im <= 0 .or. km <= 0) then
      call MessageNotify('E', 'ae_Initial', &
        & 'Number of grid points and waves should be positive')
    elseif (mod(im, 2_8) /= 0) then
      call MessageNotify('E', 'ae_Initial', &
        & 'Number of grid points should be even')
    elseif (km > im / 2) then
      call MessageNotify('E', 'ae_Initial', &
        & 'KM shoud be less equal to IM/2')
    end if

    allocate (it(im / 2_8), t(im * 3_8 / 2_8))

    call FXRINI(im, it, t)

    allocate (g_x(0:im - 1))
    do ii = 0, im - 1
      g_X(ii) = xmin + (xl / im) * ii
    end do

    allocate (g_x_Weight(0:im - 1))
    g_X_Weight = xl / im

    ae_Initialized = .true.

    call MessageNotify(&
      & 'M', 'ae_initial', 'ae_module (2026/01/30) is initialized')

  end subroutine ae_Initialize_I8

  !-----------------------------------------------------------------------
  !> モジュールの終了処理を行なう.
  !>
  subroutine ae_Finalize
    use omp_lib, only: omp_in_parallel
    if (allocated(it)) deallocate (it)
    if (allocated(t)) deallocate (t)
    if (allocated(g_X)) deallocate (g_X)
    if (allocated(g_X_Weight)) deallocate (g_X_Weight)

    if (omp_in_parallel()) then
      call ae_Finalize_tls()
    else
      !$omp parallel
      call ae_Finalize_tls()
      !$omp end parallel
    end if

    ae_Initialized = .false.

    call MessageNotify(&
      & 'M', 'ae_finalize', 'ae_module (2026/01/30) is finalized')
  end subroutine ae_Finalize
  ! --------------------------------------------------------------------------
  subroutine ae_Finalize_tls
    if (allocated(ag_work_ae_ag)) deallocate (ag_work_ae_ag)
    ae_ag_im = -1_8
    ae_ag_nm = -1_8
    if (allocated(ag_work_g_e)) deallocate (ag_work_g_e)
    if (allocated(ae_work_g_e)) deallocate (ae_work_g_e)
    g_e_km = -1_8
    g_e_im = -1_8
    if (allocated(ag_work_e_g)) deallocate (ag_work_e_g)
    if (allocated(ae_work_e_g)) deallocate (ae_work_e_g)
    e_g_km = -1_8
    e_g_im = -1_8
    if (allocated(ae_work_e_Dx_e)) deallocate (ae_work_e_Dx_e)
    e_Dx_e_km = -1_8
  end subroutine ae_Finalize_tls

  !-----------------------------------------------------------------------
  !> スペクトルデータから格子点データへ逆変換する(2 次元データ用)
  !>
  !> スペクトル逆変換の定義は以下のとおり:
  !> * スペクトルデータ: \f$e_k \, (k=-km,...,km)\f$
  !> * 格子点データ:     \f$g_j \, (j=-0,...,im-1)\f$
  !> \f{align*}{
  !>  g_j = e_0
  !>      + 2\sum_{k=1}^{km}e_k\cos(2\pi jk/im) - e_{-k}\sin(2\pi jk/im))
  !>                                               \quad (j=0,1,...,im-1).
  !> \f}
  function ag_ae(ae)
    !> スペクトルデータ
    real(DP), dimension(:, -km:), intent(in) :: ae
    !> 格子点データ
    real(DP), allocatable, dimension(:, :) :: ag_ae

    integer(8) :: n, nm, k, kmax

    if (size(ae, 2) < 2_8 * km + 1_8) then
      call MessageNotify('E', 'ag_ae', &
        & 'The Fourier dimension of input data too small.')
    elseif (size(ae, 2) > 2_8 * km + 1_8) then
      call MessageNotify('W', 'ag_ae', &
        & 'The Fourier dimension of input data too large.')
    end if
    nm = size(ae, 1)
    allocate (ag_ae(nm, 0:im - 1))

    ag_ae = 0.0_DP
    ag_ae(:, 0) = ae(:, 0)

    kmax = min(km, im / 2_8 - 1_8)
    do k = 1, kmax
      !$omp simd
      do n = 1, nm
        ag_ae(n, 2 * k) = ae(n, k)
        ag_ae(n, 2 * k + 1) = ae(n, -k)
      end do
    end do
    if (km == im / 2_8) then
      !$omp simd
      do n = 1, nm
        ag_ae(n, 1) = ae(n, km)
      end do
    end if

    call FXRTBA(nm, im, ag_ae, it, t)

  end function ag_ae

  ! ------------------------------------------------------------------
  !> スペクトルデータから格子点データへ逆変換する(1 次元データ用)
  !>
  !>  * スペクトルデータ: \f$e_k \, (k=-km,...,km)\f$
  !>  * 格子点データ:  \f$g_j \, (j=-0,...,im-1)\f$
  !> \f{align*}{
  !>  g_j = e_0
  !>      + 2\sum_{k=1}^{km}(e_k\cos(2\pi jk/im)
  !>      - e_{-k}\sin(2\pi jk/im))   \quad (j=0,1,...,im-1).
  !> \f}
  function g_e(e_data)
    !> スペクトルデータ
    real(DP), dimension(-km:km), intent(in) :: e_data
    !> 格子点データ
    real(DP), allocatable, dimension(:) :: g_e

    if (.not. allocated(ae_work_g_e) .or. g_e_km /= km) then
      if (allocated(ae_work_g_e)) deallocate (ae_work_g_e)
      allocate (ae_work_g_e(1, -km:km))
      g_e_km = km
    end if

    if (.not. allocated(ag_work_g_e) .or. g_e_im /= im) then
      if (allocated(ag_work_g_e)) deallocate (ag_work_g_e)
      allocate (ag_work_g_e(1, 0:im - 1))
      g_e_im = im
    end if

    allocate (g_e(0:im - 1))
    ae_work_g_e(1, :) = e_data
    ag_work_g_e = ag_ae(ae_work_g_e)
    g_e = ag_work_g_e(1, :)

  end function g_e

  !-----------------------------------------------------------------------
  !> 格子点データからスペクトルデータへ正変換する(2 次元データ用)
  !>
  !> スペクトル正変換の定義は以下のとおり:
  !> * 格子点データ     \f$g_j \, (j=-0,...,im-1)\f$
  !> * スペクトルデータ \f$e_k \, (k=-km,...,km)\f$
  !> \f{align*}{
  !>   e_0 & = (1/im)\sum_{j=0}^{im-1} g_j \\
  !>   e_k & = (1/im)\sum_{j=0}^{im-1} g_j \cos(2\pi jk/im)
  !>          \quad (k=1,2,...,km) \\
  !>   e_{-k} & = - (1/im)\sum_{j=0}^{im-1} g_j \sin(2\pi jk/im)
  !>          \quad (k=1,2,...,km)
  !> \f}
  function ae_ag(ag)
    !> 格子点データ
    real(DP), dimension(:, :), intent(in) :: ag
    !> スペクトルデータ
    real(DP), allocatable, dimension(:, :) :: ae_ag
    integer(8) :: n, nm, k, kmax

    if (size(ag, 2) < im) then
      call MessageNotify('E', 'ae_ag', &
        & 'The Grid points of input data too small.')
    elseif (size(ag, 2) > im) then
      call MessageNotify('W', 'ae_ag', &
        & 'The Grid points of input data too large.')
    end if

    nm = size(ag, 1)
    if (.not. allocated(ag_work_ae_ag)  &
      & .or. ae_ag_nm /= nm             &
      & .or. ae_ag_im /= im) then
      if (allocated(ag_work_ae_ag)) deallocate (ag_work_ae_ag)
      allocate (ag_work_ae_ag(nm, 0:im - 1))
      ae_ag_nm = nm
      ae_ag_nm = im
    end if

    allocate (ae_ag(nm, -km:km))
    ag_work_ae_ag = ag

    call FXRTFA(nm, im, ag_work_ae_ag, it, t)
    kmax = min(km, im / 2_8 - 1_8)
    do k = 1, kmax
      !$omp simd
      do n = 1, nm
        ae_ag(n, k) = ag_work_ae_ag(n, 2 * k)
        ae_ag(n, -k) = ag_work_ae_ag(n, 2 * k + 1)
      end do
    end do
    ae_ag(:, 0) = ag_work_ae_ag(:, 0)
    if (km == im / 2_8) then
      !$omp simd
      do n = 1, nm
        ae_ag(n, km) = ag_work_ae_ag(n, 1)
      end do
    end if

  end function ae_ag

  !-----------------------------------------------------------------------
  !> 格子点データからスペクトルデータへ正変換する(1 次元データ用)
  !>
  !> スペクトル正変換の定義は以下のとおり:
  !> * 格子点データ:     \f$g_j \, (j=-0,...,im-1)\f$
  !> * スペクトルデータ: \f$e_k \, (k=-km,...,km)\f$
  !> \f{align*}{
  !>  e_0    & = (1/im)\sum_{j=0}^{im-1} g_j \\
  !>  e_k    & = (1/im)\sum_{j=0}^{im-1} g_j \cos(2\pi jk/im)
  !>             \quad (k=1,2,...,km) \\
  !>  e_{-k} & = - (1/im)\sum_{j=0}^{im-1} g_j \sin(2\pi jk/im)
  !>              \quad (k=1,2,...,km)
  !> \f}
  function e_g(g_data)
    !> 格子点データ
    real(DP), dimension(0:im - 1), intent(in) :: g_data
    !> スペクトルデータ
    real(DP), allocatable, dimension(:) :: e_g

    if (.not. allocated(ag_work_e_g) .or. e_g_im /= im) then
      if (allocated(ag_work_e_g)) deallocate (ag_work_e_g)
      allocate (ag_work_e_g(1, 0:im - 1))
      e_g_im = im
    end if
    if (.not. allocated(ag_work_e_g) .or. e_g_km /= km) then
      if (allocated(ae_work_e_g)) deallocate (ae_work_e_g)
      allocate (ae_work_e_g(1, -km:km))
    end if

    allocate (e_g(-km:km))

    ag_work_e_g(1, :) = g_data
    ae_work_e_g = ae_ag(ag_work_e_g)
    e_g = ae_work_e_g(1, :)

  end function e_g

  !-----------------------------------------------------------------------
  !> 入力スペクトルデータに X 微分を作用する(2 次元データ).
  !>
  !> スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
  !> 作用させたデータのスペクトル変換のことである.
  function ae_Dx_ae(ae_data)
    !> 入力スペクトルデータ
    real(DP), dimension(:, -km:), intent(in) :: ae_data
    !> 入力スペクトルデータの X 微分
    real(DP), allocatable, dimension(:, :) :: ae_Dx_ae

    integer(8) :: k
    real(DP) :: coef

    if (size(ae_data, 2) < 2_8 * km + 1_8) then
      call MessageNotify('W', 'ae_Dx_ae', &
                         'The Fourier dimension of input data too small.')
    elseif (size(ae_data, 2) > 2_8 * km + 1_8) then
      call MessageNotify('W', 'ae_Dx_ae', &
                         'The Fourier dimension of input data too large.')
    end if
    allocate (ae_Dx_ae(size(ae_data, 1), -km:km))
    coef = 2.0_DP * PI * (1 / xl)

    do k = -km, km
      ae_Dx_ae(:, k) = -(coef * k) * ae_data(:, -k)
    end do

  end function ae_Dx_ae

  !-----------------------------------------------------------------------
  !> 入力スペクトルデータに X 微分を作用する(1 次元データ).
  !>
  !> スペクトルデータの X 微分とは, 対応する格子点データに X 微分を
  !> 作用させたデータのスペクトル変換のことである.
  function e_Dx_e(e_data)
    !> 入力スペクトルデータ
    real(DP), dimension(-km:km), intent(in) :: e_data
    !> 入力スペクトルデータの X 微分
    real(DP), allocatable, dimension(:) :: e_Dx_e

    if (.not. allocated(ae_work_e_Dx_e) .or. e_Dx_e_km /= km) then
      if (allocated(ae_work_e_Dx_e)) deallocate (ae_work_e_Dx_e)
      allocate (ae_work_e_Dx_e(1, -km:km))
      e_Dx_e_km = km
    end if

    allocate (e_Dx_e(-km:km))
    ae_work_e_Dx_e(1, :) = e_data
    ae_work_e_Dx_e = ae_Dx_ae(ae_work_e_Dx_e)
    e_Dx_e = ae_work_e_Dx_e(1, :)

  end function e_Dx_e

  !-----------------------------------------------------------------------
  !> 1 次元格子点データが並んだ 2 次元配列の積分
  function a_Int_ag(ag)
    !> 格子点データ
    real(DP), dimension(:, 0:), intent(in) :: ag
    !> 積分結果
    real(DP), allocatable, dimension(:) :: a_Int_ag

    integer(8) :: i, n, nm
    real(DP) :: wi

    if (size(ag, 2) < im) then
      call MessageNotify('E', 'ae_Int_ag', &
                         'The Grid points of input data too small.')
    elseif (size(ag, 2) > im) then
      call MessageNotify('W', 'ae_Int_ag', &
                         'The Grid points of input data too large.')
    end if

    nm = size(ag, 1)
    allocate (a_Int_ag(nm))
    a_Int_ag = 0.0_DP
    do i = 0, im - 1
      wi = g_X_Weight(i)
      !$omp simd
      do n = 1, nm
        a_Int_ag(n) = a_Int_ag(n) + ag(n, i) * wi
      end do
    end do

  end function a_Int_ag

  !-----------------------------------------------------------------------
  !> 1 次元格子点データの積分
  function Int_g(g)
    !> 格子点データ
    real(DP), dimension(0:im - 1), intent(in) :: g
    !> 積分結果
    real(DP) :: Int_g

    Int_g = sum(g * g_X_Weight)

  end function Int_g

  !-----------------------------------------------------------------------
  !> 1 次元格子点データが並んだ 2 次元配列の平均
  function a_Avr_ag(ag)
    !> 格子点データ
    real(DP), dimension(:, 0:), intent(in) :: ag
    !> 平均結果
    real(DP), allocatable, dimension(:) :: a_Avr_ag

    allocate (a_Avr_ag(size(ag, 1)))

    a_Avr_ag = a_Int_ag(ag) / sum(g_X_Weight)

  end function a_Avr_ag

  !-----------------------------------------------------------------------
  !> 1 次元格子点データの平均
  function Avr_g(g)
    !> 格子点データ
    real(DP), dimension(0:im - 1), intent(in) :: g
    !> 平均値
    real(DP) :: Avr_g

    Avr_g = Int_g(g) / sum(g_X_Weight)

  end function Avr_g

  !-----------------------------------------------------------------------
  !> 補間計算(1次元)
  function Interpolate_e(e_data, xval)
    !> 入力スペクトルデータ
    real(DP), dimension(-km:km), intent(IN) :: e_data
    !> 補間する点の座標
    real(DP), intent(in) :: xval
    !> 補間した結果の値
    real(DP) :: Interpolate_e

    integer(8) :: k
    real(DP) :: coef, ck, sk

    coef = 2.0_DP * PI * (1 / xl) * xval
    Interpolate_e = e_data(0)

    !$omp simd reduction(+:Interpolate_e)
    do k = 1, km
      ck = cos(coef * k)
      sk = sin(coef * k)
      Interpolate_e = Interpolate_e        &
        &  + 2.0_DP * (e_data(k) * ck  &
        &               - e_data(-k) * sk)
    end do

  end function Interpolate_e

  !-----------------------------------------------------------------------
  !> 補間計算(2次元)
  function a_Interpolate_ae(ae_data, xval)
    !> 入力スペクトルデータ
    real(DP), dimension(:, -km:), intent(IN) :: ae_data
    !> 補間する点の座標
    real(DP), intent(in) :: xval
    !> 補間した結果の値
    real(DP), allocatable, dimension(:) :: a_Interpolate_ae

    integer(8) :: k, i, imax
    real(DP) :: coef, ck, sk

    imax = size(ae_data, 1)
    allocate (a_Interpolate_ae(imax))
    coef = 2.0_DP * PI * (1 / xl) * xval

    a_Interpolate_ae = ae_data(:, 0)
    do k = 1, km
      ck = cos(coef * k)
      sk = sin(coef * k)
      !$omp simd
      do i = 1, imax
        a_Interpolate_ae(i) = a_Interpolate_ae(i)  &
          &  + 2.0_DP * (ae_data(i, k) * ck     &
          &               - ae_data(i, -k) * sk)
      end do
    end do

  end function a_Interpolate_ae

end module ae_module

! -*- mode: f90; coding: utf-8 -*-
!-------------------------------------------------------------------------
! Copyright (c) 2019 SPMODEL Development Group. All rights reserved.
!
! 履歴  2019/03/16  竹広真一
!       2019/10/04  佐々木洋平
!       2019/10/09  佐々木洋平
!       2020/11/20  竹広真一
!-------------------------------------------------------------------------
!> @author Shin-ichi Takehiro, Youhei SASAKI
!> @copyright Copyright (C) SPMODEL Development Group, 2019.
!>            License is MIT/X11. see [COPYRIGHT](@ref COPYRIGHT) in detail
!> @brief @ref w_module の下部モジュール: 微分
!> @warning
!> 本モジュールを直接呼ぶ事は想定されていないことに注意されたい．
!> ユーザは @ref w_module を呼ぶこと．
!>
module w_module_deriv_mint
  use dc_message, only : MessageNotify
  use dc_types, only: DP
  use w_module_base_mint, only :   &
    & im, jm, mm, nn, mi,          &
    & w_base_Initial, xy_w, w_xy
  implicit none
  private
  public w_deriv_Initial
  public w_deriv_Finalize
  public w_Lapla_w
  public w_LaplaInv_w
  public w_DLon_w
  public xy_GradLon_w
  public xy_GradLat_w
  public w_DivLon_xy
  public w_DivLat_xy
  public w_Div_xy_xy
  public w_Jacobian_w_w
  public xy_GradLambda_w
  public xy_GradMu_w
  public w_DivLambda_xy
  public w_DivMu_xy
  public rn

  !---------------------------------------------------------------------
  !> ラプラシアン演算用配列(後方互換性のため)
  !>
  !> * スペクトルデータのラプラシアンを計算するための係数
  !>    配列のサイズは((nn+1)*(nn+1), 2)
  !> * r(L,1) には L 番目の格納位置のスペクトルに対するラプラシアン計算の
  !>   係数 -n(n+1) の値が格納されている.
  !>
  real(DP), allocatable  :: rn(:,:)

  !---------------------------------------------------------------------
  !> ラプラシアン演算用配列
  !>
  !> * スペクトルデータのラプラシアンを計算するための係数
  !>   配列のサイズは((mm+1)*(mm+1)*2)
  !>
  real(DP), allocatable  :: D(:)

  !> 初期化フラグ
  logical               :: w_deriv_initialize=.false.

  save D, rn

contains

  !----------------------------------------------------------
  !> スペクトル微分計算に必要となる作業領域を設定する.
  !>
  !> 他の関数を呼ぶ前に, 最初にこのサブルーチンを呼んで
  !> 初期設定をしなければならない.
  !>
  !> @warning
  !> このサブルーチンを単独で用いるのでなく,
  !> 上位サブルーチン
  !> [w_Initial](@ref w_module#w_initial) を使用すること.
  !>
  subroutine w_deriv_initial
    allocate(D((MM/MI+1)*(2*(NN+1)-MM/MI*MI)*2_8))
    allocate(rn((MM/MI+1)*(2*(NN+1)-MM/MI*MI),2_8))

    call sxinmd(mm,nn,D,mi)

    rn = reshape(D,(/(MM/MI+1)*(2*(NN+1)-MM/MI*MI),2_8/))

    w_deriv_initialize=.true.

    call MessageNotify('M','w_deriv_initial',&
      'w_module_deriv_mint (2020/11/18) is initialized')

  end subroutine w_deriv_initial

  !----------------------------------------------------------
  !> 入力スペクトルデータにラプラシアン
  !> \f{align*}{
  !>    ▽^2 = 1/\cos^2φ・∂^2/∂λ^2 + 1/\cosφ・∂/∂φ(\cosφ∂/∂φ)
  !> \f}
  !> を作用する(1 層用).
  !>
  function w_Lapla_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !> 入力スペクトルデータのラプラシアン
    real(DP)              :: w_Lapla_w((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    call sxclam(mm,nn,w_data,w_Lapla_w,D,1_8,mi)

  end function w_Lapla_w

  !----------------------------------------------------------
  !> 入力スペクトルデータに逆ラプラシアン
  !> \f{align*}{
  !>    ▽^{-2}
  !>      =[1/\cos^2φ・∂^2/∂λ^2 + 1/\cosφ・∂/∂φ(\cosφ∂/∂φ)]^{-1}
  !> \f}
  !> を作用する(1 層用).
  !>
  function w_LaplaInv_w(w_data)
    !>  入力スペクトルデータ
    real(DP), intent(in)  :: w_data((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !> スペクトルデータの逆ラプラシアン
    real(DP)              :: w_LaplaInv_w((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    call sxclam(mm,nn,w_data,w_LaplaInv_w,D,2_8,mi)

  end function w_LaplaInv_w

  !----------------------------------------------------------
  !> スペクトルデータに経度微分 \f$∂/∂λ\f$ を作用させる(1 層用).
  !>
  function w_DLon_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !> スペクトルデータの経度微分
    real(DP)              :: w_DLon_w((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    call sxcsmx(mm,nn,w_data,w_DLon_w,mi)

  end function w_DLon_w

  !-------------------------------------------------------------
  !> スペクトルデータに勾配型経度微分 \f$1/\cosφ・∂/∂λ\f$ を
  !> 作用させた格子点データを返す(1 層用).
  !>
  function xy_GradLon_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !> スペクトルデータを勾配型経度微分した格子点データ
    real(DP)              :: xy_GradLon_w(0:im-1,1:jm)

    xy_GradLon_w = xy_w(w_data,ipow=1,iflag=-1)

  end function xy_GradLon_w

  !---------------------------------------------------------------
  !> スペクトルデータに勾配型緯度微分 \f$∂/∂φ\f$ を作用させて
  !> 格子点データに変換して返す(1 層用).
  !>
  function xy_GradLat_w(w_data)
    !> 入力スペクトルデータ
    real(DP), intent(in)  :: w_data((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !> スペクトルデータを勾配型緯度微分した格子点データ
    real(DP)              :: xy_GradLat_w(0:im-1,1:jm)

    xy_GradLat_w = xy_w(w_data,ipow=1,iflag=1)

  end function xy_GradLat_w

  !---------------------------------------------------------------------
  !> 格子点データに発散型経度微分 \f$1/\cosφ・∂/∂λ\f$ を作用させて
  !> スペクトルデータに変換して返す(1 層用).
  !>
  function w_DivLon_xy(xy_data)
    !> 入力格子点データ
    real(DP), intent(in)  :: xy_data(0:im-1,1:jm)
    !> 格子点データを発散型経度微分したスペクトルデータ
    real(DP)              :: w_DivLon_xy((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    w_DivLon_xy = w_xy(xy_data,ipow=1,iflag=-1)

  end function w_DivLon_xy

  !-------------------------------------------------------------------
  !> 格子点データに発散型緯度微分 \f$1/\cosφ・∂(f \cosφ)/∂φ\f$
  !> を作用させてスペクトルデータに変換して返す(1 層用).
  !>
  function w_DivLat_xy(xy_data)
    !> 入力格子点データ
    real(DP), intent(in)  :: xy_data(0:im-1,1:jm)
    !> 格子点データを発散型緯度微分したスペクトルデータ
    real(DP)              :: w_DivLat_xy((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    w_DivLat_xy = w_xy(xy_data,ipow=1,iflag=1)

  end function w_DivLat_xy

  !----------------------------------------------------------
  !> 2 つの入力格子点データをベクトル成分とする発散を計算し,
  !> スペクトルデータとして返す(1 層用).
  !>
  function w_Div_xy_xy(xy_u,xy_v)
    !> ベクトル経度成分の格子点データ
    real(DP), intent(in)  :: xy_u(0:im-1,1:jm)
    !> ベクトル緯度成分の格子点データ
    real(DP), intent(in)  :: xy_v(0:im-1,1:jm)
    !> 2 つの入力格子点データをベクトル成分とする発散のスペクトルデータ
    real(DP)              :: w_Div_xy_xy((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    w_Div_xy_xy = w_Divlon_xy(xy_u) + w_Divlat_xy(xy_v)

  end function w_Div_xy_xy

  !-------------------------------------------------------------------------
  !> 2 つのスペクトルデータにヤコビアン
  !> \f{align*}{
  !>   J(f,g) & = ∂f/∂λ・∂g/∂μ - ∂g/∂λ・∂f/∂μ \\
  !>          & = ∂f/∂λ・1/\cos φ・∂g/∂φ
  !>               - ∂g/∂λ・1/\cos φ・∂f/∂φ
  !> \f}
  !> を作用させる(1 層用).
  !>
  function w_Jacobian_w_w(w_a,w_b)
    !>  1つ目の入力スペクトルデータ
    real(DP), intent(in) :: w_a((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !>  2つ目の入力スペクトルデータ
    real(DP), intent(in) :: w_b((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !> 2 つのスペクトルデータのヤコビアン
    real(DP)             :: w_Jacobian_w_w((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    w_Jacobian_w_w =                                          &
      & w_xy(  xy_w(w_DLon_w(w_a))*xy_w(w_b,ipow=2,iflag=1)   &
      &      - xy_w(w_DLon_w(w_b))*xy_w(w_a,ipow=2,iflag=1) )

  end function w_Jacobian_w_w

  !----------------------------------------------------------
  !> スペクトルデータに勾配型経度微分 ∂/∂λ を作用する(1 層用).
  !>
  function xy_GradLambda_w(w_data)
    !>  入力スペクトルデータ
    real(DP), intent(in)  :: w_data((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !> スペクトルデータを勾配型経度微分した格子点データ
    real(DP)              :: xy_GradLambda_w(0:im-1,1:jm)

    xy_GradLambda_w = xy_w(w_data,ipow=0,iflag=-1)

  end function xy_GradLambda_w

  !----------------------------------------------------------
  !> スペクトルデータに勾配型緯度微分
  !> \f$(1-μ^2)∂/∂μ ,\, (μ=\sinφ)\f$
  !> を作用させて格子点データに変換して返す(1 層用).
  !>
  function xy_GradMu_w(w_data)
    !>  入力スペクトルデータ
    real(DP), intent(in)  :: w_data((mm/mi+1)*(2*(nn+1)-mm/mi*mi))
    !> スペクトルデータを勾配型緯度微分した格子点データ
    real(DP)              :: xy_GradMu_w(0:im-1,1:jm)

    xy_GradMu_w = xy_w(w_data,ipow=0,iflag=1)

  end function xy_GradMu_w

  !----------------------------------------------------------
  !> 格子点データに発散型経度微分
  !> \f$1/(1-μ^2)・∂/∂λ, \, (μ=\sinφ)\f$
  !> を作用させてスペクトルデータに変換して返す(1 層用).
  !>
  function w_DivLambda_xy(xy_data)
    !>  入力格子点データ
    real(DP), intent(in)  :: xy_data(0:im-1,1:jm)
    !> 格子点データを発散型経度微分したスペクトルデータ
    real(DP)              :: w_DivLambda_xy((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    w_DivLambda_xy = w_xy(xy_data,ipow=2,iflag=-1)

  end function w_DivLambda_xy

  !----------------------------------------------------------
  !> 格子点データに発散型緯度微分
  !> \f$∂/∂μ, \, (μ=\sinφ)\f$
  !> を作用させてスペクトルデータに変換して返す(1 層用).
  !>
  function w_DivMu_xy(xy_data)
    !>  入力格子点データ
    real(DP), intent(in)  :: xy_data(0:im-1,1:jm)
    !> 格子点データを発散型緯度微分したスペクトルデータ
    real(DP)              :: w_DivMu_xy((mm/mi+1)*(2*(nn+1)-mm/mi*mi))

    w_DivMu_xy = w_xy(xy_data,ipow=2,iflag=1)

  end function w_DivMu_xy

  !----------------------------------------------------------
  !> モジュールの終了処理(割り付け配列の解放)をおこなう.
  !>
  !> @warning
  !> このサブルーチンを単独で用いるのでなく,
  !> 上位サブルーチン
  !> [w_Finalize](@ref w_module#w_finalize) を使用すること.
  !>
  subroutine w_deriv_finalize

    if ( .not. w_deriv_initialize ) then
      call MessageNotify('W','w_deriv_Finalize',&
        'w_module_deriv_mint not initialized yet')
      return
    endif

    deallocate(D)           ! ラプラシアン演算用配列
    deallocate(rn)          ! ラプラシアン演算用配列

    w_deriv_initialize = .false.

    call MessageNotify('M','w_deriv_finalize',&
      'w_module_deriv_mint (2020/11/18) is finalized')

  end subroutine w_deriv_finalize

end module w_module_deriv_mint

!***********************************************************************
! ISPACK FORTRAN SUBROUTINE LIBRARY FOR SCIENTIFIC COMPUTING
! Copyright (C) 1998--2019 Keiichi Ishioka <ishioka@gfd-dennou.org>
!
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.
!
! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.
! 
! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
! 02110-1301 USA.
!***********************************************************************
SUBROUTINE SXINMD(MM,NT,D,MI)

  IMPLICIT NONE
  INTEGER(8) :: MM,NT,M,N,L,NS,ND,K,MN,MI
  REAL(8) :: D(*) ! D((MM/MI+1)*(2*(NT+1)-MM/MI*MI)*2)
  INTEGER(8) :: NPMAX
  INTEGER(8) :: N1,M1

  CALL MXGOMP(NPMAX)    

  N1=MM/MI+1
  M1=N1*MI
  MN=N1
  IF(MM/MI-M1/MI.GE.0) THEN
     MN=MN+1
  END IF

  ND=(MM/MI+1)*(2*(NT+1)-MM/MI*MI)
  
  !$omp parallel private(NS,M,N) num_threads(NPMAX)
  !$omp do schedule(dynamic)
  DO K=0,MN-1
     M=K*MI
     NS=K*(2*(NT+1)-(K-1)*MI)+1
     IF(M.EQ.0) THEN
        D(1)=0
        D(1+ND)=1
        DO N=1,NT
           D(NS+N-M)=-1D0*N*(N+1)
           D(NS+N-M+ND)=1/D(NS+N-M)
        END DO
     ELSE
        DO N=M,NT
           D(NS+2*(N-M))=-1D0*N*(N+1)
           D(NS+2*(N-M)+1)=D(NS+2*(N-M))
           D(NS+2*(N-M)+ND)=1/D(NS+2*(N-M))
           D(NS+2*(N-M)+1+ND)=D(NS+2*(N-M)+ND)
        END DO
     END IF
  END DO
  !$omp end do
  !$omp end parallel

END SUBROUTINE SXINMD

# INSTALL GUIDE                                                      {#INSTALL}

<!-- English bellow -->

@ja
## 必要要件

spmodel fortran library を利用するには以下のソフトウェアが必要です.

* Fortran Compiler: support >= fortran 2003 standard.
* [Ruby](https://www.ruby-lang.org/ja/): ソースコードの動的生成に [erb](ERBja) を利用しています. 
* [Unidata | NetCDF C Library](http://www.unidata.ucar.edu/software/netcdf/)
* [Unidata | NetCDF Fortran Library](http://www.unidata.ucar.edu/downloads/netcdf/index.jsp)
* [gtool5 | Gtool5 Fortran Library](http://www.gfd-dennou.org/library/gtool/gtool5.htm.ja)
* Optional: ドキュメントの再生成には [Doxygen](http://www.stack.nl/~dimitri/doxygen/) が必要となります. 

## インストールの手引き

### はじめに. 

spmodel fortran library は autotools ([autoconf],[automake],[libtool]) を利用しています.
autotools を利用する典型的なソフトウェアと同様に

    ./configure & make & make install

でインストールすることができるでしょう. 

### 環境変数の設定

先ずは環境変数 `FC` に使用する Fortran コンパイラを, 
環境変数 `FCFLAGS` に最適化やデバッグのためのオプションを指定して下さい. 
例えば

    % FC=gfortran
    % FCFLAGS="-g -O2 -fopenmp"

などです.

MPI 並列計算を行いたい場合には

    % FC=mpif90

といった MPI 並列対応の Fortran compiler を指定してください.

NOTE: MPI library として mpich での動作は確認してます.
      openmpi では不具合があります.


### ソースの展開と `configure` の実行

次に適当な作業ディレクトリでソースアーカイブを展開します.
ソースは gtool5-`バージョン` というディレクトリに展開されます.

	$ tar xvf gtool5_current.tar.gz

展開されたディレクトリに移動し, `./configure`を実行します.

    % ./configure

out ot tree build にも対応していますので, 例えば `build` 以下でコンパイルをしたい場合には

    % mkdir build
    % cd build
    % ../configure

といったことも可能です. 

インストール先などを変更したい場合などは, `configure` に `--help` オプ
ションをつけて, 指定可能なオプションリストをご確認下さい. 

	% ./configure --help

主なオプションは以下の通りです.

* `--with-gt5config=ARG`
  * Defatult: `PATH` から探索.
  * `ARG` に `gt5config` を明示的に指定することもできます.
    これによって NetCDF C Library および NetCDF Fortran Library,
    gtool5 fortran library に関する設定が行なわれます.

* `--with-ispack'
  * ISPACK3 Library の場所を指定します.

* `--with-lapack'
  * LAPACK Library の場所を指定します.

* `--with-blas'
  * BLAS Library の場所を指定します.

* `--with-mint`
  * セクター対称性を仮定した球面計算を可能にします

* '--with-lumatrix=ARG' 
  * 連立 1 次方程式を解くルーチンを指定します.
    VEC : ベクトル並列計算向きオリジナルルーチンを使用します.
    OMP : OpenMP 計算向きオリジナルルーチンを使用します.
    LAPACK : LAPACK のサブルーチンを使用します.

* `--prefix=ARG`
  * Defatult: `/usr/local/spmodel`
  * `ARG` にライブラリやモジュール, 実行ファイルのインストール先の
    ディレクトリのプレフィックスを指定します.

* `--host=ARG`
  * クロスコンパイルを行う場合には,
    パッケージが実行されるシステムタイプ名を `ARG` に指定します.

* `--enable-mpi`
  * Defatult: enabled
  * MPI を有効にします. `FC` に
    MPI 用のコンパイラ(例えば mpif90 等)を指定して下さい.

n* `--with-mpiexec`
  * Defatult: none
  * テスト時に使用する MPI 実行プログラムを指定します.

* `--with-mpiexec-opts`
  * Default: none
  * テスト時に使用する MPI 実行プログラムのオプションを指定します.

* `--with-mpiexec-procnum`
  * Default: 4
  * テスト時に使用する MPI 実行プログラムの並列数を指定します.


### ビルド

`configure` が正常に終了したならば,
例えば以下の様に結果のサマリが表示されますので, 内容を確認して下さい. 

```
% export FCFLAGS="-fbacktrace"
% export FC=mpif90.mpich
% ./configure --prefix=$home/gnu2.mpich --with-gt5config=$home/gnu2.mpich/bin/gt5config --with-ispack=$home/gnu2.mpich/lib/libispack3.a --with-lumatrix=OMP --with-lapack=/usr/lib/x86_64-linux-gnu/lapack/liblapack.a --enable-mpi --disable-shared --with-mpiexec=mpirun.mpich --with-mpiexec-opts=-n --with-mint

-----------------------------------------------------------------------
Summary of build options:

version:               1.0.0
Host type:             x86_64-pc-linux-gnu
Install prefix:        /home/takepiro/gnu2.mpich
C Compiler:            gcc
C Flags:               -g -O2
C Preprocessor:        gcc -E
CPP Flags:              -DF03_FEATURE -DLIB_MPI -DEIG_LAPACK -DLUMATRIX_OMP
Fortran Compiler:      /usr/bin/mpif90.mpich
Fortran Flags:         -I/home/takepiro/gnu2.mpich/include -I/usr/include -I/usr/include -O0 -march=native -fopenmp -fno-range-check -fbacktrace
MINT enable:           yes
MPI Support:           yes
MPI Executer:          mpirun.mpich
MPI Executer option:   -n
Linker:                /usr/bin/ld
Linker Flags:          -L/home/takepiro/gnu2.mpich/lib  -L/home/takepiro/gnu2.mpich/lib -L/usr/lib/x86_64-linux-gnu/lapack
Linking Libraries:     -lgtool -L/usr/lib/x86_64-linux-gnu -lnetcdff -Wl,-z,relro -Wl,-z,now -lnetcdf -lnetcdf -lm  -lispack3 -llapack
Eigen Value Solver:    LAPACK
LU Solver:             OMP
SPML Library name:     spml-lapack-omp
-----------------------------------------------------------------------
```

表示された結果が期待通りである場合には

    % make

でビルドが始まります.

### テストプログラム実行

カレントディレクトリにおいて, 以下のコマンドを実行してください.

	$ make check

### インストール

カレントディレクトリで以下のコマンドを実行してください.
システム領域にインストールする場合には管理者権限が
必要です(デフォルトの場合は `/usr/local/spmodel` にインストールします).

	# make install

### spmfrt へのパスの設定

上記のように正しくインストールが行われたら,
`spmconfig`, `spmfrt` というシェルスクリプトが
`--prefix=ARG` で指定されたディレクトリ以下の `bin` ディレクトリ
(`ARG/bin`)に作成されているはずです.
( `--prefix=` を指定しなかった場合は `/usr/local/spmodel/bin/` 以下).
このディレクトリへ `PATH` を通してください.

`spmconfig` は spmodel ライブラリのビルドに利用したコンパイラ等の情報が含まれています. 
これを用いることで, spmodel ライブラリを基盤としたソフトウェアのインストールが簡便になることが期待されています. 

```
This spml 1.0.0 has been built with the following features:

  --fc         -> /usr/bin/mpif90.mpich
  --fcflags    -> -I/home/takepiro/gnu2.mpich/include -I/home/takepiro/gnu2.mpich/include -I/usr/include -I/usr/include -O0 -march=native -fopenmp -fno-range-check
  --ldflags    -> -L/home/takepiro/gnu2.mpich/lib  -L/home/takepiro/gnu2.mpich/lib -L/usr/lib/x86_64-linux-gnu/lapack -L/home/takepiro/gnu2.mpich/lib
  --ldlibs     -> -lspml-lapack-omp -lgtool -L/usr/lib/x86_64-linux-gnu -lnetcdff -Wl,-z,relro -Wl,-z,now -lnetcdf -lnetcdf -lm  -lispack3 -llapack

  --prefix     -> /home/takepiro/gnu2.mpich
  --includedir -> /home/takepiro/gnu2.mpich/include
  --version    -> spml 1.0.0
```

`spmfrt` は `spmcofnig` の情報をベースに, 
spmodel ライブラリを利用した Fortran プログラムを簡単にコンパイル・リンクを行なうためにシェルスクリプトです.
`spmfrt` を用いることで, 自動的に spmodel ライブラリへのリンクとモジュール群へのディレクトリ指定を行ってくれます.

``` 4d
	% spmfrt test.f90
	/usr/bin/mpif90.mpich -I/home/takepiro/gnu2.mpich/include -I/home/takepiro/gnu2.mpich/include -I/usr/include -I/usr/include -O0 -march=native -fopenmp -fno-range-check test.f90 -L/home/takepiro/gnu2.mpich/lib -L/home/takepiro/gnu2.mpich/lib -L/usr/lib/x86_64-linux-gnu/lapack -L/home/takepiro/gnu2.mpich/lib -lspml-lapack-omp -lgtool -L/usr/lib/x86_64-linux-gnu -lnetcdff -Wl,-z,relro -Wl,-z,now -lnetcdf -lnetcdf -lm -lispack3 -llapack

```

@endja
@en
## Set PATH to gt5frt

If the installation is correctly done as stated above,
shell script ((*gt5frt*)) is made under the directory
`--prefix=ARG`/bin
(By default, `/usr/local/gtool5/bin/` ).

Please specify PATH to this directory.
It is an example as follows when ((*gt5frt*)) is installed in
`/usr/local/gtool5/bin/` .

((*gt5frt*)) is a shell script in order to easily compile and link
Fortran programs which utilizes the gtool5 library.
Link to the gtool5 library and directory appointment to the modules
are done automatically by using gt5frt in place of command of the
Fortran compiler.

	$ gt5frt test.f90
    /usr/bin/gfortran -I/usr/local/gtool5/include -I/usr/include -g -O2 test.f90 \
      -L/usr/local/stow/gtool5/lib -lgtool -L/usr/lib -lnetcdff -lnetcdf


@enden
@en
## Prerequisite

To use the gtool5 fortran library, the following software is required.

* Fortran Compiler: support >= fortran 2003 standard.
* [Unidata | NetCDF C Library](http://www.unidata.ucar.edu/software/netcdf/)
* [Unidata | NetCDF Fortran Library](http://www.unidata.ucar.edu/downloads/netcdf/index.jsp)
* Optional: [Doxygen](http://www.stack.nl/~dimitri/doxygen/) : For regeneration of doucments. 

## How to install

### Extract tar.gz

Make an empty directory, and extract archive.
A directory `gtool5-`version`'
created at the current working directory.

	$ tar xvf gtool5_current.tar.gz

### Specify Fortran Compiler

Specify Fortran compiler to environment variable ((* FC *)), e.g.

    % FC=gfortran

Specify Fortran compiler options for optimization and debug to
environment variable `FCFLAGS`, e.g.,

    % FCFLAGS="-g -O2 -fopenmp"

Move created directroy, and excute `./configure`'.

    % ./configure

If you want to change directory to which the library and the module, etc.
are installed, please set `--help` option as follow. Available
options are showed.

	% ./configure --help

Descriptions about principal options are listed below.

* `--with-nf-config=ARG`
  * Default: search `nf-config` from ((:PATH:)).
  * If you want to use another `nf-config`,
    set the location of `nf-config` to `ARG` explicitly.

* `--with-netcdf=ARG`
  * When you can't execute `nf-config`,
    set the location of NetCDF C Library to `ARG` explicitly.

* `--with-netcdff=ARG`
  * When you can't execute `nf-config`,
    set the location of NetCDF Fortran library to `ARG` explicitly.

* `--with-netcdff-include=ARG`
  * When you can't execute `nf-config`,
    set the location of module file `netcdf.mod` to `ARG` explicitly.

* `--prefix=ARG`
  * Default: `/usr/local/gtool5`.
    set prefix to `ARG`.

* `--host=ARG`
  * When cross-compiling,
    set the type of system on which the package will run to `ARG`.

* `--enable-mpi`
  * Default: enable
  * Enable MPI support.
    Set MPI Fortran Compiler to ((:FC:)), e.g. mpif90.

* `--with-mpiexec`
  * Default: none
  * Set MPI execute program for test.

* `--with-ncdump`
  * Default: search ((:ncdump:)) from ((:PATH:)).
  * Set ((:ncdump:)) for test.

@enden


[autoconf]: https://www.gnu.org/software/autoconf/autoconf.html
[automake]: https://www.gnu.org/software/automake/
[libtool]: https://www.gnu.org/software/automake/
[ERBja]: https://docs.ruby-lang.org/ja/3.1/library/erb.html
[ERBen]: https://docs.ruby-lang.org/en/3.1/library/erb.html
